# pylint: disable=too-many-lines,too-many-statements
# coding=utf-8
# --------------------------------------------------------------------------
# Code generated by Microsoft (R) AutoRest Code Generator (autorest: 3.9.0, generator: @autorest/python@6.13.16)
# Changes may cause incorrect behavior and will be lost if the code is regenerated.
# --------------------------------------------------------------------------
import datetime
from io import IOBase
import sys
from typing import (
    Any,
    Callable,
    Dict,
    IO,
    Iterator,
    List,
    Optional,
    Type,
    TypeVar,
    Union,
    cast,
    overload,
)

from azure.core.exceptions import (
    ClientAuthenticationError,
    HttpResponseError,
    ResourceExistsError,
    ResourceNotFoundError,
    ResourceNotModifiedError,
    map_error,
)
from azure.core.pipeline import PipelineResponse
from azure.core.rest import HttpRequest, HttpResponse
from azure.core.tracing.decorator import distributed_trace
from azure.core.utils import case_insensitive_dict

from .._serialization import Serializer

if sys.version_info >= (3, 9):
    from collections.abc import MutableMapping
else:
    from typing import MutableMapping  # type: ignore  # pylint: disable=ungrouped-imports
JSON = MutableMapping[str, Any]  # pylint: disable=unsubscriptable-object
T = TypeVar("T")
ClsType = Optional[
    Callable[[PipelineResponse[HttpRequest, HttpResponse], T, Dict[str, Any]], Any]
]

_SERIALIZER = Serializer()
_SERIALIZER.client_side_validation = False


def build_one_clicks_list_request(
    *, type: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/1-clicks"

    # Construct parameters
    if type is not None:
        _params["type"] = _SERIALIZER.query("type", type, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_one_clicks_install_kubernetes_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/1-clicks/kubernetes"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_account_get_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_ssh_keys_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account/keys"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_ssh_keys_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account/keys"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_ssh_keys_get_request(ssh_key_identifier: JSON, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account/keys/{ssh_key_identifier}"
    path_format_arguments = {
        "ssh_key_identifier": _SERIALIZER.url(
            "ssh_key_identifier", ssh_key_identifier, "object"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_ssh_keys_update_request(
    ssh_key_identifier: JSON, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account/keys/{ssh_key_identifier}"
    path_format_arguments = {
        "ssh_key_identifier": _SERIALIZER.url(
            "ssh_key_identifier", ssh_key_identifier, "object"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_ssh_keys_delete_request(
    ssh_key_identifier: JSON, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/account/keys/{ssh_key_identifier}"
    path_format_arguments = {
        "ssh_key_identifier": _SERIALIZER.url(
            "ssh_key_identifier", ssh_key_identifier, "object"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_actions_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/actions"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_actions_get_request(action_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/actions/{action_id}"
    path_format_arguments = {
        "action_id": _SERIALIZER.url("action_id", action_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_list_request(
    *,
    page: int = 1,
    per_page: int = 20,
    with_projects: Optional[bool] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps"

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if with_projects is not None:
        _params["with_projects"] = _SERIALIZER.query(
            "with_projects", with_projects, "bool"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_delete_request(id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{id}"
    path_format_arguments = {
        "id": _SERIALIZER.url("id", id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_apps_get_request(
    id: str, *, name: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{id}"
    path_format_arguments = {
        "id": _SERIALIZER.url("id", id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_update_request(id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{id}"
    path_format_arguments = {
        "id": _SERIALIZER.url("id", id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_apps_restart_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/restart"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_get_logs_active_deployment_request(  # pylint: disable=name-too-long
    app_id: str,
    component_name: str,
    *,
    follow: Optional[bool] = None,
    type: str = "UNSPECIFIED",
    pod_connection_timeout: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/components/{component_name}/logs"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "component_name": _SERIALIZER.url("component_name", component_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if follow is not None:
        _params["follow"] = _SERIALIZER.query("follow", follow, "bool")
    _params["type"] = _SERIALIZER.query("type", type, "str")
    if pod_connection_timeout is not None:
        _params["pod_connection_timeout"] = _SERIALIZER.query(
            "pod_connection_timeout", pod_connection_timeout, "str"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_get_exec_active_deployment_request(  # pylint: disable=name-too-long
    app_id: str, component_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/components/{component_name}/exec"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "component_name": _SERIALIZER.url("component_name", component_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_list_deployments_request(
    app_id: str, *, page: int = 1, per_page: int = 20, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/deployments"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_create_deployment_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/deployments"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_get_deployment_request(
    app_id: str, deployment_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/deployments/{deployment_id}"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "deployment_id": _SERIALIZER.url("deployment_id", deployment_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_cancel_deployment_request(
    app_id: str, deployment_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/deployments/{deployment_id}/cancel"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "deployment_id": _SERIALIZER.url("deployment_id", deployment_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_get_logs_request(
    app_id: str,
    deployment_id: str,
    component_name: str,
    *,
    follow: Optional[bool] = None,
    type: str = "UNSPECIFIED",
    pod_connection_timeout: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = (
        "/v2/apps/{app_id}/deployments/{deployment_id}/components/{component_name}/logs"
    )
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "deployment_id": _SERIALIZER.url("deployment_id", deployment_id, "str"),
        "component_name": _SERIALIZER.url("component_name", component_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if follow is not None:
        _params["follow"] = _SERIALIZER.query("follow", follow, "bool")
    _params["type"] = _SERIALIZER.query("type", type, "str")
    if pod_connection_timeout is not None:
        _params["pod_connection_timeout"] = _SERIALIZER.query(
            "pod_connection_timeout", pod_connection_timeout, "str"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_get_logs_aggregate_request(
    app_id: str,
    deployment_id: str,
    *,
    follow: Optional[bool] = None,
    type: str = "UNSPECIFIED",
    pod_connection_timeout: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/deployments/{deployment_id}/logs"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "deployment_id": _SERIALIZER.url("deployment_id", deployment_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if follow is not None:
        _params["follow"] = _SERIALIZER.query("follow", follow, "bool")
    _params["type"] = _SERIALIZER.query("type", type, "str")
    if pod_connection_timeout is not None:
        _params["pod_connection_timeout"] = _SERIALIZER.query(
            "pod_connection_timeout", pod_connection_timeout, "str"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_get_exec_request(
    app_id: str, deployment_id: str, component_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = (
        "/v2/apps/{app_id}/deployments/{deployment_id}/components/{component_name}/exec"
    )
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "deployment_id": _SERIALIZER.url("deployment_id", deployment_id, "str"),
        "component_name": _SERIALIZER.url("component_name", component_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_get_logs_active_deployment_aggregate_request(  # pylint: disable=name-too-long
    app_id: str,
    *,
    follow: Optional[bool] = None,
    type: str = "UNSPECIFIED",
    pod_connection_timeout: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/logs"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if follow is not None:
        _params["follow"] = _SERIALIZER.query("follow", follow, "bool")
    _params["type"] = _SERIALIZER.query("type", type, "str")
    if pod_connection_timeout is not None:
        _params["pod_connection_timeout"] = _SERIALIZER.query(
            "pod_connection_timeout", pod_connection_timeout, "str"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_list_instance_sizes_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/tiers/instance_sizes"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_get_instance_size_request(slug: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/tiers/instance_sizes/{slug}"
    path_format_arguments = {
        "slug": _SERIALIZER.url("slug", slug, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_list_regions_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/regions"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_validate_app_spec_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/propose"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_list_alerts_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/alerts"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_apps_assign_alert_destinations_request(  # pylint: disable=name-too-long
    app_id: str, alert_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/alerts/{alert_id}/destinations"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
        "alert_id": _SERIALIZER.url("alert_id", alert_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_create_rollback_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/rollback"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_validate_rollback_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/rollback/validate"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_commit_rollback_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/rollback/commit"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_revert_rollback_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/rollback/revert"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_get_metrics_bandwidth_daily_request(  # pylint: disable=name-too-long
    app_id: str, *, date: Optional[datetime.datetime] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/metrics/bandwidth_daily"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if date is not None:
        _params["date"] = _SERIALIZER.query("date", date, "iso-8601")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_apps_list_metrics_bandwidth_daily_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/metrics/bandwidth_daily"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_apps_get_health_request(app_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/apps/{app_id}/health"
    path_format_arguments = {
        "app_id": _SERIALIZER.url("app_id", app_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_cdn_list_endpoints_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_cdn_create_endpoint_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_cdn_get_endpoint_request(cdn_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints/{cdn_id}"
    path_format_arguments = {
        "cdn_id": _SERIALIZER.url("cdn_id", cdn_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_cdn_update_endpoints_request(cdn_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints/{cdn_id}"
    path_format_arguments = {
        "cdn_id": _SERIALIZER.url("cdn_id", cdn_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_cdn_delete_endpoint_request(cdn_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints/{cdn_id}"
    path_format_arguments = {
        "cdn_id": _SERIALIZER.url("cdn_id", cdn_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_cdn_purge_cache_request(cdn_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/cdn/endpoints/{cdn_id}/cache"
    path_format_arguments = {
        "cdn_id": _SERIALIZER.url("cdn_id", cdn_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_certificates_list_request(
    *, per_page: int = 20, page: int = 1, name: str = "", **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/certificates"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_certificates_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/certificates"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_certificates_get_request(certificate_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/certificates/{certificate_id}"
    path_format_arguments = {
        "certificate_id": _SERIALIZER.url("certificate_id", certificate_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_certificates_delete_request(
    certificate_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/certificates/{certificate_id}"
    path_format_arguments = {
        "certificate_id": _SERIALIZER.url("certificate_id", certificate_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_balance_get_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/customers/my/balance"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_billing_history_list_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/customers/my/billing_history"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_invoices_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/customers/my/invoices"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_invoices_get_by_uuid_request(
    invoice_uuid: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/customers/my/invoices/{invoice_uuid}"
    path_format_arguments = {
        "invoice_uuid": _SERIALIZER.url("invoice_uuid", invoice_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_invoices_get_csv_by_uuid_request(
    invoice_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "text/csv, application/json")

    # Construct URL
    _url = "/v2/customers/my/invoices/{invoice_uuid}/csv"
    path_format_arguments = {
        "invoice_uuid": _SERIALIZER.url("invoice_uuid", invoice_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_invoices_get_pdf_by_uuid_request(
    invoice_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/pdf, application/json")

    # Construct URL
    _url = "/v2/customers/my/invoices/{invoice_uuid}/pdf"
    path_format_arguments = {
        "invoice_uuid": _SERIALIZER.url("invoice_uuid", invoice_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_invoices_get_summary_by_uuid_request(  # pylint: disable=name-too-long
    invoice_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/customers/my/invoices/{invoice_uuid}/summary"
    path_format_arguments = {
        "invoice_uuid": _SERIALIZER.url("invoice_uuid", invoice_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_list_options_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/options"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_list_clusters_request(
    *, tag_name: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases"

    # Construct parameters
    if tag_name is not None:
        _params["tag_name"] = _SERIALIZER.query("tag_name", tag_name, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_databases_create_cluster_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_cluster_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_destroy_cluster_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_get_config_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/config"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_patch_config_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/config"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_databases_get_ca_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/ca"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_get_migration_status_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/online-migration"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_online_migration_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/online-migration"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_delete_online_migration_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, migration_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/online-migration/{migration_id}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "migration_id": _SERIALIZER.url("migration_id", migration_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_update_region_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/migrate"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_update_cluster_size_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/resize"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_list_firewall_rules_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/firewall"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_firewall_rules_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/firewall"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_update_maintenance_window_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/maintenance"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_install_update_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/install_update"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_list_backups_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/backups"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_list_replicas_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/replicas"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_create_replica_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/replicas"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_list_events_logs_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/events"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_get_replica_request(
    database_cluster_uuid: str, replica_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/replicas/{replica_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "replica_name": _SERIALIZER.url("replica_name", replica_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_destroy_replica_request(
    database_cluster_uuid: str, replica_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/replicas/{replica_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "replica_name": _SERIALIZER.url("replica_name", replica_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_promote_replica_request(
    database_cluster_uuid: str, replica_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/replicas/{replica_name}/promote"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "replica_name": _SERIALIZER.url("replica_name", replica_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_list_users_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_add_user_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_user_request(
    database_cluster_uuid: str, username: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users/{username}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "username": _SERIALIZER.url("username", username, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_delete_user_request(
    database_cluster_uuid: str, username: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users/{username}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "username": _SERIALIZER.url("username", username, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_update_user_request(
    database_cluster_uuid: str, username: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users/{username}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "username": _SERIALIZER.url("username", username, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_reset_auth_request(
    database_cluster_uuid: str, username: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/users/{username}/reset_auth"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "username": _SERIALIZER.url("username", username, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_list_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/dbs"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_add_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/dbs"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_request(
    database_cluster_uuid: str, database_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/dbs/{database_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "database_name": _SERIALIZER.url("database_name", database_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_delete_request(
    database_cluster_uuid: str, database_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/dbs/{database_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "database_name": _SERIALIZER.url("database_name", database_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_list_connection_pools_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/pools"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_add_connection_pool_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/pools"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_connection_pool_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, pool_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/pools/{pool_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "pool_name": _SERIALIZER.url("pool_name", pool_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_connection_pool_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, pool_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/pools/{pool_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "pool_name": _SERIALIZER.url("pool_name", pool_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_delete_connection_pool_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, pool_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/pools/{pool_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "pool_name": _SERIALIZER.url("pool_name", pool_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_get_eviction_policy_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/eviction_policy"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_eviction_policy_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/eviction_policy"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_get_sql_mode_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/sql_mode"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_sql_mode_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/sql_mode"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_update_major_version_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/upgrade"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_list_kafka_topics_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/topics"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_create_kafka_topic_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/topics"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_kafka_topic_request(
    database_cluster_uuid: str, topic_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/topics/{topic_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "topic_name": _SERIALIZER.url("topic_name", topic_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_kafka_topic_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, topic_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/topics/{topic_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "topic_name": _SERIALIZER.url("topic_name", topic_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_delete_kafka_topic_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, topic_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/topics/{topic_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "topic_name": _SERIALIZER.url("topic_name", topic_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_list_logsink_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/logsink"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_create_logsink_request(
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/logsink"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_databases_get_logsink_request(
    database_cluster_uuid: str, logsink_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/logsink/{logsink_id}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "logsink_id": _SERIALIZER.url("logsink_id", logsink_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_logsink_request(
    database_cluster_uuid: str, logsink_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/logsink/{logsink_id}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "logsink_id": _SERIALIZER.url("logsink_id", logsink_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_delete_logsink_request(
    database_cluster_uuid: str, logsink_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/logsink/{logsink_id}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "logsink_id": _SERIALIZER.url("logsink_id", logsink_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_databases_get_cluster_metrics_credentials_request(  # pylint: disable=name-too-long
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/metrics/credentials"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_update_cluster_metrics_credentials_request(  # pylint: disable=name-too-long
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/metrics/credentials"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_databases_list_opeasearch_indexes_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/indexes"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_databases_delete_opensearch_index_request(  # pylint: disable=name-too-long
    database_cluster_uuid: str, index_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/databases/{database_cluster_uuid}/indexes/{index_name}"
    path_format_arguments = {
        "database_cluster_uuid": _SERIALIZER.url(
            "database_cluster_uuid", database_cluster_uuid, "str"
        ),
        "index_name": _SERIALIZER.url("index_name", index_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_domains_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_domains_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_domains_get_request(domain_name: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_domains_delete_request(domain_name: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_domains_list_records_request(
    domain_name: str,
    *,
    name: Optional[str] = None,
    type: Optional[str] = None,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")
    if type is not None:
        _params["type"] = _SERIALIZER.query("type", type, "str")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_domains_create_record_request(domain_name: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_domains_get_record_request(
    domain_name: str, domain_record_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records/{domain_record_id}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
        "domain_record_id": _SERIALIZER.url(
            "domain_record_id", domain_record_id, "int"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_domains_patch_record_request(
    domain_name: str, domain_record_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records/{domain_record_id}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
        "domain_record_id": _SERIALIZER.url(
            "domain_record_id", domain_record_id, "int"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_domains_update_record_request(
    domain_name: str, domain_record_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records/{domain_record_id}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
        "domain_record_id": _SERIALIZER.url(
            "domain_record_id", domain_record_id, "int"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_domains_delete_record_request(
    domain_name: str, domain_record_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/domains/{domain_name}/records/{domain_record_id}"
    path_format_arguments = {
        "domain_name": _SERIALIZER.url("domain_name", domain_name, "str"),
        "domain_record_id": _SERIALIZER.url(
            "domain_record_id", domain_record_id, "int"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_droplets_list_request(
    *,
    per_page: int = 20,
    page: int = 1,
    tag_name: Optional[str] = None,
    name: Optional[str] = None,
    type: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if tag_name is not None:
        _params["tag_name"] = _SERIALIZER.query("tag_name", tag_name, "str")
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")
    if type is not None:
        _params["type"] = _SERIALIZER.query("type", type, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_droplets_destroy_by_tag_request(
    *, tag_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets"

    # Construct parameters
    _params["tag_name"] = _SERIALIZER.query("tag_name", tag_name, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="DELETE", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_get_request(droplet_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_destroy_request(droplet_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_droplets_list_backups_request(
    droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/backups"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_get_backup_policy_request(
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/backups/policy"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_list_backup_policies_request(  # pylint: disable=name-too-long
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/backups/policies"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_list_supported_backup_policies_request(  # pylint: disable=name-too-long
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/backups/supported_policies"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_list_snapshots_request(
    droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/snapshots"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_list_kernels_request(
    droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/kernels"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_list_firewalls_request(
    droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/firewalls"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplets_list_neighbors_request(
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/neighbors"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_list_associated_resources_request(  # pylint: disable=name-too-long
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/destroy_with_associated_resources"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_destroy_with_associated_resources_selective_request(  # pylint: disable=name-too-long
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/destroy_with_associated_resources/selective"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_droplets_destroy_with_associated_resources_dangerous_request(  # pylint: disable=name-too-long
    droplet_id: int, *, x_dangerous: bool, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/destroy_with_associated_resources/dangerous"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["X-Dangerous"] = _SERIALIZER.header("x_dangerous", x_dangerous, "bool")
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_droplets_get_destroy_associated_resources_status_request(  # pylint: disable=name-too-long
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/destroy_with_associated_resources/status"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplets_destroy_retry_with_associated_resources_request(  # pylint: disable=name-too-long
    droplet_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/destroy_with_associated_resources/retry"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_droplets_list_neighbors_ids_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reports/droplet_neighbors_ids"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_droplet_actions_list_request(
    droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/actions"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplet_actions_post_request(droplet_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/actions"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_droplet_actions_post_by_tag_request(  # pylint: disable=name-too-long
    *, tag_name: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/actions"

    # Construct parameters
    if tag_name is not None:
        _params["tag_name"] = _SERIALIZER.query("tag_name", tag_name, "str")

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="POST", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_droplet_actions_get_request(
    droplet_id: int, action_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/{droplet_id}/actions/{action_id}"
    path_format_arguments = {
        "droplet_id": _SERIALIZER.url("droplet_id", droplet_id, "int", minimum=1),
        "action_id": _SERIALIZER.url("action_id", action_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_list_request(
    *, per_page: int = 20, page: int = 1, name: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_autoscalepools_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_get_request(
    autoscale_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_update_request(
    autoscale_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_delete_request(
    autoscale_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_delete_dangerous_request(  # pylint: disable=name-too-long
    autoscale_pool_id: str, *, x_dangerous: bool, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}/dangerous"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["X-Dangerous"] = _SERIALIZER.header("x_dangerous", x_dangerous, "bool")
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_autoscalepools_list_members_request(  # pylint: disable=name-too-long
    autoscale_pool_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}/members"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_autoscalepools_list_history_request(  # pylint: disable=name-too-long
    autoscale_pool_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/droplets/autoscale/{autoscale_pool_id}/history"
    path_format_arguments = {
        "autoscale_pool_id": _SERIALIZER.url(
            "autoscale_pool_id", autoscale_pool_id, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_firewalls_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_firewalls_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_firewalls_get_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_firewalls_update_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_firewalls_delete_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_firewalls_assign_droplets_request(
    firewall_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/droplets"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_firewalls_delete_droplets_request(
    firewall_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/droplets"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_firewalls_add_tags_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/tags"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_firewalls_delete_tags_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/tags"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_firewalls_add_rules_request(firewall_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/rules"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_firewalls_delete_rules_request(
    firewall_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/firewalls/{firewall_id}/rules"
    path_format_arguments = {
        "firewall_id": _SERIALIZER.url("firewall_id", firewall_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_functions_list_namespaces_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_functions_create_namespace_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_functions_get_namespace_request(
    namespace_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_functions_delete_namespace_request(
    namespace_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_functions_list_triggers_request(
    namespace_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}/triggers"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_functions_create_trigger_request(
    namespace_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}/triggers"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_functions_get_trigger_request(
    namespace_id: str, trigger_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}/triggers/{trigger_name}"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
        "trigger_name": _SERIALIZER.url("trigger_name", trigger_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_functions_update_trigger_request(
    namespace_id: str, trigger_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}/triggers/{trigger_name}"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
        "trigger_name": _SERIALIZER.url("trigger_name", trigger_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_functions_delete_trigger_request(
    namespace_id: str, trigger_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/functions/namespaces/{namespace_id}/triggers/{trigger_name}"
    path_format_arguments = {
        "namespace_id": _SERIALIZER.url("namespace_id", namespace_id, "str"),
        "trigger_name": _SERIALIZER.url("trigger_name", trigger_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_images_list_request(
    *,
    type: Optional[str] = None,
    private: Optional[bool] = None,
    tag_name: Optional[str] = None,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images"

    # Construct parameters
    if type is not None:
        _params["type"] = _SERIALIZER.query("type", type, "str")
    if private is not None:
        _params["private"] = _SERIALIZER.query("private", private, "bool")
    if tag_name is not None:
        _params["tag_name"] = _SERIALIZER.query("tag_name", tag_name, "str")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_images_create_custom_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_images_get_request(image_id: JSON, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "object"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_images_update_request(image_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "int"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_images_delete_request(image_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "int"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_image_actions_list_request(image_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}/actions"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "int"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_image_actions_post_request(image_id: int, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}/actions"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "int"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_image_actions_get_request(
    image_id: int, action_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/images/{image_id}/actions/{action_id}"
    path_format_arguments = {
        "image_id": _SERIALIZER.url("image_id", image_id, "int"),
        "action_id": _SERIALIZER.url("action_id", action_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_list_clusters_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_kubernetes_create_cluster_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_cluster_request(cluster_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_update_cluster_request(
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_kubernetes_delete_cluster_request(
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_kubernetes_list_associated_resources_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/destroy_with_associated_resources"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_destroy_associated_resources_selective_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/destroy_with_associated_resources/selective"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_kubernetes_destroy_associated_resources_dangerous_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/destroy_with_associated_resources/dangerous"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_kubeconfig_request(
    cluster_id: str, *, expiry_seconds: int = 0, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/kubeconfig"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if expiry_seconds is not None:
        _params["expiry_seconds"] = _SERIALIZER.query(
            "expiry_seconds", expiry_seconds, "int", minimum=0
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_kubernetes_get_credentials_request(
    cluster_id: str, *, expiry_seconds: int = 0, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/credentials"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if expiry_seconds is not None:
        _params["expiry_seconds"] = _SERIALIZER.query(
            "expiry_seconds", expiry_seconds, "int", minimum=0
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_kubernetes_get_available_upgrades_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/upgrades"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_upgrade_cluster_request(
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/upgrade"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_list_node_pools_request(
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_add_node_pool_request(
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_node_pool_request(
    cluster_id: str, node_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools/{node_pool_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
        "node_pool_id": _SERIALIZER.url("node_pool_id", node_pool_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_update_node_pool_request(  # pylint: disable=name-too-long
    cluster_id: str, node_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools/{node_pool_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
        "node_pool_id": _SERIALIZER.url("node_pool_id", node_pool_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_kubernetes_delete_node_pool_request(  # pylint: disable=name-too-long
    cluster_id: str, node_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools/{node_pool_id}"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
        "node_pool_id": _SERIALIZER.url("node_pool_id", node_pool_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_kubernetes_delete_node_request(
    cluster_id: str,
    node_pool_id: str,
    node_id: str,
    *,
    skip_drain: int = 0,
    replace: int = 0,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = (
        "/v2/kubernetes/clusters/{cluster_id}/node_pools/{node_pool_id}/nodes/{node_id}"
    )
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
        "node_pool_id": _SERIALIZER.url("node_pool_id", node_pool_id, "str"),
        "node_id": _SERIALIZER.url("node_id", node_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if skip_drain is not None:
        _params["skip_drain"] = _SERIALIZER.query(
            "skip_drain", skip_drain, "int", maximum=1, minimum=0
        )
    if replace is not None:
        _params["replace"] = _SERIALIZER.query(
            "replace", replace, "int", maximum=1, minimum=0
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="DELETE", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_kubernetes_recycle_node_pool_request(  # pylint: disable=name-too-long
    cluster_id: str, node_pool_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/node_pools/{node_pool_id}/recycle"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
        "node_pool_id": _SERIALIZER.url("node_pool_id", node_pool_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_cluster_user_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/user"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_list_options_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/options"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_kubernetes_run_cluster_lint_request(  # pylint: disable=name-too-long
    cluster_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/clusterlint"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_cluster_lint_results_request(  # pylint: disable=name-too-long
    cluster_id: str, *, run_id: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/clusterlint"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if run_id is not None:
        _params["run_id"] = _SERIALIZER.query("run_id", run_id, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_kubernetes_add_registry_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/registry"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_kubernetes_remove_registry_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/registry"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_kubernetes_get_status_messages_request(  # pylint: disable=name-too-long
    cluster_id: str, *, since: Optional[datetime.datetime] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/kubernetes/clusters/{cluster_id}/status_messages"
    path_format_arguments = {
        "cluster_id": _SERIALIZER.url("cluster_id", cluster_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if since is not None:
        _params["since"] = _SERIALIZER.query("since", since, "iso-8601")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_load_balancers_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_load_balancers_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_load_balancers_get_request(lb_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_load_balancers_update_request(lb_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_load_balancers_delete_request(lb_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_load_balancers_delete_cache_request(  # pylint: disable=name-too-long
    lb_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}/cache"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_load_balancers_add_droplets_request(  # pylint: disable=name-too-long
    lb_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}/droplets"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_load_balancers_remove_droplets_request(  # pylint: disable=name-too-long
    lb_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}/droplets"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_load_balancers_add_forwarding_rules_request(  # pylint: disable=name-too-long
    lb_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}/forwarding_rules"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_load_balancers_remove_forwarding_rules_request(  # pylint: disable=name-too-long
    lb_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/load_balancers/{lb_id}/forwarding_rules"
    path_format_arguments = {
        "lb_id": _SERIALIZER.url("lb_id", lb_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_monitoring_list_alert_policy_request(  # pylint: disable=name-too-long
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/alerts"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_create_alert_policy_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/alerts"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_monitoring_get_alert_policy_request(  # pylint: disable=name-too-long
    alert_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/alerts/{alert_uuid}"
    path_format_arguments = {
        "alert_uuid": _SERIALIZER.url("alert_uuid", alert_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_monitoring_update_alert_policy_request(  # pylint: disable=name-too-long
    alert_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/alerts/{alert_uuid}"
    path_format_arguments = {
        "alert_uuid": _SERIALIZER.url("alert_uuid", alert_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_monitoring_delete_alert_policy_request(  # pylint: disable=name-too-long
    alert_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/alerts/{alert_uuid}"
    path_format_arguments = {
        "alert_uuid": _SERIALIZER.url("alert_uuid", alert_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_monitoring_get_droplet_bandwidth_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, interface: str, direction: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/bandwidth"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["interface"] = _SERIALIZER.query("interface", interface, "str")
    _params["direction"] = _SERIALIZER.query("direction", direction, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_cpu_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/cpu"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_filesystem_free_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/filesystem_free"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_filesystem_size_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/filesystem_size"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_load1_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/load_1"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_load5_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/load_5"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_load15_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/load_15"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_memory_cached_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/memory_cached"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_memory_free_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/memory_free"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_memory_total_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/memory_total"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_memory_available_metrics_request(  # pylint: disable=name-too-long
    *, host_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet/memory_available"

    # Construct parameters
    _params["host_id"] = _SERIALIZER.query("host_id", host_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_app_memory_percentage_metrics_request(  # pylint: disable=name-too-long
    *,
    app_id: str,
    start: str,
    end: str,
    app_component: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/apps/memory_percentage"

    # Construct parameters
    _params["app_id"] = _SERIALIZER.query("app_id", app_id, "str")
    if app_component is not None:
        _params["app_component"] = _SERIALIZER.query(
            "app_component", app_component, "str"
        )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_app_cpu_percentage_metrics_request(  # pylint: disable=name-too-long
    *,
    app_id: str,
    start: str,
    end: str,
    app_component: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/apps/cpu_percentage"

    # Construct parameters
    _params["app_id"] = _SERIALIZER.query("app_id", app_id, "str")
    if app_component is not None:
        _params["app_component"] = _SERIALIZER.query(
            "app_component", app_component, "str"
        )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_app_restart_count_metrics_yml_request(  # pylint: disable=name-too-long
    *,
    app_id: str,
    start: str,
    end: str,
    app_component: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/apps/restart_count"

    # Construct parameters
    _params["app_id"] = _SERIALIZER.query("app_id", app_id, "str")
    if app_component is not None:
        _params["app_component"] = _SERIALIZER.query(
            "app_component", app_component, "str"
        )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_connections_current_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_connections_current"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_connections_limit_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_connections_limit"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_cpu_utilization_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_cpu_utilization"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_firewall_dropped_bytes_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_firewall_dropped_bytes"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_firewall_dropped_packets_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_firewall_dropped_packets"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_http_responses_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_http_responses"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_http_requests_per_second_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_http_requests_per_second"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_network_throughput_http_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_network_throughput_http"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_network_throughput_udp_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_network_throughput_udp"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_network_throughput_tcp_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_network_throughput_tcp"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_nlb_tcp_network_throughput_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_nlb_tcp_network_throughput"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_nlb_udp_network_throughput_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_nlb_udp_network_throughput"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_tls_connections_current_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_tls_connections_current"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_tls_connections_limit_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_tls_connections_limit"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_frontend_tls_connections_exceeding_rate_limit_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/frontend_tls_connections_exceeding_rate_limit"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_session_duration_avg_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_avg"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_session_duration50_p_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_50p"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_session_duration95_p_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_95p"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_response_time_avg_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_response_time_avg"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_response_time50_p_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_response_time_50p"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_response_time95_p_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_response_time_95p"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_response_time99_p_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_response_time_99p"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_queue_size_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_queue_size"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_http_responses_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_http_responses"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_connections_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_connections"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_health_checks_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_health_checks"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_lb_droplets_downtime_request(  # pylint: disable=name-too-long
    *, lb_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/load_balancer/droplets_downtime"

    # Construct parameters
    _params["lb_id"] = _SERIALIZER.query("lb_id", lb_id, "str")
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_current_instances_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/current_instances"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_target_instances_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/target_instances"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_current_cpu_utilization_yml_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/current_cpu_utilization"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_target_cpu_utilization_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/target_cpu_utilization"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_current_memory_utilization_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/current_memory_utilization"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_droplet_autoscale_target_memory_utilization_request(  # pylint: disable=name-too-long
    *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/metrics/droplet_autoscale/target_memory_utilization"

    # Construct parameters
    _params["autoscale_pool_id"] = _SERIALIZER.query(
        "autoscale_pool_id", autoscale_pool_id, "str"
    )
    _params["start"] = _SERIALIZER.query("start", start, "str")
    _params["end"] = _SERIALIZER.query("end", end, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_create_destination_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/destinations"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_monitoring_list_destinations_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/destinations"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_monitoring_get_destination_request(
    destination_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/destinations/{destination_uuid}"
    path_format_arguments = {
        "destination_uuid": _SERIALIZER.url(
            "destination_uuid", destination_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_monitoring_update_destination_request(  # pylint: disable=name-too-long
    destination_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/destinations/{destination_uuid}"
    path_format_arguments = {
        "destination_uuid": _SERIALIZER.url(
            "destination_uuid", destination_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_monitoring_delete_destination_request(  # pylint: disable=name-too-long
    destination_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/destinations/{destination_uuid}"
    path_format_arguments = {
        "destination_uuid": _SERIALIZER.url(
            "destination_uuid", destination_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_monitoring_create_sink_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_monitoring_list_sinks_request(
    *, resource_id: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks"

    # Construct parameters
    if resource_id is not None:
        _params["resource_id"] = _SERIALIZER.query(
            "resource_id",
            resource_id,
            "str",
            pattern=r"^do:(dbaas|domain|droplet|floatingip|loadbalancer|space|volume|kubernetes|vpc):.*",
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_monitoring_get_sink_request(sink_uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/{sink_uuid}"
    path_format_arguments = {
        "sink_uuid": _SERIALIZER.url("sink_uuid", sink_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_monitoring_delete_sink_request(sink_uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/monitoring/sinks/{sink_uuid}"
    path_format_arguments = {
        "sink_uuid": _SERIALIZER.url("sink_uuid", sink_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_partner_attachments_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_get_request(pa_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_patch_request(pa_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_delete_request(pa_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_get_bgp_auth_key_request(  # pylint: disable=name-too-long
    pa_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}/bgp_auth_key"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_list_remote_routes_request(  # pylint: disable=name-too-long
    pa_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}/remote_routes"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_partner_attachments_update_remote_routes_request(  # pylint: disable=name-too-long
    pa_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}/remote_routes"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_get_service_key_request(  # pylint: disable=name-too-long
    pa_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}/service_key"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_partner_attachments_create_service_key_request(  # pylint: disable=name-too-long
    pa_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/partner_network_connect/attachments/{pa_id}/service_key"
    path_format_arguments = {
        "pa_id": _SERIALIZER.url("pa_id", pa_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_projects_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_projects_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_projects_get_default_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/default"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_projects_update_default_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/default"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_projects_patch_default_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/default"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_projects_get_request(project_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_projects_update_request(project_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_projects_patch_request(project_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_projects_delete_request(project_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_projects_list_resources_request(
    project_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}/resources"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_projects_assign_resources_request(
    project_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/{project_id}/resources"
    path_format_arguments = {
        "project_id": _SERIALIZER.url("project_id", project_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_projects_list_resources_default_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/default/resources"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_projects_assign_resources_default_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/projects/default/resources"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_regions_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/regions"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_get_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_registry_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_registry_delete_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_registry_get_subscription_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/subscription"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_registry_update_subscription_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/subscription"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_registry_get_docker_credentials_request(  # pylint: disable=name-too-long
    *, expiry_seconds: int = 0, read_write: bool = False, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/docker-credentials"

    # Construct parameters
    if expiry_seconds is not None:
        _params["expiry_seconds"] = _SERIALIZER.query(
            "expiry_seconds", expiry_seconds, "int", minimum=0
        )
    if read_write is not None:
        _params["read_write"] = _SERIALIZER.query("read_write", read_write, "bool")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_validate_name_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/validate-name"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_registry_list_repositories_request(
    registry_name: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositories"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_list_repositories_v2_request(  # pylint: disable=name-too-long
    registry_name: str,
    *,
    per_page: int = 20,
    page: int = 1,
    page_token: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositoriesV2"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if page_token is not None:
        _params["page_token"] = _SERIALIZER.query("page_token", page_token, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_list_repository_tags_request(  # pylint: disable=name-too-long
    registry_name: str,
    repository_name: str,
    *,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositories/{repository_name}/tags"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
        "repository_name": _SERIALIZER.url("repository_name", repository_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_delete_repository_tag_request(  # pylint: disable=name-too-long
    registry_name: str, repository_name: str, repository_tag: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositories/{repository_name}/tags/{repository_tag}"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
        "repository_name": _SERIALIZER.url("repository_name", repository_name, "str"),
        "repository_tag": _SERIALIZER.url("repository_tag", repository_tag, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_registry_list_repository_manifests_request(  # pylint: disable=name-too-long
    registry_name: str,
    repository_name: str,
    *,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositories/{repository_name}/digests"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
        "repository_name": _SERIALIZER.url("repository_name", repository_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_delete_repository_manifest_request(  # pylint: disable=name-too-long
    registry_name: str, repository_name: str, manifest_digest: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/repositories/{repository_name}/digests/{manifest_digest}"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
        "repository_name": _SERIALIZER.url("repository_name", repository_name, "str"),
        "manifest_digest": _SERIALIZER.url("manifest_digest", manifest_digest, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_registry_run_garbage_collection_request(  # pylint: disable=name-too-long
    registry_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/garbage-collection"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_registry_get_garbage_collection_request(  # pylint: disable=name-too-long
    registry_name: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/garbage-collection"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_registry_list_garbage_collections_request(  # pylint: disable=name-too-long
    registry_name: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/garbage-collections"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_registry_update_garbage_collection_request(  # pylint: disable=name-too-long
    registry_name: str, garbage_collection_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/{registry_name}/garbage-collection/{garbage_collection_uuid}"
    path_format_arguments = {
        "registry_name": _SERIALIZER.url("registry_name", registry_name, "str"),
        "garbage_collection_uuid": _SERIALIZER.url(
            "garbage_collection_uuid", garbage_collection_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_registry_get_options_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/registry/options"

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_reserved_ips_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_get_request(reserved_ip: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips/{reserved_ip}"
    path_format_arguments = {
        "reserved_ip": _SERIALIZER.url("reserved_ip", reserved_ip, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_delete_request(reserved_ip: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips/{reserved_ip}"
    path_format_arguments = {
        "reserved_ip": _SERIALIZER.url("reserved_ip", reserved_ip, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_actions_list_request(
    reserved_ip: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips/{reserved_ip}/actions"
    path_format_arguments = {
        "reserved_ip": _SERIALIZER.url("reserved_ip", reserved_ip, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_actions_post_request(
    reserved_ip: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips/{reserved_ip}/actions"
    path_format_arguments = {
        "reserved_ip": _SERIALIZER.url("reserved_ip", reserved_ip, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_reserved_ips_actions_get_request(
    reserved_ip: str, action_id: int, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ips/{reserved_ip}/actions/{action_id}"
    path_format_arguments = {
        "reserved_ip": _SERIALIZER.url("reserved_ip", reserved_ip, "str"),
        "action_id": _SERIALIZER.url("action_id", action_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_reserved_ipv6_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ipv6"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_reserved_ipv6_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ipv6"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_reserved_ipv6_get_request(reserved_ipv6: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ipv6/{reserved_ipv6}"
    path_format_arguments = {
        "reserved_ipv6": _SERIALIZER.url("reserved_ipv6", reserved_ipv6, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_reserved_ipv6_delete_request(
    reserved_ipv6: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ipv6/{reserved_ipv6}"
    path_format_arguments = {
        "reserved_ipv6": _SERIALIZER.url("reserved_ipv6", reserved_ipv6, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_reserved_ipv6_actions_post_request(
    reserved_ipv6: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/reserved_ipv6/{reserved_ipv6}/actions"
    path_format_arguments = {
        "reserved_ipv6": _SERIALIZER.url("reserved_ipv6", reserved_ipv6, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_sizes_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/sizes"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_snapshots_list_request(
    *,
    per_page: int = 20,
    page: int = 1,
    resource_type: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/snapshots"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if resource_type is not None:
        _params["resource_type"] = _SERIALIZER.query(
            "resource_type", resource_type, "str"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_snapshots_get_request(snapshot_id: JSON, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/snapshots/{snapshot_id}"
    path_format_arguments = {
        "snapshot_id": _SERIALIZER.url("snapshot_id", snapshot_id, "object"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_snapshots_delete_request(snapshot_id: JSON, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/snapshots/{snapshot_id}"
    path_format_arguments = {
        "snapshot_id": _SERIALIZER.url("snapshot_id", snapshot_id, "object"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_spaces_key_list_request(
    *,
    per_page: int = 20,
    page: int = 1,
    sort: str = "created_at",
    sort_direction: str = "desc",
    name: Optional[str] = None,
    bucket: Optional[str] = None,
    permission: Optional[str] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if sort is not None:
        _params["sort"] = _SERIALIZER.query("sort", sort, "str")
    if sort_direction is not None:
        _params["sort_direction"] = _SERIALIZER.query(
            "sort_direction", sort_direction, "str"
        )
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")
    if bucket is not None:
        _params["bucket"] = _SERIALIZER.query("bucket", bucket, "str")
    if permission is not None:
        _params["permission"] = _SERIALIZER.query("permission", permission, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_spaces_key_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_spaces_key_get_request(access_key: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys/{access_key}"
    path_format_arguments = {
        "access_key": _SERIALIZER.url("access_key", access_key, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_spaces_key_delete_request(access_key: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys/{access_key}"
    path_format_arguments = {
        "access_key": _SERIALIZER.url("access_key", access_key, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_spaces_key_update_request(access_key: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys/{access_key}"
    path_format_arguments = {
        "access_key": _SERIALIZER.url("access_key", access_key, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_spaces_key_patch_request(access_key: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/spaces/keys/{access_key}"
    path_format_arguments = {
        "access_key": _SERIALIZER.url("access_key", access_key, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_tags_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_tags_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_tags_get_request(tag_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags/{tag_id}"
    path_format_arguments = {
        "tag_id": _SERIALIZER.url(
            "tag_id", tag_id, "str", max_length=255, pattern=r"^[a-zA-Z0-9_\-\:]+$"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_tags_delete_request(tag_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags/{tag_id}"
    path_format_arguments = {
        "tag_id": _SERIALIZER.url(
            "tag_id", tag_id, "str", max_length=255, pattern=r"^[a-zA-Z0-9_\-\:]+$"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_tags_assign_resources_request(tag_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags/{tag_id}/resources"
    path_format_arguments = {
        "tag_id": _SERIALIZER.url(
            "tag_id", tag_id, "str", max_length=255, pattern=r"^[a-zA-Z0-9_\-\:]+$"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_tags_unassign_resources_request(tag_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/tags/{tag_id}/resources"
    path_format_arguments = {
        "tag_id": _SERIALIZER.url(
            "tag_id", tag_id, "str", max_length=255, pattern=r"^[a-zA-Z0-9_\-\:]+$"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_volumes_list_request(
    *,
    name: Optional[str] = None,
    region: Optional[str] = None,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes"

    # Construct parameters
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")
    if region is not None:
        _params["region"] = _SERIALIZER.query("region", region, "str")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volumes_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_volumes_delete_by_name_request(
    *, name: Optional[str] = None, region: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes"

    # Construct parameters
    if name is not None:
        _params["name"] = _SERIALIZER.query("name", name, "str")
    if region is not None:
        _params["region"] = _SERIALIZER.query("region", region, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="DELETE", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volumes_get_request(volume_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_volumes_delete_request(volume_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_volume_actions_post_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/actions"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="POST", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volume_actions_list_request(
    volume_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}/actions"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volume_actions_post_by_id_request(
    volume_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}/actions"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="POST", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volume_actions_get_request(
    volume_id: str, action_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}/actions/{action_id}"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
        "action_id": _SERIALIZER.url("action_id", action_id, "int", minimum=1),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volume_snapshots_get_by_id_request(
    snapshot_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/snapshots/{snapshot_id}"
    path_format_arguments = {
        "snapshot_id": _SERIALIZER.url("snapshot_id", snapshot_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_volume_snapshots_delete_by_id_request(  # pylint: disable=name-too-long
    snapshot_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/snapshots/{snapshot_id}"
    path_format_arguments = {
        "snapshot_id": _SERIALIZER.url("snapshot_id", snapshot_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_volume_snapshots_list_request(
    volume_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}/snapshots"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_volume_snapshots_create_request(volume_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/volumes/{volume_id}/snapshots"
    path_format_arguments = {
        "volume_id": _SERIALIZER.url("volume_id", volume_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_vpcs_list_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_vpcs_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_vpcs_get_request(vpc_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_vpcs_update_request(vpc_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_vpcs_patch_request(vpc_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_vpcs_delete_request(vpc_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_vpcs_list_members_request(
    vpc_id: str,
    *,
    resource_type: Optional[str] = None,
    per_page: int = 20,
    page: int = 1,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}/members"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if resource_type is not None:
        _params["resource_type"] = _SERIALIZER.query(
            "resource_type", resource_type, "str"
        )
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_vpcs_list_peerings_request(
    vpc_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}/peerings"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_vpcs_create_peerings_request(vpc_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}/peerings"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_vpcs_patch_peerings_request(
    vpc_id: str, vpc_peering_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpcs/{vpc_id}/peerings/{vpc_peering_id}"
    path_format_arguments = {
        "vpc_id": _SERIALIZER.url("vpc_id", vpc_id, "str"),
        "vpc_peering_id": _SERIALIZER.url("vpc_peering_id", vpc_peering_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_vpc_peerings_list_request(
    *, per_page: int = 20, page: int = 1, region: Optional[str] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpc_peerings"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)
    if region is not None:
        _params["region"] = _SERIALIZER.query("region", region, "str")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_vpc_peerings_create_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpc_peerings"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_vpc_peerings_get_request(vpc_peering_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpc_peerings/{vpc_peering_id}"
    path_format_arguments = {
        "vpc_peering_id": _SERIALIZER.url("vpc_peering_id", vpc_peering_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_vpc_peerings_patch_request(vpc_peering_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpc_peerings/{vpc_peering_id}"
    path_format_arguments = {
        "vpc_peering_id": _SERIALIZER.url("vpc_peering_id", vpc_peering_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PATCH", url=_url, headers=_headers, **kwargs)


def build_vpc_peerings_delete_request(
    vpc_peering_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/vpc_peerings/{vpc_peering_id}"
    path_format_arguments = {
        "vpc_peering_id": _SERIALIZER.url("vpc_peering_id", vpc_peering_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_uptime_list_checks_request(
    *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks"

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_uptime_create_check_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_uptime_get_check_request(check_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_uptime_update_check_request(check_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_uptime_delete_check_request(check_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_uptime_get_check_state_request(check_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/state"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_uptime_list_alerts_request(
    check_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/alerts"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query(
            "per_page", per_page, "int", maximum=200, minimum=1
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int", minimum=1)

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_uptime_create_alert_request(check_id: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/alerts"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_uptime_get_alert_request(
    check_id: str, alert_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/alerts/{alert_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
        "alert_id": _SERIALIZER.url("alert_id", alert_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_uptime_update_alert_request(
    check_id: str, alert_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/alerts/{alert_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
        "alert_id": _SERIALIZER.url("alert_id", alert_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_uptime_delete_alert_request(
    check_id: str, alert_id: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/uptime/checks/{check_id}/alerts/{alert_id}"
    path_format_arguments = {
        "check_id": _SERIALIZER.url("check_id", check_id, "str"),
        "alert_id": _SERIALIZER.url("alert_id", alert_id, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_list_agents_request(
    *,
    only_deployed: Optional[bool] = None,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents"

    # Construct parameters
    if only_deployed is not None:
        _params["only_deployed"] = _SERIALIZER.query(
            "only_deployed", only_deployed, "bool"
        )
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_agent_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_list_agent_api_keys_request(
    agent_uuid: str,
    *,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/api_keys"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_agent_api_key_request(
    agent_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/api_keys"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_update_agent_api_key_request(
    agent_uuid: str, api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_delete_agent_api_key_request(
    agent_uuid: str, api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_regenerate_agent_api_key_request(  # pylint: disable=name-too-long
    agent_uuid: str, api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}/regenerate"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_attach_agent_function_request(  # pylint: disable=name-too-long
    agent_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/functions"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_update_agent_function_request(  # pylint: disable=name-too-long
    agent_uuid: str, function_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "function_uuid": _SERIALIZER.url("function_uuid", function_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_detach_agent_function_request(  # pylint: disable=name-too-long
    agent_uuid: str, function_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "function_uuid": _SERIALIZER.url("function_uuid", function_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_attach_knowledge_base_request(  # pylint: disable=name-too-long
    agent_uuid: str, knowledge_base_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/knowledge_bases/{knowledge_base_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "knowledge_base_uuid": _SERIALIZER.url(
            "knowledge_base_uuid", knowledge_base_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_detach_knowledge_base_request(  # pylint: disable=name-too-long
    agent_uuid: str, knowledge_base_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{agent_uuid}/knowledge_bases/{knowledge_base_uuid}"
    path_format_arguments = {
        "agent_uuid": _SERIALIZER.url("agent_uuid", agent_uuid, "str"),
        "knowledge_base_uuid": _SERIALIZER.url(
            "knowledge_base_uuid", knowledge_base_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_attach_agent_request(
    parent_agent_uuid: str, child_agent_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}"
    path_format_arguments = {
        "parent_agent_uuid": _SERIALIZER.url(
            "parent_agent_uuid", parent_agent_uuid, "str"
        ),
        "child_agent_uuid": _SERIALIZER.url(
            "child_agent_uuid", child_agent_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_update_attached_agent_request(  # pylint: disable=name-too-long
    parent_agent_uuid: str, child_agent_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}"
    path_format_arguments = {
        "parent_agent_uuid": _SERIALIZER.url(
            "parent_agent_uuid", parent_agent_uuid, "str"
        ),
        "child_agent_uuid": _SERIALIZER.url(
            "child_agent_uuid", child_agent_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_detach_agent_request(
    parent_agent_uuid: str, child_agent_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}"
    path_format_arguments = {
        "parent_agent_uuid": _SERIALIZER.url(
            "parent_agent_uuid", parent_agent_uuid, "str"
        ),
        "child_agent_uuid": _SERIALIZER.url(
            "child_agent_uuid", child_agent_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_get_agent_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_update_agent_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_delete_agent_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_get_agent_children_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{uuid}/child_agents"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_update_agent_deployment_visibility_request(  # pylint: disable=name-too-long
    uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/agents/{uuid}/deployment_visibility"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_list_anthropic_api_keys_request(  # pylint: disable=name-too-long
    *, page: Optional[int] = None, per_page: Optional[int] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys"

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_anthropic_api_key_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_get_anthropic_api_key_request(  # pylint: disable=name-too-long
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_update_anthropic_api_key_request(  # pylint: disable=name-too-long
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_delete_anthropic_api_key_request(  # pylint: disable=name-too-long
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_list_agents_by_anthropic_key_request(  # pylint: disable=name-too-long
    uuid: str,
    *,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/anthropic/keys/{uuid}/agents"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_list_indexing_jobs_request(
    *, page: Optional[int] = None, per_page: Optional[int] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/indexing_jobs"

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_indexing_job_request(**kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/indexing_jobs"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_list_indexing_job_data_sources_request(  # pylint: disable=name-too-long
    indexing_job_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/indexing_jobs/{indexing_job_uuid}/data_sources"
    path_format_arguments = {
        "indexing_job_uuid": _SERIALIZER.url(
            "indexing_job_uuid", indexing_job_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_get_indexing_job_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/indexing_jobs/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_cancel_indexing_job_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/indexing_jobs/{uuid}/cancel"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_list_knowledge_bases_request(
    *, page: Optional[int] = None, per_page: Optional[int] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases"

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_knowledge_base_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_list_knowledge_base_data_sources_request(  # pylint: disable=name-too-long
    knowledge_base_uuid: str,
    *,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources"
    path_format_arguments = {
        "knowledge_base_uuid": _SERIALIZER.url(
            "knowledge_base_uuid", knowledge_base_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_knowledge_base_data_source_request(  # pylint: disable=name-too-long
    knowledge_base_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources"
    path_format_arguments = {
        "knowledge_base_uuid": _SERIALIZER.url(
            "knowledge_base_uuid", knowledge_base_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_delete_knowledge_base_data_source_request(  # pylint: disable=name-too-long
    knowledge_base_uuid: str, data_source_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources/{data_source_uuid}"
    path_format_arguments = {
        "knowledge_base_uuid": _SERIALIZER.url(
            "knowledge_base_uuid", knowledge_base_uuid, "str"
        ),
        "data_source_uuid": _SERIALIZER.url(
            "data_source_uuid", data_source_uuid, "str"
        ),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_get_knowledge_base_request(uuid: str, **kwargs: Any) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_update_knowledge_base_request(
    uuid: str, **kwargs: Any
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_delete_knowledge_base_request(
    uuid: str, **kwargs: Any
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/knowledge_bases/{uuid}"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_list_models_request(
    *,
    usecases: Optional[List[str]] = None,
    public_only: Optional[bool] = None,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/models"

    # Construct parameters
    if usecases is not None:
        _params["usecases"] = _SERIALIZER.query("usecases", usecases, "[str]")
    if public_only is not None:
        _params["public_only"] = _SERIALIZER.query("public_only", public_only, "bool")
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_list_openai_api_keys_request(
    *, page: Optional[int] = None, per_page: Optional[int] = None, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys"

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_create_openai_api_key_request(
    **kwargs: Any,
) -> HttpRequest:  # pylint: disable=name-too-long
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys"

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="POST", url=_url, headers=_headers, **kwargs)


def build_genai_get_openai_api_key_request(
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="GET", url=_url, headers=_headers, **kwargs)


def build_genai_update_openai_api_key_request(  # pylint: disable=name-too-long
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    content_type: Optional[str] = kwargs.pop(
        "content_type", _headers.pop("Content-Type", None)
    )
    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    if content_type is not None:
        _headers["Content-Type"] = _SERIALIZER.header(
            "content_type", content_type, "str"
        )
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="PUT", url=_url, headers=_headers, **kwargs)


def build_genai_delete_openai_api_key_request(  # pylint: disable=name-too-long
    api_key_uuid: str, **kwargs: Any
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys/{api_key_uuid}"
    path_format_arguments = {
        "api_key_uuid": _SERIALIZER.url("api_key_uuid", api_key_uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(method="DELETE", url=_url, headers=_headers, **kwargs)


def build_genai_list_agents_by_openai_key_request(  # pylint: disable=name-too-long
    uuid: str,
    *,
    page: Optional[int] = None,
    per_page: Optional[int] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/openai/keys/{uuid}/agents"
    path_format_arguments = {
        "uuid": _SERIALIZER.url("uuid", uuid, "str"),
    }

    _url: str = _url.format(**path_format_arguments)  # type: ignore

    # Construct parameters
    if page is not None:
        _params["page"] = _SERIALIZER.query("page", page, "int")
    if per_page is not None:
        _params["per_page"] = _SERIALIZER.query("per_page", per_page, "int")

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


def build_genai_list_datacenter_regions_request(  # pylint: disable=name-too-long
    *,
    serves_inference: Optional[bool] = None,
    serves_batch: Optional[bool] = None,
    **kwargs: Any,
) -> HttpRequest:
    _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
    _params = case_insensitive_dict(kwargs.pop("params", {}) or {})

    accept = _headers.pop("Accept", "application/json")

    # Construct URL
    _url = "/v2/gen-ai/regions"

    # Construct parameters
    if serves_inference is not None:
        _params["serves_inference"] = _SERIALIZER.query(
            "serves_inference", serves_inference, "bool"
        )
    if serves_batch is not None:
        _params["serves_batch"] = _SERIALIZER.query(
            "serves_batch", serves_batch, "bool"
        )

    # Construct headers
    _headers["Accept"] = _SERIALIZER.header("accept", accept, "str")

    return HttpRequest(
        method="GET", url=_url, params=_params, headers=_headers, **kwargs
    )


class OneClicksOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`one_clicks` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, type: Optional[str] = None, **kwargs: Any) -> JSON:
        """List 1-Click Applications.

        To list all available 1-Click applications, send a GET request to ``/v2/1-clicks``. The
        ``type`` may
        be provided as query paramater in order to restrict results to a certain type of 1-Click, for
        example: ``/v2/1-clicks?type=droplet``. Current supported types are ``kubernetes`` and
        ``droplet``.

        The response will be a JSON object with a key called ``1_clicks``. This will be set to an array
        of
        1-Click application data, each of which will contain the the slug and type for the 1-Click.

        :keyword type: Restrict results to a certain type of 1-Click. Known values are: "droplet" and
         "kubernetes". Default value is None.
        :paramtype type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "1_clicks": [
                        {
                            "slug": "str",  # The slug identifier for the 1-Click
                              application. Required.
                            "type": "str"  # The type of the 1-Click application.
                              Required.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_one_clicks_list_request(
            type=type,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def install_kubernetes(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Install Kubernetes 1-Click Applications.

        To install a Kubernetes 1-Click application on a cluster, send a POST request to
        ``/v2/1-clicks/kubernetes``. The ``addon_slugs`` and ``cluster_uuid`` must be provided as body
        parameter in order to specify which 1-Click application(s) to install. To list all available
        1-Click Kubernetes applications, send a request to ``/v2/1-clicks?type=kubernetes``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "addon_slugs": [
                        "str"  # An array of 1-Click Application slugs to be installed to the
                          Kubernetes cluster. Required.
                    ],
                    "cluster_uuid": "str"  # A unique ID for the Kubernetes cluster to which the
                      1-Click Applications will be installed. Required.
                }

                # response body for status code(s): 200
                response == {
                    "message": "str"  # Optional. A message about the result of the request.
                }
        """

    @overload
    def install_kubernetes(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        """Install Kubernetes 1-Click Applications.

        To install a Kubernetes 1-Click application on a cluster, send a POST request to
        ``/v2/1-clicks/kubernetes``. The ``addon_slugs`` and ``cluster_uuid`` must be provided as body
        parameter in order to specify which 1-Click application(s) to install. To list all available
        1-Click Kubernetes applications, send a request to ``/v2/1-clicks?type=kubernetes``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "message": "str"  # Optional. A message about the result of the request.
                }
        """

    @distributed_trace
    def install_kubernetes(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Install Kubernetes 1-Click Applications.

        To install a Kubernetes 1-Click application on a cluster, send a POST request to
        ``/v2/1-clicks/kubernetes``. The ``addon_slugs`` and ``cluster_uuid`` must be provided as body
        parameter in order to specify which 1-Click application(s) to install. To list all available
        1-Click Kubernetes applications, send a request to ``/v2/1-clicks?type=kubernetes``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "addon_slugs": [
                        "str"  # An array of 1-Click Application slugs to be installed to the
                          Kubernetes cluster. Required.
                    ],
                    "cluster_uuid": "str"  # A unique ID for the Kubernetes cluster to which the
                      1-Click Applications will be installed. Required.
                }

                # response body for status code(s): 200
                response == {
                    "message": "str"  # Optional. A message about the result of the request.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_one_clicks_install_kubernetes_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class AccountOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`account` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def get(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get User Information.

        To show information about the current user account, send a GET request to ``/v2/account``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "account": {
                        "droplet_limit": 0,  # The total number of Droplets current user or
                          team may have active at one time. Required.
                        "email": "str",  # The email address used by the current user to
                          register for DigitalOcean. Required.
                        "email_verified": False,  # Default value is False. If true, the user
                          has verified their account via email. False otherwise. Required.
                        "floating_ip_limit": 0,  # The total number of Floating IPs the
                          current user or team may have. Required.
                        "status": "active",  # Default value is "active". This value is one
                          of "active", "warning" or "locked". Known values are: "active", "warning",
                          and "locked".
                        "status_message": "str",  # A human-readable message giving more
                          details about the status of the account. Required.
                        "uuid": "str",  # The unique universal identifier for the current
                          user. Required.
                        "name": "str",  # Optional. The display name for the current user.
                        "team": {
                            "name": "str",  # Optional. The name for the current team.
                            "uuid": "str"  # Optional. The unique universal identifier
                              for the current team.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_account_get_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class SshKeysOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`ssh_keys` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All SSH Keys.

        To list all of the keys in your account, send a GET request to ``/v2/account/keys``. The
        response will be a JSON object with a key set to ``ssh_keys``. The value of this will be an
        array of ssh_key objects, each of which contains the standard ssh_key attributes.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "ssh_keys": [
                        {
                            "name": "str",  # A human-readable display name for this key,
                              used to easily identify the SSH keys when they are displayed. Required.
                            "public_key": "str",  # The entire public key string that was
                              uploaded. Embedded into the root user's ``authorized_keys`` file if you
                              include this key during Droplet creation. Required.
                            "fingerprint": "str",  # Optional. A unique identifier that
                              differentiates this key from other keys using  a format that SSH
                              recognizes. The fingerprint is created when the key is added to your
                              account.
                            "id": 0  # Optional. A unique identification number for this
                              key. Can be used to embed a  specific SSH key into a Droplet.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_ssh_keys_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New SSH Key.

        To add a new SSH public key to your DigitalOcean account, send a POST request to
        ``/v2/account/keys``. Set the ``name`` attribute to the name you wish to use and the
        ``public_key`` attribute to the full public key you are adding.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable display name for this key, used to easily
                      identify the SSH keys when they are displayed. Required.
                    "public_key": "str",  # The entire public key string that was uploaded.
                      Embedded into the root user's ``authorized_keys`` file if you include this key
                      during Droplet creation. Required.
                    "fingerprint": "str",  # Optional. A unique identifier that differentiates
                      this key from other keys using  a format that SSH recognizes. The fingerprint is
                      created when the key is added to your account.
                    "id": 0  # Optional. A unique identification number for this key. Can be used
                      to embed a  specific SSH key into a Droplet.
                }

                # response body for status code(s): 201
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New SSH Key.

        To add a new SSH public key to your DigitalOcean account, send a POST request to
        ``/v2/account/keys``. Set the ``name`` attribute to the name you wish to use and the
        ``public_key`` attribute to the full public key you are adding.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New SSH Key.

        To add a new SSH public key to your DigitalOcean account, send a POST request to
        ``/v2/account/keys``. Set the ``name`` attribute to the name you wish to use and the
        ``public_key`` attribute to the full public key you are adding.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable display name for this key, used to easily
                      identify the SSH keys when they are displayed. Required.
                    "public_key": "str",  # The entire public key string that was uploaded.
                      Embedded into the root user's ``authorized_keys`` file if you include this key
                      during Droplet creation. Required.
                    "fingerprint": "str",  # Optional. A unique identifier that differentiates
                      this key from other keys using  a format that SSH recognizes. The fingerprint is
                      created when the key is added to your account.
                    "id": 0  # Optional. A unique identification number for this key. Can be used
                      to embed a  specific SSH key into a Droplet.
                }

                # response body for status code(s): 201
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_ssh_keys_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, ssh_key_identifier: JSON, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing SSH Key.

        To get information about a key, send a GET request to ``/v2/account/keys/$KEY_ID`` or
        ``/v2/account/keys/$KEY_FINGERPRINT``.
        The response will be a JSON object with the key ``ssh_key`` and value an ssh_key object which
        contains the standard ssh_key attributes.

        :param ssh_key_identifier: Either the ID or the fingerprint of an existing SSH key. Required.
        :type ssh_key_identifier: JSON
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_ssh_keys_get_request(
            ssh_key_identifier=ssh_key_identifier,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        ssh_key_identifier: JSON,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an SSH Key's Name.

        To update the name of an SSH key, send a PUT request to either ``/v2/account/keys/$SSH_KEY_ID``
        or ``/v2/account/keys/$SSH_KEY_FINGERPRINT``. Set the ``name`` attribute to the new name you
        want to use.

        :param ssh_key_identifier: Either the ID or the fingerprint of an existing SSH key. Required.
        :type ssh_key_identifier: JSON
        :param body: Set the ``name`` attribute to the new name you want to use. Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. A human-readable display name for this key, used
                      to easily identify the SSH keys when they are displayed.
                }

                # response body for status code(s): 200
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        ssh_key_identifier: JSON,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an SSH Key's Name.

        To update the name of an SSH key, send a PUT request to either ``/v2/account/keys/$SSH_KEY_ID``
        or ``/v2/account/keys/$SSH_KEY_FINGERPRINT``. Set the ``name`` attribute to the new name you
        want to use.

        :param ssh_key_identifier: Either the ID or the fingerprint of an existing SSH key. Required.
        :type ssh_key_identifier: JSON
        :param body: Set the ``name`` attribute to the new name you want to use. Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self, ssh_key_identifier: JSON, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an SSH Key's Name.

        To update the name of an SSH key, send a PUT request to either ``/v2/account/keys/$SSH_KEY_ID``
        or ``/v2/account/keys/$SSH_KEY_FINGERPRINT``. Set the ``name`` attribute to the new name you
        want to use.

        :param ssh_key_identifier: Either the ID or the fingerprint of an existing SSH key. Required.
        :type ssh_key_identifier: JSON
        :param body: Set the ``name`` attribute to the new name you want to use. Is either a JSON type
         or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. A human-readable display name for this key, used
                      to easily identify the SSH keys when they are displayed.
                }

                # response body for status code(s): 200
                response == {
                    "ssh_key": {
                        "name": "str",  # A human-readable display name for this key, used to
                          easily identify the SSH keys when they are displayed. Required.
                        "public_key": "str",  # The entire public key string that was
                          uploaded. Embedded into the root user's ``authorized_keys`` file if you
                          include this key during Droplet creation. Required.
                        "fingerprint": "str",  # Optional. A unique identifier that
                          differentiates this key from other keys using  a format that SSH recognizes.
                          The fingerprint is created when the key is added to your account.
                        "id": 0  # Optional. A unique identification number for this key. Can
                          be used to embed a  specific SSH key into a Droplet.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_ssh_keys_update_request(
            ssh_key_identifier=ssh_key_identifier,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, ssh_key_identifier: JSON, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an SSH Key.

        To destroy a public SSH key that you have in your account, send a DELETE request to
        ``/v2/account/keys/$KEY_ID`` or ``/v2/account/keys/$KEY_FINGERPRINT``.
        A 204 status will be returned, indicating that the action was successful and that the response
        body is empty.

        :param ssh_key_identifier: Either the ID or the fingerprint of an existing SSH key. Required.
        :type ssh_key_identifier: JSON
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_ssh_keys_delete_request(
            ssh_key_identifier=ssh_key_identifier,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class ActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Actions.

        This will be the entire list of actions taken on your account, so it will be quite large. As
        with any large collection returned by the API, the results will be paginated with only 20 on
        each page by default.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_actions_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, action_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Action.

        To retrieve a specific action object, send a GET request to ``/v2/actions/$ACTION_ID``.

        :param action_id: A unique numeric ID that can be used to identify and reference an action.
         Required.
        :type action_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_actions_get_request(
            action_id=action_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class AppsOperations:  # pylint: disable=too-many-public-methods
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`apps` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        page: int = 1,
        per_page: int = 20,
        with_projects: Optional[bool] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Apps.

        List all apps on your account. Information about the current active deployment as well as any
        in progress ones will also be included for each app.

        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword with_projects: Whether the project_id of listed apps should be fetched and included.
         Default value is None.
        :paramtype with_projects: bool
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "apps": [
                        {
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "active_deployment": {
                                "cause": "str",  # Optional. What caused this
                                  deployment to be created.
                                "cloned_from": "str",  # Optional. The ID of a
                                  previous deployment that this deployment was cloned from.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  creation time of the deployment.
                                "functions": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this functions component.
                                        "namespace": "str",  # Optional. The
                                          namespace where the functions are deployed.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this functions component.
                                    }
                                ],
                                "id": "str",  # Optional. The ID of the deployment.
                                "jobs": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this job.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this job.
                                    }
                                ],
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                                  "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                                  "CANCELED".
                                "phase_last_updated_at": "2020-02-20 00:00:00",  #
                                  Optional. When the deployment phase was last updated.
                                "progress": {
                                    "error_steps": 0,  # Optional. Number of
                                      unsuccessful steps.
                                    "pending_steps": 0,  # Optional. Number of
                                      pending steps.
                                    "running_steps": 0,  # Optional. Number of
                                      currently running steps.
                                    "steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "success_steps": 0,  # Optional. Number of
                                      successful steps.
                                    "summary_steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "total_steps": 0  # Optional. Total number of
                                      steps.
                                },
                                "services": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this service.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this service.
                                    }
                                ],
                                "spec": {
                                    "name": "str",  # The name of the app. Must
                                      be unique across all apps in the same account. Required.
                                    "databases": [
                                        {
                                            "name": "str",  # The
                                              database's name. The name must be unique across all
                                              components within the same app and cannot use capital
                                              letters. Required.
                                            "cluster_name": "str",  #
                                              Optional. The name of the underlying DigitalOcean DBaaS
                                              cluster. This is required for production databases. For
                                              dev databases, if cluster_name is not set, a new cluster
                                              will be provisioned.
                                            "db_name": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL database to
                                              configure.
                                            "db_user": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL user to
                                              configure.
                                            "engine": "UNSET",  #
                                              Optional. Default value is "UNSET". * MYSQL: MySQL * PG:
                                              PostgreSQL * REDIS: Redis * MONGODB: MongoDB * KAFKA:
                                              Kafka * OPENSEARCH: OpenSearch. Known values are:
                                              "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                              "OPENSEARCH".
                                            "production": bool,  #
                                              Optional. Whether this is a production or dev database.
                                            "version": "str"  # Optional.
                                              The version of the database engine.
                                        }
                                    ],
                                    "domains": [
                                        {
                                            "domain": "str",  # The
                                              hostname for the domain. Required.
                                            "minimum_tls_version": "str",
                                              # Optional. The minimum version of TLS a client
                                              application can use to access resources for the domain.
                                              Must be one of the following values wrapped within
                                              quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                              "1.2" and "1.3".
                                            "type": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * DEFAULT: The
                                              default ``.ondigitalocean.app`` domain assigned to this
                                              app * PRIMARY: The primary domain for this app that is
                                              displayed as the default in the control panel, used in
                                              bindable environment variables, and any other places that
                                              reference an app's live URL. Only one domain may be set
                                              as primary. * ALIAS: A non-primary domain. Known values
                                              are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and "ALIAS".
                                            "wildcard": bool,  #
                                              Optional. Indicates whether the domain includes all
                                              sub-domains, in addition to the given domain.
                                            "zone": "str"  # Optional.
                                              Optional. If the domain uses DigitalOcean DNS and you
                                              would like App Platform to automatically manage it for
                                              you, set this to the name of the domain on your account.
                                              For example, If the domain you are adding is
                                              ``app.domain.com``"" , the zone could be ``domain.com``.
                                        }
                                    ],
                                    "egress": {
                                        "type": "AUTOASSIGN"  # Optional.
                                          Default value is "AUTOASSIGN". The app egress type. Known
                                          values are: "AUTOASSIGN" and "DEDICATED_IP".
                                    },
                                    "functions": [
                                        {
                                            "name": "str",  # The name.
                                              Must be unique across all components within the same app.
                                              Required.
                                            "alerts": [
                                                {
                                                    "disabled":
                                                      bool,  # Optional. Is the alert disabled?.
                                                    "operator":
                                                      "UNSPECIFIED_OPERATOR",  # Optional. Default
                                                      value is "UNSPECIFIED_OPERATOR". Known values
                                                      are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                      "LESS_THAN".
                                                    "rule":
                                                      "UNSPECIFIED_RULE",  # Optional. Default value is
                                                      "UNSPECIFIED_RULE". Known values are:
                                                      "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                      "MEM_UTILIZATION", "RESTART_COUNT",
                                                      "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                      "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                      "FUNCTIONS_ACTIVATION_COUNT",
                                                      "FUNCTIONS_AVERAGE_DURATION_MS",
                                                      "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                      "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                      "FUNCTIONS_ERROR_COUNT", and
                                                      "FUNCTIONS_GB_RATE_PER_SECOND".
                                                    "value": 0.0,
                                                      # Optional. Threshold value for alert.
                                                    "window":
                                                      "UNSPECIFIED_WINDOW"  # Optional. Default value
                                                      is "UNSPECIFIED_WINDOW". Known values are:
                                                      "UNSPECIFIED_WINDOW", "FIVE_MINUTES",
                                                      "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                                                }
                                            ],
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "ingress": {
                                        "rules": [
                                            {
                                                "component": {
                                                    "name":
                                                      "str",  # The name of the component to route to.
                                                      Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``. Note: this is not applicable for
                                                      Functions Components and is mutually exclusive
                                                      with ``rewrite``.
                                                    "rewrite":
                                                      "str"  # Optional. An optional field that will
                                                      rewrite the path of the component to be what is
                                                      specified here. By default, the HTTP request path
                                                      will be trimmed from the left when forwarded to
                                                      the component. For example, a component with
                                                      ``path=/api`` will have requests to ``/api/list``
                                                      trimmed to ``/list``. If you specified the
                                                      rewrite to be ``/v1/``"" , requests to
                                                      ``/api/list`` would be rewritten to ``/v1/list``.
                                                      Note: this is mutually exclusive with
                                                      ``preserve_path_prefix``.
                                                },
                                                "cors": {
                "allow_credentials": bool,  # Optional. Whether
                                                      browsers should expose the response to the
                                                      client-side JavaScript code when the
                                                      request"u2019s credentials mode is include. This
                                                      configures the
                                                      ``Access-Control-Allow-Credentials`` header.
                "allow_headers": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP request
                                                          headers. This configures the
                                                          ``Access-Control-Allow-Headers`` header.
                                                    ],
                "allow_methods": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP methods.
                                                          This configures the
                                                          ``Access-Control-Allow-Methods`` header.
                                                    ],
                "allow_origins": [
                                                        {
                "exact": "str",  # Optional. Exact string
                                                              match. Only 1 of ``exact``"" ,
                                                              ``prefix``"" , or ``regex`` must be set.
                "prefix": "str",  # Optional.
                                                              Prefix-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set.
                "regex": "str"  # Optional. RE2 style
                                                              regex-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set. For more information about RE2
                                                              syntax, see:
                                                              https://github.com/google/re2/wiki/Syntax.
                                                        }
                                                    ],
                "expose_headers": [
                                                        "str"
                                                          # Optional. The set of HTTP response headers
                                                          that browsers are allowed to access. This
                                                          configures the
                                                          ``Access-Control-Expose-Headers`` header.
                                                    ],
                                                    "max_age":
                                                      "str"  # Optional. An optional duration
                                                      specifying how long browsers can cache the
                                                      results of a preflight request. This configures
                                                      the ``Access-Control-Max-Age`` header.
                                                },
                                                "match": {
                                                    "authority":
                                                      {
                "exact": "str"  # Required.
                                                    },
                                                    "path": {
                "prefix": "str"  # Prefix-based match. For
                                                          example, ``/api`` will match ``/api``"" ,
                                                          ``/api/``"" , and any nested paths such as
                                                          ``/api/v1/endpoint``. Required.
                                                    }
                                                },
                                                "redirect": {
                                                    "authority":
                                                      "str",  # Optional. The authority/host to
                                                      redirect to. This can be a hostname or IP
                                                      address. Note: use ``port`` to set the port.
                                                    "port": 0,  #
                                                      Optional. The port to redirect to.
                "redirect_code": 0,  # Optional. The redirect
                                                      code to use. Defaults to ``302``. Supported
                                                      values are 300, 301, 302, 303, 304, 307, 308.
                                                    "scheme":
                                                      "str",  # Optional. The scheme to redirect to.
                                                      Supported values are ``http`` or ``https``.
                                                      Default: ``https``.
                                                    "uri": "str"
                                                      # Optional. An optional URI path to redirect to.
                                                      Note: if this is specified the whole URI of the
                                                      original request will be overwritten to this
                                                      value, irrespective of the original request URI
                                                      being matched.
                                                }
                                            }
                                        ]
                                    },
                                    "jobs": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "kind": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * UNSPECIFIED:
                                              Default job type, will auto-complete to POST_DEPLOY kind.
                                              * PRE_DEPLOY: Indicates a job that runs before an app
                                              deployment. * POST_DEPLOY: Indicates a job that runs
                                              after an app deployment. * FAILED_DEPLOY: Indicates a job
                                              that runs after a component fails to deploy. Known values
                                              are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                              "FAILED_DEPLOY".
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "maintenance": {
                                        "archive": bool,  # Optional.
                                          Indicates whether the app should be archived. Setting this to
                                          true implies that enabled is set to true.
                                        "enabled": bool,  # Optional.
                                          Indicates whether maintenance mode should be enabled for the
                                          app.
                                        "offline_page_url": "str"  #
                                          Optional. A custom offline page to display when maintenance
                                          mode is enabled or the app is archived.
                                    },
                                    "region": "str",  # Optional. The slug form
                                      of the geographical origin of the app. Default: ``nearest
                                      available``. Known values are: "ams", "nyc", "fra", "sfo", "sgp",
                                      "blr", "tor", "lon", and "syd".
                                    "services": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "health_check": {
                                                "failure_threshold":
                                                  0,  # Optional. The number of failed health checks
                                                  before considered unhealthy.
                                                "http_path": "str",
                                                  # Optional. The route path used for the HTTP health
                                                  check ping. If not set, the HTTP health check will be
                                                  disabled and a TCP health check used instead.
                "initial_delay_seconds": 0,  # Optional. The number
                                                  of seconds to wait before beginning health checks.
                                                "period_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  health checks.
                                                "port": 0,  #
                                                  Optional. The port on which the health check will be
                                                  performed. If not set, the health check will be
                                                  performed on the component's http_port.
                                                "success_threshold":
                                                  0,  # Optional. The number of successful health
                                                  checks before considered healthy.
                                                "timeout_seconds": 0
                                                  # Optional. The number of seconds after which the
                                                  check times out.
                                            },
                                            "http_port": 0,  # Optional.
                                              The internal port on which this service's run command
                                              will listen. Default: 8080 If there is not an environment
                                              variable with the name ``PORT``"" , one will be
                                              automatically added with its value set to the value of
                                              this field.
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "internal_ports": [
                                                0  # Optional. The
                                                  ports on which this service will listen for internal
                                                  traffic.
                                            ],
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "protocol": "str",  #
                                              Optional. The protocol which the service uses to serve
                                              traffic on the http_port.   * ``HTTP``"" : The app is
                                              serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                              app is serving the HTTP/2 protocol. Currently, this needs
                                              to be implemented in the service by serving HTTP/2
                                              cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                                                "drain_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  selecting a container instance for termination and
                                                  issuing the TERM signal. Selecting a container
                                                  instance for termination begins an asynchronous drain
                                                  of new requests on upstream load-balancers. (Default
                                                  15).
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "static_sites": [
                                        {
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "catchall_document": "str",
                                              # Optional. The name of the document to use as the
                                              fallback for any requests to documents that are not found
                                              when serving this static site. Only 1 of
                                              ``catchall_document`` or ``error_document`` can be set.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "error_document": "404.html",
                                              # Optional. Default value is "404.html". The name of the
                                              error document to use when serving this static site.
                                              Default: 404.html. If no such file exists within the
                                              built assets, App Platform will supply one.
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "index_document":
                                              "index.html",  # Optional. Default value is "index.html".
                                              The name of the index document to use when serving this
                                              static site. Default: index.html.
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "output_dir": "str",  #
                                              Optional. An optional path to where the built assets will
                                              be located, relative to the build context. If not set,
                                              App Platform will automatically scan for these directory
                                              names: ``_static``"" , ``dist``"" , ``public``"" ,
                                              ``build``.
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "workers": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ]
                                },
                                "static_sites": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this static site.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this static site.
                                    }
                                ],
                                "tier_slug": "str",  # Optional. The current pricing
                                  tier slug of the deployment.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  When the deployment was last updated.
                                "workers": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this worker.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this worker.
                                    }
                                ]
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the app.
                            "dedicated_ips": [
                                {
                                    "id": "str",  # Optional. The ID of the
                                      dedicated egress IP.
                                    "ip": "str",  # Optional. The IP address of
                                      the dedicated egress IP.
                                    "status": "UNKNOWN"  # Optional. Default
                                      value is "UNKNOWN". The status of the dedicated egress IP. Known
                                      values are: "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                                }
                            ],
                            "default_ingress": "str",  # Optional. The default hostname
                              on which the app is accessible.
                            "domains": [
                                {
                                    "certificate_expires_at": "2020-02-20
                                      00:00:00",  # Optional. Current SSL certificate expiration time.
                                    "id": "str",  # Optional. The ID of the
                                      domain.
                                    "phase": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "CONFIGURING", "ACTIVE", and "ERROR".
                                    "progress": {
                                        "steps": [
                                            {}  # Optional. The steps of
                                              the domain's progress.
                                        ]
                                    },
                                    "rotate_validation_records": bool,  #
                                      Optional. Validation values have changed and require manual
                                      intervention.
                                    "spec": {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    },
                                    "validations": [
                                        {
                                            "txt_name": "str",  #
                                              Optional. TXT record name.
                                            "txt_value": "str"  #
                                              Optional. TXT record value.
                                        }
                                    ]
                                }
                            ],
                            "id": "str",  # Optional. The ID of the application.
                            "in_progress_deployment": {
                                "cause": "str",  # Optional. What caused this
                                  deployment to be created.
                                "cloned_from": "str",  # Optional. The ID of a
                                  previous deployment that this deployment was cloned from.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  creation time of the deployment.
                                "functions": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this functions component.
                                        "namespace": "str",  # Optional. The
                                          namespace where the functions are deployed.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this functions component.
                                    }
                                ],
                                "id": "str",  # Optional. The ID of the deployment.
                                "jobs": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this job.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this job.
                                    }
                                ],
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                                  "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                                  "CANCELED".
                                "phase_last_updated_at": "2020-02-20 00:00:00",  #
                                  Optional. When the deployment phase was last updated.
                                "progress": {
                                    "error_steps": 0,  # Optional. Number of
                                      unsuccessful steps.
                                    "pending_steps": 0,  # Optional. Number of
                                      pending steps.
                                    "running_steps": 0,  # Optional. Number of
                                      currently running steps.
                                    "steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "success_steps": 0,  # Optional. Number of
                                      successful steps.
                                    "summary_steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "total_steps": 0  # Optional. Total number of
                                      steps.
                                },
                                "services": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this service.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this service.
                                    }
                                ],
                                "spec": {
                                    "name": "str",  # The name of the app. Must
                                      be unique across all apps in the same account. Required.
                                    "databases": [
                                        {
                                            "name": "str",  # The
                                              database's name. The name must be unique across all
                                              components within the same app and cannot use capital
                                              letters. Required.
                                            "cluster_name": "str",  #
                                              Optional. The name of the underlying DigitalOcean DBaaS
                                              cluster. This is required for production databases. For
                                              dev databases, if cluster_name is not set, a new cluster
                                              will be provisioned.
                                            "db_name": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL database to
                                              configure.
                                            "db_user": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL user to
                                              configure.
                                            "engine": "UNSET",  #
                                              Optional. Default value is "UNSET". * MYSQL: MySQL * PG:
                                              PostgreSQL * REDIS: Redis * MONGODB: MongoDB * KAFKA:
                                              Kafka * OPENSEARCH: OpenSearch. Known values are:
                                              "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                              "OPENSEARCH".
                                            "production": bool,  #
                                              Optional. Whether this is a production or dev database.
                                            "version": "str"  # Optional.
                                              The version of the database engine.
                                        }
                                    ],
                                    "domains": [
                                        {
                                            "domain": "str",  # The
                                              hostname for the domain. Required.
                                            "minimum_tls_version": "str",
                                              # Optional. The minimum version of TLS a client
                                              application can use to access resources for the domain.
                                              Must be one of the following values wrapped within
                                              quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                              "1.2" and "1.3".
                                            "type": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * DEFAULT: The
                                              default ``.ondigitalocean.app`` domain assigned to this
                                              app * PRIMARY: The primary domain for this app that is
                                              displayed as the default in the control panel, used in
                                              bindable environment variables, and any other places that
                                              reference an app's live URL. Only one domain may be set
                                              as primary. * ALIAS: A non-primary domain. Known values
                                              are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and "ALIAS".
                                            "wildcard": bool,  #
                                              Optional. Indicates whether the domain includes all
                                              sub-domains, in addition to the given domain.
                                            "zone": "str"  # Optional.
                                              Optional. If the domain uses DigitalOcean DNS and you
                                              would like App Platform to automatically manage it for
                                              you, set this to the name of the domain on your account.
                                              For example, If the domain you are adding is
                                              ``app.domain.com``"" , the zone could be ``domain.com``.
                                        }
                                    ],
                                    "egress": {
                                        "type": "AUTOASSIGN"  # Optional.
                                          Default value is "AUTOASSIGN". The app egress type. Known
                                          values are: "AUTOASSIGN" and "DEDICATED_IP".
                                    },
                                    "functions": [
                                        {
                                            "name": "str",  # The name.
                                              Must be unique across all components within the same app.
                                              Required.
                                            "alerts": [
                                                {
                                                    "disabled":
                                                      bool,  # Optional. Is the alert disabled?.
                                                    "operator":
                                                      "UNSPECIFIED_OPERATOR",  # Optional. Default
                                                      value is "UNSPECIFIED_OPERATOR". Known values
                                                      are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                      "LESS_THAN".
                                                    "rule":
                                                      "UNSPECIFIED_RULE",  # Optional. Default value is
                                                      "UNSPECIFIED_RULE". Known values are:
                                                      "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                      "MEM_UTILIZATION", "RESTART_COUNT",
                                                      "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                      "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                      "FUNCTIONS_ACTIVATION_COUNT",
                                                      "FUNCTIONS_AVERAGE_DURATION_MS",
                                                      "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                      "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                      "FUNCTIONS_ERROR_COUNT", and
                                                      "FUNCTIONS_GB_RATE_PER_SECOND".
                                                    "value": 0.0,
                                                      # Optional. Threshold value for alert.
                                                    "window":
                                                      "UNSPECIFIED_WINDOW"  # Optional. Default value
                                                      is "UNSPECIFIED_WINDOW". Known values are:
                                                      "UNSPECIFIED_WINDOW", "FIVE_MINUTES",
                                                      "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                                                }
                                            ],
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "ingress": {
                                        "rules": [
                                            {
                                                "component": {
                                                    "name":
                                                      "str",  # The name of the component to route to.
                                                      Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``. Note: this is not applicable for
                                                      Functions Components and is mutually exclusive
                                                      with ``rewrite``.
                                                    "rewrite":
                                                      "str"  # Optional. An optional field that will
                                                      rewrite the path of the component to be what is
                                                      specified here. By default, the HTTP request path
                                                      will be trimmed from the left when forwarded to
                                                      the component. For example, a component with
                                                      ``path=/api`` will have requests to ``/api/list``
                                                      trimmed to ``/list``. If you specified the
                                                      rewrite to be ``/v1/``"" , requests to
                                                      ``/api/list`` would be rewritten to ``/v1/list``.
                                                      Note: this is mutually exclusive with
                                                      ``preserve_path_prefix``.
                                                },
                                                "cors": {
                "allow_credentials": bool,  # Optional. Whether
                                                      browsers should expose the response to the
                                                      client-side JavaScript code when the
                                                      request"u2019s credentials mode is include. This
                                                      configures the
                                                      ``Access-Control-Allow-Credentials`` header.
                "allow_headers": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP request
                                                          headers. This configures the
                                                          ``Access-Control-Allow-Headers`` header.
                                                    ],
                "allow_methods": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP methods.
                                                          This configures the
                                                          ``Access-Control-Allow-Methods`` header.
                                                    ],
                "allow_origins": [
                                                        {
                "exact": "str",  # Optional. Exact string
                                                              match. Only 1 of ``exact``"" ,
                                                              ``prefix``"" , or ``regex`` must be set.
                "prefix": "str",  # Optional.
                                                              Prefix-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set.
                "regex": "str"  # Optional. RE2 style
                                                              regex-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set. For more information about RE2
                                                              syntax, see:
                                                              https://github.com/google/re2/wiki/Syntax.
                                                        }
                                                    ],
                "expose_headers": [
                                                        "str"
                                                          # Optional. The set of HTTP response headers
                                                          that browsers are allowed to access. This
                                                          configures the
                                                          ``Access-Control-Expose-Headers`` header.
                                                    ],
                                                    "max_age":
                                                      "str"  # Optional. An optional duration
                                                      specifying how long browsers can cache the
                                                      results of a preflight request. This configures
                                                      the ``Access-Control-Max-Age`` header.
                                                },
                                                "match": {
                                                    "authority":
                                                      {
                "exact": "str"  # Required.
                                                    },
                                                    "path": {
                "prefix": "str"  # Prefix-based match. For
                                                          example, ``/api`` will match ``/api``"" ,
                                                          ``/api/``"" , and any nested paths such as
                                                          ``/api/v1/endpoint``. Required.
                                                    }
                                                },
                                                "redirect": {
                                                    "authority":
                                                      "str",  # Optional. The authority/host to
                                                      redirect to. This can be a hostname or IP
                                                      address. Note: use ``port`` to set the port.
                                                    "port": 0,  #
                                                      Optional. The port to redirect to.
                "redirect_code": 0,  # Optional. The redirect
                                                      code to use. Defaults to ``302``. Supported
                                                      values are 300, 301, 302, 303, 304, 307, 308.
                                                    "scheme":
                                                      "str",  # Optional. The scheme to redirect to.
                                                      Supported values are ``http`` or ``https``.
                                                      Default: ``https``.
                                                    "uri": "str"
                                                      # Optional. An optional URI path to redirect to.
                                                      Note: if this is specified the whole URI of the
                                                      original request will be overwritten to this
                                                      value, irrespective of the original request URI
                                                      being matched.
                                                }
                                            }
                                        ]
                                    },
                                    "jobs": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "kind": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * UNSPECIFIED:
                                              Default job type, will auto-complete to POST_DEPLOY kind.
                                              * PRE_DEPLOY: Indicates a job that runs before an app
                                              deployment. * POST_DEPLOY: Indicates a job that runs
                                              after an app deployment. * FAILED_DEPLOY: Indicates a job
                                              that runs after a component fails to deploy. Known values
                                              are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                              "FAILED_DEPLOY".
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "maintenance": {
                                        "archive": bool,  # Optional.
                                          Indicates whether the app should be archived. Setting this to
                                          true implies that enabled is set to true.
                                        "enabled": bool,  # Optional.
                                          Indicates whether maintenance mode should be enabled for the
                                          app.
                                        "offline_page_url": "str"  #
                                          Optional. A custom offline page to display when maintenance
                                          mode is enabled or the app is archived.
                                    },
                                    "region": "str",  # Optional. The slug form
                                      of the geographical origin of the app. Default: ``nearest
                                      available``. Known values are: "ams", "nyc", "fra", "sfo", "sgp",
                                      "blr", "tor", "lon", and "syd".
                                    "services": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "health_check": {
                                                "failure_threshold":
                                                  0,  # Optional. The number of failed health checks
                                                  before considered unhealthy.
                                                "http_path": "str",
                                                  # Optional. The route path used for the HTTP health
                                                  check ping. If not set, the HTTP health check will be
                                                  disabled and a TCP health check used instead.
                "initial_delay_seconds": 0,  # Optional. The number
                                                  of seconds to wait before beginning health checks.
                                                "period_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  health checks.
                                                "port": 0,  #
                                                  Optional. The port on which the health check will be
                                                  performed. If not set, the health check will be
                                                  performed on the component's http_port.
                                                "success_threshold":
                                                  0,  # Optional. The number of successful health
                                                  checks before considered healthy.
                                                "timeout_seconds": 0
                                                  # Optional. The number of seconds after which the
                                                  check times out.
                                            },
                                            "http_port": 0,  # Optional.
                                              The internal port on which this service's run command
                                              will listen. Default: 8080 If there is not an environment
                                              variable with the name ``PORT``"" , one will be
                                              automatically added with its value set to the value of
                                              this field.
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "internal_ports": [
                                                0  # Optional. The
                                                  ports on which this service will listen for internal
                                                  traffic.
                                            ],
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "protocol": "str",  #
                                              Optional. The protocol which the service uses to serve
                                              traffic on the http_port.   * ``HTTP``"" : The app is
                                              serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                              app is serving the HTTP/2 protocol. Currently, this needs
                                              to be implemented in the service by serving HTTP/2
                                              cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                                                "drain_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  selecting a container instance for termination and
                                                  issuing the TERM signal. Selecting a container
                                                  instance for termination begins an asynchronous drain
                                                  of new requests on upstream load-balancers. (Default
                                                  15).
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "static_sites": [
                                        {
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "catchall_document": "str",
                                              # Optional. The name of the document to use as the
                                              fallback for any requests to documents that are not found
                                              when serving this static site. Only 1 of
                                              ``catchall_document`` or ``error_document`` can be set.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "error_document": "404.html",
                                              # Optional. Default value is "404.html". The name of the
                                              error document to use when serving this static site.
                                              Default: 404.html. If no such file exists within the
                                              built assets, App Platform will supply one.
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "index_document":
                                              "index.html",  # Optional. Default value is "index.html".
                                              The name of the index document to use when serving this
                                              static site. Default: index.html.
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "output_dir": "str",  #
                                              Optional. An optional path to where the built assets will
                                              be located, relative to the build context. If not set,
                                              App Platform will automatically scan for these directory
                                              names: ``_static``"" , ``dist``"" , ``public``"" ,
                                              ``build``.
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "workers": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ]
                                },
                                "static_sites": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this static site.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this static site.
                                    }
                                ],
                                "tier_slug": "str",  # Optional. The current pricing
                                  tier slug of the deployment.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  When the deployment was last updated.
                                "workers": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this worker.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this worker.
                                    }
                                ]
                            },
                            "last_deployment_created_at": "2020-02-20 00:00:00",  #
                              Optional. The creation time of the last deployment.
                            "live_domain": "str",  # Optional. The live domain of the
                              app.
                            "live_url": "str",  # Optional. The live URL of the app.
                            "live_url_base": "str",  # Optional. The live URL base of the
                              app, the URL excluding the path.
                            "owner_uuid": "str",  # Optional. The ID of the account to
                              which the application belongs.
                            "pending_deployment": {
                                "cause": "str",  # Optional. What caused this
                                  deployment to be created.
                                "cloned_from": "str",  # Optional. The ID of a
                                  previous deployment that this deployment was cloned from.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  creation time of the deployment.
                                "functions": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this functions component.
                                        "namespace": "str",  # Optional. The
                                          namespace where the functions are deployed.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this functions component.
                                    }
                                ],
                                "id": "str",  # Optional. The ID of the deployment.
                                "jobs": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this job.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this job.
                                    }
                                ],
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                                  "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                                  "CANCELED".
                                "phase_last_updated_at": "2020-02-20 00:00:00",  #
                                  Optional. When the deployment phase was last updated.
                                "progress": {
                                    "error_steps": 0,  # Optional. Number of
                                      unsuccessful steps.
                                    "pending_steps": 0,  # Optional. Number of
                                      pending steps.
                                    "running_steps": 0,  # Optional. Number of
                                      currently running steps.
                                    "steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "success_steps": 0,  # Optional. Number of
                                      successful steps.
                                    "summary_steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "total_steps": 0  # Optional. Total number of
                                      steps.
                                },
                                "services": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this service.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this service.
                                    }
                                ],
                                "spec": {
                                    "name": "str",  # The name of the app. Must
                                      be unique across all apps in the same account. Required.
                                    "databases": [
                                        {
                                            "name": "str",  # The
                                              database's name. The name must be unique across all
                                              components within the same app and cannot use capital
                                              letters. Required.
                                            "cluster_name": "str",  #
                                              Optional. The name of the underlying DigitalOcean DBaaS
                                              cluster. This is required for production databases. For
                                              dev databases, if cluster_name is not set, a new cluster
                                              will be provisioned.
                                            "db_name": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL database to
                                              configure.
                                            "db_user": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL user to
                                              configure.
                                            "engine": "UNSET",  #
                                              Optional. Default value is "UNSET". * MYSQL: MySQL * PG:
                                              PostgreSQL * REDIS: Redis * MONGODB: MongoDB * KAFKA:
                                              Kafka * OPENSEARCH: OpenSearch. Known values are:
                                              "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                              "OPENSEARCH".
                                            "production": bool,  #
                                              Optional. Whether this is a production or dev database.
                                            "version": "str"  # Optional.
                                              The version of the database engine.
                                        }
                                    ],
                                    "domains": [
                                        {
                                            "domain": "str",  # The
                                              hostname for the domain. Required.
                                            "minimum_tls_version": "str",
                                              # Optional. The minimum version of TLS a client
                                              application can use to access resources for the domain.
                                              Must be one of the following values wrapped within
                                              quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                              "1.2" and "1.3".
                                            "type": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * DEFAULT: The
                                              default ``.ondigitalocean.app`` domain assigned to this
                                              app * PRIMARY: The primary domain for this app that is
                                              displayed as the default in the control panel, used in
                                              bindable environment variables, and any other places that
                                              reference an app's live URL. Only one domain may be set
                                              as primary. * ALIAS: A non-primary domain. Known values
                                              are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and "ALIAS".
                                            "wildcard": bool,  #
                                              Optional. Indicates whether the domain includes all
                                              sub-domains, in addition to the given domain.
                                            "zone": "str"  # Optional.
                                              Optional. If the domain uses DigitalOcean DNS and you
                                              would like App Platform to automatically manage it for
                                              you, set this to the name of the domain on your account.
                                              For example, If the domain you are adding is
                                              ``app.domain.com``"" , the zone could be ``domain.com``.
                                        }
                                    ],
                                    "egress": {
                                        "type": "AUTOASSIGN"  # Optional.
                                          Default value is "AUTOASSIGN". The app egress type. Known
                                          values are: "AUTOASSIGN" and "DEDICATED_IP".
                                    },
                                    "functions": [
                                        {
                                            "name": "str",  # The name.
                                              Must be unique across all components within the same app.
                                              Required.
                                            "alerts": [
                                                {
                                                    "disabled":
                                                      bool,  # Optional. Is the alert disabled?.
                                                    "operator":
                                                      "UNSPECIFIED_OPERATOR",  # Optional. Default
                                                      value is "UNSPECIFIED_OPERATOR". Known values
                                                      are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                      "LESS_THAN".
                                                    "rule":
                                                      "UNSPECIFIED_RULE",  # Optional. Default value is
                                                      "UNSPECIFIED_RULE". Known values are:
                                                      "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                      "MEM_UTILIZATION", "RESTART_COUNT",
                                                      "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                      "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                      "FUNCTIONS_ACTIVATION_COUNT",
                                                      "FUNCTIONS_AVERAGE_DURATION_MS",
                                                      "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                      "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                      "FUNCTIONS_ERROR_COUNT", and
                                                      "FUNCTIONS_GB_RATE_PER_SECOND".
                                                    "value": 0.0,
                                                      # Optional. Threshold value for alert.
                                                    "window":
                                                      "UNSPECIFIED_WINDOW"  # Optional. Default value
                                                      is "UNSPECIFIED_WINDOW". Known values are:
                                                      "UNSPECIFIED_WINDOW", "FIVE_MINUTES",
                                                      "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                                                }
                                            ],
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "ingress": {
                                        "rules": [
                                            {
                                                "component": {
                                                    "name":
                                                      "str",  # The name of the component to route to.
                                                      Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``. Note: this is not applicable for
                                                      Functions Components and is mutually exclusive
                                                      with ``rewrite``.
                                                    "rewrite":
                                                      "str"  # Optional. An optional field that will
                                                      rewrite the path of the component to be what is
                                                      specified here. By default, the HTTP request path
                                                      will be trimmed from the left when forwarded to
                                                      the component. For example, a component with
                                                      ``path=/api`` will have requests to ``/api/list``
                                                      trimmed to ``/list``. If you specified the
                                                      rewrite to be ``/v1/``"" , requests to
                                                      ``/api/list`` would be rewritten to ``/v1/list``.
                                                      Note: this is mutually exclusive with
                                                      ``preserve_path_prefix``.
                                                },
                                                "cors": {
                "allow_credentials": bool,  # Optional. Whether
                                                      browsers should expose the response to the
                                                      client-side JavaScript code when the
                                                      request"u2019s credentials mode is include. This
                                                      configures the
                                                      ``Access-Control-Allow-Credentials`` header.
                "allow_headers": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP request
                                                          headers. This configures the
                                                          ``Access-Control-Allow-Headers`` header.
                                                    ],
                "allow_methods": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP methods.
                                                          This configures the
                                                          ``Access-Control-Allow-Methods`` header.
                                                    ],
                "allow_origins": [
                                                        {
                "exact": "str",  # Optional. Exact string
                                                              match. Only 1 of ``exact``"" ,
                                                              ``prefix``"" , or ``regex`` must be set.
                "prefix": "str",  # Optional.
                                                              Prefix-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set.
                "regex": "str"  # Optional. RE2 style
                                                              regex-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set. For more information about RE2
                                                              syntax, see:
                                                              https://github.com/google/re2/wiki/Syntax.
                                                        }
                                                    ],
                "expose_headers": [
                                                        "str"
                                                          # Optional. The set of HTTP response headers
                                                          that browsers are allowed to access. This
                                                          configures the
                                                          ``Access-Control-Expose-Headers`` header.
                                                    ],
                                                    "max_age":
                                                      "str"  # Optional. An optional duration
                                                      specifying how long browsers can cache the
                                                      results of a preflight request. This configures
                                                      the ``Access-Control-Max-Age`` header.
                                                },
                                                "match": {
                                                    "authority":
                                                      {
                "exact": "str"  # Required.
                                                    },
                                                    "path": {
                "prefix": "str"  # Prefix-based match. For
                                                          example, ``/api`` will match ``/api``"" ,
                                                          ``/api/``"" , and any nested paths such as
                                                          ``/api/v1/endpoint``. Required.
                                                    }
                                                },
                                                "redirect": {
                                                    "authority":
                                                      "str",  # Optional. The authority/host to
                                                      redirect to. This can be a hostname or IP
                                                      address. Note: use ``port`` to set the port.
                                                    "port": 0,  #
                                                      Optional. The port to redirect to.
                "redirect_code": 0,  # Optional. The redirect
                                                      code to use. Defaults to ``302``. Supported
                                                      values are 300, 301, 302, 303, 304, 307, 308.
                                                    "scheme":
                                                      "str",  # Optional. The scheme to redirect to.
                                                      Supported values are ``http`` or ``https``.
                                                      Default: ``https``.
                                                    "uri": "str"
                                                      # Optional. An optional URI path to redirect to.
                                                      Note: if this is specified the whole URI of the
                                                      original request will be overwritten to this
                                                      value, irrespective of the original request URI
                                                      being matched.
                                                }
                                            }
                                        ]
                                    },
                                    "jobs": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "kind": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * UNSPECIFIED:
                                              Default job type, will auto-complete to POST_DEPLOY kind.
                                              * PRE_DEPLOY: Indicates a job that runs before an app
                                              deployment. * POST_DEPLOY: Indicates a job that runs
                                              after an app deployment. * FAILED_DEPLOY: Indicates a job
                                              that runs after a component fails to deploy. Known values
                                              are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                              "FAILED_DEPLOY".
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "maintenance": {
                                        "archive": bool,  # Optional.
                                          Indicates whether the app should be archived. Setting this to
                                          true implies that enabled is set to true.
                                        "enabled": bool,  # Optional.
                                          Indicates whether maintenance mode should be enabled for the
                                          app.
                                        "offline_page_url": "str"  #
                                          Optional. A custom offline page to display when maintenance
                                          mode is enabled or the app is archived.
                                    },
                                    "region": "str",  # Optional. The slug form
                                      of the geographical origin of the app. Default: ``nearest
                                      available``. Known values are: "ams", "nyc", "fra", "sfo", "sgp",
                                      "blr", "tor", "lon", and "syd".
                                    "services": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "health_check": {
                                                "failure_threshold":
                                                  0,  # Optional. The number of failed health checks
                                                  before considered unhealthy.
                                                "http_path": "str",
                                                  # Optional. The route path used for the HTTP health
                                                  check ping. If not set, the HTTP health check will be
                                                  disabled and a TCP health check used instead.
                "initial_delay_seconds": 0,  # Optional. The number
                                                  of seconds to wait before beginning health checks.
                                                "period_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  health checks.
                                                "port": 0,  #
                                                  Optional. The port on which the health check will be
                                                  performed. If not set, the health check will be
                                                  performed on the component's http_port.
                                                "success_threshold":
                                                  0,  # Optional. The number of successful health
                                                  checks before considered healthy.
                                                "timeout_seconds": 0
                                                  # Optional. The number of seconds after which the
                                                  check times out.
                                            },
                                            "http_port": 0,  # Optional.
                                              The internal port on which this service's run command
                                              will listen. Default: 8080 If there is not an environment
                                              variable with the name ``PORT``"" , one will be
                                              automatically added with its value set to the value of
                                              this field.
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "internal_ports": [
                                                0  # Optional. The
                                                  ports on which this service will listen for internal
                                                  traffic.
                                            ],
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "protocol": "str",  #
                                              Optional. The protocol which the service uses to serve
                                              traffic on the http_port.   * ``HTTP``"" : The app is
                                              serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                              app is serving the HTTP/2 protocol. Currently, this needs
                                              to be implemented in the service by serving HTTP/2
                                              cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                                                "drain_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  selecting a container instance for termination and
                                                  issuing the TERM signal. Selecting a container
                                                  instance for termination begins an asynchronous drain
                                                  of new requests on upstream load-balancers. (Default
                                                  15).
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "static_sites": [
                                        {
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "catchall_document": "str",
                                              # Optional. The name of the document to use as the
                                              fallback for any requests to documents that are not found
                                              when serving this static site. Only 1 of
                                              ``catchall_document`` or ``error_document`` can be set.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "error_document": "404.html",
                                              # Optional. Default value is "404.html". The name of the
                                              error document to use when serving this static site.
                                              Default: 404.html. If no such file exists within the
                                              built assets, App Platform will supply one.
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "index_document":
                                              "index.html",  # Optional. Default value is "index.html".
                                              The name of the index document to use when serving this
                                              static site. Default: index.html.
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "output_dir": "str",  #
                                              Optional. An optional path to where the built assets will
                                              be located, relative to the build context. If not set,
                                              App Platform will automatically scan for these directory
                                              names: ``_static``"" , ``dist``"" , ``public``"" ,
                                              ``build``.
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "workers": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ]
                                },
                                "static_sites": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this static site.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this static site.
                                    }
                                ],
                                "tier_slug": "str",  # Optional. The current pricing
                                  tier slug of the deployment.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  When the deployment was last updated.
                                "workers": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this worker.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this worker.
                                    }
                                ]
                            },
                            "pinned_deployment": {
                                "cause": "str",  # Optional. What caused this
                                  deployment to be created.
                                "cloned_from": "str",  # Optional. The ID of a
                                  previous deployment that this deployment was cloned from.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  creation time of the deployment.
                                "functions": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this functions component.
                                        "namespace": "str",  # Optional. The
                                          namespace where the functions are deployed.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this functions component.
                                    }
                                ],
                                "id": "str",  # Optional. The ID of the deployment.
                                "jobs": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this job.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this job.
                                    }
                                ],
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                                  "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                                  "CANCELED".
                                "phase_last_updated_at": "2020-02-20 00:00:00",  #
                                  Optional. When the deployment phase was last updated.
                                "progress": {
                                    "error_steps": 0,  # Optional. Number of
                                      unsuccessful steps.
                                    "pending_steps": 0,  # Optional. Number of
                                      pending steps.
                                    "running_steps": 0,  # Optional. Number of
                                      currently running steps.
                                    "steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "success_steps": 0,  # Optional. Number of
                                      successful steps.
                                    "summary_steps": [
                                        {
                                            "component_name": "str",  #
                                              Optional. The component name that this step is associated
                                              with.
                                            "ended_at": "2020-02-20
                                              00:00:00",  # Optional. The end time of this step.
                                            "message_base": "str",  #
                                              Optional. The base of a human-readable description of the
                                              step intended to be combined with the component name for
                                              presentation. For example:  ``message_base`` = "Building
                                              service" ``component_name`` = "api".
                                            "name": "str",  # Optional.
                                              The name of this step.
                                            "reason": {
                                                "code": "str",  #
                                                  Optional. The error code.
                                                "message": "str"  #
                                                  Optional. The error message.
                                            },
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. The start time of this step.
                                            "status": "UNKNOWN",  #
                                              Optional. Default value is "UNKNOWN". Known values are:
                                              "UNKNOWN", "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                            "steps": [
                                                {}  # Optional. Child
                                                  steps of this step.
                                            ]
                                        }
                                    ],
                                    "total_steps": 0  # Optional. Total number of
                                      steps.
                                },
                                "services": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this service.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this service.
                                    }
                                ],
                                "spec": {
                                    "name": "str",  # The name of the app. Must
                                      be unique across all apps in the same account. Required.
                                    "databases": [
                                        {
                                            "name": "str",  # The
                                              database's name. The name must be unique across all
                                              components within the same app and cannot use capital
                                              letters. Required.
                                            "cluster_name": "str",  #
                                              Optional. The name of the underlying DigitalOcean DBaaS
                                              cluster. This is required for production databases. For
                                              dev databases, if cluster_name is not set, a new cluster
                                              will be provisioned.
                                            "db_name": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL database to
                                              configure.
                                            "db_user": "str",  #
                                              Optional. The name of the MySQL or PostgreSQL user to
                                              configure.
                                            "engine": "UNSET",  #
                                              Optional. Default value is "UNSET". * MYSQL: MySQL * PG:
                                              PostgreSQL * REDIS: Redis * MONGODB: MongoDB * KAFKA:
                                              Kafka * OPENSEARCH: OpenSearch. Known values are:
                                              "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                              "OPENSEARCH".
                                            "production": bool,  #
                                              Optional. Whether this is a production or dev database.
                                            "version": "str"  # Optional.
                                              The version of the database engine.
                                        }
                                    ],
                                    "domains": [
                                        {
                                            "domain": "str",  # The
                                              hostname for the domain. Required.
                                            "minimum_tls_version": "str",
                                              # Optional. The minimum version of TLS a client
                                              application can use to access resources for the domain.
                                              Must be one of the following values wrapped within
                                              quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                              "1.2" and "1.3".
                                            "type": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * DEFAULT: The
                                              default ``.ondigitalocean.app`` domain assigned to this
                                              app * PRIMARY: The primary domain for this app that is
                                              displayed as the default in the control panel, used in
                                              bindable environment variables, and any other places that
                                              reference an app's live URL. Only one domain may be set
                                              as primary. * ALIAS: A non-primary domain. Known values
                                              are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and "ALIAS".
                                            "wildcard": bool,  #
                                              Optional. Indicates whether the domain includes all
                                              sub-domains, in addition to the given domain.
                                            "zone": "str"  # Optional.
                                              Optional. If the domain uses DigitalOcean DNS and you
                                              would like App Platform to automatically manage it for
                                              you, set this to the name of the domain on your account.
                                              For example, If the domain you are adding is
                                              ``app.domain.com``"" , the zone could be ``domain.com``.
                                        }
                                    ],
                                    "egress": {
                                        "type": "AUTOASSIGN"  # Optional.
                                          Default value is "AUTOASSIGN". The app egress type. Known
                                          values are: "AUTOASSIGN" and "DEDICATED_IP".
                                    },
                                    "functions": [
                                        {
                                            "name": "str",  # The name.
                                              Must be unique across all components within the same app.
                                              Required.
                                            "alerts": [
                                                {
                                                    "disabled":
                                                      bool,  # Optional. Is the alert disabled?.
                                                    "operator":
                                                      "UNSPECIFIED_OPERATOR",  # Optional. Default
                                                      value is "UNSPECIFIED_OPERATOR". Known values
                                                      are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                      "LESS_THAN".
                                                    "rule":
                                                      "UNSPECIFIED_RULE",  # Optional. Default value is
                                                      "UNSPECIFIED_RULE". Known values are:
                                                      "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                      "MEM_UTILIZATION", "RESTART_COUNT",
                                                      "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                      "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                      "FUNCTIONS_ACTIVATION_COUNT",
                                                      "FUNCTIONS_AVERAGE_DURATION_MS",
                                                      "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                      "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                      "FUNCTIONS_ERROR_COUNT", and
                                                      "FUNCTIONS_GB_RATE_PER_SECOND".
                                                    "value": 0.0,
                                                      # Optional. Threshold value for alert.
                                                    "window":
                                                      "UNSPECIFIED_WINDOW"  # Optional. Default value
                                                      is "UNSPECIFIED_WINDOW". Known values are:
                                                      "UNSPECIFIED_WINDOW", "FIVE_MINUTES",
                                                      "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                                                }
                                            ],
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "ingress": {
                                        "rules": [
                                            {
                                                "component": {
                                                    "name":
                                                      "str",  # The name of the component to route to.
                                                      Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``. Note: this is not applicable for
                                                      Functions Components and is mutually exclusive
                                                      with ``rewrite``.
                                                    "rewrite":
                                                      "str"  # Optional. An optional field that will
                                                      rewrite the path of the component to be what is
                                                      specified here. By default, the HTTP request path
                                                      will be trimmed from the left when forwarded to
                                                      the component. For example, a component with
                                                      ``path=/api`` will have requests to ``/api/list``
                                                      trimmed to ``/list``. If you specified the
                                                      rewrite to be ``/v1/``"" , requests to
                                                      ``/api/list`` would be rewritten to ``/v1/list``.
                                                      Note: this is mutually exclusive with
                                                      ``preserve_path_prefix``.
                                                },
                                                "cors": {
                "allow_credentials": bool,  # Optional. Whether
                                                      browsers should expose the response to the
                                                      client-side JavaScript code when the
                                                      request"u2019s credentials mode is include. This
                                                      configures the
                                                      ``Access-Control-Allow-Credentials`` header.
                "allow_headers": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP request
                                                          headers. This configures the
                                                          ``Access-Control-Allow-Headers`` header.
                                                    ],
                "allow_methods": [
                                                        "str"
                                                          # Optional. The set of allowed HTTP methods.
                                                          This configures the
                                                          ``Access-Control-Allow-Methods`` header.
                                                    ],
                "allow_origins": [
                                                        {
                "exact": "str",  # Optional. Exact string
                                                              match. Only 1 of ``exact``"" ,
                                                              ``prefix``"" , or ``regex`` must be set.
                "prefix": "str",  # Optional.
                                                              Prefix-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set.
                "regex": "str"  # Optional. RE2 style
                                                              regex-based match. Only 1 of ``exact``""
                                                              , ``prefix``"" , or ``regex`` must be
                                                              set. For more information about RE2
                                                              syntax, see:
                                                              https://github.com/google/re2/wiki/Syntax.
                                                        }
                                                    ],
                "expose_headers": [
                                                        "str"
                                                          # Optional. The set of HTTP response headers
                                                          that browsers are allowed to access. This
                                                          configures the
                                                          ``Access-Control-Expose-Headers`` header.
                                                    ],
                                                    "max_age":
                                                      "str"  # Optional. An optional duration
                                                      specifying how long browsers can cache the
                                                      results of a preflight request. This configures
                                                      the ``Access-Control-Max-Age`` header.
                                                },
                                                "match": {
                                                    "authority":
                                                      {
                "exact": "str"  # Required.
                                                    },
                                                    "path": {
                "prefix": "str"  # Prefix-based match. For
                                                          example, ``/api`` will match ``/api``"" ,
                                                          ``/api/``"" , and any nested paths such as
                                                          ``/api/v1/endpoint``. Required.
                                                    }
                                                },
                                                "redirect": {
                                                    "authority":
                                                      "str",  # Optional. The authority/host to
                                                      redirect to. This can be a hostname or IP
                                                      address. Note: use ``port`` to set the port.
                                                    "port": 0,  #
                                                      Optional. The port to redirect to.
                "redirect_code": 0,  # Optional. The redirect
                                                      code to use. Defaults to ``302``. Supported
                                                      values are 300, 301, 302, 303, 304, 307, 308.
                                                    "scheme":
                                                      "str",  # Optional. The scheme to redirect to.
                                                      Supported values are ``http`` or ``https``.
                                                      Default: ``https``.
                                                    "uri": "str"
                                                      # Optional. An optional URI path to redirect to.
                                                      Note: if this is specified the whole URI of the
                                                      original request will be overwritten to this
                                                      value, irrespective of the original request URI
                                                      being matched.
                                                }
                                            }
                                        ]
                                    },
                                    "jobs": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "kind": "UNSPECIFIED",  #
                                              Optional. Default value is "UNSPECIFIED". * UNSPECIFIED:
                                              Default job type, will auto-complete to POST_DEPLOY kind.
                                              * PRE_DEPLOY: Indicates a job that runs before an app
                                              deployment. * POST_DEPLOY: Indicates a job that runs
                                              after an app deployment. * FAILED_DEPLOY: Indicates a job
                                              that runs after a component fails to deploy. Known values
                                              are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                              "FAILED_DEPLOY".
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "maintenance": {
                                        "archive": bool,  # Optional.
                                          Indicates whether the app should be archived. Setting this to
                                          true implies that enabled is set to true.
                                        "enabled": bool,  # Optional.
                                          Indicates whether maintenance mode should be enabled for the
                                          app.
                                        "offline_page_url": "str"  #
                                          Optional. A custom offline page to display when maintenance
                                          mode is enabled or the app is archived.
                                    },
                                    "region": "str",  # Optional. The slug form
                                      of the geographical origin of the app. Default: ``nearest
                                      available``. Known values are: "ams", "nyc", "fra", "sfo", "sgp",
                                      "blr", "tor", "lon", and "syd".
                                    "services": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "health_check": {
                                                "failure_threshold":
                                                  0,  # Optional. The number of failed health checks
                                                  before considered unhealthy.
                                                "http_path": "str",
                                                  # Optional. The route path used for the HTTP health
                                                  check ping. If not set, the HTTP health check will be
                                                  disabled and a TCP health check used instead.
                "initial_delay_seconds": 0,  # Optional. The number
                                                  of seconds to wait before beginning health checks.
                                                "period_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  health checks.
                                                "port": 0,  #
                                                  Optional. The port on which the health check will be
                                                  performed. If not set, the health check will be
                                                  performed on the component's http_port.
                                                "success_threshold":
                                                  0,  # Optional. The number of successful health
                                                  checks before considered healthy.
                                                "timeout_seconds": 0
                                                  # Optional. The number of seconds after which the
                                                  check times out.
                                            },
                                            "http_port": 0,  # Optional.
                                              The internal port on which this service's run command
                                              will listen. Default: 8080 If there is not an environment
                                              variable with the name ``PORT``"" , one will be
                                              automatically added with its value set to the value of
                                              this field.
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "internal_ports": [
                                                0  # Optional. The
                                                  ports on which this service will listen for internal
                                                  traffic.
                                            ],
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "protocol": "str",  #
                                              Optional. The protocol which the service uses to serve
                                              traffic on the http_port.   * ``HTTP``"" : The app is
                                              serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                              app is serving the HTTP/2 protocol. Currently, this needs
                                              to be implemented in the service by serving HTTP/2
                                              cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                                                "drain_seconds": 0,
                                                  # Optional. The number of seconds to wait between
                                                  selecting a container instance for termination and
                                                  issuing the TERM signal. Selecting a container
                                                  instance for termination begins an asynchronous drain
                                                  of new requests on upstream load-balancers. (Default
                                                  15).
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ],
                                    "static_sites": [
                                        {
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "catchall_document": "str",
                                              # Optional. The name of the document to use as the
                                              fallback for any requests to documents that are not found
                                              when serving this static site. Only 1 of
                                              ``catchall_document`` or ``error_document`` can be set.
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "error_document": "404.html",
                                              # Optional. Default value is "404.html". The name of the
                                              error document to use when serving this static site.
                                              Default: 404.html. If no such file exists within the
                                              built assets, App Platform will supply one.
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "index_document":
                                              "index.html",  # Optional. Default value is "index.html".
                                              The name of the index document to use when serving this
                                              static site. Default: index.html.
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "output_dir": "str",  #
                                              Optional. An optional path to where the built assets will
                                              be located, relative to the build context. If not set,
                                              App Platform will automatically scan for these directory
                                              names: ``_static``"" , ``dist``"" , ``public``"" ,
                                              ``build``.
                                            "routes": [
                                                {
                                                    "path":
                                                      "str",  # Optional. (Deprecated - Use Ingress
                                                      Rules instead). An HTTP path prefix. Paths must
                                                      start with / and must be unique across all
                                                      components within an app.
                "preserve_path_prefix": bool  # Optional. An
                                                      optional flag to preserve the path that is
                                                      forwarded to the backend service. By default, the
                                                      HTTP request path will be trimmed from the left
                                                      when forwarded to the component. For example, a
                                                      component with ``path=/api`` will have requests
                                                      to ``/api/list`` trimmed to ``/list``. If this
                                                      value is ``true``"" , the path will remain
                                                      ``/api/list``.
                                                }
                                            ],
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str"  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                        }
                                    ],
                                    "workers": [
                                        {
                                            "autoscaling": {
                                                "max_instance_count":
                                                  0,  # Optional. The maximum amount of instances for
                                                  this component. Must be more than min_instance_count.
                                                "metrics": {
                                                    "cpu": {
                "percent": 80  # Optional. Default value is
                                                          80. The average target CPU utilization for
                                                          the component.
                                                    }
                                                },
                                                "min_instance_count":
                                                  0  # Optional. The minimum amount of instances for
                                                  this component. Must be less than max_instance_count.
                                            },
                                            "bitbucket": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "build_command": "str",  #
                                              Optional. An optional build command to run while building
                                              this component from source.
                                            "dockerfile_path": "str",  #
                                              Optional. The path to the Dockerfile relative to the root
                                              of the repo. If set, it will be used to build this
                                              component. Otherwise, App Platform will attempt to build
                                              it using buildpacks.
                                            "environment_slug": "str",  #
                                              Optional. An environment slug describing the type of this
                                              app. For a full list, please refer to `the product
                                              documentation
                                              <https://docs.digitalocean.com/products/app-platform/>`_.
                                            "envs": [
                                                {
                                                    "key": "str",
                                                      # The variable name. Required.
                                                    "scope":
                                                      "RUN_AND_BUILD_TIME",  # Optional. Default value
                                                      is "RUN_AND_BUILD_TIME". * RUN_TIME: Made
                                                      available only at run-time * BUILD_TIME: Made
                                                      available only at build-time *
                                                      RUN_AND_BUILD_TIME: Made available at both build
                                                      and run-time. Known values are: "UNSET",
                                                      "RUN_TIME", "BUILD_TIME", and
                                                      "RUN_AND_BUILD_TIME".
                                                    "type":
                                                      "GENERAL",  # Optional. Default value is
                                                      "GENERAL". * GENERAL: A plain-text environment
                                                      variable * SECRET: A secret encrypted environment
                                                      variable. Known values are: "GENERAL" and
                                                      "SECRET".
                                                    "value":
                                                      "str"  # Optional. The value. If the type is
                                                      ``SECRET``"" , the value will be encrypted on
                                                      first submission. On following submissions, the
                                                      encrypted value should be used.
                                                }
                                            ],
                                            "git": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "repo_clone_url":
                                                  "str"  # Optional. The clone URL of the repo.
                                                  Example:
                                                  ``https://github.com/digitalocean/sample-golang.git``.
                                            },
                                            "github": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "gitlab": {
                                                "branch": "str",  #
                                                  Optional. The name of the branch to use.
                                                "deploy_on_push":
                                                  bool,  # Optional. Whether to automatically deploy
                                                  new commits made to the repo.
                                                "repo": "str"  #
                                                  Optional. The name of the repo in the format
                                                  owner/repo. Example: ``digitalocean/sample-golang``.
                                            },
                                            "image": {
                                                "deploy_on_push": {
                                                    "enabled":
                                                      bool  # Optional. Whether to automatically deploy
                                                      new images. Can only be used for images hosted in
                                                      DOCR and can only be used with an image tag, not
                                                      a specific digest.
                                                },
                                                "digest": "str",  #
                                                  Optional. The image digest. Cannot be specified if
                                                  tag is provided.
                                                "registry": "str",  #
                                                  Optional. The registry name. Must be left empty for
                                                  the ``DOCR`` registry type.
                "registry_credentials": "str",  # Optional. The
                                                  credentials to be able to pull the image. The value
                                                  will be encrypted on first submission. On following
                                                  submissions, the encrypted value should be used.   *
                                                  "$username:$access_token" for registries of type
                                                  ``DOCKER_HUB``. * "$username:$access_token" for
                                                  registries of type ``GHCR``.
                                                "registry_type":
                                                  "str",  # Optional. * DOCKER_HUB: The DockerHub
                                                  container registry type. * DOCR: The DigitalOcean
                                                  container registry type. * GHCR: The Github container
                                                  registry type. Known values are: "DOCKER_HUB",
                                                  "DOCR", and "GHCR".
                                                "repository": "str",
                                                  # Optional. The repository name.
                                                "tag": "latest"  #
                                                  Optional. Default value is "latest". The repository
                                                  tag. Defaults to ``latest`` if not provided and no
                                                  digest is provided. Cannot be specified if digest is
                                                  provided.
                                            },
                                            "instance_count": 1,  #
                                              Optional. Default value is 1. The amount of instances
                                              that this component should be scaled to. Default: 1. Must
                                              not be set if autoscaling is used.
                                            "instance_size_slug": {},
                                            "log_destinations": [
                                                {
                                                    "name":
                                                      "str",  # Required.
                                                    "datadog": {
                "api_key": "str",  # Datadog API key.
                                                          Required.
                "endpoint": "str"  # Optional. Datadog HTTP
                                                          log intake endpoint.
                                                    },
                                                    "logtail": {
                "token": "str"  # Optional. Logtail token.
                                                    },
                "open_search": {
                "basic_auth": {
                "password": {},  # Optional. Password for
                                                              user defined in User. Is required when
                                                              ``endpoint`` is set. Cannot be set if
                                                              using a DigitalOcean DBaaS OpenSearch
                                                              cluster.
                "user": "str"  # Optional. Username to
                                                              authenticate with. Only required when
                                                              ``endpoint`` is set. Defaults to
                                                              ``doadmin`` when ``cluster_name`` is set.
                                                        },
                "cluster_name": "str",  # Optional. The name
                                                          of a DigitalOcean DBaaS OpenSearch cluster to
                                                          use as a log forwarding destination. Cannot
                                                          be specified if ``endpoint`` is also
                                                          specified.
                "endpoint": "str",  # Optional. OpenSearch
                                                          API Endpoint. Only HTTPS is supported.
                                                          Format:
                                                          https://:code:`<host>`::code:`<port>`. Cannot
                                                          be specified if ``cluster_name`` is also
                                                          specified.
                "index_name": "logs"  # Optional. Default
                                                          value is "logs". The index name to use for
                                                          the logs. If not set, the default index name
                                                          is "logs".
                                                    },
                                                    "papertrail":
                                                      {
                "endpoint": "str"  # Papertrail syslog
                                                          endpoint. Required.
                                                    }
                                                }
                                            ],
                                            "name": "str",  # Optional.
                                              The name. Must be unique across all components within the
                                              same app.
                                            "run_command": "str",  #
                                              Optional. An optional run command to override the
                                              component's default.
                                            "source_dir": "str",  #
                                              Optional. An optional path to the working directory to
                                              use for the build. For Dockerfile builds, this will be
                                              used as the build context. Must be relative to the root
                                              of the repo.
                                            "termination": {
                "grace_period_seconds": 0  # Optional. The number of
                                                  seconds to wait between sending a TERM signal to a
                                                  container and issuing a KILL which causes immediate
                                                  shutdown. (Default 120).
                                            }
                                        }
                                    ]
                                },
                                "static_sites": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this static site.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this static site.
                                    }
                                ],
                                "tier_slug": "str",  # Optional. The current pricing
                                  tier slug of the deployment.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  When the deployment was last updated.
                                "workers": [
                                    {
                                        "name": "str",  # Optional. The name
                                          of this worker.
                                        "source_commit_hash": "str"  #
                                          Optional. The commit hash of the repository that was used to
                                          build this worker.
                                    }
                                ]
                            },
                            "project_id": "str",  # Optional. The ID of the project the
                              app is assigned to. This will be empty if there is a lookup failure.
                            "region": {
                                "continent": "str",  # Optional. The continent that
                                  this region is in.
                                "data_centers": [
                                    "str"  # Optional. Data centers that are in
                                      this region.
                                ],
                                "default": bool,  # Optional. Whether or not the
                                  region is presented as the default.
                                "disabled": bool,  # Optional. Whether or not the
                                  region is open for new apps.
                                "flag": "str",  # Optional. The flag of this region.
                                "label": "str",  # Optional. A human-readable name of
                                  the region.
                                "reason": "str",  # Optional. Reason that this region
                                  is not available.
                                "slug": "str"  # Optional. The slug form of the
                                  region name.
                            },
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the app.
                            "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the
                              app's last configuration update.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_list_request(
            page=page,
            per_page=per_page,
            with_projects=with_projects,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New App.

        Create a new app by submitting an app specification. For documentation on app specifications
        (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "project_id": "str"  # Optional. The ID of the project the app should be
                      assigned to. If omitted, it will be assigned to your default project.
                }

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New App.

        Create a new app by submitting an app specification. For documentation on app specifications
        (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New App.

        Create a new app by submitting an app specification. For documentation on app specifications
        (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "project_id": "str"  # Optional. The ID of the project the app should be
                      assigned to. If omitted, it will be assigned to your default project.
                }

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete an App.

        Delete an existing app. Once deleted, all active deployments will be permanently shut down and
        the app deleted. If needed, be sure to back up your app specification so that you may re-create
        it at a later time.

        :param id: The ID of the app. Required.
        :type id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "id": "str"  # Optional. The ID of the app that was deleted.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_delete_request(
            id=id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, id: str, *, name: Optional[str] = None, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing App.

        Retrieve details about an existing app by either its ID or name. To retrieve an app by its
        name, do not include an ID in the request path. Information about the current active deployment
        as well as any in progress ones will also be included in the response.

        :param id: The ID of the app. Required.
        :type id: str
        :keyword name: The name of the app to retrieve. Default value is None.
        :paramtype name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_request(
            id=id,
            name=name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an App.

        Update an existing app by submitting a new app specification. For documentation on app
        specifications (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param id: The ID of the app. Required.
        :type id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "update_all_source_versions": False  # Optional. Default value is False.
                      Whether or not to update the source versions (for example fetching a new commit
                      or image digest) of all components. By default (when this is false) only newly
                      added sources will be updated to avoid changes like updating the scale of a
                      component from also updating the respective code.
                }

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an App.

        Update an existing app by submitting a new app specification. For documentation on app
        specifications (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param id: The ID of the app. Required.
        :type id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(self, id: str, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Update an App.

        Update an existing app by submitting a new app specification. For documentation on app
        specifications (\\ ``AppSpec`` objects), please refer to `the product documentation
        <https://docs.digitalocean.com/products/app-platform/reference/app-spec/>`_.

        :param id: The ID of the app. Required.
        :type id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "update_all_source_versions": False  # Optional. Default value is False.
                      Whether or not to update the source versions (for example fetching a new commit
                      or image digest) of all components. By default (when this is false) only newly
                      added sources will be updated to avoid changes like updating the scale of a
                      component from also updating the respective code.
                }

                # response body for status code(s): 200
                response == {
                    "app": {
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "active_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the app.
                        "dedicated_ips": [
                            {
                                "id": "str",  # Optional. The ID of the dedicated
                                  egress IP.
                                "ip": "str",  # Optional. The IP address of the
                                  dedicated egress IP.
                                "status": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". The status of the dedicated egress IP. Known values are:
                                  "UNKNOWN", "ASSIGNING", "ASSIGNED", and "REMOVED".
                            }
                        ],
                        "default_ingress": "str",  # Optional. The default hostname on which
                          the app is accessible.
                        "domains": [
                            {
                                "certificate_expires_at": "2020-02-20 00:00:00",  #
                                  Optional. Current SSL certificate expiration time.
                                "id": "str",  # Optional. The ID of the domain.
                                "phase": "UNKNOWN",  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "PENDING", "CONFIGURING",
                                  "ACTIVE", and "ERROR".
                                "progress": {
                                    "steps": [
                                        {}  # Optional. The steps of the
                                          domain's progress.
                                    ]
                                },
                                "rotate_validation_records": bool,  # Optional.
                                  Validation values have changed and require manual intervention.
                                "spec": {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                },
                                "validations": [
                                    {
                                        "txt_name": "str",  # Optional. TXT
                                          record name.
                                        "txt_value": "str"  # Optional. TXT
                                          record value.
                                    }
                                ]
                            }
                        ],
                        "id": "str",  # Optional. The ID of the application.
                        "in_progress_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "last_deployment_created_at": "2020-02-20 00:00:00",  # Optional. The
                          creation time of the last deployment.
                        "live_domain": "str",  # Optional. The live domain of the app.
                        "live_url": "str",  # Optional. The live URL of the app.
                        "live_url_base": "str",  # Optional. The live URL base of the app,
                          the URL excluding the path.
                        "owner_uuid": "str",  # Optional. The ID of the account to which the
                          application belongs.
                        "pending_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "pinned_deployment": {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        },
                        "project_id": "str",  # Optional. The ID of the project the app is
                          assigned to. This will be empty if there is a lookup failure.
                        "region": {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        },
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          app.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. Time of the app's
                          last configuration update.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_update_request(
            id=id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def restart(
        self,
        app_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Restart an App.

        Perform a rolling restart of all or specific components in an app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "components": [
                        "str"  # Optional. Optional list of components to restart. If not
                          provided, all components will be restarted.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def restart(
        self,
        app_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Restart an App.

        Perform a rolling restart of all or specific components in an app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def restart(
        self, app_id: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Restart an App.

        Perform a rolling restart of all or specific components in an app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "components": [
                        "str"  # Optional. Optional list of components to restart. If not
                          provided, all components will be restarted.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_apps_restart_request(
            app_id=app_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_logs_active_deployment(
        self,
        app_id: str,
        component_name: str,
        *,
        follow: Optional[bool] = None,
        type: str = "UNSPECIFIED",
        pod_connection_timeout: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Active Deployment Logs.

        Retrieve the logs of the active deployment if one exists. The response will include links to
        either real-time logs of an in-progress or active deployment or archived logs of a past
        deployment. Note log_type=BUILD logs will return logs associated with the current active
        deployment (being served). To view build logs associated with in-progress build, the query must
        explicitly reference the deployment id.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param component_name: An optional component name. If set, logs will be limited to this
         component only. Required.
        :type component_name: str
        :keyword follow: Whether the logs should follow live updates. Default value is None.
        :paramtype follow: bool
        :keyword type: The type of logs to retrieve


         * BUILD: Build-time logs
         * DEPLOY: Deploy-time logs
         * RUN: Live run-time logs
         * RUN_RESTARTED: Logs of crashed/restarted instances during runtime. Known values are:
         "UNSPECIFIED", "BUILD", "DEPLOY", "RUN", and "RUN_RESTARTED". Default value is "UNSPECIFIED".
        :paramtype type: str
        :keyword pod_connection_timeout: An optional time duration to wait if the underlying component
         instance is not immediately available. Default: ``3m``. Default value is None.
        :paramtype pod_connection_timeout: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "historic_urls": [
                        "str"  # Optional. A list of URLs to archived log files.
                    ],
                    "live_url": "str"  # Optional. A URL of the real-time live logs. This URL may
                      use either the ``https://`` or ``wss://`` protocols and will keep pushing live
                      logs as they become available.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_logs_active_deployment_request(
            app_id=app_id,
            component_name=component_name,
            follow=follow,
            type=type,
            pod_connection_timeout=pod_connection_timeout,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_exec_active_deployment(
        self, app_id: str, component_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Exec URL.

        Returns a websocket URL that allows sending/receiving console input and output to a component
        of the active deployment if one exists.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param component_name: An optional component name. If set, logs will be limited to this
         component only. Required.
        :type component_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "url": "str"  # Optional. A websocket URL that allows sending/receiving
                      console input and receiving console output.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_exec_active_deployment_request(
            app_id=app_id,
            component_name=component_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_deployments(
        self, app_id: str, *, page: int = 1, per_page: int = 20, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List App Deployments.

        List all deployments of an app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "deployments": [
                        {
                            "cause": "str",  # Optional. What caused this deployment to
                              be created.
                            "cloned_from": "str",  # Optional. The ID of a previous
                              deployment that this deployment was cloned from.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The
                              creation time of the deployment.
                            "functions": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      functions component.
                                    "namespace": "str",  # Optional. The
                                      namespace where the functions are deployed.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      functions component.
                                }
                            ],
                            "id": "str",  # Optional. The ID of the deployment.
                            "jobs": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      job.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this job.
                                }
                            ],
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING_BUILD", "BUILDING",
                              "PENDING_DEPLOY", "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and
                              "CANCELED".
                            "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional.
                              When the deployment phase was last updated.
                            "progress": {
                                "error_steps": 0,  # Optional. Number of unsuccessful
                                  steps.
                                "pending_steps": 0,  # Optional. Number of pending
                                  steps.
                                "running_steps": 0,  # Optional. Number of currently
                                  running steps.
                                "steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "success_steps": 0,  # Optional. Number of successful
                                  steps.
                                "summary_steps": [
                                    {
                                        "component_name": "str",  # Optional.
                                          The component name that this step is associated with.
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The end time of this step.
                                        "message_base": "str",  # Optional.
                                          The base of a human-readable description of the step intended
                                          to be combined with the component name for presentation. For
                                          example:  ``message_base`` = "Building service"
                                          ``component_name`` = "api".
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN",  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                        "steps": [
                                            {}  # Optional. Child steps
                                              of this step.
                                        ]
                                    }
                                ],
                                "total_steps": 0  # Optional. Total number of steps.
                            },
                            "services": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      service.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this
                                      service.
                                }
                            ],
                            "spec": {
                                "name": "str",  # The name of the app. Must be unique
                                  across all apps in the same account. Required.
                                "databases": [
                                    {
                                        "name": "str",  # The database's
                                          name. The name must be unique across all components within
                                          the same app and cannot use capital letters. Required.
                                        "cluster_name": "str",  # Optional.
                                          The name of the underlying DigitalOcean DBaaS cluster. This
                                          is required for production databases. For dev databases, if
                                          cluster_name is not set, a new cluster will be provisioned.
                                        "db_name": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL database to configure.
                                        "db_user": "str",  # Optional. The
                                          name of the MySQL or PostgreSQL user to configure.
                                        "engine": "UNSET",  # Optional.
                                          Default value is "UNSET". * MYSQL: MySQL * PG: PostgreSQL *
                                          REDIS: Redis * MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH:
                                          OpenSearch. Known values are: "UNSET", "MYSQL", "PG",
                                          "REDIS", "MONGODB", "KAFKA", and "OPENSEARCH".
                                        "production": bool,  # Optional.
                                          Whether this is a production or dev database.
                                        "version": "str"  # Optional. The
                                          version of the database engine.
                                    }
                                ],
                                "domains": [
                                    {
                                        "domain": "str",  # The hostname for
                                          the domain. Required.
                                        "minimum_tls_version": "str",  #
                                          Optional. The minimum version of TLS a client application can
                                          use to access resources for the domain.  Must be one of the
                                          following values wrapped within quotations: ``"1.2"`` or
                                          ``"1.3"``. Known values are: "1.2" and "1.3".
                                        "type": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * DEFAULT: The default
                                          ``.ondigitalocean.app`` domain assigned to this app *
                                          PRIMARY: The primary domain for this app that is displayed as
                                          the default in the control panel, used in bindable
                                          environment variables, and any other places that reference an
                                          app's live URL. Only one domain may be set as primary. *
                                          ALIAS: A non-primary domain. Known values are: "UNSPECIFIED",
                                          "DEFAULT", "PRIMARY", and "ALIAS".
                                        "wildcard": bool,  # Optional.
                                          Indicates whether the domain includes all sub-domains, in
                                          addition to the given domain.
                                        "zone": "str"  # Optional. Optional.
                                          If the domain uses DigitalOcean DNS and you would like App
                                          Platform to automatically manage it for you, set this to the
                                          name of the domain on your account.  For example, If the
                                          domain you are adding is ``app.domain.com``"" , the zone
                                          could be ``domain.com``.
                                    }
                                ],
                                "egress": {
                                    "type": "AUTOASSIGN"  # Optional. Default
                                      value is "AUTOASSIGN". The app egress type. Known values are:
                                      "AUTOASSIGN" and "DEDICATED_IP".
                                },
                                "functions": [
                                    {
                                        "name": "str",  # The name. Must be
                                          unique across all components within the same app. Required.
                                        "alerts": [
                                            {
                                                "disabled": bool,  #
                                                  Optional. Is the alert disabled?.
                                                "operator":
                                                  "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                                  "UNSPECIFIED_OPERATOR". Known values are:
                                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                                  "LESS_THAN".
                                                "rule":
                                                  "UNSPECIFIED_RULE",  # Optional. Default value is
                                                  "UNSPECIFIED_RULE". Known values are:
                                                  "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                                  "MEM_UTILIZATION", "RESTART_COUNT",
                                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE",
                                                  "DOMAIN_FAILED", "DOMAIN_LIVE",
                                                  "FUNCTIONS_ACTIVATION_COUNT",
                                                  "FUNCTIONS_AVERAGE_DURATION_MS",
                                                  "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                                  "FUNCTIONS_ERROR_COUNT", and
                                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                                "value": 0.0,  #
                                                  Optional. Threshold value for alert.
                                                "window":
                                                  "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                                  "UNSPECIFIED_WINDOW". Known values are:
                                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                                  "THIRTY_MINUTES", and "ONE_HOUR".
                                            }
                                        ],
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "ingress": {
                                    "rules": [
                                        {
                                            "component": {
                                                "name": "str",  # The
                                                  name of the component to route to. Required.
                "preserve_path_prefix": "str",  # Optional. An
                                                  optional flag to preserve the path that is forwarded
                                                  to the backend service. By default, the HTTP request
                                                  path will be trimmed from the left when forwarded to
                                                  the component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``. Note: this is not
                                                  applicable for Functions Components and is mutually
                                                  exclusive with ``rewrite``.
                                                "rewrite": "str"  #
                                                  Optional. An optional field that will rewrite the
                                                  path of the component to be what is specified here.
                                                  By default, the HTTP request path will be trimmed
                                                  from the left when forwarded to the component. For
                                                  example, a component with ``path=/api`` will have
                                                  requests to ``/api/list`` trimmed to ``/list``. If
                                                  you specified the rewrite to be ``/v1/``"" , requests
                                                  to ``/api/list`` would be rewritten to ``/v1/list``.
                                                  Note: this is mutually exclusive with
                                                  ``preserve_path_prefix``.
                                            },
                                            "cors": {
                                                "allow_credentials":
                                                  bool,  # Optional. Whether browsers should expose the
                                                  response to the client-side JavaScript code when the
                                                  request"u2019s credentials mode is include. This
                                                  configures the ``Access-Control-Allow-Credentials``
                                                  header.
                                                "allow_headers": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP request
                                                      headers. This configures the
                                                      ``Access-Control-Allow-Headers`` header.
                                                ],
                                                "allow_methods": [
                                                    "str"  #
                                                      Optional. The set of allowed HTTP methods. This
                                                      configures the ``Access-Control-Allow-Methods``
                                                      header.
                                                ],
                                                "allow_origins": [
                                                    {
                "exact": "str",  # Optional. Exact string
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "prefix": "str",  # Optional. Prefix-based
                                                          match. Only 1 of ``exact``"" , ``prefix``"" ,
                                                          or ``regex`` must be set.
                "regex": "str"  # Optional. RE2 style
                                                          regex-based match. Only 1 of ``exact``"" ,
                                                          ``prefix``"" , or ``regex`` must be set. For
                                                          more information about RE2 syntax, see:
                                                          https://github.com/google/re2/wiki/Syntax.
                                                    }
                                                ],
                                                "expose_headers": [
                                                    "str"  #
                                                      Optional. The set of HTTP response headers that
                                                      browsers are allowed to access. This configures
                                                      the ``Access-Control-Expose-Headers`` header.
                                                ],
                                                "max_age": "str"  #
                                                  Optional. An optional duration specifying how long
                                                  browsers can cache the results of a preflight
                                                  request. This configures the
                                                  ``Access-Control-Max-Age`` header.
                                            },
                                            "match": {
                                                "authority": {
                                                    "exact":
                                                      "str"  # Required.
                                                },
                                                "path": {
                                                    "prefix":
                                                      "str"  # Prefix-based match. For example,
                                                      ``/api`` will match ``/api``"" , ``/api/``"" ,
                                                      and any nested paths such as
                                                      ``/api/v1/endpoint``. Required.
                                                }
                                            },
                                            "redirect": {
                                                "authority": "str",
                                                  # Optional. The authority/host to redirect to. This
                                                  can be a hostname or IP address. Note: use ``port``
                                                  to set the port.
                                                "port": 0,  #
                                                  Optional. The port to redirect to.
                                                "redirect_code": 0,
                                                  # Optional. The redirect code to use. Defaults to
                                                  ``302``. Supported values are 300, 301, 302, 303,
                                                  304, 307, 308.
                                                "scheme": "str",  #
                                                  Optional. The scheme to redirect to. Supported values
                                                  are ``http`` or ``https``. Default: ``https``.
                                                "uri": "str"  #
                                                  Optional. An optional URI path to redirect to. Note:
                                                  if this is specified the whole URI of the original
                                                  request will be overwritten to this value,
                                                  irrespective of the original request URI being
                                                  matched.
                                            }
                                        }
                                    ]
                                },
                                "jobs": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "kind": "UNSPECIFIED",  # Optional.
                                          Default value is "UNSPECIFIED". * UNSPECIFIED: Default job
                                          type, will auto-complete to POST_DEPLOY kind. * PRE_DEPLOY:
                                          Indicates a job that runs before an app deployment. *
                                          POST_DEPLOY: Indicates a job that runs after an app
                                          deployment. * FAILED_DEPLOY: Indicates a job that runs after
                                          a component fails to deploy. Known values are: "UNSPECIFIED",
                                          "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "maintenance": {
                                    "archive": bool,  # Optional. Indicates
                                      whether the app should be archived. Setting this to true implies
                                      that enabled is set to true.
                                    "enabled": bool,  # Optional. Indicates
                                      whether maintenance mode should be enabled for the app.
                                    "offline_page_url": "str"  # Optional. A
                                      custom offline page to display when maintenance mode is enabled
                                      or the app is archived.
                                },
                                "region": "str",  # Optional. The slug form of the
                                  geographical origin of the app. Default: ``nearest available``. Known
                                  values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon",
                                  and "syd".
                                "services": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "health_check": {
                                            "failure_threshold": 0,  #
                                              Optional. The number of failed health checks before
                                              considered unhealthy.
                                            "http_path": "str",  #
                                              Optional. The route path used for the HTTP health check
                                              ping. If not set, the HTTP health check will be disabled
                                              and a TCP health check used instead.
                                            "initial_delay_seconds": 0,
                                              # Optional. The number of seconds to wait before
                                              beginning health checks.
                                            "period_seconds": 0,  #
                                              Optional. The number of seconds to wait between health
                                              checks.
                                            "port": 0,  # Optional. The
                                              port on which the health check will be performed. If not
                                              set, the health check will be performed on the
                                              component's http_port.
                                            "success_threshold": 0,  #
                                              Optional. The number of successful health checks before
                                              considered healthy.
                                            "timeout_seconds": 0  #
                                              Optional. The number of seconds after which the check
                                              times out.
                                        },
                                        "http_port": 0,  # Optional. The
                                          internal port on which this service's run command will
                                          listen. Default: 8080 If there is not an environment variable
                                          with the name ``PORT``"" , one will be automatically added
                                          with its value set to the value of this field.
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "internal_ports": [
                                            0  # Optional. The ports on
                                              which this service will listen for internal traffic.
                                        ],
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "protocol": "str",  # Optional. The
                                          protocol which the service uses to serve traffic on the
                                          http_port.   * ``HTTP``"" : The app is serving the HTTP
                                          protocol. Default. * ``HTTP2``"" : The app is serving the
                                          HTTP/2 protocol. Currently, this needs to be implemented in
                                          the service by serving HTTP/2 cleartext (h2c). Known values
                                          are: "HTTP" and "HTTP2".
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "drain_seconds": 0,  #
                                              Optional. The number of seconds to wait between selecting
                                              a container instance for termination and issuing the TERM
                                              signal. Selecting a container instance for termination
                                              begins an asynchronous drain of new requests on upstream
                                              load-balancers. (Default 15).
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ],
                                "static_sites": [
                                    {
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "catchall_document": "str",  #
                                          Optional. The name of the document to use as the fallback for
                                          any requests to documents that are not found when serving
                                          this static site. Only 1 of ``catchall_document`` or
                                          ``error_document`` can be set.
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "error_document": "404.html",  #
                                          Optional. Default value is "404.html". The name of the error
                                          document to use when serving this static site. Default:
                                          404.html. If no such file exists within the built assets, App
                                          Platform will supply one.
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "index_document": "index.html",  #
                                          Optional. Default value is "index.html". The name of the
                                          index document to use when serving this static site. Default:
                                          index.html.
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "output_dir": "str",  # Optional. An
                                          optional path to where the built assets will be located,
                                          relative to the build context. If not set, App Platform will
                                          automatically scan for these directory names: ``_static``"" ,
                                          ``dist``"" , ``public``"" , ``build``.
                                        "routes": [
                                            {
                                                "path": "str",  #
                                                  Optional. (Deprecated - Use Ingress Rules instead).
                                                  An HTTP path prefix. Paths must start with / and must
                                                  be unique across all components within an app.
                "preserve_path_prefix": bool  # Optional. An optional
                                                  flag to preserve the path that is forwarded to the
                                                  backend service. By default, the HTTP request path
                                                  will be trimmed from the left when forwarded to the
                                                  component. For example, a component with
                                                  ``path=/api`` will have requests to ``/api/list``
                                                  trimmed to ``/list``. If this value is ``true``"" ,
                                                  the path will remain ``/api/list``.
                                            }
                                        ],
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str"  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                    }
                                ],
                                "workers": [
                                    {
                                        "autoscaling": {
                                            "max_instance_count": 0,  #
                                              Optional. The maximum amount of instances for this
                                              component. Must be more than min_instance_count.
                                            "metrics": {
                                                "cpu": {
                                                    "percent": 80
                                                      # Optional. Default value is 80. The average
                                                      target CPU utilization for the component.
                                                }
                                            },
                                            "min_instance_count": 0  #
                                              Optional. The minimum amount of instances for this
                                              component. Must be less than max_instance_count.
                                        },
                                        "bitbucket": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "build_command": "str",  # Optional.
                                          An optional build command to run while building this
                                          component from source.
                                        "dockerfile_path": "str",  #
                                          Optional. The path to the Dockerfile relative to the root of
                                          the repo. If set, it will be used to build this component.
                                          Otherwise, App Platform will attempt to build it using
                                          buildpacks.
                                        "environment_slug": "str",  #
                                          Optional. An environment slug describing the type of this
                                          app. For a full list, please refer to `the product
                                          documentation
                                          <https://docs.digitalocean.com/products/app-platform/>`_.
                                        "envs": [
                                            {
                                                "key": "str",  # The
                                                  variable name. Required.
                                                "scope":
                                                  "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                                  "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only
                                                  at run-time * BUILD_TIME: Made available only at
                                                  build-time * RUN_AND_BUILD_TIME: Made available at
                                                  both build and run-time. Known values are: "UNSET",
                                                  "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                                "type": "GENERAL",  #
                                                  Optional. Default value is "GENERAL". * GENERAL: A
                                                  plain-text environment variable * SECRET: A secret
                                                  encrypted environment variable. Known values are:
                                                  "GENERAL" and "SECRET".
                                                "value": "str"  #
                                                  Optional. The value. If the type is ``SECRET``"" ,
                                                  the value will be encrypted on first submission. On
                                                  following submissions, the encrypted value should be
                                                  used.
                                            }
                                        ],
                                        "git": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "repo_clone_url": "str"  #
                                              Optional. The clone URL of the repo. Example:
                                              ``https://github.com/digitalocean/sample-golang.git``.
                                        },
                                        "github": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "gitlab": {
                                            "branch": "str",  # Optional.
                                              The name of the branch to use.
                                            "deploy_on_push": bool,  #
                                              Optional. Whether to automatically deploy new commits
                                              made to the repo.
                                            "repo": "str"  # Optional.
                                              The name of the repo in the format owner/repo. Example:
                                              ``digitalocean/sample-golang``.
                                        },
                                        "image": {
                                            "deploy_on_push": {
                                                "enabled": bool  #
                                                  Optional. Whether to automatically deploy new images.
                                                  Can only be used for images hosted in DOCR and can
                                                  only be used with an image tag, not a specific
                                                  digest.
                                            },
                                            "digest": "str",  # Optional.
                                              The image digest. Cannot be specified if tag is provided.
                                            "registry": "str",  #
                                              Optional. The registry name. Must be left empty for the
                                              ``DOCR`` registry type.
                                            "registry_credentials":
                                              "str",  # Optional. The credentials to be able to pull
                                              the image. The value will be encrypted on first
                                              submission. On following submissions, the encrypted value
                                              should be used.   * "$username:$access_token" for
                                              registries of type ``DOCKER_HUB``. *
                                              "$username:$access_token" for registries of type
                                              ``GHCR``.
                                            "registry_type": "str",  #
                                              Optional. * DOCKER_HUB: The DockerHub container registry
                                              type. * DOCR: The DigitalOcean container registry type. *
                                              GHCR: The Github container registry type. Known values
                                              are: "DOCKER_HUB", "DOCR", and "GHCR".
                                            "repository": "str",  #
                                              Optional. The repository name.
                                            "tag": "latest"  # Optional.
                                              Default value is "latest". The repository tag. Defaults
                                              to ``latest`` if not provided and no digest is provided.
                                              Cannot be specified if digest is provided.
                                        },
                                        "instance_count": 1,  # Optional.
                                          Default value is 1. The amount of instances that this
                                          component should be scaled to. Default: 1. Must not be set if
                                          autoscaling is used.
                                        "instance_size_slug": {},
                                        "log_destinations": [
                                            {
                                                "name": "str",  #
                                                  Required.
                                                "datadog": {
                                                    "api_key":
                                                      "str",  # Datadog API key. Required.
                                                    "endpoint":
                                                      "str"  # Optional. Datadog HTTP log intake
                                                      endpoint.
                                                },
                                                "logtail": {
                                                    "token":
                                                      "str"  # Optional. Logtail token.
                                                },
                                                "open_search": {
                                                    "basic_auth":
                                                      {
                "password": {},  # Optional. Password for
                                                          user defined in User. Is required when
                                                          ``endpoint`` is set. Cannot be set if using a
                                                          DigitalOcean DBaaS OpenSearch cluster.
                "user": "str"  # Optional. Username to
                                                          authenticate with. Only required when
                                                          ``endpoint`` is set. Defaults to ``doadmin``
                                                          when ``cluster_name`` is set.
                                                    },
                "cluster_name": "str",  # Optional. The name of a
                                                      DigitalOcean DBaaS OpenSearch cluster to use as a
                                                      log forwarding destination. Cannot be specified
                                                      if ``endpoint`` is also specified.
                                                    "endpoint":
                                                      "str",  # Optional. OpenSearch API Endpoint. Only
                                                      HTTPS is supported. Format:
                                                      https://:code:`<host>`::code:`<port>`. Cannot be
                                                      specified if ``cluster_name`` is also specified.
                                                    "index_name":
                                                      "logs"  # Optional. Default value is "logs". The
                                                      index name to use for the logs. If not set, the
                                                      default index name is "logs".
                                                },
                                                "papertrail": {
                                                    "endpoint":
                                                      "str"  # Papertrail syslog endpoint. Required.
                                                }
                                            }
                                        ],
                                        "name": "str",  # Optional. The name.
                                          Must be unique across all components within the same app.
                                        "run_command": "str",  # Optional. An
                                          optional run command to override the component's default.
                                        "source_dir": "str",  # Optional. An
                                          optional path to the working directory to use for the build.
                                          For Dockerfile builds, this will be used as the build
                                          context. Must be relative to the root of the repo.
                                        "termination": {
                                            "grace_period_seconds": 0  #
                                              Optional. The number of seconds to wait between sending a
                                              TERM signal to a container and issuing a KILL which
                                              causes immediate shutdown. (Default 120).
                                        }
                                    }
                                ]
                            },
                            "static_sites": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      static site.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this static
                                      site.
                                }
                            ],
                            "tier_slug": "str",  # Optional. The current pricing tier
                              slug of the deployment.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. When the
                              deployment was last updated.
                            "workers": [
                                {
                                    "name": "str",  # Optional. The name of this
                                      worker.
                                    "source_commit_hash": "str"  # Optional. The
                                      commit hash of the repository that was used to build this worker.
                                }
                            ]
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_list_deployments_request(
            app_id=app_id,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_deployment(
        self,
        app_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an App Deployment.

        Creating an app deployment will pull the latest changes from your repository and schedule a new
        deployment for your app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "force_build": bool  # Optional. Indicates whether to force a build of app
                      from source even if an existing cached build is suitable for re-use.
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_deployment(
        self,
        app_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an App Deployment.

        Creating an app deployment will pull the latest changes from your repository and schedule a new
        deployment for your app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_deployment(
        self, app_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an App Deployment.

        Creating an app deployment will pull the latest changes from your repository and schedule a new
        deployment for your app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "force_build": bool  # Optional. Indicates whether to force a build of app
                      from source even if an existing cached build is suitable for re-use.
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_create_deployment_request(
            app_id=app_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_deployment(self, app_id: str, deployment_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an App Deployment.

        Retrieve information about an app deployment.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param deployment_id: The deployment ID. Required.
        :type deployment_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_deployment_request(
            app_id=app_id,
            deployment_id=deployment_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def cancel_deployment(self, app_id: str, deployment_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Cancel a Deployment.

        Immediately cancel an in-progress deployment.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param deployment_id: The deployment ID. Required.
        :type deployment_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_cancel_deployment_request(
            app_id=app_id,
            deployment_id=deployment_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_logs(
        self,
        app_id: str,
        deployment_id: str,
        component_name: str,
        *,
        follow: Optional[bool] = None,
        type: str = "UNSPECIFIED",
        pod_connection_timeout: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Deployment Logs.

        Retrieve the logs of a past, in-progress, or active deployment. The response will include links
        to either real-time logs of an in-progress or active deployment or archived logs of a past
        deployment.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param deployment_id: The deployment ID. Required.
        :type deployment_id: str
        :param component_name: An optional component name. If set, logs will be limited to this
         component only. Required.
        :type component_name: str
        :keyword follow: Whether the logs should follow live updates. Default value is None.
        :paramtype follow: bool
        :keyword type: The type of logs to retrieve


         * BUILD: Build-time logs
         * DEPLOY: Deploy-time logs
         * RUN: Live run-time logs
         * RUN_RESTARTED: Logs of crashed/restarted instances during runtime. Known values are:
         "UNSPECIFIED", "BUILD", "DEPLOY", "RUN", and "RUN_RESTARTED". Default value is "UNSPECIFIED".
        :paramtype type: str
        :keyword pod_connection_timeout: An optional time duration to wait if the underlying component
         instance is not immediately available. Default: ``3m``. Default value is None.
        :paramtype pod_connection_timeout: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "historic_urls": [
                        "str"  # Optional. A list of URLs to archived log files.
                    ],
                    "live_url": "str"  # Optional. A URL of the real-time live logs. This URL may
                      use either the ``https://`` or ``wss://`` protocols and will keep pushing live
                      logs as they become available.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_logs_request(
            app_id=app_id,
            deployment_id=deployment_id,
            component_name=component_name,
            follow=follow,
            type=type,
            pod_connection_timeout=pod_connection_timeout,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_logs_aggregate(
        self,
        app_id: str,
        deployment_id: str,
        *,
        follow: Optional[bool] = None,
        type: str = "UNSPECIFIED",
        pod_connection_timeout: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Aggregate Deployment Logs.

        Retrieve the logs of a past, in-progress, or active deployment. If a component name is
        specified, the logs will be limited to only that component. The response will include links to
        either real-time logs of an in-progress or active deployment or archived logs of a past
        deployment.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param deployment_id: The deployment ID. Required.
        :type deployment_id: str
        :keyword follow: Whether the logs should follow live updates. Default value is None.
        :paramtype follow: bool
        :keyword type: The type of logs to retrieve


         * BUILD: Build-time logs
         * DEPLOY: Deploy-time logs
         * RUN: Live run-time logs
         * RUN_RESTARTED: Logs of crashed/restarted instances during runtime. Known values are:
         "UNSPECIFIED", "BUILD", "DEPLOY", "RUN", and "RUN_RESTARTED". Default value is "UNSPECIFIED".
        :paramtype type: str
        :keyword pod_connection_timeout: An optional time duration to wait if the underlying component
         instance is not immediately available. Default: ``3m``. Default value is None.
        :paramtype pod_connection_timeout: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "historic_urls": [
                        "str"  # Optional. A list of URLs to archived log files.
                    ],
                    "live_url": "str"  # Optional. A URL of the real-time live logs. This URL may
                      use either the ``https://`` or ``wss://`` protocols and will keep pushing live
                      logs as they become available.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_logs_aggregate_request(
            app_id=app_id,
            deployment_id=deployment_id,
            follow=follow,
            type=type,
            pod_connection_timeout=pod_connection_timeout,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_exec(
        self, app_id: str, deployment_id: str, component_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Exec URL for Deployment.

        Returns a websocket URL that allows sending/receiving console input and output to a component
        of the specified deployment if one exists.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param deployment_id: The deployment ID. Required.
        :type deployment_id: str
        :param component_name: An optional component name. If set, logs will be limited to this
         component only. Required.
        :type component_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "url": "str"  # Optional. A websocket URL that allows sending/receiving
                      console input and receiving console output.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_exec_request(
            app_id=app_id,
            deployment_id=deployment_id,
            component_name=component_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_logs_active_deployment_aggregate(
        self,
        app_id: str,
        *,
        follow: Optional[bool] = None,
        type: str = "UNSPECIFIED",
        pod_connection_timeout: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Active Deployment Aggregate Logs.

        Retrieve the logs of the active deployment if one exists. The response will include links to
        either real-time logs of an in-progress or active deployment or archived logs of a past
        deployment. Note log_type=BUILD logs will return logs associated with the current active
        deployment (being served). To view build logs associated with in-progress build, the query must
        explicitly reference the deployment id.

        :param app_id: The app ID. Required.
        :type app_id: str
        :keyword follow: Whether the logs should follow live updates. Default value is None.
        :paramtype follow: bool
        :keyword type: The type of logs to retrieve


         * BUILD: Build-time logs
         * DEPLOY: Deploy-time logs
         * RUN: Live run-time logs
         * RUN_RESTARTED: Logs of crashed/restarted instances during runtime. Known values are:
         "UNSPECIFIED", "BUILD", "DEPLOY", "RUN", and "RUN_RESTARTED". Default value is "UNSPECIFIED".
        :paramtype type: str
        :keyword pod_connection_timeout: An optional time duration to wait if the underlying component
         instance is not immediately available. Default: ``3m``. Default value is None.
        :paramtype pod_connection_timeout: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "historic_urls": [
                        "str"  # Optional. A list of URLs to archived log files.
                    ],
                    "live_url": "str"  # Optional. A URL of the real-time live logs. This URL may
                      use either the ``https://`` or ``wss://`` protocols and will keep pushing live
                      logs as they become available.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_logs_active_deployment_aggregate_request(
            app_id=app_id,
            follow=follow,
            type=type,
            pod_connection_timeout=pod_connection_timeout,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_instance_sizes(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Instance Sizes.

        List all instance sizes for ``service``\\ , ``worker``\\ , and ``job`` components.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "discount_percent": 0.0,  # Optional.
                    "instance_sizes": [
                        {
                            "bandwidth_allowance_gib": "str",  # Optional. The bandwidth
                              allowance in GiB for the instance size.
                            "cpu_type": "UNSPECIFIED",  # Optional. Default value is
                              "UNSPECIFIED". * SHARED: Shared vCPU cores    * DEDICATED: Dedicated vCPU
                              cores. Known values are: "UNSPECIFIED", "SHARED", and "DEDICATED".
                            "cpus": "str",  # Optional. The number of allotted vCPU
                              cores.
                            "deprecation_intent": bool,  # Optional. Indicates if the
                              instance size is intended for deprecation.
                            "memory_bytes": "str",  # Optional. The allotted memory in
                              bytes.
                            "name": "str",  # Optional. A human-readable name of the
                              instance size.
                            "scalable": bool,  # Optional. Indicates if the instance size
                              can enable autoscaling.
                            "single_instance_only": bool,  # Optional. Indicates if the
                              instance size allows more than one instance.
                            "slug": "str",  # Optional. The slug of the instance size.
                            "tier_downgrade_to": "str",  # Optional. The slug of the
                              corresponding downgradable instance size on the lower tier.
                            "tier_slug": "str",  # Optional. The slug of the tier to
                              which this instance size belongs.
                            "tier_upgrade_to": "str",  # Optional. The slug of the
                              corresponding upgradable instance size on the higher tier.
                            "usd_per_month": "str",  # Optional. The cost of this
                              instance size in USD per month.
                            "usd_per_second": "str"  # Optional. The cost of this
                              instance size in USD per second.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_list_instance_sizes_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_instance_size(self, slug: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Instance Size.

        Retrieve information about a specific instance size for ``service``\\ , ``worker``\\ , and
        ``job`` components.

        :param slug: The slug of the instance size. Required.
        :type slug: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "instance_size": {
                        "bandwidth_allowance_gib": "str",  # Optional. The bandwidth
                          allowance in GiB for the instance size.
                        "cpu_type": "UNSPECIFIED",  # Optional. Default value is
                          "UNSPECIFIED". * SHARED: Shared vCPU cores    * DEDICATED: Dedicated vCPU
                          cores. Known values are: "UNSPECIFIED", "SHARED", and "DEDICATED".
                        "cpus": "str",  # Optional. The number of allotted vCPU cores.
                        "deprecation_intent": bool,  # Optional. Indicates if the instance
                          size is intended for deprecation.
                        "memory_bytes": "str",  # Optional. The allotted memory in bytes.
                        "name": "str",  # Optional. A human-readable name of the instance
                          size.
                        "scalable": bool,  # Optional. Indicates if the instance size can
                          enable autoscaling.
                        "single_instance_only": bool,  # Optional. Indicates if the instance
                          size allows more than one instance.
                        "slug": "str",  # Optional. The slug of the instance size.
                        "tier_downgrade_to": "str",  # Optional. The slug of the
                          corresponding downgradable instance size on the lower tier.
                        "tier_slug": "str",  # Optional. The slug of the tier to which this
                          instance size belongs.
                        "tier_upgrade_to": "str",  # Optional. The slug of the corresponding
                          upgradable instance size on the higher tier.
                        "usd_per_month": "str",  # Optional. The cost of this instance size
                          in USD per month.
                        "usd_per_second": "str"  # Optional. The cost of this instance size
                          in USD per second.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_instance_size_request(
            slug=slug,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_regions(self, **kwargs: Any) -> JSON:
        """List App Regions.

        List all regions supported by App Platform.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "regions": [
                        {
                            "continent": "str",  # Optional. The continent that this
                              region is in.
                            "data_centers": [
                                "str"  # Optional. Data centers that are in this
                                  region.
                            ],
                            "default": bool,  # Optional. Whether or not the region is
                              presented as the default.
                            "disabled": bool,  # Optional. Whether or not the region is
                              open for new apps.
                            "flag": "str",  # Optional. The flag of this region.
                            "label": "str",  # Optional. A human-readable name of the
                              region.
                            "reason": "str",  # Optional. Reason that this region is not
                              available.
                            "slug": "str"  # Optional. The slug form of the region name.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_list_regions_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def validate_app_spec(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Propose an App Spec.

        To propose and validate a spec for a new or existing app, send a POST request to the
        ``/v2/apps/propose`` endpoint. The request returns some information about the proposed app,
        including app cost and upgrade cost. If an existing app ID is specified, the app spec is
        treated as a proposed update to the existing app.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "app_id": "str"  # Optional. An optional ID of an existing app. If set, the
                      spec will be treated as a proposed update to the specified app. The existing app
                      is not modified using this method.
                }

                # response body for status code(s): 200
                response == {
                    "app_cost": 0,  # Optional. The monthly cost of the proposed app in USD.
                    "app_is_static": bool,  # Optional. Indicates whether the app is a static
                      app.
                    "app_name_available": bool,  # Optional. Indicates whether the app name is
                      available.
                    "app_name_suggestion": "str",  # Optional. The suggested name if the proposed
                      app name is unavailable.
                    "app_tier_downgrade_cost": 0,  # Optional. The monthly cost of the proposed
                      app in USD using the previous pricing plan tier. For example, if you propose an
                      app that uses the Professional tier, the ``app_tier_downgrade_cost`` field
                      displays the monthly cost of the app if it were to use the Basic tier. If the
                      proposed app already uses the lest expensive tier, the field is empty.
                    "existing_static_apps": "str",  # Optional. The maximum number of free static
                      apps the account can have. We will charge you for any additional static apps.
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    }
                }
        """

    @overload
    def validate_app_spec(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Propose an App Spec.

        To propose and validate a spec for a new or existing app, send a POST request to the
        ``/v2/apps/propose`` endpoint. The request returns some information about the proposed app,
        including app cost and upgrade cost. If an existing app ID is specified, the app spec is
        treated as a proposed update to the existing app.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app_cost": 0,  # Optional. The monthly cost of the proposed app in USD.
                    "app_is_static": bool,  # Optional. Indicates whether the app is a static
                      app.
                    "app_name_available": bool,  # Optional. Indicates whether the app name is
                      available.
                    "app_name_suggestion": "str",  # Optional. The suggested name if the proposed
                      app name is unavailable.
                    "app_tier_downgrade_cost": 0,  # Optional. The monthly cost of the proposed
                      app in USD using the previous pricing plan tier. For example, if you propose an
                      app that uses the Professional tier, the ``app_tier_downgrade_cost`` field
                      displays the monthly cost of the app if it were to use the Basic tier. If the
                      proposed app already uses the lest expensive tier, the field is empty.
                    "existing_static_apps": "str",  # Optional. The maximum number of free static
                      apps the account can have. We will charge you for any additional static apps.
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    }
                }
        """

    @distributed_trace
    def validate_app_spec(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Propose an App Spec.

        To propose and validate a spec for a new or existing app, send a POST request to the
        ``/v2/apps/propose`` endpoint. The request returns some information about the proposed app,
        including app cost and upgrade cost. If an existing app ID is specified, the app spec is
        treated as a proposed update to the existing app.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    },
                    "app_id": "str"  # Optional. An optional ID of an existing app. If set, the
                      spec will be treated as a proposed update to the specified app. The existing app
                      is not modified using this method.
                }

                # response body for status code(s): 200
                response == {
                    "app_cost": 0,  # Optional. The monthly cost of the proposed app in USD.
                    "app_is_static": bool,  # Optional. Indicates whether the app is a static
                      app.
                    "app_name_available": bool,  # Optional. Indicates whether the app name is
                      available.
                    "app_name_suggestion": "str",  # Optional. The suggested name if the proposed
                      app name is unavailable.
                    "app_tier_downgrade_cost": 0,  # Optional. The monthly cost of the proposed
                      app in USD using the previous pricing plan tier. For example, if you propose an
                      app that uses the Professional tier, the ``app_tier_downgrade_cost`` field
                      displays the monthly cost of the app if it were to use the Basic tier. If the
                      proposed app already uses the lest expensive tier, the field is empty.
                    "existing_static_apps": "str",  # Optional. The maximum number of free static
                      apps the account can have. We will charge you for any additional static apps.
                    "spec": {
                        "name": "str",  # The name of the app. Must be unique across all apps
                          in the same account. Required.
                        "databases": [
                            {
                                "name": "str",  # The database's name. The name must
                                  be unique across all components within the same app and cannot use
                                  capital letters. Required.
                                "cluster_name": "str",  # Optional. The name of the
                                  underlying DigitalOcean DBaaS cluster. This is required for
                                  production databases. For dev databases, if cluster_name is not set,
                                  a new cluster will be provisioned.
                                "db_name": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL database to configure.
                                "db_user": "str",  # Optional. The name of the MySQL
                                  or PostgreSQL user to configure.
                                "engine": "UNSET",  # Optional. Default value is
                                  "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis * MONGODB:
                                  MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known values are:
                                  "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA", and
                                  "OPENSEARCH".
                                "production": bool,  # Optional. Whether this is a
                                  production or dev database.
                                "version": "str"  # Optional. The version of the
                                  database engine.
                            }
                        ],
                        "domains": [
                            {
                                "domain": "str",  # The hostname for the domain.
                                  Required.
                                "minimum_tls_version": "str",  # Optional. The
                                  minimum version of TLS a client application can use to access
                                  resources for the domain.  Must be one of the following values
                                  wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values are:
                                  "1.2" and "1.3".
                                "type": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * DEFAULT: The default ``.ondigitalocean.app`` domain
                                  assigned to this app * PRIMARY: The primary domain for this app that
                                  is displayed as the default in the control panel, used in bindable
                                  environment variables, and any other places that reference an app's
                                  live URL. Only one domain may be set as primary. * ALIAS: A
                                  non-primary domain. Known values are: "UNSPECIFIED", "DEFAULT",
                                  "PRIMARY", and "ALIAS".
                                "wildcard": bool,  # Optional. Indicates whether the
                                  domain includes all sub-domains, in addition to the given domain.
                                "zone": "str"  # Optional. Optional. If the domain
                                  uses DigitalOcean DNS and you would like App Platform to
                                  automatically manage it for you, set this to the name of the domain
                                  on your account.  For example, If the domain you are adding is
                                  ``app.domain.com``"" , the zone could be ``domain.com``.
                            }
                        ],
                        "egress": {
                            "type": "AUTOASSIGN"  # Optional. Default value is
                              "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                              "DEDICATED_IP".
                        },
                        "functions": [
                            {
                                "name": "str",  # The name. Must be unique across all
                                  components within the same app. Required.
                                "alerts": [
                                    {
                                        "disabled": bool,  # Optional. Is the
                                          alert disabled?.
                                        "operator": "UNSPECIFIED_OPERATOR",
                                          # Optional. Default value is "UNSPECIFIED_OPERATOR". Known
                                          values are: "UNSPECIFIED_OPERATOR", "GREATER_THAN", and
                                          "LESS_THAN".
                                        "rule": "UNSPECIFIED_RULE",  #
                                          Optional. Default value is "UNSPECIFIED_RULE". Known values
                                          are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                          "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                          "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                          "FUNCTIONS_ACTIVATION_COUNT",
                                          "FUNCTIONS_AVERAGE_DURATION_MS",
                                          "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                          "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT",
                                          and "FUNCTIONS_GB_RATE_PER_SECOND".
                                        "value": 0.0,  # Optional. Threshold
                                          value for alert.
                                        "window": "UNSPECIFIED_WINDOW"  #
                                          Optional. Default value is "UNSPECIFIED_WINDOW". Known values
                                          are: "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                          "THIRTY_MINUTES", and "ONE_HOUR".
                                    }
                                ],
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "ingress": {
                            "rules": [
                                {
                                    "component": {
                                        "name": "str",  # The name of the
                                          component to route to. Required.
                                        "preserve_path_prefix": "str",  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``. Note: this is not applicable for Functions
                                          Components and is mutually exclusive with ``rewrite``.
                                        "rewrite": "str"  # Optional. An
                                          optional field that will rewrite the path of the component to
                                          be what is specified here. By default, the HTTP request path
                                          will be trimmed from the left when forwarded to the
                                          component. For example, a component with ``path=/api`` will
                                          have requests to ``/api/list`` trimmed to ``/list``. If you
                                          specified the rewrite to be ``/v1/``"" , requests to
                                          ``/api/list`` would be rewritten to ``/v1/list``. Note: this
                                          is mutually exclusive with ``preserve_path_prefix``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "match": {
                                        "authority": {
                                            "exact": "str"  # Required.
                                        },
                                        "path": {
                                            "prefix": "str"  #
                                              Prefix-based match. For example, ``/api`` will match
                                              ``/api``"" , ``/api/``"" , and any nested paths such as
                                              ``/api/v1/endpoint``. Required.
                                        }
                                    },
                                    "redirect": {
                                        "authority": "str",  # Optional. The
                                          authority/host to redirect to. This can be a hostname or IP
                                          address. Note: use ``port`` to set the port.
                                        "port": 0,  # Optional. The port to
                                          redirect to.
                                        "redirect_code": 0,  # Optional. The
                                          redirect code to use. Defaults to ``302``. Supported values
                                          are 300, 301, 302, 303, 304, 307, 308.
                                        "scheme": "str",  # Optional. The
                                          scheme to redirect to. Supported values are ``http`` or
                                          ``https``. Default: ``https``.
                                        "uri": "str"  # Optional. An optional
                                          URI path to redirect to. Note: if this is specified the whole
                                          URI of the original request will be overwritten to this
                                          value, irrespective of the original request URI being
                                          matched.
                                    }
                                }
                            ]
                        },
                        "jobs": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "kind": "UNSPECIFIED",  # Optional. Default value is
                                  "UNSPECIFIED". * UNSPECIFIED: Default job type, will auto-complete to
                                  POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job that runs before an
                                  app deployment. * POST_DEPLOY: Indicates a job that runs after an app
                                  deployment. * FAILED_DEPLOY: Indicates a job that runs after a
                                  component fails to deploy. Known values are: "UNSPECIFIED",
                                  "PRE_DEPLOY", "POST_DEPLOY", and "FAILED_DEPLOY".
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "maintenance": {
                            "archive": bool,  # Optional. Indicates whether the app
                              should be archived. Setting this to true implies that enabled is set to
                              true.
                            "enabled": bool,  # Optional. Indicates whether maintenance
                              mode should be enabled for the app.
                            "offline_page_url": "str"  # Optional. A custom offline page
                              to display when maintenance mode is enabled or the app is archived.
                        },
                        "region": "str",  # Optional. The slug form of the geographical
                          origin of the app. Default: ``nearest available``. Known values are: "ams",
                          "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and "syd".
                        "services": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "health_check": {
                                    "failure_threshold": 0,  # Optional. The
                                      number of failed health checks before considered unhealthy.
                                    "http_path": "str",  # Optional. The route
                                      path used for the HTTP health check ping. If not set, the HTTP
                                      health check will be disabled and a TCP health check used
                                      instead.
                                    "initial_delay_seconds": 0,  # Optional. The
                                      number of seconds to wait before beginning health checks.
                                    "period_seconds": 0,  # Optional. The number
                                      of seconds to wait between health checks.
                                    "port": 0,  # Optional. The port on which the
                                      health check will be performed. If not set, the health check will
                                      be performed on the component's http_port.
                                    "success_threshold": 0,  # Optional. The
                                      number of successful health checks before considered healthy.
                                    "timeout_seconds": 0  # Optional. The number
                                      of seconds after which the check times out.
                                },
                                "http_port": 0,  # Optional. The internal port on
                                  which this service's run command will listen. Default: 8080 If there
                                  is not an environment variable with the name ``PORT``"" , one will be
                                  automatically added with its value set to the value of this field.
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "internal_ports": [
                                    0  # Optional. The ports on which this
                                      service will listen for internal traffic.
                                ],
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "protocol": "str",  # Optional. The protocol which
                                  the service uses to serve traffic on the http_port.   * ``HTTP``"" :
                                  The app is serving the HTTP protocol. Default. * ``HTTP2``"" : The
                                  app is serving the HTTP/2 protocol. Currently, this needs to be
                                  implemented in the service by serving HTTP/2 cleartext (h2c). Known
                                  values are: "HTTP" and "HTTP2".
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "drain_seconds": 0,  # Optional. The number
                                      of seconds to wait between selecting a container instance for
                                      termination and issuing the TERM signal. Selecting a container
                                      instance for termination begins an asynchronous drain of new
                                      requests on upstream load-balancers. (Default 15).
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ],
                        "static_sites": [
                            {
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "catchall_document": "str",  # Optional. The name of
                                  the document to use as the fallback for any requests to documents
                                  that are not found when serving this static site. Only 1 of
                                  ``catchall_document`` or ``error_document`` can be set.
                                "cors": {
                                    "allow_credentials": bool,  # Optional.
                                      Whether browsers should expose the response to the client-side
                                      JavaScript code when the request"u2019s credentials mode is
                                      include. This configures the ``Access-Control-Allow-Credentials``
                                      header.
                                    "allow_headers": [
                                        "str"  # Optional. The set of allowed
                                          HTTP request headers. This configures the
                                          ``Access-Control-Allow-Headers`` header.
                                    ],
                                    "allow_methods": [
                                        "str"  # Optional. The set of allowed
                                          HTTP methods. This configures the
                                          ``Access-Control-Allow-Methods`` header.
                                    ],
                                    "allow_origins": [
                                        {
                                            "exact": "str",  # Optional.
                                              Exact string match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "prefix": "str",  # Optional.
                                              Prefix-based match. Only 1 of ``exact``"" , ``prefix``""
                                              , or ``regex`` must be set.
                                            "regex": "str"  # Optional.
                                              RE2 style regex-based match. Only 1 of ``exact``"" ,
                                              ``prefix``"" , or ``regex`` must be set. For more
                                              information about RE2 syntax, see:
                                              https://github.com/google/re2/wiki/Syntax.
                                        }
                                    ],
                                    "expose_headers": [
                                        "str"  # Optional. The set of HTTP
                                          response headers that browsers are allowed to access. This
                                          configures the ``Access-Control-Expose-Headers`` header.
                                    ],
                                    "max_age": "str"  # Optional. An optional
                                      duration specifying how long browsers can cache the results of a
                                      preflight request. This configures the ``Access-Control-Max-Age``
                                      header.
                                },
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "error_document": "404.html",  # Optional. Default
                                  value is "404.html". The name of the error document to use when
                                  serving this static site. Default: 404.html. If no such file exists
                                  within the built assets, App Platform will supply one.
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "index_document": "index.html",  # Optional. Default
                                  value is "index.html". The name of the index document to use when
                                  serving this static site. Default: index.html.
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "output_dir": "str",  # Optional. An optional path to
                                  where the built assets will be located, relative to the build
                                  context. If not set, App Platform will automatically scan for these
                                  directory names: ``_static``"" , ``dist``"" , ``public``"" ,
                                  ``build``.
                                "routes": [
                                    {
                                        "path": "str",  # Optional.
                                          (Deprecated - Use Ingress Rules instead). An HTTP path
                                          prefix. Paths must start with / and must be unique across all
                                          components within an app.
                                        "preserve_path_prefix": bool  #
                                          Optional. An optional flag to preserve the path that is
                                          forwarded to the backend service. By default, the HTTP
                                          request path will be trimmed from the left when forwarded to
                                          the component. For example, a component with ``path=/api``
                                          will have requests to ``/api/list`` trimmed to ``/list``. If
                                          this value is ``true``"" , the path will remain
                                          ``/api/list``.
                                    }
                                ],
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str"  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                            }
                        ],
                        "workers": [
                            {
                                "autoscaling": {
                                    "max_instance_count": 0,  # Optional. The
                                      maximum amount of instances for this component. Must be more than
                                      min_instance_count.
                                    "metrics": {
                                        "cpu": {
                                            "percent": 80  # Optional.
                                              Default value is 80. The average target CPU utilization
                                              for the component.
                                        }
                                    },
                                    "min_instance_count": 0  # Optional. The
                                      minimum amount of instances for this component. Must be less than
                                      max_instance_count.
                                },
                                "bitbucket": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "build_command": "str",  # Optional. An optional
                                  build command to run while building this component from source.
                                "dockerfile_path": "str",  # Optional. The path to
                                  the Dockerfile relative to the root of the repo. If set, it will be
                                  used to build this component. Otherwise, App Platform will attempt to
                                  build it using buildpacks.
                                "environment_slug": "str",  # Optional. An
                                  environment slug describing the type of this app. For a full list,
                                  please refer to `the product documentation
                                  <https://docs.digitalocean.com/products/app-platform/>`_.
                                "envs": [
                                    {
                                        "key": "str",  # The variable name.
                                          Required.
                                        "scope": "RUN_AND_BUILD_TIME",  #
                                          Optional. Default value is "RUN_AND_BUILD_TIME". * RUN_TIME:
                                          Made available only at run-time * BUILD_TIME: Made available
                                          only at build-time * RUN_AND_BUILD_TIME: Made available at
                                          both build and run-time. Known values are: "UNSET",
                                          "RUN_TIME", "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                        "type": "GENERAL",  # Optional.
                                          Default value is "GENERAL". * GENERAL: A plain-text
                                          environment variable * SECRET: A secret encrypted environment
                                          variable. Known values are: "GENERAL" and "SECRET".
                                        "value": "str"  # Optional. The
                                          value. If the type is ``SECRET``"" , the value will be
                                          encrypted on first submission. On following submissions, the
                                          encrypted value should be used.
                                    }
                                ],
                                "git": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "repo_clone_url": "str"  # Optional. The
                                      clone URL of the repo. Example:
                                      ``https://github.com/digitalocean/sample-golang.git``.
                                },
                                "github": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "gitlab": {
                                    "branch": "str",  # Optional. The name of the
                                      branch to use.
                                    "deploy_on_push": bool,  # Optional. Whether
                                      to automatically deploy new commits made to the repo.
                                    "repo": "str"  # Optional. The name of the
                                      repo in the format owner/repo. Example:
                                      ``digitalocean/sample-golang``.
                                },
                                "image": {
                                    "deploy_on_push": {
                                        "enabled": bool  # Optional. Whether
                                          to automatically deploy new images. Can only be used for
                                          images hosted in DOCR and can only be used with an image tag,
                                          not a specific digest.
                                    },
                                    "digest": "str",  # Optional. The image
                                      digest. Cannot be specified if tag is provided.
                                    "registry": "str",  # Optional. The registry
                                      name. Must be left empty for the ``DOCR`` registry type.
                                    "registry_credentials": "str",  # Optional.
                                      The credentials to be able to pull the image. The value will be
                                      encrypted on first submission. On following submissions, the
                                      encrypted value should be used.   * "$username:$access_token" for
                                      registries of type ``DOCKER_HUB``. * "$username:$access_token"
                                      for registries of type ``GHCR``.
                                    "registry_type": "str",  # Optional. *
                                      DOCKER_HUB: The DockerHub container registry type. * DOCR: The
                                      DigitalOcean container registry type. * GHCR: The Github
                                      container registry type. Known values are: "DOCKER_HUB", "DOCR",
                                      and "GHCR".
                                    "repository": "str",  # Optional. The
                                      repository name.
                                    "tag": "latest"  # Optional. Default value is
                                      "latest". The repository tag. Defaults to ``latest`` if not
                                      provided and no digest is provided. Cannot be specified if digest
                                      is provided.
                                },
                                "instance_count": 1,  # Optional. Default value is 1.
                                  The amount of instances that this component should be scaled to.
                                  Default: 1. Must not be set if autoscaling is used.
                                "instance_size_slug": {},
                                "log_destinations": [
                                    {
                                        "name": "str",  # Required.
                                        "datadog": {
                                            "api_key": "str",  # Datadog
                                              API key. Required.
                                            "endpoint": "str"  #
                                              Optional. Datadog HTTP log intake endpoint.
                                        },
                                        "logtail": {
                                            "token": "str"  # Optional.
                                              Logtail token.
                                        },
                                        "open_search": {
                                            "basic_auth": {
                                                "password": {},  #
                                                  Optional. Password for user defined in User. Is
                                                  required when ``endpoint`` is set. Cannot be set if
                                                  using a DigitalOcean DBaaS OpenSearch cluster.
                                                "user": "str"  #
                                                  Optional. Username to authenticate with. Only
                                                  required when ``endpoint`` is set. Defaults to
                                                  ``doadmin`` when ``cluster_name`` is set.
                                            },
                                            "cluster_name": "str",  #
                                              Optional. The name of a DigitalOcean DBaaS OpenSearch
                                              cluster to use as a log forwarding destination. Cannot be
                                              specified if ``endpoint`` is also specified.
                                            "endpoint": "str",  #
                                              Optional. OpenSearch API Endpoint. Only HTTPS is
                                              supported. Format: https://:code:`<host>`::code:`<port>`.
                                              Cannot be specified if ``cluster_name`` is also
                                              specified.
                                            "index_name": "logs"  #
                                              Optional. Default value is "logs". The index name to use
                                              for the logs. If not set, the default index name is
                                              "logs".
                                        },
                                        "papertrail": {
                                            "endpoint": "str"  #
                                              Papertrail syslog endpoint. Required.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. The name. Must be unique
                                  across all components within the same app.
                                "run_command": "str",  # Optional. An optional run
                                  command to override the component's default.
                                "source_dir": "str",  # Optional. An optional path to
                                  the working directory to use for the build. For Dockerfile builds,
                                  this will be used as the build context. Must be relative to the root
                                  of the repo.
                                "termination": {
                                    "grace_period_seconds": 0  # Optional. The
                                      number of seconds to wait between sending a TERM signal to a
                                      container and issuing a KILL which causes immediate shutdown.
                                      (Default 120).
                                }
                            }
                        ]
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_validate_app_spec_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_alerts(self, app_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List all app alerts.

        List alerts associated to the app and any components. This includes configuration information
        about the alerts including emails, slack webhooks, and triggering events or conditions.

        :param app_id: The app ID. Required.
        :type app_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "alerts": [
                        {
                            "component_name": "str",  # Optional. Name of component the
                              alert belongs to.
                            "emails": [
                                ""  # Optional. Default value is "". Emails for
                                  alerts to go to.
                            ],
                            "id": "str",  # Optional. The ID of the alert.
                            "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN".
                              Known values are: "UNKNOWN", "PENDING", "CONFIGURING", "ACTIVE", and
                              "ERROR".
                            "progress": {
                                "steps": [
                                    {
                                        "ended_at": "2020-02-20 00:00:00",  #
                                          Optional. The start time of this step.
                                        "name": "str",  # Optional. The name
                                          of this step.
                                        "reason": {
                                            "code": "str",  # Optional.
                                              The error code.
                                            "message": "str"  # Optional.
                                              The error message.
                                        },
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. The start time of this step.
                                        "status": "UNKNOWN"  # Optional.
                                          Default value is "UNKNOWN". Known values are: "UNKNOWN",
                                          "PENDING", "RUNNING", "ERROR", and "SUCCESS".
                                    }
                                ]
                            },
                            "slack_webhooks": [
                                {
                                    "channel": "str",  # Optional. Name of the
                                      Slack Webhook Channel.
                                    "url": "str"  # Optional. URL of the Slack
                                      webhook.
                                }
                            ],
                            "spec": {
                                "disabled": bool,  # Optional. Is the alert
                                  disabled?.
                                "operator": "UNSPECIFIED_OPERATOR",  # Optional.
                                  Default value is "UNSPECIFIED_OPERATOR". Known values are:
                                  "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                "rule": "UNSPECIFIED_RULE",  # Optional. Default
                                  value is "UNSPECIFIED_RULE". Known values are: "UNSPECIFIED_RULE",
                                  "CPU_UTILIZATION", "MEM_UTILIZATION", "RESTART_COUNT",
                                  "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE", "DOMAIN_FAILED",
                                  "DOMAIN_LIVE", "FUNCTIONS_ACTIVATION_COUNT",
                                  "FUNCTIONS_AVERAGE_DURATION_MS", "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                  "FUNCTIONS_AVERAGE_WAIT_TIME_MS", "FUNCTIONS_ERROR_COUNT", and
                                  "FUNCTIONS_GB_RATE_PER_SECOND".
                                "value": 0.0,  # Optional. Threshold value for alert.
                                "window": "UNSPECIFIED_WINDOW"  # Optional. Default
                                  value is "UNSPECIFIED_WINDOW". Known values are:
                                  "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                  "THIRTY_MINUTES", and "ONE_HOUR".
                            }
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_list_alerts_request(
            app_id=app_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def assign_alert_destinations(
        self,
        app_id: str,
        alert_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update destinations for alerts.

        Updates the emails and slack webhook destinations for app alerts. Emails must be associated to
        a user with access to the app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param alert_id: The alert ID. Required.
        :type alert_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "emails": [
                        ""  # Optional. Default value is "".
                    ],
                    "slack_webhooks": [
                        {
                            "channel": "str",  # Optional. Name of the Slack Webhook
                              Channel.
                            "url": "str"  # Optional. URL of the Slack webhook.
                        }
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "component_name": "str",  # Optional. Name of component the alert
                          belongs to.
                        "emails": [
                            ""  # Optional. Default value is "". Emails for alerts to go
                              to.
                        ],
                        "id": "str",  # Optional. The ID of the alert.
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING", "CONFIGURING", "ACTIVE", and "ERROR".
                        "progress": {
                            "steps": [
                                {
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN"  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                }
                            ]
                        },
                        "slack_webhooks": [
                            {
                                "channel": "str",  # Optional. Name of the Slack
                                  Webhook Channel.
                                "url": "str"  # Optional. URL of the Slack webhook.
                            }
                        ],
                        "spec": {
                            "disabled": bool,  # Optional. Is the alert disabled?.
                            "operator": "UNSPECIFIED_OPERATOR",  # Optional. Default
                              value is "UNSPECIFIED_OPERATOR". Known values are:
                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                            "rule": "UNSPECIFIED_RULE",  # Optional. Default value is
                              "UNSPECIFIED_RULE". Known values are: "UNSPECIFIED_RULE",
                              "CPU_UTILIZATION", "MEM_UTILIZATION", "RESTART_COUNT",
                              "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                              "FUNCTIONS_ACTIVATION_COUNT", "FUNCTIONS_AVERAGE_DURATION_MS",
                              "FUNCTIONS_ERROR_RATE_PER_MINUTE", "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                              "FUNCTIONS_ERROR_COUNT", and "FUNCTIONS_GB_RATE_PER_SECOND".
                            "value": 0.0,  # Optional. Threshold value for alert.
                            "window": "UNSPECIFIED_WINDOW"  # Optional. Default value is
                              "UNSPECIFIED_WINDOW". Known values are: "UNSPECIFIED_WINDOW",
                              "FIVE_MINUTES", "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def assign_alert_destinations(
        self,
        app_id: str,
        alert_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update destinations for alerts.

        Updates the emails and slack webhook destinations for app alerts. Emails must be associated to
        a user with access to the app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param alert_id: The alert ID. Required.
        :type alert_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "component_name": "str",  # Optional. Name of component the alert
                          belongs to.
                        "emails": [
                            ""  # Optional. Default value is "". Emails for alerts to go
                              to.
                        ],
                        "id": "str",  # Optional. The ID of the alert.
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING", "CONFIGURING", "ACTIVE", and "ERROR".
                        "progress": {
                            "steps": [
                                {
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN"  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                }
                            ]
                        },
                        "slack_webhooks": [
                            {
                                "channel": "str",  # Optional. Name of the Slack
                                  Webhook Channel.
                                "url": "str"  # Optional. URL of the Slack webhook.
                            }
                        ],
                        "spec": {
                            "disabled": bool,  # Optional. Is the alert disabled?.
                            "operator": "UNSPECIFIED_OPERATOR",  # Optional. Default
                              value is "UNSPECIFIED_OPERATOR". Known values are:
                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                            "rule": "UNSPECIFIED_RULE",  # Optional. Default value is
                              "UNSPECIFIED_RULE". Known values are: "UNSPECIFIED_RULE",
                              "CPU_UTILIZATION", "MEM_UTILIZATION", "RESTART_COUNT",
                              "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                              "FUNCTIONS_ACTIVATION_COUNT", "FUNCTIONS_AVERAGE_DURATION_MS",
                              "FUNCTIONS_ERROR_RATE_PER_MINUTE", "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                              "FUNCTIONS_ERROR_COUNT", and "FUNCTIONS_GB_RATE_PER_SECOND".
                            "value": 0.0,  # Optional. Threshold value for alert.
                            "window": "UNSPECIFIED_WINDOW"  # Optional. Default value is
                              "UNSPECIFIED_WINDOW". Known values are: "UNSPECIFIED_WINDOW",
                              "FIVE_MINUTES", "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def assign_alert_destinations(
        self, app_id: str, alert_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update destinations for alerts.

        Updates the emails and slack webhook destinations for app alerts. Emails must be associated to
        a user with access to the app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param alert_id: The alert ID. Required.
        :type alert_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "emails": [
                        ""  # Optional. Default value is "".
                    ],
                    "slack_webhooks": [
                        {
                            "channel": "str",  # Optional. Name of the Slack Webhook
                              Channel.
                            "url": "str"  # Optional. URL of the Slack webhook.
                        }
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "component_name": "str",  # Optional. Name of component the alert
                          belongs to.
                        "emails": [
                            ""  # Optional. Default value is "". Emails for alerts to go
                              to.
                        ],
                        "id": "str",  # Optional. The ID of the alert.
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING", "CONFIGURING", "ACTIVE", and "ERROR".
                        "progress": {
                            "steps": [
                                {
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN"  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                }
                            ]
                        },
                        "slack_webhooks": [
                            {
                                "channel": "str",  # Optional. Name of the Slack
                                  Webhook Channel.
                                "url": "str"  # Optional. URL of the Slack webhook.
                            }
                        ],
                        "spec": {
                            "disabled": bool,  # Optional. Is the alert disabled?.
                            "operator": "UNSPECIFIED_OPERATOR",  # Optional. Default
                              value is "UNSPECIFIED_OPERATOR". Known values are:
                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                            "rule": "UNSPECIFIED_RULE",  # Optional. Default value is
                              "UNSPECIFIED_RULE". Known values are: "UNSPECIFIED_RULE",
                              "CPU_UTILIZATION", "MEM_UTILIZATION", "RESTART_COUNT",
                              "DEPLOYMENT_FAILED", "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                              "FUNCTIONS_ACTIVATION_COUNT", "FUNCTIONS_AVERAGE_DURATION_MS",
                              "FUNCTIONS_ERROR_RATE_PER_MINUTE", "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                              "FUNCTIONS_ERROR_COUNT", and "FUNCTIONS_GB_RATE_PER_SECOND".
                            "value": 0.0,  # Optional. Threshold value for alert.
                            "window": "UNSPECIFIED_WINDOW"  # Optional. Default value is
                              "UNSPECIFIED_WINDOW". Known values are: "UNSPECIFIED_WINDOW",
                              "FIVE_MINUTES", "TEN_MINUTES", "THIRTY_MINUTES", and "ONE_HOUR".
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_assign_alert_destinations_request(
            app_id=app_id,
            alert_id=alert_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_rollback(
        self,
        app_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Rollback App.

        Rollback an app to a previous deployment. A new deployment will be created to perform the
        rollback.
        The app will be pinned to the rollback deployment preventing any new deployments from being
        created,
        either manually or through Auto Deploy on Push webhooks. To resume deployments, the rollback
        must be
        either committed or reverted.

        It is recommended to use the Validate App Rollback endpoint to double check if the rollback is
        valid and if there are any warnings.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "deployment_id": "str",  # Optional. The ID of the deployment to rollback to.
                    "skip_pin": bool  # Optional. Whether to skip pinning the rollback
                      deployment. If false, the rollback deployment will be pinned and any new
                      deployments including Auto Deploy on Push hooks will be disabled until the
                      rollback is either manually committed or reverted via the CommitAppRollback or
                      RevertAppRollback endpoints respectively. If true, the rollback will be
                      immediately committed and the app will remain unpinned.
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_rollback(
        self,
        app_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Rollback App.

        Rollback an app to a previous deployment. A new deployment will be created to perform the
        rollback.
        The app will be pinned to the rollback deployment preventing any new deployments from being
        created,
        either manually or through Auto Deploy on Push webhooks. To resume deployments, the rollback
        must be
        either committed or reverted.

        It is recommended to use the Validate App Rollback endpoint to double check if the rollback is
        valid and if there are any warnings.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_rollback(
        self, app_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Rollback App.

        Rollback an app to a previous deployment. A new deployment will be created to perform the
        rollback.
        The app will be pinned to the rollback deployment preventing any new deployments from being
        created,
        either manually or through Auto Deploy on Push webhooks. To resume deployments, the rollback
        must be
        either committed or reverted.

        It is recommended to use the Validate App Rollback endpoint to double check if the rollback is
        valid and if there are any warnings.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "deployment_id": "str",  # Optional. The ID of the deployment to rollback to.
                    "skip_pin": bool  # Optional. Whether to skip pinning the rollback
                      deployment. If false, the rollback deployment will be pinned and any new
                      deployments including Auto Deploy on Push hooks will be disabled until the
                      rollback is either manually committed or reverted via the CommitAppRollback or
                      RevertAppRollback endpoints respectively. If true, the rollback will be
                      immediately committed and the app will remain unpinned.
                }

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_create_rollback_request(
            app_id=app_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def validate_rollback(
        self,
        app_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Validate App Rollback.

        Check whether an app can be rolled back to a specific deployment. This endpoint can also be
        used
        to check if there are any warnings or validation conditions that will cause the rollback to
        proceed
        under unideal circumstances. For example, if a component must be rebuilt as part of the
        rollback
        causing it to take longer than usual.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "deployment_id": "str",  # Optional. The ID of the deployment to rollback to.
                    "skip_pin": bool  # Optional. Whether to skip pinning the rollback
                      deployment. If false, the rollback deployment will be pinned and any new
                      deployments including Auto Deploy on Push hooks will be disabled until the
                      rollback is either manually committed or reverted via the CommitAppRollback or
                      RevertAppRollback endpoints respectively. If true, the rollback will be
                      immediately committed and the app will remain unpinned.
                }

                # response body for status code(s): 200
                response == {
                    "error": {
                        "code": "str",  # Optional. A code identifier that represents the
                          failing condition.  Failing conditions:   * ``incompatible_phase`` -
                          indicates that the deployment's phase is not suitable for rollback. *
                          ``incompatible_result`` - indicates that the deployment's result is not
                          suitable for rollback. * ``exceeded_revision_limit`` - indicates that the app
                          has exceeded the rollback revision limits for its tier. * ``app_pinned`` -
                          indicates that there is already a rollback in progress and the app is pinned.
                          * ``database_config_conflict`` - indicates that the deployment's database
                          config is different than the current config. * ``region_conflict`` -
                          indicates that the deployment's region differs from the current app region.
                          Warning conditions:   * ``static_site_requires_rebuild`` - indicates that the
                          deployment contains at least one static site that will require a rebuild. *
                          ``image_source_missing_digest`` - indicates that the deployment contains at
                          least one component with an image source that is missing a digest. Known
                          values are: "incompatible_phase", "incompatible_result",
                          "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                          "region_conflict", "static_site_requires_rebuild", and
                          "image_source_missing_digest".
                        "components": [
                            "str"  # Optional.
                        ],
                        "message": "str"  # Optional. A human-readable message describing the
                          failing condition.
                    },
                    "valid": bool,  # Optional. Indicates whether the app can be rolled back to
                      the specified deployment.
                    "warnings": [
                        {
                            "code": "str",  # Optional. A code identifier that represents
                              the failing condition.  Failing conditions:   * ``incompatible_phase`` -
                              indicates that the deployment's phase is not suitable for rollback. *
                              ``incompatible_result`` - indicates that the deployment's result is not
                              suitable for rollback. * ``exceeded_revision_limit`` - indicates that the
                              app has exceeded the rollback revision limits for its tier. *
                              ``app_pinned`` - indicates that there is already a rollback in progress
                              and the app is pinned. * ``database_config_conflict`` - indicates that
                              the deployment's database config is different than the current config. *
                              ``region_conflict`` - indicates that the deployment's region differs from
                              the current app region.  Warning conditions:   *
                              ``static_site_requires_rebuild`` - indicates that the deployment contains
                              at least one static site that will require a rebuild. *
                              ``image_source_missing_digest`` - indicates that the deployment contains
                              at least one component with an image source that is missing a digest.
                              Known values are: "incompatible_phase", "incompatible_result",
                              "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                              "region_conflict", "static_site_requires_rebuild", and
                              "image_source_missing_digest".
                            "components": [
                                "str"  # Optional. Contains a list of warnings that
                                  may cause the rollback to run under unideal circumstances.
                            ],
                            "message": "str"  # Optional. A human-readable message
                              describing the failing condition.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def validate_rollback(
        self,
        app_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Validate App Rollback.

        Check whether an app can be rolled back to a specific deployment. This endpoint can also be
        used
        to check if there are any warnings or validation conditions that will cause the rollback to
        proceed
        under unideal circumstances. For example, if a component must be rebuilt as part of the
        rollback
        causing it to take longer than usual.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "error": {
                        "code": "str",  # Optional. A code identifier that represents the
                          failing condition.  Failing conditions:   * ``incompatible_phase`` -
                          indicates that the deployment's phase is not suitable for rollback. *
                          ``incompatible_result`` - indicates that the deployment's result is not
                          suitable for rollback. * ``exceeded_revision_limit`` - indicates that the app
                          has exceeded the rollback revision limits for its tier. * ``app_pinned`` -
                          indicates that there is already a rollback in progress and the app is pinned.
                          * ``database_config_conflict`` - indicates that the deployment's database
                          config is different than the current config. * ``region_conflict`` -
                          indicates that the deployment's region differs from the current app region.
                          Warning conditions:   * ``static_site_requires_rebuild`` - indicates that the
                          deployment contains at least one static site that will require a rebuild. *
                          ``image_source_missing_digest`` - indicates that the deployment contains at
                          least one component with an image source that is missing a digest. Known
                          values are: "incompatible_phase", "incompatible_result",
                          "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                          "region_conflict", "static_site_requires_rebuild", and
                          "image_source_missing_digest".
                        "components": [
                            "str"  # Optional.
                        ],
                        "message": "str"  # Optional. A human-readable message describing the
                          failing condition.
                    },
                    "valid": bool,  # Optional. Indicates whether the app can be rolled back to
                      the specified deployment.
                    "warnings": [
                        {
                            "code": "str",  # Optional. A code identifier that represents
                              the failing condition.  Failing conditions:   * ``incompatible_phase`` -
                              indicates that the deployment's phase is not suitable for rollback. *
                              ``incompatible_result`` - indicates that the deployment's result is not
                              suitable for rollback. * ``exceeded_revision_limit`` - indicates that the
                              app has exceeded the rollback revision limits for its tier. *
                              ``app_pinned`` - indicates that there is already a rollback in progress
                              and the app is pinned. * ``database_config_conflict`` - indicates that
                              the deployment's database config is different than the current config. *
                              ``region_conflict`` - indicates that the deployment's region differs from
                              the current app region.  Warning conditions:   *
                              ``static_site_requires_rebuild`` - indicates that the deployment contains
                              at least one static site that will require a rebuild. *
                              ``image_source_missing_digest`` - indicates that the deployment contains
                              at least one component with an image source that is missing a digest.
                              Known values are: "incompatible_phase", "incompatible_result",
                              "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                              "region_conflict", "static_site_requires_rebuild", and
                              "image_source_missing_digest".
                            "components": [
                                "str"  # Optional. Contains a list of warnings that
                                  may cause the rollback to run under unideal circumstances.
                            ],
                            "message": "str"  # Optional. A human-readable message
                              describing the failing condition.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def validate_rollback(
        self, app_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Validate App Rollback.

        Check whether an app can be rolled back to a specific deployment. This endpoint can also be
        used
        to check if there are any warnings or validation conditions that will cause the rollback to
        proceed
        under unideal circumstances. For example, if a component must be rebuilt as part of the
        rollback
        causing it to take longer than usual.

        :param app_id: The app ID. Required.
        :type app_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "deployment_id": "str",  # Optional. The ID of the deployment to rollback to.
                    "skip_pin": bool  # Optional. Whether to skip pinning the rollback
                      deployment. If false, the rollback deployment will be pinned and any new
                      deployments including Auto Deploy on Push hooks will be disabled until the
                      rollback is either manually committed or reverted via the CommitAppRollback or
                      RevertAppRollback endpoints respectively. If true, the rollback will be
                      immediately committed and the app will remain unpinned.
                }

                # response body for status code(s): 200
                response == {
                    "error": {
                        "code": "str",  # Optional. A code identifier that represents the
                          failing condition.  Failing conditions:   * ``incompatible_phase`` -
                          indicates that the deployment's phase is not suitable for rollback. *
                          ``incompatible_result`` - indicates that the deployment's result is not
                          suitable for rollback. * ``exceeded_revision_limit`` - indicates that the app
                          has exceeded the rollback revision limits for its tier. * ``app_pinned`` -
                          indicates that there is already a rollback in progress and the app is pinned.
                          * ``database_config_conflict`` - indicates that the deployment's database
                          config is different than the current config. * ``region_conflict`` -
                          indicates that the deployment's region differs from the current app region.
                          Warning conditions:   * ``static_site_requires_rebuild`` - indicates that the
                          deployment contains at least one static site that will require a rebuild. *
                          ``image_source_missing_digest`` - indicates that the deployment contains at
                          least one component with an image source that is missing a digest. Known
                          values are: "incompatible_phase", "incompatible_result",
                          "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                          "region_conflict", "static_site_requires_rebuild", and
                          "image_source_missing_digest".
                        "components": [
                            "str"  # Optional.
                        ],
                        "message": "str"  # Optional. A human-readable message describing the
                          failing condition.
                    },
                    "valid": bool,  # Optional. Indicates whether the app can be rolled back to
                      the specified deployment.
                    "warnings": [
                        {
                            "code": "str",  # Optional. A code identifier that represents
                              the failing condition.  Failing conditions:   * ``incompatible_phase`` -
                              indicates that the deployment's phase is not suitable for rollback. *
                              ``incompatible_result`` - indicates that the deployment's result is not
                              suitable for rollback. * ``exceeded_revision_limit`` - indicates that the
                              app has exceeded the rollback revision limits for its tier. *
                              ``app_pinned`` - indicates that there is already a rollback in progress
                              and the app is pinned. * ``database_config_conflict`` - indicates that
                              the deployment's database config is different than the current config. *
                              ``region_conflict`` - indicates that the deployment's region differs from
                              the current app region.  Warning conditions:   *
                              ``static_site_requires_rebuild`` - indicates that the deployment contains
                              at least one static site that will require a rebuild. *
                              ``image_source_missing_digest`` - indicates that the deployment contains
                              at least one component with an image source that is missing a digest.
                              Known values are: "incompatible_phase", "incompatible_result",
                              "exceeded_revision_limit", "app_pinned", "database_config_conflict",
                              "region_conflict", "static_site_requires_rebuild", and
                              "image_source_missing_digest".
                            "components": [
                                "str"  # Optional. Contains a list of warnings that
                                  may cause the rollback to run under unideal circumstances.
                            ],
                            "message": "str"  # Optional. A human-readable message
                              describing the failing condition.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_validate_rollback_request(
            app_id=app_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def commit_rollback(self, app_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Commit App Rollback.

        Commit an app rollback. This action permanently applies the rollback and unpins the app to
        resume new deployments.

        :param app_id: The app ID. Required.
        :type app_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_apps_commit_rollback_request(
            app_id=app_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def revert_rollback(self, app_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Revert App Rollback.

        Revert an app rollback. This action reverts the active rollback by creating a new deployment
        from the
        latest app spec prior to the rollback and unpins the app to resume new deployments.

        :param app_id: The app ID. Required.
        :type app_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "deployment": {
                        "cause": "str",  # Optional. What caused this deployment to be
                          created.
                        "cloned_from": "str",  # Optional. The ID of a previous deployment
                          that this deployment was cloned from.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The creation time
                          of the deployment.
                        "functions": [
                            {
                                "name": "str",  # Optional. The name of this
                                  functions component.
                                "namespace": "str",  # Optional. The namespace where
                                  the functions are deployed.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this functions
                                  component.
                            }
                        ],
                        "id": "str",  # Optional. The ID of the deployment.
                        "jobs": [
                            {
                                "name": "str",  # Optional. The name of this job.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this job.
                            }
                        ],
                        "phase": "UNKNOWN",  # Optional. Default value is "UNKNOWN". Known
                          values are: "UNKNOWN", "PENDING_BUILD", "BUILDING", "PENDING_DEPLOY",
                          "DEPLOYING", "ACTIVE", "SUPERSEDED", "ERROR", and "CANCELED".
                        "phase_last_updated_at": "2020-02-20 00:00:00",  # Optional. When the
                          deployment phase was last updated.
                        "progress": {
                            "error_steps": 0,  # Optional. Number of unsuccessful steps.
                            "pending_steps": 0,  # Optional. Number of pending steps.
                            "running_steps": 0,  # Optional. Number of currently running
                              steps.
                            "steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "success_steps": 0,  # Optional. Number of successful steps.
                            "summary_steps": [
                                {
                                    "component_name": "str",  # Optional. The
                                      component name that this step is associated with.
                                    "ended_at": "2020-02-20 00:00:00",  #
                                      Optional. The end time of this step.
                                    "message_base": "str",  # Optional. The base
                                      of a human-readable description of the step intended to be
                                      combined with the component name for presentation. For example:
                                      ``message_base`` = "Building service" ``component_name`` = "api".
                                    "name": "str",  # Optional. The name of this
                                      step.
                                    "reason": {
                                        "code": "str",  # Optional. The error
                                          code.
                                        "message": "str"  # Optional. The
                                          error message.
                                    },
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. The start time of this step.
                                    "status": "UNKNOWN",  # Optional. Default
                                      value is "UNKNOWN". Known values are: "UNKNOWN", "PENDING",
                                      "RUNNING", "ERROR", and "SUCCESS".
                                    "steps": [
                                        {}  # Optional. Child steps of this
                                          step.
                                    ]
                                }
                            ],
                            "total_steps": 0  # Optional. Total number of steps.
                        },
                        "services": [
                            {
                                "name": "str",  # Optional. The name of this service.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this service.
                            }
                        ],
                        "spec": {
                            "name": "str",  # The name of the app. Must be unique across
                              all apps in the same account. Required.
                            "databases": [
                                {
                                    "name": "str",  # The database's name. The
                                      name must be unique across all components within the same app and
                                      cannot use capital letters. Required.
                                    "cluster_name": "str",  # Optional. The name
                                      of the underlying DigitalOcean DBaaS cluster. This is required
                                      for production databases. For dev databases, if cluster_name is
                                      not set, a new cluster will be provisioned.
                                    "db_name": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL database to configure.
                                    "db_user": "str",  # Optional. The name of
                                      the MySQL or PostgreSQL user to configure.
                                    "engine": "UNSET",  # Optional. Default value
                                      is "UNSET". * MYSQL: MySQL * PG: PostgreSQL * REDIS: Redis *
                                      MONGODB: MongoDB * KAFKA: Kafka * OPENSEARCH: OpenSearch. Known
                                      values are: "UNSET", "MYSQL", "PG", "REDIS", "MONGODB", "KAFKA",
                                      and "OPENSEARCH".
                                    "production": bool,  # Optional. Whether this
                                      is a production or dev database.
                                    "version": "str"  # Optional. The version of
                                      the database engine.
                                }
                            ],
                            "domains": [
                                {
                                    "domain": "str",  # The hostname for the
                                      domain. Required.
                                    "minimum_tls_version": "str",  # Optional.
                                      The minimum version of TLS a client application can use to access
                                      resources for the domain.  Must be one of the following values
                                      wrapped within quotations: ``"1.2"`` or ``"1.3"``. Known values
                                      are: "1.2" and "1.3".
                                    "type": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * DEFAULT: The default
                                      ``.ondigitalocean.app`` domain assigned to this app * PRIMARY:
                                      The primary domain for this app that is displayed as the default
                                      in the control panel, used in bindable environment variables, and
                                      any other places that reference an app's live URL. Only one
                                      domain may be set as primary. * ALIAS: A non-primary domain.
                                      Known values are: "UNSPECIFIED", "DEFAULT", "PRIMARY", and
                                      "ALIAS".
                                    "wildcard": bool,  # Optional. Indicates
                                      whether the domain includes all sub-domains, in addition to the
                                      given domain.
                                    "zone": "str"  # Optional. Optional. If the
                                      domain uses DigitalOcean DNS and you would like App Platform to
                                      automatically manage it for you, set this to the name of the
                                      domain on your account.  For example, If the domain you are
                                      adding is ``app.domain.com``"" , the zone could be
                                      ``domain.com``.
                                }
                            ],
                            "egress": {
                                "type": "AUTOASSIGN"  # Optional. Default value is
                                  "AUTOASSIGN". The app egress type. Known values are: "AUTOASSIGN" and
                                  "DEDICATED_IP".
                            },
                            "functions": [
                                {
                                    "name": "str",  # The name. Must be unique
                                      across all components within the same app. Required.
                                    "alerts": [
                                        {
                                            "disabled": bool,  #
                                              Optional. Is the alert disabled?.
                                            "operator":
                                              "UNSPECIFIED_OPERATOR",  # Optional. Default value is
                                              "UNSPECIFIED_OPERATOR". Known values are:
                                              "UNSPECIFIED_OPERATOR", "GREATER_THAN", and "LESS_THAN".
                                            "rule": "UNSPECIFIED_RULE",
                                              # Optional. Default value is "UNSPECIFIED_RULE". Known
                                              values are: "UNSPECIFIED_RULE", "CPU_UTILIZATION",
                                              "MEM_UTILIZATION", "RESTART_COUNT", "DEPLOYMENT_FAILED",
                                              "DEPLOYMENT_LIVE", "DOMAIN_FAILED", "DOMAIN_LIVE",
                                              "FUNCTIONS_ACTIVATION_COUNT",
                                              "FUNCTIONS_AVERAGE_DURATION_MS",
                                              "FUNCTIONS_ERROR_RATE_PER_MINUTE",
                                              "FUNCTIONS_AVERAGE_WAIT_TIME_MS",
                                              "FUNCTIONS_ERROR_COUNT", and
                                              "FUNCTIONS_GB_RATE_PER_SECOND".
                                            "value": 0.0,  # Optional.
                                              Threshold value for alert.
                                            "window":
                                              "UNSPECIFIED_WINDOW"  # Optional. Default value is
                                              "UNSPECIFIED_WINDOW". Known values are:
                                              "UNSPECIFIED_WINDOW", "FIVE_MINUTES", "TEN_MINUTES",
                                              "THIRTY_MINUTES", and "ONE_HOUR".
                                        }
                                    ],
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "ingress": {
                                "rules": [
                                    {
                                        "component": {
                                            "name": "str",  # The name of
                                              the component to route to. Required.
                                            "preserve_path_prefix":
                                              "str",  # Optional. An optional flag to preserve the path
                                              that is forwarded to the backend service. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``. Note: this is not applicable for
                                              Functions Components and is mutually exclusive with
                                              ``rewrite``.
                                            "rewrite": "str"  # Optional.
                                              An optional field that will rewrite the path of the
                                              component to be what is specified here. By default, the
                                              HTTP request path will be trimmed from the left when
                                              forwarded to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If you specified the rewrite to be
                                              ``/v1/``"" , requests to ``/api/list`` would be rewritten
                                              to ``/v1/list``. Note: this is mutually exclusive with
                                              ``preserve_path_prefix``.
                                        },
                                        "cors": {
                                            "allow_credentials": bool,  #
                                              Optional. Whether browsers should expose the response to
                                              the client-side JavaScript code when the request"u2019s
                                              credentials mode is include. This configures the
                                              ``Access-Control-Allow-Credentials`` header.
                                            "allow_headers": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP request headers. This
                                                  configures the ``Access-Control-Allow-Headers``
                                                  header.
                                            ],
                                            "allow_methods": [
                                                "str"  # Optional.
                                                  The set of allowed HTTP methods. This configures the
                                                  ``Access-Control-Allow-Methods`` header.
                                            ],
                                            "allow_origins": [
                                                {
                                                    "exact":
                                                      "str",  # Optional. Exact string match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "prefix":
                                                      "str",  # Optional. Prefix-based match. Only 1 of
                                                      ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                      set.
                                                    "regex":
                                                      "str"  # Optional. RE2 style regex-based match.
                                                      Only 1 of ``exact``"" , ``prefix``"" , or
                                                      ``regex`` must be set. For more information about
                                                      RE2 syntax, see:
                                                      https://github.com/google/re2/wiki/Syntax.
                                                }
                                            ],
                                            "expose_headers": [
                                                "str"  # Optional.
                                                  The set of HTTP response headers that browsers are
                                                  allowed to access. This configures the
                                                  ``Access-Control-Expose-Headers`` header.
                                            ],
                                            "max_age": "str"  # Optional.
                                              An optional duration specifying how long browsers can
                                              cache the results of a preflight request. This configures
                                              the ``Access-Control-Max-Age`` header.
                                        },
                                        "match": {
                                            "authority": {
                                                "exact": "str"  #
                                                  Required.
                                            },
                                            "path": {
                                                "prefix": "str"  #
                                                  Prefix-based match. For example, ``/api`` will match
                                                  ``/api``"" , ``/api/``"" , and any nested paths such
                                                  as ``/api/v1/endpoint``. Required.
                                            }
                                        },
                                        "redirect": {
                                            "authority": "str",  #
                                              Optional. The authority/host to redirect to. This can be
                                              a hostname or IP address. Note: use ``port`` to set the
                                              port.
                                            "port": 0,  # Optional. The
                                              port to redirect to.
                                            "redirect_code": 0,  #
                                              Optional. The redirect code to use. Defaults to ``302``.
                                              Supported values are 300, 301, 302, 303, 304, 307, 308.
                                            "scheme": "str",  # Optional.
                                              The scheme to redirect to. Supported values are ``http``
                                              or ``https``. Default: ``https``.
                                            "uri": "str"  # Optional. An
                                              optional URI path to redirect to. Note: if this is
                                              specified the whole URI of the original request will be
                                              overwritten to this value, irrespective of the original
                                              request URI being matched.
                                        }
                                    }
                                ]
                            },
                            "jobs": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "kind": "UNSPECIFIED",  # Optional. Default
                                      value is "UNSPECIFIED". * UNSPECIFIED: Default job type, will
                                      auto-complete to POST_DEPLOY kind. * PRE_DEPLOY: Indicates a job
                                      that runs before an app deployment. * POST_DEPLOY: Indicates a
                                      job that runs after an app deployment. * FAILED_DEPLOY: Indicates
                                      a job that runs after a component fails to deploy. Known values
                                      are: "UNSPECIFIED", "PRE_DEPLOY", "POST_DEPLOY", and
                                      "FAILED_DEPLOY".
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "maintenance": {
                                "archive": bool,  # Optional. Indicates whether the
                                  app should be archived. Setting this to true implies that enabled is
                                  set to true.
                                "enabled": bool,  # Optional. Indicates whether
                                  maintenance mode should be enabled for the app.
                                "offline_page_url": "str"  # Optional. A custom
                                  offline page to display when maintenance mode is enabled or the app
                                  is archived.
                            },
                            "region": "str",  # Optional. The slug form of the
                              geographical origin of the app. Default: ``nearest available``. Known
                              values are: "ams", "nyc", "fra", "sfo", "sgp", "blr", "tor", "lon", and
                              "syd".
                            "services": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "health_check": {
                                        "failure_threshold": 0,  # Optional.
                                          The number of failed health checks before considered
                                          unhealthy.
                                        "http_path": "str",  # Optional. The
                                          route path used for the HTTP health check ping. If not set,
                                          the HTTP health check will be disabled and a TCP health check
                                          used instead.
                                        "initial_delay_seconds": 0,  #
                                          Optional. The number of seconds to wait before beginning
                                          health checks.
                                        "period_seconds": 0,  # Optional. The
                                          number of seconds to wait between health checks.
                                        "port": 0,  # Optional. The port on
                                          which the health check will be performed. If not set, the
                                          health check will be performed on the component's http_port.
                                        "success_threshold": 0,  # Optional.
                                          The number of successful health checks before considered
                                          healthy.
                                        "timeout_seconds": 0  # Optional. The
                                          number of seconds after which the check times out.
                                    },
                                    "http_port": 0,  # Optional. The internal
                                      port on which this service's run command will listen. Default:
                                      8080 If there is not an environment variable with the name
                                      ``PORT``"" , one will be automatically added with its value set
                                      to the value of this field.
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "internal_ports": [
                                        0  # Optional. The ports on which
                                          this service will listen for internal traffic.
                                    ],
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "protocol": "str",  # Optional. The protocol
                                      which the service uses to serve traffic on the http_port.   *
                                      ``HTTP``"" : The app is serving the HTTP protocol. Default. *
                                      ``HTTP2``"" : The app is serving the HTTP/2 protocol. Currently,
                                      this needs to be implemented in the service by serving HTTP/2
                                      cleartext (h2c). Known values are: "HTTP" and "HTTP2".
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "drain_seconds": 0,  # Optional. The
                                          number of seconds to wait between selecting a container
                                          instance for termination and issuing the TERM signal.
                                          Selecting a container instance for termination begins an
                                          asynchronous drain of new requests on upstream
                                          load-balancers. (Default 15).
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ],
                            "static_sites": [
                                {
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "catchall_document": "str",  # Optional. The
                                      name of the document to use as the fallback for any requests to
                                      documents that are not found when serving this static site. Only
                                      1 of ``catchall_document`` or ``error_document`` can be set.
                                    "cors": {
                                        "allow_credentials": bool,  #
                                          Optional. Whether browsers should expose the response to the
                                          client-side JavaScript code when the request"u2019s
                                          credentials mode is include. This configures the
                                          ``Access-Control-Allow-Credentials`` header.
                                        "allow_headers": [
                                            "str"  # Optional. The set of
                                              allowed HTTP request headers. This configures the
                                              ``Access-Control-Allow-Headers`` header.
                                        ],
                                        "allow_methods": [
                                            "str"  # Optional. The set of
                                              allowed HTTP methods. This configures the
                                              ``Access-Control-Allow-Methods`` header.
                                        ],
                                        "allow_origins": [
                                            {
                                                "exact": "str",  #
                                                  Optional. Exact string match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "prefix": "str",  #
                                                  Optional. Prefix-based match. Only 1 of ``exact``"" ,
                                                  ``prefix``"" , or ``regex`` must be set.
                                                "regex": "str"  #
                                                  Optional. RE2 style regex-based match. Only 1 of
                                                  ``exact``"" , ``prefix``"" , or ``regex`` must be
                                                  set. For more information about RE2 syntax, see:
                                                  https://github.com/google/re2/wiki/Syntax.
                                            }
                                        ],
                                        "expose_headers": [
                                            "str"  # Optional. The set of
                                              HTTP response headers that browsers are allowed to
                                              access. This configures the
                                              ``Access-Control-Expose-Headers`` header.
                                        ],
                                        "max_age": "str"  # Optional. An
                                          optional duration specifying how long browsers can cache the
                                          results of a preflight request. This configures the
                                          ``Access-Control-Max-Age`` header.
                                    },
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "error_document": "404.html",  # Optional.
                                      Default value is "404.html". The name of the error document to
                                      use when serving this static site. Default: 404.html. If no such
                                      file exists within the built assets, App Platform will supply
                                      one.
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "index_document": "index.html",  # Optional.
                                      Default value is "index.html". The name of the index document to
                                      use when serving this static site. Default: index.html.
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "output_dir": "str",  # Optional. An optional
                                      path to where the built assets will be located, relative to the
                                      build context. If not set, App Platform will automatically scan
                                      for these directory names: ``_static``"" , ``dist``"" ,
                                      ``public``"" , ``build``.
                                    "routes": [
                                        {
                                            "path": "str",  # Optional.
                                              (Deprecated - Use Ingress Rules instead). An HTTP path
                                              prefix. Paths must start with / and must be unique across
                                              all components within an app.
                                            "preserve_path_prefix": bool
                                              # Optional. An optional flag to preserve the path that is
                                              forwarded to the backend service. By default, the HTTP
                                              request path will be trimmed from the left when forwarded
                                              to the component. For example, a component with
                                              ``path=/api`` will have requests to ``/api/list`` trimmed
                                              to ``/list``. If this value is ``true``"" , the path will
                                              remain ``/api/list``.
                                        }
                                    ],
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str"  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                }
                            ],
                            "workers": [
                                {
                                    "autoscaling": {
                                        "max_instance_count": 0,  # Optional.
                                          The maximum amount of instances for this component. Must be
                                          more than min_instance_count.
                                        "metrics": {
                                            "cpu": {
                                                "percent": 80  #
                                                  Optional. Default value is 80. The average target CPU
                                                  utilization for the component.
                                            }
                                        },
                                        "min_instance_count": 0  # Optional.
                                          The minimum amount of instances for this component. Must be
                                          less than max_instance_count.
                                    },
                                    "bitbucket": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "build_command": "str",  # Optional. An
                                      optional build command to run while building this component from
                                      source.
                                    "dockerfile_path": "str",  # Optional. The
                                      path to the Dockerfile relative to the root of the repo. If set,
                                      it will be used to build this component. Otherwise, App Platform
                                      will attempt to build it using buildpacks.
                                    "environment_slug": "str",  # Optional. An
                                      environment slug describing the type of this app. For a full
                                      list, please refer to `the product documentation
                                      <https://docs.digitalocean.com/products/app-platform/>`_.
                                    "envs": [
                                        {
                                            "key": "str",  # The variable
                                              name. Required.
                                            "scope":
                                              "RUN_AND_BUILD_TIME",  # Optional. Default value is
                                              "RUN_AND_BUILD_TIME". * RUN_TIME: Made available only at
                                              run-time * BUILD_TIME: Made available only at build-time
                                              * RUN_AND_BUILD_TIME: Made available at both build and
                                              run-time. Known values are: "UNSET", "RUN_TIME",
                                              "BUILD_TIME", and "RUN_AND_BUILD_TIME".
                                            "type": "GENERAL",  #
                                              Optional. Default value is "GENERAL". * GENERAL: A
                                              plain-text environment variable * SECRET: A secret
                                              encrypted environment variable. Known values are:
                                              "GENERAL" and "SECRET".
                                            "value": "str"  # Optional.
                                              The value. If the type is ``SECRET``"" , the value will
                                              be encrypted on first submission. On following
                                              submissions, the encrypted value should be used.
                                        }
                                    ],
                                    "git": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "repo_clone_url": "str"  # Optional.
                                          The clone URL of the repo. Example:
                                          ``https://github.com/digitalocean/sample-golang.git``.
                                    },
                                    "github": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "gitlab": {
                                        "branch": "str",  # Optional. The
                                          name of the branch to use.
                                        "deploy_on_push": bool,  # Optional.
                                          Whether to automatically deploy new commits made to the repo.
                                        "repo": "str"  # Optional. The name
                                          of the repo in the format owner/repo. Example:
                                          ``digitalocean/sample-golang``.
                                    },
                                    "image": {
                                        "deploy_on_push": {
                                            "enabled": bool  # Optional.
                                              Whether to automatically deploy new images. Can only be
                                              used for images hosted in DOCR and can only be used with
                                              an image tag, not a specific digest.
                                        },
                                        "digest": "str",  # Optional. The
                                          image digest. Cannot be specified if tag is provided.
                                        "registry": "str",  # Optional. The
                                          registry name. Must be left empty for the ``DOCR`` registry
                                          type.
                                        "registry_credentials": "str",  #
                                          Optional. The credentials to be able to pull the image. The
                                          value will be encrypted on first submission. On following
                                          submissions, the encrypted value should be used.   *
                                          "$username:$access_token" for registries of type
                                          ``DOCKER_HUB``. * "$username:$access_token" for registries of
                                          type ``GHCR``.
                                        "registry_type": "str",  # Optional.
                                          * DOCKER_HUB: The DockerHub container registry type. * DOCR:
                                          The DigitalOcean container registry type. * GHCR: The Github
                                          container registry type. Known values are: "DOCKER_HUB",
                                          "DOCR", and "GHCR".
                                        "repository": "str",  # Optional. The
                                          repository name.
                                        "tag": "latest"  # Optional. Default
                                          value is "latest". The repository tag. Defaults to ``latest``
                                          if not provided and no digest is provided. Cannot be
                                          specified if digest is provided.
                                    },
                                    "instance_count": 1,  # Optional. Default
                                      value is 1. The amount of instances that this component should be
                                      scaled to. Default: 1. Must not be set if autoscaling is used.
                                    "instance_size_slug": {},
                                    "log_destinations": [
                                        {
                                            "name": "str",  # Required.
                                            "datadog": {
                                                "api_key": "str",  #
                                                  Datadog API key. Required.
                                                "endpoint": "str"  #
                                                  Optional. Datadog HTTP log intake endpoint.
                                            },
                                            "logtail": {
                                                "token": "str"  #
                                                  Optional. Logtail token.
                                            },
                                            "open_search": {
                                                "basic_auth": {
                                                    "password":
                                                      {},  # Optional. Password for user defined in
                                                      User. Is required when ``endpoint`` is set.
                                                      Cannot be set if using a DigitalOcean DBaaS
                                                      OpenSearch cluster.
                                                    "user": "str"
                                                      # Optional. Username to authenticate with. Only
                                                      required when ``endpoint`` is set. Defaults to
                                                      ``doadmin`` when ``cluster_name`` is set.
                                                },
                                                "cluster_name":
                                                  "str",  # Optional. The name of a DigitalOcean DBaaS
                                                  OpenSearch cluster to use as a log forwarding
                                                  destination. Cannot be specified if ``endpoint`` is
                                                  also specified.
                                                "endpoint": "str",  #
                                                  Optional. OpenSearch API Endpoint. Only HTTPS is
                                                  supported. Format:
                                                  https://:code:`<host>`::code:`<port>`. Cannot be
                                                  specified if ``cluster_name`` is also specified.
                                                "index_name": "logs"
                                                  # Optional. Default value is "logs". The index name
                                                  to use for the logs. If not set, the default index
                                                  name is "logs".
                                            },
                                            "papertrail": {
                                                "endpoint": "str"  #
                                                  Papertrail syslog endpoint. Required.
                                            }
                                        }
                                    ],
                                    "name": "str",  # Optional. The name. Must be
                                      unique across all components within the same app.
                                    "run_command": "str",  # Optional. An
                                      optional run command to override the component's default.
                                    "source_dir": "str",  # Optional. An optional
                                      path to the working directory to use for the build. For
                                      Dockerfile builds, this will be used as the build context. Must
                                      be relative to the root of the repo.
                                    "termination": {
                                        "grace_period_seconds": 0  #
                                          Optional. The number of seconds to wait between sending a
                                          TERM signal to a container and issuing a KILL which causes
                                          immediate shutdown. (Default 120).
                                    }
                                }
                            ]
                        },
                        "static_sites": [
                            {
                                "name": "str",  # Optional. The name of this static
                                  site.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this static site.
                            }
                        ],
                        "tier_slug": "str",  # Optional. The current pricing tier slug of the
                          deployment.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. When the deployment
                          was last updated.
                        "workers": [
                            {
                                "name": "str",  # Optional. The name of this worker.
                                "source_commit_hash": "str"  # Optional. The commit
                                  hash of the repository that was used to build this worker.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_revert_rollback_request(
            app_id=app_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_metrics_bandwidth_daily(
        self, app_id: str, *, date: Optional[datetime.datetime] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve App Daily Bandwidth Metrics.

        Retrieve daily bandwidth usage metrics for a single app.

        :param app_id: The app ID. Required.
        :type app_id: str
        :keyword date: Optional day to query. Only the date component of the timestamp will be
         considered. Default: yesterday. Default value is None.
        :paramtype date: ~datetime.datetime
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app_bandwidth_usage": [
                        {
                            "app_id": "str",  # Optional. The ID of the app.
                            "bandwidth_bytes": "str"  # Optional. The used bandwidth
                              amount in bytes.
                        }
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. The date for the metrics data.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_metrics_bandwidth_daily_request(
            app_id=app_id,
            date=date,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def list_metrics_bandwidth_daily(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Multiple Apps' Daily Bandwidth Metrics.

        Retrieve daily bandwidth usage metrics for multiple apps.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "app_ids": [
                        "str"  # A list of app IDs to query bandwidth metrics for. Required.
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. Optional day to query. Only the
                      date component of the timestamp will be considered. Default: yesterday.
                }

                # response body for status code(s): 200
                response == {
                    "app_bandwidth_usage": [
                        {
                            "app_id": "str",  # Optional. The ID of the app.
                            "bandwidth_bytes": "str"  # Optional. The used bandwidth
                              amount in bytes.
                        }
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. The date for the metrics data.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def list_metrics_bandwidth_daily(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Multiple Apps' Daily Bandwidth Metrics.

        Retrieve daily bandwidth usage metrics for multiple apps.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app_bandwidth_usage": [
                        {
                            "app_id": "str",  # Optional. The ID of the app.
                            "bandwidth_bytes": "str"  # Optional. The used bandwidth
                              amount in bytes.
                        }
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. The date for the metrics data.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def list_metrics_bandwidth_daily(
        self, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Multiple Apps' Daily Bandwidth Metrics.

        Retrieve daily bandwidth usage metrics for multiple apps.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "app_ids": [
                        "str"  # A list of app IDs to query bandwidth metrics for. Required.
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. Optional day to query. Only the
                      date component of the timestamp will be considered. Default: yesterday.
                }

                # response body for status code(s): 200
                response == {
                    "app_bandwidth_usage": [
                        {
                            "app_id": "str",  # Optional. The ID of the app.
                            "bandwidth_bytes": "str"  # Optional. The used bandwidth
                              amount in bytes.
                        }
                    ],
                    "date": "2020-02-20 00:00:00"  # Optional. The date for the metrics data.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_apps_list_metrics_bandwidth_daily_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_health(self, app_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve App Health.

        Retrieve information like health status, cpu and memory utilization of app components.

        :param app_id: The app ID. Required.
        :type app_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "app_health": {
                        "components": [
                            {
                                "cpu_usage_percent": 0.0,  # Optional.
                                "memory_usage_percent": 0.0,  # Optional.
                                "name": "str",  # Optional.
                                "replicas_desired": 0,  # Optional.
                                "replicas_ready": 0,  # Optional.
                                "state": "UNKNOWN"  # Optional. Default value is
                                  "UNKNOWN". Known values are: "UNKNOWN", "HEALTHY", and "UNHEALTHY".
                            }
                        ],
                        "functions_components": [
                            {
                                "functions_component_health_metrics": [
                                    {
                                        "metric_label": "str",  # Optional.
                                        "metric_value": 0.0,  # Optional.
                                        "time_window": "str"  # Optional.
                                    }
                                ],
                                "name": "str"  # Optional.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_apps_get_health_request(
            app_id=app_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class CdnOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`cdn` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_endpoints(
        self, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All CDN Endpoints.

        To list all of the CDN endpoints available on your account, send a GET request to
        ``/v2/cdn/endpoints``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "endpoints": [
                        {
                            "origin": "str",  # The fully qualified domain name (FQDN)
                              for the origin server which provides the content for the CDN. This is
                              currently restricted to a Space. Required.
                            "certificate_id": "str",  # Optional. The ID of a
                              DigitalOcean managed TLS certificate used for SSL when a custom subdomain
                              is provided.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the CDN endpoint was created.
                            "custom_domain": "str",  # Optional. The fully qualified
                              domain name (FQDN) of the custom subdomain used with the CDN endpoint.
                            "endpoint": "str",  # Optional. The fully qualified domain
                              name (FQDN) from which the CDN-backed content is served.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a CDN endpoint.
                            "ttl": 3600  # Optional. Default value is 3600. The amount of
                              time the content is cached by the CDN's edge servers in seconds. TTL must
                              be one of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour)
                              when excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_cdn_list_endpoints_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_endpoint(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New CDN Endpoint.

        To create a new CDN endpoint, send a POST request to ``/v2/cdn/endpoints``. The
        origin attribute must be set to the fully qualified domain name (FQDN) of a
        DigitalOcean Space. Optionally, the TTL may be configured by setting the ``ttl``
        attribute.

        A custom subdomain may be configured by specifying the ``custom_domain`` and
        ``certificate_id`` attributes.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "origin": "str",  # The fully qualified domain name (FQDN) for the origin
                      server which provides the content for the CDN. This is currently restricted to a
                      Space. Required.
                    "certificate_id": "str",  # Optional. The ID of a DigitalOcean managed TLS
                      certificate used for SSL when a custom subdomain is provided.
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the CDN endpoint was
                      created.
                    "custom_domain": "str",  # Optional. The fully qualified domain name (FQDN)
                      of the custom subdomain used with the CDN endpoint.
                    "endpoint": "str",  # Optional. The fully qualified domain name (FQDN) from
                      which the CDN-backed content is served.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a CDN endpoint.
                    "ttl": 3600  # Optional. Default value is 3600. The amount of time the
                      content is cached by the CDN's edge servers in seconds. TTL must be one of 60,
                      600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when excluded. Known
                      values are: 60, 600, 3600, 86400, and 604800.
                }

                # response body for status code(s): 201
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
        """

    @overload
    def create_endpoint(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New CDN Endpoint.

        To create a new CDN endpoint, send a POST request to ``/v2/cdn/endpoints``. The
        origin attribute must be set to the fully qualified domain name (FQDN) of a
        DigitalOcean Space. Optionally, the TTL may be configured by setting the ``ttl``
        attribute.

        A custom subdomain may be configured by specifying the ``custom_domain`` and
        ``certificate_id`` attributes.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
        """

    @distributed_trace
    def create_endpoint(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New CDN Endpoint.

        To create a new CDN endpoint, send a POST request to ``/v2/cdn/endpoints``. The
        origin attribute must be set to the fully qualified domain name (FQDN) of a
        DigitalOcean Space. Optionally, the TTL may be configured by setting the ``ttl``
        attribute.

        A custom subdomain may be configured by specifying the ``custom_domain`` and
        ``certificate_id`` attributes.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "origin": "str",  # The fully qualified domain name (FQDN) for the origin
                      server which provides the content for the CDN. This is currently restricted to a
                      Space. Required.
                    "certificate_id": "str",  # Optional. The ID of a DigitalOcean managed TLS
                      certificate used for SSL when a custom subdomain is provided.
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the CDN endpoint was
                      created.
                    "custom_domain": "str",  # Optional. The fully qualified domain name (FQDN)
                      of the custom subdomain used with the CDN endpoint.
                    "endpoint": "str",  # Optional. The fully qualified domain name (FQDN) from
                      which the CDN-backed content is served.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a CDN endpoint.
                    "ttl": 3600  # Optional. Default value is 3600. The amount of time the
                      content is cached by the CDN's edge servers in seconds. TTL must be one of 60,
                      600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when excluded. Known
                      values are: 60, 600, 3600, 86400, and 604800.
                }

                # response body for status code(s): 201
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_cdn_create_endpoint_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_endpoint(self, cdn_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing CDN Endpoint.

        To show information about an existing CDN endpoint, send a GET request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID``.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_cdn_get_endpoint_request(
            cdn_id=cdn_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_endpoints(
        self,
        cdn_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a CDN Endpoint.

        To update the TTL, certificate ID, or the FQDN of the custom subdomain for
        an existing CDN endpoint, send a PUT request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID``.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "certificate_id": "str",  # Optional. The ID of a DigitalOcean managed TLS
                      certificate used for SSL when a custom subdomain is provided.
                    "custom_domain": "str",  # Optional. The fully qualified domain name (FQDN)
                      of the custom subdomain used with the CDN endpoint.
                    "ttl": 3600  # Optional. Default value is 3600. The amount of time the
                      content is cached by the CDN's edge servers in seconds. TTL must be one of 60,
                      600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when excluded. Known
                      values are: 60, 600, 3600, 86400, and 604800.
                }

                # response body for status code(s): 200
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_endpoints(
        self,
        cdn_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a CDN Endpoint.

        To update the TTL, certificate ID, or the FQDN of the custom subdomain for
        an existing CDN endpoint, send a PUT request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID``.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_endpoints(
        self, cdn_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a CDN Endpoint.

        To update the TTL, certificate ID, or the FQDN of the custom subdomain for
        an existing CDN endpoint, send a PUT request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID``.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "certificate_id": "str",  # Optional. The ID of a DigitalOcean managed TLS
                      certificate used for SSL when a custom subdomain is provided.
                    "custom_domain": "str",  # Optional. The fully qualified domain name (FQDN)
                      of the custom subdomain used with the CDN endpoint.
                    "ttl": 3600  # Optional. Default value is 3600. The amount of time the
                      content is cached by the CDN's edge servers in seconds. TTL must be one of 60,
                      600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when excluded. Known
                      values are: 60, 600, 3600, 86400, and 604800.
                }

                # response body for status code(s): 200
                response == {
                    "endpoint": {
                        "origin": "str",  # The fully qualified domain name (FQDN) for the
                          origin server which provides the content for the CDN. This is currently
                          restricted to a Space. Required.
                        "certificate_id": "str",  # Optional. The ID of a DigitalOcean
                          managed TLS certificate used for SSL when a custom subdomain is provided.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the CDN
                          endpoint was created.
                        "custom_domain": "str",  # Optional. The fully qualified domain name
                          (FQDN) of the custom subdomain used with the CDN endpoint.
                        "endpoint": "str",  # Optional. The fully qualified domain name
                          (FQDN) from which the CDN-backed content is served.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a CDN endpoint.
                        "ttl": 3600  # Optional. Default value is 3600. The amount of time
                          the content is cached by the CDN's edge servers in seconds. TTL must be one
                          of 60, 600, 3600, 86400, or 604800. Defaults to 3600 (one hour) when
                          excluded. Known values are: 60, 600, 3600, 86400, and 604800.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_cdn_update_endpoints_request(
            cdn_id=cdn_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_endpoint(self, cdn_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a CDN Endpoint.

        To delete a specific CDN endpoint, send a DELETE request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_cdn_delete_endpoint_request(
            cdn_id=cdn_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def purge_cache(
        self,
        cdn_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Purge the Cache for an Existing CDN Endpoint.

        To purge cached content from a CDN endpoint, send a DELETE request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID/cache``. The body of the request should include
        a ``files`` attribute containing a list of cached file paths to be purged. A
        path may be for a single file or may contain a wildcard (\\ ``*``\\ ) to recursively
        purge all files under a directory. When only a wildcard is provided, all cached
        files will be purged. There is a rate limit of 50 files per 20 seconds that can
        be purged. CDN endpoints have a rate limit of 5 requests per 10 seconds.
        Purging files using a wildcard path counts as a single request against the API's
        rate limit. Two identical purge requests cannot be sent at the same time.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "files": [
                        "str"  # An array of strings containing the path to the content to be
                          purged from the CDN cache. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def purge_cache(
        self,
        cdn_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Purge the Cache for an Existing CDN Endpoint.

        To purge cached content from a CDN endpoint, send a DELETE request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID/cache``. The body of the request should include
        a ``files`` attribute containing a list of cached file paths to be purged. A
        path may be for a single file or may contain a wildcard (\\ ``*``\\ ) to recursively
        purge all files under a directory. When only a wildcard is provided, all cached
        files will be purged. There is a rate limit of 50 files per 20 seconds that can
        be purged. CDN endpoints have a rate limit of 5 requests per 10 seconds.
        Purging files using a wildcard path counts as a single request against the API's
        rate limit. Two identical purge requests cannot be sent at the same time.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def purge_cache(
        self, cdn_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Purge the Cache for an Existing CDN Endpoint.

        To purge cached content from a CDN endpoint, send a DELETE request to
        ``/v2/cdn/endpoints/$ENDPOINT_ID/cache``. The body of the request should include
        a ``files`` attribute containing a list of cached file paths to be purged. A
        path may be for a single file or may contain a wildcard (\\ ``*``\\ ) to recursively
        purge all files under a directory. When only a wildcard is provided, all cached
        files will be purged. There is a rate limit of 50 files per 20 seconds that can
        be purged. CDN endpoints have a rate limit of 5 requests per 10 seconds.
        Purging files using a wildcard path counts as a single request against the API's
        rate limit. Two identical purge requests cannot be sent at the same time.

        :param cdn_id: A unique identifier for a CDN endpoint. Required.
        :type cdn_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "files": [
                        "str"  # An array of strings containing the path to the content to be
                          purged from the CDN cache. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_cdn_purge_cache_request(
            cdn_id=cdn_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class CertificatesOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`certificates` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self, *, per_page: int = 20, page: int = 1, name: str = "", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Certificates.

        To list all of the certificates available on your account, send a GET request to
        ``/v2/certificates``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword name: Name of expected certificate. Default value is "".
        :paramtype name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "certificates": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the certificate was created.
                            "dns_names": [
                                "str"  # Optional. An array of fully qualified domain
                                  names (FQDNs) for which the certificate was issued.
                            ],
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a certificate.
                            "name": "str",  # Optional. A unique human-readable name
                              referring to a certificate.
                            "not_after": "2020-02-20 00:00:00",  # Optional. A time value
                              given in ISO8601 combined date and time format that represents the
                              certificate's expiration date.
                            "sha1_fingerprint": "str",  # Optional. A unique identifier
                              generated from the SHA-1 fingerprint of the certificate.
                            "state": "str",  # Optional. A string representing the
                              current state of the certificate. It may be ``pending``"" ,
                              ``verified``"" , or ``error``. Known values are: "pending", "verified",
                              and "error".
                            "type": "str"  # Optional. A string representing the type of
                              the certificate. The value will be ``custom`` for a user-uploaded
                              certificate or ``lets_encrypt`` for one automatically generated with
                              Let's Encrypt. Known values are: "custom" and "lets_encrypt".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_certificates_list_request(
            per_page=per_page,
            page=page,
            name=name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Certificate.

        To upload new SSL certificate which you have previously generated, send a POST
        request to ``/v2/certificates``.

        When uploading a user-generated certificate, the ``private_key``\\ ,
        ``leaf_certificate``\\ , and optionally the ``certificate_chain`` attributes should
        be provided. The type must be set to ``custom``.

        When using Let's Encrypt to create a certificate, the ``dns_names`` attribute
        must be provided, and the type must be set to ``lets_encrypt``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "certificate": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the certificate
                          was created.
                        "dns_names": [
                            "str"  # Optional. An array of fully qualified domain names
                              (FQDNs) for which the certificate was issued.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a certificate.
                        "name": "str",  # Optional. A unique human-readable name referring to
                          a certificate.
                        "not_after": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents the certificate's
                          expiration date.
                        "sha1_fingerprint": "str",  # Optional. A unique identifier generated
                          from the SHA-1 fingerprint of the certificate.
                        "state": "str",  # Optional. A string representing the current state
                          of the certificate. It may be ``pending``"" , ``verified``"" , or ``error``.
                          Known values are: "pending", "verified", and "error".
                        "type": "str"  # Optional. A string representing the type of the
                          certificate. The value will be ``custom`` for a user-uploaded certificate or
                          ``lets_encrypt`` for one automatically generated with Let's Encrypt. Known
                          values are: "custom" and "lets_encrypt".
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Certificate.

        To upload new SSL certificate which you have previously generated, send a POST
        request to ``/v2/certificates``.

        When uploading a user-generated certificate, the ``private_key``\\ ,
        ``leaf_certificate``\\ , and optionally the ``certificate_chain`` attributes should
        be provided. The type must be set to ``custom``.

        When using Let's Encrypt to create a certificate, the ``dns_names`` attribute
        must be provided, and the type must be set to ``lets_encrypt``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "certificate": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the certificate
                          was created.
                        "dns_names": [
                            "str"  # Optional. An array of fully qualified domain names
                              (FQDNs) for which the certificate was issued.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a certificate.
                        "name": "str",  # Optional. A unique human-readable name referring to
                          a certificate.
                        "not_after": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents the certificate's
                          expiration date.
                        "sha1_fingerprint": "str",  # Optional. A unique identifier generated
                          from the SHA-1 fingerprint of the certificate.
                        "state": "str",  # Optional. A string representing the current state
                          of the certificate. It may be ``pending``"" , ``verified``"" , or ``error``.
                          Known values are: "pending", "verified", and "error".
                        "type": "str"  # Optional. A string representing the type of the
                          certificate. The value will be ``custom`` for a user-uploaded certificate or
                          ``lets_encrypt`` for one automatically generated with Let's Encrypt. Known
                          values are: "custom" and "lets_encrypt".
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Certificate.

        To upload new SSL certificate which you have previously generated, send a POST
        request to ``/v2/certificates``.

        When uploading a user-generated certificate, the ``private_key``\\ ,
        ``leaf_certificate``\\ , and optionally the ``certificate_chain`` attributes should
        be provided. The type must be set to ``custom``.

        When using Let's Encrypt to create a certificate, the ``dns_names`` attribute
        must be provided, and the type must be set to ``lets_encrypt``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "certificate": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the certificate
                          was created.
                        "dns_names": [
                            "str"  # Optional. An array of fully qualified domain names
                              (FQDNs) for which the certificate was issued.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a certificate.
                        "name": "str",  # Optional. A unique human-readable name referring to
                          a certificate.
                        "not_after": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents the certificate's
                          expiration date.
                        "sha1_fingerprint": "str",  # Optional. A unique identifier generated
                          from the SHA-1 fingerprint of the certificate.
                        "state": "str",  # Optional. A string representing the current state
                          of the certificate. It may be ``pending``"" , ``verified``"" , or ``error``.
                          Known values are: "pending", "verified", and "error".
                        "type": "str"  # Optional. A string representing the type of the
                          certificate. The value will be ``custom`` for a user-uploaded certificate or
                          ``lets_encrypt`` for one automatically generated with Let's Encrypt. Known
                          values are: "custom" and "lets_encrypt".
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_certificates_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, certificate_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Certificate.

        To show information about an existing certificate, send a GET request to
        ``/v2/certificates/$CERTIFICATE_ID``.

        :param certificate_id: A unique identifier for a certificate. Required.
        :type certificate_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "certificate": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the certificate
                          was created.
                        "dns_names": [
                            "str"  # Optional. An array of fully qualified domain names
                              (FQDNs) for which the certificate was issued.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a certificate.
                        "name": "str",  # Optional. A unique human-readable name referring to
                          a certificate.
                        "not_after": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents the certificate's
                          expiration date.
                        "sha1_fingerprint": "str",  # Optional. A unique identifier generated
                          from the SHA-1 fingerprint of the certificate.
                        "state": "str",  # Optional. A string representing the current state
                          of the certificate. It may be ``pending``"" , ``verified``"" , or ``error``.
                          Known values are: "pending", "verified", and "error".
                        "type": "str"  # Optional. A string representing the type of the
                          certificate. The value will be ``custom`` for a user-uploaded certificate or
                          ``lets_encrypt`` for one automatically generated with Let's Encrypt. Known
                          values are: "custom" and "lets_encrypt".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_certificates_get_request(
            certificate_id=certificate_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, certificate_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Certificate.

        To delete a specific certificate, send a DELETE request to
        ``/v2/certificates/$CERTIFICATE_ID``.

        :param certificate_id: A unique identifier for a certificate. Required.
        :type certificate_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_certificates_delete_request(
            certificate_id=certificate_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class BalanceOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`balance` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def get(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Customer Balance.

        To retrieve the balances on a customer's account, send a GET request to
        ``/v2/customers/my/balance``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "account_balance": "str",  # Optional. Current balance of the customer's most
                      recent billing activity.  Does not reflect ``month_to_date_usage``.
                    "generated_at": "2020-02-20 00:00:00",  # Optional. The time at which
                      balances were most recently generated.
                    "month_to_date_balance": "str",  # Optional. Balance as of the
                      ``generated_at`` time.  This value includes the ``account_balance`` and
                      ``month_to_date_usage``.
                    "month_to_date_usage": "str"  # Optional. Amount used in the current billing
                      period as of the ``generated_at`` time.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_balance_get_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class BillingHistoryOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`billing_history` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Billing History.

        To retrieve a list of all billing history entries, send a GET request to
        ``/v2/customers/my/billing_history``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "billing_history": [
                        {
                            "amount": "str",  # Optional. Amount of the billing history
                              entry.
                            "date": "2020-02-20 00:00:00",  # Optional. Time the billing
                              history entry occurred.
                            "description": "str",  # Optional. Description of the billing
                              history entry.
                            "invoice_id": "str",  # Optional. ID of the invoice
                              associated with the billing history entry, if  applicable.
                            "invoice_uuid": "str",  # Optional. UUID of the invoice
                              associated with the billing history entry, if  applicable.
                            "type": "str"  # Optional. Type of billing history entry.
                              Known values are: "ACHFailure", "Adjustment", "AttemptFailed",
                              "Chargeback", "Credit", "CreditExpiration", "Invoice", "Payment",
                              "Refund", and "Reversal".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_billing_history_list_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class InvoicesOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`invoices` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Invoices.

        To retrieve a list of all invoices, send a GET request to ``/v2/customers/my/invoices``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "invoice_preview": {
                        "amount": "str",  # Optional. Total amount of the invoice, in USD.
                          This will reflect month-to-date usage in the invoice preview.
                        "invoice_id": "str",  # Optional. ID of the invoice. Listed on the
                          face of the invoice PDF as the "Invoice number".
                        "invoice_period": "str",  # Optional. Billing period of usage for
                          which the invoice is issued, in ``YYYY-MM``  format.
                        "invoice_uuid": "str",  # Optional. The UUID of the invoice. The
                          canonical reference for the invoice.
                        "updated_at": "str"  # Optional. Time the invoice was last updated.
                          This is only included with the invoice preview.
                    },
                    "invoices": [
                        {
                            "amount": "str",  # Optional. Total amount of the invoice, in
                              USD.  This will reflect month-to-date usage in the invoice preview.
                            "invoice_id": "str",  # Optional. ID of the invoice. Listed
                              on the face of the invoice PDF as the "Invoice number".
                            "invoice_period": "str",  # Optional. Billing period of usage
                              for which the invoice is issued, in ``YYYY-MM``  format.
                            "invoice_uuid": "str",  # Optional. The UUID of the invoice.
                              The canonical reference for the invoice.
                            "updated_at": "str"  # Optional. Time the invoice was last
                              updated.  This is only included with the invoice preview.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_invoices_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_by_uuid(
        self, invoice_uuid: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Invoice by UUID.

        To retrieve the invoice items for an invoice, send a GET request to
        ``/v2/customers/my/invoices/$INVOICE_UUID``.

        :param invoice_uuid: UUID of the invoice. Required.
        :type invoice_uuid: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "invoice_items": [
                        {
                            "amount": "str",  # Optional. Billed amount of this invoice
                              item. Billed in USD.
                            "description": "str",  # Optional. Description of the invoice
                              item.
                            "duration": "str",  # Optional. Duration of time this invoice
                              item was used and subsequently billed.
                            "duration_unit": "str",  # Optional. Unit of time for
                              duration.
                            "end_time": "str",  # Optional. Time the invoice item stopped
                              being billed for usage.
                            "group_description": "str",  # Optional. Description of the
                              invoice item when it is a grouped set of usage, such  as DOKS or
                              databases.
                            "product": "str",  # Optional. Name of the product being
                              billed in the invoice item.
                            "project_name": "str",  # Optional. Name of the DigitalOcean
                              Project this resource belongs to.
                            "resource_id": "str",  # Optional. ID of the resource billing
                              in the invoice item if available.
                            "resource_uuid": "str",  # Optional. UUID of the resource
                              billing in the invoice item if available.
                            "start_time": "str"  # Optional. Time the invoice item began
                              to be billed for usage.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_invoices_get_by_uuid_request(
            invoice_uuid=invoice_uuid,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_csv_by_uuid(self, invoice_uuid: str, **kwargs: Any) -> Union[str, JSON]:
        # pylint: disable=line-too-long
        """Retrieve an Invoice CSV by UUID.

        To retrieve a CSV for an invoice, send a GET request to
        ``/v2/customers/my/invoices/$INVOICE_UUID/csv``.

        :param invoice_uuid: UUID of the invoice. Required.
        :type invoice_uuid: str
        :return: str or JSON object
        :rtype: str or JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Union[str, JSON]] = kwargs.pop("cls", None)

        _request = build_invoices_get_csv_by_uuid_request(
            invoice_uuid=invoice_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["content-disposition"] = self._deserialize(
                "str", response.headers.get("content-disposition")
            )
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(Union[str, JSON], deserialized), response_headers)  # type: ignore

        return cast(Union[str, JSON], deserialized)  # type: ignore

    @distributed_trace
    def get_pdf_by_uuid(
        self, invoice_uuid: str, **kwargs: Any
    ) -> Union[Iterator[bytes], JSON]:
        # pylint: disable=line-too-long
        """Retrieve an Invoice PDF by UUID.

        To retrieve a PDF for an invoice, send a GET request to
        ``/v2/customers/my/invoices/$INVOICE_UUID/pdf``.

        :param invoice_uuid: UUID of the invoice. Required.
        :type invoice_uuid: str
        :return: Iterator[bytes] or JSON object
        :rtype: Iterator[bytes] or JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Union[Iterator[bytes], JSON]] = kwargs.pop("cls", None)

        _request = build_invoices_get_pdf_by_uuid_request(
            invoice_uuid=invoice_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = True
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["content-disposition"] = self._deserialize(
                "str", response.headers.get("content-disposition")
            )
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            deserialized = response.iter_bytes()

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            deserialized = response.iter_bytes()

        if cls:
            return cls(pipeline_response, cast(Union[Iterator[bytes], JSON], deserialized), response_headers)  # type: ignore

        return cast(Union[Iterator[bytes], JSON], deserialized)  # type: ignore

    @distributed_trace
    def get_summary_by_uuid(self, invoice_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Invoice Summary by UUID.

        To retrieve a summary for an invoice, send a GET request to
        ``/v2/customers/my/invoices/$INVOICE_UUID/summary``.

        :param invoice_uuid: UUID of the invoice. Required.
        :type invoice_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "amount": "str",  # Optional. Total amount of the invoice, in USD.  This will
                      reflect month-to-date usage in the invoice preview.
                    "billing_period": "str",  # Optional. Billing period of usage for which the
                      invoice is issued, in ``YYYY-MM``  format.
                    "credits_and_adjustments": {
                        "amount": "str",  # Optional. Total amount charged in USD.
                        "name": "str"  # Optional. Name of the charge.
                    },
                    "invoice_id": "str",  # Optional. ID of the invoice.
                    "invoice_uuid": "str",  # Optional. UUID of the invoice.
                    "overages": {
                        "amount": "str",  # Optional. Total amount charged in USD.
                        "name": "str"  # Optional. Name of the charge.
                    },
                    "product_charges": {
                        "amount": "str",  # Optional. Total amount charged.
                        "items": [
                            {
                                "amount": "str",  # Optional. Amount of the charge.
                                "count": "str",  # Optional. Number of times the
                                  charge was applied.
                                "name": "str"  # Optional. Description of the charge.
                            }
                        ],
                        "name": "str"  # Optional. Description of usage charges.
                    },
                    "taxes": {
                        "amount": "str",  # Optional. Total amount charged in USD.
                        "name": "str"  # Optional. Name of the charge.
                    },
                    "user_billing_address": {
                        "address_line1": "str",  # Optional. Street address line 1.
                        "address_line2": "str",  # Optional. Street address line 2.
                        "city": "str",  # Optional. City.
                        "country_iso2_code": "str",  # Optional. Country (ISO2) code.
                        "created_at": "str",  # Optional. Timestamp billing address was
                          created.
                        "postal_code": "str",  # Optional. Postal code.
                        "region": "str",  # Optional. Region.
                        "updated_at": "str"  # Optional. Timestamp billing address was
                          updated.
                    },
                    "user_company": "str",  # Optional. Company of the DigitalOcean customer
                      being invoiced, if set.
                    "user_email": "str",  # Optional. Email of the DigitalOcean customer being
                      invoiced.
                    "user_name": "str"  # Optional. Name of the DigitalOcean customer being
                      invoiced.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_invoices_get_summary_by_uuid_request(
            invoice_uuid=invoice_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class DatabasesOperations:  # pylint: disable=too-many-public-methods
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`databases` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_options(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Database Options.

        To list all of the options available for the offered database engines, send a GET request to
        ``/v2/databases/options``.
        The result will be a JSON object with an ``options`` key.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "options": {
                        "kafka": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        },
                        "mongodb": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        },
                        "mysql": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        },
                        "opensearch": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        },
                        "pg": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        },
                        "redis": {
                            "layouts": [
                                {
                                    "num_nodes": 0,  # Optional. An array of
                                      objects, each indicating the node sizes (otherwise referred to as
                                      slugs) that are available with various numbers of nodes in the
                                      database cluster. Each slugs denotes the node's identifier, CPU,
                                      and RAM (in that order).
                                    "sizes": [
                                        "str"  # Optional. An array of
                                          objects containing the slugs available with various node
                                          counts.
                                    ]
                                }
                            ],
                            "regions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ],
                            "versions": [
                                "str"  # Optional. An array of strings containing the
                                  names of available regions.
                            ]
                        }
                    },
                    "version_availability": {
                        "kafka": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ],
                        "mongodb": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ],
                        "mysql": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ],
                        "opensearch": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ],
                        "pg": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ],
                        "redis": [
                            {
                                "end_of_availability": "str",  # Optional. A
                                  timestamp referring to the date when the particular version will no
                                  longer be available for creating new clusters. If null, the version
                                  does not have an end of availability timeline.
                                "end_of_life": "str",  # Optional. A timestamp
                                  referring to the date when the particular version will no longer be
                                  supported. If null, the version does not have an end of life
                                  timeline.
                                "version": "str"  # Optional. The engine version.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_options_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_clusters(self, *, tag_name: Optional[str] = None, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Database Clusters.

        To list all of the database clusters available on your account, send a GET request to
        ``/v2/databases``. To limit the results to database clusters with a specific tag, include the
        ``tag_name`` query parameter set to the name of the tag. For example,
        ``/v2/databases?tag_name=$TAG_NAME``.

        The result will be a JSON object with a ``databases`` key. This will be set to an array of
        database objects, each of which will contain the standard database attributes.

        The embedded ``connection`` and ``private_connection`` objects will contain the information
        needed to access the database cluster. For multi-node clusters, the ``standby_connection`` and
        ``standby_private_connection`` objects will contain the information needed to connect to the
        cluster's standby node(s).

        The embedded ``maintenance_window`` object will contain information about any scheduled
        maintenance for the database cluster.

        :keyword tag_name: Limits the results to database clusters with a specific tag. Default value
         is None.
        :paramtype tag_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "databases": [
                        {
                            "engine": "str",  # A slug representing the database engine
                              used for the cluster. The possible values are: "pg" for PostgreSQL,
                              "mysql" for MySQL, "redis" for Redis, "mongodb" for MongoDB, "kafka" for
                              Kafka, and "opensearch" for OpenSearch. Required. Known values are: "pg",
                              "mysql", "redis", "mongodb", "kafka", and "opensearch".
                            "name": "str",  # A unique, human-readable name referring to
                              a database cluster. Required.
                            "num_nodes": 0,  # The number of nodes in the database
                              cluster. Required.
                            "region": "str",  # The slug identifier for the region where
                              the database cluster is located. Required.
                            "size": "str",  # The slug identifier representing the size
                              of the nodes in the database cluster. Required.
                            "connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the database cluster was created.
                            "db_names": [
                                "str"  # Optional. An array of strings containing the
                                  names of databases created in the database cluster.
                            ],
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a database cluster.
                            "maintenance_window": {
                                "day": "str",  # The day of the week on which to
                                  apply maintenance updates. Required.
                                "hour": "str",  # The hour in UTC at which
                                  maintenance updates will be applied in 24 hour format. Required.
                                "description": [
                                    "str"  # Optional. A list of strings, each
                                      containing information about a pending maintenance update.
                                ],
                                "pending": bool  # Optional. A boolean value
                                  indicating whether any maintenance is scheduled to be performed in
                                  the next window.
                            },
                            "metrics_endpoints": [
                                {
                                    "host": "str",  # Optional. A FQDN pointing
                                      to the database cluster's node(s).
                                    "port": 0  # Optional. The port on which a
                                      service is listening.
                                }
                            ],
                            "private_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "private_network_uuid": "str",  # Optional. A string
                              specifying the UUID of the VPC to which the database cluster will be
                              assigned. If excluded, the cluster when creating a new database cluster,
                              it will be assigned to your account's default VPC for the region.
                            "project_id": "str",  # Optional. The ID of the project that
                              the database cluster is assigned to. If excluded when creating a new
                              database cluster, it will be assigned to your default project.
                            "rules": [
                                {
                                    "type": "str",  # The type of resource that
                                      the firewall rule allows to access the database cluster.
                                      Required. Known values are: "droplet", "k8s", "ip_addr", "tag",
                                      and "app".
                                    "value": "str",  # The ID of the specific
                                      resource, the name of a tag applied to a group of resources, or
                                      the IP address that the firewall rule allows to access the
                                      database cluster. Required.
                                    "cluster_uuid": "str",  # Optional. A unique
                                      ID for the database cluster to which the rule is applied.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the firewall rule was created.
                                    "uuid": "str"  # Optional. A unique ID for
                                      the firewall rule itself.
                                }
                            ],
                            "semantic_version": "str",  # Optional. A string representing
                              the semantic version of the database engine in use for the cluster.
                            "standby_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "standby_private_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "status": "str",  # Optional. A string representing the
                              current status of the database cluster. Known values are: "creating",
                              "online", "resizing", "migrating", and "forking".
                            "storage_size_mib": 0,  # Optional. Additional storage added
                              to the cluster, in MiB. If null, no additional storage is added to the
                              cluster, beyond what is provided as a base amount from the 'size' and any
                              previously added additional storage.
                            "tags": [
                                "str"  # Optional. An array of tags that have been
                                  applied to the database cluster.
                            ],
                            "ui_connection": {
                                "host": "str",  # Optional. The FQDN pointing to the
                                  opensearch cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  opensearch dashboard is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  opensearch dashboard.
                            },
                            "users": [
                                {
                                    "name": "str",  # The name of a database
                                      user. Required.
                                    "access_cert": "str",  # Optional. Access
                                      certificate for TLS client authentication. (Kafka only).
                                    "access_key": "str",  # Optional. Access key
                                      for TLS client authentication. (Kafka only).
                                    "mysql_settings": {
                                        "auth_plugin": "str"  # A string
                                          specifying the authentication method to be used for
                                          connections to the MySQL user account. The valid values are
                                          ``mysql_native_password`` or ``caching_sha2_password``. If
                                          excluded when creating a new user, the default for the
                                          version of MySQL in use will be used. As of MySQL 8.0, the
                                          default is ``caching_sha2_password``. Required. Known values
                                          are: "mysql_native_password" and "caching_sha2_password".
                                    },
                                    "password": "str",  # Optional. A randomly
                                      generated password for the database user.
                                    "role": "str",  # Optional. A string
                                      representing the database user's role. The value will be either
                                      "primary" or "normal". Known values are: "primary" and "normal".
                                    "settings": {
                                        "acl": [
                                            {
                                                "permission": "str",
                                                  # Permission set applied to the ACL. 'consume' allows
                                                  for messages to be consumed from the topic. 'produce'
                                                  allows for messages to be published to the topic.
                                                  'produceconsume' allows for both 'consume' and
                                                  'produce' permission. 'admin' allows for
                                                  'produceconsume' as well as any operations to
                                                  administer the topic (delete, update). Required.
                                                  Known values are: "admin", "consume", "produce", and
                                                  "produceconsume".
                                                "topic": "str",  # A
                                                  regex for matching the topic(s) that this ACL should
                                                  apply to. Required.
                                                "id": "str"  #
                                                  Optional. An identifier for the ACL. Will be computed
                                                  after the ACL is created/updated.
                                            }
                                        ],
                                        "opensearch_acl": [
                                            {
                                                "index": "str",  #
                                                  Optional. A regex for matching the indexes that this
                                                  ACL should apply to.
                                                "permission": "str"
                                                  # Optional. Permission set applied to the ACL. 'read'
                                                  allows user to read from the index. 'write' allows
                                                  for user to write to the index. 'readwrite' allows
                                                  for both 'read' and 'write' permission.
                                                  'deny'(default) restricts user from performing any
                                                  operation over an index. 'admin' allows for
                                                  'readwrite' as well as any operations to administer
                                                  the index. Known values are: "deny", "admin", "read",
                                                  "readwrite", and "write".
                                            }
                                        ],
                                        "pg_allow_replication": bool  #
                                          Optional. For Postgres clusters, set to ``true`` for a user
                                          with replication rights. This option is not currently
                                          supported for other database engines.
                                    }
                                }
                            ],
                            "version": "str",  # Optional. A string representing the
                              version of the database engine in use for the cluster.
                            "version_end_of_availability": "str",  # Optional. A
                              timestamp referring to the date when the particular version will no
                              longer be available for creating new clusters. If null, the version does
                              not have an end of availability timeline.
                            "version_end_of_life": "str"  # Optional. A timestamp
                              referring to the date when the particular version will no longer be
                              supported. If null, the version does not have an end of life timeline.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_clusters_request(
            tag_name=tag_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_cluster(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Database Cluster.

        To create a database cluster, send a POST request to ``/v2/databases``. To see a list  of
        options for each engine, such as available regions, size slugs, and versions, send a GET
        request to the ``/v2/databases/options`` endpoint. The available sizes for  the
        ``storage_size_mib`` field depends on the cluster's size. To see a list of available sizes, see
        `Managed Database Pricing <https://www.digitalocean.com/pricing/managed-databases>`_.

        The create response returns a JSON object with a key called ``database``. The value of this is
        an object that contains the standard attributes associated with a database cluster. The initial
        value of the database cluster's ``status`` attribute is ``creating``. When the cluster is ready
        to receive traffic, this changes to ``online``.

        The embedded ``connection`` and ``private_connection`` objects contains the information needed
        to access the database cluster. For multi-node clusters, the ``standby_connection`` and
        ``standby_private_connection`` objects contain the information needed to connect to the
        cluster's standby node(s).

        DigitalOcean managed PostgreSQL and MySQL database clusters take automated daily backups. To
        create a new database cluster based on a backup of an existing cluster, send a POST request to
        ``/v2/databases``. In addition to the standard database cluster attributes, the JSON body must
        include a key named ``backup_restore`` with the name of the original database cluster and the
        timestamp of the backup to be restored. Creating a database from a backup is the same as
        forking a database in the control panel.
        Note: Backups are not supported for Redis clusters.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "engine": "str",  # A slug representing the database engine used for the
                      cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis"
                      for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch" for
                      OpenSearch. Required. Known values are: "pg", "mysql", "redis", "mongodb",
                      "kafka", and "opensearch".
                    "name": "str",  # A unique, human-readable name referring to a database
                      cluster. Required.
                    "num_nodes": 0,  # The number of nodes in the database cluster. Required.
                    "region": "str",  # The slug identifier for the region where the database
                      cluster is located. Required.
                    "size": "str",  # The slug identifier representing the size of the nodes in
                      the database cluster. Required.
                    "backup_restore": {
                        "database_name": "str",  # The name of an existing database cluster
                          from which the backup will be restored. Required.
                        "backup_created_at": "2020-02-20 00:00:00"  # Optional. The timestamp
                          of an existing database cluster backup in ISO8601 combined date and time
                          format. The most recent backup will be used if excluded.
                    },
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the database cluster
                      was created.
                    "db_names": [
                        "str"  # Optional. An array of strings containing the names of
                          databases created in the database cluster.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a database cluster.
                    "maintenance_window": {
                        "day": "str",  # The day of the week on which to apply maintenance
                          updates. Required.
                        "hour": "str",  # The hour in UTC at which maintenance updates will
                          be applied in 24 hour format. Required.
                        "description": [
                            "str"  # Optional. A list of strings, each containing
                              information about a pending maintenance update.
                        ],
                        "pending": bool  # Optional. A boolean value indicating whether any
                          maintenance is scheduled to be performed in the next window.
                    },
                    "metrics_endpoints": [
                        {
                            "host": "str",  # Optional. A FQDN pointing to the database
                              cluster's node(s).
                            "port": 0  # Optional. The port on which a service is
                              listening.
                        }
                    ],
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_network_uuid": "str",  # Optional. A string specifying the UUID of
                      the VPC to which the database cluster will be assigned. If excluded, the cluster
                      when creating a new database cluster, it will be assigned to your account's
                      default VPC for the region.
                    "project_id": "str",  # Optional. The ID of the project that the database
                      cluster is assigned to. If excluded when creating a new database cluster, it will
                      be assigned to your default project.
                    "rules": [
                        {
                            "type": "str",  # The type of resource that the firewall rule
                              allows to access the database cluster. Required. Known values are:
                              "droplet", "k8s", "ip_addr", "tag", and "app".
                            "value": "str",  # The ID of the specific resource, the name
                              of a tag applied to a group of resources, or the IP address that the
                              firewall rule allows to access the database cluster. Required.
                            "cluster_uuid": "str",  # Optional. A unique ID for the
                              database cluster to which the rule is applied.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall rule was created.
                            "uuid": "str"  # Optional. A unique ID for the firewall rule
                              itself.
                        }
                    ],
                    "semantic_version": "str",  # Optional. A string representing the semantic
                      version of the database engine in use for the cluster.
                    "standby_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "status": "str",  # Optional. A string representing the current status of the
                      database cluster. Known values are: "creating", "online", "resizing",
                      "migrating", and "forking".
                    "storage_size_mib": 0,  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                    "tags": [
                        "str"  # Optional. An array of tags that have been applied to the
                          database cluster.
                    ],
                    "ui_connection": {
                        "host": "str",  # Optional. The FQDN pointing to the opensearch
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the opensearch dashboard is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. This is provided as a convenience and
                          should be able to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the opensearch
                          dashboard.
                    },
                    "users": [
                        {
                            "name": "str",  # The name of a database user. Required.
                            "access_cert": "str",  # Optional. Access certificate for TLS
                              client authentication. (Kafka only).
                            "access_key": "str",  # Optional. Access key for TLS client
                              authentication. (Kafka only).
                            "mysql_settings": {
                                "auth_plugin": "str"  # A string specifying the
                                  authentication method to be used for connections to the MySQL user
                                  account. The valid values are ``mysql_native_password`` or
                                  ``caching_sha2_password``. If excluded when creating a new user, the
                                  default for the version of MySQL in use will be used. As of MySQL
                                  8.0, the default is ``caching_sha2_password``. Required. Known values
                                  are: "mysql_native_password" and "caching_sha2_password".
                            },
                            "password": "str",  # Optional. A randomly generated password
                              for the database user.
                            "role": "str",  # Optional. A string representing the
                              database user's role. The value will be either "primary" or "normal".
                              Known values are: "primary" and "normal".
                            "settings": {
                                "acl": [
                                    {
                                        "permission": "str",  # Permission
                                          set applied to the ACL. 'consume' allows for messages to be
                                          consumed from the topic. 'produce' allows for messages to be
                                          published to the topic. 'produceconsume' allows for both
                                          'consume' and 'produce' permission. 'admin' allows for
                                          'produceconsume' as well as any operations to administer the
                                          topic (delete, update). Required. Known values are: "admin",
                                          "consume", "produce", and "produceconsume".
                                        "topic": "str",  # A regex for
                                          matching the topic(s) that this ACL should apply to.
                                          Required.
                                        "id": "str"  # Optional. An
                                          identifier for the ACL. Will be computed after the ACL is
                                          created/updated.
                                    }
                                ],
                                "opensearch_acl": [
                                    {
                                        "index": "str",  # Optional. A regex
                                          for matching the indexes that this ACL should apply to.
                                        "permission": "str"  # Optional.
                                          Permission set applied to the ACL. 'read' allows user to read
                                          from the index. 'write' allows for user to write to the
                                          index. 'readwrite' allows for both 'read' and 'write'
                                          permission. 'deny'(default) restricts user from performing
                                          any operation over an index. 'admin' allows for 'readwrite'
                                          as well as any operations to administer the index. Known
                                          values are: "deny", "admin", "read", "readwrite", and
                                          "write".
                                    }
                                ],
                                "pg_allow_replication": bool  # Optional. For
                                  Postgres clusters, set to ``true`` for a user with replication
                                  rights. This option is not currently supported for other database
                                  engines.
                            }
                        }
                    ],
                    "version": "str",  # Optional. A string representing the version of the
                      database engine in use for the cluster.
                    "version_end_of_availability": "str",  # Optional. A timestamp referring to
                      the date when the particular version will no longer be available for creating new
                      clusters. If null, the version does not have an end of availability timeline.
                    "version_end_of_life": "str"  # Optional. A timestamp referring to the date
                      when the particular version will no longer be supported. If null, the version
                      does not have an end of life timeline.
                }

                # response body for status code(s): 201
                response == {
                    "database": {
                        "engine": "str",  # A slug representing the database engine used for
                          the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL,
                          "redis" for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch"
                          for OpenSearch. Required. Known values are: "pg", "mysql", "redis",
                          "mongodb", "kafka", and "opensearch".
                        "name": "str",  # A unique, human-readable name referring to a
                          database cluster. Required.
                        "num_nodes": 0,  # The number of nodes in the database cluster.
                          Required.
                        "region": "str",  # The slug identifier for the region where the
                          database cluster is located. Required.
                        "size": "str",  # The slug identifier representing the size of the
                          nodes in the database cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "db_names": [
                            "str"  # Optional. An array of strings containing the names
                              of databases created in the database cluster.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database cluster.
                        "maintenance_window": {
                            "day": "str",  # The day of the week on which to apply
                              maintenance updates. Required.
                            "hour": "str",  # The hour in UTC at which maintenance
                              updates will be applied in 24 hour format. Required.
                            "description": [
                                "str"  # Optional. A list of strings, each containing
                                  information about a pending maintenance update.
                            ],
                            "pending": bool  # Optional. A boolean value indicating
                              whether any maintenance is scheduled to be performed in the next window.
                        },
                        "metrics_endpoints": [
                            {
                                "host": "str",  # Optional. A FQDN pointing to the
                                  database cluster's node(s).
                                "port": 0  # Optional. The port on which a service is
                                  listening.
                            }
                        ],
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the database cluster will be assigned. If excluded,
                          the cluster when creating a new database cluster, it will be assigned to your
                          account's default VPC for the region.
                        "project_id": "str",  # Optional. The ID of the project that the
                          database cluster is assigned to. If excluded when creating a new database
                          cluster, it will be assigned to your default project.
                        "rules": [
                            {
                                "type": "str",  # The type of resource that the
                                  firewall rule allows to access the database cluster. Required. Known
                                  values are: "droplet", "k8s", "ip_addr", "tag", and "app".
                                "value": "str",  # The ID of the specific resource,
                                  the name of a tag applied to a group of resources, or the IP address
                                  that the firewall rule allows to access the database cluster.
                                  Required.
                                "cluster_uuid": "str",  # Optional. A unique ID for
                                  the database cluster to which the rule is applied.
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the firewall rule was created.
                                "uuid": "str"  # Optional. A unique ID for the
                                  firewall rule itself.
                            }
                        ],
                        "semantic_version": "str",  # Optional. A string representing the
                          semantic version of the database engine in use for the cluster.
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. An array of tags that have been applied to
                              the database cluster.
                        ],
                        "ui_connection": {
                            "host": "str",  # Optional. The FQDN pointing to the
                              opensearch cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the opensearch
                              dashboard is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. This is provided as a convenience
                              and should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the
                              opensearch dashboard.
                        },
                        "users": [
                            {
                                "name": "str",  # The name of a database user.
                                  Required.
                                "access_cert": "str",  # Optional. Access certificate
                                  for TLS client authentication. (Kafka only).
                                "access_key": "str",  # Optional. Access key for TLS
                                  client authentication. (Kafka only).
                                "mysql_settings": {
                                    "auth_plugin": "str"  # A string specifying
                                      the authentication method to be used for connections to the MySQL
                                      user account. The valid values are ``mysql_native_password`` or
                                      ``caching_sha2_password``. If excluded when creating a new user,
                                      the default for the version of MySQL in use will be used. As of
                                      MySQL 8.0, the default is ``caching_sha2_password``. Required.
                                      Known values are: "mysql_native_password" and
                                      "caching_sha2_password".
                                },
                                "password": "str",  # Optional. A randomly generated
                                  password for the database user.
                                "role": "str",  # Optional. A string representing the
                                  database user's role. The value will be either "primary" or "normal".
                                  Known values are: "primary" and "normal".
                                "settings": {
                                    "acl": [
                                        {
                                            "permission": "str",  #
                                              Permission set applied to the ACL. 'consume' allows for
                                              messages to be consumed from the topic. 'produce' allows
                                              for messages to be published to the topic.
                                              'produceconsume' allows for both 'consume' and 'produce'
                                              permission. 'admin' allows for 'produceconsume' as well
                                              as any operations to administer the topic (delete,
                                              update). Required. Known values are: "admin", "consume",
                                              "produce", and "produceconsume".
                                            "topic": "str",  # A regex
                                              for matching the topic(s) that this ACL should apply to.
                                              Required.
                                            "id": "str"  # Optional. An
                                              identifier for the ACL. Will be computed after the ACL is
                                              created/updated.
                                        }
                                    ],
                                    "opensearch_acl": [
                                        {
                                            "index": "str",  # Optional.
                                              A regex for matching the indexes that this ACL should
                                              apply to.
                                            "permission": "str"  #
                                              Optional. Permission set applied to the ACL. 'read'
                                              allows user to read from the index. 'write' allows for
                                              user to write to the index. 'readwrite' allows for both
                                              'read' and 'write' permission. 'deny'(default) restricts
                                              user from performing any operation over an index. 'admin'
                                              allows for 'readwrite' as well as any operations to
                                              administer the index. Known values are: "deny", "admin",
                                              "read", "readwrite", and "write".
                                        }
                                    ],
                                    "pg_allow_replication": bool  # Optional. For
                                      Postgres clusters, set to ``true`` for a user with replication
                                      rights. This option is not currently supported for other database
                                      engines.
                                }
                            }
                        ],
                        "version": "str",  # Optional. A string representing the version of
                          the database engine in use for the cluster.
                        "version_end_of_availability": "str",  # Optional. A timestamp
                          referring to the date when the particular version will no longer be available
                          for creating new clusters. If null, the version does not have an end of
                          availability timeline.
                        "version_end_of_life": "str"  # Optional. A timestamp referring to
                          the date when the particular version will no longer be supported. If null,
                          the version does not have an end of life timeline.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_cluster(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Database Cluster.

        To create a database cluster, send a POST request to ``/v2/databases``. To see a list  of
        options for each engine, such as available regions, size slugs, and versions, send a GET
        request to the ``/v2/databases/options`` endpoint. The available sizes for  the
        ``storage_size_mib`` field depends on the cluster's size. To see a list of available sizes, see
        `Managed Database Pricing <https://www.digitalocean.com/pricing/managed-databases>`_.

        The create response returns a JSON object with a key called ``database``. The value of this is
        an object that contains the standard attributes associated with a database cluster. The initial
        value of the database cluster's ``status`` attribute is ``creating``. When the cluster is ready
        to receive traffic, this changes to ``online``.

        The embedded ``connection`` and ``private_connection`` objects contains the information needed
        to access the database cluster. For multi-node clusters, the ``standby_connection`` and
        ``standby_private_connection`` objects contain the information needed to connect to the
        cluster's standby node(s).

        DigitalOcean managed PostgreSQL and MySQL database clusters take automated daily backups. To
        create a new database cluster based on a backup of an existing cluster, send a POST request to
        ``/v2/databases``. In addition to the standard database cluster attributes, the JSON body must
        include a key named ``backup_restore`` with the name of the original database cluster and the
        timestamp of the backup to be restored. Creating a database from a backup is the same as
        forking a database in the control panel.
        Note: Backups are not supported for Redis clusters.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "database": {
                        "engine": "str",  # A slug representing the database engine used for
                          the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL,
                          "redis" for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch"
                          for OpenSearch. Required. Known values are: "pg", "mysql", "redis",
                          "mongodb", "kafka", and "opensearch".
                        "name": "str",  # A unique, human-readable name referring to a
                          database cluster. Required.
                        "num_nodes": 0,  # The number of nodes in the database cluster.
                          Required.
                        "region": "str",  # The slug identifier for the region where the
                          database cluster is located. Required.
                        "size": "str",  # The slug identifier representing the size of the
                          nodes in the database cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "db_names": [
                            "str"  # Optional. An array of strings containing the names
                              of databases created in the database cluster.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database cluster.
                        "maintenance_window": {
                            "day": "str",  # The day of the week on which to apply
                              maintenance updates. Required.
                            "hour": "str",  # The hour in UTC at which maintenance
                              updates will be applied in 24 hour format. Required.
                            "description": [
                                "str"  # Optional. A list of strings, each containing
                                  information about a pending maintenance update.
                            ],
                            "pending": bool  # Optional. A boolean value indicating
                              whether any maintenance is scheduled to be performed in the next window.
                        },
                        "metrics_endpoints": [
                            {
                                "host": "str",  # Optional. A FQDN pointing to the
                                  database cluster's node(s).
                                "port": 0  # Optional. The port on which a service is
                                  listening.
                            }
                        ],
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the database cluster will be assigned. If excluded,
                          the cluster when creating a new database cluster, it will be assigned to your
                          account's default VPC for the region.
                        "project_id": "str",  # Optional. The ID of the project that the
                          database cluster is assigned to. If excluded when creating a new database
                          cluster, it will be assigned to your default project.
                        "rules": [
                            {
                                "type": "str",  # The type of resource that the
                                  firewall rule allows to access the database cluster. Required. Known
                                  values are: "droplet", "k8s", "ip_addr", "tag", and "app".
                                "value": "str",  # The ID of the specific resource,
                                  the name of a tag applied to a group of resources, or the IP address
                                  that the firewall rule allows to access the database cluster.
                                  Required.
                                "cluster_uuid": "str",  # Optional. A unique ID for
                                  the database cluster to which the rule is applied.
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the firewall rule was created.
                                "uuid": "str"  # Optional. A unique ID for the
                                  firewall rule itself.
                            }
                        ],
                        "semantic_version": "str",  # Optional. A string representing the
                          semantic version of the database engine in use for the cluster.
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. An array of tags that have been applied to
                              the database cluster.
                        ],
                        "ui_connection": {
                            "host": "str",  # Optional. The FQDN pointing to the
                              opensearch cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the opensearch
                              dashboard is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. This is provided as a convenience
                              and should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the
                              opensearch dashboard.
                        },
                        "users": [
                            {
                                "name": "str",  # The name of a database user.
                                  Required.
                                "access_cert": "str",  # Optional. Access certificate
                                  for TLS client authentication. (Kafka only).
                                "access_key": "str",  # Optional. Access key for TLS
                                  client authentication. (Kafka only).
                                "mysql_settings": {
                                    "auth_plugin": "str"  # A string specifying
                                      the authentication method to be used for connections to the MySQL
                                      user account. The valid values are ``mysql_native_password`` or
                                      ``caching_sha2_password``. If excluded when creating a new user,
                                      the default for the version of MySQL in use will be used. As of
                                      MySQL 8.0, the default is ``caching_sha2_password``. Required.
                                      Known values are: "mysql_native_password" and
                                      "caching_sha2_password".
                                },
                                "password": "str",  # Optional. A randomly generated
                                  password for the database user.
                                "role": "str",  # Optional. A string representing the
                                  database user's role. The value will be either "primary" or "normal".
                                  Known values are: "primary" and "normal".
                                "settings": {
                                    "acl": [
                                        {
                                            "permission": "str",  #
                                              Permission set applied to the ACL. 'consume' allows for
                                              messages to be consumed from the topic. 'produce' allows
                                              for messages to be published to the topic.
                                              'produceconsume' allows for both 'consume' and 'produce'
                                              permission. 'admin' allows for 'produceconsume' as well
                                              as any operations to administer the topic (delete,
                                              update). Required. Known values are: "admin", "consume",
                                              "produce", and "produceconsume".
                                            "topic": "str",  # A regex
                                              for matching the topic(s) that this ACL should apply to.
                                              Required.
                                            "id": "str"  # Optional. An
                                              identifier for the ACL. Will be computed after the ACL is
                                              created/updated.
                                        }
                                    ],
                                    "opensearch_acl": [
                                        {
                                            "index": "str",  # Optional.
                                              A regex for matching the indexes that this ACL should
                                              apply to.
                                            "permission": "str"  #
                                              Optional. Permission set applied to the ACL. 'read'
                                              allows user to read from the index. 'write' allows for
                                              user to write to the index. 'readwrite' allows for both
                                              'read' and 'write' permission. 'deny'(default) restricts
                                              user from performing any operation over an index. 'admin'
                                              allows for 'readwrite' as well as any operations to
                                              administer the index. Known values are: "deny", "admin",
                                              "read", "readwrite", and "write".
                                        }
                                    ],
                                    "pg_allow_replication": bool  # Optional. For
                                      Postgres clusters, set to ``true`` for a user with replication
                                      rights. This option is not currently supported for other database
                                      engines.
                                }
                            }
                        ],
                        "version": "str",  # Optional. A string representing the version of
                          the database engine in use for the cluster.
                        "version_end_of_availability": "str",  # Optional. A timestamp
                          referring to the date when the particular version will no longer be available
                          for creating new clusters. If null, the version does not have an end of
                          availability timeline.
                        "version_end_of_life": "str"  # Optional. A timestamp referring to
                          the date when the particular version will no longer be supported. If null,
                          the version does not have an end of life timeline.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_cluster(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Database Cluster.

        To create a database cluster, send a POST request to ``/v2/databases``. To see a list  of
        options for each engine, such as available regions, size slugs, and versions, send a GET
        request to the ``/v2/databases/options`` endpoint. The available sizes for  the
        ``storage_size_mib`` field depends on the cluster's size. To see a list of available sizes, see
        `Managed Database Pricing <https://www.digitalocean.com/pricing/managed-databases>`_.

        The create response returns a JSON object with a key called ``database``. The value of this is
        an object that contains the standard attributes associated with a database cluster. The initial
        value of the database cluster's ``status`` attribute is ``creating``. When the cluster is ready
        to receive traffic, this changes to ``online``.

        The embedded ``connection`` and ``private_connection`` objects contains the information needed
        to access the database cluster. For multi-node clusters, the ``standby_connection`` and
        ``standby_private_connection`` objects contain the information needed to connect to the
        cluster's standby node(s).

        DigitalOcean managed PostgreSQL and MySQL database clusters take automated daily backups. To
        create a new database cluster based on a backup of an existing cluster, send a POST request to
        ``/v2/databases``. In addition to the standard database cluster attributes, the JSON body must
        include a key named ``backup_restore`` with the name of the original database cluster and the
        timestamp of the backup to be restored. Creating a database from a backup is the same as
        forking a database in the control panel.
        Note: Backups are not supported for Redis clusters.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "engine": "str",  # A slug representing the database engine used for the
                      cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL, "redis"
                      for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch" for
                      OpenSearch. Required. Known values are: "pg", "mysql", "redis", "mongodb",
                      "kafka", and "opensearch".
                    "name": "str",  # A unique, human-readable name referring to a database
                      cluster. Required.
                    "num_nodes": 0,  # The number of nodes in the database cluster. Required.
                    "region": "str",  # The slug identifier for the region where the database
                      cluster is located. Required.
                    "size": "str",  # The slug identifier representing the size of the nodes in
                      the database cluster. Required.
                    "backup_restore": {
                        "database_name": "str",  # The name of an existing database cluster
                          from which the backup will be restored. Required.
                        "backup_created_at": "2020-02-20 00:00:00"  # Optional. The timestamp
                          of an existing database cluster backup in ISO8601 combined date and time
                          format. The most recent backup will be used if excluded.
                    },
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the database cluster
                      was created.
                    "db_names": [
                        "str"  # Optional. An array of strings containing the names of
                          databases created in the database cluster.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a database cluster.
                    "maintenance_window": {
                        "day": "str",  # The day of the week on which to apply maintenance
                          updates. Required.
                        "hour": "str",  # The hour in UTC at which maintenance updates will
                          be applied in 24 hour format. Required.
                        "description": [
                            "str"  # Optional. A list of strings, each containing
                              information about a pending maintenance update.
                        ],
                        "pending": bool  # Optional. A boolean value indicating whether any
                          maintenance is scheduled to be performed in the next window.
                    },
                    "metrics_endpoints": [
                        {
                            "host": "str",  # Optional. A FQDN pointing to the database
                              cluster's node(s).
                            "port": 0  # Optional. The port on which a service is
                              listening.
                        }
                    ],
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_network_uuid": "str",  # Optional. A string specifying the UUID of
                      the VPC to which the database cluster will be assigned. If excluded, the cluster
                      when creating a new database cluster, it will be assigned to your account's
                      default VPC for the region.
                    "project_id": "str",  # Optional. The ID of the project that the database
                      cluster is assigned to. If excluded when creating a new database cluster, it will
                      be assigned to your default project.
                    "rules": [
                        {
                            "type": "str",  # The type of resource that the firewall rule
                              allows to access the database cluster. Required. Known values are:
                              "droplet", "k8s", "ip_addr", "tag", and "app".
                            "value": "str",  # The ID of the specific resource, the name
                              of a tag applied to a group of resources, or the IP address that the
                              firewall rule allows to access the database cluster. Required.
                            "cluster_uuid": "str",  # Optional. A unique ID for the
                              database cluster to which the rule is applied.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall rule was created.
                            "uuid": "str"  # Optional. A unique ID for the firewall rule
                              itself.
                        }
                    ],
                    "semantic_version": "str",  # Optional. A string representing the semantic
                      version of the database engine in use for the cluster.
                    "standby_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "status": "str",  # Optional. A string representing the current status of the
                      database cluster. Known values are: "creating", "online", "resizing",
                      "migrating", and "forking".
                    "storage_size_mib": 0,  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                    "tags": [
                        "str"  # Optional. An array of tags that have been applied to the
                          database cluster.
                    ],
                    "ui_connection": {
                        "host": "str",  # Optional. The FQDN pointing to the opensearch
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the opensearch dashboard is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. This is provided as a convenience and
                          should be able to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the opensearch
                          dashboard.
                    },
                    "users": [
                        {
                            "name": "str",  # The name of a database user. Required.
                            "access_cert": "str",  # Optional. Access certificate for TLS
                              client authentication. (Kafka only).
                            "access_key": "str",  # Optional. Access key for TLS client
                              authentication. (Kafka only).
                            "mysql_settings": {
                                "auth_plugin": "str"  # A string specifying the
                                  authentication method to be used for connections to the MySQL user
                                  account. The valid values are ``mysql_native_password`` or
                                  ``caching_sha2_password``. If excluded when creating a new user, the
                                  default for the version of MySQL in use will be used. As of MySQL
                                  8.0, the default is ``caching_sha2_password``. Required. Known values
                                  are: "mysql_native_password" and "caching_sha2_password".
                            },
                            "password": "str",  # Optional. A randomly generated password
                              for the database user.
                            "role": "str",  # Optional. A string representing the
                              database user's role. The value will be either "primary" or "normal".
                              Known values are: "primary" and "normal".
                            "settings": {
                                "acl": [
                                    {
                                        "permission": "str",  # Permission
                                          set applied to the ACL. 'consume' allows for messages to be
                                          consumed from the topic. 'produce' allows for messages to be
                                          published to the topic. 'produceconsume' allows for both
                                          'consume' and 'produce' permission. 'admin' allows for
                                          'produceconsume' as well as any operations to administer the
                                          topic (delete, update). Required. Known values are: "admin",
                                          "consume", "produce", and "produceconsume".
                                        "topic": "str",  # A regex for
                                          matching the topic(s) that this ACL should apply to.
                                          Required.
                                        "id": "str"  # Optional. An
                                          identifier for the ACL. Will be computed after the ACL is
                                          created/updated.
                                    }
                                ],
                                "opensearch_acl": [
                                    {
                                        "index": "str",  # Optional. A regex
                                          for matching the indexes that this ACL should apply to.
                                        "permission": "str"  # Optional.
                                          Permission set applied to the ACL. 'read' allows user to read
                                          from the index. 'write' allows for user to write to the
                                          index. 'readwrite' allows for both 'read' and 'write'
                                          permission. 'deny'(default) restricts user from performing
                                          any operation over an index. 'admin' allows for 'readwrite'
                                          as well as any operations to administer the index. Known
                                          values are: "deny", "admin", "read", "readwrite", and
                                          "write".
                                    }
                                ],
                                "pg_allow_replication": bool  # Optional. For
                                  Postgres clusters, set to ``true`` for a user with replication
                                  rights. This option is not currently supported for other database
                                  engines.
                            }
                        }
                    ],
                    "version": "str",  # Optional. A string representing the version of the
                      database engine in use for the cluster.
                    "version_end_of_availability": "str",  # Optional. A timestamp referring to
                      the date when the particular version will no longer be available for creating new
                      clusters. If null, the version does not have an end of availability timeline.
                    "version_end_of_life": "str"  # Optional. A timestamp referring to the date
                      when the particular version will no longer be supported. If null, the version
                      does not have an end of life timeline.
                }

                # response body for status code(s): 201
                response == {
                    "database": {
                        "engine": "str",  # A slug representing the database engine used for
                          the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL,
                          "redis" for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch"
                          for OpenSearch. Required. Known values are: "pg", "mysql", "redis",
                          "mongodb", "kafka", and "opensearch".
                        "name": "str",  # A unique, human-readable name referring to a
                          database cluster. Required.
                        "num_nodes": 0,  # The number of nodes in the database cluster.
                          Required.
                        "region": "str",  # The slug identifier for the region where the
                          database cluster is located. Required.
                        "size": "str",  # The slug identifier representing the size of the
                          nodes in the database cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "db_names": [
                            "str"  # Optional. An array of strings containing the names
                              of databases created in the database cluster.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database cluster.
                        "maintenance_window": {
                            "day": "str",  # The day of the week on which to apply
                              maintenance updates. Required.
                            "hour": "str",  # The hour in UTC at which maintenance
                              updates will be applied in 24 hour format. Required.
                            "description": [
                                "str"  # Optional. A list of strings, each containing
                                  information about a pending maintenance update.
                            ],
                            "pending": bool  # Optional. A boolean value indicating
                              whether any maintenance is scheduled to be performed in the next window.
                        },
                        "metrics_endpoints": [
                            {
                                "host": "str",  # Optional. A FQDN pointing to the
                                  database cluster's node(s).
                                "port": 0  # Optional. The port on which a service is
                                  listening.
                            }
                        ],
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the database cluster will be assigned. If excluded,
                          the cluster when creating a new database cluster, it will be assigned to your
                          account's default VPC for the region.
                        "project_id": "str",  # Optional. The ID of the project that the
                          database cluster is assigned to. If excluded when creating a new database
                          cluster, it will be assigned to your default project.
                        "rules": [
                            {
                                "type": "str",  # The type of resource that the
                                  firewall rule allows to access the database cluster. Required. Known
                                  values are: "droplet", "k8s", "ip_addr", "tag", and "app".
                                "value": "str",  # The ID of the specific resource,
                                  the name of a tag applied to a group of resources, or the IP address
                                  that the firewall rule allows to access the database cluster.
                                  Required.
                                "cluster_uuid": "str",  # Optional. A unique ID for
                                  the database cluster to which the rule is applied.
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the firewall rule was created.
                                "uuid": "str"  # Optional. A unique ID for the
                                  firewall rule itself.
                            }
                        ],
                        "semantic_version": "str",  # Optional. A string representing the
                          semantic version of the database engine in use for the cluster.
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. An array of tags that have been applied to
                              the database cluster.
                        ],
                        "ui_connection": {
                            "host": "str",  # Optional. The FQDN pointing to the
                              opensearch cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the opensearch
                              dashboard is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. This is provided as a convenience
                              and should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the
                              opensearch dashboard.
                        },
                        "users": [
                            {
                                "name": "str",  # The name of a database user.
                                  Required.
                                "access_cert": "str",  # Optional. Access certificate
                                  for TLS client authentication. (Kafka only).
                                "access_key": "str",  # Optional. Access key for TLS
                                  client authentication. (Kafka only).
                                "mysql_settings": {
                                    "auth_plugin": "str"  # A string specifying
                                      the authentication method to be used for connections to the MySQL
                                      user account. The valid values are ``mysql_native_password`` or
                                      ``caching_sha2_password``. If excluded when creating a new user,
                                      the default for the version of MySQL in use will be used. As of
                                      MySQL 8.0, the default is ``caching_sha2_password``. Required.
                                      Known values are: "mysql_native_password" and
                                      "caching_sha2_password".
                                },
                                "password": "str",  # Optional. A randomly generated
                                  password for the database user.
                                "role": "str",  # Optional. A string representing the
                                  database user's role. The value will be either "primary" or "normal".
                                  Known values are: "primary" and "normal".
                                "settings": {
                                    "acl": [
                                        {
                                            "permission": "str",  #
                                              Permission set applied to the ACL. 'consume' allows for
                                              messages to be consumed from the topic. 'produce' allows
                                              for messages to be published to the topic.
                                              'produceconsume' allows for both 'consume' and 'produce'
                                              permission. 'admin' allows for 'produceconsume' as well
                                              as any operations to administer the topic (delete,
                                              update). Required. Known values are: "admin", "consume",
                                              "produce", and "produceconsume".
                                            "topic": "str",  # A regex
                                              for matching the topic(s) that this ACL should apply to.
                                              Required.
                                            "id": "str"  # Optional. An
                                              identifier for the ACL. Will be computed after the ACL is
                                              created/updated.
                                        }
                                    ],
                                    "opensearch_acl": [
                                        {
                                            "index": "str",  # Optional.
                                              A regex for matching the indexes that this ACL should
                                              apply to.
                                            "permission": "str"  #
                                              Optional. Permission set applied to the ACL. 'read'
                                              allows user to read from the index. 'write' allows for
                                              user to write to the index. 'readwrite' allows for both
                                              'read' and 'write' permission. 'deny'(default) restricts
                                              user from performing any operation over an index. 'admin'
                                              allows for 'readwrite' as well as any operations to
                                              administer the index. Known values are: "deny", "admin",
                                              "read", "readwrite", and "write".
                                        }
                                    ],
                                    "pg_allow_replication": bool  # Optional. For
                                      Postgres clusters, set to ``true`` for a user with replication
                                      rights. This option is not currently supported for other database
                                      engines.
                                }
                            }
                        ],
                        "version": "str",  # Optional. A string representing the version of
                          the database engine in use for the cluster.
                        "version_end_of_availability": "str",  # Optional. A timestamp
                          referring to the date when the particular version will no longer be available
                          for creating new clusters. If null, the version does not have an end of
                          availability timeline.
                        "version_end_of_life": "str"  # Optional. A timestamp referring to
                          the date when the particular version will no longer be supported. If null,
                          the version does not have an end of life timeline.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_create_cluster_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_cluster(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Database Cluster.

        To show information about an existing database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID``.

        The response will be a JSON object with a database key. This will be set to an object
        containing the standard database cluster attributes.

        The embedded ``connection`` and ``private_connection`` objects will contain the information
        needed to access the database cluster. For multi-node clusters, the ``standby_connection`` and
        ``standby_private_connection`` objects contain the information needed to connect to the
        cluster's standby node(s).

        The embedded maintenance_window object will contain information about any scheduled maintenance
        for the database cluster.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "database": {
                        "engine": "str",  # A slug representing the database engine used for
                          the cluster. The possible values are: "pg" for PostgreSQL, "mysql" for MySQL,
                          "redis" for Redis, "mongodb" for MongoDB, "kafka" for Kafka, and "opensearch"
                          for OpenSearch. Required. Known values are: "pg", "mysql", "redis",
                          "mongodb", "kafka", and "opensearch".
                        "name": "str",  # A unique, human-readable name referring to a
                          database cluster. Required.
                        "num_nodes": 0,  # The number of nodes in the database cluster.
                          Required.
                        "region": "str",  # The slug identifier for the region where the
                          database cluster is located. Required.
                        "size": "str",  # The slug identifier representing the size of the
                          nodes in the database cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "db_names": [
                            "str"  # Optional. An array of strings containing the names
                              of databases created in the database cluster.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database cluster.
                        "maintenance_window": {
                            "day": "str",  # The day of the week on which to apply
                              maintenance updates. Required.
                            "hour": "str",  # The hour in UTC at which maintenance
                              updates will be applied in 24 hour format. Required.
                            "description": [
                                "str"  # Optional. A list of strings, each containing
                                  information about a pending maintenance update.
                            ],
                            "pending": bool  # Optional. A boolean value indicating
                              whether any maintenance is scheduled to be performed in the next window.
                        },
                        "metrics_endpoints": [
                            {
                                "host": "str",  # Optional. A FQDN pointing to the
                                  database cluster's node(s).
                                "port": 0  # Optional. The port on which a service is
                                  listening.
                            }
                        ],
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the database cluster will be assigned. If excluded,
                          the cluster when creating a new database cluster, it will be assigned to your
                          account's default VPC for the region.
                        "project_id": "str",  # Optional. The ID of the project that the
                          database cluster is assigned to. If excluded when creating a new database
                          cluster, it will be assigned to your default project.
                        "rules": [
                            {
                                "type": "str",  # The type of resource that the
                                  firewall rule allows to access the database cluster. Required. Known
                                  values are: "droplet", "k8s", "ip_addr", "tag", and "app".
                                "value": "str",  # The ID of the specific resource,
                                  the name of a tag applied to a group of resources, or the IP address
                                  that the firewall rule allows to access the database cluster.
                                  Required.
                                "cluster_uuid": "str",  # Optional. A unique ID for
                                  the database cluster to which the rule is applied.
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the firewall rule was created.
                                "uuid": "str"  # Optional. A unique ID for the
                                  firewall rule itself.
                            }
                        ],
                        "semantic_version": "str",  # Optional. A string representing the
                          semantic version of the database engine in use for the cluster.
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. An array of tags that have been applied to
                              the database cluster.
                        ],
                        "ui_connection": {
                            "host": "str",  # Optional. The FQDN pointing to the
                              opensearch cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the opensearch
                              dashboard is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. This is provided as a convenience
                              and should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the
                              opensearch dashboard.
                        },
                        "users": [
                            {
                                "name": "str",  # The name of a database user.
                                  Required.
                                "access_cert": "str",  # Optional. Access certificate
                                  for TLS client authentication. (Kafka only).
                                "access_key": "str",  # Optional. Access key for TLS
                                  client authentication. (Kafka only).
                                "mysql_settings": {
                                    "auth_plugin": "str"  # A string specifying
                                      the authentication method to be used for connections to the MySQL
                                      user account. The valid values are ``mysql_native_password`` or
                                      ``caching_sha2_password``. If excluded when creating a new user,
                                      the default for the version of MySQL in use will be used. As of
                                      MySQL 8.0, the default is ``caching_sha2_password``. Required.
                                      Known values are: "mysql_native_password" and
                                      "caching_sha2_password".
                                },
                                "password": "str",  # Optional. A randomly generated
                                  password for the database user.
                                "role": "str",  # Optional. A string representing the
                                  database user's role. The value will be either "primary" or "normal".
                                  Known values are: "primary" and "normal".
                                "settings": {
                                    "acl": [
                                        {
                                            "permission": "str",  #
                                              Permission set applied to the ACL. 'consume' allows for
                                              messages to be consumed from the topic. 'produce' allows
                                              for messages to be published to the topic.
                                              'produceconsume' allows for both 'consume' and 'produce'
                                              permission. 'admin' allows for 'produceconsume' as well
                                              as any operations to administer the topic (delete,
                                              update). Required. Known values are: "admin", "consume",
                                              "produce", and "produceconsume".
                                            "topic": "str",  # A regex
                                              for matching the topic(s) that this ACL should apply to.
                                              Required.
                                            "id": "str"  # Optional. An
                                              identifier for the ACL. Will be computed after the ACL is
                                              created/updated.
                                        }
                                    ],
                                    "opensearch_acl": [
                                        {
                                            "index": "str",  # Optional.
                                              A regex for matching the indexes that this ACL should
                                              apply to.
                                            "permission": "str"  #
                                              Optional. Permission set applied to the ACL. 'read'
                                              allows user to read from the index. 'write' allows for
                                              user to write to the index. 'readwrite' allows for both
                                              'read' and 'write' permission. 'deny'(default) restricts
                                              user from performing any operation over an index. 'admin'
                                              allows for 'readwrite' as well as any operations to
                                              administer the index. Known values are: "deny", "admin",
                                              "read", "readwrite", and "write".
                                        }
                                    ],
                                    "pg_allow_replication": bool  # Optional. For
                                      Postgres clusters, set to ``true`` for a user with replication
                                      rights. This option is not currently supported for other database
                                      engines.
                                }
                            }
                        ],
                        "version": "str",  # Optional. A string representing the version of
                          the database engine in use for the cluster.
                        "version_end_of_availability": "str",  # Optional. A timestamp
                          referring to the date when the particular version will no longer be available
                          for creating new clusters. If null, the version does not have an end of
                          availability timeline.
                        "version_end_of_life": "str"  # Optional. A timestamp referring to
                          the date when the particular version will no longer be supported. If null,
                          the version does not have an end of life timeline.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_cluster_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def destroy_cluster(
        self, database_cluster_uuid: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Destroy a Database Cluster.

        To destroy a specific database, send a DELETE request to ``/v2/databases/$DATABASE_ID``.
        A status of 204 will be given. This indicates that the request was processed successfully, but
        that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_destroy_cluster_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_config(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Database Cluster Configuration.

        Shows configuration parameters for an existing database cluster by sending a GET request to
        ``/v2/databases/$DATABASE_ID/config``.
        The response is a JSON object with a ``config`` key, which is set to an object
        containing any database configuration parameters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "config": {}
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_config_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch_config(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update the Database Configuration for an Existing Database.

        To update the configuration for an existing database cluster, send a PATCH request to
        ``/v2/databases/$DATABASE_ID/config``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {}
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch_config(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update the Database Configuration for an Existing Database.

        To update the configuration for an existing database cluster, send a PATCH request to
        ``/v2/databases/$DATABASE_ID/config``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch_config(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update the Database Configuration for an Existing Database.

        To update the configuration for an existing database cluster, send a PATCH request to
        ``/v2/databases/$DATABASE_ID/config``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {}
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_patch_config_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_ca(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the Public Certificate.

        To retrieve the public certificate used to secure the connection to the database cluster send a
        GET request to
        ``/v2/databases/$DATABASE_ID/ca``.

        The response will be a JSON object with a ``ca`` key. This will be set to an object
        containing the base64 encoding of the public key certificate.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "ca": {
                        "certificate": "str"  # base64 encoding of the certificate used to
                          secure database connections. Required.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_ca_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_migration_status(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the Status of an Online Migration.

        To retrieve the status of the most recent online migration, send a GET request to
        ``/v2/databases/$DATABASE_ID/online-migration``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "created_at": "str",  # Optional. The time the migration was initiated, in
                      ISO 8601 format.
                    "id": "str",  # Optional. The ID of the most recent migration.
                    "status": "str"  # Optional. The current status of the migration. Known
                      values are: "running", "syncing", "canceled", "error", and "done".
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_migration_status_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_online_migration(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start an Online Migration.

        To start an online migration, send a PUT request to
        ``/v2/databases/$DATABASE_ID/online-migration`` endpoint. Migrating a cluster establishes a
        connection with an existing cluster and replicates its contents to the target cluster. If the
        existing database is continuously being written to,  the migration process will continue for up
        to two weeks unless it is manually stopped. Online migration is only available for `MySQL
        <https://docs.digitalocean.com/products/databases/mysql/how-to/migrate/#:~:text=To%20migrate%20a%20MySQL%20database,then%20select%20Set%20Up%20Migration>`_\\
        , `PostgreSQL <https://docs.digitalocean.com/products/databases/postgresql/how-to/migrate/>`_\\
        , and `Redis <https://docs.digitalocean.com/products/databases/redis/how-to/migrate/>`_
        clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "source": {
                        "dbname": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "username": "str"  # Optional. The default user for the database.
                    },
                    "disable_ssl": bool,  # Optional. Enables SSL encryption when connecting to
                      the source database.
                    "ignore_dbs": [
                        "str"  # Optional. List of databases that should be ignored during
                          migration.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "created_at": "str",  # Optional. The time the migration was initiated, in
                      ISO 8601 format.
                    "id": "str",  # Optional. The ID of the most recent migration.
                    "status": "str"  # Optional. The current status of the migration. Known
                      values are: "running", "syncing", "canceled", "error", and "done".
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_online_migration(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start an Online Migration.

        To start an online migration, send a PUT request to
        ``/v2/databases/$DATABASE_ID/online-migration`` endpoint. Migrating a cluster establishes a
        connection with an existing cluster and replicates its contents to the target cluster. If the
        existing database is continuously being written to,  the migration process will continue for up
        to two weeks unless it is manually stopped. Online migration is only available for `MySQL
        <https://docs.digitalocean.com/products/databases/mysql/how-to/migrate/#:~:text=To%20migrate%20a%20MySQL%20database,then%20select%20Set%20Up%20Migration>`_\\
        , `PostgreSQL <https://docs.digitalocean.com/products/databases/postgresql/how-to/migrate/>`_\\
        , and `Redis <https://docs.digitalocean.com/products/databases/redis/how-to/migrate/>`_
        clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "created_at": "str",  # Optional. The time the migration was initiated, in
                      ISO 8601 format.
                    "id": "str",  # Optional. The ID of the most recent migration.
                    "status": "str"  # Optional. The current status of the migration. Known
                      values are: "running", "syncing", "canceled", "error", and "done".
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_online_migration(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start an Online Migration.

        To start an online migration, send a PUT request to
        ``/v2/databases/$DATABASE_ID/online-migration`` endpoint. Migrating a cluster establishes a
        connection with an existing cluster and replicates its contents to the target cluster. If the
        existing database is continuously being written to,  the migration process will continue for up
        to two weeks unless it is manually stopped. Online migration is only available for `MySQL
        <https://docs.digitalocean.com/products/databases/mysql/how-to/migrate/#:~:text=To%20migrate%20a%20MySQL%20database,then%20select%20Set%20Up%20Migration>`_\\
        , `PostgreSQL <https://docs.digitalocean.com/products/databases/postgresql/how-to/migrate/>`_\\
        , and `Redis <https://docs.digitalocean.com/products/databases/redis/how-to/migrate/>`_
        clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "source": {
                        "dbname": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "username": "str"  # Optional. The default user for the database.
                    },
                    "disable_ssl": bool,  # Optional. Enables SSL encryption when connecting to
                      the source database.
                    "ignore_dbs": [
                        "str"  # Optional. List of databases that should be ignored during
                          migration.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "created_at": "str",  # Optional. The time the migration was initiated, in
                      ISO 8601 format.
                    "id": "str",  # Optional. The ID of the most recent migration.
                    "status": "str"  # Optional. The current status of the migration. Known
                      values are: "running", "syncing", "canceled", "error", and "done".
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_online_migration_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_online_migration(
        self, database_cluster_uuid: str, migration_id: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Stop an Online Migration.

        To stop an online migration, send a DELETE request to
        ``/v2/databases/$DATABASE_ID/online-migration/$MIGRATION_ID``.

        A status of 204 will be given. This indicates that the request was processed successfully, but
        that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param migration_id: A unique identifier assigned to the online migration. Required.
        :type migration_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_online_migration_request(
            database_cluster_uuid=database_cluster_uuid,
            migration_id=migration_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update_region(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Migrate a Database Cluster to a New Region.

        To migrate a database cluster to a new region, send a ``PUT`` request to
        ``/v2/databases/$DATABASE_ID/migrate``. The body of the request must specify a
        ``region`` attribute.

        A successful request will receive a 202 Accepted status code with no body in
        response. Querying the database cluster will show that its ``status`` attribute
        will now be set to ``migrating``. This will transition back to ``online`` when the
        migration has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region": "str"  # A slug identifier for the region to which the database
                      cluster will be migrated. Required.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_region(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Migrate a Database Cluster to a New Region.

        To migrate a database cluster to a new region, send a ``PUT`` request to
        ``/v2/databases/$DATABASE_ID/migrate``. The body of the request must specify a
        ``region`` attribute.

        A successful request will receive a 202 Accepted status code with no body in
        response. Querying the database cluster will show that its ``status`` attribute
        will now be set to ``migrating``. This will transition back to ``online`` when the
        migration has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_region(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Migrate a Database Cluster to a New Region.

        To migrate a database cluster to a new region, send a ``PUT`` request to
        ``/v2/databases/$DATABASE_ID/migrate``. The body of the request must specify a
        ``region`` attribute.

        A successful request will receive a 202 Accepted status code with no body in
        response. Querying the database cluster will show that its ``status`` attribute
        will now be set to ``migrating``. This will transition back to ``online`` when the
        migration has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region": "str"  # A slug identifier for the region to which the database
                      cluster will be migrated. Required.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_region_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update_cluster_size(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Resize a Database Cluster.

        To resize a database cluster, send a PUT request to ``/v2/databases/$DATABASE_ID/resize``. The
        body of the request must specify both the size and num_nodes attributes.
        A successful request will receive a 202 Accepted status code with no body in response. Querying
        the database cluster will show that its status attribute will now be set to resizing. This will
        transition back to online when the resize operation has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "num_nodes": 0,  # The number of nodes in the database cluster. Valid values
                      are are 1-3. In addition to the primary node, up to two standby nodes may be
                      added for highly available configurations. Required.
                    "size": "str",  # A slug identifier representing desired the size of the
                      nodes in the database cluster. Required.
                    "storage_size_mib": 0  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_cluster_size(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Resize a Database Cluster.

        To resize a database cluster, send a PUT request to ``/v2/databases/$DATABASE_ID/resize``. The
        body of the request must specify both the size and num_nodes attributes.
        A successful request will receive a 202 Accepted status code with no body in response. Querying
        the database cluster will show that its status attribute will now be set to resizing. This will
        transition back to online when the resize operation has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_cluster_size(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Resize a Database Cluster.

        To resize a database cluster, send a PUT request to ``/v2/databases/$DATABASE_ID/resize``. The
        body of the request must specify both the size and num_nodes attributes.
        A successful request will receive a 202 Accepted status code with no body in response. Querying
        the database cluster will show that its status attribute will now be set to resizing. This will
        transition back to online when the resize operation has completed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "num_nodes": 0,  # The number of nodes in the database cluster. Valid values
                      are are 1-3. In addition to the primary node, up to two standby nodes may be
                      added for highly available configurations. Required.
                    "size": "str",  # A slug identifier representing desired the size of the
                      nodes in the database cluster. Required.
                    "storage_size_mib": 0  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_cluster_size_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_firewall_rules(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Firewall Rules (Trusted Sources) for a Database Cluster.

        To list all of a database cluster's firewall rules (known as "trusted sources" in the control
        panel), send a GET request to ``/v2/databases/$DATABASE_ID/firewall``.
        The result will be a JSON object with a ``rules`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "rules": [
                        {
                            "type": "str",  # The type of resource that the firewall rule
                              allows to access the database cluster. Required. Known values are:
                              "droplet", "k8s", "ip_addr", "tag", and "app".
                            "value": "str",  # The ID of the specific resource, the name
                              of a tag applied to a group of resources, or the IP address that the
                              firewall rule allows to access the database cluster. Required.
                            "cluster_uuid": "str",  # Optional. A unique ID for the
                              database cluster to which the rule is applied.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall rule was created.
                            "uuid": "str"  # Optional. A unique ID for the firewall rule
                              itself.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_firewall_rules_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_firewall_rules(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Firewall Rules (Trusted Sources) for a Database.

        To update a database cluster's firewall rules (known as "trusted sources" in the control
        panel), send a PUT request to ``/v2/databases/$DATABASE_ID/firewall`` specifying which
        resources should be able to open connections to the database. You may limit connections to
        specific Droplets, Kubernetes clusters, or IP addresses. When a tag is provided, any Droplet or
        Kubernetes node with that tag applied to it will have access. The firewall is limited to 100
        rules (or trusted sources). When possible, we recommend `placing your databases into a VPC
        network <https://docs.digitalocean.com/products/networking/vpc/>`_ to limit access to them
        instead of using a firewall.
        A successful.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "rules": [
                        {
                            "type": "str",  # The type of resource that the firewall rule
                              allows to access the database cluster. Required. Known values are:
                              "droplet", "k8s", "ip_addr", "tag", and "app".
                            "value": "str",  # The ID of the specific resource, the name
                              of a tag applied to a group of resources, or the IP address that the
                              firewall rule allows to access the database cluster. Required.
                            "cluster_uuid": "str",  # Optional. A unique ID for the
                              database cluster to which the rule is applied.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall rule was created.
                            "uuid": "str"  # Optional. A unique ID for the firewall rule
                              itself.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_firewall_rules(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Firewall Rules (Trusted Sources) for a Database.

        To update a database cluster's firewall rules (known as "trusted sources" in the control
        panel), send a PUT request to ``/v2/databases/$DATABASE_ID/firewall`` specifying which
        resources should be able to open connections to the database. You may limit connections to
        specific Droplets, Kubernetes clusters, or IP addresses. When a tag is provided, any Droplet or
        Kubernetes node with that tag applied to it will have access. The firewall is limited to 100
        rules (or trusted sources). When possible, we recommend `placing your databases into a VPC
        network <https://docs.digitalocean.com/products/networking/vpc/>`_ to limit access to them
        instead of using a firewall.
        A successful.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_firewall_rules(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Firewall Rules (Trusted Sources) for a Database.

        To update a database cluster's firewall rules (known as "trusted sources" in the control
        panel), send a PUT request to ``/v2/databases/$DATABASE_ID/firewall`` specifying which
        resources should be able to open connections to the database. You may limit connections to
        specific Droplets, Kubernetes clusters, or IP addresses. When a tag is provided, any Droplet or
        Kubernetes node with that tag applied to it will have access. The firewall is limited to 100
        rules (or trusted sources). When possible, we recommend `placing your databases into a VPC
        network <https://docs.digitalocean.com/products/networking/vpc/>`_ to limit access to them
        instead of using a firewall.
        A successful.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "rules": [
                        {
                            "type": "str",  # The type of resource that the firewall rule
                              allows to access the database cluster. Required. Known values are:
                              "droplet", "k8s", "ip_addr", "tag", and "app".
                            "value": "str",  # The ID of the specific resource, the name
                              of a tag applied to a group of resources, or the IP address that the
                              firewall rule allows to access the database cluster. Required.
                            "cluster_uuid": "str",  # Optional. A unique ID for the
                              database cluster to which the rule is applied.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall rule was created.
                            "uuid": "str"  # Optional. A unique ID for the firewall rule
                              itself.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_firewall_rules_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update_maintenance_window(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure a Database Cluster's Maintenance Window.

        To configure the window when automatic maintenance should be performed for a database cluster,
        send a PUT request to ``/v2/databases/$DATABASE_ID/maintenance``.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "day": "str",  # The day of the week on which to apply maintenance updates.
                      Required.
                    "hour": "str",  # The hour in UTC at which maintenance updates will be
                      applied in 24 hour format. Required.
                    "description": [
                        "str"  # Optional. A list of strings, each containing information
                          about a pending maintenance update.
                    ],
                    "pending": bool  # Optional. A boolean value indicating whether any
                      maintenance is scheduled to be performed in the next window.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_maintenance_window(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure a Database Cluster's Maintenance Window.

        To configure the window when automatic maintenance should be performed for a database cluster,
        send a PUT request to ``/v2/databases/$DATABASE_ID/maintenance``.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_maintenance_window(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure a Database Cluster's Maintenance Window.

        To configure the window when automatic maintenance should be performed for a database cluster,
        send a PUT request to ``/v2/databases/$DATABASE_ID/maintenance``.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "day": "str",  # The day of the week on which to apply maintenance updates.
                      Required.
                    "hour": "str",  # The hour in UTC at which maintenance updates will be
                      applied in 24 hour format. Required.
                    "description": [
                        "str"  # Optional. A list of strings, each containing information
                          about a pending maintenance update.
                    ],
                    "pending": bool  # Optional. A boolean value indicating whether any
                      maintenance is scheduled to be performed in the next window.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_maintenance_window_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def install_update(
        self, database_cluster_uuid: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Start Database Maintenance.

        To start the installation of updates for a database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/install_update``.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_install_update_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_backups(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Backups for a Database Cluster.

        To list all of the available backups of a PostgreSQL or MySQL database cluster, send a GET
        request to ``/v2/databases/$DATABASE_ID/backups``.
        **Note**\\ : Backups are not supported for Redis clusters.
        The result will be a JSON object with a ``backups key``. This will be set to an array of backup
        objects, each of which will contain the size of the backup and the timestamp at which it was
        created.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "backups": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format at which the backup was created.
                              Required.
                            "size_gigabytes": 0.0  # The size of the database backup in
                              GBs. Required.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_backups_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_replicas(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Read-only Replicas.

        To list all of the read-only replicas associated with a database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/replicas``.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        The result will be a JSON object with a ``replicas`` key. This will be set to an array of
        database replica objects, each of which will contain the standard database replica attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "replicas": [
                        {
                            "name": "str",  # The name to give the read-only replicating.
                              Required.
                            "connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the database cluster was created.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a database replica.
                            "private_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "private_network_uuid": "str",  # Optional. A string
                              specifying the UUID of the VPC to which the read-only replica will be
                              assigned. If excluded, the replica will be assigned to your account's
                              default VPC for the region.
                            "region": "str",  # Optional. A slug identifier for the
                              region where the read-only replica will be located. If excluded, the
                              replica will be placed in the same region as the cluster.
                            "size": "str",  # Optional. A slug identifier representing
                              the size of the node for the read-only replica. The size of the replica
                              must be at least as large as the node size for the database cluster from
                              which it is replicating.
                            "status": "str",  # Optional. A string representing the
                              current status of the database cluster. Known values are: "creating",
                              "online", "resizing", "migrating", and "forking".
                            "storage_size_mib": 0,  # Optional. Additional storage added
                              to the cluster, in MiB. If null, no additional storage is added to the
                              cluster, beyond what is provided as a base amount from the 'size' and any
                              previously added additional storage.
                            "tags": [
                                "str"  # Optional. A flat array of tag names as
                                  strings to apply to the read-only replica after it is created. Tag
                                  names can either be existing or new tags.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_replicas_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_replica(
        self,
        database_cluster_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Read-only Replica.

        To create a read-only replica for a PostgreSQL or MySQL database cluster, send a POST request
        to ``/v2/databases/$DATABASE_ID/replicas`` specifying the name it should be given, the size of
        the node to be used, and the region where it will be located.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        The response will be a JSON object with a key called ``replica``. The value of this will be an
        object that contains the standard attributes associated with a database replica. The initial
        value of the read-only replica's ``status`` attribute will be ``forking``. When the replica is
        ready to receive traffic, this will transition to ``active``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name to give the read-only replicating. Required.
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the database cluster
                      was created.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a database replica.
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_network_uuid": "str",  # Optional. A string specifying the UUID of
                      the VPC to which the read-only replica will be assigned. If excluded, the replica
                      will be assigned to your account's default VPC for the region.
                    "region": "str",  # Optional. A slug identifier for the region where the
                      read-only replica will be located. If excluded, the replica will be placed in the
                      same region as the cluster.
                    "size": "str",  # Optional. A slug identifier representing the size of the
                      node for the read-only replica. The size of the replica must be at least as large
                      as the node size for the database cluster from which it is replicating.
                    "status": "str",  # Optional. A string representing the current status of the
                      database cluster. Known values are: "creating", "online", "resizing",
                      "migrating", and "forking".
                    "storage_size_mib": 0,  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to apply to
                          the read-only replica after it is created. Tag names can either be existing
                          or new tags.
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "replica": {
                        "name": "str",  # The name to give the read-only replicating.
                          Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database replica.
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the read-only replica will be assigned. If excluded,
                          the replica will be assigned to your account's default VPC for the region.
                        "region": "str",  # Optional. A slug identifier for the region where
                          the read-only replica will be located. If excluded, the replica will be
                          placed in the same region as the cluster.
                        "size": "str",  # Optional. A slug identifier representing the size
                          of the node for the read-only replica. The size of the replica must be at
                          least as large as the node size for the database cluster from which it is
                          replicating.
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to
                              apply to the read-only replica after it is created. Tag names can either
                              be existing or new tags.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_replica(
        self,
        database_cluster_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Read-only Replica.

        To create a read-only replica for a PostgreSQL or MySQL database cluster, send a POST request
        to ``/v2/databases/$DATABASE_ID/replicas`` specifying the name it should be given, the size of
        the node to be used, and the region where it will be located.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        The response will be a JSON object with a key called ``replica``. The value of this will be an
        object that contains the standard attributes associated with a database replica. The initial
        value of the read-only replica's ``status`` attribute will be ``forking``. When the replica is
        ready to receive traffic, this will transition to ``active``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "replica": {
                        "name": "str",  # The name to give the read-only replicating.
                          Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database replica.
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the read-only replica will be assigned. If excluded,
                          the replica will be assigned to your account's default VPC for the region.
                        "region": "str",  # Optional. A slug identifier for the region where
                          the read-only replica will be located. If excluded, the replica will be
                          placed in the same region as the cluster.
                        "size": "str",  # Optional. A slug identifier representing the size
                          of the node for the read-only replica. The size of the replica must be at
                          least as large as the node size for the database cluster from which it is
                          replicating.
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to
                              apply to the read-only replica after it is created. Tag names can either
                              be existing or new tags.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_replica(
        self,
        database_cluster_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Read-only Replica.

        To create a read-only replica for a PostgreSQL or MySQL database cluster, send a POST request
        to ``/v2/databases/$DATABASE_ID/replicas`` specifying the name it should be given, the size of
        the node to be used, and the region where it will be located.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        The response will be a JSON object with a key called ``replica``. The value of this will be an
        object that contains the standard attributes associated with a database replica. The initial
        value of the read-only replica's ``status`` attribute will be ``forking``. When the replica is
        ready to receive traffic, this will transition to ``active``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name to give the read-only replicating. Required.
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the database cluster
                      was created.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a database replica.
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_network_uuid": "str",  # Optional. A string specifying the UUID of
                      the VPC to which the read-only replica will be assigned. If excluded, the replica
                      will be assigned to your account's default VPC for the region.
                    "region": "str",  # Optional. A slug identifier for the region where the
                      read-only replica will be located. If excluded, the replica will be placed in the
                      same region as the cluster.
                    "size": "str",  # Optional. A slug identifier representing the size of the
                      node for the read-only replica. The size of the replica must be at least as large
                      as the node size for the database cluster from which it is replicating.
                    "status": "str",  # Optional. A string representing the current status of the
                      database cluster. Known values are: "creating", "online", "resizing",
                      "migrating", and "forking".
                    "storage_size_mib": 0,  # Optional. Additional storage added to the cluster,
                      in MiB. If null, no additional storage is added to the cluster, beyond what is
                      provided as a base amount from the 'size' and any previously added additional
                      storage.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to apply to
                          the read-only replica after it is created. Tag names can either be existing
                          or new tags.
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "replica": {
                        "name": "str",  # The name to give the read-only replicating.
                          Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database replica.
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the read-only replica will be assigned. If excluded,
                          the replica will be assigned to your account's default VPC for the region.
                        "region": "str",  # Optional. A slug identifier for the region where
                          the read-only replica will be located. If excluded, the replica will be
                          placed in the same region as the cluster.
                        "size": "str",  # Optional. A slug identifier representing the size
                          of the node for the read-only replica. The size of the replica must be at
                          least as large as the node size for the database cluster from which it is
                          replicating.
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to
                              apply to the read-only replica after it is created. Tag names can either
                              be existing or new tags.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_databases_create_replica_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_events_logs(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List all Events Logs.

        To list all of the cluster events, send a GET request to
        ``/v2/databases/$DATABASE_ID/events``.

        The result will be a JSON object with a ``events`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "events": [
                        {
                            "cluster_name": "str",  # Optional. The name of cluster.
                            "create_time": "str",  # Optional. The time of the generation
                              of a event.
                            "event_type": "str",  # Optional. Type of the event. Known
                              values are: "cluster_maintenance_perform", "cluster_master_promotion",
                              "cluster_create", "cluster_update", "cluster_delete", "cluster_poweron",
                              and "cluster_poweroff".
                            "id": "str"  # Optional. ID of the particular event.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_events_logs_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_replica(
        self, database_cluster_uuid: str, replica_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Read-only Replica.

        To show information about an existing database replica, send a GET request to
        ``/v2/databases/$DATABASE_ID/replicas/$REPLICA_NAME``.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        The response will be a JSON object with a ``replica key``. This will be set to an object
        containing the standard database replica attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param replica_name: The name of the database replica. Required.
        :type replica_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "replica": {
                        "name": "str",  # The name to give the read-only replicating.
                          Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the database
                          cluster was created.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a database replica.
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_network_uuid": "str",  # Optional. A string specifying the
                          UUID of the VPC to which the read-only replica will be assigned. If excluded,
                          the replica will be assigned to your account's default VPC for the region.
                        "region": "str",  # Optional. A slug identifier for the region where
                          the read-only replica will be located. If excluded, the replica will be
                          placed in the same region as the cluster.
                        "size": "str",  # Optional. A slug identifier representing the size
                          of the node for the read-only replica. The size of the replica must be at
                          least as large as the node size for the database cluster from which it is
                          replicating.
                        "status": "str",  # Optional. A string representing the current
                          status of the database cluster. Known values are: "creating", "online",
                          "resizing", "migrating", and "forking".
                        "storage_size_mib": 0,  # Optional. Additional storage added to the
                          cluster, in MiB. If null, no additional storage is added to the cluster,
                          beyond what is provided as a base amount from the 'size' and any previously
                          added additional storage.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to
                              apply to the read-only replica after it is created. Tag names can either
                              be existing or new tags.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_replica_request(
            database_cluster_uuid=database_cluster_uuid,
            replica_name=replica_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def destroy_replica(
        self, database_cluster_uuid: str, replica_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Destroy a Read-only Replica.

        To destroy a specific read-only replica, send a DELETE request to
        ``/v2/databases/$DATABASE_ID/replicas/$REPLICA_NAME``.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        A status of 204 will be given. This indicates that the request was processed successfully, but
        that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param replica_name: The name of the database replica. Required.
        :type replica_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_destroy_replica_request(
            database_cluster_uuid=database_cluster_uuid,
            replica_name=replica_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def promote_replica(
        self, database_cluster_uuid: str, replica_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Promote a Read-only Replica to become a Primary Cluster.

        To promote a specific read-only replica, send a PUT request to
        ``/v2/databases/$DATABASE_ID/replicas/$REPLICA_NAME/promote``.

        **Note**\\ : Read-only replicas are not supported for Redis clusters.

        A status of 204 will be given. This indicates that the request was processed successfully, but
        that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param replica_name: The name of the database replica. Required.
        :type replica_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_promote_replica_request(
            database_cluster_uuid=database_cluster_uuid,
            replica_name=replica_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_users(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List all Database Users.

        To list all of the users for your database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/users``.

        Note: User management is not supported for Redis clusters.

        The result will be a JSON object with a ``users`` key. This will be set to an array
        of database user objects, each of which will contain the standard database user attributes.

        For MySQL clusters, additional options will be contained in the mysql_settings object.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "users": [
                        {
                            "name": "str",  # The name of a database user. Required.
                            "access_cert": "str",  # Optional. Access certificate for TLS
                              client authentication. (Kafka only).
                            "access_key": "str",  # Optional. Access key for TLS client
                              authentication. (Kafka only).
                            "mysql_settings": {
                                "auth_plugin": "str"  # A string specifying the
                                  authentication method to be used for connections to the MySQL user
                                  account. The valid values are ``mysql_native_password`` or
                                  ``caching_sha2_password``. If excluded when creating a new user, the
                                  default for the version of MySQL in use will be used. As of MySQL
                                  8.0, the default is ``caching_sha2_password``. Required. Known values
                                  are: "mysql_native_password" and "caching_sha2_password".
                            },
                            "password": "str",  # Optional. A randomly generated password
                              for the database user.
                            "role": "str",  # Optional. A string representing the
                              database user's role. The value will be either "primary" or "normal".
                              Known values are: "primary" and "normal".
                            "settings": {
                                "acl": [
                                    {
                                        "permission": "str",  # Permission
                                          set applied to the ACL. 'consume' allows for messages to be
                                          consumed from the topic. 'produce' allows for messages to be
                                          published to the topic. 'produceconsume' allows for both
                                          'consume' and 'produce' permission. 'admin' allows for
                                          'produceconsume' as well as any operations to administer the
                                          topic (delete, update). Required. Known values are: "admin",
                                          "consume", "produce", and "produceconsume".
                                        "topic": "str",  # A regex for
                                          matching the topic(s) that this ACL should apply to.
                                          Required.
                                        "id": "str"  # Optional. An
                                          identifier for the ACL. Will be computed after the ACL is
                                          created/updated.
                                    }
                                ],
                                "opensearch_acl": [
                                    {
                                        "index": "str",  # Optional. A regex
                                          for matching the indexes that this ACL should apply to.
                                        "permission": "str"  # Optional.
                                          Permission set applied to the ACL. 'read' allows user to read
                                          from the index. 'write' allows for user to write to the
                                          index. 'readwrite' allows for both 'read' and 'write'
                                          permission. 'deny'(default) restricts user from performing
                                          any operation over an index. 'admin' allows for 'readwrite'
                                          as well as any operations to administer the index. Known
                                          values are: "deny", "admin", "read", "readwrite", and
                                          "write".
                                    }
                                ],
                                "pg_allow_replication": bool  # Optional. For
                                  Postgres clusters, set to ``true`` for a user with replication
                                  rights. This option is not currently supported for other database
                                  engines.
                            }
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_users_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def add_user(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Database User.

        To add a new database user, send a POST request to ``/v2/databases/$DATABASE_ID/users``
        with the desired username.

        Note: User management is not supported for Redis clusters.

        When adding a user to a MySQL cluster, additional options can be configured in the
        ``mysql_settings`` object.

        When adding a user to a Kafka cluster, additional options can be configured in
        the ``settings`` object.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the standard attributes associated with a database user including
        its randomly generated password.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name of a database user. Required.
                    "access_cert": "str",  # Optional. Access certificate for TLS client
                      authentication. (Kafka only).
                    "access_key": "str",  # Optional. Access key for TLS client authentication.
                      (Kafka only).
                    "mysql_settings": {
                        "auth_plugin": "str"  # A string specifying the authentication method
                          to be used for connections to the MySQL user account. The valid values are
                          ``mysql_native_password`` or ``caching_sha2_password``. If excluded when
                          creating a new user, the default for the version of MySQL in use will be
                          used. As of MySQL 8.0, the default is ``caching_sha2_password``. Required.
                          Known values are: "mysql_native_password" and "caching_sha2_password".
                    },
                    "password": "str",  # Optional. A randomly generated password for the
                      database user.
                    "readonly": bool,  # Optional. For MongoDB clusters, set to ``true`` to
                      create a read-only user. This option is not currently supported for other
                      database engines.
                    "role": "str",  # Optional. A string representing the database user's role.
                      The value will be either "primary" or "normal". Known values are: "primary" and
                      "normal".
                    "settings": {
                        "acl": [
                            {
                                "permission": "str",  # Permission set applied to the
                                  ACL. 'consume' allows for messages to be consumed from the topic.
                                  'produce' allows for messages to be published to the topic.
                                  'produceconsume' allows for both 'consume' and 'produce' permission.
                                  'admin' allows for 'produceconsume' as well as any operations to
                                  administer the topic (delete, update). Required. Known values are:
                                  "admin", "consume", "produce", and "produceconsume".
                                "topic": "str",  # A regex for matching the topic(s)
                                  that this ACL should apply to. Required.
                                "id": "str"  # Optional. An identifier for the ACL.
                                  Will be computed after the ACL is created/updated.
                            }
                        ],
                        "opensearch_acl": [
                            {
                                "index": "str",  # Optional. A regex for matching the
                                  indexes that this ACL should apply to.
                                "permission": "str"  # Optional. Permission set
                                  applied to the ACL. 'read' allows user to read from the index.
                                  'write' allows for user to write to the index. 'readwrite' allows for
                                  both 'read' and 'write' permission. 'deny'(default) restricts user
                                  from performing any operation over an index. 'admin' allows for
                                  'readwrite' as well as any operations to administer the index. Known
                                  values are: "deny", "admin", "read", "readwrite", and "write".
                            }
                        ],
                        "pg_allow_replication": bool  # Optional. For Postgres clusters, set
                          to ``true`` for a user with replication rights. This option is not currently
                          supported for other database engines.
                    }
                }

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_user(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Database User.

        To add a new database user, send a POST request to ``/v2/databases/$DATABASE_ID/users``
        with the desired username.

        Note: User management is not supported for Redis clusters.

        When adding a user to a MySQL cluster, additional options can be configured in the
        ``mysql_settings`` object.

        When adding a user to a Kafka cluster, additional options can be configured in
        the ``settings`` object.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the standard attributes associated with a database user including
        its randomly generated password.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_user(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Database User.

        To add a new database user, send a POST request to ``/v2/databases/$DATABASE_ID/users``
        with the desired username.

        Note: User management is not supported for Redis clusters.

        When adding a user to a MySQL cluster, additional options can be configured in the
        ``mysql_settings`` object.

        When adding a user to a Kafka cluster, additional options can be configured in
        the ``settings`` object.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the standard attributes associated with a database user including
        its randomly generated password.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name of a database user. Required.
                    "access_cert": "str",  # Optional. Access certificate for TLS client
                      authentication. (Kafka only).
                    "access_key": "str",  # Optional. Access key for TLS client authentication.
                      (Kafka only).
                    "mysql_settings": {
                        "auth_plugin": "str"  # A string specifying the authentication method
                          to be used for connections to the MySQL user account. The valid values are
                          ``mysql_native_password`` or ``caching_sha2_password``. If excluded when
                          creating a new user, the default for the version of MySQL in use will be
                          used. As of MySQL 8.0, the default is ``caching_sha2_password``. Required.
                          Known values are: "mysql_native_password" and "caching_sha2_password".
                    },
                    "password": "str",  # Optional. A randomly generated password for the
                      database user.
                    "readonly": bool,  # Optional. For MongoDB clusters, set to ``true`` to
                      create a read-only user. This option is not currently supported for other
                      database engines.
                    "role": "str",  # Optional. A string representing the database user's role.
                      The value will be either "primary" or "normal". Known values are: "primary" and
                      "normal".
                    "settings": {
                        "acl": [
                            {
                                "permission": "str",  # Permission set applied to the
                                  ACL. 'consume' allows for messages to be consumed from the topic.
                                  'produce' allows for messages to be published to the topic.
                                  'produceconsume' allows for both 'consume' and 'produce' permission.
                                  'admin' allows for 'produceconsume' as well as any operations to
                                  administer the topic (delete, update). Required. Known values are:
                                  "admin", "consume", "produce", and "produceconsume".
                                "topic": "str",  # A regex for matching the topic(s)
                                  that this ACL should apply to. Required.
                                "id": "str"  # Optional. An identifier for the ACL.
                                  Will be computed after the ACL is created/updated.
                            }
                        ],
                        "opensearch_acl": [
                            {
                                "index": "str",  # Optional. A regex for matching the
                                  indexes that this ACL should apply to.
                                "permission": "str"  # Optional. Permission set
                                  applied to the ACL. 'read' allows user to read from the index.
                                  'write' allows for user to write to the index. 'readwrite' allows for
                                  both 'read' and 'write' permission. 'deny'(default) restricts user
                                  from performing any operation over an index. 'admin' allows for
                                  'readwrite' as well as any operations to administer the index. Known
                                  values are: "deny", "admin", "read", "readwrite", and "write".
                            }
                        ],
                        "pg_allow_replication": bool  # Optional. For Postgres clusters, set
                          to ``true`` for a user with replication rights. This option is not currently
                          supported for other database engines.
                    }
                }

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_add_user_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_user(
        self, database_cluster_uuid: str, username: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Database User.

        To show information about an existing database user, send a GET request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME``.

        Note: User management is not supported for Redis clusters.

        The response will be a JSON object with a ``user`` key. This will be set to an object
        containing the standard database user attributes.

        For MySQL clusters, additional options will be contained in the ``mysql_settings``
        object.

        For Kafka clusters, additional options will be contained in the ``settings`` object.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_user_request(
            database_cluster_uuid=database_cluster_uuid,
            username=username,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_user(
        self, database_cluster_uuid: str, username: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove a Database User.

        To remove a specific database user, send a DELETE request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        Note: User management is not supported for Redis clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_user_request(
            database_cluster_uuid=database_cluster_uuid,
            username=username,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update_user(
        self,
        database_cluster_uuid: str,
        username: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Database User.

        To update an existing database user, send a PUT request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME``
        with the desired settings.

        **Note**\\ : only ``settings`` can be updated via this type of request. If you wish to change
        the name of a user,
        you must recreate a new user.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the name of the update database user, along with the ``settings`` object
        that
        has been updated.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "settings": {
                        "acl": [
                            {
                                "permission": "str",  # Permission set applied to the
                                  ACL. 'consume' allows for messages to be consumed from the topic.
                                  'produce' allows for messages to be published to the topic.
                                  'produceconsume' allows for both 'consume' and 'produce' permission.
                                  'admin' allows for 'produceconsume' as well as any operations to
                                  administer the topic (delete, update). Required. Known values are:
                                  "admin", "consume", "produce", and "produceconsume".
                                "topic": "str",  # A regex for matching the topic(s)
                                  that this ACL should apply to. Required.
                                "id": "str"  # Optional. An identifier for the ACL.
                                  Will be computed after the ACL is created/updated.
                            }
                        ],
                        "opensearch_acl": [
                            {
                                "index": "str",  # Optional. A regex for matching the
                                  indexes that this ACL should apply to.
                                "permission": "str"  # Optional. Permission set
                                  applied to the ACL. 'read' allows user to read from the index.
                                  'write' allows for user to write to the index. 'readwrite' allows for
                                  both 'read' and 'write' permission. 'deny'(default) restricts user
                                  from performing any operation over an index. 'admin' allows for
                                  'readwrite' as well as any operations to administer the index. Known
                                  values are: "deny", "admin", "read", "readwrite", and "write".
                            }
                        ],
                        "pg_allow_replication": bool  # Optional. For Postgres clusters, set
                          to ``true`` for a user with replication rights. This option is not currently
                          supported for other database engines.
                    }
                }

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_user(
        self,
        database_cluster_uuid: str,
        username: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Database User.

        To update an existing database user, send a PUT request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME``
        with the desired settings.

        **Note**\\ : only ``settings`` can be updated via this type of request. If you wish to change
        the name of a user,
        you must recreate a new user.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the name of the update database user, along with the ``settings`` object
        that
        has been updated.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_user(
        self,
        database_cluster_uuid: str,
        username: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Database User.

        To update an existing database user, send a PUT request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME``
        with the desired settings.

        **Note**\\ : only ``settings`` can be updated via this type of request. If you wish to change
        the name of a user,
        you must recreate a new user.

        The response will be a JSON object with a key called ``user``. The value of this will be an
        object that contains the name of the update database user, along with the ``settings`` object
        that
        has been updated.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "settings": {
                        "acl": [
                            {
                                "permission": "str",  # Permission set applied to the
                                  ACL. 'consume' allows for messages to be consumed from the topic.
                                  'produce' allows for messages to be published to the topic.
                                  'produceconsume' allows for both 'consume' and 'produce' permission.
                                  'admin' allows for 'produceconsume' as well as any operations to
                                  administer the topic (delete, update). Required. Known values are:
                                  "admin", "consume", "produce", and "produceconsume".
                                "topic": "str",  # A regex for matching the topic(s)
                                  that this ACL should apply to. Required.
                                "id": "str"  # Optional. An identifier for the ACL.
                                  Will be computed after the ACL is created/updated.
                            }
                        ],
                        "opensearch_acl": [
                            {
                                "index": "str",  # Optional. A regex for matching the
                                  indexes that this ACL should apply to.
                                "permission": "str"  # Optional. Permission set
                                  applied to the ACL. 'read' allows user to read from the index.
                                  'write' allows for user to write to the index. 'readwrite' allows for
                                  both 'read' and 'write' permission. 'deny'(default) restricts user
                                  from performing any operation over an index. 'admin' allows for
                                  'readwrite' as well as any operations to administer the index. Known
                                  values are: "deny", "admin", "read", "readwrite", and "write".
                            }
                        ],
                        "pg_allow_replication": bool  # Optional. For Postgres clusters, set
                          to ``true`` for a user with replication rights. This option is not currently
                          supported for other database engines.
                    }
                }

                # response body for status code(s): 201
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_user_request(
            database_cluster_uuid=database_cluster_uuid,
            username=username,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def reset_auth(
        self,
        database_cluster_uuid: str,
        username: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Reset a Database User's Password or Authentication Method.

        To reset the password for a database user, send a POST request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME/reset_auth``.

        For ``mysql`` databases, the authentication method can be specifying by
        including a key in the JSON body called ``mysql_settings`` with the ``auth_plugin``
        value specified.

        The response will be a JSON object with a ``user`` key. This will be set to an
        object containing the standard database user attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "mysql_settings": {
                        "auth_plugin": "str"  # A string specifying the authentication method
                          to be used for connections to the MySQL user account. The valid values are
                          ``mysql_native_password`` or ``caching_sha2_password``. If excluded when
                          creating a new user, the default for the version of MySQL in use will be
                          used. As of MySQL 8.0, the default is ``caching_sha2_password``. Required.
                          Known values are: "mysql_native_password" and "caching_sha2_password".
                    }
                }

                # response body for status code(s): 200
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def reset_auth(
        self,
        database_cluster_uuid: str,
        username: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Reset a Database User's Password or Authentication Method.

        To reset the password for a database user, send a POST request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME/reset_auth``.

        For ``mysql`` databases, the authentication method can be specifying by
        including a key in the JSON body called ``mysql_settings`` with the ``auth_plugin``
        value specified.

        The response will be a JSON object with a ``user`` key. This will be set to an
        object containing the standard database user attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def reset_auth(
        self,
        database_cluster_uuid: str,
        username: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Reset a Database User's Password or Authentication Method.

        To reset the password for a database user, send a POST request to
        ``/v2/databases/$DATABASE_ID/users/$USERNAME/reset_auth``.

        For ``mysql`` databases, the authentication method can be specifying by
        including a key in the JSON body called ``mysql_settings`` with the ``auth_plugin``
        value specified.

        The response will be a JSON object with a ``user`` key. This will be set to an
        object containing the standard database user attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param username: The name of the database user. Required.
        :type username: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "mysql_settings": {
                        "auth_plugin": "str"  # A string specifying the authentication method
                          to be used for connections to the MySQL user account. The valid values are
                          ``mysql_native_password`` or ``caching_sha2_password``. If excluded when
                          creating a new user, the default for the version of MySQL in use will be
                          used. As of MySQL 8.0, the default is ``caching_sha2_password``. Required.
                          Known values are: "mysql_native_password" and "caching_sha2_password".
                    }
                }

                # response body for status code(s): 200
                response == {
                    "user": {
                        "name": "str",  # The name of a database user. Required.
                        "access_cert": "str",  # Optional. Access certificate for TLS client
                          authentication. (Kafka only).
                        "access_key": "str",  # Optional. Access key for TLS client
                          authentication. (Kafka only).
                        "mysql_settings": {
                            "auth_plugin": "str"  # A string specifying the
                              authentication method to be used for connections to the MySQL user
                              account. The valid values are ``mysql_native_password`` or
                              ``caching_sha2_password``. If excluded when creating a new user, the
                              default for the version of MySQL in use will be used. As of MySQL 8.0,
                              the default is ``caching_sha2_password``. Required. Known values are:
                              "mysql_native_password" and "caching_sha2_password".
                        },
                        "password": "str",  # Optional. A randomly generated password for the
                          database user.
                        "role": "str",  # Optional. A string representing the database user's
                          role. The value will be either "primary" or "normal". Known values are:
                          "primary" and "normal".
                        "settings": {
                            "acl": [
                                {
                                    "permission": "str",  # Permission set
                                      applied to the ACL. 'consume' allows for messages to be consumed
                                      from the topic. 'produce' allows for messages to be published to
                                      the topic. 'produceconsume' allows for both 'consume' and
                                      'produce' permission. 'admin' allows for 'produceconsume' as well
                                      as any operations to administer the topic (delete, update).
                                      Required. Known values are: "admin", "consume", "produce", and
                                      "produceconsume".
                                    "topic": "str",  # A regex for matching the
                                      topic(s) that this ACL should apply to. Required.
                                    "id": "str"  # Optional. An identifier for
                                      the ACL. Will be computed after the ACL is created/updated.
                                }
                            ],
                            "opensearch_acl": [
                                {
                                    "index": "str",  # Optional. A regex for
                                      matching the indexes that this ACL should apply to.
                                    "permission": "str"  # Optional. Permission
                                      set applied to the ACL. 'read' allows user to read from the
                                      index. 'write' allows for user to write to the index. 'readwrite'
                                      allows for both 'read' and 'write' permission. 'deny'(default)
                                      restricts user from performing any operation over an index.
                                      'admin' allows for 'readwrite' as well as any operations to
                                      administer the index. Known values are: "deny", "admin", "read",
                                      "readwrite", and "write".
                                }
                            ],
                            "pg_allow_replication": bool  # Optional. For Postgres
                              clusters, set to ``true`` for a user with replication rights. This option
                              is not currently supported for other database engines.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_reset_auth_request(
            database_cluster_uuid=database_cluster_uuid,
            username=username,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Databases.

        To list all of the databases in a clusters, send a GET request to
        ``/v2/databases/$DATABASE_ID/dbs``.

        The result will be a JSON object with a ``dbs`` key. This will be set to an array
        of database objects, each of which will contain the standard database attributes.

        Note: Database management is not supported for Redis clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "dbs": [
                        {
                            "name": "str"  # The name of the database. Required.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def add(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Database.

        To add a new database to an existing cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/dbs``.

        Note: Database management is not supported for Redis clusters.

        The response will be a JSON object with a key called ``db``. The value of this will be
        an object that contains the standard attributes associated with a database.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # The name of the database. Required.
                }

                # response body for status code(s): 201
                response == {
                    "db": {
                        "name": "str"  # The name of the database. Required.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Database.

        To add a new database to an existing cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/dbs``.

        Note: Database management is not supported for Redis clusters.

        The response will be a JSON object with a key called ``db``. The value of this will be
        an object that contains the standard attributes associated with a database.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "db": {
                        "name": "str"  # The name of the database. Required.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Database.

        To add a new database to an existing cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/dbs``.

        Note: Database management is not supported for Redis clusters.

        The response will be a JSON object with a key called ``db``. The value of this will be
        an object that contains the standard attributes associated with a database.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # The name of the database. Required.
                }

                # response body for status code(s): 201
                response == {
                    "db": {
                        "name": "str"  # The name of the database. Required.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_add_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(
        self, database_cluster_uuid: str, database_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Database.

        To show information about an existing database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/dbs/$DB_NAME``.

        Note: Database management is not supported for Redis clusters.

        The response will be a JSON object with a ``db`` key. This will be set to an object
        containing the standard database attributes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param database_name: The name of the database. Required.
        :type database_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "db": {
                        "name": "str"  # The name of the database. Required.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_request(
            database_cluster_uuid=database_cluster_uuid,
            database_name=database_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(
        self, database_cluster_uuid: str, database_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Database.

        To delete a specific database, send a DELETE request to
        ``/v2/databases/$DATABASE_ID/dbs/$DB_NAME``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        Note: Database management is not supported for Redis clusters.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param database_name: The name of the database. Required.
        :type database_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_request(
            database_cluster_uuid=database_cluster_uuid,
            database_name=database_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_connection_pools(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Connection Pools (PostgreSQL).

        To list all of the connection pools available to a PostgreSQL database cluster, send a GET
        request to ``/v2/databases/$DATABASE_ID/pools``.
        The result will be a JSON object with a ``pools`` key. This will be set to an array of
        connection pool objects.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "pools": [
                        {
                            "db": "str",  # The database for use with the connection
                              pool. Required.
                            "mode": "str",  # The PGBouncer transaction mode for the
                              connection pool. The allowed values are session, transaction, and
                              statement. Required.
                            "name": "str",  # A unique name for the connection pool. Must
                              be between 3 and 60 characters. Required.
                            "size": 0,  # The desired size of the PGBouncer connection
                              pool. The maximum allowed size is determined by the size of the cluster's
                              primary node. 25 backend server connections are allowed for every 1GB of
                              RAM. Three are reserved for maintenance. For example, a primary node with
                              1 GB of RAM allows for a maximum of 22 backend server connections while
                              one with 4 GB would allow for 97. Note that these are shared across all
                              connection pools in a cluster. Required.
                            "connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "private_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "standby_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "standby_private_connection": {
                                "database": "str",  # Optional. The name of the
                                  default database.
                                "host": "str",  # Optional. The FQDN pointing to the
                                  database cluster's current primary node.
                                "password": "str",  # Optional. The randomly
                                  generated password for the default user.
                                "port": 0,  # Optional. The port on which the
                                  database cluster is listening.
                                "ssl": bool,  # Optional. A boolean value indicating
                                  if the connection should be made over SSL.
                                "uri": "str",  # Optional. A connection string in the
                                  format accepted by the ``psql`` command. This is provided as a
                                  convenience and should be able to be constructed by the other
                                  attributes.
                                "user": "str"  # Optional. The default user for the
                                  database.
                            },
                            "user": "str"  # Optional. The name of the user for use with
                              the connection pool. When excluded, all sessions connect to the database
                              as the inbound user.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_connection_pools_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def add_connection_pool(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Connection Pool (PostgreSQL).

        For PostgreSQL database clusters, connection pools can be used to allow a
        database to share its idle connections. The popular PostgreSQL connection
        pooling utility PgBouncer is used to provide this service. `See here for more information
        <https://docs.digitalocean.com/products/databases/postgresql/how-to/manage-connection-pools/>`_
        about how and why to use PgBouncer connection pooling including
        details about the available transaction modes.

        To add a new connection pool to a PostgreSQL database cluster, send a POST
        request to ``/v2/databases/$DATABASE_ID/pools`` specifying a name for the pool,
        the user to connect with, the database to connect to, as well as its desired
        size and transaction mode.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "db": "str",  # The database for use with the connection pool. Required.
                    "mode": "str",  # The PGBouncer transaction mode for the connection pool. The
                      allowed values are session, transaction, and statement. Required.
                    "name": "str",  # A unique name for the connection pool. Must be between 3
                      and 60 characters. Required.
                    "size": 0,  # The desired size of the PGBouncer connection pool. The maximum
                      allowed size is determined by the size of the cluster's primary node. 25 backend
                      server connections are allowed for every 1GB of RAM. Three are reserved for
                      maintenance. For example, a primary node with 1 GB of RAM allows for a maximum of
                      22 backend server connections while one with 4 GB would allow for 97. Note that
                      these are shared across all connection pools in a cluster. Required.
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "user": "str"  # Optional. The name of the user for use with the connection
                      pool. When excluded, all sessions connect to the database as the inbound user.
                }

                # response body for status code(s): 201
                response == {
                    "pool": {
                        "db": "str",  # The database for use with the connection pool.
                          Required.
                        "mode": "str",  # The PGBouncer transaction mode for the connection
                          pool. The allowed values are session, transaction, and statement. Required.
                        "name": "str",  # A unique name for the connection pool. Must be
                          between 3 and 60 characters. Required.
                        "size": 0,  # The desired size of the PGBouncer connection pool. The
                          maximum allowed size is determined by the size of the cluster's primary node.
                          25 backend server connections are allowed for every 1GB of RAM. Three are
                          reserved for maintenance. For example, a primary node with 1 GB of RAM allows
                          for a maximum of 22 backend server connections while one with 4 GB would
                          allow for 97. Note that these are shared across all connection pools in a
                          cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "user": "str"  # Optional. The name of the user for use with the
                          connection pool. When excluded, all sessions connect to the database as the
                          inbound user.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_connection_pool(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Connection Pool (PostgreSQL).

        For PostgreSQL database clusters, connection pools can be used to allow a
        database to share its idle connections. The popular PostgreSQL connection
        pooling utility PgBouncer is used to provide this service. `See here for more information
        <https://docs.digitalocean.com/products/databases/postgresql/how-to/manage-connection-pools/>`_
        about how and why to use PgBouncer connection pooling including
        details about the available transaction modes.

        To add a new connection pool to a PostgreSQL database cluster, send a POST
        request to ``/v2/databases/$DATABASE_ID/pools`` specifying a name for the pool,
        the user to connect with, the database to connect to, as well as its desired
        size and transaction mode.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "pool": {
                        "db": "str",  # The database for use with the connection pool.
                          Required.
                        "mode": "str",  # The PGBouncer transaction mode for the connection
                          pool. The allowed values are session, transaction, and statement. Required.
                        "name": "str",  # A unique name for the connection pool. Must be
                          between 3 and 60 characters. Required.
                        "size": 0,  # The desired size of the PGBouncer connection pool. The
                          maximum allowed size is determined by the size of the cluster's primary node.
                          25 backend server connections are allowed for every 1GB of RAM. Three are
                          reserved for maintenance. For example, a primary node with 1 GB of RAM allows
                          for a maximum of 22 backend server connections while one with 4 GB would
                          allow for 97. Note that these are shared across all connection pools in a
                          cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "user": "str"  # Optional. The name of the user for use with the
                          connection pool. When excluded, all sessions connect to the database as the
                          inbound user.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_connection_pool(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a New Connection Pool (PostgreSQL).

        For PostgreSQL database clusters, connection pools can be used to allow a
        database to share its idle connections. The popular PostgreSQL connection
        pooling utility PgBouncer is used to provide this service. `See here for more information
        <https://docs.digitalocean.com/products/databases/postgresql/how-to/manage-connection-pools/>`_
        about how and why to use PgBouncer connection pooling including
        details about the available transaction modes.

        To add a new connection pool to a PostgreSQL database cluster, send a POST
        request to ``/v2/databases/$DATABASE_ID/pools`` specifying a name for the pool,
        the user to connect with, the database to connect to, as well as its desired
        size and transaction mode.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "db": "str",  # The database for use with the connection pool. Required.
                    "mode": "str",  # The PGBouncer transaction mode for the connection pool. The
                      allowed values are session, transaction, and statement. Required.
                    "name": "str",  # A unique name for the connection pool. Must be between 3
                      and 60 characters. Required.
                    "size": 0,  # The desired size of the PGBouncer connection pool. The maximum
                      allowed size is determined by the size of the cluster's primary node. 25 backend
                      server connections are allowed for every 1GB of RAM. Three are reserved for
                      maintenance. For example, a primary node with 1 GB of RAM allows for a maximum of
                      22 backend server connections while one with 4 GB would allow for 97. Note that
                      these are shared across all connection pools in a cluster. Required.
                    "connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "standby_private_connection": {
                        "database": "str",  # Optional. The name of the default database.
                        "host": "str",  # Optional. The FQDN pointing to the database
                          cluster's current primary node.
                        "password": "str",  # Optional. The randomly generated password for
                          the default user.
                        "port": 0,  # Optional. The port on which the database cluster is
                          listening.
                        "ssl": bool,  # Optional. A boolean value indicating if the
                          connection should be made over SSL.
                        "uri": "str",  # Optional. A connection string in the format accepted
                          by the ``psql`` command. This is provided as a convenience and should be able
                          to be constructed by the other attributes.
                        "user": "str"  # Optional. The default user for the database.
                    },
                    "user": "str"  # Optional. The name of the user for use with the connection
                      pool. When excluded, all sessions connect to the database as the inbound user.
                }

                # response body for status code(s): 201
                response == {
                    "pool": {
                        "db": "str",  # The database for use with the connection pool.
                          Required.
                        "mode": "str",  # The PGBouncer transaction mode for the connection
                          pool. The allowed values are session, transaction, and statement. Required.
                        "name": "str",  # A unique name for the connection pool. Must be
                          between 3 and 60 characters. Required.
                        "size": 0,  # The desired size of the PGBouncer connection pool. The
                          maximum allowed size is determined by the size of the cluster's primary node.
                          25 backend server connections are allowed for every 1GB of RAM. Three are
                          reserved for maintenance. For example, a primary node with 1 GB of RAM allows
                          for a maximum of 22 backend server connections while one with 4 GB would
                          allow for 97. Note that these are shared across all connection pools in a
                          cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "user": "str"  # Optional. The name of the user for use with the
                          connection pool. When excluded, all sessions connect to the database as the
                          inbound user.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_add_connection_pool_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_connection_pool(
        self, database_cluster_uuid: str, pool_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Existing Connection Pool (PostgreSQL).

        To show information about an existing connection pool for a PostgreSQL database cluster, send a
        GET request to ``/v2/databases/$DATABASE_ID/pools/$POOL_NAME``.
        The response will be a JSON object with a ``pool`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param pool_name: The name used to identify the connection pool. Required.
        :type pool_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "pool": {
                        "db": "str",  # The database for use with the connection pool.
                          Required.
                        "mode": "str",  # The PGBouncer transaction mode for the connection
                          pool. The allowed values are session, transaction, and statement. Required.
                        "name": "str",  # A unique name for the connection pool. Must be
                          between 3 and 60 characters. Required.
                        "size": 0,  # The desired size of the PGBouncer connection pool. The
                          maximum allowed size is determined by the size of the cluster's primary node.
                          25 backend server connections are allowed for every 1GB of RAM. Three are
                          reserved for maintenance. For example, a primary node with 1 GB of RAM allows
                          for a maximum of 22 backend server connections while one with 4 GB would
                          allow for 97. Note that these are shared across all connection pools in a
                          cluster. Required.
                        "connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "standby_private_connection": {
                            "database": "str",  # Optional. The name of the default
                              database.
                            "host": "str",  # Optional. The FQDN pointing to the database
                              cluster's current primary node.
                            "password": "str",  # Optional. The randomly generated
                              password for the default user.
                            "port": 0,  # Optional. The port on which the database
                              cluster is listening.
                            "ssl": bool,  # Optional. A boolean value indicating if the
                              connection should be made over SSL.
                            "uri": "str",  # Optional. A connection string in the format
                              accepted by the ``psql`` command. This is provided as a convenience and
                              should be able to be constructed by the other attributes.
                            "user": "str"  # Optional. The default user for the database.
                        },
                        "user": "str"  # Optional. The name of the user for use with the
                          connection pool. When excluded, all sessions connect to the database as the
                          inbound user.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_connection_pool_request(
            database_cluster_uuid=database_cluster_uuid,
            pool_name=pool_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_connection_pool(
        self,
        database_cluster_uuid: str,
        pool_name: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Connection Pools (PostgreSQL).

        To update a connection pool for a PostgreSQL database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/pools/$POOL_NAME``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param pool_name: The name used to identify the connection pool. Required.
        :type pool_name: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "db": "str",  # The database for use with the connection pool. Required.
                    "mode": "str",  # The PGBouncer transaction mode for the connection pool. The
                      allowed values are session, transaction, and statement. Required.
                    "size": 0,  # The desired size of the PGBouncer connection pool. The maximum
                      allowed size is determined by the size of the cluster's primary node. 25 backend
                      server connections are allowed for every 1GB of RAM. Three are reserved for
                      maintenance. For example, a primary node with 1 GB of RAM allows for a maximum of
                      22 backend server connections while one with 4 GB would allow for 97. Note that
                      these are shared across all connection pools in a cluster. Required.
                    "user": "str"  # Optional. The name of the user for use with the connection
                      pool. When excluded, all sessions connect to the database as the inbound user.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_connection_pool(
        self,
        database_cluster_uuid: str,
        pool_name: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Connection Pools (PostgreSQL).

        To update a connection pool for a PostgreSQL database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/pools/$POOL_NAME``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param pool_name: The name used to identify the connection pool. Required.
        :type pool_name: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_connection_pool(
        self,
        database_cluster_uuid: str,
        pool_name: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Connection Pools (PostgreSQL).

        To update a connection pool for a PostgreSQL database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/pools/$POOL_NAME``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param pool_name: The name used to identify the connection pool. Required.
        :type pool_name: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "db": "str",  # The database for use with the connection pool. Required.
                    "mode": "str",  # The PGBouncer transaction mode for the connection pool. The
                      allowed values are session, transaction, and statement. Required.
                    "size": 0,  # The desired size of the PGBouncer connection pool. The maximum
                      allowed size is determined by the size of the cluster's primary node. 25 backend
                      server connections are allowed for every 1GB of RAM. Three are reserved for
                      maintenance. For example, a primary node with 1 GB of RAM allows for a maximum of
                      22 backend server connections while one with 4 GB would allow for 97. Note that
                      these are shared across all connection pools in a cluster. Required.
                    "user": "str"  # Optional. The name of the user for use with the connection
                      pool. When excluded, all sessions connect to the database as the inbound user.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_connection_pool_request(
            database_cluster_uuid=database_cluster_uuid,
            pool_name=pool_name,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_connection_pool(
        self, database_cluster_uuid: str, pool_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Connection Pool (PostgreSQL).

        To delete a specific connection pool for a PostgreSQL database cluster, send
        a DELETE request to ``/v2/databases/$DATABASE_ID/pools/$POOL_NAME``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param pool_name: The name used to identify the connection pool. Required.
        :type pool_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_connection_pool_request(
            database_cluster_uuid=database_cluster_uuid,
            pool_name=pool_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_eviction_policy(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the Eviction Policy for a Redis Cluster.

        To retrieve the configured eviction policy for an existing Redis cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/eviction_policy``.
        The response will be a JSON object with an ``eviction_policy`` key. This will be set to a
        string representing the eviction policy.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "eviction_policy": "str"  # A string specifying the desired eviction policy
                      for the Redis cluster.   * ``noeviction``"" : Don't evict any data, returns error
                      when memory limit is reached. * ``allkeys_lru:`` Evict any key, least recently
                      used (LRU) first. * ``allkeys_random``"" : Evict keys in a random order. *
                      ``volatile_lru``"" : Evict keys with expiration only, least recently used (LRU)
                      first. * ``volatile_random``"" : Evict keys with expiration only in a random
                      order. * ``volatile_ttl``"" : Evict keys with expiration only, shortest
                      time-to-live (TTL) first. Required. Known values are: "noeviction",
                      "allkeys_lru", "allkeys_random", "volatile_lru", "volatile_random", and
                      "volatile_ttl".
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_eviction_policy_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_eviction_policy(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure the Eviction Policy for a Redis Cluster.

        To configure an eviction policy for an existing Redis cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/eviction_policy`` specifying the desired policy.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "eviction_policy": "str"  # A string specifying the desired eviction policy
                      for the Redis cluster.   * ``noeviction``"" : Don't evict any data, returns error
                      when memory limit is reached. * ``allkeys_lru:`` Evict any key, least recently
                      used (LRU) first. * ``allkeys_random``"" : Evict keys in a random order. *
                      ``volatile_lru``"" : Evict keys with expiration only, least recently used (LRU)
                      first. * ``volatile_random``"" : Evict keys with expiration only in a random
                      order. * ``volatile_ttl``"" : Evict keys with expiration only, shortest
                      time-to-live (TTL) first. Required. Known values are: "noeviction",
                      "allkeys_lru", "allkeys_random", "volatile_lru", "volatile_random", and
                      "volatile_ttl".
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_eviction_policy(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure the Eviction Policy for a Redis Cluster.

        To configure an eviction policy for an existing Redis cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/eviction_policy`` specifying the desired policy.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_eviction_policy(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Configure the Eviction Policy for a Redis Cluster.

        To configure an eviction policy for an existing Redis cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/eviction_policy`` specifying the desired policy.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "eviction_policy": "str"  # A string specifying the desired eviction policy
                      for the Redis cluster.   * ``noeviction``"" : Don't evict any data, returns error
                      when memory limit is reached. * ``allkeys_lru:`` Evict any key, least recently
                      used (LRU) first. * ``allkeys_random``"" : Evict keys in a random order. *
                      ``volatile_lru``"" : Evict keys with expiration only, least recently used (LRU)
                      first. * ``volatile_random``"" : Evict keys with expiration only in a random
                      order. * ``volatile_ttl``"" : Evict keys with expiration only, shortest
                      time-to-live (TTL) first. Required. Known values are: "noeviction",
                      "allkeys_lru", "allkeys_random", "volatile_lru", "volatile_random", and
                      "volatile_ttl".
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_eviction_policy_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_sql_mode(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the SQL Modes for a MySQL Cluster.

        To retrieve the configured SQL modes for an existing MySQL cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/sql_mode``.
        The response will be a JSON object with a ``sql_mode`` key. This will be set to a string
        representing the configured SQL modes.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "sql_mode": "str"  # A string specifying the configured SQL modes for the
                      MySQL cluster. Required.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_sql_mode_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_sql_mode(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update SQL Mode for a Cluster.

        To configure the SQL modes for an existing MySQL cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/sql_mode`` specifying the desired modes. See the official MySQL 8
        documentation for a `full list of supported SQL modes
        <https://dev.mysql.com/doc/refman/8.0/en/sql-mode.html#sql-mode-full>`_.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "sql_mode": "str"  # A string specifying the configured SQL modes for the
                      MySQL cluster. Required.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_sql_mode(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update SQL Mode for a Cluster.

        To configure the SQL modes for an existing MySQL cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/sql_mode`` specifying the desired modes. See the official MySQL 8
        documentation for a `full list of supported SQL modes
        <https://dev.mysql.com/doc/refman/8.0/en/sql-mode.html#sql-mode-full>`_.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_sql_mode(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update SQL Mode for a Cluster.

        To configure the SQL modes for an existing MySQL cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/sql_mode`` specifying the desired modes. See the official MySQL 8
        documentation for a `full list of supported SQL modes
        <https://dev.mysql.com/doc/refman/8.0/en/sql-mode.html#sql-mode-full>`_.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "sql_mode": "str"  # A string specifying the configured SQL modes for the
                      MySQL cluster. Required.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_sql_mode_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update_major_version(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade Major Version for a Database.

        To upgrade the major version of a database, send a PUT request to
        ``/v2/databases/$DATABASE_ID/upgrade``\\ , specifying the target version.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "version": "str"  # Optional. A string representing the version of the
                      database engine in use for the cluster.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_major_version(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade Major Version for a Database.

        To upgrade the major version of a database, send a PUT request to
        ``/v2/databases/$DATABASE_ID/upgrade``\\ , specifying the target version.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_major_version(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade Major Version for a Database.

        To upgrade the major version of a database, send a PUT request to
        ``/v2/databases/$DATABASE_ID/upgrade``\\ , specifying the target version.
        A successful request will receive a 204 No Content status code with no body in response.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "version": "str"  # Optional. A string representing the version of the
                      database engine in use for the cluster.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_major_version_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_kafka_topics(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Topics for a Kafka Cluster.

        To list all of a Kafka cluster's topics, send a GET request to
        ``/v2/databases/$DATABASE_ID/topics``.

        The result will be a JSON object with a ``topics`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "topics": [
                        {
                            "name": "str",  # Optional. The name of the Kafka topic.
                            "partition_count": 0,  # Optional. The number of partitions
                              available for the topic. On update, this value can only be increased.
                            "replication_factor": 0,  # Optional. The number of nodes to
                              replicate data across the cluster.
                            "state": "str"  # Optional. The state of the Kafka topic.
                              Known values are: "active", "configuring", "deleting", and "unknown".
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_kafka_topics_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_kafka_topic(
        self,
        database_cluster_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Topic for a Kafka Cluster.

        To create a topic attached to a Kafka cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/topics``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "cleanup_policy": "delete",  # Optional. Default value is "delete".
                          The cleanup_policy sets the retention policy to use on log segments. 'delete'
                          will discard old segments when retention time/size limits are reached.
                          'compact' will enable log compaction, resulting in retention of the latest
                          value for each key. Known values are: "delete", "compact", and
                          "compact_delete".
                        "compression_type": "producer",  # Optional. Default value is
                          "producer". The compression_type specifies the compression type of the topic.
                          Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                          "uncompressed".
                        "delete_retention_ms": 86400000,  # Optional. Default value is
                          86400000. The delete_retention_ms specifies how long (in ms) to retain delete
                          tombstone markers for topics.
                        "file_delete_delay_ms": 60000,  # Optional. Default value is 60000.
                          The file_delete_delay_ms specifies the time (in ms) to wait before deleting a
                          file from the filesystem.
                        "flush_messages": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_messages specifies the number of messages to
                          accumulate on a log partition before messages are flushed to disk.
                        "flush_ms": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_ms specifies the maximum time (in ms) that a
                          message is kept in memory before being flushed to disk.
                        "index_interval_bytes": 4096,  # Optional. Default value is 4096. The
                          index_interval_bytes specifies the number of bytes between entries being
                          added into te offset index.
                        "max_compaction_lag_ms": 9223372036854776000,  # Optional. Default
                          value is 9223372036854776000. The max_compaction_lag_ms specifies the maximum
                          amount of time (in ms) that a message will remain uncompacted. This is only
                          applicable if the logs are have compaction enabled.
                        "max_message_bytes": 1048588,  # Optional. Default value is 1048588.
                          The max_messages_bytes specifies the largest record batch size (in bytes)
                          that can be sent to the server.  This is calculated after compression if
                          compression is enabled.
                        "message_down_conversion_enable": True,  # Optional. Default value is
                          True. The message_down_conversion_enable specifies whether down-conversion of
                          message formats is enabled to satisfy consumer requests. When 'false', the
                          broker will not perform conversion for consumers expecting older message
                          formats. The broker will respond with an ``UNSUPPORTED_VERSION`` error for
                          consume requests from these older clients.
                        "message_format_version": "3.0-IV1",  # Optional. Default value is
                          "3.0-IV1". The message_format_version specifies the message format version
                          used by the broker to append messages to the logs. The value of this setting
                          is assumed to be 3.0-IV1 if the broker protocol version is 3.0 or higher. By
                          setting a  particular message format version, all existing messages on disk
                          must be smaller or equal to the specified version. Known values are: "0.8.0",
                          "0.8.1", "0.8.2", "0.9.0", "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0",
                          "0.10.1-IV1", "0.10.1-IV2", "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1",
                          "0.11.0-IV2", "1.0-IV0", "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0",
                          "2.1-IV1", "2.1-IV2", "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0",
                          "2.4-IV1", "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                          "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0", "3.3-IV1",
                          "3.3-IV2", and "3.3-IV3".
                        "message_timestamp_type": "create_time",  # Optional. Default value
                          is "create_time". The message_timestamp_type specifies whether to use the
                          message create time or log append time as the timestamp on a message. Known
                          values are: "create_time" and "log_append_time".
                        "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value is 0.5.
                          The min_cleanable_dirty_ratio specifies the frequency of log compaction (if
                          enabled) in relation to duplicates present in the logs. For example, at 0.5,
                          at most 50% of the log could be duplicates before compaction would begin.
                        "min_compaction_lag_ms": 0,  # Optional. Default value is 0. The
                          min_compaction_lag_ms specifies the minimum time (in ms) that a message will
                          remain uncompacted in the log. Only relevant if log compaction is enabled.
                        "min_insync_replicas": 1,  # Optional. Default value is 1. The
                          min_insync_replicas specifies the number of replicas that must ACK a write
                          for the write to be considered successful.
                        "preallocate": False,  # Optional. Default value is False. The
                          preallocate specifies whether a file should be preallocated on disk when
                          creating a new log segment.
                        "retention_bytes": -1,  # Optional. Default value is -1. The
                          retention_bytes specifies the maximum size of the log (in bytes) before
                          deleting messages. -1 indicates that there is no limit.
                        "retention_ms": 604800000,  # Optional. Default value is 604800000.
                          The retention_ms specifies the maximum amount of time (in ms) to keep a
                          message before deleting it.
                        "segment_bytes": 209715200,  # Optional. Default value is 209715200.
                          The segment_bytes specifies the maximum size of a single log file (in bytes).
                        "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                          segment_jitter_ms specifies the maximum random jitter subtracted from the
                          scheduled segment roll time to avoid thundering herds of segment rolling.
                        "segment_ms": 604800000  # Optional. Default value is 604800000. The
                          segment_ms specifies the period of time after which the log will be forced to
                          roll if the segment file isn't full. This ensures that retention can delete
                          or compact old data.
                    },
                    "name": "str",  # Optional. The name of the Kafka topic.
                    "partition_count": 0,  # Optional. The number of partitions available for the
                      topic. On update, this value can only be increased.
                    "replication_factor": 0  # Optional. The number of nodes to replicate data
                      across the cluster.
                }

                # response body for status code(s): 201
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_kafka_topic(
        self,
        database_cluster_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Topic for a Kafka Cluster.

        To create a topic attached to a Kafka cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/topics``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_kafka_topic(
        self,
        database_cluster_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Topic for a Kafka Cluster.

        To create a topic attached to a Kafka cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/topics``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "cleanup_policy": "delete",  # Optional. Default value is "delete".
                          The cleanup_policy sets the retention policy to use on log segments. 'delete'
                          will discard old segments when retention time/size limits are reached.
                          'compact' will enable log compaction, resulting in retention of the latest
                          value for each key. Known values are: "delete", "compact", and
                          "compact_delete".
                        "compression_type": "producer",  # Optional. Default value is
                          "producer". The compression_type specifies the compression type of the topic.
                          Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                          "uncompressed".
                        "delete_retention_ms": 86400000,  # Optional. Default value is
                          86400000. The delete_retention_ms specifies how long (in ms) to retain delete
                          tombstone markers for topics.
                        "file_delete_delay_ms": 60000,  # Optional. Default value is 60000.
                          The file_delete_delay_ms specifies the time (in ms) to wait before deleting a
                          file from the filesystem.
                        "flush_messages": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_messages specifies the number of messages to
                          accumulate on a log partition before messages are flushed to disk.
                        "flush_ms": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_ms specifies the maximum time (in ms) that a
                          message is kept in memory before being flushed to disk.
                        "index_interval_bytes": 4096,  # Optional. Default value is 4096. The
                          index_interval_bytes specifies the number of bytes between entries being
                          added into te offset index.
                        "max_compaction_lag_ms": 9223372036854776000,  # Optional. Default
                          value is 9223372036854776000. The max_compaction_lag_ms specifies the maximum
                          amount of time (in ms) that a message will remain uncompacted. This is only
                          applicable if the logs are have compaction enabled.
                        "max_message_bytes": 1048588,  # Optional. Default value is 1048588.
                          The max_messages_bytes specifies the largest record batch size (in bytes)
                          that can be sent to the server.  This is calculated after compression if
                          compression is enabled.
                        "message_down_conversion_enable": True,  # Optional. Default value is
                          True. The message_down_conversion_enable specifies whether down-conversion of
                          message formats is enabled to satisfy consumer requests. When 'false', the
                          broker will not perform conversion for consumers expecting older message
                          formats. The broker will respond with an ``UNSUPPORTED_VERSION`` error for
                          consume requests from these older clients.
                        "message_format_version": "3.0-IV1",  # Optional. Default value is
                          "3.0-IV1". The message_format_version specifies the message format version
                          used by the broker to append messages to the logs. The value of this setting
                          is assumed to be 3.0-IV1 if the broker protocol version is 3.0 or higher. By
                          setting a  particular message format version, all existing messages on disk
                          must be smaller or equal to the specified version. Known values are: "0.8.0",
                          "0.8.1", "0.8.2", "0.9.0", "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0",
                          "0.10.1-IV1", "0.10.1-IV2", "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1",
                          "0.11.0-IV2", "1.0-IV0", "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0",
                          "2.1-IV1", "2.1-IV2", "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0",
                          "2.4-IV1", "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                          "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0", "3.3-IV1",
                          "3.3-IV2", and "3.3-IV3".
                        "message_timestamp_type": "create_time",  # Optional. Default value
                          is "create_time". The message_timestamp_type specifies whether to use the
                          message create time or log append time as the timestamp on a message. Known
                          values are: "create_time" and "log_append_time".
                        "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value is 0.5.
                          The min_cleanable_dirty_ratio specifies the frequency of log compaction (if
                          enabled) in relation to duplicates present in the logs. For example, at 0.5,
                          at most 50% of the log could be duplicates before compaction would begin.
                        "min_compaction_lag_ms": 0,  # Optional. Default value is 0. The
                          min_compaction_lag_ms specifies the minimum time (in ms) that a message will
                          remain uncompacted in the log. Only relevant if log compaction is enabled.
                        "min_insync_replicas": 1,  # Optional. Default value is 1. The
                          min_insync_replicas specifies the number of replicas that must ACK a write
                          for the write to be considered successful.
                        "preallocate": False,  # Optional. Default value is False. The
                          preallocate specifies whether a file should be preallocated on disk when
                          creating a new log segment.
                        "retention_bytes": -1,  # Optional. Default value is -1. The
                          retention_bytes specifies the maximum size of the log (in bytes) before
                          deleting messages. -1 indicates that there is no limit.
                        "retention_ms": 604800000,  # Optional. Default value is 604800000.
                          The retention_ms specifies the maximum amount of time (in ms) to keep a
                          message before deleting it.
                        "segment_bytes": 209715200,  # Optional. Default value is 209715200.
                          The segment_bytes specifies the maximum size of a single log file (in bytes).
                        "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                          segment_jitter_ms specifies the maximum random jitter subtracted from the
                          scheduled segment roll time to avoid thundering herds of segment rolling.
                        "segment_ms": 604800000  # Optional. Default value is 604800000. The
                          segment_ms specifies the period of time after which the log will be forced to
                          roll if the segment file isn't full. This ensures that retention can delete
                          or compact old data.
                    },
                    "name": "str",  # Optional. The name of the Kafka topic.
                    "partition_count": 0,  # Optional. The number of partitions available for the
                      topic. On update, this value can only be increased.
                    "replication_factor": 0  # Optional. The number of nodes to replicate data
                      across the cluster.
                }

                # response body for status code(s): 201
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_databases_create_kafka_topic_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_kafka_topic(
        self, database_cluster_uuid: str, topic_name: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Topic for a Kafka Cluster.

        To retrieve a given topic by name from the set of a Kafka cluster's topics,
        send a GET request to ``/v2/databases/$DATABASE_ID/topics/$TOPIC_NAME``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param topic_name: The name used to identify the Kafka topic. Required.
        :type topic_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_kafka_topic_request(
            database_cluster_uuid=database_cluster_uuid,
            topic_name=topic_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_kafka_topic(
        self,
        database_cluster_uuid: str,
        topic_name: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Topic for a Kafka Cluster.

        To update a topic attached to a Kafka cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/topics/$TOPIC_NAME``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param topic_name: The name used to identify the Kafka topic. Required.
        :type topic_name: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "cleanup_policy": "delete",  # Optional. Default value is "delete".
                          The cleanup_policy sets the retention policy to use on log segments. 'delete'
                          will discard old segments when retention time/size limits are reached.
                          'compact' will enable log compaction, resulting in retention of the latest
                          value for each key. Known values are: "delete", "compact", and
                          "compact_delete".
                        "compression_type": "producer",  # Optional. Default value is
                          "producer". The compression_type specifies the compression type of the topic.
                          Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                          "uncompressed".
                        "delete_retention_ms": 86400000,  # Optional. Default value is
                          86400000. The delete_retention_ms specifies how long (in ms) to retain delete
                          tombstone markers for topics.
                        "file_delete_delay_ms": 60000,  # Optional. Default value is 60000.
                          The file_delete_delay_ms specifies the time (in ms) to wait before deleting a
                          file from the filesystem.
                        "flush_messages": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_messages specifies the number of messages to
                          accumulate on a log partition before messages are flushed to disk.
                        "flush_ms": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_ms specifies the maximum time (in ms) that a
                          message is kept in memory before being flushed to disk.
                        "index_interval_bytes": 4096,  # Optional. Default value is 4096. The
                          index_interval_bytes specifies the number of bytes between entries being
                          added into te offset index.
                        "max_compaction_lag_ms": 9223372036854776000,  # Optional. Default
                          value is 9223372036854776000. The max_compaction_lag_ms specifies the maximum
                          amount of time (in ms) that a message will remain uncompacted. This is only
                          applicable if the logs are have compaction enabled.
                        "max_message_bytes": 1048588,  # Optional. Default value is 1048588.
                          The max_messages_bytes specifies the largest record batch size (in bytes)
                          that can be sent to the server.  This is calculated after compression if
                          compression is enabled.
                        "message_down_conversion_enable": True,  # Optional. Default value is
                          True. The message_down_conversion_enable specifies whether down-conversion of
                          message formats is enabled to satisfy consumer requests. When 'false', the
                          broker will not perform conversion for consumers expecting older message
                          formats. The broker will respond with an ``UNSUPPORTED_VERSION`` error for
                          consume requests from these older clients.
                        "message_format_version": "3.0-IV1",  # Optional. Default value is
                          "3.0-IV1". The message_format_version specifies the message format version
                          used by the broker to append messages to the logs. The value of this setting
                          is assumed to be 3.0-IV1 if the broker protocol version is 3.0 or higher. By
                          setting a  particular message format version, all existing messages on disk
                          must be smaller or equal to the specified version. Known values are: "0.8.0",
                          "0.8.1", "0.8.2", "0.9.0", "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0",
                          "0.10.1-IV1", "0.10.1-IV2", "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1",
                          "0.11.0-IV2", "1.0-IV0", "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0",
                          "2.1-IV1", "2.1-IV2", "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0",
                          "2.4-IV1", "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                          "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0", "3.3-IV1",
                          "3.3-IV2", and "3.3-IV3".
                        "message_timestamp_type": "create_time",  # Optional. Default value
                          is "create_time". The message_timestamp_type specifies whether to use the
                          message create time or log append time as the timestamp on a message. Known
                          values are: "create_time" and "log_append_time".
                        "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value is 0.5.
                          The min_cleanable_dirty_ratio specifies the frequency of log compaction (if
                          enabled) in relation to duplicates present in the logs. For example, at 0.5,
                          at most 50% of the log could be duplicates before compaction would begin.
                        "min_compaction_lag_ms": 0,  # Optional. Default value is 0. The
                          min_compaction_lag_ms specifies the minimum time (in ms) that a message will
                          remain uncompacted in the log. Only relevant if log compaction is enabled.
                        "min_insync_replicas": 1,  # Optional. Default value is 1. The
                          min_insync_replicas specifies the number of replicas that must ACK a write
                          for the write to be considered successful.
                        "preallocate": False,  # Optional. Default value is False. The
                          preallocate specifies whether a file should be preallocated on disk when
                          creating a new log segment.
                        "retention_bytes": -1,  # Optional. Default value is -1. The
                          retention_bytes specifies the maximum size of the log (in bytes) before
                          deleting messages. -1 indicates that there is no limit.
                        "retention_ms": 604800000,  # Optional. Default value is 604800000.
                          The retention_ms specifies the maximum amount of time (in ms) to keep a
                          message before deleting it.
                        "segment_bytes": 209715200,  # Optional. Default value is 209715200.
                          The segment_bytes specifies the maximum size of a single log file (in bytes).
                        "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                          segment_jitter_ms specifies the maximum random jitter subtracted from the
                          scheduled segment roll time to avoid thundering herds of segment rolling.
                        "segment_ms": 604800000  # Optional. Default value is 604800000. The
                          segment_ms specifies the period of time after which the log will be forced to
                          roll if the segment file isn't full. This ensures that retention can delete
                          or compact old data.
                    },
                    "partition_count": 0,  # Optional. The number of partitions available for the
                      topic. On update, this value can only be increased.
                    "replication_factor": 0  # Optional. The number of nodes to replicate data
                      across the cluster.
                }

                # response body for status code(s): 200
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_kafka_topic(
        self,
        database_cluster_uuid: str,
        topic_name: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Topic for a Kafka Cluster.

        To update a topic attached to a Kafka cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/topics/$TOPIC_NAME``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param topic_name: The name used to identify the Kafka topic. Required.
        :type topic_name: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_kafka_topic(
        self,
        database_cluster_uuid: str,
        topic_name: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Topic for a Kafka Cluster.

        To update a topic attached to a Kafka cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/topics/$TOPIC_NAME``.

        The result will be a JSON object with a ``topic`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param topic_name: The name used to identify the Kafka topic. Required.
        :type topic_name: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "cleanup_policy": "delete",  # Optional. Default value is "delete".
                          The cleanup_policy sets the retention policy to use on log segments. 'delete'
                          will discard old segments when retention time/size limits are reached.
                          'compact' will enable log compaction, resulting in retention of the latest
                          value for each key. Known values are: "delete", "compact", and
                          "compact_delete".
                        "compression_type": "producer",  # Optional. Default value is
                          "producer". The compression_type specifies the compression type of the topic.
                          Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                          "uncompressed".
                        "delete_retention_ms": 86400000,  # Optional. Default value is
                          86400000. The delete_retention_ms specifies how long (in ms) to retain delete
                          tombstone markers for topics.
                        "file_delete_delay_ms": 60000,  # Optional. Default value is 60000.
                          The file_delete_delay_ms specifies the time (in ms) to wait before deleting a
                          file from the filesystem.
                        "flush_messages": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_messages specifies the number of messages to
                          accumulate on a log partition before messages are flushed to disk.
                        "flush_ms": 9223372036854776000,  # Optional. Default value is
                          9223372036854776000. The flush_ms specifies the maximum time (in ms) that a
                          message is kept in memory before being flushed to disk.
                        "index_interval_bytes": 4096,  # Optional. Default value is 4096. The
                          index_interval_bytes specifies the number of bytes between entries being
                          added into te offset index.
                        "max_compaction_lag_ms": 9223372036854776000,  # Optional. Default
                          value is 9223372036854776000. The max_compaction_lag_ms specifies the maximum
                          amount of time (in ms) that a message will remain uncompacted. This is only
                          applicable if the logs are have compaction enabled.
                        "max_message_bytes": 1048588,  # Optional. Default value is 1048588.
                          The max_messages_bytes specifies the largest record batch size (in bytes)
                          that can be sent to the server.  This is calculated after compression if
                          compression is enabled.
                        "message_down_conversion_enable": True,  # Optional. Default value is
                          True. The message_down_conversion_enable specifies whether down-conversion of
                          message formats is enabled to satisfy consumer requests. When 'false', the
                          broker will not perform conversion for consumers expecting older message
                          formats. The broker will respond with an ``UNSUPPORTED_VERSION`` error for
                          consume requests from these older clients.
                        "message_format_version": "3.0-IV1",  # Optional. Default value is
                          "3.0-IV1". The message_format_version specifies the message format version
                          used by the broker to append messages to the logs. The value of this setting
                          is assumed to be 3.0-IV1 if the broker protocol version is 3.0 or higher. By
                          setting a  particular message format version, all existing messages on disk
                          must be smaller or equal to the specified version. Known values are: "0.8.0",
                          "0.8.1", "0.8.2", "0.9.0", "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0",
                          "0.10.1-IV1", "0.10.1-IV2", "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1",
                          "0.11.0-IV2", "1.0-IV0", "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0",
                          "2.1-IV1", "2.1-IV2", "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0",
                          "2.4-IV1", "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                          "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0", "3.3-IV1",
                          "3.3-IV2", and "3.3-IV3".
                        "message_timestamp_type": "create_time",  # Optional. Default value
                          is "create_time". The message_timestamp_type specifies whether to use the
                          message create time or log append time as the timestamp on a message. Known
                          values are: "create_time" and "log_append_time".
                        "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value is 0.5.
                          The min_cleanable_dirty_ratio specifies the frequency of log compaction (if
                          enabled) in relation to duplicates present in the logs. For example, at 0.5,
                          at most 50% of the log could be duplicates before compaction would begin.
                        "min_compaction_lag_ms": 0,  # Optional. Default value is 0. The
                          min_compaction_lag_ms specifies the minimum time (in ms) that a message will
                          remain uncompacted in the log. Only relevant if log compaction is enabled.
                        "min_insync_replicas": 1,  # Optional. Default value is 1. The
                          min_insync_replicas specifies the number of replicas that must ACK a write
                          for the write to be considered successful.
                        "preallocate": False,  # Optional. Default value is False. The
                          preallocate specifies whether a file should be preallocated on disk when
                          creating a new log segment.
                        "retention_bytes": -1,  # Optional. Default value is -1. The
                          retention_bytes specifies the maximum size of the log (in bytes) before
                          deleting messages. -1 indicates that there is no limit.
                        "retention_ms": 604800000,  # Optional. Default value is 604800000.
                          The retention_ms specifies the maximum amount of time (in ms) to keep a
                          message before deleting it.
                        "segment_bytes": 209715200,  # Optional. Default value is 209715200.
                          The segment_bytes specifies the maximum size of a single log file (in bytes).
                        "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                          segment_jitter_ms specifies the maximum random jitter subtracted from the
                          scheduled segment roll time to avoid thundering herds of segment rolling.
                        "segment_ms": 604800000  # Optional. Default value is 604800000. The
                          segment_ms specifies the period of time after which the log will be forced to
                          roll if the segment file isn't full. This ensures that retention can delete
                          or compact old data.
                    },
                    "partition_count": 0,  # Optional. The number of partitions available for the
                      topic. On update, this value can only be increased.
                    "replication_factor": 0  # Optional. The number of nodes to replicate data
                      across the cluster.
                }

                # response body for status code(s): 200
                response == {
                    "topic": {
                        "config": {
                            "cleanup_policy": "delete",  # Optional. Default value is
                              "delete". The cleanup_policy sets the retention policy to use on log
                              segments. 'delete' will discard old segments when retention time/size
                              limits are reached. 'compact' will enable log compaction, resulting in
                              retention of the latest value for each key. Known values are: "delete",
                              "compact", and "compact_delete".
                            "compression_type": "producer",  # Optional. Default value is
                              "producer". The compression_type specifies the compression type of the
                              topic. Known values are: "producer", "gzip", "snappy", "Iz4", "zstd", and
                              "uncompressed".
                            "delete_retention_ms": 86400000,  # Optional. Default value
                              is 86400000. The delete_retention_ms specifies how long (in ms) to retain
                              delete tombstone markers for topics.
                            "file_delete_delay_ms": 60000,  # Optional. Default value is
                              60000. The file_delete_delay_ms specifies the time (in ms) to wait before
                              deleting a file from the filesystem.
                            "flush_messages": 9223372036854776000,  # Optional. Default
                              value is 9223372036854776000. The flush_messages specifies the number of
                              messages to accumulate on a log partition before messages are flushed to
                              disk.
                            "flush_ms": 9223372036854776000,  # Optional. Default value
                              is 9223372036854776000. The flush_ms specifies the maximum time (in ms)
                              that a message is kept in memory before being flushed to disk.
                            "index_interval_bytes": 4096,  # Optional. Default value is
                              4096. The index_interval_bytes specifies the number of bytes between
                              entries being added into te offset index.
                            "max_compaction_lag_ms": 9223372036854776000,  # Optional.
                              Default value is 9223372036854776000. The max_compaction_lag_ms specifies
                              the maximum amount of time (in ms) that a message will remain
                              uncompacted. This is only applicable if the logs are have compaction
                              enabled.
                            "max_message_bytes": 1048588,  # Optional. Default value is
                              1048588. The max_messages_bytes specifies the largest record batch size
                              (in bytes) that can be sent to the server.  This is calculated after
                              compression if compression is enabled.
                            "message_down_conversion_enable": True,  # Optional. Default
                              value is True. The message_down_conversion_enable specifies whether
                              down-conversion of message formats is enabled to satisfy consumer
                              requests. When 'false', the broker will not perform conversion for
                              consumers expecting older message formats. The broker will respond with
                              an ``UNSUPPORTED_VERSION`` error for consume requests from these older
                              clients.
                            "message_format_version": "3.0-IV1",  # Optional. Default
                              value is "3.0-IV1". The message_format_version specifies the message
                              format version used by the broker to append messages to the logs. The
                              value of this setting is assumed to be 3.0-IV1 if the broker protocol
                              version is 3.0 or higher. By setting a  particular message format
                              version, all existing messages on disk must be smaller or equal to the
                              specified version. Known values are: "0.8.0", "0.8.1", "0.8.2", "0.9.0",
                              "0.10.0-IV0", "0.10.0-IV1", "0.10.1-IV0", "0.10.1-IV1", "0.10.1-IV2",
                              "0.10.2-IV0", "0.11.0-IV0", "0.11.0-IV1", "0.11.0-IV2", "1.0-IV0",
                              "1.1-IV0", "2.0-IV0", "2.0-IV1", "2.1-IV0", "2.1-IV1", "2.1-IV2",
                              "2.2-IV0", "2.2-IV1", "2.3-IV0", "2.3-IV1", "2.4-IV0", "2.4-IV1",
                              "2.5-IV0", "2.6-IV0", "2.7-IV0", "2.7-IV1", "2.7-IV2", "2.8-IV0",
                              "2.8-IV1", "3.0-IV0", "3.0-IV1", "3.1-IV0", "3.2-IV0", "3.3-IV0",
                              "3.3-IV1", "3.3-IV2", and "3.3-IV3".
                            "message_timestamp_type": "create_time",  # Optional. Default
                              value is "create_time". The message_timestamp_type specifies whether to
                              use the message create time or log append time as the timestamp on a
                              message. Known values are: "create_time" and "log_append_time".
                            "min_cleanable_dirty_ratio": 0.5,  # Optional. Default value
                              is 0.5. The min_cleanable_dirty_ratio specifies the frequency of log
                              compaction (if enabled) in relation to duplicates present in the logs.
                              For example, at 0.5, at most 50% of the log could be duplicates before
                              compaction would begin.
                            "min_compaction_lag_ms": 0,  # Optional. Default value is 0.
                              The min_compaction_lag_ms specifies the minimum time (in ms) that a
                              message will remain uncompacted in the log. Only relevant if log
                              compaction is enabled.
                            "min_insync_replicas": 1,  # Optional. Default value is 1.
                              The min_insync_replicas specifies the number of replicas that must ACK a
                              write for the write to be considered successful.
                            "preallocate": False,  # Optional. Default value is False.
                              The preallocate specifies whether a file should be preallocated on disk
                              when creating a new log segment.
                            "retention_bytes": -1,  # Optional. Default value is -1. The
                              retention_bytes specifies the maximum size of the log (in bytes) before
                              deleting messages. -1 indicates that there is no limit.
                            "retention_ms": 604800000,  # Optional. Default value is
                              604800000. The retention_ms specifies the maximum amount of time (in ms)
                              to keep a message before deleting it.
                            "segment_bytes": 209715200,  # Optional. Default value is
                              209715200. The segment_bytes specifies the maximum size of a single log
                              file (in bytes).
                            "segment_jitter_ms": 0,  # Optional. Default value is 0. The
                              segment_jitter_ms specifies the maximum random jitter subtracted from the
                              scheduled segment roll time to avoid thundering herds of segment rolling.
                            "segment_ms": 604800000  # Optional. Default value is
                              604800000. The segment_ms specifies the period of time after which the
                              log will be forced to roll if the segment file isn't full. This ensures
                              that retention can delete or compact old data.
                        },
                        "name": "str",  # Optional. The name of the Kafka topic.
                        "partitions": [
                            {
                                "consumer_groups": [
                                    {
                                        "group_name": "str",  # Optional.
                                          Name of the consumer group.
                                        "offset": 0  # Optional. The current
                                          offset of the consumer group.
                                    }
                                ],
                                "earliest_offset": 0,  # Optional. The earliest
                                  consumer offset amongst consumer groups.
                                "id": 0,  # Optional. An identifier for the
                                  partition.
                                "in_sync_replicas": 0,  # Optional. The number of
                                  nodes that are in-sync (have the latest data) for the given
                                  partition.
                                "size": 0  # Optional. Size of the topic partition in
                                  bytes.
                            }
                        ],
                        "replication_factor": 0,  # Optional. The number of nodes to
                          replicate data across the cluster.
                        "state": "str"  # Optional. The state of the Kafka topic. Known
                          values are: "active", "configuring", "deleting", and "unknown".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_databases_update_kafka_topic_request(
            database_cluster_uuid=database_cluster_uuid,
            topic_name=topic_name,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_kafka_topic(
        self, database_cluster_uuid: str, topic_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Topic for a Kafka Cluster.

        To delete a single topic within a Kafka cluster, send a DELETE request
        to ``/v2/databases/$DATABASE_ID/topics/$TOPIC_NAME``.

        A status of 204 will be given. This indicates that the request was
        processed successfully, but that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param topic_name: The name used to identify the Kafka topic. Required.
        :type topic_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_kafka_topic_request(
            database_cluster_uuid=database_cluster_uuid,
            topic_name=topic_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_logsink(self, database_cluster_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Logsinks for a Database Cluster.

        To list logsinks for a database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/logsink``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "sinks": [
                        {
                            "config": {},
                            "sink_id": "str",  # Optional. A unique identifier for
                              Logsink.
                            "sink_name": "str",  # Optional. The name of the Logsink.
                            "sink_type": "str"  # Optional. Known values are: "rsyslog",
                              "elasticsearch", and "opensearch".
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_logsink_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_logsink(
        self,
        database_cluster_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Logsink for a Database Cluster.

        To create logsink for a database cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/logsink``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "sink_name": "str",  # Optional. The name of the Logsink.
                    "sink_type": "str"  # Optional. Known values are: "rsyslog", "elasticsearch",
                      and "opensearch".
                }

                # response body for status code(s): 201
                response == {
                    "sink": {
                        "config": {},
                        "sink_id": "str",  # Optional. A unique identifier for Logsink.
                        "sink_name": "str",  # Optional. The name of the Logsink.
                        "sink_type": "str"  # Optional. Known values are: "rsyslog",
                          "elasticsearch", and "opensearch".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_logsink(
        self,
        database_cluster_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Logsink for a Database Cluster.

        To create logsink for a database cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/logsink``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "sink": {
                        "config": {},
                        "sink_id": "str",  # Optional. A unique identifier for Logsink.
                        "sink_name": "str",  # Optional. The name of the Logsink.
                        "sink_type": "str"  # Optional. Known values are: "rsyslog",
                          "elasticsearch", and "opensearch".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_logsink(
        self, database_cluster_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Logsink for a Database Cluster.

        To create logsink for a database cluster, send a POST request to
        ``/v2/databases/$DATABASE_ID/logsink``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "sink_name": "str",  # Optional. The name of the Logsink.
                    "sink_type": "str"  # Optional. Known values are: "rsyslog", "elasticsearch",
                      and "opensearch".
                }

                # response body for status code(s): 201
                response == {
                    "sink": {
                        "config": {},
                        "sink_id": "str",  # Optional. A unique identifier for Logsink.
                        "sink_name": "str",  # Optional. The name of the Logsink.
                        "sink_type": "str"  # Optional. Known values are: "rsyslog",
                          "elasticsearch", and "opensearch".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_create_logsink_request(
            database_cluster_uuid=database_cluster_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_logsink(
        self, database_cluster_uuid: str, logsink_id: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Logsink for a Database Cluster.

        To get a logsink for a database cluster, send a GET request to
        ``/v2/databases/$DATABASE_ID/logsink/$LOGSINK_ID``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param logsink_id: A unique identifier for a logsink of a database cluster. Required.
        :type logsink_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "sink": {
                        "config": {},
                        "sink_id": "str",  # Optional. A unique identifier for Logsink.
                        "sink_name": "str",  # Optional. The name of the Logsink.
                        "sink_type": "str"  # Optional. Known values are: "rsyslog",
                          "elasticsearch", and "opensearch".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_logsink_request(
            database_cluster_uuid=database_cluster_uuid,
            logsink_id=logsink_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_logsink(
        self,
        database_cluster_uuid: str,
        logsink_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logsink for a Database Cluster.

        To update a logsink for a database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/logsink/$LOGSINK_ID``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param logsink_id: A unique identifier for a logsink of a database cluster. Required.
        :type logsink_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {}
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_logsink(
        self,
        database_cluster_uuid: str,
        logsink_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logsink for a Database Cluster.

        To update a logsink for a database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/logsink/$LOGSINK_ID``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param logsink_id: A unique identifier for a logsink of a database cluster. Required.
        :type logsink_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_logsink(
        self,
        database_cluster_uuid: str,
        logsink_id: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logsink for a Database Cluster.

        To update a logsink for a database cluster, send a PUT request to
        ``/v2/databases/$DATABASE_ID/logsink/$LOGSINK_ID``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param logsink_id: A unique identifier for a logsink of a database cluster. Required.
        :type logsink_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {}
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_databases_update_logsink_request(
            database_cluster_uuid=database_cluster_uuid,
            logsink_id=logsink_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_logsink(
        self, database_cluster_uuid: str, logsink_id: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Logsink for a Database Cluster.

        To delete a logsink for a database cluster, send a DELETE request to
        ``/v2/databases/$DATABASE_ID/logsink/$LOGSINK_ID``.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param logsink_id: A unique identifier for a logsink of a database cluster. Required.
        :type logsink_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_logsink_request(
            database_cluster_uuid=database_cluster_uuid,
            logsink_id=logsink_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_cluster_metrics_credentials(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Database Clusters' Metrics Endpoint Credentials.

        To show the credentials for all database clusters' metrics endpoints, send a GET request to
        ``/v2/databases/metrics/credentials``. The result will be a JSON object with a ``credentials``
        key.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "credentials": {
                        "credentials": {
                            "basic_auth_password": "str",  # Optional. basic
                              authentication password for metrics HTTP endpoint.
                            "basic_auth_username": "str"  # Optional. basic
                              authentication username for metrics HTTP endpoint.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_get_cluster_metrics_credentials_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_cluster_metrics_credentials(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Update Database Clusters' Metrics Endpoint Credentials.

        To update the credentials for all database clusters' metrics endpoints, send a PUT request to
        ``/v2/databases/metrics/credentials``. A successful request will receive a 204 No Content
        status code  with no body in response.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "credentials": {
                        "basic_auth_password": "str",  # Optional. basic authentication
                          password for metrics HTTP endpoint.
                        "basic_auth_username": "str"  # Optional. basic authentication
                          username for metrics HTTP endpoint.
                    }
                }
        """

    @overload
    def update_cluster_metrics_credentials(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Update Database Clusters' Metrics Endpoint Credentials.

        To update the credentials for all database clusters' metrics endpoints, send a PUT request to
        ``/v2/databases/metrics/credentials``. A successful request will receive a 204 No Content
        status code  with no body in response.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:
        """

    @distributed_trace
    def update_cluster_metrics_credentials(  # pylint: disable=inconsistent-return-statements
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> None:
        """Update Database Clusters' Metrics Endpoint Credentials.

        To update the credentials for all database clusters' metrics endpoints, send a PUT request to
        ``/v2/databases/metrics/credentials``. A successful request will receive a 204 No Content
        status code  with no body in response.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "credentials": {
                        "basic_auth_password": "str",  # Optional. basic authentication
                          password for metrics HTTP endpoint.
                        "basic_auth_username": "str"  # Optional. basic authentication
                          username for metrics HTTP endpoint.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[None] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_databases_update_cluster_metrics_credentials_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if cls:
            return cls(pipeline_response, None, response_headers)  # type: ignore

    @distributed_trace
    def list_opeasearch_indexes(
        self, database_cluster_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Indexes for a OpenSearch Cluster.

        To list all of a OpenSearch cluster's indexes, send a GET request to
        ``/v2/databases/$DATABASE_ID/indexes``.

        The result will be a JSON object with a ``indexes`` key.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "indexes": [
                        {
                            "created_time": "2020-02-20 00:00:00",  # Optional. The date
                              and time the index was created.
                            "health": "str",  # Optional. The health of the OpenSearch
                              index. Known values are: "unknown", "green", "yellow", "red", and "red*".
                            "index_name": "str",  # Optional. The name of the opensearch
                              index.
                            "number_of_replicas": 0,  # Optional. The number of replicas
                              for the index.
                            "number_of_shards": 0,  # Optional. The number of shards for
                              the index.
                            "size": 0,  # Optional. The size of the index.
                            "status": "str"  # Optional. The status of the OpenSearch
                              index. Known values are: "unknown", "open", "close", and "none".
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_databases_list_opeasearch_indexes_request(
            database_cluster_uuid=database_cluster_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_opensearch_index(
        self, database_cluster_uuid: str, index_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Index for OpenSearch Cluster.

        To delete a single index within OpenSearch cluster, send a DELETE request
        to ``/v2/databases/$DATABASE_ID/indexes/$INDEX_NAME``.

        A status of 204 will be given. This indicates that the request was
        processed successfully, but that no response body is needed.

        :param database_cluster_uuid: A unique identifier for a database cluster. Required.
        :type database_cluster_uuid: str
        :param index_name: The name of the OpenSearch index. Required.
        :type index_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_databases_delete_opensearch_index_request(
            database_cluster_uuid=database_cluster_uuid,
            index_name=index_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class DomainsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`domains` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Domains.

        To retrieve a list of all of the domains in your account, send a GET request to
        ``/v2/domains``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "domains": [
                        {
                            "ip_address": "str",  # Optional. This optional attribute may
                              contain an IP address. When provided, an A record will be automatically
                              created pointing to the apex domain.
                            "name": "str",  # Optional. The name of the domain itself.
                              This should follow the standard domain format of domain.TLD. For
                              instance, ``example.com`` is a valid domain name.
                            "ttl": 0,  # Optional. This value is the time to live for the
                              records on this domain, in seconds. This defines the time frame that
                              clients can cache queried information before a refresh should be
                              requested.
                            "zone_file": "str"  # Optional. This attribute contains the
                              complete contents of the zone file for the selected domain. Individual
                              domain record resources should be used to get more granular control over
                              records. However, this attribute can also be used to get information
                              about the SOA record, which is created automatically and is not
                              accessible as an individual record resource.
                        }
                    ],
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_domains_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain.

        To create a new domain, send a POST request to ``/v2/domains``. Set the "name"
        attribute to the domain name you are adding. Optionally, you may set the
        "ip_address" attribute, and an A record will be automatically created pointing
        to the apex domain.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "ip_address": "str",  # Optional. This optional attribute may contain an IP
                      address. When provided, an A record will be automatically created pointing to the
                      apex domain.
                    "name": "str",  # Optional. The name of the domain itself. This should follow
                      the standard domain format of domain.TLD. For instance, ``example.com`` is a
                      valid domain name.
                    "ttl": 0,  # Optional. This value is the time to live for the records on this
                      domain, in seconds. This defines the time frame that clients can cache queried
                      information before a refresh should be requested.
                    "zone_file": "str"  # Optional. This attribute contains the complete contents
                      of the zone file for the selected domain. Individual domain record resources
                      should be used to get more granular control over records. However, this attribute
                      can also be used to get information about the SOA record, which is created
                      automatically and is not accessible as an individual record resource.
                }

                # response body for status code(s): 201
                response == {
                    "domain": {
                        "ip_address": "str",  # Optional. This optional attribute may contain
                          an IP address. When provided, an A record will be automatically created
                          pointing to the apex domain.
                        "name": "str",  # Optional. The name of the domain itself. This
                          should follow the standard domain format of domain.TLD. For instance,
                          ``example.com`` is a valid domain name.
                        "ttl": 0,  # Optional. This value is the time to live for the records
                          on this domain, in seconds. This defines the time frame that clients can
                          cache queried information before a refresh should be requested.
                        "zone_file": "str"  # Optional. This attribute contains the complete
                          contents of the zone file for the selected domain. Individual domain record
                          resources should be used to get more granular control over records. However,
                          this attribute can also be used to get information about the SOA record,
                          which is created automatically and is not accessible as an individual record
                          resource.
                    }
                }
        """

    @overload
    def create(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain.

        To create a new domain, send a POST request to ``/v2/domains``. Set the "name"
        attribute to the domain name you are adding. Optionally, you may set the
        "ip_address" attribute, and an A record will be automatically created pointing
        to the apex domain.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "domain": {
                        "ip_address": "str",  # Optional. This optional attribute may contain
                          an IP address. When provided, an A record will be automatically created
                          pointing to the apex domain.
                        "name": "str",  # Optional. The name of the domain itself. This
                          should follow the standard domain format of domain.TLD. For instance,
                          ``example.com`` is a valid domain name.
                        "ttl": 0,  # Optional. This value is the time to live for the records
                          on this domain, in seconds. This defines the time frame that clients can
                          cache queried information before a refresh should be requested.
                        "zone_file": "str"  # Optional. This attribute contains the complete
                          contents of the zone file for the selected domain. Individual domain record
                          resources should be used to get more granular control over records. However,
                          this attribute can also be used to get information about the SOA record,
                          which is created automatically and is not accessible as an individual record
                          resource.
                    }
                }
        """

    @distributed_trace
    def create(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain.

        To create a new domain, send a POST request to ``/v2/domains``. Set the "name"
        attribute to the domain name you are adding. Optionally, you may set the
        "ip_address" attribute, and an A record will be automatically created pointing
        to the apex domain.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "ip_address": "str",  # Optional. This optional attribute may contain an IP
                      address. When provided, an A record will be automatically created pointing to the
                      apex domain.
                    "name": "str",  # Optional. The name of the domain itself. This should follow
                      the standard domain format of domain.TLD. For instance, ``example.com`` is a
                      valid domain name.
                    "ttl": 0,  # Optional. This value is the time to live for the records on this
                      domain, in seconds. This defines the time frame that clients can cache queried
                      information before a refresh should be requested.
                    "zone_file": "str"  # Optional. This attribute contains the complete contents
                      of the zone file for the selected domain. Individual domain record resources
                      should be used to get more granular control over records. However, this attribute
                      can also be used to get information about the SOA record, which is created
                      automatically and is not accessible as an individual record resource.
                }

                # response body for status code(s): 201
                response == {
                    "domain": {
                        "ip_address": "str",  # Optional. This optional attribute may contain
                          an IP address. When provided, an A record will be automatically created
                          pointing to the apex domain.
                        "name": "str",  # Optional. The name of the domain itself. This
                          should follow the standard domain format of domain.TLD. For instance,
                          ``example.com`` is a valid domain name.
                        "ttl": 0,  # Optional. This value is the time to live for the records
                          on this domain, in seconds. This defines the time frame that clients can
                          cache queried information before a refresh should be requested.
                        "zone_file": "str"  # Optional. This attribute contains the complete
                          contents of the zone file for the selected domain. Individual domain record
                          resources should be used to get more granular control over records. However,
                          this attribute can also be used to get information about the SOA record,
                          which is created automatically and is not accessible as an individual record
                          resource.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_domains_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, domain_name: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Domain.

        To get details about a specific domain, send a GET request to ``/v2/domains/$DOMAIN_NAME``.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "domain": {
                        "ip_address": "str",  # Optional. This optional attribute may contain
                          an IP address. When provided, an A record will be automatically created
                          pointing to the apex domain.
                        "name": "str",  # Optional. The name of the domain itself. This
                          should follow the standard domain format of domain.TLD. For instance,
                          ``example.com`` is a valid domain name.
                        "ttl": 0,  # Optional. This value is the time to live for the records
                          on this domain, in seconds. This defines the time frame that clients can
                          cache queried information before a refresh should be requested.
                        "zone_file": "str"  # Optional. This attribute contains the complete
                          contents of the zone file for the selected domain. Individual domain record
                          resources should be used to get more granular control over records. However,
                          this attribute can also be used to get information about the SOA record,
                          which is created automatically and is not accessible as an individual record
                          resource.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_domains_get_request(
            domain_name=domain_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, domain_name: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Domain.

        To delete a domain, send a DELETE request to ``/v2/domains/$DOMAIN_NAME``.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_domains_delete_request(
            domain_name=domain_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_records(
        self,
        domain_name: str,
        *,
        name: Optional[str] = None,
        type: Optional[str] = None,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Domain Records.

        To get a listing of all records configured for a domain, send a GET request to
        ``/v2/domains/$DOMAIN_NAME/records``.
        The list of records returned can be filtered by using the ``name`` and ``type`` query
        parameters. For example, to only include A records for a domain, send a GET request to
        ``/v2/domains/$DOMAIN_NAME/records?type=A``. ``name`` must be a fully qualified record name.
        For example, to only include records matching ``sub.example.com``\\ , send a GET request to
        ``/v2/domains/$DOMAIN_NAME/records?name=sub.example.com``. Both name and type may be used
        together.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :keyword name: A fully qualified record name. For example, to only include records matching
         sub.example.com, send a GET request to
         ``/v2/domains/$DOMAIN_NAME/records?name=sub.example.com``. Default value is None.
        :paramtype name: str
        :keyword type: The type of the DNS record. For example: A, CNAME, TXT, ... Known values are:
         "A", "AAAA", "CAA", "CNAME", "MX", "NS", "SOA", "SRV", and "TXT". Default value is None.
        :paramtype type: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "domain_records": [
                        {
                            "type": "str",  # The type of the DNS record. For example: A,
                              CNAME, TXT, ... Required.
                            "data": "str",  # Optional. Variable data depending on record
                              type. For example, the "data" value for an A record would be the IPv4
                              address to which the domain will be mapped. For a CAA record, it would
                              contain the domain name of the CA being granted permission to issue
                              certificates.
                            "flags": 0,  # Optional. An unsigned integer between 0-255
                              used for CAA records.
                            "id": 0,  # Optional. A unique identifier for each domain
                              record.
                            "name": "str",  # Optional. The host name, alias, or service
                              being defined by the record.
                            "port": 0,  # Optional. The port for SRV records.
                            "priority": 0,  # Optional. The priority for SRV and MX
                              records.
                            "tag": "str",  # Optional. The parameter tag for CAA records.
                              Valid values are "issue", "issuewild", or "iodef".
                            "ttl": 0,  # Optional. This value is the time to live for the
                              record, in seconds. This defines the time frame that clients can cache
                              queried information before a refresh should be requested.
                            "weight": 0  # Optional. The weight for SRV records.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_domains_list_records_request(
            domain_name=domain_name,
            name=name,
            type=type,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_record(
        self,
        domain_name: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain Record.

        To create a new record to a domain, send a POST request to
        ``/v2/domains/$DOMAIN_NAME/records``.

        The request must include all of the required fields for the domain record type
        being added.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective required attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_record(
        self,
        domain_name: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain Record.

        To create a new record to a domain, send a POST request to
        ``/v2/domains/$DOMAIN_NAME/records``.

        The request must include all of the required fields for the domain record type
        being added.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective required attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_record(
        self,
        domain_name: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Domain Record.

        To create a new record to a domain, send a POST request to
        ``/v2/domains/$DOMAIN_NAME/records``.

        The request must include all of the required fields for the domain record type
        being added.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective required attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_domains_create_record_request(
            domain_name=domain_name,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_record(
        self, domain_name: str, domain_record_id: int, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Domain Record.

        To retrieve a specific domain record, send a GET request to
        ``/v2/domains/$DOMAIN_NAME/records/$RECORD_ID``.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_domains_get_record_request(
            domain_name=domain_name,
            domain_record_id=domain_record_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PATCH request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "type": "str",  # The type of the DNS record. For example: A, CNAME, TXT, ...
                      Required.
                    "data": "str",  # Optional. Variable data depending on record type. For
                      example, the "data" value for an A record would be the IPv4 address to which the
                      domain will be mapped. For a CAA record, it would contain the domain name of the
                      CA being granted permission to issue certificates.
                    "flags": 0,  # Optional. An unsigned integer between 0-255 used for CAA
                      records.
                    "id": 0,  # Optional. A unique identifier for each domain record.
                    "name": "str",  # Optional. The host name, alias, or service being defined by
                      the record.
                    "port": 0,  # Optional. The port for SRV records.
                    "priority": 0,  # Optional. The priority for SRV and MX records.
                    "tag": "str",  # Optional. The parameter tag for CAA records. Valid values
                      are "issue", "issuewild", or "iodef".
                    "ttl": 0,  # Optional. This value is the time to live for the record, in
                      seconds. This defines the time frame that clients can cache queried information
                      before a refresh should be requested.
                    "weight": 0  # Optional. The weight for SRV records.
                }

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PATCH request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PATCH request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "type": "str",  # The type of the DNS record. For example: A, CNAME, TXT, ...
                      Required.
                    "data": "str",  # Optional. Variable data depending on record type. For
                      example, the "data" value for an A record would be the IPv4 address to which the
                      domain will be mapped. For a CAA record, it would contain the domain name of the
                      CA being granted permission to issue certificates.
                    "flags": 0,  # Optional. An unsigned integer between 0-255 used for CAA
                      records.
                    "id": 0,  # Optional. A unique identifier for each domain record.
                    "name": "str",  # Optional. The host name, alias, or service being defined by
                      the record.
                    "port": 0,  # Optional. The port for SRV records.
                    "priority": 0,  # Optional. The priority for SRV and MX records.
                    "tag": "str",  # Optional. The parameter tag for CAA records. Valid values
                      are "issue", "issuewild", or "iodef".
                    "ttl": 0,  # Optional. This value is the time to live for the record, in
                      seconds. This defines the time frame that clients can cache queried information
                      before a refresh should be requested.
                    "weight": 0  # Optional. The weight for SRV records.
                }

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_domains_patch_record_request(
            domain_name=domain_name,
            domain_record_id=domain_record_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PUT request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "type": "str",  # The type of the DNS record. For example: A, CNAME, TXT, ...
                      Required.
                    "data": "str",  # Optional. Variable data depending on record type. For
                      example, the "data" value for an A record would be the IPv4 address to which the
                      domain will be mapped. For a CAA record, it would contain the domain name of the
                      CA being granted permission to issue certificates.
                    "flags": 0,  # Optional. An unsigned integer between 0-255 used for CAA
                      records.
                    "id": 0,  # Optional. A unique identifier for each domain record.
                    "name": "str",  # Optional. The host name, alias, or service being defined by
                      the record.
                    "port": 0,  # Optional. The port for SRV records.
                    "priority": 0,  # Optional. The priority for SRV and MX records.
                    "tag": "str",  # Optional. The parameter tag for CAA records. Valid values
                      are "issue", "issuewild", or "iodef".
                    "ttl": 0,  # Optional. This value is the time to live for the record, in
                      seconds. This defines the time frame that clients can cache queried information
                      before a refresh should be requested.
                    "weight": 0  # Optional. The weight for SRV records.
                }

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PUT request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_record(
        self,
        domain_name: str,
        domain_record_id: int,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Domain Record.

        To update an existing record, send a PUT request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``. Any attribute valid for
        the record type can be set to a new value for the record.

        See the `attribute table <#tag/Domain-Records>`_ for details regarding record
        types and their respective attributes.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "type": "str",  # The type of the DNS record. For example: A, CNAME, TXT, ...
                      Required.
                    "data": "str",  # Optional. Variable data depending on record type. For
                      example, the "data" value for an A record would be the IPv4 address to which the
                      domain will be mapped. For a CAA record, it would contain the domain name of the
                      CA being granted permission to issue certificates.
                    "flags": 0,  # Optional. An unsigned integer between 0-255 used for CAA
                      records.
                    "id": 0,  # Optional. A unique identifier for each domain record.
                    "name": "str",  # Optional. The host name, alias, or service being defined by
                      the record.
                    "port": 0,  # Optional. The port for SRV records.
                    "priority": 0,  # Optional. The priority for SRV and MX records.
                    "tag": "str",  # Optional. The parameter tag for CAA records. Valid values
                      are "issue", "issuewild", or "iodef".
                    "ttl": 0,  # Optional. This value is the time to live for the record, in
                      seconds. This defines the time frame that clients can cache queried information
                      before a refresh should be requested.
                    "weight": 0  # Optional. The weight for SRV records.
                }

                # response body for status code(s): 200
                response == {
                    "domain_record": {
                        "type": "str",  # The type of the DNS record. For example: A, CNAME,
                          TXT, ... Required.
                        "data": "str",  # Optional. Variable data depending on record type.
                          For example, the "data" value for an A record would be the IPv4 address to
                          which the domain will be mapped. For a CAA record, it would contain the
                          domain name of the CA being granted permission to issue certificates.
                        "flags": 0,  # Optional. An unsigned integer between 0-255 used for
                          CAA records.
                        "id": 0,  # Optional. A unique identifier for each domain record.
                        "name": "str",  # Optional. The host name, alias, or service being
                          defined by the record.
                        "port": 0,  # Optional. The port for SRV records.
                        "priority": 0,  # Optional. The priority for SRV and MX records.
                        "tag": "str",  # Optional. The parameter tag for CAA records. Valid
                          values are "issue", "issuewild", or "iodef".
                        "ttl": 0,  # Optional. This value is the time to live for the record,
                          in seconds. This defines the time frame that clients can cache queried
                          information before a refresh should be requested.
                        "weight": 0  # Optional. The weight for SRV records.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_domains_update_record_request(
            domain_name=domain_name,
            domain_record_id=domain_record_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_record(
        self, domain_name: str, domain_record_id: int, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Domain Record.

        To delete a record for a domain, send a DELETE request to
        ``/v2/domains/$DOMAIN_NAME/records/$DOMAIN_RECORD_ID``.

        The record will be deleted and the response status will be a 204. This
        indicates a successful request with no body returned.

        :param domain_name: The name of the domain itself. Required.
        :type domain_name: str
        :param domain_record_id: The unique identifier of the domain record. Required.
        :type domain_record_id: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_domains_delete_record_request(
            domain_name=domain_name,
            domain_record_id=domain_record_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class DropletsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`droplets` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        per_page: int = 20,
        page: int = 1,
        tag_name: Optional[str] = None,
        name: Optional[str] = None,
        type: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Droplets.

        To list all Droplets in your account, send a GET request to ``/v2/droplets``.

        The response body will be a JSON object with a key of ``droplets``. This will be
        set to an array containing objects each representing a Droplet. These will
        contain the standard Droplet attributes.

        Filtering Results by Tag
        ^^^^^^^^^^^^^^^^^^^^^^^^

        It's possible to request filtered results by including certain query parameters.
        To only list Droplets assigned to a specific tag, include the ``tag_name`` query
        parameter set to the name of the tag in your GET request. For example,
        ``/v2/droplets?tag_name=$TAG_NAME``.

        GPU Droplets
        ^^^^^^^^^^^^

        By default, only non-GPU Droplets are returned. To list only GPU Droplets, set
        the ``type`` query parameter to ``gpus``. For example, ``/v2/droplets?type=gpus``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword tag_name: Used to filter Droplets by a specific tag. Can not be combined with ``name``
         or ``type``. Default value is None.
        :paramtype tag_name: str
        :keyword name: Used to filter list response by Droplet name returning only exact matches. It is
         case-insensitive and can not be combined with ``tag_name``. Default value is None.
        :paramtype name: str
        :keyword type: When ``type`` is set to ``gpus``\\ , only GPU Droplets will be returned. By
         default, only non-GPU Droplets are returned. Can not be combined with ``tag_name``. Known
         values are: "droplets" and "gpus". Default value is None.
        :paramtype type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "droplets": [
                        {
                            "backup_ids": [
                                0  # An array of backup IDs of any backups that have
                                  been taken of the Droplet instance.  Droplet backups are enabled at
                                  the time of the instance creation. Required.
                            ],
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the Droplet
                              was created. Required.
                            "disk": 0,  # The size of the Droplet's disk in gigabytes.
                              Required.
                            "features": [
                                "str"  # An array of features enabled on this
                                  Droplet. Required.
                            ],
                            "id": 0,  # A unique identifier for each Droplet instance.
                              This is automatically generated upon Droplet creation. Required.
                            "image": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the image was created.
                                "description": "str",  # Optional. An optional
                                  free-form text field to describe an image.
                                "distribution": "str",  # Optional. The name of a
                                  custom image's distribution. Currently, the valid values are  ``Arch
                                  Linux``"" , ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``""
                                  , ``Fedora Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" ,
                                  ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" , ``Ubuntu``"" ,
                                  and ``Unknown``.  Any other value will be accepted but ignored, and
                                  ``Unknown`` will be used in its place. Known values are: "Arch
                                  Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic",
                                  "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                                  "Ubuntu", and "Unknown".
                                "error_message": "str",  # Optional. A string
                                  containing information about errors that may occur when importing  a
                                  custom image.
                                "id": 0,  # Optional. A unique number that can be
                                  used to identify and reference a specific image.
                                "min_disk_size": 0,  # Optional. The minimum disk
                                  size in GB required for a Droplet to use this image.
                                "name": "str",  # Optional. The display name that has
                                  been given to an image.  This is what is shown in the control panel
                                  and is generally a descriptive title for the image in question.
                                "public": bool,  # Optional. This is a boolean value
                                  that indicates whether the image in question is public or not. An
                                  image that is public is available to all accounts. A non-public image
                                  is only accessible from your account.
                                "regions": [
                                    "str"  # Optional. This attribute is an array
                                      of the regions that the image is available in. The regions are
                                      represented by their identifying slug values.
                                ],
                                "size_gigabytes": 0.0,  # Optional. The size of the
                                  image in gigabytes.
                                "slug": "str",  # Optional. A uniquely identifying
                                  string that is associated with each of the DigitalOcean-provided
                                  public images. These can be used to reference a public image as an
                                  alternative to the numeric id.
                                "status": "str",  # Optional. A status string
                                  indicating the state of a custom image. This may be ``NEW``"" ,
                                  ``available``"" , ``pending``"" , ``deleted``"" , or ``retired``.
                                  Known values are: "NEW", "available", "pending", "deleted", and
                                  "retired".
                                "tags": [
                                    "str"  # Optional. A flat array of tag names
                                      as strings to be applied to the resource. Tag names may be for
                                      either existing or new tags.
                                ],
                                "type": "str"  # Optional. Describes the kind of
                                  image. It may be one of ``base``"" , ``snapshot``"" , ``backup``"" ,
                                  ``custom``"" , or ``admin``. Respectively, this specifies whether an
                                  image is a DigitalOcean base OS image, user-generated Droplet
                                  snapshot, automatically created Droplet backup, user-provided virtual
                                  machine image, or an image used for DigitalOcean managed resources
                                  (e.g. DOKS worker nodes). Known values are: "base", "snapshot",
                                  "backup", "custom", and "admin".
                            },
                            "locked": bool,  # A boolean value indicating whether the
                              Droplet has been locked, preventing actions by users. Required.
                            "memory": 0,  # Memory of the Droplet in megabytes. Required.
                            "name": "str",  # The human-readable name set for the Droplet
                              instance. Required.
                            "networks": {
                                "v4": [
                                    {
                                        "gateway": "str",  # Optional. The
                                          gateway of the specified IPv4 network interface.  For private
                                          interfaces, a gateway is not provided. This is denoted by
                                          returning ``nil`` as its value.
                                        "ip_address": "str",  # Optional. The
                                          IP address of the IPv4 network interface.
                                        "netmask": "str",  # Optional. The
                                          netmask of the IPv4 network interface.
                                        "type": "str"  # Optional. The type
                                          of the IPv4 network interface. Known values are: "public" and
                                          "private".
                                    }
                                ],
                                "v6": [
                                    {
                                        "gateway": "str",  # Optional. The
                                          gateway of the specified IPv6 network interface.
                                        "ip_address": "str",  # Optional. The
                                          IP address of the IPv6 network interface.
                                        "netmask": 0,  # Optional. The
                                          netmask of the IPv6 network interface.
                                        "type": "str"  # Optional. The type
                                          of the IPv6 network interface.  **Note**"" : IPv6 private
                                          networking is not currently supported. "public"
                                    }
                                ]
                            },
                            "next_backup_window": {
                                "end": "2020-02-20 00:00:00",  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  end of the Droplet's backup window.
                                "start": "2020-02-20 00:00:00"  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  start of the Droplet's backup window.
                            },
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "size": {
                                "available": True,  # Default value is True. This is
                                  a boolean value that represents whether new Droplets can be created
                                  with this size.
                                "description": "str",  # A string describing the
                                  class of Droplets created from this size. For example: Basic, General
                                  Purpose, CPU-Optimized, Memory-Optimized, or Storage-Optimized.
                                  Required.
                                "disk": 0,  # The amount of disk space set aside for
                                  Droplets of this size. The value is represented in gigabytes.
                                  Required.
                                "memory": 0,  # The amount of RAM allocated to
                                  Droplets created of this size. The value is represented in megabytes.
                                  Required.
                                "price_hourly": 0.0,  # This describes the price of
                                  the Droplet size as measured hourly. The value is measured in US
                                  dollars. Required.
                                "price_monthly": 0.0,  # This attribute describes the
                                  monthly cost of this Droplet size if the Droplet is kept for an
                                  entire month. The value is measured in US dollars. Required.
                                "regions": [
                                    "str"  # An array containing the region slugs
                                      where this size is available for Droplet creates. Required.
                                ],
                                "slug": "str",  # A human-readable string that is
                                  used to uniquely identify each size. Required.
                                "transfer": 0.0,  # The amount of transfer bandwidth
                                  that is available for Droplets created in this size. This only counts
                                  traffic on the public interface. The value is given in terabytes.
                                  Required.
                                "vcpus": 0,  # The number of CPUs allocated to
                                  Droplets of this size. Required.
                                "disk_info": [
                                    {
                                        "size": {
                                            "amount": 0,  # Optional. The
                                              amount of space allocated to the disk.
                                            "unit": "str"  # Optional.
                                              The unit of measure for the disk size.
                                        },
                                        "type": "str"  # Optional. The type
                                          of disk. All Droplets contain a ``local`` disk. Additionally,
                                          GPU Droplets can also have a ``scratch`` disk for
                                          non-persistent data. Known values are: "local" and "scratch".
                                    }
                                ],
                                "gpu_info": {
                                    "count": 0,  # Optional. The number of GPUs
                                      allocated to the Droplet.
                                    "model": "str",  # Optional. The model of the
                                      GPU.
                                    "vram": {
                                        "amount": 0,  # Optional. The amount
                                          of VRAM allocated to the GPU.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the VRAM.
                                    }
                                }
                            },
                            "size_slug": "str",  # The unique slug identifier for the
                              size of this Droplet. Required.
                            "snapshot_ids": [
                                0  # An array of snapshot IDs of any snapshots
                                  created from the Droplet instance. Required.
                            ],
                            "status": "str",  # A status string indicating the state of
                              the Droplet instance. This may be "new", "active", "off", or "archive".
                              Required. Known values are: "new", "active", "off", and "archive".
                            "tags": [
                                "str"  # An array of Tags the Droplet has been tagged
                                  with. Required.
                            ],
                            "vcpus": 0,  # The number of virtual CPUs. Required.
                            "volume_ids": [
                                "str"  # A flat array including the unique identifier
                                  for each Block Storage volume attached to the Droplet. Required.
                            ],
                            "disk_info": [
                                {
                                    "size": {
                                        "amount": 0,  # Optional. The amount
                                          of space allocated to the disk.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the disk size.
                                    },
                                    "type": "str"  # Optional. The type of disk.
                                      All Droplets contain a ``local`` disk. Additionally, GPU Droplets
                                      can also have a ``scratch`` disk for non-persistent data. Known
                                      values are: "local" and "scratch".
                                }
                            ],
                            "gpu_info": {
                                "count": 0,  # Optional. The number of GPUs allocated
                                  to the Droplet.
                                "model": "str",  # Optional. The model of the GPU.
                                "vram": {
                                    "amount": 0,  # Optional. The amount of VRAM
                                      allocated to the GPU.
                                    "unit": "str"  # Optional. The unit of
                                      measure for the VRAM.
                                }
                            },
                            "kernel": {
                                "id": 0,  # Optional. A unique number used to
                                  identify and reference a specific kernel.
                                "name": "str",  # Optional. The display name of the
                                  kernel. This is shown in the web UI and is generally a descriptive
                                  title for the kernel in question.
                                "version": "str"  # Optional. A standard kernel
                                  version string representing the version, patch, and release
                                  information.
                            },
                            "vpc_uuid": "str"  # Optional. A string specifying the UUID
                              of the VPC to which the Droplet is assigned.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_request(
            per_page=per_page,
            page=page,
            tag_name=tag_name,
            name=name,
            type=type,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        """Create a New Droplet.

        To create a new Droplet, send a POST request to ``/v2/droplets`` setting the
        required attributes.

        A Droplet will be created using the provided information. The response body
        will contain a JSON object with a key called ``droplet``. The value will be an
        object containing the standard attributes for your new Droplet. The response
        code, 202 Accepted, does not indicate the success or failure of the operation,
        just that the request has been accepted for processing. The ``actions`` returned
        as part of the response's ``links`` object can be used to check the status
        of the Droplet create event.

        Create Multiple Droplets
        ^^^^^^^^^^^^^^^^^^^^^^^^

        Creating multiple Droplets is very similar to creating a single Droplet.
        Instead of sending ``name`` as a string, send ``names`` as an array of strings. A
        Droplet will be created for each name you send using the associated
        information. Up to ten Droplets may be created this way at a time.

        Rather than returning a single Droplet, the response body will contain a JSON
        array with a key called ``droplets``. This will be set to an array of JSON
        objects, each of which will contain the standard Droplet attributes. The
        response code, 202 Accepted, does not indicate the success or failure of any
        operation, just that the request has been accepted for processing. The array
        of ``actions`` returned as part of the response's ``links`` object can be used to
        check the status of each individual Droplet create event.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}
        """

    @overload
    def create(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        """Create a New Droplet.

        To create a new Droplet, send a POST request to ``/v2/droplets`` setting the
        required attributes.

        A Droplet will be created using the provided information. The response body
        will contain a JSON object with a key called ``droplet``. The value will be an
        object containing the standard attributes for your new Droplet. The response
        code, 202 Accepted, does not indicate the success or failure of the operation,
        just that the request has been accepted for processing. The ``actions`` returned
        as part of the response's ``links`` object can be used to check the status
        of the Droplet create event.

        Create Multiple Droplets
        ^^^^^^^^^^^^^^^^^^^^^^^^

        Creating multiple Droplets is very similar to creating a single Droplet.
        Instead of sending ``name`` as a string, send ``names`` as an array of strings. A
        Droplet will be created for each name you send using the associated
        information. Up to ten Droplets may be created this way at a time.

        Rather than returning a single Droplet, the response body will contain a JSON
        array with a key called ``droplets``. This will be set to an array of JSON
        objects, each of which will contain the standard Droplet attributes. The
        response code, 202 Accepted, does not indicate the success or failure of any
        operation, just that the request has been accepted for processing. The array
        of ``actions`` returned as part of the response's ``links`` object can be used to
        check the status of each individual Droplet create event.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:
        """

    @distributed_trace
    def create(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        """Create a New Droplet.

        To create a new Droplet, send a POST request to ``/v2/droplets`` setting the
        required attributes.

        A Droplet will be created using the provided information. The response body
        will contain a JSON object with a key called ``droplet``. The value will be an
        object containing the standard attributes for your new Droplet. The response
        code, 202 Accepted, does not indicate the success or failure of the operation,
        just that the request has been accepted for processing. The ``actions`` returned
        as part of the response's ``links`` object can be used to check the status
        of the Droplet create event.

        Create Multiple Droplets
        ^^^^^^^^^^^^^^^^^^^^^^^^

        Creating multiple Droplets is very similar to creating a single Droplet.
        Instead of sending ``name`` as a string, send ``names`` as an array of strings. A
        Droplet will be created for each name you send using the associated
        information. Up to ten Droplets may be created this way at a time.

        Rather than returning a single Droplet, the response body will contain a JSON
        array with a key called ``droplets``. This will be set to an array of JSON
        objects, each of which will contain the standard Droplet attributes. The
        response code, 202 Accepted, does not indicate the success or failure of any
        operation, just that the request has been accepted for processing. The array
        of ``actions`` returned as part of the response's ``links`` object can be used to
        check the status of each individual Droplet create event.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_droplets_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def destroy_by_tag(self, *, tag_name: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Deleting Droplets by Tag.

        To delete **all** Droplets assigned to a specific tag, include the ``tag_name``
        query parameter set to the name of the tag in your DELETE request. For
        example,  ``/v2/droplets?tag_name=$TAG_NAME``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :keyword tag_name: Specifies Droplets to be deleted by tag. Required.
        :paramtype tag_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_droplets_destroy_by_tag_request(
            tag_name=tag_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )
            response_headers["content-type"] = self._deserialize(
                "str", response.headers.get("content-type")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get(self, droplet_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Droplet.

        To show information about an individual Droplet, send a GET request to
        ``/v2/droplets/$DROPLET_ID``.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "droplet": {
                        "backup_ids": [
                            0  # An array of backup IDs of any backups that have been
                              taken of the Droplet instance.  Droplet backups are enabled at the time
                              of the instance creation. Required.
                        ],
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the Droplet was created.
                          Required.
                        "disk": 0,  # The size of the Droplet's disk in gigabytes. Required.
                        "features": [
                            "str"  # An array of features enabled on this Droplet.
                              Required.
                        ],
                        "id": 0,  # A unique identifier for each Droplet instance. This is
                          automatically generated upon Droplet creation. Required.
                        "image": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the image was created.
                            "description": "str",  # Optional. An optional free-form text
                              field to describe an image.
                            "distribution": "str",  # Optional. The name of a custom
                              image's distribution. Currently, the valid values are  ``Arch Linux``"" ,
                              ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                              Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" ,
                              ``RancherOS``"" , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.
                              Any other value will be accepted but ignored, and ``Unknown`` will be
                              used in its place. Known values are: "Arch Linux", "CentOS", "CoreOS",
                              "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo", "openSUSE",
                              "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                            "error_message": "str",  # Optional. A string containing
                              information about errors that may occur when importing  a custom image.
                            "id": 0,  # Optional. A unique number that can be used to
                              identify and reference a specific image.
                            "min_disk_size": 0,  # Optional. The minimum disk size in GB
                              required for a Droplet to use this image.
                            "name": "str",  # Optional. The display name that has been
                              given to an image.  This is what is shown in the control panel and is
                              generally a descriptive title for the image in question.
                            "public": bool,  # Optional. This is a boolean value that
                              indicates whether the image in question is public or not. An image that
                              is public is available to all accounts. A non-public image is only
                              accessible from your account.
                            "regions": [
                                "str"  # Optional. This attribute is an array of the
                                  regions that the image is available in. The regions are represented
                                  by their identifying slug values.
                            ],
                            "size_gigabytes": 0.0,  # Optional. The size of the image in
                              gigabytes.
                            "slug": "str",  # Optional. A uniquely identifying string
                              that is associated with each of the DigitalOcean-provided public images.
                              These can be used to reference a public image as an alternative to the
                              numeric id.
                            "status": "str",  # Optional. A status string indicating the
                              state of a custom image. This may be ``NEW``"" ,  ``available``"" ,
                              ``pending``"" , ``deleted``"" , or ``retired``. Known values are: "NEW",
                              "available", "pending", "deleted", and "retired".
                            "tags": [
                                "str"  # Optional. A flat array of tag names as
                                  strings to be applied to the resource. Tag names may be for either
                                  existing or new tags.
                            ],
                            "type": "str"  # Optional. Describes the kind of image. It
                              may be one of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" ,
                              or ``admin``. Respectively, this specifies whether an image is a
                              DigitalOcean base OS image, user-generated Droplet snapshot,
                              automatically created Droplet backup, user-provided virtual machine
                              image, or an image used for DigitalOcean managed resources (e.g. DOKS
                              worker nodes). Known values are: "base", "snapshot", "backup", "custom",
                              and "admin".
                        },
                        "locked": bool,  # A boolean value indicating whether the Droplet has
                          been locked, preventing actions by users. Required.
                        "memory": 0,  # Memory of the Droplet in megabytes. Required.
                        "name": "str",  # The human-readable name set for the Droplet
                          instance. Required.
                        "networks": {
                            "v4": [
                                {
                                    "gateway": "str",  # Optional. The gateway of
                                      the specified IPv4 network interface.  For private interfaces, a
                                      gateway is not provided. This is denoted by returning ``nil`` as
                                      its value.
                                    "ip_address": "str",  # Optional. The IP
                                      address of the IPv4 network interface.
                                    "netmask": "str",  # Optional. The netmask of
                                      the IPv4 network interface.
                                    "type": "str"  # Optional. The type of the
                                      IPv4 network interface. Known values are: "public" and "private".
                                }
                            ],
                            "v6": [
                                {
                                    "gateway": "str",  # Optional. The gateway of
                                      the specified IPv6 network interface.
                                    "ip_address": "str",  # Optional. The IP
                                      address of the IPv6 network interface.
                                    "netmask": 0,  # Optional. The netmask of the
                                      IPv6 network interface.
                                    "type": "str"  # Optional. The type of the
                                      IPv6 network interface.  **Note**"" : IPv6 private  networking is
                                      not currently supported. "public"
                                }
                            ]
                        },
                        "next_backup_window": {
                            "end": "2020-02-20 00:00:00",  # Optional. A time value given
                              in ISO8601 combined date and time format specifying the end of the
                              Droplet's backup window.
                            "start": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format specifying the start of
                              the Droplet's backup window.
                        },
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "size": {
                            "available": True,  # Default value is True. This is a
                              boolean value that represents whether new Droplets can be created with
                              this size.
                            "description": "str",  # A string describing the class of
                              Droplets created from this size. For example: Basic, General Purpose,
                              CPU-Optimized, Memory-Optimized, or Storage-Optimized. Required.
                            "disk": 0,  # The amount of disk space set aside for Droplets
                              of this size. The value is represented in gigabytes. Required.
                            "memory": 0,  # The amount of RAM allocated to Droplets
                              created of this size. The value is represented in megabytes. Required.
                            "price_hourly": 0.0,  # This describes the price of the
                              Droplet size as measured hourly. The value is measured in US dollars.
                              Required.
                            "price_monthly": 0.0,  # This attribute describes the monthly
                              cost of this Droplet size if the Droplet is kept for an entire month. The
                              value is measured in US dollars. Required.
                            "regions": [
                                "str"  # An array containing the region slugs where
                                  this size is available for Droplet creates. Required.
                            ],
                            "slug": "str",  # A human-readable string that is used to
                              uniquely identify each size. Required.
                            "transfer": 0.0,  # The amount of transfer bandwidth that is
                              available for Droplets created in this size. This only counts traffic on
                              the public interface. The value is given in terabytes. Required.
                            "vcpus": 0,  # The number of CPUs allocated to Droplets of
                              this size. Required.
                            "disk_info": [
                                {
                                    "size": {
                                        "amount": 0,  # Optional. The amount
                                          of space allocated to the disk.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the disk size.
                                    },
                                    "type": "str"  # Optional. The type of disk.
                                      All Droplets contain a ``local`` disk. Additionally, GPU Droplets
                                      can also have a ``scratch`` disk for non-persistent data. Known
                                      values are: "local" and "scratch".
                                }
                            ],
                            "gpu_info": {
                                "count": 0,  # Optional. The number of GPUs allocated
                                  to the Droplet.
                                "model": "str",  # Optional. The model of the GPU.
                                "vram": {
                                    "amount": 0,  # Optional. The amount of VRAM
                                      allocated to the GPU.
                                    "unit": "str"  # Optional. The unit of
                                      measure for the VRAM.
                                }
                            }
                        },
                        "size_slug": "str",  # The unique slug identifier for the size of
                          this Droplet. Required.
                        "snapshot_ids": [
                            0  # An array of snapshot IDs of any snapshots created from
                              the Droplet instance. Required.
                        ],
                        "status": "str",  # A status string indicating the state of the
                          Droplet instance. This may be "new", "active", "off", or "archive". Required.
                          Known values are: "new", "active", "off", and "archive".
                        "tags": [
                            "str"  # An array of Tags the Droplet has been tagged with.
                              Required.
                        ],
                        "vcpus": 0,  # The number of virtual CPUs. Required.
                        "volume_ids": [
                            "str"  # A flat array including the unique identifier for
                              each Block Storage volume attached to the Droplet. Required.
                        ],
                        "disk_info": [
                            {
                                "size": {
                                    "amount": 0,  # Optional. The amount of space
                                      allocated to the disk.
                                    "unit": "str"  # Optional. The unit of
                                      measure for the disk size.
                                },
                                "type": "str"  # Optional. The type of disk. All
                                  Droplets contain a ``local`` disk. Additionally, GPU Droplets can
                                  also have a ``scratch`` disk for non-persistent data. Known values
                                  are: "local" and "scratch".
                            }
                        ],
                        "gpu_info": {
                            "count": 0,  # Optional. The number of GPUs allocated to the
                              Droplet.
                            "model": "str",  # Optional. The model of the GPU.
                            "vram": {
                                "amount": 0,  # Optional. The amount of VRAM
                                  allocated to the GPU.
                                "unit": "str"  # Optional. The unit of measure for
                                  the VRAM.
                            }
                        },
                        "kernel": {
                            "id": 0,  # Optional. A unique number used to identify and
                              reference a specific kernel.
                            "name": "str",  # Optional. The display name of the kernel.
                              This is shown in the web UI and is generally a descriptive title for the
                              kernel in question.
                            "version": "str"  # Optional. A standard kernel version
                              string representing the version, patch, and release information.
                        },
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Droplet is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_get_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def destroy(self, droplet_id: int, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an Existing Droplet.

        To delete a Droplet, send a DELETE request to ``/v2/droplets/$DROPLET_ID``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_droplets_destroy_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )
            response_headers["content-type"] = self._deserialize(
                "str", response.headers.get("content-type")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_backups(
        self, droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Backups for a Droplet.

        To retrieve any backups associated with a Droplet, send a GET request to
        ``/v2/droplets/$DROPLET_ID/backups``.

        You will get back a JSON object that has a ``backups`` key. This will be set to
        an array of backup objects, each of which contain the standard
        Droplet backup attributes.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "backups": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the snapshot
                              was created. Required.
                            "min_disk_size": 0,  # The minimum size in GB required for a
                              volume or Droplet to use this snapshot. Required.
                            "name": "str",  # A human-readable name for the snapshot.
                              Required.
                            "regions": [
                                "str"  # An array of the regions that the snapshot is
                                  available in. The regions are represented by their identifying slug
                                  values. Required.
                            ],
                            "size_gigabytes": 0.0,  # The billable size of the snapshot
                              in gigabytes. Required.
                            "type": "str"  # Describes the kind of image. It may be one
                              of ``snapshot`` or ``backup``. This specifies whether an image is a
                              user-generated Droplet snapshot or automatically created Droplet backup.
                              Required. Known values are: "snapshot" and "backup".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_backups_request(
            droplet_id=droplet_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_backup_policy(self, droplet_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the Backup Policy for an Existing Droplet.

        To show information about an individual Droplet's backup policy, send a GET
        request to ``/v2/droplets/$DROPLET_ID/backups/policy``.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "backup_enabled": bool,  # Optional. A boolean value indicating
                          whether backups are enabled for the Droplet.
                        "backup_policy": {
                            "hour": 0,  # Optional. The hour of the day that the backup
                              window will start. Known values are: 0, 4, 8, 12, 16, and 20.
                            "plan": "str",  # Optional. The backup plan used for the
                              Droplet. The plan can be either ``daily`` or ``weekly``. Known values
                              are: "daily" and "weekly".
                            "retention_period_days": 0,  # Optional. The number of days
                              the backup will be retained.
                            "weekday": "str",  # Optional. The day of the week on which
                              the backup will occur. Known values are: "SUN", "MON", "TUE", "WED",
                              "THU", "FRI", and "SAT".
                            "window_length_hours": 0  # Optional. The length of the
                              backup window starting from ``hour``.
                        },
                        "droplet_id": 0,  # Optional. The unique identifier for the Droplet.
                        "next_backup_window": {
                            "end": "2020-02-20 00:00:00",  # Optional. A time value given
                              in ISO8601 combined date and time format specifying the end of the
                              Droplet's backup window.
                            "start": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format specifying the start of
                              the Droplet's backup window.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_get_backup_policy_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_backup_policies(
        self, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Backup Policies for All Existing Droplets.

        To list information about the backup policies for all Droplets in the account,
        send a GET request to ``/v2/droplets/backups/policies``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "policies": {
                        "str": {
                            "backup_enabled": bool,  # Optional. A boolean value
                              indicating whether backups are enabled for the Droplet.
                            "backup_policy": {
                                "hour": 0,  # Optional. The hour of the day that the
                                  backup window will start. Known values are: 0, 4, 8, 12, 16, and 20.
                                "plan": "str",  # Optional. The backup plan used for
                                  the Droplet. The plan can be either ``daily`` or ``weekly``. Known
                                  values are: "daily" and "weekly".
                                "retention_period_days": 0,  # Optional. The number
                                  of days the backup will be retained.
                                "weekday": "str",  # Optional. The day of the week on
                                  which the backup will occur. Known values are: "SUN", "MON", "TUE",
                                  "WED", "THU", "FRI", and "SAT".
                                "window_length_hours": 0  # Optional. The length of
                                  the backup window starting from ``hour``.
                            },
                            "droplet_id": 0,  # Optional. The unique identifier for the
                              Droplet.
                            "next_backup_window": {
                                "end": "2020-02-20 00:00:00",  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  end of the Droplet's backup window.
                                "start": "2020-02-20 00:00:00"  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  start of the Droplet's backup window.
                            }
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_backup_policies_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_supported_backup_policies(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Supported Droplet Backup Policies.

        To retrieve a list of all supported Droplet backup policies, send a GET
        request to ``/v2/droplets/backups/supported_policies``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "supported_policies": [
                        {
                            "name": "str",  # Optional. The name of the Droplet backup
                              plan.
                            "possible_days": [
                                "str"  # Optional. The day of the week the backup
                                  will occur.
                            ],
                            "possible_window_starts": [
                                0  # Optional. An array of integers representing the
                                  hours of the day that a backup can start.
                            ],
                            "retention_period_days": 0,  # Optional. The number of days
                              that a backup will be kept.
                            "window_length_hours": 0  # Optional. The number of hours
                              that a backup window is open.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_supported_backup_policies_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_snapshots(
        self, droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Snapshots for a Droplet.

        To retrieve the snapshots that have been created from a Droplet, send a GET
        request to ``/v2/droplets/$DROPLET_ID/snapshots``.

        You will get back a JSON object that has a ``snapshots`` key. This will be set
        to an array of snapshot objects, each of which contain the standard Droplet
        snapshot attributes.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "snapshots": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the snapshot
                              was created. Required.
                            "min_disk_size": 0,  # The minimum size in GB required for a
                              volume or Droplet to use this snapshot. Required.
                            "name": "str",  # A human-readable name for the snapshot.
                              Required.
                            "regions": [
                                "str"  # An array of the regions that the snapshot is
                                  available in. The regions are represented by their identifying slug
                                  values. Required.
                            ],
                            "size_gigabytes": 0.0,  # The billable size of the snapshot
                              in gigabytes. Required.
                            "type": "str"  # Describes the kind of image. It may be one
                              of ``snapshot`` or ``backup``. This specifies whether an image is a
                              user-generated Droplet snapshot or automatically created Droplet backup.
                              Required. Known values are: "snapshot" and "backup".
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_snapshots_request(
            droplet_id=droplet_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_kernels(
        self, droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Available Kernels for a Droplet.

        To retrieve a list of all kernels available to a Droplet, send a GET request
        to ``/v2/droplets/$DROPLET_ID/kernels``

        The response will be a JSON object that has a key called ``kernels``. This will
        be set to an array of ``kernel`` objects, each of which contain the standard
        ``kernel`` attributes.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "kernels": [
                        {
                            "id": 0,  # Optional. A unique number used to identify and
                              reference a specific kernel.
                            "name": "str",  # Optional. The display name of the kernel.
                              This is shown in the web UI and is generally a descriptive title for the
                              kernel in question.
                            "version": "str"  # Optional. A standard kernel version
                              string representing the version, patch, and release information.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_kernels_request(
            droplet_id=droplet_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_firewalls(
        self, droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List all Firewalls Applied to a Droplet.

        To retrieve a list of all firewalls available to a Droplet, send a GET request
        to ``/v2/droplets/$DROPLET_ID/firewalls``

        The response will be a JSON object that has a key called ``firewalls``. This will
        be set to an array of ``firewall`` objects, each of which contain the standard
        ``firewall`` attributes.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "firewalls": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall was created.
                            "droplet_ids": [
                                0  # Optional. An array containing the IDs of the
                                  Droplets assigned to the firewall.
                            ],
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a firewall.
                            "inbound_rules": [
                                {
                                    "ports": "str",  # The ports on which traffic
                                      will be allowed specified as a string containing a single port, a
                                      range (e.g. "8000-9000"), or "0" when all ports are open for a
                                      protocol. For ICMP rules this parameter will always return "0".
                                      Required.
                                    "protocol": "str",  # The type of traffic to
                                      be allowed. This may be one of ``tcp``"" , ``udp``"" , or
                                      ``icmp``. Required. Known values are: "tcp", "udp", and "icmp".
                                    "sources": {
                                        "addresses": [
                                            "str"  # Optional. An array
                                              of strings containing the IPv4 addresses, IPv6 addresses,
                                              IPv4 CIDRs, and/or IPv6 CIDRs to which the firewall will
                                              allow traffic.
                                        ],
                                        "droplet_ids": [
                                            0  # Optional. An array
                                              containing the IDs of the Droplets to which the firewall
                                              will allow traffic.
                                        ],
                                        "kubernetes_ids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the Kubernetes clusters to which
                                              the firewall will allow traffic.
                                        ],
                                        "load_balancer_uids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the load balancers to which the
                                              firewall will allow traffic.
                                        ],
                                        "tags": {}  # Optional. Any object.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. A human-readable name for a
                              firewall. The name must begin with an alphanumeric character. Subsequent
                              characters must either be alphanumeric characters, a period (.), or a
                              dash (-).
                            "outbound_rules": [
                                {
                                    "destinations": {
                                        "addresses": [
                                            "str"  # Optional. An array
                                              of strings containing the IPv4 addresses, IPv6 addresses,
                                              IPv4 CIDRs, and/or IPv6 CIDRs to which the firewall will
                                              allow traffic.
                                        ],
                                        "droplet_ids": [
                                            0  # Optional. An array
                                              containing the IDs of the Droplets to which the firewall
                                              will allow traffic.
                                        ],
                                        "kubernetes_ids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the Kubernetes clusters to which
                                              the firewall will allow traffic.
                                        ],
                                        "load_balancer_uids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the load balancers to which the
                                              firewall will allow traffic.
                                        ],
                                        "tags": {}  # Optional. Any object.
                                    },
                                    "ports": "str",  # The ports on which traffic
                                      will be allowed specified as a string containing a single port, a
                                      range (e.g. "8000-9000"), or "0" when all ports are open for a
                                      protocol. For ICMP rules this parameter will always return "0".
                                      Required.
                                    "protocol": "str"  # The type of traffic to
                                      be allowed. This may be one of ``tcp``"" , ``udp``"" , or
                                      ``icmp``. Required. Known values are: "tcp", "udp", and "icmp".
                                }
                            ],
                            "pending_changes": [
                                {
                                    "droplet_id": 0,  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                    "removing": bool,  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                    "status": "str"  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                }
                            ],
                            "status": "str",  # Optional. A status string indicating the
                              current state of the firewall. This can be "waiting", "succeeded", or
                              "failed". Known values are: "waiting", "succeeded", and "failed".
                            "tags": {}  # Optional. Any object.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_firewalls_request(
            droplet_id=droplet_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_neighbors(self, droplet_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Neighbors for a Droplet.

        To retrieve a list of any "neighbors" (i.e. Droplets that are co-located on
        the same physical hardware) for a specific Droplet, send a GET request to
        ``/v2/droplets/$DROPLET_ID/neighbors``.

        The results will be returned as a JSON object with a key of ``droplets``. This
        will be set to an array containing objects representing any other Droplets
        that share the same physical hardware. An empty array indicates that the
        Droplet is not co-located any other Droplets associated with your account.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "droplets": [
                        {
                            "backup_ids": [
                                0  # An array of backup IDs of any backups that have
                                  been taken of the Droplet instance.  Droplet backups are enabled at
                                  the time of the instance creation. Required.
                            ],
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the Droplet
                              was created. Required.
                            "disk": 0,  # The size of the Droplet's disk in gigabytes.
                              Required.
                            "features": [
                                "str"  # An array of features enabled on this
                                  Droplet. Required.
                            ],
                            "id": 0,  # A unique identifier for each Droplet instance.
                              This is automatically generated upon Droplet creation. Required.
                            "image": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the image was created.
                                "description": "str",  # Optional. An optional
                                  free-form text field to describe an image.
                                "distribution": "str",  # Optional. The name of a
                                  custom image's distribution. Currently, the valid values are  ``Arch
                                  Linux``"" , ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``""
                                  , ``Fedora Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" ,
                                  ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" , ``Ubuntu``"" ,
                                  and ``Unknown``.  Any other value will be accepted but ignored, and
                                  ``Unknown`` will be used in its place. Known values are: "Arch
                                  Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic",
                                  "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                                  "Ubuntu", and "Unknown".
                                "error_message": "str",  # Optional. A string
                                  containing information about errors that may occur when importing  a
                                  custom image.
                                "id": 0,  # Optional. A unique number that can be
                                  used to identify and reference a specific image.
                                "min_disk_size": 0,  # Optional. The minimum disk
                                  size in GB required for a Droplet to use this image.
                                "name": "str",  # Optional. The display name that has
                                  been given to an image.  This is what is shown in the control panel
                                  and is generally a descriptive title for the image in question.
                                "public": bool,  # Optional. This is a boolean value
                                  that indicates whether the image in question is public or not. An
                                  image that is public is available to all accounts. A non-public image
                                  is only accessible from your account.
                                "regions": [
                                    "str"  # Optional. This attribute is an array
                                      of the regions that the image is available in. The regions are
                                      represented by their identifying slug values.
                                ],
                                "size_gigabytes": 0.0,  # Optional. The size of the
                                  image in gigabytes.
                                "slug": "str",  # Optional. A uniquely identifying
                                  string that is associated with each of the DigitalOcean-provided
                                  public images. These can be used to reference a public image as an
                                  alternative to the numeric id.
                                "status": "str",  # Optional. A status string
                                  indicating the state of a custom image. This may be ``NEW``"" ,
                                  ``available``"" , ``pending``"" , ``deleted``"" , or ``retired``.
                                  Known values are: "NEW", "available", "pending", "deleted", and
                                  "retired".
                                "tags": [
                                    "str"  # Optional. A flat array of tag names
                                      as strings to be applied to the resource. Tag names may be for
                                      either existing or new tags.
                                ],
                                "type": "str"  # Optional. Describes the kind of
                                  image. It may be one of ``base``"" , ``snapshot``"" , ``backup``"" ,
                                  ``custom``"" , or ``admin``. Respectively, this specifies whether an
                                  image is a DigitalOcean base OS image, user-generated Droplet
                                  snapshot, automatically created Droplet backup, user-provided virtual
                                  machine image, or an image used for DigitalOcean managed resources
                                  (e.g. DOKS worker nodes). Known values are: "base", "snapshot",
                                  "backup", "custom", and "admin".
                            },
                            "locked": bool,  # A boolean value indicating whether the
                              Droplet has been locked, preventing actions by users. Required.
                            "memory": 0,  # Memory of the Droplet in megabytes. Required.
                            "name": "str",  # The human-readable name set for the Droplet
                              instance. Required.
                            "networks": {
                                "v4": [
                                    {
                                        "gateway": "str",  # Optional. The
                                          gateway of the specified IPv4 network interface.  For private
                                          interfaces, a gateway is not provided. This is denoted by
                                          returning ``nil`` as its value.
                                        "ip_address": "str",  # Optional. The
                                          IP address of the IPv4 network interface.
                                        "netmask": "str",  # Optional. The
                                          netmask of the IPv4 network interface.
                                        "type": "str"  # Optional. The type
                                          of the IPv4 network interface. Known values are: "public" and
                                          "private".
                                    }
                                ],
                                "v6": [
                                    {
                                        "gateway": "str",  # Optional. The
                                          gateway of the specified IPv6 network interface.
                                        "ip_address": "str",  # Optional. The
                                          IP address of the IPv6 network interface.
                                        "netmask": 0,  # Optional. The
                                          netmask of the IPv6 network interface.
                                        "type": "str"  # Optional. The type
                                          of the IPv6 network interface.  **Note**"" : IPv6 private
                                          networking is not currently supported. "public"
                                    }
                                ]
                            },
                            "next_backup_window": {
                                "end": "2020-02-20 00:00:00",  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  end of the Droplet's backup window.
                                "start": "2020-02-20 00:00:00"  # Optional. A time
                                  value given in ISO8601 combined date and time format specifying the
                                  start of the Droplet's backup window.
                            },
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "size": {
                                "available": True,  # Default value is True. This is
                                  a boolean value that represents whether new Droplets can be created
                                  with this size.
                                "description": "str",  # A string describing the
                                  class of Droplets created from this size. For example: Basic, General
                                  Purpose, CPU-Optimized, Memory-Optimized, or Storage-Optimized.
                                  Required.
                                "disk": 0,  # The amount of disk space set aside for
                                  Droplets of this size. The value is represented in gigabytes.
                                  Required.
                                "memory": 0,  # The amount of RAM allocated to
                                  Droplets created of this size. The value is represented in megabytes.
                                  Required.
                                "price_hourly": 0.0,  # This describes the price of
                                  the Droplet size as measured hourly. The value is measured in US
                                  dollars. Required.
                                "price_monthly": 0.0,  # This attribute describes the
                                  monthly cost of this Droplet size if the Droplet is kept for an
                                  entire month. The value is measured in US dollars. Required.
                                "regions": [
                                    "str"  # An array containing the region slugs
                                      where this size is available for Droplet creates. Required.
                                ],
                                "slug": "str",  # A human-readable string that is
                                  used to uniquely identify each size. Required.
                                "transfer": 0.0,  # The amount of transfer bandwidth
                                  that is available for Droplets created in this size. This only counts
                                  traffic on the public interface. The value is given in terabytes.
                                  Required.
                                "vcpus": 0,  # The number of CPUs allocated to
                                  Droplets of this size. Required.
                                "disk_info": [
                                    {
                                        "size": {
                                            "amount": 0,  # Optional. The
                                              amount of space allocated to the disk.
                                            "unit": "str"  # Optional.
                                              The unit of measure for the disk size.
                                        },
                                        "type": "str"  # Optional. The type
                                          of disk. All Droplets contain a ``local`` disk. Additionally,
                                          GPU Droplets can also have a ``scratch`` disk for
                                          non-persistent data. Known values are: "local" and "scratch".
                                    }
                                ],
                                "gpu_info": {
                                    "count": 0,  # Optional. The number of GPUs
                                      allocated to the Droplet.
                                    "model": "str",  # Optional. The model of the
                                      GPU.
                                    "vram": {
                                        "amount": 0,  # Optional. The amount
                                          of VRAM allocated to the GPU.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the VRAM.
                                    }
                                }
                            },
                            "size_slug": "str",  # The unique slug identifier for the
                              size of this Droplet. Required.
                            "snapshot_ids": [
                                0  # An array of snapshot IDs of any snapshots
                                  created from the Droplet instance. Required.
                            ],
                            "status": "str",  # A status string indicating the state of
                              the Droplet instance. This may be "new", "active", "off", or "archive".
                              Required. Known values are: "new", "active", "off", and "archive".
                            "tags": [
                                "str"  # An array of Tags the Droplet has been tagged
                                  with. Required.
                            ],
                            "vcpus": 0,  # The number of virtual CPUs. Required.
                            "volume_ids": [
                                "str"  # A flat array including the unique identifier
                                  for each Block Storage volume attached to the Droplet. Required.
                            ],
                            "disk_info": [
                                {
                                    "size": {
                                        "amount": 0,  # Optional. The amount
                                          of space allocated to the disk.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the disk size.
                                    },
                                    "type": "str"  # Optional. The type of disk.
                                      All Droplets contain a ``local`` disk. Additionally, GPU Droplets
                                      can also have a ``scratch`` disk for non-persistent data. Known
                                      values are: "local" and "scratch".
                                }
                            ],
                            "gpu_info": {
                                "count": 0,  # Optional. The number of GPUs allocated
                                  to the Droplet.
                                "model": "str",  # Optional. The model of the GPU.
                                "vram": {
                                    "amount": 0,  # Optional. The amount of VRAM
                                      allocated to the GPU.
                                    "unit": "str"  # Optional. The unit of
                                      measure for the VRAM.
                                }
                            },
                            "kernel": {
                                "id": 0,  # Optional. A unique number used to
                                  identify and reference a specific kernel.
                                "name": "str",  # Optional. The display name of the
                                  kernel. This is shown in the web UI and is generally a descriptive
                                  title for the kernel in question.
                                "version": "str"  # Optional. A standard kernel
                                  version string representing the version, patch, and release
                                  information.
                            },
                            "vpc_uuid": "str"  # Optional. A string specifying the UUID
                              of the VPC to which the Droplet is assigned.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_neighbors_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_associated_resources(self, droplet_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Associated Resources for a Droplet.

        To list the associated billable resources that can be destroyed along with a
        Droplet, send a GET request to the
        ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources`` endpoint.

        The response will be a JSON object containing ``snapshots``\\ , ``volumes``\\ , and
        ``volume_snapshots`` keys. Each will be set to an array of objects containing
        information about the associated resources.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "floating_ips": [
                        {
                            "cost": "str",  # Optional. The cost of the resource in USD
                              per month if the resource is retained after the Droplet is destroyed.
                            "id": "str",  # Optional. The unique identifier for the
                              resource associated with the Droplet.
                            "name": "str"  # Optional. The name of the resource
                              associated with the Droplet.
                        }
                    ],
                    "reserved_ips": [
                        {
                            "cost": "str",  # Optional. The cost of the resource in USD
                              per month if the resource is retained after the Droplet is destroyed.
                            "id": "str",  # Optional. The unique identifier for the
                              resource associated with the Droplet.
                            "name": "str"  # Optional. The name of the resource
                              associated with the Droplet.
                        }
                    ],
                    "snapshots": [
                        {
                            "cost": "str",  # Optional. The cost of the resource in USD
                              per month if the resource is retained after the Droplet is destroyed.
                            "id": "str",  # Optional. The unique identifier for the
                              resource associated with the Droplet.
                            "name": "str"  # Optional. The name of the resource
                              associated with the Droplet.
                        }
                    ],
                    "volume_snapshots": [
                        {
                            "cost": "str",  # Optional. The cost of the resource in USD
                              per month if the resource is retained after the Droplet is destroyed.
                            "id": "str",  # Optional. The unique identifier for the
                              resource associated with the Droplet.
                            "name": "str"  # Optional. The name of the resource
                              associated with the Droplet.
                        }
                    ],
                    "volumes": [
                        {
                            "cost": "str",  # Optional. The cost of the resource in USD
                              per month if the resource is retained after the Droplet is destroyed.
                            "id": "str",  # Optional. The unique identifier for the
                              resource associated with the Droplet.
                            "name": "str"  # Optional. The name of the resource
                              associated with the Droplet.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_associated_resources_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def destroy_with_associated_resources_selective(  # pylint: disable=name-too-long
        self,
        droplet_id: int,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Destroy a Droplet and its Associated Resources.

        To destroy a Droplet along with a sub-set of its associated resources, send a
        DELETE request to the ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/selective``
        endpoint. The JSON body of the request should include ``reserved_ips``\\ , ``snapshots``\\ ,
        ``volumes``\\ ,
        or ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed. The IDs can be found by querying the Droplet's
        associated resources. Any associated resource not included in the request
        will remain and continue to accrue changes on your account.

        A successful response will include a 202 response code and no content. Use
        the status endpoint to check on the success or failure of the destruction of
        the individual resources.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "floating_ips": [
                        "str"  # Optional. An array of unique identifiers for the floating
                          IPs to be scheduled for deletion.
                    ],
                    "reserved_ips": [
                        "str"  # Optional. An array of unique identifiers for the reserved
                          IPs to be scheduled for deletion.
                    ],
                    "snapshots": [
                        "str"  # Optional. An array of unique identifiers for the snapshots
                          to be scheduled for deletion.
                    ],
                    "volume_snapshots": [
                        "str"  # Optional. An array of unique identifiers for the volume
                          snapshots to be scheduled for deletion.
                    ],
                    "volumes": [
                        "str"  # Optional. An array of unique identifiers for the volumes to
                          be scheduled for deletion.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def destroy_with_associated_resources_selective(  # pylint: disable=name-too-long
        self,
        droplet_id: int,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Destroy a Droplet and its Associated Resources.

        To destroy a Droplet along with a sub-set of its associated resources, send a
        DELETE request to the ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/selective``
        endpoint. The JSON body of the request should include ``reserved_ips``\\ , ``snapshots``\\ ,
        ``volumes``\\ ,
        or ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed. The IDs can be found by querying the Droplet's
        associated resources. Any associated resource not included in the request
        will remain and continue to accrue changes on your account.

        A successful response will include a 202 response code and no content. Use
        the status endpoint to check on the success or failure of the destruction of
        the individual resources.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def destroy_with_associated_resources_selective(  # pylint: disable=name-too-long
        self,
        droplet_id: int,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Destroy a Droplet and its Associated Resources.

        To destroy a Droplet along with a sub-set of its associated resources, send a
        DELETE request to the ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/selective``
        endpoint. The JSON body of the request should include ``reserved_ips``\\ , ``snapshots``\\ ,
        ``volumes``\\ ,
        or ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed. The IDs can be found by querying the Droplet's
        associated resources. Any associated resource not included in the request
        will remain and continue to accrue changes on your account.

        A successful response will include a 202 response code and no content. Use
        the status endpoint to check on the success or failure of the destruction of
        the individual resources.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "floating_ips": [
                        "str"  # Optional. An array of unique identifiers for the floating
                          IPs to be scheduled for deletion.
                    ],
                    "reserved_ips": [
                        "str"  # Optional. An array of unique identifiers for the reserved
                          IPs to be scheduled for deletion.
                    ],
                    "snapshots": [
                        "str"  # Optional. An array of unique identifiers for the snapshots
                          to be scheduled for deletion.
                    ],
                    "volume_snapshots": [
                        "str"  # Optional. An array of unique identifiers for the volume
                          snapshots to be scheduled for deletion.
                    ],
                    "volumes": [
                        "str"  # Optional. An array of unique identifiers for the volumes to
                          be scheduled for deletion.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_droplets_destroy_with_associated_resources_selective_request(
            droplet_id=droplet_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def destroy_with_associated_resources_dangerous(  # pylint: disable=name-too-long
        self, droplet_id: int, *, x_dangerous: bool, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Destroy a Droplet and All of its Associated Resources (Dangerous).

        To destroy a Droplet along with all of its associated resources, send a DELETE
        request to the ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/dangerous``
        endpoint. The headers of this request must include an ``X-Dangerous`` key set to
        ``true``. To preview which resources will be destroyed, first query the
        Droplet's associated resources. This operation *can not* be reverse and should
        be used with caution.

        A successful response will include a 202 response code and no content. Use the
        status endpoint to check on the success or failure of the destruction of the
        individual resources.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword x_dangerous: Acknowledge this action will destroy the Droplet and all associated
         resources and *can not* be reversed. Required.
        :paramtype x_dangerous: bool
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_droplets_destroy_with_associated_resources_dangerous_request(
            droplet_id=droplet_id,
            x_dangerous=x_dangerous,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_destroy_associated_resources_status(
        self, droplet_id: int, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Check Status of a Droplet Destroy with Associated Resources Request.

        To check on the status of a request to destroy a Droplet with its associated
        resources, send a GET request to the
        ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/status`` endpoint.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format indicating when the requested action was
                      completed.
                    "droplet": {
                        "destroyed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format indicating when the resource
                          was destroyed if the request was successful.
                        "error_message": "str",  # Optional. A string indicating that the
                          resource was not successfully destroyed and providing additional information.
                        "id": "str",  # Optional. The unique identifier for the resource
                          scheduled for deletion.
                        "name": "str"  # Optional. The name of the resource scheduled for
                          deletion.
                    },
                    "failures": 0,  # Optional. A count of the associated resources that failed
                      to be destroyed, if any.
                    "resources": {
                        "floating_ips": [
                            {
                                "destroyed_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format indicating
                                  when the resource was destroyed if the request was successful.
                                "error_message": "str",  # Optional. A string
                                  indicating that the resource was not successfully destroyed and
                                  providing additional information.
                                "id": "str",  # Optional. The unique identifier for
                                  the resource scheduled for deletion.
                                "name": "str"  # Optional. The name of the resource
                                  scheduled for deletion.
                            }
                        ],
                        "reserved_ips": [
                            {
                                "destroyed_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format indicating
                                  when the resource was destroyed if the request was successful.
                                "error_message": "str",  # Optional. A string
                                  indicating that the resource was not successfully destroyed and
                                  providing additional information.
                                "id": "str",  # Optional. The unique identifier for
                                  the resource scheduled for deletion.
                                "name": "str"  # Optional. The name of the resource
                                  scheduled for deletion.
                            }
                        ],
                        "snapshots": [
                            {
                                "destroyed_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format indicating
                                  when the resource was destroyed if the request was successful.
                                "error_message": "str",  # Optional. A string
                                  indicating that the resource was not successfully destroyed and
                                  providing additional information.
                                "id": "str",  # Optional. The unique identifier for
                                  the resource scheduled for deletion.
                                "name": "str"  # Optional. The name of the resource
                                  scheduled for deletion.
                            }
                        ],
                        "volume_snapshots": [
                            {
                                "destroyed_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format indicating
                                  when the resource was destroyed if the request was successful.
                                "error_message": "str",  # Optional. A string
                                  indicating that the resource was not successfully destroyed and
                                  providing additional information.
                                "id": "str",  # Optional. The unique identifier for
                                  the resource scheduled for deletion.
                                "name": "str"  # Optional. The name of the resource
                                  scheduled for deletion.
                            }
                        ],
                        "volumes": [
                            {
                                "destroyed_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format indicating
                                  when the resource was destroyed if the request was successful.
                                "error_message": "str",  # Optional. A string
                                  indicating that the resource was not successfully destroyed and
                                  providing additional information.
                                "id": "str",  # Optional. The unique identifier for
                                  the resource scheduled for deletion.
                                "name": "str"  # Optional. The name of the resource
                                  scheduled for deletion.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_get_destroy_associated_resources_status_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def destroy_retry_with_associated_resources(
        self, droplet_id: int, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Retry a Droplet Destroy with Associated Resources Request.

        If the status of a request to destroy a Droplet with its associated resources
        reported any errors, it can be retried by sending a POST request to the
        ``/v2/droplets/$DROPLET_ID/destroy_with_associated_resources/retry`` endpoint.

        Only one destroy can be active at a time per Droplet. If a retry is issued
        while another destroy is in progress for the Droplet a 409 status code will
        be returned. A successful response will include a 202 response code and no
        content.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404, 409
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_droplets_destroy_retry_with_associated_resources_request(
            droplet_id=droplet_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404, 409]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 409:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_neighbors_ids(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Droplet Neighbors.

        To retrieve a list of all Droplets that are co-located on the same physical
        hardware, send a GET request to ``/v2/reports/droplet_neighbors_ids``.

        The results will be returned as a JSON object with a key of ``neighbor_ids``.
        This will be set to an array of arrays. Each array will contain a set of
        Droplet IDs for Droplets that share a physical server. An empty array
        indicates that all Droplets associated with your account are located on
        separate physical hardware.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "neighbor_ids": [
                        [
                            0  # Optional. An array of arrays. Each array will contain a
                              set of Droplet IDs for Droplets that share a physical server.
                        ]
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplets_list_neighbors_ids_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class DropletActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`droplet_actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self, droplet_id: int, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Actions for a Droplet.

        To retrieve a list of all actions that have been executed for a Droplet, send
        a GET request to ``/v2/droplets/$DROPLET_ID/actions``.

        The results will be returned as a JSON object with an ``actions`` key. This will
        be set to an array filled with ``action`` objects containing the standard
        ``action`` attributes.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplet_actions_list_request(
            droplet_id=droplet_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def post(
        self,
        droplet_id: int,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Droplet Action.

        To initiate an action on a Droplet send a POST request to
        ``/v2/droplets/$DROPLET_ID/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - :code:`<nobr>`enable_backups`</nobr>`
             - Enables backups for a Droplet
           * - :code:`<nobr>`disable_backups`</nobr>`
             - Disables backups for a Droplet
           * - :code:`<nobr>`change_backup_policy`</nobr>`
             - Update the backup policy for a Droplet
           * - :code:`<nobr>`reboot`</nobr>`
             - Reboots a Droplet. A ``reboot`` action is an attempt to reboot the Droplet in a graceful
        way, similar to using the ``reboot`` command from the console.
           * - :code:`<nobr>`power_cycle`</nobr>`
             - Power cycles a Droplet. A ``powercycle`` action is similar to pushing the reset button
        on a physical machine, it's similar to booting from scratch.
           * - :code:`<nobr>`shutdown`</nobr>`
             - Shutsdown a Droplet. A shutdown action is an attempt to shutdown the Droplet in a
        graceful way, similar to using the ``shutdown`` command from the console. Since a ``shutdown``
        command can fail, this action guarantees that the command is issued, not that it succeeds. The
        preferred way to turn off a Droplet is to attempt a shutdown, with a reasonable timeout,
        followed by a ``power_off`` action to ensure the Droplet is off.
           * - :code:`<nobr>`power_off`</nobr>`
             - Powers off a Droplet. A ``power_off`` event is a hard shutdown and should only be used
        if the ``shutdown`` action is not successful. It is similar to cutting the power on a server
        and could lead to complications.
           * - :code:`<nobr>`power_on`</nobr>`
             - Powers on a Droplet.
           * - :code:`<nobr>`restore`</nobr>`
             - Restore a Droplet using a backup image. The image ID that is passed in must be a backup
        of the current Droplet instance. The operation will leave any embedded SSH keys intact.
           * - :code:`<nobr>`password_reset`</nobr>`
             - Resets the root password for a Droplet. A new password will be provided via email. It
        must be changed after first use.
           * - :code:`<nobr>`resize`</nobr>`
             - Resizes a Droplet. Set the ``size`` attribute to a size slug. If a permanent resize with
        disk changes included is desired, set the ``disk`` attribute to ``true``.
           * - :code:`<nobr>`rebuild`</nobr>`
             - Rebuilds a Droplet from a new base image. Set the ``image`` attribute to an image ID or
        slug.
           * - :code:`<nobr>`rename`</nobr>`
             - Renames a Droplet.
           * - :code:`<nobr>`change_kernel`</nobr>`
             - Changes a Droplet's kernel. Only applies to Droplets with externally managed kernels.
        All Droplets created after March 2017 use internal kernels by default.
           * - :code:`<nobr>`enable_ipv6`</nobr>`
             - Enables IPv6 for a Droplet. Once enabled for a Droplet, IPv6 can not be disabled. When
        enabling IPv6 on an existing Droplet, `additional OS-level configuration
        <https://docs.digitalocean.com/products/networking/ipv6/how-to/enable/#on-existing-droplets>`_
        is required.
           * - :code:`<nobr>`snapshot`</nobr>`
             - Takes a snapshot of a Droplet.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post(
        self,
        droplet_id: int,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Droplet Action.

        To initiate an action on a Droplet send a POST request to
        ``/v2/droplets/$DROPLET_ID/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - :code:`<nobr>`enable_backups`</nobr>`
             - Enables backups for a Droplet
           * - :code:`<nobr>`disable_backups`</nobr>`
             - Disables backups for a Droplet
           * - :code:`<nobr>`change_backup_policy`</nobr>`
             - Update the backup policy for a Droplet
           * - :code:`<nobr>`reboot`</nobr>`
             - Reboots a Droplet. A ``reboot`` action is an attempt to reboot the Droplet in a graceful
        way, similar to using the ``reboot`` command from the console.
           * - :code:`<nobr>`power_cycle`</nobr>`
             - Power cycles a Droplet. A ``powercycle`` action is similar to pushing the reset button
        on a physical machine, it's similar to booting from scratch.
           * - :code:`<nobr>`shutdown`</nobr>`
             - Shutsdown a Droplet. A shutdown action is an attempt to shutdown the Droplet in a
        graceful way, similar to using the ``shutdown`` command from the console. Since a ``shutdown``
        command can fail, this action guarantees that the command is issued, not that it succeeds. The
        preferred way to turn off a Droplet is to attempt a shutdown, with a reasonable timeout,
        followed by a ``power_off`` action to ensure the Droplet is off.
           * - :code:`<nobr>`power_off`</nobr>`
             - Powers off a Droplet. A ``power_off`` event is a hard shutdown and should only be used
        if the ``shutdown`` action is not successful. It is similar to cutting the power on a server
        and could lead to complications.
           * - :code:`<nobr>`power_on`</nobr>`
             - Powers on a Droplet.
           * - :code:`<nobr>`restore`</nobr>`
             - Restore a Droplet using a backup image. The image ID that is passed in must be a backup
        of the current Droplet instance. The operation will leave any embedded SSH keys intact.
           * - :code:`<nobr>`password_reset`</nobr>`
             - Resets the root password for a Droplet. A new password will be provided via email. It
        must be changed after first use.
           * - :code:`<nobr>`resize`</nobr>`
             - Resizes a Droplet. Set the ``size`` attribute to a size slug. If a permanent resize with
        disk changes included is desired, set the ``disk`` attribute to ``true``.
           * - :code:`<nobr>`rebuild`</nobr>`
             - Rebuilds a Droplet from a new base image. Set the ``image`` attribute to an image ID or
        slug.
           * - :code:`<nobr>`rename`</nobr>`
             - Renames a Droplet.
           * - :code:`<nobr>`change_kernel`</nobr>`
             - Changes a Droplet's kernel. Only applies to Droplets with externally managed kernels.
        All Droplets created after March 2017 use internal kernels by default.
           * - :code:`<nobr>`enable_ipv6`</nobr>`
             - Enables IPv6 for a Droplet. Once enabled for a Droplet, IPv6 can not be disabled. When
        enabling IPv6 on an existing Droplet, `additional OS-level configuration
        <https://docs.digitalocean.com/products/networking/ipv6/how-to/enable/#on-existing-droplets>`_
        is required.
           * - :code:`<nobr>`snapshot`</nobr>`
             - Takes a snapshot of a Droplet.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post(
        self,
        droplet_id: int,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Droplet Action.

        To initiate an action on a Droplet send a POST request to
        ``/v2/droplets/$DROPLET_ID/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - :code:`<nobr>`enable_backups`</nobr>`
             - Enables backups for a Droplet
           * - :code:`<nobr>`disable_backups`</nobr>`
             - Disables backups for a Droplet
           * - :code:`<nobr>`change_backup_policy`</nobr>`
             - Update the backup policy for a Droplet
           * - :code:`<nobr>`reboot`</nobr>`
             - Reboots a Droplet. A ``reboot`` action is an attempt to reboot the Droplet in a graceful
        way, similar to using the ``reboot`` command from the console.
           * - :code:`<nobr>`power_cycle`</nobr>`
             - Power cycles a Droplet. A ``powercycle`` action is similar to pushing the reset button
        on a physical machine, it's similar to booting from scratch.
           * - :code:`<nobr>`shutdown`</nobr>`
             - Shutsdown a Droplet. A shutdown action is an attempt to shutdown the Droplet in a
        graceful way, similar to using the ``shutdown`` command from the console. Since a ``shutdown``
        command can fail, this action guarantees that the command is issued, not that it succeeds. The
        preferred way to turn off a Droplet is to attempt a shutdown, with a reasonable timeout,
        followed by a ``power_off`` action to ensure the Droplet is off.
           * - :code:`<nobr>`power_off`</nobr>`
             - Powers off a Droplet. A ``power_off`` event is a hard shutdown and should only be used
        if the ``shutdown`` action is not successful. It is similar to cutting the power on a server
        and could lead to complications.
           * - :code:`<nobr>`power_on`</nobr>`
             - Powers on a Droplet.
           * - :code:`<nobr>`restore`</nobr>`
             - Restore a Droplet using a backup image. The image ID that is passed in must be a backup
        of the current Droplet instance. The operation will leave any embedded SSH keys intact.
           * - :code:`<nobr>`password_reset`</nobr>`
             - Resets the root password for a Droplet. A new password will be provided via email. It
        must be changed after first use.
           * - :code:`<nobr>`resize`</nobr>`
             - Resizes a Droplet. Set the ``size`` attribute to a size slug. If a permanent resize with
        disk changes included is desired, set the ``disk`` attribute to ``true``.
           * - :code:`<nobr>`rebuild`</nobr>`
             - Rebuilds a Droplet from a new base image. Set the ``image`` attribute to an image ID or
        slug.
           * - :code:`<nobr>`rename`</nobr>`
             - Renames a Droplet.
           * - :code:`<nobr>`change_kernel`</nobr>`
             - Changes a Droplet's kernel. Only applies to Droplets with externally managed kernels.
        All Droplets created after March 2017 use internal kernels by default.
           * - :code:`<nobr>`enable_ipv6`</nobr>`
             - Enables IPv6 for a Droplet. Once enabled for a Droplet, IPv6 can not be disabled. When
        enabling IPv6 on an existing Droplet, `additional OS-level configuration
        <https://docs.digitalocean.com/products/networking/ipv6/how-to/enable/#on-existing-droplets>`_
        is required.
           * - :code:`<nobr>`snapshot`</nobr>`
             - Takes a snapshot of a Droplet.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Is either a JSON type or a IO[bytes] type. Default value is
         None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_droplet_actions_post_request(
            droplet_id=droplet_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def post_by_tag(
        self,
        body: Optional[JSON] = None,
        *,
        tag_name: Optional[str] = None,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Acting on Tagged Droplets.

        Some actions can be performed in bulk on tagged Droplets. The actions can be
        initiated by sending a POST to ``/v2/droplets/actions?tag_name=$TAG_NAME`` with
        the action arguments.

        Only a sub-set of action types are supported:


        * ``power_cycle``
        * ``power_on``
        * ``power_off``
        * ``shutdown``
        * ``enable_ipv6``
        * ``enable_backups``
        * ``disable_backups``
        * ``snapshot``.

        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Default value is None.
        :type body: JSON
        :keyword tag_name: Used to filter Droplets by a specific tag. Can not be combined with ``name``
         or ``type``. Default value is None.
        :paramtype tag_name: str
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ]
                }
        """

    @overload
    def post_by_tag(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        tag_name: Optional[str] = None,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Acting on Tagged Droplets.

        Some actions can be performed in bulk on tagged Droplets. The actions can be
        initiated by sending a POST to ``/v2/droplets/actions?tag_name=$TAG_NAME`` with
        the action arguments.

        Only a sub-set of action types are supported:


        * ``power_cycle``
        * ``power_on``
        * ``power_off``
        * ``shutdown``
        * ``enable_ipv6``
        * ``enable_backups``
        * ``disable_backups``
        * ``snapshot``.

        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Default value is None.
        :type body: IO[bytes]
        :keyword tag_name: Used to filter Droplets by a specific tag. Can not be combined with ``name``
         or ``type``. Default value is None.
        :paramtype tag_name: str
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ]
                }
        """

    @distributed_trace
    def post_by_tag(
        self,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        *,
        tag_name: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Acting on Tagged Droplets.

        Some actions can be performed in bulk on tagged Droplets. The actions can be
        initiated by sending a POST to ``/v2/droplets/actions?tag_name=$TAG_NAME`` with
        the action arguments.

        Only a sub-set of action types are supported:


        * ``power_cycle``
        * ``power_on``
        * ``power_off``
        * ``shutdown``
        * ``enable_ipv6``
        * ``enable_backups``
        * ``disable_backups``
        * ``snapshot``.

        :param body: The ``type`` attribute set in the request body will specify the  action that
         will be taken on the Droplet. Some actions will require additional
         attributes to be set as well. Is either a JSON type or a IO[bytes] type. Default value is
         None.
        :type body: JSON or IO[bytes]
        :keyword tag_name: Used to filter Droplets by a specific tag. Can not be combined with ``name``
         or ``type``. Default value is None.
        :paramtype tag_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_droplet_actions_post_by_tag_request(
            tag_name=tag_name,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, droplet_id: int, action_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve a Droplet Action.

        To retrieve a Droplet action, send a GET request to
        ``/v2/droplets/$DROPLET_ID/actions/$ACTION_ID``.

        The response will be a JSON object with a key called ``action``. The value will
        be a Droplet action object.

        :param droplet_id: A unique identifier for a Droplet instance. Required.
        :type droplet_id: int
        :param action_id: A unique numeric ID that can be used to identify and reference an action.
         Required.
        :type action_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_droplet_actions_get_request(
            droplet_id=droplet_id,
            action_id=action_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class AutoscalepoolsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`autoscalepools` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        per_page: int = 20,
        page: int = 1,
        name: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Autoscale Pools.

        To list all autoscale pools in your team, send a GET request to ``/v2/droplets/autoscale``.
        The response body will be a JSON object with a key of ``autoscale_pools`` containing an array
        of autoscale pool objects.
        These each contain the standard autoscale pool attributes.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword name: The name of the autoscale pool. Default value is None.
        :paramtype name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "autoscale_pools": [
                        {
                            "active_resources_count": 0,  # The number of active Droplets
                              in the autoscale pool. Required.
                            "config": {},
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the autoscale
                              pool was created. Required.
                            "droplet_template": {
                                "image": "str",  # The Droplet image to be used for
                                  all Droplets in the autoscale pool. You may specify the slug or the
                                  image ID. Required.
                                "region": "str",  # The datacenter in which all of
                                  the Droplets will be created. Required. Known values are: "nyc1",
                                  "nyc2", "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1",
                                  "lon1", "fra1", "tor1", "blr1", and "syd1".
                                "size": "str",  # The Droplet size to be used for all
                                  Droplets in the autoscale pool. Required.
                                "ssh_keys": [
                                    "str"  # The SSH keys to be installed on the
                                      Droplets in the autoscale pool. You can either specify the key ID
                                      or the fingerprint. Required.
                                ],
                                "ipv6": bool,  # Optional. Assigns a unique IPv6
                                  address to each of the Droplets in the autoscale pool.
                                "name": "str",  # Optional. The name(s) to be applied
                                  to all Droplets in the autoscale pool.
                                "project_id": "str",  # Optional. The project that
                                  the Droplets in the autoscale pool will belong to.
                                "tags": [
                                    "str"  # Optional. The tags to apply to each
                                      of the Droplets in the autoscale pool.
                                ],
                                "user_data": "str",  # Optional. A string containing
                                  user data that cloud-init consumes to configure a Droplet on first
                                  boot. User data is often a cloud-config file or Bash script. It must
                                  be plain text and may not exceed 64 KiB in size.
                                "vpc_uuid": "str",  # Optional. The VPC where the
                                  Droplets in the autoscale pool will be created. The VPC must be in
                                  the region where you want to create the Droplets.
                                "with_droplet_agent": bool  # Optional. Installs the
                                  Droplet agent. This must be set to true to monitor Droplets for
                                  resource utilization scaling.
                            },
                            "id": "str",  # A unique identifier for each autoscale pool
                              instance. This is automatically generated upon autoscale pool creation.
                              Required.
                            "name": "str",  # The human-readable name set for the
                              autoscale pool. Required.
                            "status": "str",  # The current status of the autoscale pool.
                              Required. Known values are: "active", "deleting", and "error".
                            "updated_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the autoscale
                              pool was last updated. Required.
                            "current_utilization": {
                                "cpu": 0.0,  # Optional. The average CPU utilization
                                  of the autoscale pool.
                                "memory": 0.0  # Optional. The average memory
                                  utilization of the autoscale pool.
                            }
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_autoscalepools_list_request(
            per_page=per_page,
            page=page,
            name=name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Autoscale Pool.

        To create a new autoscale pool, send a POST request to ``/v2/droplets/autoscale`` setting the
        required attributes.

        The response body will contain a JSON object with a key called ``autoscale_pool`` containing
        the standard attributes for the new autoscale pool.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "droplet_template": {
                        "image": "str",  # The Droplet image to be used for all Droplets in
                          the autoscale pool. You may specify the slug or the image ID. Required.
                        "region": "str",  # The datacenter in which all of the Droplets will
                          be created. Required. Known values are: "nyc1", "nyc2", "nyc3", "ams2",
                          "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1", "tor1", "blr1", and
                          "syd1".
                        "size": "str",  # The Droplet size to be used for all Droplets in the
                          autoscale pool. Required.
                        "ssh_keys": [
                            "str"  # The SSH keys to be installed on the Droplets in the
                              autoscale pool. You can either specify the key ID or the fingerprint.
                              Required.
                        ],
                        "ipv6": bool,  # Optional. Assigns a unique IPv6 address to each of
                          the Droplets in the autoscale pool.
                        "name": "str",  # Optional. The name(s) to be applied to all Droplets
                          in the autoscale pool.
                        "project_id": "str",  # Optional. The project that the Droplets in
                          the autoscale pool will belong to.
                        "tags": [
                            "str"  # Optional. The tags to apply to each of the Droplets
                              in the autoscale pool.
                        ],
                        "user_data": "str",  # Optional. A string containing user data that
                          cloud-init consumes to configure a Droplet on first boot. User data is often
                          a cloud-config file or Bash script. It must be plain text and may not exceed
                          64 KiB in size.
                        "vpc_uuid": "str",  # Optional. The VPC where the Droplets in the
                          autoscale pool will be created. The VPC must be in the region where you want
                          to create the Droplets.
                        "with_droplet_agent": bool  # Optional. Installs the Droplet agent.
                          This must be set to true to monitor Droplets for resource utilization
                          scaling.
                    },
                    "name": "str"  # The human-readable name of the autoscale pool. This field
                      cannot be updated. Required.
                }

                # response body for status code(s): 202
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
        """

    @overload
    def create(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Autoscale Pool.

        To create a new autoscale pool, send a POST request to ``/v2/droplets/autoscale`` setting the
        required attributes.

        The response body will contain a JSON object with a key called ``autoscale_pool`` containing
        the standard attributes for the new autoscale pool.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
        """

    @distributed_trace
    def create(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Autoscale Pool.

        To create a new autoscale pool, send a POST request to ``/v2/droplets/autoscale`` setting the
        required attributes.

        The response body will contain a JSON object with a key called ``autoscale_pool`` containing
        the standard attributes for the new autoscale pool.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "droplet_template": {
                        "image": "str",  # The Droplet image to be used for all Droplets in
                          the autoscale pool. You may specify the slug or the image ID. Required.
                        "region": "str",  # The datacenter in which all of the Droplets will
                          be created. Required. Known values are: "nyc1", "nyc2", "nyc3", "ams2",
                          "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1", "tor1", "blr1", and
                          "syd1".
                        "size": "str",  # The Droplet size to be used for all Droplets in the
                          autoscale pool. Required.
                        "ssh_keys": [
                            "str"  # The SSH keys to be installed on the Droplets in the
                              autoscale pool. You can either specify the key ID or the fingerprint.
                              Required.
                        ],
                        "ipv6": bool,  # Optional. Assigns a unique IPv6 address to each of
                          the Droplets in the autoscale pool.
                        "name": "str",  # Optional. The name(s) to be applied to all Droplets
                          in the autoscale pool.
                        "project_id": "str",  # Optional. The project that the Droplets in
                          the autoscale pool will belong to.
                        "tags": [
                            "str"  # Optional. The tags to apply to each of the Droplets
                              in the autoscale pool.
                        ],
                        "user_data": "str",  # Optional. A string containing user data that
                          cloud-init consumes to configure a Droplet on first boot. User data is often
                          a cloud-config file or Bash script. It must be plain text and may not exceed
                          64 KiB in size.
                        "vpc_uuid": "str",  # Optional. The VPC where the Droplets in the
                          autoscale pool will be created. The VPC must be in the region where you want
                          to create the Droplets.
                        "with_droplet_agent": bool  # Optional. Installs the Droplet agent.
                          This must be set to true to monitor Droplets for resource utilization
                          scaling.
                    },
                    "name": "str"  # The human-readable name of the autoscale pool. This field
                      cannot be updated. Required.
                }

                # response body for status code(s): 202
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_autoscalepools_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, autoscale_pool_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Autoscale Pool.

        To show information about an individual autoscale pool, send a GET request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID``.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_autoscalepools_get_request(
            autoscale_pool_id=autoscale_pool_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        autoscale_pool_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Autoscale Pool.

        To update the configuration of an existing autoscale pool, send a PUT request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID``. The request must contain a full representation
        of the autoscale pool including existing attributes.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "droplet_template": {
                        "image": "str",  # The Droplet image to be used for all Droplets in
                          the autoscale pool. You may specify the slug or the image ID. Required.
                        "region": "str",  # The datacenter in which all of the Droplets will
                          be created. Required. Known values are: "nyc1", "nyc2", "nyc3", "ams2",
                          "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1", "tor1", "blr1", and
                          "syd1".
                        "size": "str",  # The Droplet size to be used for all Droplets in the
                          autoscale pool. Required.
                        "ssh_keys": [
                            "str"  # The SSH keys to be installed on the Droplets in the
                              autoscale pool. You can either specify the key ID or the fingerprint.
                              Required.
                        ],
                        "ipv6": bool,  # Optional. Assigns a unique IPv6 address to each of
                          the Droplets in the autoscale pool.
                        "name": "str",  # Optional. The name(s) to be applied to all Droplets
                          in the autoscale pool.
                        "project_id": "str",  # Optional. The project that the Droplets in
                          the autoscale pool will belong to.
                        "tags": [
                            "str"  # Optional. The tags to apply to each of the Droplets
                              in the autoscale pool.
                        ],
                        "user_data": "str",  # Optional. A string containing user data that
                          cloud-init consumes to configure a Droplet on first boot. User data is often
                          a cloud-config file or Bash script. It must be plain text and may not exceed
                          64 KiB in size.
                        "vpc_uuid": "str",  # Optional. The VPC where the Droplets in the
                          autoscale pool will be created. The VPC must be in the region where you want
                          to create the Droplets.
                        "with_droplet_agent": bool  # Optional. Installs the Droplet agent.
                          This must be set to true to monitor Droplets for resource utilization
                          scaling.
                    },
                    "name": "str"  # The human-readable name of the autoscale pool. This field
                      cannot be updated. Required.
                }

                # response body for status code(s): 200
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        autoscale_pool_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Autoscale Pool.

        To update the configuration of an existing autoscale pool, send a PUT request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID``. The request must contain a full representation
        of the autoscale pool including existing attributes.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self,
        autoscale_pool_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Autoscale Pool.

        To update the configuration of an existing autoscale pool, send a PUT request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID``. The request must contain a full representation
        of the autoscale pool including existing attributes.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {},
                    "droplet_template": {
                        "image": "str",  # The Droplet image to be used for all Droplets in
                          the autoscale pool. You may specify the slug or the image ID. Required.
                        "region": "str",  # The datacenter in which all of the Droplets will
                          be created. Required. Known values are: "nyc1", "nyc2", "nyc3", "ams2",
                          "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1", "tor1", "blr1", and
                          "syd1".
                        "size": "str",  # The Droplet size to be used for all Droplets in the
                          autoscale pool. Required.
                        "ssh_keys": [
                            "str"  # The SSH keys to be installed on the Droplets in the
                              autoscale pool. You can either specify the key ID or the fingerprint.
                              Required.
                        ],
                        "ipv6": bool,  # Optional. Assigns a unique IPv6 address to each of
                          the Droplets in the autoscale pool.
                        "name": "str",  # Optional. The name(s) to be applied to all Droplets
                          in the autoscale pool.
                        "project_id": "str",  # Optional. The project that the Droplets in
                          the autoscale pool will belong to.
                        "tags": [
                            "str"  # Optional. The tags to apply to each of the Droplets
                              in the autoscale pool.
                        ],
                        "user_data": "str",  # Optional. A string containing user data that
                          cloud-init consumes to configure a Droplet on first boot. User data is often
                          a cloud-config file or Bash script. It must be plain text and may not exceed
                          64 KiB in size.
                        "vpc_uuid": "str",  # Optional. The VPC where the Droplets in the
                          autoscale pool will be created. The VPC must be in the region where you want
                          to create the Droplets.
                        "with_droplet_agent": bool  # Optional. Installs the Droplet agent.
                          This must be set to true to monitor Droplets for resource utilization
                          scaling.
                    },
                    "name": "str"  # The human-readable name of the autoscale pool. This field
                      cannot be updated. Required.
                }

                # response body for status code(s): 200
                response == {
                    "autoscale_pool": {
                        "active_resources_count": 0,  # The number of active Droplets in the
                          autoscale pool. Required.
                        "config": {},
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          created. Required.
                        "droplet_template": {
                            "image": "str",  # The Droplet image to be used for all
                              Droplets in the autoscale pool. You may specify the slug or the image ID.
                              Required.
                            "region": "str",  # The datacenter in which all of the
                              Droplets will be created. Required. Known values are: "nyc1", "nyc2",
                              "nyc3", "ams2", "ams3", "sfo1", "sfo2", "sfo3", "sgp1", "lon1", "fra1",
                              "tor1", "blr1", and "syd1".
                            "size": "str",  # The Droplet size to be used for all
                              Droplets in the autoscale pool. Required.
                            "ssh_keys": [
                                "str"  # The SSH keys to be installed on the Droplets
                                  in the autoscale pool. You can either specify the key ID or the
                                  fingerprint. Required.
                            ],
                            "ipv6": bool,  # Optional. Assigns a unique IPv6 address to
                              each of the Droplets in the autoscale pool.
                            "name": "str",  # Optional. The name(s) to be applied to all
                              Droplets in the autoscale pool.
                            "project_id": "str",  # Optional. The project that the
                              Droplets in the autoscale pool will belong to.
                            "tags": [
                                "str"  # Optional. The tags to apply to each of the
                                  Droplets in the autoscale pool.
                            ],
                            "user_data": "str",  # Optional. A string containing user
                              data that cloud-init consumes to configure a Droplet on first boot. User
                              data is often a cloud-config file or Bash script. It must be plain text
                              and may not exceed 64 KiB in size.
                            "vpc_uuid": "str",  # Optional. The VPC where the Droplets in
                              the autoscale pool will be created. The VPC must be in the region where
                              you want to create the Droplets.
                            "with_droplet_agent": bool  # Optional. Installs the Droplet
                              agent. This must be set to true to monitor Droplets for resource
                              utilization scaling.
                        },
                        "id": "str",  # A unique identifier for each autoscale pool instance.
                          This is automatically generated upon autoscale pool creation. Required.
                        "name": "str",  # The human-readable name set for the autoscale pool.
                          Required.
                        "status": "str",  # The current status of the autoscale pool.
                          Required. Known values are: "active", "deleting", and "error".
                        "updated_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the autoscale pool was
                          last updated. Required.
                        "current_utilization": {
                            "cpu": 0.0,  # Optional. The average CPU utilization of the
                              autoscale pool.
                            "memory": 0.0  # Optional. The average memory utilization of
                              the autoscale pool.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_autoscalepools_update_request(
            autoscale_pool_id=autoscale_pool_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, autoscale_pool_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete autoscale pool.

        To destroy an autoscale pool, send a DELETE request to the
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID`` endpoint.

        A successful response will include a 202 response code and no content.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_autoscalepools_delete_request(
            autoscale_pool_id=autoscale_pool_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_dangerous(
        self, autoscale_pool_id: str, *, x_dangerous: bool, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete autoscale pool and resources.

        To destroy an autoscale pool and its associated resources (Droplets),
        send a DELETE request to the ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID/dangerous`` endpoint.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :keyword x_dangerous: Acknowledge this action will destroy the autoscale pool and its
         associated resources and *can not* be reversed. Required.
        :paramtype x_dangerous: bool
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_autoscalepools_delete_dangerous_request(
            autoscale_pool_id=autoscale_pool_id,
            x_dangerous=x_dangerous,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_members(
        self,
        autoscale_pool_id: str,
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List members.

        To list the Droplets in an autoscale pool, send a GET request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID/members``.

        The response body will be a JSON object with a key of ``droplets``. This will be
        set to an array containing information about each of the Droplets in the autoscale pool.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "droplets": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # The creation time of
                              the Droplet in ISO8601 combined date and time format. Required.
                            "current_utilization": {
                                "cpu": 0.0,  # Optional. The CPU utilization average
                                  of the individual Droplet.
                                "memory": 0.0  # Optional. The memory utilization
                                  average of the individual Droplet.
                            },
                            "droplet_id": 0,  # The unique identifier of the Droplet.
                              Required.
                            "health_status": "str",  # The health status of the Droplet.
                              Required.
                            "status": "str",  # The power status of the Droplet.
                              Required. Known values are: "provisioning", "active", "deleting", and
                              "off".
                            "updated_at": "2020-02-20 00:00:00"  # The last updated time
                              of the Droplet in ISO8601 combined date and time format. Required.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_autoscalepools_list_members_request(
            autoscale_pool_id=autoscale_pool_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_history(
        self,
        autoscale_pool_id: str,
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List history events.

        To list all of the scaling history events of an autoscale pool, send a GET request to
        ``/v2/droplets/autoscale/$AUTOSCALE_POOL_ID/history``.

        The response body will be a JSON object with a key of ``history``. This will be
        set to an array containing objects each representing a history event.

        :param autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :type autoscale_pool_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "history": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # The creation time of
                              the history event in ISO8601 combined date and time format. Required.
                            "current_instance_count": 0,  # The current number of
                              Droplets in the autoscale pool. Required.
                            "desired_instance_count": 0,  # The target number of Droplets
                              for the autoscale pool after the scaling event. Required.
                            "history_event_id": "str",  # The unique identifier of the
                              history event. Required.
                            "reason": "str",  # The reason for the scaling event.
                              Required. Known values are: "CONFIGURATION_CHANGE", "SCALE_UP", and
                              "SCALE_DOWN".
                            "status": "str",  # The status of the scaling event.
                              Required. Known values are: "in_progress", "success", and "error".
                            "updated_at": "2020-02-20 00:00:00"  # The last updated time
                              of the history event in ISO8601 combined date and time format. Required.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_autoscalepools_list_history_request(
            autoscale_pool_id=autoscale_pool_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class FirewallsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`firewalls` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Firewalls.

        To list all of the firewalls available on your account, send a GET request to
        ``/v2/firewalls``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "firewalls": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the firewall was created.
                            "droplet_ids": [
                                0  # Optional. An array containing the IDs of the
                                  Droplets assigned to the firewall.
                            ],
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a firewall.
                            "inbound_rules": [
                                {
                                    "ports": "str",  # The ports on which traffic
                                      will be allowed specified as a string containing a single port, a
                                      range (e.g. "8000-9000"), or "0" when all ports are open for a
                                      protocol. For ICMP rules this parameter will always return "0".
                                      Required.
                                    "protocol": "str",  # The type of traffic to
                                      be allowed. This may be one of ``tcp``"" , ``udp``"" , or
                                      ``icmp``. Required. Known values are: "tcp", "udp", and "icmp".
                                    "sources": {
                                        "addresses": [
                                            "str"  # Optional. An array
                                              of strings containing the IPv4 addresses, IPv6 addresses,
                                              IPv4 CIDRs, and/or IPv6 CIDRs to which the firewall will
                                              allow traffic.
                                        ],
                                        "droplet_ids": [
                                            0  # Optional. An array
                                              containing the IDs of the Droplets to which the firewall
                                              will allow traffic.
                                        ],
                                        "kubernetes_ids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the Kubernetes clusters to which
                                              the firewall will allow traffic.
                                        ],
                                        "load_balancer_uids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the load balancers to which the
                                              firewall will allow traffic.
                                        ],
                                        "tags": {}  # Optional. Any object.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. A human-readable name for a
                              firewall. The name must begin with an alphanumeric character. Subsequent
                              characters must either be alphanumeric characters, a period (.), or a
                              dash (-).
                            "outbound_rules": [
                                {
                                    "destinations": {
                                        "addresses": [
                                            "str"  # Optional. An array
                                              of strings containing the IPv4 addresses, IPv6 addresses,
                                              IPv4 CIDRs, and/or IPv6 CIDRs to which the firewall will
                                              allow traffic.
                                        ],
                                        "droplet_ids": [
                                            0  # Optional. An array
                                              containing the IDs of the Droplets to which the firewall
                                              will allow traffic.
                                        ],
                                        "kubernetes_ids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the Kubernetes clusters to which
                                              the firewall will allow traffic.
                                        ],
                                        "load_balancer_uids": [
                                            "str"  # Optional. An array
                                              containing the IDs of the load balancers to which the
                                              firewall will allow traffic.
                                        ],
                                        "tags": {}  # Optional. Any object.
                                    },
                                    "ports": "str",  # The ports on which traffic
                                      will be allowed specified as a string containing a single port, a
                                      range (e.g. "8000-9000"), or "0" when all ports are open for a
                                      protocol. For ICMP rules this parameter will always return "0".
                                      Required.
                                    "protocol": "str"  # The type of traffic to
                                      be allowed. This may be one of ``tcp``"" , ``udp``"" , or
                                      ``icmp``. Required. Known values are: "tcp", "udp", and "icmp".
                                }
                            ],
                            "pending_changes": [
                                {
                                    "droplet_id": 0,  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                    "removing": bool,  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                    "status": "str"  # Optional. An array of
                                      objects each containing the fields "droplet_id", "removing", and
                                      "status". It is provided to detail exactly which Droplets are
                                      having their security policies updated. When empty, all changes
                                      have been successfully applied.
                                }
                            ],
                            "status": "str",  # Optional. A status string indicating the
                              current state of the firewall. This can be "waiting", "succeeded", or
                              "failed". Known values are: "waiting", "succeeded", and "failed".
                            "tags": {}  # Optional. Any object.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_firewalls_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Firewall.

        To create a new firewall, send a POST request to ``/v2/firewalls``. The request
        must contain at least one inbound or outbound access rule.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the firewall was
                      created.
                    "droplet_ids": [
                        0  # Optional. An array containing the IDs of the Droplets assigned
                          to the firewall.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a firewall.
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "name": "str",  # Optional. A human-readable name for a firewall. The name
                      must begin with an alphanumeric character. Subsequent characters must either be
                      alphanumeric characters, a period (.), or a dash (-).
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ],
                    "pending_changes": [
                        {
                            "droplet_id": 0,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "removing": bool,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "status": "str"  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                        }
                    ],
                    "status": "str",  # Optional. A status string indicating the current state of
                      the firewall. This can be "waiting", "succeeded", or "failed". Known values are:
                      "waiting", "succeeded", and "failed".
                    "tags": {}  # Optional. Any object.
                }

                # response body for status code(s): 202
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Firewall.

        To create a new firewall, send a POST request to ``/v2/firewalls``. The request
        must contain at least one inbound or outbound access rule.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Firewall.

        To create a new firewall, send a POST request to ``/v2/firewalls``. The request
        must contain at least one inbound or outbound access rule.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the firewall was
                      created.
                    "droplet_ids": [
                        0  # Optional. An array containing the IDs of the Droplets assigned
                          to the firewall.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a firewall.
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "name": "str",  # Optional. A human-readable name for a firewall. The name
                      must begin with an alphanumeric character. Subsequent characters must either be
                      alphanumeric characters, a period (.), or a dash (-).
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ],
                    "pending_changes": [
                        {
                            "droplet_id": 0,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "removing": bool,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "status": "str"  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                        }
                    ],
                    "status": "str",  # Optional. A status string indicating the current state of
                      the firewall. This can be "waiting", "succeeded", or "failed". Known values are:
                      "waiting", "succeeded", and "failed".
                    "tags": {}  # Optional. Any object.
                }

                # response body for status code(s): 202
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 400]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, firewall_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Firewall.

        To show information about an existing firewall, send a GET request to
        ``/v2/firewalls/$FIREWALL_ID``.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_firewalls_get_request(
            firewall_id=firewall_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Firewall.

        To update the configuration of an existing firewall, send a PUT request to
        ``/v2/firewalls/$FIREWALL_ID``. The request should contain a full representation
        of the firewall including existing attributes. **Note that any attributes that
        are not provided will be reset to their default values.**.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the firewall was
                      created.
                    "droplet_ids": [
                        0  # Optional. An array containing the IDs of the Droplets assigned
                          to the firewall.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a firewall.
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "name": "str",  # Optional. A human-readable name for a firewall. The name
                      must begin with an alphanumeric character. Subsequent characters must either be
                      alphanumeric characters, a period (.), or a dash (-).
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ],
                    "pending_changes": [
                        {
                            "droplet_id": 0,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "removing": bool,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "status": "str"  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                        }
                    ],
                    "status": "str",  # Optional. A status string indicating the current state of
                      the firewall. This can be "waiting", "succeeded", or "failed". Known values are:
                      "waiting", "succeeded", and "failed".
                    "tags": {}  # Optional. Any object.
                }

                # response body for status code(s): 200
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Firewall.

        To update the configuration of an existing firewall, send a PUT request to
        ``/v2/firewalls/$FIREWALL_ID``. The request should contain a full representation
        of the firewall including existing attributes. **Note that any attributes that
        are not provided will be reset to their default values.**.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Firewall.

        To update the configuration of an existing firewall, send a PUT request to
        ``/v2/firewalls/$FIREWALL_ID``. The request should contain a full representation
        of the firewall including existing attributes. **Note that any attributes that
        are not provided will be reset to their default values.**.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the firewall was
                      created.
                    "droplet_ids": [
                        0  # Optional. An array containing the IDs of the Droplets assigned
                          to the firewall.
                    ],
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a firewall.
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "name": "str",  # Optional. A human-readable name for a firewall. The name
                      must begin with an alphanumeric character. Subsequent characters must either be
                      alphanumeric characters, a period (.), or a dash (-).
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ],
                    "pending_changes": [
                        {
                            "droplet_id": 0,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "removing": bool,  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                            "status": "str"  # Optional. An array of objects each
                              containing the fields "droplet_id", "removing", and "status". It is
                              provided to detail exactly which Droplets are having their security
                              policies updated. When empty, all changes have been successfully applied.
                        }
                    ],
                    "status": "str",  # Optional. A status string indicating the current state of
                      the firewall. This can be "waiting", "succeeded", or "failed". Known values are:
                      "waiting", "succeeded", and "failed".
                    "tags": {}  # Optional. Any object.
                }

                # response body for status code(s): 200
                response == {
                    "firewall": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the firewall
                          was created.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              assigned to the firewall.
                        ],
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a firewall.
                        "inbound_rules": [
                            {
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str",  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                                "sources": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                }
                            }
                        ],
                        "name": "str",  # Optional. A human-readable name for a firewall. The
                          name must begin with an alphanumeric character. Subsequent characters must
                          either be alphanumeric characters, a period (.), or a dash (-).
                        "outbound_rules": [
                            {
                                "destinations": {
                                    "addresses": [
                                        "str"  # Optional. An array of
                                          strings containing the IPv4 addresses, IPv6 addresses, IPv4
                                          CIDRs, and/or IPv6 CIDRs to which the firewall will allow
                                          traffic.
                                    ],
                                    "droplet_ids": [
                                        0  # Optional. An array containing
                                          the IDs of the Droplets to which the firewall will allow
                                          traffic.
                                    ],
                                    "kubernetes_ids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the Kubernetes clusters to which the
                                          firewall will allow traffic.
                                    ],
                                    "load_balancer_uids": [
                                        "str"  # Optional. An array
                                          containing the IDs of the load balancers to which the
                                          firewall will allow traffic.
                                    ],
                                    "tags": {}  # Optional. Any object.
                                },
                                "ports": "str",  # The ports on which traffic will be
                                  allowed specified as a string containing a single port, a range (e.g.
                                  "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                                  rules this parameter will always return "0". Required.
                                "protocol": "str"  # The type of traffic to be
                                  allowed. This may be one of ``tcp``"" , ``udp``"" , or ``icmp``.
                                  Required. Known values are: "tcp", "udp", and "icmp".
                            }
                        ],
                        "pending_changes": [
                            {
                                "droplet_id": 0,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "removing": bool,  # Optional. An array of objects
                                  each containing the fields "droplet_id", "removing", and "status". It
                                  is provided to detail exactly which Droplets are having their
                                  security policies updated. When empty, all changes have been
                                  successfully applied.
                                "status": "str"  # Optional. An array of objects each
                                  containing the fields "droplet_id", "removing", and "status". It is
                                  provided to detail exactly which Droplets are having their security
                                  policies updated. When empty, all changes have been successfully
                                  applied.
                            }
                        ],
                        "status": "str",  # Optional. A status string indicating the current
                          state of the firewall. This can be "waiting", "succeeded", or "failed". Known
                          values are: "waiting", "succeeded", and "failed".
                        "tags": {}  # Optional. Any object.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_update_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, firewall_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Firewall.

        To delete a firewall send a DELETE request to ``/v2/firewalls/$FIREWALL_ID``.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_firewalls_delete_request(
            firewall_id=firewall_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def assign_droplets(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Firewall.

        To assign a Droplet to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there
        should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets to be assigned to
                          the firewall. Required.
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def assign_droplets(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Firewall.

        To assign a Droplet to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there
        should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def assign_droplets(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Firewall.

        To assign a Droplet to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there
        should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets to be assigned to
                          the firewall. Required.
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_assign_droplets_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def delete_droplets(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Firewall.

        To remove a Droplet from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there should
        be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets to be removed from
                          the firewall. Required.
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def delete_droplets(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Firewall.

        To remove a Droplet from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there should
        be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def delete_droplets(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Firewall.

        To remove a Droplet from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/droplets``. In the body of the request, there should
        be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets to be removed from
                          the firewall. Required.
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_delete_droplets_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def add_tags(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Tags to a Firewall.

        To assign a tag representing a group of Droplets to a firewall, send a POST
        request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the request,
        there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tags": {}  # Any object. Required.
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_tags(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Tags to a Firewall.

        To assign a tag representing a group of Droplets to a firewall, send a POST
        request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the request,
        there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_tags(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Tags to a Firewall.

        To assign a tag representing a group of Droplets to a firewall, send a POST
        request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the request,
        there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tags": {}  # Any object. Required.
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_add_tags_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def delete_tags(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Tags from a Firewall.

        To remove a tag representing a group of Droplets from a firewall, send a
        DELETE request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the
        request, there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tags": {}  # Any object. Required.
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def delete_tags(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Tags from a Firewall.

        To remove a tag representing a group of Droplets from a firewall, send a
        DELETE request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the
        request, there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def delete_tags(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Tags from a Firewall.

        To remove a tag representing a group of Droplets from a firewall, send a
        DELETE request to ``/v2/firewalls/$FIREWALL_ID/tags``. In the body of the
        request, there should be a ``tags`` attribute containing a list of tag names.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tags": {}  # Any object. Required.
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_delete_tags_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def add_rules(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Rules to a Firewall.

        To add additional access rules to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        inbound_rules and/or outbound_rules attribute containing an array of rules to
        be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_rules(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Rules to a Firewall.

        To add additional access rules to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        inbound_rules and/or outbound_rules attribute containing an array of rules to
        be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_rules(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Rules to a Firewall.

        To add additional access rules to a firewall, send a POST request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        inbound_rules and/or outbound_rules attribute containing an array of rules to
        be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_add_rules_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def delete_rules(
        self,
        firewall_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Rules from a Firewall.

        To remove access rules from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        ``inbound_rules`` and/or ``outbound_rules`` attribute containing an array of rules
        to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def delete_rules(
        self,
        firewall_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Rules from a Firewall.

        To remove access rules from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        ``inbound_rules`` and/or ``outbound_rules`` attribute containing an array of rules
        to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def delete_rules(
        self,
        firewall_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Rules from a Firewall.

        To remove access rules from a firewall, send a DELETE request to
        ``/v2/firewalls/$FIREWALL_ID/rules``. The body of the request may include an
        ``inbound_rules`` and/or ``outbound_rules`` attribute containing an array of rules
        to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param firewall_id: A unique ID that can be used to identify and reference a firewall.
         Required.
        :type firewall_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "inbound_rules": [
                        {
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str",  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                            "sources": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            }
                        }
                    ],
                    "outbound_rules": [
                        {
                            "destinations": {
                                "addresses": [
                                    "str"  # Optional. An array of strings
                                      containing the IPv4 addresses, IPv6 addresses, IPv4 CIDRs, and/or
                                      IPv6 CIDRs to which the firewall will allow traffic.
                                ],
                                "droplet_ids": [
                                    0  # Optional. An array containing the IDs of
                                      the Droplets to which the firewall will allow traffic.
                                ],
                                "kubernetes_ids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the Kubernetes clusters to which the firewall will allow
                                      traffic.
                                ],
                                "load_balancer_uids": [
                                    "str"  # Optional. An array containing the
                                      IDs of the load balancers to which the firewall will allow
                                      traffic.
                                ],
                                "tags": {}  # Optional. Any object.
                            },
                            "ports": "str",  # The ports on which traffic will be allowed
                              specified as a string containing a single port, a range (e.g.
                              "8000-9000"), or "0" when all ports are open for a protocol. For ICMP
                              rules this parameter will always return "0". Required.
                            "protocol": "str"  # The type of traffic to be allowed. This
                              may be one of ``tcp``"" , ``udp``"" , or ``icmp``. Required. Known values
                              are: "tcp", "udp", and "icmp".
                        }
                    ]
                }

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_firewalls_delete_rules_request(
            firewall_id=firewall_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class FunctionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`functions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_namespaces(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Namespaces.

        Returns a list of namespaces associated with the current user. To get all namespaces, send a
        GET request to ``/v2/functions/namespaces``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "namespaces": [
                        {
                            "api_host": "str",  # Optional. The namespace's API hostname.
                              Each function in a namespace is provided an endpoint at the namespace's
                              hostname.
                            "created_at": "str",  # Optional. UTC time string.
                            "key": "str",  # Optional. A random alpha numeric string.
                              This key is used in conjunction with the namespace's UUID to authenticate
                              a user to use the namespace via ``doctl``"" , DigitalOcean's official
                              CLI.
                            "label": "str",  # Optional. The namespace's unique name.
                            "namespace": "str",  # Optional. A unique string format of
                              UUID with a prefix fn-.
                            "region": "str",  # Optional. The namespace's datacenter
                              region.
                            "updated_at": "str",  # Optional. UTC time string.
                            "uuid": "str"  # Optional. The namespace's Universally Unique
                              Identifier.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_functions_list_namespaces_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_namespace(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Namespace.

        Creates a new serverless functions namespace in the desired region and associates it with the
        provided label. A namespace is a collection of functions and their associated packages,
        triggers, and project specifications. To create a namespace, send a POST request to
        ``/v2/functions/namespaces`` with the ``region`` and ``label`` properties.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "label": "str",  # The namespace's unique name. Required.
                    "region": "str"  # The `datacenter region
                      <https://docs.digitalocean.com/products/platform/availability-matrix/#available-datacenters>`_
                      in which to create the namespace. Required.
                }

                # response body for status code(s): 200
                response == {
                    "namespace": {
                        "api_host": "str",  # Optional. The namespace's API hostname. Each
                          function in a namespace is provided an endpoint at the namespace's hostname.
                        "created_at": "str",  # Optional. UTC time string.
                        "key": "str",  # Optional. A random alpha numeric string. This key is
                          used in conjunction with the namespace's UUID to authenticate  a user to use
                          the namespace via ``doctl``"" , DigitalOcean's official CLI.
                        "label": "str",  # Optional. The namespace's unique name.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "region": "str",  # Optional. The namespace's datacenter region.
                        "updated_at": "str",  # Optional. UTC time string.
                        "uuid": "str"  # Optional. The namespace's Universally Unique
                          Identifier.
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_namespace(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Namespace.

        Creates a new serverless functions namespace in the desired region and associates it with the
        provided label. A namespace is a collection of functions and their associated packages,
        triggers, and project specifications. To create a namespace, send a POST request to
        ``/v2/functions/namespaces`` with the ``region`` and ``label`` properties.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "namespace": {
                        "api_host": "str",  # Optional. The namespace's API hostname. Each
                          function in a namespace is provided an endpoint at the namespace's hostname.
                        "created_at": "str",  # Optional. UTC time string.
                        "key": "str",  # Optional. A random alpha numeric string. This key is
                          used in conjunction with the namespace's UUID to authenticate  a user to use
                          the namespace via ``doctl``"" , DigitalOcean's official CLI.
                        "label": "str",  # Optional. The namespace's unique name.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "region": "str",  # Optional. The namespace's datacenter region.
                        "updated_at": "str",  # Optional. UTC time string.
                        "uuid": "str"  # Optional. The namespace's Universally Unique
                          Identifier.
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_namespace(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create Namespace.

        Creates a new serverless functions namespace in the desired region and associates it with the
        provided label. A namespace is a collection of functions and their associated packages,
        triggers, and project specifications. To create a namespace, send a POST request to
        ``/v2/functions/namespaces`` with the ``region`` and ``label`` properties.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "label": "str",  # The namespace's unique name. Required.
                    "region": "str"  # The `datacenter region
                      <https://docs.digitalocean.com/products/platform/availability-matrix/#available-datacenters>`_
                      in which to create the namespace. Required.
                }

                # response body for status code(s): 200
                response == {
                    "namespace": {
                        "api_host": "str",  # Optional. The namespace's API hostname. Each
                          function in a namespace is provided an endpoint at the namespace's hostname.
                        "created_at": "str",  # Optional. UTC time string.
                        "key": "str",  # Optional. A random alpha numeric string. This key is
                          used in conjunction with the namespace's UUID to authenticate  a user to use
                          the namespace via ``doctl``"" , DigitalOcean's official CLI.
                        "label": "str",  # Optional. The namespace's unique name.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "region": "str",  # Optional. The namespace's datacenter region.
                        "updated_at": "str",  # Optional. UTC time string.
                        "uuid": "str"  # Optional. The namespace's Universally Unique
                          Identifier.
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_functions_create_namespace_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404, 422]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 422:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_namespace(self, namespace_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Namespace.

        Gets the namespace details for the given namespace UUID. To get namespace details, send a GET
        request to ``/v2/functions/namespaces/$NAMESPACE_ID`` with no parameters.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "namespace": {
                        "api_host": "str",  # Optional. The namespace's API hostname. Each
                          function in a namespace is provided an endpoint at the namespace's hostname.
                        "created_at": "str",  # Optional. UTC time string.
                        "key": "str",  # Optional. A random alpha numeric string. This key is
                          used in conjunction with the namespace's UUID to authenticate  a user to use
                          the namespace via ``doctl``"" , DigitalOcean's official CLI.
                        "label": "str",  # Optional. The namespace's unique name.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "region": "str",  # Optional. The namespace's datacenter region.
                        "updated_at": "str",  # Optional. UTC time string.
                        "uuid": "str"  # Optional. The namespace's Universally Unique
                          Identifier.
                    }
                }
                # response body for status code(s): 403, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_functions_get_namespace_request(
            namespace_id=namespace_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 403, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 403:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_namespace(self, namespace_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Namespace.

        Deletes the given namespace.  When a namespace is deleted all assets, in the namespace are
        deleted, this includes packages, functions and triggers. Deleting a namespace is a destructive
        operation and assets in the namespace are not recoverable after deletion. Some metadata is
        retained, such as activations, or soft deleted for reporting purposes.
        To delete namespace, send a DELETE request to ``/v2/functions/namespaces/$NAMESPACE_ID``.
        A successful deletion returns a 204 response.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_functions_delete_namespace_request(
            namespace_id=namespace_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_triggers(self, namespace_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Triggers.

        Returns a list of triggers associated with the current user and namespace. To get all triggers,
        send a GET request to ``/v2/functions/namespaces/$NAMESPACE_ID/triggers``.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "triggers": [
                        {
                            "created_at": "str",  # Optional. UTC time string.
                            "function": "str",  # Optional. Name of function(action) that
                              exists in the given namespace.
                            "is_enabled": bool,  # Optional. Indicates weather the
                              trigger is paused or unpaused.
                            "name": "str",  # Optional. The trigger's unique name within
                              the namespace.
                            "namespace": "str",  # Optional. A unique string format of
                              UUID with a prefix fn-.
                            "scheduled_details": {
                                "cron": "str",  # valid cron expression string which
                                  is required for SCHEDULED type triggers. Required.
                                "body": {
                                    "name": "str"  # Optional. Optional data to
                                      be sent to function while triggering the function.
                                }
                            },
                            "scheduled_runs": {
                                "last_run_at": "str",  # Optional. Indicates last run
                                  time. null value indicates trigger not run yet.
                                "next_run_at": "str"  # Optional. Indicates next run
                                  time. null value indicates trigger will not run.
                            },
                            "type": "str",  # Optional. String which indicates the type
                              of trigger source like SCHEDULED.
                            "updated_at": "str"  # Optional. UTC time string.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_functions_list_triggers_request(
            namespace_id=namespace_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_trigger(
        self,
        namespace_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Trigger.

        Creates a new trigger for a given function in a namespace. To create a trigger, send a POST
        request to ``/v2/functions/namespaces/$NAMESPACE_ID/triggers`` with the ``name``\\ ,
        ``function``\\ , ``type``\\ , ``is_enabled`` and ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "function": "str",  # Name of function(action) that exists in the given
                      namespace. Required.
                    "is_enabled": bool,  # Indicates weather the trigger is paused or unpaused.
                      Required.
                    "name": "str",  # The trigger's unique name within the namespace. Required.
                    "scheduled_details": {
                        "cron": "str",  # valid cron expression string which is required for
                          SCHEDULED type triggers. Required.
                        "body": {
                            "name": "str"  # Optional. Optional data to be sent to
                              function while triggering the function.
                        }
                    },
                    "type": "str"  # One of different type of triggers. Currently only SCHEDULED
                      is supported. Required.
                }

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_trigger(
        self,
        namespace_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Trigger.

        Creates a new trigger for a given function in a namespace. To create a trigger, send a POST
        request to ``/v2/functions/namespaces/$NAMESPACE_ID/triggers`` with the ``name``\\ ,
        ``function``\\ , ``type``\\ , ``is_enabled`` and ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_trigger(
        self, namespace_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Trigger.

        Creates a new trigger for a given function in a namespace. To create a trigger, send a POST
        request to ``/v2/functions/namespaces/$NAMESPACE_ID/triggers`` with the ``name``\\ ,
        ``function``\\ , ``type``\\ , ``is_enabled`` and ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "function": "str",  # Name of function(action) that exists in the given
                      namespace. Required.
                    "is_enabled": bool,  # Indicates weather the trigger is paused or unpaused.
                      Required.
                    "name": "str",  # The trigger's unique name within the namespace. Required.
                    "scheduled_details": {
                        "cron": "str",  # valid cron expression string which is required for
                          SCHEDULED type triggers. Required.
                        "body": {
                            "name": "str"  # Optional. Optional data to be sent to
                              function while triggering the function.
                        }
                    },
                    "type": "str"  # One of different type of triggers. Currently only SCHEDULED
                      is supported. Required.
                }

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_functions_create_trigger_request(
            namespace_id=namespace_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404, 422]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 422:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_trigger(self, namespace_id: str, trigger_name: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Trigger.

        Gets the trigger details. To get the trigger details, send a GET request to
        ``/v2/functions/namespaces/$NAMESPACE_ID/triggers/$TRIGGER_NAME``.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param trigger_name: The name of the trigger to be managed. Required.
        :type trigger_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_functions_get_trigger_request(
            namespace_id=namespace_id,
            trigger_name=trigger_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_trigger(
        self,
        namespace_id: str,
        trigger_name: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Trigger.

        Updates the details of the given trigger. To update a trigger, send a PUT request to
        ``/v2/functions/namespaces/$NAMESPACE_ID/triggers/$TRIGGER_NAME`` with new values for the
        ``is_enabled`` or ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param trigger_name: The name of the trigger to be managed. Required.
        :type trigger_name: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "is_enabled": bool,  # Optional. Indicates weather the trigger is paused or
                      unpaused.
                    "scheduled_details": {
                        "cron": "str",  # valid cron expression string which is required for
                          SCHEDULED type triggers. Required.
                        "body": {
                            "name": "str"  # Optional. Optional data to be sent to
                              function while triggering the function.
                        }
                    }
                }

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_trigger(
        self,
        namespace_id: str,
        trigger_name: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Trigger.

        Updates the details of the given trigger. To update a trigger, send a PUT request to
        ``/v2/functions/namespaces/$NAMESPACE_ID/triggers/$TRIGGER_NAME`` with new values for the
        ``is_enabled`` or ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param trigger_name: The name of the trigger to be managed. Required.
        :type trigger_name: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_trigger(
        self,
        namespace_id: str,
        trigger_name: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Trigger.

        Updates the details of the given trigger. To update a trigger, send a PUT request to
        ``/v2/functions/namespaces/$NAMESPACE_ID/triggers/$TRIGGER_NAME`` with new values for the
        ``is_enabled`` or ``scheduled_details`` properties.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param trigger_name: The name of the trigger to be managed. Required.
        :type trigger_name: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "is_enabled": bool,  # Optional. Indicates weather the trigger is paused or
                      unpaused.
                    "scheduled_details": {
                        "cron": "str",  # valid cron expression string which is required for
                          SCHEDULED type triggers. Required.
                        "body": {
                            "name": "str"  # Optional. Optional data to be sent to
                              function while triggering the function.
                        }
                    }
                }

                # response body for status code(s): 200
                response == {
                    "trigger": {
                        "created_at": "str",  # Optional. UTC time string.
                        "function": "str",  # Optional. Name of function(action) that exists
                          in the given namespace.
                        "is_enabled": bool,  # Optional. Indicates weather the trigger is
                          paused or unpaused.
                        "name": "str",  # Optional. The trigger's unique name within the
                          namespace.
                        "namespace": "str",  # Optional. A unique string format of UUID with
                          a prefix fn-.
                        "scheduled_details": {
                            "cron": "str",  # valid cron expression string which is
                              required for SCHEDULED type triggers. Required.
                            "body": {
                                "name": "str"  # Optional. Optional data to be sent
                                  to function while triggering the function.
                            }
                        },
                        "scheduled_runs": {
                            "last_run_at": "str",  # Optional. Indicates last run time.
                              null value indicates trigger not run yet.
                            "next_run_at": "str"  # Optional. Indicates next run time.
                              null value indicates trigger will not run.
                        },
                        "type": "str",  # Optional. String which indicates the type of
                          trigger source like SCHEDULED.
                        "updated_at": "str"  # Optional. UTC time string.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_functions_update_trigger_request(
            namespace_id=namespace_id,
            trigger_name=trigger_name,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_trigger(
        self, namespace_id: str, trigger_name: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Trigger.

        Deletes the given trigger.
        To delete trigger, send a DELETE request to
        ``/v2/functions/namespaces/$NAMESPACE_ID/triggers/$TRIGGER_NAME``.
        A successful deletion returns a 204 response.

        :param namespace_id: The ID of the namespace to be managed. Required.
        :type namespace_id: str
        :param trigger_name: The name of the trigger to be managed. Required.
        :type trigger_name: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_functions_delete_trigger_request(
            namespace_id=namespace_id,
            trigger_name=trigger_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class ImagesOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`images` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        type: Optional[str] = None,
        private: Optional[bool] = None,
        tag_name: Optional[str] = None,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Images.

        To list all of the images available on your account, send a GET request to /v2/images.

        Filtering Results
        -----------------

        ----

        It's possible to request filtered results by including certain query parameters.

        **Image Type**

        Either 1-Click Application or OS Distribution images can be filtered by using the ``type``
        query parameter.

        ..

           Important: The ``type`` query parameter does not directly relate to the ``type`` attribute.


        To retrieve only **\\ *distribution*\\ ** images, include the ``type`` query parameter set to
        distribution, ``/v2/images?type=distribution``.

        To retrieve only **\\ *application*\\ ** images, include the ``type`` query parameter set to
        application, ``/v2/images?type=application``.

        **User Images**

        To retrieve only the private images of a user, include the ``private`` query parameter set to
        true, ``/v2/images?private=true``.

        **Tags**

        To list all images assigned to a specific tag, include the ``tag_name`` query parameter set to
        the name of the tag in your GET request. For example, ``/v2/images?tag_name=$TAG_NAME``.

        :keyword type: Filters results based on image type which can be either ``application`` or
         ``distribution``. Known values are: "application" and "distribution". Default value is None.
        :paramtype type: str
        :keyword private: Used to filter only user images. Default value is None.
        :paramtype private: bool
        :keyword tag_name: Used to filter images by a specific tag. Default value is None.
        :paramtype tag_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "images": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the image was created.
                            "description": "str",  # Optional. An optional free-form text
                              field to describe an image.
                            "distribution": "str",  # Optional. The name of a custom
                              image's distribution. Currently, the valid values are  ``Arch Linux``"" ,
                              ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                              Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" ,
                              ``RancherOS``"" , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.
                              Any other value will be accepted but ignored, and ``Unknown`` will be
                              used in its place. Known values are: "Arch Linux", "CentOS", "CoreOS",
                              "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo", "openSUSE",
                              "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                            "error_message": "str",  # Optional. A string containing
                              information about errors that may occur when importing  a custom image.
                            "id": 0,  # Optional. A unique number that can be used to
                              identify and reference a specific image.
                            "min_disk_size": 0,  # Optional. The minimum disk size in GB
                              required for a Droplet to use this image.
                            "name": "str",  # Optional. The display name that has been
                              given to an image.  This is what is shown in the control panel and is
                              generally a descriptive title for the image in question.
                            "public": bool,  # Optional. This is a boolean value that
                              indicates whether the image in question is public or not. An image that
                              is public is available to all accounts. A non-public image is only
                              accessible from your account.
                            "regions": [
                                "str"  # Optional. This attribute is an array of the
                                  regions that the image is available in. The regions are represented
                                  by their identifying slug values.
                            ],
                            "size_gigabytes": 0.0,  # Optional. The size of the image in
                              gigabytes.
                            "slug": "str",  # Optional. A uniquely identifying string
                              that is associated with each of the DigitalOcean-provided public images.
                              These can be used to reference a public image as an alternative to the
                              numeric id.
                            "status": "str",  # Optional. A status string indicating the
                              state of a custom image. This may be ``NEW``"" ,  ``available``"" ,
                              ``pending``"" , ``deleted``"" , or ``retired``. Known values are: "NEW",
                              "available", "pending", "deleted", and "retired".
                            "tags": [
                                "str"  # Optional. A flat array of tag names as
                                  strings to be applied to the resource. Tag names may be for either
                                  existing or new tags.
                            ],
                            "type": "str"  # Optional. Describes the kind of image. It
                              may be one of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" ,
                              or ``admin``. Respectively, this specifies whether an image is a
                              DigitalOcean base OS image, user-generated Droplet snapshot,
                              automatically created Droplet backup, user-provided virtual machine
                              image, or an image used for DigitalOcean managed resources (e.g. DOKS
                              worker nodes). Known values are: "base", "snapshot", "backup", "custom",
                              and "admin".
                        }
                    ],
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_images_list_request(
            type=type,
            private=private,
            tag_name=tag_name,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_custom(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Custom Image.

        To create a new custom image, send a POST request to /v2/images.
        The body must contain a url attribute pointing to a Linux virtual machine
        image to be imported into DigitalOcean.
        The image must be in the raw, qcow2, vhdx, vdi, or vmdk format.
        It may be compressed using gzip or bzip2 and must be smaller than 100 GB after
         being decompressed.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region": "str",  # The slug identifier for the region where the resource
                      will initially be  available. Required. Known values are: "ams1", "ams2", "ams3",
                      "blr1", "fra1", "lon1", "nyc1", "nyc2", "nyc3", "sfo1", "sfo2", "sfo3", "sgp1",
                      "tor1", and "syd1".
                    "url": "str",  # A URL from which the custom Linux virtual machine image may
                      be retrieved.  The image it points to must be in the raw, qcow2, vhdx, vdi, or
                      vmdk format.  It may be compressed using gzip or bzip2 and must be smaller than
                      100 GB after being decompressed. Required.
                    "description": "str",  # Optional. An optional free-form text field to
                      describe an image.
                    "distribution": "str",  # Optional. The name of a custom image's
                      distribution. Currently, the valid values are  ``Arch Linux``"" , ``CentOS``"" ,
                      ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora Atomic``"" ,  ``FreeBSD``""
                      , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" ,
                      ``Ubuntu``"" , and ``Unknown``.  Any other value will be accepted but ignored,
                      and ``Unknown`` will be used in its place. Known values are: "Arch Linux",
                      "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo",
                      "openSUSE", "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                    "name": "str",  # Optional. The display name that has been given to an image.
                      This is what is shown in the control panel and is generally a descriptive title
                      for the image in question.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to be applied
                          to the resource. Tag names may be for either existing or new tags.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
        """

    @overload
    def create_custom(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Custom Image.

        To create a new custom image, send a POST request to /v2/images.
        The body must contain a url attribute pointing to a Linux virtual machine
        image to be imported into DigitalOcean.
        The image must be in the raw, qcow2, vhdx, vdi, or vmdk format.
        It may be compressed using gzip or bzip2 and must be smaller than 100 GB after
         being decompressed.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
        """

    @distributed_trace
    def create_custom(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a Custom Image.

        To create a new custom image, send a POST request to /v2/images.
        The body must contain a url attribute pointing to a Linux virtual machine
        image to be imported into DigitalOcean.
        The image must be in the raw, qcow2, vhdx, vdi, or vmdk format.
        It may be compressed using gzip or bzip2 and must be smaller than 100 GB after
         being decompressed.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region": "str",  # The slug identifier for the region where the resource
                      will initially be  available. Required. Known values are: "ams1", "ams2", "ams3",
                      "blr1", "fra1", "lon1", "nyc1", "nyc2", "nyc3", "sfo1", "sfo2", "sfo3", "sgp1",
                      "tor1", and "syd1".
                    "url": "str",  # A URL from which the custom Linux virtual machine image may
                      be retrieved.  The image it points to must be in the raw, qcow2, vhdx, vdi, or
                      vmdk format.  It may be compressed using gzip or bzip2 and must be smaller than
                      100 GB after being decompressed. Required.
                    "description": "str",  # Optional. An optional free-form text field to
                      describe an image.
                    "distribution": "str",  # Optional. The name of a custom image's
                      distribution. Currently, the valid values are  ``Arch Linux``"" , ``CentOS``"" ,
                      ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora Atomic``"" ,  ``FreeBSD``""
                      , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" ,
                      ``Ubuntu``"" , and ``Unknown``.  Any other value will be accepted but ignored,
                      and ``Unknown`` will be used in its place. Known values are: "Arch Linux",
                      "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo",
                      "openSUSE", "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                    "name": "str",  # Optional. The display name that has been given to an image.
                      This is what is shown in the control panel and is generally a descriptive title
                      for the image in question.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to be applied
                          to the resource. Tag names may be for either existing or new tags.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_images_create_custom_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, image_id: JSON, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Image.

        To retrieve information about an image, send a ``GET`` request to
        ``/v2/images/$IDENTIFIER``.

        :param image_id: A unique number (id) or string (slug) used to identify and reference a
         specific image.

         **Public** images can be identified by image ``id`` or ``slug``.

         **Private** images *must* be identified by image ``id``. Required.
        :type image_id: JSON
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_images_get_request(
            image_id=image_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        image_id: int,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Image.

        To update an image, send a ``PUT`` request to ``/v2/images/$IMAGE_ID``.
        Set the ``name`` attribute to the new value you would like to use.
        For custom images, the ``description`` and ``distribution`` attributes may also be updated.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "description": "str",  # Optional. An optional free-form text field to
                      describe an image.
                    "distribution": "str",  # Optional. The name of a custom image's
                      distribution. Currently, the valid values are  ``Arch Linux``"" , ``CentOS``"" ,
                      ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora Atomic``"" ,  ``FreeBSD``""
                      , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" ,
                      ``Ubuntu``"" , and ``Unknown``.  Any other value will be accepted but ignored,
                      and ``Unknown`` will be used in its place. Known values are: "Arch Linux",
                      "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo",
                      "openSUSE", "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                    "name": "str"  # Optional. The display name that has been given to an image.
                      This is what is shown in the control panel and is generally a descriptive title
                      for the image in question.
                }

                # response body for status code(s): 200
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        image_id: int,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Image.

        To update an image, send a ``PUT`` request to ``/v2/images/$IMAGE_ID``.
        Set the ``name`` attribute to the new value you would like to use.
        For custom images, the ``description`` and ``distribution`` attributes may also be updated.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self, image_id: int, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Image.

        To update an image, send a ``PUT`` request to ``/v2/images/$IMAGE_ID``.
        Set the ``name`` attribute to the new value you would like to use.
        For custom images, the ``description`` and ``distribution`` attributes may also be updated.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "description": "str",  # Optional. An optional free-form text field to
                      describe an image.
                    "distribution": "str",  # Optional. The name of a custom image's
                      distribution. Currently, the valid values are  ``Arch Linux``"" , ``CentOS``"" ,
                      ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora Atomic``"" ,  ``FreeBSD``""
                      , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``"" , ``Rocky Linux``"" ,
                      ``Ubuntu``"" , and ``Unknown``.  Any other value will be accepted but ignored,
                      and ``Unknown`` will be used in its place. Known values are: "Arch Linux",
                      "CentOS", "CoreOS", "Debian", "Fedora", "Fedora Atomic", "FreeBSD", "Gentoo",
                      "openSUSE", "RancherOS", "Rocky Linux", "Ubuntu", and "Unknown".
                    "name": "str"  # Optional. The display name that has been given to an image.
                      This is what is shown in the control panel and is generally a descriptive title
                      for the image in question.
                }

                # response body for status code(s): 200
                response == {
                    "image": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the image was
                          created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe an image.
                        "distribution": "str",  # Optional. The name of a custom image's
                          distribution. Currently, the valid values are  ``Arch Linux``"" ,
                          ``CentOS``"" , ``CoreOS``"" , ``Debian``"" , ``Fedora``"" , ``Fedora
                          Atomic``"" ,  ``FreeBSD``"" , ``Gentoo``"" , ``openSUSE``"" , ``RancherOS``""
                          , ``Rocky Linux``"" , ``Ubuntu``"" , and ``Unknown``.  Any other value will
                          be accepted but ignored, and ``Unknown`` will be used in its place. Known
                          values are: "Arch Linux", "CentOS", "CoreOS", "Debian", "Fedora", "Fedora
                          Atomic", "FreeBSD", "Gentoo", "openSUSE", "RancherOS", "Rocky Linux",
                          "Ubuntu", and "Unknown".
                        "error_message": "str",  # Optional. A string containing information
                          about errors that may occur when importing  a custom image.
                        "id": 0,  # Optional. A unique number that can be used to identify
                          and reference a specific image.
                        "min_disk_size": 0,  # Optional. The minimum disk size in GB required
                          for a Droplet to use this image.
                        "name": "str",  # Optional. The display name that has been given to
                          an image.  This is what is shown in the control panel and is generally a
                          descriptive title for the image in question.
                        "public": bool,  # Optional. This is a boolean value that indicates
                          whether the image in question is public or not. An image that is public is
                          available to all accounts. A non-public image is only accessible from your
                          account.
                        "regions": [
                            "str"  # Optional. This attribute is an array of the regions
                              that the image is available in. The regions are represented by their
                              identifying slug values.
                        ],
                        "size_gigabytes": 0.0,  # Optional. The size of the image in
                          gigabytes.
                        "slug": "str",  # Optional. A uniquely identifying string that is
                          associated with each of the DigitalOcean-provided public images. These can be
                          used to reference a public image as an alternative to the numeric id.
                        "status": "str",  # Optional. A status string indicating the state of
                          a custom image. This may be ``NEW``"" ,  ``available``"" , ``pending``"" ,
                          ``deleted``"" , or ``retired``. Known values are: "NEW", "available",
                          "pending", "deleted", and "retired".
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ],
                        "type": "str"  # Optional. Describes the kind of image. It may be one
                          of ``base``"" , ``snapshot``"" , ``backup``"" , ``custom``"" , or ``admin``.
                          Respectively, this specifies whether an image is a DigitalOcean base OS
                          image, user-generated Droplet snapshot, automatically created Droplet backup,
                          user-provided virtual machine image, or an image used for DigitalOcean
                          managed resources (e.g. DOKS worker nodes). Known values are: "base",
                          "snapshot", "backup", "custom", and "admin".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_images_update_request(
            image_id=image_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, image_id: int, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an Image.

        To delete a snapshot or custom image, send a ``DELETE`` request to ``/v2/images/$IMAGE_ID``.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_images_delete_request(
            image_id=image_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class ImageActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`image_actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, image_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Actions for an Image.

        To retrieve all actions that have been executed on an image, send a GET request to
        ``/v2/images/$IMAGE_ID/actions``.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_image_actions_list_request(
            image_id=image_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def post(
        self,
        image_id: int,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate an Image Action.

        The following actions are available on an Image.

        Convert an Image to a Snapshot
        ------------------------------

        To convert an image, for example, a backup to a snapshot, send a POST request
        to ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``convert``.

        Transfer an Image
        -----------------

        To transfer an image to another region, send a POST request to
        ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``transfer`` and set
        ``region`` attribute to the slug identifier of the region you wish to transfer
        to.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      completed.
                    "id": 0,  # Optional. A unique numeric ID that can be used to identify and
                      reference an action.
                    "region": {
                        "available": bool,  # This is a boolean value that represents whether
                          new Droplets can be created in this region. Required.
                        "features": {},  # This attribute is set to an array which contains
                          features available in this region. Required.
                        "name": "str",  # The display name of the region.  This will be a
                          full name that is used in the control panel and other interfaces. Required.
                        "sizes": {},  # This attribute is set to an array which contains the
                          identifying slugs for the sizes available in this region. Required.
                        "slug": "str"  # A human-readable string that is used as a unique
                          identifier for each region. Required.
                    },
                    "region_slug": "str",  # Optional. A human-readable string that is used as a
                      unique identifier for each region.
                    "resource_id": 0,  # Optional. A unique identifier for the resource that the
                      action is associated with.
                    "resource_type": "str",  # Optional. The type of resource that the action is
                      associated with.
                    "started_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      initiated.
                    "status": "in-progress",  # Optional. Default value is "in-progress". The
                      current status of the action. This can be "in-progress", "completed", or
                      "errored". Known values are: "in-progress", "completed", and "errored".
                    "type": "str"  # Optional. This is the type of action that the object
                      represents. For example, this could be "transfer" to represent the state of an
                      image transfer action.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post(
        self,
        image_id: int,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate an Image Action.

        The following actions are available on an Image.

        Convert an Image to a Snapshot
        ------------------------------

        To convert an image, for example, a backup to a snapshot, send a POST request
        to ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``convert``.

        Transfer an Image
        -----------------

        To transfer an image to another region, send a POST request to
        ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``transfer`` and set
        ``region`` attribute to the slug identifier of the region you wish to transfer
        to.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      completed.
                    "id": 0,  # Optional. A unique numeric ID that can be used to identify and
                      reference an action.
                    "region": {
                        "available": bool,  # This is a boolean value that represents whether
                          new Droplets can be created in this region. Required.
                        "features": {},  # This attribute is set to an array which contains
                          features available in this region. Required.
                        "name": "str",  # The display name of the region.  This will be a
                          full name that is used in the control panel and other interfaces. Required.
                        "sizes": {},  # This attribute is set to an array which contains the
                          identifying slugs for the sizes available in this region. Required.
                        "slug": "str"  # A human-readable string that is used as a unique
                          identifier for each region. Required.
                    },
                    "region_slug": "str",  # Optional. A human-readable string that is used as a
                      unique identifier for each region.
                    "resource_id": 0,  # Optional. A unique identifier for the resource that the
                      action is associated with.
                    "resource_type": "str",  # Optional. The type of resource that the action is
                      associated with.
                    "started_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      initiated.
                    "status": "in-progress",  # Optional. Default value is "in-progress". The
                      current status of the action. This can be "in-progress", "completed", or
                      "errored". Known values are: "in-progress", "completed", and "errored".
                    "type": "str"  # Optional. This is the type of action that the object
                      represents. For example, this could be "transfer" to represent the state of an
                      image transfer action.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post(
        self,
        image_id: int,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate an Image Action.

        The following actions are available on an Image.

        Convert an Image to a Snapshot
        ------------------------------

        To convert an image, for example, a backup to a snapshot, send a POST request
        to ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``convert``.

        Transfer an Image
        -----------------

        To transfer an image to another region, send a POST request to
        ``/v2/images/$IMAGE_ID/actions``. Set the ``type`` attribute to ``transfer`` and set
        ``region`` attribute to the slug identifier of the region you wish to transfer
        to.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      completed.
                    "id": 0,  # Optional. A unique numeric ID that can be used to identify and
                      reference an action.
                    "region": {
                        "available": bool,  # This is a boolean value that represents whether
                          new Droplets can be created in this region. Required.
                        "features": {},  # This attribute is set to an array which contains
                          features available in this region. Required.
                        "name": "str",  # The display name of the region.  This will be a
                          full name that is used in the control panel and other interfaces. Required.
                        "sizes": {},  # This attribute is set to an array which contains the
                          identifying slugs for the sizes available in this region. Required.
                        "slug": "str"  # A human-readable string that is used as a unique
                          identifier for each region. Required.
                    },
                    "region_slug": "str",  # Optional. A human-readable string that is used as a
                      unique identifier for each region.
                    "resource_id": 0,  # Optional. A unique identifier for the resource that the
                      action is associated with.
                    "resource_type": "str",  # Optional. The type of resource that the action is
                      associated with.
                    "started_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      initiated.
                    "status": "in-progress",  # Optional. Default value is "in-progress". The
                      current status of the action. This can be "in-progress", "completed", or
                      "errored". Known values are: "in-progress", "completed", and "errored".
                    "type": "str"  # Optional. This is the type of action that the object
                      represents. For example, this could be "transfer" to represent the state of an
                      image transfer action.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_image_actions_post_request(
            image_id=image_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, image_id: int, action_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Action.

        To retrieve the status of an image action, send a GET request to
        ``/v2/images/$IMAGE_ID/actions/$IMAGE_ACTION_ID``.

        :param image_id: A unique number that can be used to identify and reference a specific image.
         Required.
        :type image_id: int
        :param action_id: A unique numeric ID that can be used to identify and reference an action.
         Required.
        :type action_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      completed.
                    "id": 0,  # Optional. A unique numeric ID that can be used to identify and
                      reference an action.
                    "region": {
                        "available": bool,  # This is a boolean value that represents whether
                          new Droplets can be created in this region. Required.
                        "features": {},  # This attribute is set to an array which contains
                          features available in this region. Required.
                        "name": "str",  # The display name of the region.  This will be a
                          full name that is used in the control panel and other interfaces. Required.
                        "sizes": {},  # This attribute is set to an array which contains the
                          identifying slugs for the sizes available in this region. Required.
                        "slug": "str"  # A human-readable string that is used as a unique
                          identifier for each region. Required.
                    },
                    "region_slug": "str",  # Optional. A human-readable string that is used as a
                      unique identifier for each region.
                    "resource_id": 0,  # Optional. A unique identifier for the resource that the
                      action is associated with.
                    "resource_type": "str",  # Optional. The type of resource that the action is
                      associated with.
                    "started_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the action was
                      initiated.
                    "status": "in-progress",  # Optional. Default value is "in-progress". The
                      current status of the action. This can be "in-progress", "completed", or
                      "errored". Known values are: "in-progress", "completed", and "errored".
                    "type": "str"  # Optional. This is the type of action that the object
                      represents. For example, this could be "transfer" to represent the state of an
                      image transfer action.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_image_actions_get_request(
            image_id=image_id,
            action_id=action_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class KubernetesOperations:  # pylint: disable=too-many-public-methods
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`kubernetes` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_clusters(
        self, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Kubernetes Clusters.

        To list all of the Kubernetes clusters on your account, send a GET request
        to ``/v2/kubernetes/clusters``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "kubernetes_clusters": [
                        {
                            "name": "str",  # A human-readable name for a Kubernetes
                              cluster. Required.
                            "node_pools": [
                                {
                                    "auto_scale": bool,  # Optional. A boolean
                                      value indicating whether auto-scaling is enabled for this node
                                      pool.
                                    "count": 0,  # Optional. The number of
                                      Droplet instances in the node pool.
                                    "id": "str",  # Optional. A unique ID that
                                      can be used to identify and reference a specific node pool.
                                    "labels": {},  # Optional. An object of
                                      key/value mappings specifying labels to apply to all nodes in a
                                      pool. Labels will automatically be applied to all existing nodes
                                      and any subsequent nodes added to the pool. Note that when a
                                      label is removed, it is not deleted from the nodes in the pool.
                                    "max_nodes": 0,  # Optional. The maximum
                                      number of nodes that this node pool can be auto-scaled to. The
                                      value will be ``0`` if ``auto_scale`` is set to ``false``.
                                    "min_nodes": 0,  # Optional. The minimum
                                      number of nodes that this node pool can be auto-scaled to. The
                                      value will be ``0`` if ``auto_scale`` is set to ``false``.
                                    "name": "str",  # Optional. A human-readable
                                      name for the node pool.
                                    "nodes": [
                                        {
                                            "created_at": "2020-02-20
                                              00:00:00",  # Optional. A time value given in ISO8601
                                              combined date and time format that represents when the
                                              node was created.
                                            "droplet_id": "str",  #
                                              Optional. The ID of the Droplet used for the worker node.
                                            "id": "str",  # Optional. A
                                              unique ID that can be used to identify and reference the
                                              node.
                                            "name": "str",  # Optional.
                                              An automatically generated, human-readable name for the
                                              node.
                                            "status": {
                                                "state": "str"  #
                                                  Optional. A string indicating the current status of
                                                  the node. Known values are: "provisioning",
                                                  "running", "draining", and "deleting".
                                            },
                                            "updated_at": "2020-02-20
                                              00:00:00"  # Optional. A time value given in ISO8601
                                              combined date and time format that represents when the
                                              node was last updated.
                                        }
                                    ],
                                    "size": "str",  # Optional. The slug
                                      identifier for the type of Droplet used as workers in the node
                                      pool.
                                    "tags": [
                                        "str"  # Optional. An array
                                          containing the tags applied to the node pool. All node pools
                                          are automatically tagged ``k8s``"" , ``k8s-worker``"" , and
                                          ``k8s:$K8S_CLUSTER_ID``.
                                    ],
                                    "taints": [
                                        {
                                            "effect": "str",  # Optional.
                                              How the node reacts to pods that it won't tolerate.
                                              Available effect values are ``NoSchedule``"" ,
                                              ``PreferNoSchedule``"" , and ``NoExecute``. Known values
                                              are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                            "key": "str",  # Optional. An
                                              arbitrary string. The ``key`` and ``value`` fields of the
                                              ``taint`` object form a key-value pair. For example, if
                                              the value of the ``key`` field is "special" and the value
                                              of the ``value`` field is "gpu", the key value pair would
                                              be ``special=gpu``.
                                            "value": "str"  # Optional.
                                              An arbitrary string. The ``key`` and ``value`` fields of
                                              the ``taint`` object form a key-value pair. For example,
                                              if the value of the ``key`` field is "special" and the
                                              value of the ``value`` field is "gpu", the key value pair
                                              would be ``special=gpu``.
                                        }
                                    ]
                                }
                            ],
                            "region": "str",  # The slug identifier for the region where
                              the Kubernetes cluster is located. Required.
                            "version": "str",  # The slug identifier for the version of
                              Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"),
                              the latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                              "latest", the latest published version will be used. See the
                              ``/v2/kubernetes/options`` endpoint to find all currently available
                              versions. Required.
                            "auto_upgrade": False,  # Optional. Default value is False. A
                              boolean value indicating whether the cluster will be automatically
                              upgraded to new patch releases during its maintenance window.
                            "cluster_autoscaler_configuration": {
                                "scale_down_unneeded_time": "str",  # Optional. Used
                                  to customize how long a node is unneeded before being scaled down.
                                "scale_down_utilization_threshold": 0.0  # Optional.
                                  Used to customize when cluster autoscaler scales down non-empty nodes
                                  by setting the node utilization threshold.
                            },
                            "cluster_subnet": "str",  # Optional. The range of IP
                              addresses for the overlay network of the Kubernetes cluster in CIDR
                              notation.
                            "control_plane_firewall": {
                                "allowed_addresses": [
                                    "str"  # Optional. An array of public
                                      addresses (IPv4 or CIDR) allowed to access the control plane.
                                ],
                                "enabled": bool  # Optional. Indicates whether the
                                  control plane firewall is enabled.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the Kubernetes cluster was created.
                            "endpoint": "str",  # Optional. The base URL of the API
                              server on the Kubernetes master node.
                            "ha": False,  # Optional. Default value is False. A boolean
                              value indicating whether the control plane is run in a highly available
                              configuration in the cluster. Highly available control planes incur less
                              downtime. The property cannot be disabled.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a Kubernetes cluster.
                            "ipv4": "str",  # Optional. The public IPv4 address of the
                              Kubernetes master node. This will not be set if high availability is
                              configured on the cluster (v1.21+).
                            "maintenance_policy": {
                                "day": "str",  # Optional. The day of the maintenance
                                  window policy. May be one of ``monday`` through ``sunday``"" , or
                                  ``any`` to indicate an arbitrary week day. Known values are: "any",
                                  "monday", "tuesday", "wednesday", "thursday", "friday", "saturday",
                                  and "sunday".
                                "duration": "str",  # Optional. The duration of the
                                  maintenance window policy in human-readable format.
                                "start_time": "str"  # Optional. The start time in
                                  UTC of the maintenance window policy in 24-hour clock format / HH:MM
                                  notation (e.g., ``15:00``"" ).
                            },
                            "registry_enabled": bool,  # Optional. A read-only boolean
                              value indicating if a container registry is integrated with the cluster.
                            "routing_agent": {
                                "enabled": bool  # Optional. Indicates whether the
                                  routing-agent component is enabled.
                            },
                            "service_subnet": "str",  # Optional. The range of assignable
                              IP addresses for services running in the Kubernetes cluster in CIDR
                              notation.
                            "status": {
                                "message": "str",  # Optional. An optional message
                                  providing additional information about the current cluster state.
                                "state": "str"  # Optional. A string indicating the
                                  current status of the cluster. Known values are: "running",
                                  "provisioning", "degraded", "error", "deleted", "upgrading", and
                                  "deleting".
                            },
                            "surge_upgrade": False,  # Optional. Default value is False.
                              A boolean value indicating whether surge upgrade is enabled/disabled for
                              the cluster. Surge upgrade makes cluster upgrades fast and reliable by
                              bringing up new nodes before destroying the outdated nodes.
                            "tags": [
                                "str"  # Optional. An array of tags applied to the
                                  Kubernetes cluster. All clusters are automatically tagged ``k8s`` and
                                  ``k8s:$K8S_CLUSTER_ID``.
                            ],
                            "updated_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the Kubernetes cluster was last updated.
                            "vpc_uuid": "str"  # Optional. A string specifying the UUID
                              of the VPC to which the Kubernetes cluster is assigned.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_list_clusters_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_cluster(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Kubernetes Cluster.

        To create a new Kubernetes cluster, send a POST request to
        ``/v2/kubernetes/clusters``. The request must contain at least one node pool
        with at least one worker.

        The request may contain a maintenance window policy describing a time period
        when disruptive maintenance tasks may be carried out. Omitting the policy
        implies that a window will be chosen automatically. See
        `here <https://docs.digitalocean.com/products/kubernetes/how-to/upgrade-cluster/>`_
        for details.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for a Kubernetes cluster. Required.
                    "node_pools": [
                        {
                            "auto_scale": bool,  # Optional. A boolean value indicating
                              whether auto-scaling is enabled for this node pool.
                            "count": 0,  # Optional. The number of Droplet instances in
                              the node pool.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a specific node pool.
                            "labels": {},  # Optional. An object of key/value mappings
                              specifying labels to apply to all nodes in a pool. Labels will
                              automatically be applied to all existing nodes and any subsequent nodes
                              added to the pool. Note that when a label is removed, it is not deleted
                              from the nodes in the pool.
                            "max_nodes": 0,  # Optional. The maximum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "min_nodes": 0,  # Optional. The minimum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "name": "str",  # Optional. A human-readable name for the
                              node pool.
                            "nodes": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was created.
                                    "droplet_id": "str",  # Optional. The ID of
                                      the Droplet used for the worker node.
                                    "id": "str",  # Optional. A unique ID that
                                      can be used to identify and reference the node.
                                    "name": "str",  # Optional. An automatically
                                      generated, human-readable name for the node.
                                    "status": {
                                        "state": "str"  # Optional. A string
                                          indicating the current status of the node. Known values are:
                                          "provisioning", "running", "draining", and "deleting".
                                    },
                                    "updated_at": "2020-02-20 00:00:00"  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was last updated.
                                }
                            ],
                            "size": "str",  # Optional. The slug identifier for the type
                              of Droplet used as workers in the node pool.
                            "tags": [
                                "str"  # Optional. An array containing the tags
                                  applied to the node pool. All node pools are automatically tagged
                                  ``k8s``"" , ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                            ],
                            "taints": [
                                {
                                    "effect": "str",  # Optional. How the node
                                      reacts to pods that it won't tolerate. Available effect values
                                      are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                      ``NoExecute``. Known values are: "NoSchedule",
                                      "PreferNoSchedule", and "NoExecute".
                                    "key": "str",  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                    "value": "str"  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                }
                            ]
                        }
                    ],
                    "region": "str",  # The slug identifier for the region where the Kubernetes
                      cluster is located. Required.
                    "version": "str",  # The slug identifier for the version of Kubernetes used
                      for the cluster. If set to a minor version (e.g. "1.14"), the latest version
                      within it will be used (e.g. "1.14.6-do.1"); if set to "latest", the latest
                      published version will be used. See the ``/v2/kubernetes/options`` endpoint to
                      find all currently available versions. Required.
                    "auto_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether the cluster will be automatically upgraded to new patch
                      releases during its maintenance window.
                    "cluster_autoscaler_configuration": {
                        "scale_down_unneeded_time": "str",  # Optional. Used to customize how
                          long a node is unneeded before being scaled down.
                        "scale_down_utilization_threshold": 0.0  # Optional. Used to
                          customize when cluster autoscaler scales down non-empty nodes by setting the
                          node utilization threshold.
                    },
                    "cluster_subnet": "str",  # Optional. The range of IP addresses for the
                      overlay network of the Kubernetes cluster in CIDR notation.
                    "control_plane_firewall": {
                        "allowed_addresses": [
                            "str"  # Optional. An array of public addresses (IPv4 or
                              CIDR) allowed to access the control plane.
                        ],
                        "enabled": bool  # Optional. Indicates whether the control plane
                          firewall is enabled.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the Kubernetes cluster
                      was created.
                    "endpoint": "str",  # Optional. The base URL of the API server on the
                      Kubernetes master node.
                    "ha": False,  # Optional. Default value is False. A boolean value indicating
                      whether the control plane is run in a highly available configuration in the
                      cluster. Highly available control planes incur less downtime. The property cannot
                      be disabled.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a Kubernetes cluster.
                    "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes master
                      node. This will not be set if high availability is configured on the cluster
                      (v1.21+).
                    "maintenance_policy": {
                        "day": "str",  # Optional. The day of the maintenance window policy.
                          May be one of ``monday`` through ``sunday``"" , or ``any`` to indicate an
                          arbitrary week day. Known values are: "any", "monday", "tuesday",
                          "wednesday", "thursday", "friday", "saturday", and "sunday".
                        "duration": "str",  # Optional. The duration of the maintenance
                          window policy in human-readable format.
                        "start_time": "str"  # Optional. The start time in UTC of the
                          maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                          ``15:00``"" ).
                    },
                    "registry_enabled": bool,  # Optional. A read-only boolean value indicating
                      if a container registry is integrated with the cluster.
                    "routing_agent": {
                        "enabled": bool  # Optional. Indicates whether the routing-agent
                          component is enabled.
                    },
                    "service_subnet": "str",  # Optional. The range of assignable IP addresses
                      for services running in the Kubernetes cluster in CIDR notation.
                    "status": {
                        "message": "str",  # Optional. An optional message providing
                          additional information about the current cluster state.
                        "state": "str"  # Optional. A string indicating the current status of
                          the cluster. Known values are: "running", "provisioning", "degraded",
                          "error", "deleted", "upgrading", and "deleting".
                    },
                    "surge_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether surge upgrade is enabled/disabled for the cluster. Surge
                      upgrade makes cluster upgrades fast and reliable by bringing up new nodes before
                      destroying the outdated nodes.
                    "tags": [
                        "str"  # Optional. An array of tags applied to the Kubernetes
                          cluster. All clusters are automatically tagged ``k8s`` and
                          ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the Kubernetes cluster
                      was last updated.
                    "vpc_uuid": "str"  # Optional. A string specifying the UUID of the VPC to
                      which the Kubernetes cluster is assigned.
                }

                # response body for status code(s): 201
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
        """

    @overload
    def create_cluster(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Kubernetes Cluster.

        To create a new Kubernetes cluster, send a POST request to
        ``/v2/kubernetes/clusters``. The request must contain at least one node pool
        with at least one worker.

        The request may contain a maintenance window policy describing a time period
        when disruptive maintenance tasks may be carried out. Omitting the policy
        implies that a window will be chosen automatically. See
        `here <https://docs.digitalocean.com/products/kubernetes/how-to/upgrade-cluster/>`_
        for details.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
        """

    @distributed_trace
    def create_cluster(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Kubernetes Cluster.

        To create a new Kubernetes cluster, send a POST request to
        ``/v2/kubernetes/clusters``. The request must contain at least one node pool
        with at least one worker.

        The request may contain a maintenance window policy describing a time period
        when disruptive maintenance tasks may be carried out. Omitting the policy
        implies that a window will be chosen automatically. See
        `here <https://docs.digitalocean.com/products/kubernetes/how-to/upgrade-cluster/>`_
        for details.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for a Kubernetes cluster. Required.
                    "node_pools": [
                        {
                            "auto_scale": bool,  # Optional. A boolean value indicating
                              whether auto-scaling is enabled for this node pool.
                            "count": 0,  # Optional. The number of Droplet instances in
                              the node pool.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a specific node pool.
                            "labels": {},  # Optional. An object of key/value mappings
                              specifying labels to apply to all nodes in a pool. Labels will
                              automatically be applied to all existing nodes and any subsequent nodes
                              added to the pool. Note that when a label is removed, it is not deleted
                              from the nodes in the pool.
                            "max_nodes": 0,  # Optional. The maximum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "min_nodes": 0,  # Optional. The minimum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "name": "str",  # Optional. A human-readable name for the
                              node pool.
                            "nodes": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was created.
                                    "droplet_id": "str",  # Optional. The ID of
                                      the Droplet used for the worker node.
                                    "id": "str",  # Optional. A unique ID that
                                      can be used to identify and reference the node.
                                    "name": "str",  # Optional. An automatically
                                      generated, human-readable name for the node.
                                    "status": {
                                        "state": "str"  # Optional. A string
                                          indicating the current status of the node. Known values are:
                                          "provisioning", "running", "draining", and "deleting".
                                    },
                                    "updated_at": "2020-02-20 00:00:00"  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was last updated.
                                }
                            ],
                            "size": "str",  # Optional. The slug identifier for the type
                              of Droplet used as workers in the node pool.
                            "tags": [
                                "str"  # Optional. An array containing the tags
                                  applied to the node pool. All node pools are automatically tagged
                                  ``k8s``"" , ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                            ],
                            "taints": [
                                {
                                    "effect": "str",  # Optional. How the node
                                      reacts to pods that it won't tolerate. Available effect values
                                      are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                      ``NoExecute``. Known values are: "NoSchedule",
                                      "PreferNoSchedule", and "NoExecute".
                                    "key": "str",  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                    "value": "str"  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                }
                            ]
                        }
                    ],
                    "region": "str",  # The slug identifier for the region where the Kubernetes
                      cluster is located. Required.
                    "version": "str",  # The slug identifier for the version of Kubernetes used
                      for the cluster. If set to a minor version (e.g. "1.14"), the latest version
                      within it will be used (e.g. "1.14.6-do.1"); if set to "latest", the latest
                      published version will be used. See the ``/v2/kubernetes/options`` endpoint to
                      find all currently available versions. Required.
                    "auto_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether the cluster will be automatically upgraded to new patch
                      releases during its maintenance window.
                    "cluster_autoscaler_configuration": {
                        "scale_down_unneeded_time": "str",  # Optional. Used to customize how
                          long a node is unneeded before being scaled down.
                        "scale_down_utilization_threshold": 0.0  # Optional. Used to
                          customize when cluster autoscaler scales down non-empty nodes by setting the
                          node utilization threshold.
                    },
                    "cluster_subnet": "str",  # Optional. The range of IP addresses for the
                      overlay network of the Kubernetes cluster in CIDR notation.
                    "control_plane_firewall": {
                        "allowed_addresses": [
                            "str"  # Optional. An array of public addresses (IPv4 or
                              CIDR) allowed to access the control plane.
                        ],
                        "enabled": bool  # Optional. Indicates whether the control plane
                          firewall is enabled.
                    },
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the Kubernetes cluster
                      was created.
                    "endpoint": "str",  # Optional. The base URL of the API server on the
                      Kubernetes master node.
                    "ha": False,  # Optional. Default value is False. A boolean value indicating
                      whether the control plane is run in a highly available configuration in the
                      cluster. Highly available control planes incur less downtime. The property cannot
                      be disabled.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a Kubernetes cluster.
                    "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes master
                      node. This will not be set if high availability is configured on the cluster
                      (v1.21+).
                    "maintenance_policy": {
                        "day": "str",  # Optional. The day of the maintenance window policy.
                          May be one of ``monday`` through ``sunday``"" , or ``any`` to indicate an
                          arbitrary week day. Known values are: "any", "monday", "tuesday",
                          "wednesday", "thursday", "friday", "saturday", and "sunday".
                        "duration": "str",  # Optional. The duration of the maintenance
                          window policy in human-readable format.
                        "start_time": "str"  # Optional. The start time in UTC of the
                          maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                          ``15:00``"" ).
                    },
                    "registry_enabled": bool,  # Optional. A read-only boolean value indicating
                      if a container registry is integrated with the cluster.
                    "routing_agent": {
                        "enabled": bool  # Optional. Indicates whether the routing-agent
                          component is enabled.
                    },
                    "service_subnet": "str",  # Optional. The range of assignable IP addresses
                      for services running in the Kubernetes cluster in CIDR notation.
                    "status": {
                        "message": "str",  # Optional. An optional message providing
                          additional information about the current cluster state.
                        "state": "str"  # Optional. A string indicating the current status of
                          the cluster. Known values are: "running", "provisioning", "degraded",
                          "error", "deleted", "upgrading", and "deleting".
                    },
                    "surge_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether surge upgrade is enabled/disabled for the cluster. Surge
                      upgrade makes cluster upgrades fast and reliable by bringing up new nodes before
                      destroying the outdated nodes.
                    "tags": [
                        "str"  # Optional. An array of tags applied to the Kubernetes
                          cluster. All clusters are automatically tagged ``k8s`` and
                          ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the Kubernetes cluster
                      was last updated.
                    "vpc_uuid": "str"  # Optional. A string specifying the UUID of the VPC to
                      which the Kubernetes cluster is assigned.
                }

                # response body for status code(s): 201
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_create_cluster_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_cluster(self, cluster_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Kubernetes Cluster.

        To show information about an existing Kubernetes cluster, send a GET request
        to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_cluster_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_cluster(
        self,
        cluster_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Kubernetes Cluster.

        To update a Kubernetes cluster, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID`` and specify one or more of the
        attributes below.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for a Kubernetes cluster. Required.
                    "auto_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether the cluster will be automatically upgraded to new patch
                      releases during its maintenance window.
                    "cluster_autoscaler_configuration": {
                        "scale_down_unneeded_time": "str",  # Optional. Used to customize how
                          long a node is unneeded before being scaled down.
                        "scale_down_utilization_threshold": 0.0  # Optional. Used to
                          customize when cluster autoscaler scales down non-empty nodes by setting the
                          node utilization threshold.
                    },
                    "control_plane_firewall": {
                        "allowed_addresses": [
                            "str"  # Optional. An array of public addresses (IPv4 or
                              CIDR) allowed to access the control plane.
                        ],
                        "enabled": bool  # Optional. Indicates whether the control plane
                          firewall is enabled.
                    },
                    "ha": False,  # Optional. Default value is False. A boolean value indicating
                      whether the control plane is run in a highly available configuration in the
                      cluster. Highly available control planes incur less downtime. The property cannot
                      be disabled.
                    "maintenance_policy": {
                        "day": "str",  # Optional. The day of the maintenance window policy.
                          May be one of ``monday`` through ``sunday``"" , or ``any`` to indicate an
                          arbitrary week day. Known values are: "any", "monday", "tuesday",
                          "wednesday", "thursday", "friday", "saturday", and "sunday".
                        "duration": "str",  # Optional. The duration of the maintenance
                          window policy in human-readable format.
                        "start_time": "str"  # Optional. The start time in UTC of the
                          maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                          ``15:00``"" ).
                    },
                    "routing_agent": {
                        "enabled": bool  # Optional. Indicates whether the routing-agent
                          component is enabled.
                    },
                    "surge_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether surge upgrade is enabled/disabled for the cluster. Surge
                      upgrade makes cluster upgrades fast and reliable by bringing up new nodes before
                      destroying the outdated nodes.
                    "tags": [
                        "str"  # Optional. An array of tags applied to the Kubernetes
                          cluster. All clusters are automatically tagged ``k8s`` and
                          ``k8s:$K8S_CLUSTER_ID``.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_cluster(
        self,
        cluster_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Kubernetes Cluster.

        To update a Kubernetes cluster, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID`` and specify one or more of the
        attributes below.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_cluster(
        self, cluster_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Kubernetes Cluster.

        To update a Kubernetes cluster, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID`` and specify one or more of the
        attributes below.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for a Kubernetes cluster. Required.
                    "auto_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether the cluster will be automatically upgraded to new patch
                      releases during its maintenance window.
                    "cluster_autoscaler_configuration": {
                        "scale_down_unneeded_time": "str",  # Optional. Used to customize how
                          long a node is unneeded before being scaled down.
                        "scale_down_utilization_threshold": 0.0  # Optional. Used to
                          customize when cluster autoscaler scales down non-empty nodes by setting the
                          node utilization threshold.
                    },
                    "control_plane_firewall": {
                        "allowed_addresses": [
                            "str"  # Optional. An array of public addresses (IPv4 or
                              CIDR) allowed to access the control plane.
                        ],
                        "enabled": bool  # Optional. Indicates whether the control plane
                          firewall is enabled.
                    },
                    "ha": False,  # Optional. Default value is False. A boolean value indicating
                      whether the control plane is run in a highly available configuration in the
                      cluster. Highly available control planes incur less downtime. The property cannot
                      be disabled.
                    "maintenance_policy": {
                        "day": "str",  # Optional. The day of the maintenance window policy.
                          May be one of ``monday`` through ``sunday``"" , or ``any`` to indicate an
                          arbitrary week day. Known values are: "any", "monday", "tuesday",
                          "wednesday", "thursday", "friday", "saturday", and "sunday".
                        "duration": "str",  # Optional. The duration of the maintenance
                          window policy in human-readable format.
                        "start_time": "str"  # Optional. The start time in UTC of the
                          maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                          ``15:00``"" ).
                    },
                    "routing_agent": {
                        "enabled": bool  # Optional. Indicates whether the routing-agent
                          component is enabled.
                    },
                    "surge_upgrade": False,  # Optional. Default value is False. A boolean value
                      indicating whether surge upgrade is enabled/disabled for the cluster. Surge
                      upgrade makes cluster upgrades fast and reliable by bringing up new nodes before
                      destroying the outdated nodes.
                    "tags": [
                        "str"  # Optional. An array of tags applied to the Kubernetes
                          cluster. All clusters are automatically tagged ``k8s`` and
                          ``k8s:$K8S_CLUSTER_ID``.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "kubernetes_cluster": {
                        "name": "str",  # A human-readable name for a Kubernetes cluster.
                          Required.
                        "node_pools": [
                            {
                                "auto_scale": bool,  # Optional. A boolean value
                                  indicating whether auto-scaling is enabled for this node pool.
                                "count": 0,  # Optional. The number of Droplet
                                  instances in the node pool.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference a specific node pool.
                                "labels": {},  # Optional. An object of key/value
                                  mappings specifying labels to apply to all nodes in a pool. Labels
                                  will automatically be applied to all existing nodes and any
                                  subsequent nodes added to the pool. Note that when a label is
                                  removed, it is not deleted from the nodes in the pool.
                                "max_nodes": 0,  # Optional. The maximum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "min_nodes": 0,  # Optional. The minimum number of
                                  nodes that this node pool can be auto-scaled to. The value will be
                                  ``0`` if ``auto_scale`` is set to ``false``.
                                "name": "str",  # Optional. A human-readable name for
                                  the node pool.
                                "nodes": [
                                    {
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was created.
                                        "droplet_id": "str",  # Optional. The
                                          ID of the Droplet used for the worker node.
                                        "id": "str",  # Optional. A unique ID
                                          that can be used to identify and reference the node.
                                        "name": "str",  # Optional. An
                                          automatically generated, human-readable name for the node.
                                        "status": {
                                            "state": "str"  # Optional. A
                                              string indicating the current status of the node. Known
                                              values are: "provisioning", "running", "draining", and
                                              "deleting".
                                        },
                                        "updated_at": "2020-02-20 00:00:00"
                                          # Optional. A time value given in ISO8601 combined date and
                                          time format that represents when the node was last updated.
                                    }
                                ],
                                "size": "str",  # Optional. The slug identifier for
                                  the type of Droplet used as workers in the node pool.
                                "tags": [
                                    "str"  # Optional. An array containing the
                                      tags applied to the node pool. All node pools are automatically
                                      tagged ``k8s``"" , ``k8s-worker``"" , and
                                      ``k8s:$K8S_CLUSTER_ID``.
                                ],
                                "taints": [
                                    {
                                        "effect": "str",  # Optional. How the
                                          node reacts to pods that it won't tolerate. Available effect
                                          values are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                          ``NoExecute``. Known values are: "NoSchedule",
                                          "PreferNoSchedule", and "NoExecute".
                                        "key": "str",  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                        "value": "str"  # Optional. An
                                          arbitrary string. The ``key`` and ``value`` fields of the
                                          ``taint`` object form a key-value pair. For example, if the
                                          value of the ``key`` field is "special" and the value of the
                                          ``value`` field is "gpu", the key value pair would be
                                          ``special=gpu``.
                                    }
                                ]
                            }
                        ],
                        "region": "str",  # The slug identifier for the region where the
                          Kubernetes cluster is located. Required.
                        "version": "str",  # The slug identifier for the version of
                          Kubernetes used for the cluster. If set to a minor version (e.g. "1.14"), the
                          latest version within it will be used (e.g. "1.14.6-do.1"); if set to
                          "latest", the latest published version will be used. See the
                          ``/v2/kubernetes/options`` endpoint to find all currently available versions.
                          Required.
                        "auto_upgrade": False,  # Optional. Default value is False. A boolean
                          value indicating whether the cluster will be automatically upgraded to new
                          patch releases during its maintenance window.
                        "cluster_autoscaler_configuration": {
                            "scale_down_unneeded_time": "str",  # Optional. Used to
                              customize how long a node is unneeded before being scaled down.
                            "scale_down_utilization_threshold": 0.0  # Optional. Used to
                              customize when cluster autoscaler scales down non-empty nodes by setting
                              the node utilization threshold.
                        },
                        "cluster_subnet": "str",  # Optional. The range of IP addresses for
                          the overlay network of the Kubernetes cluster in CIDR notation.
                        "control_plane_firewall": {
                            "allowed_addresses": [
                                "str"  # Optional. An array of public addresses (IPv4
                                  or CIDR) allowed to access the control plane.
                            ],
                            "enabled": bool  # Optional. Indicates whether the control
                              plane firewall is enabled.
                        },
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was created.
                        "endpoint": "str",  # Optional. The base URL of the API server on the
                          Kubernetes master node.
                        "ha": False,  # Optional. Default value is False. A boolean value
                          indicating whether the control plane is run in a highly available
                          configuration in the cluster. Highly available control planes incur less
                          downtime. The property cannot be disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a Kubernetes cluster.
                        "ipv4": "str",  # Optional. The public IPv4 address of the Kubernetes
                          master node. This will not be set if high availability is configured on the
                          cluster (v1.21+).
                        "maintenance_policy": {
                            "day": "str",  # Optional. The day of the maintenance window
                              policy. May be one of ``monday`` through ``sunday``"" , or ``any`` to
                              indicate an arbitrary week day. Known values are: "any", "monday",
                              "tuesday", "wednesday", "thursday", "friday", "saturday", and "sunday".
                            "duration": "str",  # Optional. The duration of the
                              maintenance window policy in human-readable format.
                            "start_time": "str"  # Optional. The start time in UTC of the
                              maintenance window policy in 24-hour clock format / HH:MM notation (e.g.,
                              ``15:00``"" ).
                        },
                        "registry_enabled": bool,  # Optional. A read-only boolean value
                          indicating if a container registry is integrated with the cluster.
                        "routing_agent": {
                            "enabled": bool  # Optional. Indicates whether the
                              routing-agent component is enabled.
                        },
                        "service_subnet": "str",  # Optional. The range of assignable IP
                          addresses for services running in the Kubernetes cluster in CIDR notation.
                        "status": {
                            "message": "str",  # Optional. An optional message providing
                              additional information about the current cluster state.
                            "state": "str"  # Optional. A string indicating the current
                              status of the cluster. Known values are: "running", "provisioning",
                              "degraded", "error", "deleted", "upgrading", and "deleting".
                        },
                        "surge_upgrade": False,  # Optional. Default value is False. A
                          boolean value indicating whether surge upgrade is enabled/disabled for the
                          cluster. Surge upgrade makes cluster upgrades fast and reliable by bringing
                          up new nodes before destroying the outdated nodes.
                        "tags": [
                            "str"  # Optional. An array of tags applied to the Kubernetes
                              cluster. All clusters are automatically tagged ``k8s`` and
                              ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the Kubernetes
                          cluster was last updated.
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the Kubernetes cluster is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_update_cluster_request(
            cluster_id=cluster_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_cluster(self, cluster_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Kubernetes Cluster.

        To delete a Kubernetes cluster and all services deployed to it, send a DELETE
        request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID``.

        A 204 status code with no body will be returned in response to a successful
        request.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_kubernetes_delete_cluster_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_associated_resources(self, cluster_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Associated Resources for Cluster Deletion.

        To list the associated billable resources that can be destroyed along with a cluster, send a
        GET request to the
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/destroy_with_associated_resources`` endpoint.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "load_balancers": [
                        {
                            "id": "str",  # Optional. The ID of a resource associated
                              with a Kubernetes cluster.
                            "name": "str"  # Optional. The name of a resource associated
                              with a Kubernetes cluster.
                        }
                    ],
                    "volume_snapshots": [
                        {
                            "id": "str",  # Optional. The ID of a resource associated
                              with a Kubernetes cluster.
                            "name": "str"  # Optional. The name of a resource associated
                              with a Kubernetes cluster.
                        }
                    ],
                    "volumes": [
                        {
                            "id": "str",  # Optional. The ID of a resource associated
                              with a Kubernetes cluster.
                            "name": "str"  # Optional. The name of a resource associated
                              with a Kubernetes cluster.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_list_associated_resources_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def destroy_associated_resources_selective(
        self,
        cluster_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Delete a Cluster and its Associated Resources.

        To delete a Kubernetes cluster along with a subset of its associated resources,
        send a DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/destroy_with_associated_resources/selective``.

        The JSON body of the request should include ``load_balancers``\\ , ``volumes``\\ , or
        ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed.

        The IDs can be found by querying the cluster's associated resources endpoint.
        Any associated resource not included in the request will remain and continue
        to accrue changes on your account.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "load_balancers": [
                        "str"  # Optional. A list of IDs for associated load balancers to
                          destroy along with the cluster.
                    ],
                    "volume_snapshots": [
                        "str"  # Optional. A list of IDs for associated volume snapshots to
                          destroy along with the cluster.
                    ],
                    "volumes": [
                        "str"  # Optional. A list of IDs for associated volumes to destroy
                          along with the cluster.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def destroy_associated_resources_selective(
        self,
        cluster_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Delete a Cluster and its Associated Resources.

        To delete a Kubernetes cluster along with a subset of its associated resources,
        send a DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/destroy_with_associated_resources/selective``.

        The JSON body of the request should include ``load_balancers``\\ , ``volumes``\\ , or
        ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed.

        The IDs can be found by querying the cluster's associated resources endpoint.
        Any associated resource not included in the request will remain and continue
        to accrue changes on your account.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def destroy_associated_resources_selective(
        self, cluster_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Selectively Delete a Cluster and its Associated Resources.

        To delete a Kubernetes cluster along with a subset of its associated resources,
        send a DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/destroy_with_associated_resources/selective``.

        The JSON body of the request should include ``load_balancers``\\ , ``volumes``\\ , or
        ``volume_snapshots`` keys each set to an array of IDs for the associated
        resources to be destroyed.

        The IDs can be found by querying the cluster's associated resources endpoint.
        Any associated resource not included in the request will remain and continue
        to accrue changes on your account.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "load_balancers": [
                        "str"  # Optional. A list of IDs for associated load balancers to
                          destroy along with the cluster.
                    ],
                    "volume_snapshots": [
                        "str"  # Optional. A list of IDs for associated volume snapshots to
                          destroy along with the cluster.
                    ],
                    "volumes": [
                        "str"  # Optional. A list of IDs for associated volumes to destroy
                          along with the cluster.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_destroy_associated_resources_selective_request(
            cluster_id=cluster_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def destroy_associated_resources_dangerous(
        self, cluster_id: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Cluster and All of its Associated Resources (Dangerous).

        To delete a Kubernetes cluster with all of its associated resources, send a
        DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/destroy_with_associated_resources/dangerous``.
        A 204 status code with no body will be returned in response to a successful request.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_kubernetes_destroy_associated_resources_dangerous_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_kubeconfig(
        self, cluster_id: str, *, expiry_seconds: int = 0, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Retrieve the kubeconfig for a Kubernetes Cluster.

        This endpoint returns a kubeconfig file in YAML format. It can be used to
        connect to and administer the cluster using the Kubernetes command line tool,
        ``kubectl``\\ , or other programs supporting kubeconfig files (e.g., client libraries).

        The resulting kubeconfig file uses token-based authentication for clusters
        supporting it, and certificate-based authentication otherwise. For a list of
        supported versions and more information, see "\\ `How to Connect to a DigitalOcean
        Kubernetes Cluster
        <https://docs.digitalocean.com/products/kubernetes/how-to/connect-to-cluster/>`_\\ ".

        To retrieve a kubeconfig file for use with a Kubernetes cluster, send a GET
        request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/kubeconfig``.

        Clusters supporting token-based authentication may define an expiration by
        passing a duration in seconds as a query parameter to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/kubeconfig?expiry_seconds=$DURATION_IN_SECONDS``.
        If not set or 0, then the token will have a 7 day expiry. The query parameter
        has no impact in certificate-based authentication.

        Kubernetes Roles granted to a user with a token-based kubeconfig are derived from that user's
        DigitalOcean role. Predefined roles (Owner, Member, Modifier etc.) have an automatic mapping
        to Kubernetes roles. Custom roles are not automatically mapped to any Kubernetes roles,
        and require `additional configuration
        <https://docs.digitalocean.com/products/kubernetes/how-to/set-up-custom-rolebindings/>`_
        by a cluster administrator.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :keyword expiry_seconds: The duration in seconds that the returned Kubernetes credentials will
         be valid. If not set or 0, the credentials will have a 7 day expiry. Default value is 0.
        :paramtype expiry_seconds: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_kubeconfig_request(
            cluster_id=cluster_id,
            expiry_seconds=expiry_seconds,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_credentials(
        self, cluster_id: str, *, expiry_seconds: int = 0, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Credentials for a Kubernetes Cluster.

        This endpoint returns a JSON object . It can be used to programmatically
        construct Kubernetes clients which cannot parse kubeconfig files.

        The resulting JSON object contains token-based authentication for clusters
        supporting it, and certificate-based authentication otherwise. For a list of
        supported versions and more information, see "\\ `How to Connect to a DigitalOcean
        Kubernetes Cluster
        <https://docs.digitalocean.com/products/kubernetes/how-to/connect-to-cluster/>`_\\ ".

        To retrieve credentials for accessing a Kubernetes cluster, send a GET
        request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/credentials``.

        Clusters supporting token-based authentication may define an expiration by
        passing a duration in seconds as a query parameter to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/credentials?expiry_seconds=$DURATION_IN_SECONDS``.
        If not set or 0, then the token will have a 7 day expiry. The query parameter
        has no impact in certificate-based authentication.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :keyword expiry_seconds: The duration in seconds that the returned Kubernetes credentials will
         be valid. If not set or 0, the credentials will have a 7 day expiry. Default value is 0.
        :paramtype expiry_seconds: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "certificate_authority_data": bytes("bytes", encoding="utf-8"),  # Optional.
                      A base64 encoding of bytes representing the certificate authority data for
                      accessing the cluster.
                    "client_certificate_data": bytes("bytes", encoding="utf-8"),  # Optional. A
                      base64 encoding of bytes representing the x509 client certificate data for access
                      the cluster. This is only returned for clusters without support for token-based
                      authentication.  Newly created Kubernetes clusters do not return credentials
                      using certificate-based authentication. For additional information, `see here
                      <https://docs.digitalocean.com/products/kubernetes/how-to/connect-to-cluster/#authenticate>`_.
                    "client_key_data": bytes("bytes", encoding="utf-8"),  # Optional. A base64
                      encoding of bytes representing the x509 client key data for access the cluster.
                      This is only returned for clusters without support for token-based
                      authentication.  Newly created Kubernetes clusters do not return credentials
                      using certificate-based authentication. For additional information, `see here
                      <https://docs.digitalocean.com/products/kubernetes/how-to/connect-to-cluster/#authenticate>`_.
                    "expires_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the access token
                      expires.
                    "server": "str",  # Optional. The URL used to access the cluster API server.
                    "token": "str"  # Optional. An access token used to authenticate with the
                      cluster. This is only returned for clusters with support for token-based
                      authentication.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_credentials_request(
            cluster_id=cluster_id,
            expiry_seconds=expiry_seconds,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_available_upgrades(self, cluster_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Available Upgrades for an Existing Kubernetes Cluster.

        To determine whether a cluster can be upgraded, and the versions to which it
        can be upgraded, send a GET request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrades``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "available_upgrade_versions": [
                        {
                            "kubernetes_version": "str",  # Optional. The upstream
                              version string for the version of Kubernetes provided by a given slug.
                            "slug": "str",  # Optional. The slug identifier for an
                              available version of Kubernetes for use when creating or updating a
                              cluster. The string contains both the upstream version of Kubernetes as
                              well as the DigitalOcean revision.
                            "supported_features": [
                                "str"  # Optional. The features available with the
                                  version of Kubernetes provided by a given slug.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_available_upgrades_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def upgrade_cluster(
        self,
        cluster_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade a Kubernetes Cluster.

        To immediately upgrade a Kubernetes cluster to a newer patch release of
        Kubernetes, send a POST request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrade``.
        The body of the request must specify a version attribute.

        Available upgrade versions for a cluster can be fetched from
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrades``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "version": "str"  # Optional. The slug identifier for the version of
                      Kubernetes that the cluster will be upgraded to.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def upgrade_cluster(
        self,
        cluster_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade a Kubernetes Cluster.

        To immediately upgrade a Kubernetes cluster to a newer patch release of
        Kubernetes, send a POST request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrade``.
        The body of the request must specify a version attribute.

        Available upgrade versions for a cluster can be fetched from
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrades``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def upgrade_cluster(
        self, cluster_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Upgrade a Kubernetes Cluster.

        To immediately upgrade a Kubernetes cluster to a newer patch release of
        Kubernetes, send a POST request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrade``.
        The body of the request must specify a version attribute.

        Available upgrade versions for a cluster can be fetched from
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/upgrades``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "version": "str"  # Optional. The slug identifier for the version of
                      Kubernetes that the cluster will be upgraded to.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_upgrade_cluster_request(
            cluster_id=cluster_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_node_pools(self, cluster_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Node Pools in a Kubernetes Clusters.

        To list all of the node pools in a Kubernetes clusters, send a GET request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "node_pools": [
                        {
                            "auto_scale": bool,  # Optional. A boolean value indicating
                              whether auto-scaling is enabled for this node pool.
                            "count": 0,  # Optional. The number of Droplet instances in
                              the node pool.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a specific node pool.
                            "labels": {},  # Optional. An object of key/value mappings
                              specifying labels to apply to all nodes in a pool. Labels will
                              automatically be applied to all existing nodes and any subsequent nodes
                              added to the pool. Note that when a label is removed, it is not deleted
                              from the nodes in the pool.
                            "max_nodes": 0,  # Optional. The maximum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "min_nodes": 0,  # Optional. The minimum number of nodes that
                              this node pool can be auto-scaled to. The value will be ``0`` if
                              ``auto_scale`` is set to ``false``.
                            "name": "str",  # Optional. A human-readable name for the
                              node pool.
                            "nodes": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was created.
                                    "droplet_id": "str",  # Optional. The ID of
                                      the Droplet used for the worker node.
                                    "id": "str",  # Optional. A unique ID that
                                      can be used to identify and reference the node.
                                    "name": "str",  # Optional. An automatically
                                      generated, human-readable name for the node.
                                    "status": {
                                        "state": "str"  # Optional. A string
                                          indicating the current status of the node. Known values are:
                                          "provisioning", "running", "draining", and "deleting".
                                    },
                                    "updated_at": "2020-02-20 00:00:00"  #
                                      Optional. A time value given in ISO8601 combined date and time
                                      format that represents when the node was last updated.
                                }
                            ],
                            "size": "str",  # Optional. The slug identifier for the type
                              of Droplet used as workers in the node pool.
                            "tags": [
                                "str"  # Optional. An array containing the tags
                                  applied to the node pool. All node pools are automatically tagged
                                  ``k8s``"" , ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                            ],
                            "taints": [
                                {
                                    "effect": "str",  # Optional. How the node
                                      reacts to pods that it won't tolerate. Available effect values
                                      are ``NoSchedule``"" , ``PreferNoSchedule``"" , and
                                      ``NoExecute``. Known values are: "NoSchedule",
                                      "PreferNoSchedule", and "NoExecute".
                                    "key": "str",  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                    "value": "str"  # Optional. An arbitrary
                                      string. The ``key`` and ``value`` fields of the ``taint`` object
                                      form a key-value pair. For example, if the value of the ``key``
                                      field is "special" and the value of the ``value`` field is "gpu",
                                      the key value pair would be ``special=gpu``.
                                }
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_list_node_pools_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def add_node_pool(
        self,
        cluster_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Node Pool to a Kubernetes Cluster.

        To add an additional node pool to a Kubernetes clusters, send a POST request
        to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools`` with the following
        attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "auto_scale": bool,  # Optional. A boolean value indicating whether
                      auto-scaling is enabled for this node pool.
                    "count": 0,  # Optional. The number of Droplet instances in the node pool.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a specific node pool.
                    "labels": {},  # Optional. An object of key/value mappings specifying labels
                      to apply to all nodes in a pool. Labels will automatically be applied to all
                      existing nodes and any subsequent nodes added to the pool. Note that when a label
                      is removed, it is not deleted from the nodes in the pool.
                    "max_nodes": 0,  # Optional. The maximum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "min_nodes": 0,  # Optional. The minimum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "name": "str",  # Optional. A human-readable name for the node pool.
                    "nodes": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the node was created.
                            "droplet_id": "str",  # Optional. The ID of the Droplet used
                              for the worker node.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the node.
                            "name": "str",  # Optional. An automatically generated,
                              human-readable name for the node.
                            "status": {
                                "state": "str"  # Optional. A string indicating the
                                  current status of the node. Known values are: "provisioning",
                                  "running", "draining", and "deleting".
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format that represents when the
                              node was last updated.
                        }
                    ],
                    "size": "str",  # Optional. The slug identifier for the type of Droplet used
                      as workers in the node pool.
                    "tags": [
                        "str"  # Optional. An array containing the tags applied to the node
                          pool. All node pools are automatically tagged ``k8s``"" , ``k8s-worker``"" ,
                          and ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "taints": [
                        {
                            "effect": "str",  # Optional. How the node reacts to pods
                              that it won't tolerate. Available effect values are ``NoSchedule``"" ,
                              ``PreferNoSchedule``"" , and ``NoExecute``. Known values are:
                              "NoSchedule", "PreferNoSchedule", and "NoExecute".
                            "key": "str",  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                            "value": "str"  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                        }
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_node_pool(
        self,
        cluster_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Node Pool to a Kubernetes Cluster.

        To add an additional node pool to a Kubernetes clusters, send a POST request
        to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools`` with the following
        attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_node_pool(
        self, cluster_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add a Node Pool to a Kubernetes Cluster.

        To add an additional node pool to a Kubernetes clusters, send a POST request
        to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools`` with the following
        attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "auto_scale": bool,  # Optional. A boolean value indicating whether
                      auto-scaling is enabled for this node pool.
                    "count": 0,  # Optional. The number of Droplet instances in the node pool.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a specific node pool.
                    "labels": {},  # Optional. An object of key/value mappings specifying labels
                      to apply to all nodes in a pool. Labels will automatically be applied to all
                      existing nodes and any subsequent nodes added to the pool. Note that when a label
                      is removed, it is not deleted from the nodes in the pool.
                    "max_nodes": 0,  # Optional. The maximum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "min_nodes": 0,  # Optional. The minimum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "name": "str",  # Optional. A human-readable name for the node pool.
                    "nodes": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the node was created.
                            "droplet_id": "str",  # Optional. The ID of the Droplet used
                              for the worker node.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the node.
                            "name": "str",  # Optional. An automatically generated,
                              human-readable name for the node.
                            "status": {
                                "state": "str"  # Optional. A string indicating the
                                  current status of the node. Known values are: "provisioning",
                                  "running", "draining", and "deleting".
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format that represents when the
                              node was last updated.
                        }
                    ],
                    "size": "str",  # Optional. The slug identifier for the type of Droplet used
                      as workers in the node pool.
                    "tags": [
                        "str"  # Optional. An array containing the tags applied to the node
                          pool. All node pools are automatically tagged ``k8s``"" , ``k8s-worker``"" ,
                          and ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "taints": [
                        {
                            "effect": "str",  # Optional. How the node reacts to pods
                              that it won't tolerate. Available effect values are ``NoSchedule``"" ,
                              ``PreferNoSchedule``"" , and ``NoExecute``. Known values are:
                              "NoSchedule", "PreferNoSchedule", and "NoExecute".
                            "key": "str",  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                            "value": "str"  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                        }
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_add_node_pool_request(
            cluster_id=cluster_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_node_pool(self, cluster_id: str, node_pool_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve a Node Pool for a Kubernetes Cluster.

        To show information about a specific node pool in a Kubernetes cluster, send
        a GET request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_node_pool_request(
            cluster_id=cluster_id,
            node_pool_id=node_pool_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Node Pool in a Kubernetes Cluster.

        To update the name of a node pool, edit the tags applied to it, or adjust its
        number of nodes, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID`` with the
        following attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "auto_scale": bool,  # Optional. A boolean value indicating whether
                      auto-scaling is enabled for this node pool.
                    "count": 0,  # Optional. The number of Droplet instances in the node pool.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a specific node pool.
                    "labels": {},  # Optional. An object of key/value mappings specifying labels
                      to apply to all nodes in a pool. Labels will automatically be applied to all
                      existing nodes and any subsequent nodes added to the pool. Note that when a label
                      is removed, it is not deleted from the nodes in the pool.
                    "max_nodes": 0,  # Optional. The maximum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "min_nodes": 0,  # Optional. The minimum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "name": "str",  # Optional. A human-readable name for the node pool.
                    "nodes": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the node was created.
                            "droplet_id": "str",  # Optional. The ID of the Droplet used
                              for the worker node.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the node.
                            "name": "str",  # Optional. An automatically generated,
                              human-readable name for the node.
                            "status": {
                                "state": "str"  # Optional. A string indicating the
                                  current status of the node. Known values are: "provisioning",
                                  "running", "draining", and "deleting".
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format that represents when the
                              node was last updated.
                        }
                    ],
                    "tags": [
                        "str"  # Optional. An array containing the tags applied to the node
                          pool. All node pools are automatically tagged ``k8s``"" , ``k8s-worker``"" ,
                          and ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "taints": [
                        {
                            "effect": "str",  # Optional. How the node reacts to pods
                              that it won't tolerate. Available effect values are ``NoSchedule``"" ,
                              ``PreferNoSchedule``"" , and ``NoExecute``. Known values are:
                              "NoSchedule", "PreferNoSchedule", and "NoExecute".
                            "key": "str",  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                            "value": "str"  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                        }
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Node Pool in a Kubernetes Cluster.

        To update the name of a node pool, edit the tags applied to it, or adjust its
        number of nodes, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID`` with the
        following attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Node Pool in a Kubernetes Cluster.

        To update the name of a node pool, edit the tags applied to it, or adjust its
        number of nodes, send a PUT request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID`` with the
        following attributes.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "auto_scale": bool,  # Optional. A boolean value indicating whether
                      auto-scaling is enabled for this node pool.
                    "count": 0,  # Optional. The number of Droplet instances in the node pool.
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference a specific node pool.
                    "labels": {},  # Optional. An object of key/value mappings specifying labels
                      to apply to all nodes in a pool. Labels will automatically be applied to all
                      existing nodes and any subsequent nodes added to the pool. Note that when a label
                      is removed, it is not deleted from the nodes in the pool.
                    "max_nodes": 0,  # Optional. The maximum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "min_nodes": 0,  # Optional. The minimum number of nodes that this node pool
                      can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is set to
                      ``false``.
                    "name": "str",  # Optional. A human-readable name for the node pool.
                    "nodes": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the node was created.
                            "droplet_id": "str",  # Optional. The ID of the Droplet used
                              for the worker node.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the node.
                            "name": "str",  # Optional. An automatically generated,
                              human-readable name for the node.
                            "status": {
                                "state": "str"  # Optional. A string indicating the
                                  current status of the node. Known values are: "provisioning",
                                  "running", "draining", and "deleting".
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format that represents when the
                              node was last updated.
                        }
                    ],
                    "tags": [
                        "str"  # Optional. An array containing the tags applied to the node
                          pool. All node pools are automatically tagged ``k8s``"" , ``k8s-worker``"" ,
                          and ``k8s:$K8S_CLUSTER_ID``.
                    ],
                    "taints": [
                        {
                            "effect": "str",  # Optional. How the node reacts to pods
                              that it won't tolerate. Available effect values are ``NoSchedule``"" ,
                              ``PreferNoSchedule``"" , and ``NoExecute``. Known values are:
                              "NoSchedule", "PreferNoSchedule", and "NoExecute".
                            "key": "str",  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                            "value": "str"  # Optional. An arbitrary string. The ``key``
                              and ``value`` fields of the ``taint`` object form a key-value pair. For
                              example, if the value of the ``key`` field is "special" and the value of
                              the ``value`` field is "gpu", the key value pair would be
                              ``special=gpu``.
                        }
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "node_pool": {
                        "auto_scale": bool,  # Optional. A boolean value indicating whether
                          auto-scaling is enabled for this node pool.
                        "count": 0,  # Optional. The number of Droplet instances in the node
                          pool.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a specific node pool.
                        "labels": {},  # Optional. An object of key/value mappings specifying
                          labels to apply to all nodes in a pool. Labels will automatically be applied
                          to all existing nodes and any subsequent nodes added to the pool. Note that
                          when a label is removed, it is not deleted from the nodes in the pool.
                        "max_nodes": 0,  # Optional. The maximum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "min_nodes": 0,  # Optional. The minimum number of nodes that this
                          node pool can be auto-scaled to. The value will be ``0`` if ``auto_scale`` is
                          set to ``false``.
                        "name": "str",  # Optional. A human-readable name for the node pool.
                        "nodes": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was created.
                                "droplet_id": "str",  # Optional. The ID of the
                                  Droplet used for the worker node.
                                "id": "str",  # Optional. A unique ID that can be
                                  used to identify and reference the node.
                                "name": "str",  # Optional. An automatically
                                  generated, human-readable name for the node.
                                "status": {
                                    "state": "str"  # Optional. A string
                                      indicating the current status of the node. Known values are:
                                      "provisioning", "running", "draining", and "deleting".
                                },
                                "updated_at": "2020-02-20 00:00:00"  # Optional. A
                                  time value given in ISO8601 combined date and time format that
                                  represents when the node was last updated.
                            }
                        ],
                        "size": "str",  # Optional. The slug identifier for the type of
                          Droplet used as workers in the node pool.
                        "tags": [
                            "str"  # Optional. An array containing the tags applied to
                              the node pool. All node pools are automatically tagged ``k8s``"" ,
                              ``k8s-worker``"" , and ``k8s:$K8S_CLUSTER_ID``.
                        ],
                        "taints": [
                            {
                                "effect": "str",  # Optional. How the node reacts to
                                  pods that it won't tolerate. Available effect values are
                                  ``NoSchedule``"" , ``PreferNoSchedule``"" , and ``NoExecute``. Known
                                  values are: "NoSchedule", "PreferNoSchedule", and "NoExecute".
                                "key": "str",  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                                "value": "str"  # Optional. An arbitrary string. The
                                  ``key`` and ``value`` fields of the ``taint`` object form a key-value
                                  pair. For example, if the value of the ``key`` field is "special" and
                                  the value of the ``value`` field is "gpu", the key value pair would
                                  be ``special=gpu``.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_update_node_pool_request(
            cluster_id=cluster_id,
            node_pool_id=node_pool_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_node_pool(
        self, cluster_id: str, node_pool_id: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Node Pool in a Kubernetes Cluster.

        To delete a node pool, send a DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID``.

        A 204 status code with no body will be returned in response to a successful
        request. Nodes in the pool will subsequently be drained and deleted.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_kubernetes_delete_node_pool_request(
            cluster_id=cluster_id,
            node_pool_id=node_pool_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_node(
        self,
        cluster_id: str,
        node_pool_id: str,
        node_id: str,
        *,
        skip_drain: int = 0,
        replace: int = 0,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Node in a Kubernetes Cluster.

        To delete a single node in a pool, send a DELETE request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID/nodes/$NODE_ID``.

        Appending the ``skip_drain=1`` query parameter to the request causes node
        draining to be skipped. Omitting the query parameter or setting its value to
        ``0`` carries out draining prior to deletion.

        Appending the ``replace=1`` query parameter to the request causes the node to
        be replaced by a new one after deletion. Omitting the query parameter or
        setting its value to ``0`` deletes without replacement.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param node_id: A unique ID that can be used to reference a node in a Kubernetes node pool.
         Required.
        :type node_id: str
        :keyword skip_drain: Specifies whether or not to drain workloads from a node before it is
         deleted. Setting it to ``1`` causes node draining to be skipped. Omitting the query parameter
         or setting its value to ``0`` carries out draining prior to deletion. Default value is 0.
        :paramtype skip_drain: int
        :keyword replace: Specifies whether or not to replace a node after it has been deleted. Setting
         it to ``1`` causes the node to be replaced by a new one after deletion. Omitting the query
         parameter or setting its value to ``0`` deletes without replacement. Default value is 0.
        :paramtype replace: int
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_kubernetes_delete_node_request(
            cluster_id=cluster_id,
            node_pool_id=node_pool_id,
            node_id=node_id,
            skip_drain=skip_drain,
            replace=replace,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def recycle_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Recycle a Kubernetes Node Pool.

        The endpoint has been deprecated. Please use the DELETE
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID/nodes/$NODE_ID``
        method instead.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "nodes": [
                        "str"  # Optional.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def recycle_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Recycle a Kubernetes Node Pool.

        The endpoint has been deprecated. Please use the DELETE
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID/nodes/$NODE_ID``
        method instead.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def recycle_node_pool(
        self,
        cluster_id: str,
        node_pool_id: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Recycle a Kubernetes Node Pool.

        The endpoint has been deprecated. Please use the DELETE
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/node_pools/$NODE_POOL_ID/nodes/$NODE_ID``
        method instead.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param node_pool_id: A unique ID that can be used to reference a Kubernetes node pool.
         Required.
        :type node_pool_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "nodes": [
                        "str"  # Optional.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_kubernetes_recycle_node_pool_request(
            cluster_id=cluster_id,
            node_pool_id=node_pool_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_cluster_user(self, cluster_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve User Information for a Kubernetes Cluster.

        To show information the user associated with a Kubernetes cluster, send a GET
        request to ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/user``.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "kubernetes_cluster_user": {
                        "groups": [
                            "str"  # Optional. A list of in-cluster groups that the user
                              belongs to.
                        ],
                        "username": "str"  # Optional. The username for the cluster admin
                          user.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_cluster_user_request(
            cluster_id=cluster_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_options(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Available Regions, Node Sizes, and Versions of Kubernetes.

        To list the versions of Kubernetes available for use, the regions that support Kubernetes, and
        the available node sizes, send a GET request to ``/v2/kubernetes/options``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "options": {
                        "regions": [
                            {
                                "name": "str",  # Optional. A DigitalOcean region
                                  where Kubernetes is available.
                                "slug": "str"  # Optional. The identifier for a
                                  region for use when creating a new cluster.
                            }
                        ],
                        "sizes": [
                            {
                                "name": "str",  # Optional. A Droplet size available
                                  for use in a Kubernetes node pool.
                                "slug": "str"  # Optional. The identifier for a size
                                  for use when creating a new cluster.
                            }
                        ],
                        "versions": [
                            {
                                "kubernetes_version": "str",  # Optional. The
                                  upstream version string for the version of Kubernetes provided by a
                                  given slug.
                                "slug": "str",  # Optional. The slug identifier for
                                  an available version of Kubernetes for use when creating or updating
                                  a cluster. The string contains both the upstream version of
                                  Kubernetes as well as the DigitalOcean revision.
                                "supported_features": [
                                    "str"  # Optional. The features available
                                      with the version of Kubernetes provided by a given slug.
                                ]
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_list_options_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def run_cluster_lint(
        self,
        cluster_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Run Clusterlint Checks on a Kubernetes Cluster.

        Clusterlint helps operators conform to Kubernetes best practices around
        resources, security and reliability to avoid common problems while operating
        or upgrading the clusters.

        To request a clusterlint run on your cluster, send a POST request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/clusterlint``. This will run all
        checks present in the ``doks`` group by default, if a request body is not
        specified. Optionally specify the below attributes.

        For information about the available checks, please refer to
        `the clusterlint check documentation
        <https://github.com/digitalocean/clusterlint/blob/master/checks.md>`_.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "exclude_checks": [
                        "str"  # Optional. An array of checks that will be run when
                          clusterlint executes checks.
                    ],
                    "exclude_groups": [
                        "str"  # Optional. An array of check groups that will be omitted when
                          clusterlint executes checks.
                    ],
                    "include_checks": [
                        "str"  # Optional. An array of checks that will be run when
                          clusterlint executes checks.
                    ],
                    "include_groups": [
                        "str"  # Optional. An array of check groups that will be run when
                          clusterlint executes checks.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "run_id": "str"  # Optional. ID of the clusterlint run that can be used later
                      to fetch the diagnostics.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def run_cluster_lint(
        self,
        cluster_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Run Clusterlint Checks on a Kubernetes Cluster.

        Clusterlint helps operators conform to Kubernetes best practices around
        resources, security and reliability to avoid common problems while operating
        or upgrading the clusters.

        To request a clusterlint run on your cluster, send a POST request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/clusterlint``. This will run all
        checks present in the ``doks`` group by default, if a request body is not
        specified. Optionally specify the below attributes.

        For information about the available checks, please refer to
        `the clusterlint check documentation
        <https://github.com/digitalocean/clusterlint/blob/master/checks.md>`_.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "run_id": "str"  # Optional. ID of the clusterlint run that can be used later
                      to fetch the diagnostics.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def run_cluster_lint(
        self,
        cluster_id: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Run Clusterlint Checks on a Kubernetes Cluster.

        Clusterlint helps operators conform to Kubernetes best practices around
        resources, security and reliability to avoid common problems while operating
        or upgrading the clusters.

        To request a clusterlint run on your cluster, send a POST request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/clusterlint``. This will run all
        checks present in the ``doks`` group by default, if a request body is not
        specified. Optionally specify the below attributes.

        For information about the available checks, please refer to
        `the clusterlint check documentation
        <https://github.com/digitalocean/clusterlint/blob/master/checks.md>`_.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "exclude_checks": [
                        "str"  # Optional. An array of checks that will be run when
                          clusterlint executes checks.
                    ],
                    "exclude_groups": [
                        "str"  # Optional. An array of check groups that will be omitted when
                          clusterlint executes checks.
                    ],
                    "include_checks": [
                        "str"  # Optional. An array of checks that will be run when
                          clusterlint executes checks.
                    ],
                    "include_groups": [
                        "str"  # Optional. An array of check groups that will be run when
                          clusterlint executes checks.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "run_id": "str"  # Optional. ID of the clusterlint run that can be used later
                      to fetch the diagnostics.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_kubernetes_run_cluster_lint_request(
            cluster_id=cluster_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_cluster_lint_results(
        self, cluster_id: str, *, run_id: Optional[str] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Fetch Clusterlint Diagnostics for a Kubernetes Cluster.

        To request clusterlint diagnostics for your cluster, send a GET request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/clusterlint``. If the ``run_id`` query
        parameter is provided, then the diagnostics for the specific run is fetched.
        By default, the latest results are shown.

        To find out how to address clusterlint feedback, please refer to
        `the clusterlint check documentation
        <https://github.com/digitalocean/clusterlint/blob/master/checks.md>`_.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :keyword run_id: Specifies the clusterlint run whose results will be retrieved. Default value
         is None.
        :paramtype run_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "completed_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the schedule
                      clusterlint run request was completed.
                    "diagnostics": [
                        {
                            "check_name": "str",  # Optional. The clusterlint check that
                              resulted in the diagnostic.
                            "message": "str",  # Optional. Feedback about the object for
                              users to fix.
                            "object": {
                                "kind": "str",  # Optional. The kind of Kubernetes
                                  API object.
                                "name": "str",  # Optional. Name of the object.
                                "namespace": "str"  # Optional. The namespace the
                                  object resides in the cluster.
                            },
                            "severity": "str"  # Optional. Can be one of error, warning
                              or suggestion.
                        }
                    ],
                    "requested_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the schedule
                      clusterlint run request was made.
                    "run_id": "str"  # Optional. Id of the clusterlint run that can be used later
                      to fetch the diagnostics.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_cluster_lint_results_request(
            cluster_id=cluster_id,
            run_id=run_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def add_registry(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Add Container Registry to Kubernetes Clusters.

        To integrate the container registry with Kubernetes clusters, send a POST request to
        ``/v2/kubernetes/registry``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cluster_uuids": [
                        "str"  # Optional. An array containing the UUIDs of Kubernetes
                          clusters.
                    ]
                }
        """

    @overload
    def add_registry(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Add Container Registry to Kubernetes Clusters.

        To integrate the container registry with Kubernetes clusters, send a POST request to
        ``/v2/kubernetes/registry``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:
        """

    @distributed_trace
    def add_registry(  # pylint: disable=inconsistent-return-statements
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> None:
        """Add Container Registry to Kubernetes Clusters.

        To integrate the container registry with Kubernetes clusters, send a POST request to
        ``/v2/kubernetes/registry``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cluster_uuids": [
                        "str"  # Optional. An array containing the UUIDs of Kubernetes
                          clusters.
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[None] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_kubernetes_add_registry_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if cls:
            return cls(pipeline_response, None, response_headers)  # type: ignore

    @overload
    def remove_registry(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Remove Container Registry from Kubernetes Clusters.

        To remove the container registry from Kubernetes clusters, send a DELETE request to
        ``/v2/kubernetes/registry``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cluster_uuids": [
                        "str"  # Optional. An array containing the UUIDs of Kubernetes
                          clusters.
                    ]
                }
        """

    @overload
    def remove_registry(  # pylint: disable=inconsistent-return-statements
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> None:
        """Remove Container Registry from Kubernetes Clusters.

        To remove the container registry from Kubernetes clusters, send a DELETE request to
        ``/v2/kubernetes/registry``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:
        """

    @distributed_trace
    def remove_registry(  # pylint: disable=inconsistent-return-statements
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> None:
        """Remove Container Registry from Kubernetes Clusters.

        To remove the container registry from Kubernetes clusters, send a DELETE request to
        ``/v2/kubernetes/registry``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: None
        :rtype: None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cluster_uuids": [
                        "str"  # Optional. An array containing the UUIDs of Kubernetes
                          clusters.
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[None] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_kubernetes_remove_registry_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if cls:
            return cls(pipeline_response, None, response_headers)  # type: ignore

    @distributed_trace
    def get_status_messages(
        self,
        cluster_id: str,
        *,
        since: Optional[datetime.datetime] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Fetch Status Messages for a Kubernetes Cluster.

        To retrieve status messages for a Kubernetes cluster, send a GET request to
        ``/v2/kubernetes/clusters/$K8S_CLUSTER_ID/status_messages``. Status messages inform users of
        any issues that come up during the cluster lifecycle.

        :param cluster_id: A unique ID that can be used to reference a Kubernetes cluster. Required.
        :type cluster_id: str
        :keyword since: A timestamp used to return status messages emitted since the specified time.
         The timestamp should be in ISO8601 format. Default value is None.
        :paramtype since: ~datetime.datetime
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "messages": [
                        {
                            "message": "str",  # Optional. Status information about the
                              cluster which impacts it's lifecycle.
                            "timestamp": "2020-02-20 00:00:00"  # Optional. A timestamp
                              in ISO8601 format that represents when the status message was emitted.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_kubernetes_get_status_messages_request(
            cluster_id=cluster_id,
            since=since,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class LoadBalancersOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`load_balancers` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Load Balancer.

        To create a new load balancer instance, send a POST request to
        ``/v2/load_balancers``.

        You can specify the Droplets that will sit behind the load balancer using one
        of two methods:


        * Set ``droplet_ids`` to a list of specific Droplet IDs.
        * Set ``tag`` to the name of a tag. All Droplets with this tag applied will be
          assigned to the load balancer. Additional Droplets will be automatically
          assigned as they are tagged.

        These methods are mutually exclusive.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Load Balancer.

        To create a new load balancer instance, send a POST request to
        ``/v2/load_balancers``.

        You can specify the Droplets that will sit behind the load balancer using one
        of two methods:


        * Set ``droplet_ids`` to a list of specific Droplet IDs.
        * Set ``tag`` to the name of a tag. All Droplets with this tag applied will be
          assigned to the load balancer. Additional Droplets will be automatically
          assigned as they are tagged.

        These methods are mutually exclusive.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Load Balancer.

        To create a new load balancer instance, send a POST request to
        ``/v2/load_balancers``.

        You can specify the Droplets that will sit behind the load balancer using one
        of two methods:


        * Set ``droplet_ids`` to a list of specific Droplet IDs.
        * Set ``tag`` to the name of a tag. All Droplets with this tag applied will be
          assigned to the load balancer. Additional Droplets will be automatically
          assigned as they are tagged.

        These methods are mutually exclusive.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Load Balancers.

        To list all of the load balancer instances on your account, send a GET request
        to ``/v2/load_balancers``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "load_balancers": [
                        {
                            "forwarding_rules": [
                                {
                                    "entry_port": 0,  # An integer representing
                                      the port on which the load balancer instance will listen.
                                      Required.
                                    "entry_protocol": "str",  # The protocol used
                                      for traffic to the load balancer. The possible values are:
                                      ``http``"" , ``https``"" , ``http2``"" , ``http3``"" , ``tcp``""
                                      , or ``udp``. If you set the  ``entry_protocol`` to ``udp``"" ,
                                      the ``target_protocol`` must be set to ``udp``.  When using UDP,
                                      the load balancer requires that you set up a health  check with a
                                      port that uses TCP, HTTP, or HTTPS to work properly. Required.
                                      Known values are: "http", "https", "http2", "http3", "tcp", and
                                      "udp".
                                    "target_port": 0,  # An integer representing
                                      the port on the backend Droplets to which the load balancer will
                                      send traffic. Required.
                                    "target_protocol": "str",  # The protocol
                                      used for traffic from the load balancer to the backend Droplets.
                                      The possible values are: ``http``"" , ``https``"" , ``http2``"" ,
                                      ``tcp``"" , or ``udp``. If you set the ``target_protocol`` to
                                      ``udp``"" , the ``entry_protocol`` must be set to  ``udp``. When
                                      using UDP, the load balancer requires that you set up a health
                                      check with a port that uses TCP, HTTP, or HTTPS to work properly.
                                      Required. Known values are: "http", "https", "http2", "tcp", and
                                      "udp".
                                    "certificate_id": "str",  # Optional. The ID
                                      of the TLS certificate used for SSL termination if enabled.
                                    "tls_passthrough": bool  # Optional. A
                                      boolean value indicating whether SSL encrypted traffic will be
                                      passed through to the backend Droplets.
                                }
                            ],
                            "algorithm": "round_robin",  # Optional. Default value is
                              "round_robin". This field has been deprecated. You can no longer specify
                              an algorithm for load balancers. Known values are: "round_robin" and
                              "least_connections".
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the load balancer was created.
                            "disable_lets_encrypt_dns_records": False,  # Optional.
                              Default value is False. A boolean value indicating whether to disable
                              automatic DNS record creation for Let's Encrypt certificates that are
                              added to the load balancer.
                            "domains": [
                                {
                                    "certificate_id": "str",  # Optional. The ID
                                      of the TLS certificate used for SSL termination.
                                    "is_managed": bool,  # Optional. A boolean
                                      value indicating if the domain is already managed by
                                      DigitalOcean. If true, all A and AAAA records required to enable
                                      Global load balancers will be automatically added.
                                    "name": "str"  # Optional. FQDN to associate
                                      with a Global load balancer.
                                }
                            ],
                            "enable_backend_keepalive": False,  # Optional. Default value
                              is False. A boolean value indicating whether HTTP keepalive connections
                              are maintained to target Droplets.
                            "enable_proxy_protocol": False,  # Optional. Default value is
                              False. A boolean value indicating whether PROXY Protocol is in use.
                            "firewall": {
                                "allow": [
                                    "str"  # Optional. the rules for allowing
                                      traffic to the load balancer (in the form 'ip:1.2.3.4' or
                                      'cidr:1.2.0.0/16').
                                ],
                                "deny": [
                                    "str"  # Optional. the rules for denying
                                      traffic to the load balancer (in the form 'ip:1.2.3.4' or
                                      'cidr:1.2.0.0/16').
                                ]
                            },
                            "glb_settings": {
                                "cdn": {
                                    "is_enabled": bool  # Optional. A boolean
                                      flag to enable CDN caching.
                                },
                                "failover_threshold": 0,  # Optional. An integer
                                  value as a percentage to indicate failure threshold to decide how the
                                  regional priorities will take effect. A value of ``50`` would
                                  indicate that the Global load balancer will choose a lower priority
                                  region to forward traffic to once this failure threshold has been
                                  reached for the higher priority region.
                                "region_priorities": {
                                    "str": 0  # Optional. A map of region string
                                      to an integer priority value indicating preference for which
                                      regional target a Global load balancer will forward traffic to. A
                                      lower value indicates a higher priority.
                                },
                                "target_port": 0,  # Optional. An integer
                                  representing the port on the target backends which the load balancer
                                  will forward traffic to.
                                "target_protocol": "str"  # Optional. The protocol
                                  used for forwarding traffic from the load balancer to the target
                                  backends. The possible values are ``http``"" , ``https`` and
                                  ``http2``. Known values are: "http", "https", and "http2".
                            },
                            "health_check": {
                                "check_interval_seconds": 10,  # Optional. Default
                                  value is 10. The number of seconds between between two consecutive
                                  health checks.
                                "healthy_threshold": 3,  # Optional. Default value is
                                  3. The number of times a health check must pass for a backend Droplet
                                  to be marked "healthy" and be re-added to the pool.
                                "path": "/",  # Optional. Default value is "/". The
                                  path on the backend Droplets to which the load balancer instance will
                                  send a request.
                                "port": 80,  # Optional. Default value is 80. An
                                  integer representing the port on the backend Droplets on which the
                                  health check will attempt a connection.
                                "protocol": "http",  # Optional. Default value is
                                  "http". The protocol used for health checks sent to the backend
                                  Droplets. The possible values are ``http``"" , ``https``"" , or
                                  ``tcp``. Known values are: "http", "https", and "tcp".
                                "response_timeout_seconds": 5,  # Optional. Default
                                  value is 5. The number of seconds the load balancer instance will
                                  wait for a response until marking a health check as failed.
                                "unhealthy_threshold": 5  # Optional. Default value
                                  is 5. The number of times a health check must fail for a backend
                                  Droplet to be marked "unhealthy" and be removed from the pool.
                            },
                            "http_idle_timeout_seconds": 60,  # Optional. Default value
                              is 60. An integer value which configures the idle timeout for HTTP
                              requests to the target droplets.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference a load balancer.
                            "ip": "str",  # Optional. An attribute containing the
                              public-facing IP address of the load balancer.
                            "ipv6": "str",  # Optional. An attribute containing the
                              public-facing IPv6 address of the load balancer.
                            "name": "str",  # Optional. A human-readable name for a load
                              balancer instance.
                            "network": "EXTERNAL",  # Optional. Default value is
                              "EXTERNAL". A string indicating whether the load balancer should be
                              external or internal. Internal load balancers have no public IPs and are
                              only accessible to resources on the same VPC network. This property
                              cannot be updated after creating the load balancer. Known values are:
                              "EXTERNAL" and "INTERNAL".
                            "network_stack": "IPV4",  # Optional. Default value is
                              "IPV4". A string indicating whether the load balancer will support IPv4
                              or both IPv4 and IPv6 networking. This property cannot be updated after
                              creating the load balancer. Known values are: "IPV4" and "DUALSTACK".
                            "project_id": "str",  # Optional. The ID of the project that
                              the load balancer is associated with. If no ID is provided at creation,
                              the load balancer associates with the user's default project. If an
                              invalid project ID is provided, the load balancer will not be created.
                            "redirect_http_to_https": False,  # Optional. Default value
                              is False. A boolean value indicating whether HTTP requests to the load
                              balancer on port 80 will be redirected to HTTPS on port 443.
                            "size": "lb-small",  # Optional. Default value is "lb-small".
                              This field has been replaced by the ``size_unit`` field for all regions
                              except in AMS2, NYC2, and SFO1. Each available load balancer size now
                              equates to the load balancer having a set number of nodes.   *
                              ``lb-small`` = 1 node * ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes
                              You can resize load balancers after creation up to once per hour. You
                              cannot resize a load balancer within the first hour of its creation.
                              Known values are: "lb-small", "lb-medium", and "lb-large".
                            "size_unit": 1,  # Optional. Default value is 1. How many
                              nodes the load balancer contains. Each additional node increases the load
                              balancer's ability to manage more connections. Load balancers can be
                              scaled up or down, and you can change the number of nodes after creation
                              up to once per hour. This field is currently not available in the AMS2,
                              NYC2, or SFO1 regions. Use the ``size`` field to scale load balancers
                              that reside in these regions.
                            "status": "str",  # Optional. A status string indicating the
                              current state of the load balancer. This can be ``new``"" , ``active``""
                              , or ``errored``. Known values are: "new", "active", and "errored".
                            "sticky_sessions": {
                                "cookie_name": "str",  # Optional. The name of the
                                  cookie sent to the client. This attribute is only returned when using
                                  ``cookies`` for the sticky sessions type.
                                "cookie_ttl_seconds": 0,  # Optional. The number of
                                  seconds until the cookie set by the load balancer expires. This
                                  attribute is only returned when using ``cookies`` for the sticky
                                  sessions type.
                                "type": "none"  # Optional. Default value is "none".
                                  An attribute indicating how and if requests from a client will be
                                  persistently served by the same backend Droplet. The possible values
                                  are ``cookies`` or ``none``. Known values are: "cookies" and "none".
                            },
                            "tag": "str",  # Optional. The name of a Droplet tag
                              corresponding to Droplets assigned to the load balancer.
                            "target_load_balancer_ids": [
                                "str"  # Optional. An array containing the UUIDs of
                                  the Regional load balancers to be used as target backends for a
                                  Global load balancer.
                            ],
                            "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                              "DEFAULT". A string indicating the policy for the TLS cipher suites used
                              by the load balancer. The possible values are ``DEFAULT`` or ``STRONG``.
                              The default value is ``DEFAULT``. Known values are: "DEFAULT" and
                              "STRONG".
                            "type": "REGIONAL",  # Optional. Default value is "REGIONAL".
                              A string indicating whether the load balancer should be a standard
                              regional HTTP load balancer, a regional network load balancer that routes
                              traffic at the TCP/UDP transport layer, or a global load balancer. Known
                              values are: "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                            "vpc_uuid": "str"  # Optional. A string specifying the UUID
                              of the VPC to which the load balancer is assigned.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_load_balancers_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, lb_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Load Balancer.

        To show information about a load balancer instance, send a GET request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID``.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_load_balancers_get_request(
            lb_id=lb_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        lb_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Load Balancer.

        To update a load balancer's settings, send a PUT request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID``. The request should contain a full
        representation of the load balancer including existing attributes. It may
        contain *one of* the ``droplets_ids`` or ``tag`` attributes as they are mutually
        exclusive. **Note that any attribute that is not provided will be reset to its
        default value.**.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 200
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        lb_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Load Balancer.

        To update a load balancer's settings, send a PUT request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID``. The request should contain a full
        representation of the load balancer including existing attributes. It may
        contain *one of* the ``droplets_ids`` or ``tag`` attributes as they are mutually
        exclusive. **Note that any attribute that is not provided will be reset to its
        default value.**.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(self, lb_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Update a Load Balancer.

        To update a load balancer's settings, send a PUT request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID``. The request should contain a full
        representation of the load balancer including existing attributes. It may
        contain *one of* the ``droplets_ids`` or ``tag`` attributes as they are mutually
        exclusive. **Note that any attribute that is not provided will be reset to its
        default value.**.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 200
                response == {
                    "load_balancer": {
                        "forwarding_rules": [
                            {
                                "entry_port": 0,  # An integer representing the port
                                  on which the load balancer instance will listen. Required.
                                "entry_protocol": "str",  # The protocol used for
                                  traffic to the load balancer. The possible values are: ``http``"" ,
                                  ``https``"" , ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If
                                  you set the  ``entry_protocol`` to ``udp``"" , the
                                  ``target_protocol`` must be set to ``udp``.  When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "http3", "tcp", and "udp".
                                "target_port": 0,  # An integer representing the port
                                  on the backend Droplets to which the load balancer will send traffic.
                                  Required.
                                "target_protocol": "str",  # The protocol used for
                                  traffic from the load balancer to the backend Droplets. The possible
                                  values are: ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or
                                  ``udp``. If you set the ``target_protocol`` to ``udp``"" , the
                                  ``entry_protocol`` must be set to  ``udp``. When using UDP, the load
                                  balancer requires that you set up a health  check with a port that
                                  uses TCP, HTTP, or HTTPS to work properly. Required. Known values
                                  are: "http", "https", "http2", "tcp", and "udp".
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination if enabled.
                                "tls_passthrough": bool  # Optional. A boolean value
                                  indicating whether SSL encrypted traffic will be passed through to
                                  the backend Droplets.
                            }
                        ],
                        "algorithm": "round_robin",  # Optional. Default value is
                          "round_robin". This field has been deprecated. You can no longer specify an
                          algorithm for load balancers. Known values are: "round_robin" and
                          "least_connections".
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the load
                          balancer was created.
                        "disable_lets_encrypt_dns_records": False,  # Optional. Default value
                          is False. A boolean value indicating whether to disable automatic DNS record
                          creation for Let's Encrypt certificates that are added to the load balancer.
                        "domains": [
                            {
                                "certificate_id": "str",  # Optional. The ID of the
                                  TLS certificate used for SSL termination.
                                "is_managed": bool,  # Optional. A boolean value
                                  indicating if the domain is already managed by DigitalOcean. If true,
                                  all A and AAAA records required to enable Global load balancers will
                                  be automatically added.
                                "name": "str"  # Optional. FQDN to associate with a
                                  Global load balancer.
                            }
                        ],
                        "enable_backend_keepalive": False,  # Optional. Default value is
                          False. A boolean value indicating whether HTTP keepalive connections are
                          maintained to target Droplets.
                        "enable_proxy_protocol": False,  # Optional. Default value is False.
                          A boolean value indicating whether PROXY Protocol is in use.
                        "firewall": {
                            "allow": [
                                "str"  # Optional. the rules for allowing traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ],
                            "deny": [
                                "str"  # Optional. the rules for denying traffic to
                                  the load balancer (in the form 'ip:1.2.3.4' or 'cidr:1.2.0.0/16').
                            ]
                        },
                        "glb_settings": {
                            "cdn": {
                                "is_enabled": bool  # Optional. A boolean flag to
                                  enable CDN caching.
                            },
                            "failover_threshold": 0,  # Optional. An integer value as a
                              percentage to indicate failure threshold to decide how the regional
                              priorities will take effect. A value of ``50`` would indicate that the
                              Global load balancer will choose a lower priority region to forward
                              traffic to once this failure threshold has been reached for the higher
                              priority region.
                            "region_priorities": {
                                "str": 0  # Optional. A map of region string to an
                                  integer priority value indicating preference for which regional
                                  target a Global load balancer will forward traffic to. A lower value
                                  indicates a higher priority.
                            },
                            "target_port": 0,  # Optional. An integer representing the
                              port on the target backends which the load balancer will forward traffic
                              to.
                            "target_protocol": "str"  # Optional. The protocol used for
                              forwarding traffic from the load balancer to the target backends. The
                              possible values are ``http``"" , ``https`` and ``http2``. Known values
                              are: "http", "https", and "http2".
                        },
                        "health_check": {
                            "check_interval_seconds": 10,  # Optional. Default value is
                              10. The number of seconds between between two consecutive health checks.
                            "healthy_threshold": 3,  # Optional. Default value is 3. The
                              number of times a health check must pass for a backend Droplet to be
                              marked "healthy" and be re-added to the pool.
                            "path": "/",  # Optional. Default value is "/". The path on
                              the backend Droplets to which the load balancer instance will send a
                              request.
                            "port": 80,  # Optional. Default value is 80. An integer
                              representing the port on the backend Droplets on which the health check
                              will attempt a connection.
                            "protocol": "http",  # Optional. Default value is "http". The
                              protocol used for health checks sent to the backend Droplets. The
                              possible values are ``http``"" , ``https``"" , or ``tcp``. Known values
                              are: "http", "https", and "tcp".
                            "response_timeout_seconds": 5,  # Optional. Default value is
                              5. The number of seconds the load balancer instance will wait for a
                              response until marking a health check as failed.
                            "unhealthy_threshold": 5  # Optional. Default value is 5. The
                              number of times a health check must fail for a backend Droplet to be
                              marked "unhealthy" and be removed from the pool.
                        },
                        "http_idle_timeout_seconds": 60,  # Optional. Default value is 60. An
                          integer value which configures the idle timeout for HTTP requests to the
                          target droplets.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference a load balancer.
                        "ip": "str",  # Optional. An attribute containing the public-facing
                          IP address of the load balancer.
                        "ipv6": "str",  # Optional. An attribute containing the public-facing
                          IPv6 address of the load balancer.
                        "name": "str",  # Optional. A human-readable name for a load balancer
                          instance.
                        "network": "EXTERNAL",  # Optional. Default value is "EXTERNAL". A
                          string indicating whether the load balancer should be external or internal.
                          Internal load balancers have no public IPs and are only accessible to
                          resources on the same VPC network. This property cannot be updated after
                          creating the load balancer. Known values are: "EXTERNAL" and "INTERNAL".
                        "network_stack": "IPV4",  # Optional. Default value is "IPV4". A
                          string indicating whether the load balancer will support IPv4 or both IPv4
                          and IPv6 networking. This property cannot be updated after creating the load
                          balancer. Known values are: "IPV4" and "DUALSTACK".
                        "project_id": "str",  # Optional. The ID of the project that the load
                          balancer is associated with. If no ID is provided at creation, the load
                          balancer associates with the user's default project. If an invalid project ID
                          is provided, the load balancer will not be created.
                        "redirect_http_to_https": False,  # Optional. Default value is False.
                          A boolean value indicating whether HTTP requests to the load balancer on port
                          80 will be redirected to HTTPS on port 443.
                        "size": "lb-small",  # Optional. Default value is "lb-small". This
                          field has been replaced by the ``size_unit`` field for all regions except in
                          AMS2, NYC2, and SFO1. Each available load balancer size now equates to the
                          load balancer having a set number of nodes.   * ``lb-small`` = 1 node *
                          ``lb-medium`` = 3 nodes * ``lb-large`` = 6 nodes  You can resize load
                          balancers after creation up to once per hour. You cannot resize a load
                          balancer within the first hour of its creation. Known values are: "lb-small",
                          "lb-medium", and "lb-large".
                        "size_unit": 1,  # Optional. Default value is 1. How many nodes the
                          load balancer contains. Each additional node increases the load balancer's
                          ability to manage more connections. Load balancers can be scaled up or down,
                          and you can change the number of nodes after creation up to once per hour.
                          This field is currently not available in the AMS2, NYC2, or SFO1 regions. Use
                          the ``size`` field to scale load balancers that reside in these regions.
                        "status": "str",  # Optional. A status string indicating the current
                          state of the load balancer. This can be ``new``"" , ``active``"" , or
                          ``errored``. Known values are: "new", "active", and "errored".
                        "sticky_sessions": {
                            "cookie_name": "str",  # Optional. The name of the cookie
                              sent to the client. This attribute is only returned when using
                              ``cookies`` for the sticky sessions type.
                            "cookie_ttl_seconds": 0,  # Optional. The number of seconds
                              until the cookie set by the load balancer expires. This attribute is only
                              returned when using ``cookies`` for the sticky sessions type.
                            "type": "none"  # Optional. Default value is "none". An
                              attribute indicating how and if requests from a client will be
                              persistently served by the same backend Droplet. The possible values are
                              ``cookies`` or ``none``. Known values are: "cookies" and "none".
                        },
                        "tag": "str",  # Optional. The name of a Droplet tag corresponding to
                          Droplets assigned to the load balancer.
                        "target_load_balancer_ids": [
                            "str"  # Optional. An array containing the UUIDs of the
                              Regional load balancers to be used as target backends for a Global load
                              balancer.
                        ],
                        "tls_cipher_policy": "DEFAULT",  # Optional. Default value is
                          "DEFAULT". A string indicating the policy for the TLS cipher suites used by
                          the load balancer. The possible values are ``DEFAULT`` or ``STRONG``. The
                          default value is ``DEFAULT``. Known values are: "DEFAULT" and "STRONG".
                        "type": "REGIONAL",  # Optional. Default value is "REGIONAL". A
                          string indicating whether the load balancer should be a standard regional
                          HTTP load balancer, a regional network load balancer that routes traffic at
                          the TCP/UDP transport layer, or a global load balancer. Known values are:
                          "REGIONAL", "REGIONAL_NETWORK", and "GLOBAL".
                        "vpc_uuid": "str"  # Optional. A string specifying the UUID of the
                          VPC to which the load balancer is assigned.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_update_request(
            lb_id=lb_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, lb_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Load Balancer.

        To delete a load balancer instance, disassociating any Droplets assigned to it
        and removing it from your account, send a DELETE request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_load_balancers_delete_request(
            lb_id=lb_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_cache(self, lb_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Global Load Balancer CDN Cache.

        To delete a Global load balancer CDN cache, send a DELETE request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/cache``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_load_balancers_delete_cache_request(
            lb_id=lb_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def add_droplets(
        self,
        lb_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Load Balancer.

        To assign a Droplet to a load balancer instance, send a POST request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.
        Individual Droplets can not be added to a load balancer configured with a
        Droplet tag. Attempting to do so will result in a "422 Unprocessable Entity"
        response from the API.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets assigned to the load
                          balancer. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_droplets(
        self,
        lb_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Load Balancer.

        To assign a Droplet to a load balancer instance, send a POST request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.
        Individual Droplets can not be added to a load balancer configured with a
        Droplet tag. Attempting to do so will result in a "422 Unprocessable Entity"
        response from the API.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_droplets(
        self, lb_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Droplets to a Load Balancer.

        To assign a Droplet to a load balancer instance, send a POST request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.
        Individual Droplets can not be added to a load balancer configured with a
        Droplet tag. Attempting to do so will result in a "422 Unprocessable Entity"
        response from the API.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets assigned to the load
                          balancer. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_add_droplets_request(
            lb_id=lb_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def remove_droplets(
        self,
        lb_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Load Balancer.

        To remove a Droplet from a load balancer instance, send a DELETE request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets assigned to the load
                          balancer. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def remove_droplets(
        self,
        lb_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Load Balancer.

        To remove a Droplet from a load balancer instance, send a DELETE request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def remove_droplets(
        self, lb_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Droplets from a Load Balancer.

        To remove a Droplet from a load balancer instance, send a DELETE request to
        ``/v2/load_balancers/$LOAD_BALANCER_ID/droplets``. In the body of the request,
        there should be a ``droplet_ids`` attribute containing a list of Droplet IDs.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "droplet_ids": [
                        0  # An array containing the IDs of the Droplets assigned to the load
                          balancer. Required.
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_remove_droplets_request(
            lb_id=lb_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def add_forwarding_rules(
        self,
        lb_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Forwarding Rules to a Load Balancer.

        To add an additional forwarding rule to a load balancer instance, send a POST
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the body
        of the request, there should be a ``forwarding_rules`` attribute containing an
        array of rules to be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "forwarding_rules": [
                        {
                            "entry_port": 0,  # An integer representing the port on which
                              the load balancer instance will listen. Required.
                            "entry_protocol": "str",  # The protocol used for traffic to
                              the load balancer. The possible values are: ``http``"" , ``https``"" ,
                              ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If you set the
                              ``entry_protocol`` to ``udp``"" , the ``target_protocol`` must be set to
                              ``udp``.  When using UDP, the load balancer requires that you set up a
                              health  check with a port that uses TCP, HTTP, or HTTPS to work properly.
                              Required. Known values are: "http", "https", "http2", "http3", "tcp", and
                              "udp".
                            "target_port": 0,  # An integer representing the port on the
                              backend Droplets to which the load balancer will send traffic. Required.
                            "target_protocol": "str",  # The protocol used for traffic
                              from the load balancer to the backend Droplets. The possible values are:
                              ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or ``udp``. If you
                              set the ``target_protocol`` to ``udp``"" , the ``entry_protocol`` must be
                              set to  ``udp``. When using UDP, the load balancer requires that you set
                              up a health  check with a port that uses TCP, HTTP, or HTTPS to work
                              properly. Required. Known values are: "http", "https", "http2", "tcp",
                              and "udp".
                            "certificate_id": "str",  # Optional. The ID of the TLS
                              certificate used for SSL termination if enabled.
                            "tls_passthrough": bool  # Optional. A boolean value
                              indicating whether SSL encrypted traffic will be passed through to the
                              backend Droplets.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def add_forwarding_rules(
        self,
        lb_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Forwarding Rules to a Load Balancer.

        To add an additional forwarding rule to a load balancer instance, send a POST
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the body
        of the request, there should be a ``forwarding_rules`` attribute containing an
        array of rules to be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def add_forwarding_rules(
        self, lb_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Add Forwarding Rules to a Load Balancer.

        To add an additional forwarding rule to a load balancer instance, send a POST
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the body
        of the request, there should be a ``forwarding_rules`` attribute containing an
        array of rules to be added.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "forwarding_rules": [
                        {
                            "entry_port": 0,  # An integer representing the port on which
                              the load balancer instance will listen. Required.
                            "entry_protocol": "str",  # The protocol used for traffic to
                              the load balancer. The possible values are: ``http``"" , ``https``"" ,
                              ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If you set the
                              ``entry_protocol`` to ``udp``"" , the ``target_protocol`` must be set to
                              ``udp``.  When using UDP, the load balancer requires that you set up a
                              health  check with a port that uses TCP, HTTP, or HTTPS to work properly.
                              Required. Known values are: "http", "https", "http2", "http3", "tcp", and
                              "udp".
                            "target_port": 0,  # An integer representing the port on the
                              backend Droplets to which the load balancer will send traffic. Required.
                            "target_protocol": "str",  # The protocol used for traffic
                              from the load balancer to the backend Droplets. The possible values are:
                              ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or ``udp``. If you
                              set the ``target_protocol`` to ``udp``"" , the ``entry_protocol`` must be
                              set to  ``udp``. When using UDP, the load balancer requires that you set
                              up a health  check with a port that uses TCP, HTTP, or HTTPS to work
                              properly. Required. Known values are: "http", "https", "http2", "tcp",
                              and "udp".
                            "certificate_id": "str",  # Optional. The ID of the TLS
                              certificate used for SSL termination if enabled.
                            "tls_passthrough": bool  # Optional. A boolean value
                              indicating whether SSL encrypted traffic will be passed through to the
                              backend Droplets.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_add_forwarding_rules_request(
            lb_id=lb_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def remove_forwarding_rules(
        self,
        lb_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Forwarding Rules from a Load Balancer.

        To remove forwarding rules from a load balancer instance, send a DELETE
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the
        body of the request, there should be a ``forwarding_rules`` attribute containing
        an array of rules to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "forwarding_rules": [
                        {
                            "entry_port": 0,  # An integer representing the port on which
                              the load balancer instance will listen. Required.
                            "entry_protocol": "str",  # The protocol used for traffic to
                              the load balancer. The possible values are: ``http``"" , ``https``"" ,
                              ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If you set the
                              ``entry_protocol`` to ``udp``"" , the ``target_protocol`` must be set to
                              ``udp``.  When using UDP, the load balancer requires that you set up a
                              health  check with a port that uses TCP, HTTP, or HTTPS to work properly.
                              Required. Known values are: "http", "https", "http2", "http3", "tcp", and
                              "udp".
                            "target_port": 0,  # An integer representing the port on the
                              backend Droplets to which the load balancer will send traffic. Required.
                            "target_protocol": "str",  # The protocol used for traffic
                              from the load balancer to the backend Droplets. The possible values are:
                              ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or ``udp``. If you
                              set the ``target_protocol`` to ``udp``"" , the ``entry_protocol`` must be
                              set to  ``udp``. When using UDP, the load balancer requires that you set
                              up a health  check with a port that uses TCP, HTTP, or HTTPS to work
                              properly. Required. Known values are: "http", "https", "http2", "tcp",
                              and "udp".
                            "certificate_id": "str",  # Optional. The ID of the TLS
                              certificate used for SSL termination if enabled.
                            "tls_passthrough": bool  # Optional. A boolean value
                              indicating whether SSL encrypted traffic will be passed through to the
                              backend Droplets.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def remove_forwarding_rules(
        self,
        lb_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Forwarding Rules from a Load Balancer.

        To remove forwarding rules from a load balancer instance, send a DELETE
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the
        body of the request, there should be a ``forwarding_rules`` attribute containing
        an array of rules to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def remove_forwarding_rules(
        self, lb_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Remove Forwarding Rules from a Load Balancer.

        To remove forwarding rules from a load balancer instance, send a DELETE
        request to ``/v2/load_balancers/$LOAD_BALANCER_ID/forwarding_rules``. In the
        body of the request, there should be a ``forwarding_rules`` attribute containing
        an array of rules to be removed.

        No response body will be sent back, but the response code will indicate
        success. Specifically, the response code will be a 204, which means that the
        action was successful with no returned body data.

        :param lb_id: A unique identifier for a load balancer. Required.
        :type lb_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "forwarding_rules": [
                        {
                            "entry_port": 0,  # An integer representing the port on which
                              the load balancer instance will listen. Required.
                            "entry_protocol": "str",  # The protocol used for traffic to
                              the load balancer. The possible values are: ``http``"" , ``https``"" ,
                              ``http2``"" , ``http3``"" , ``tcp``"" , or ``udp``. If you set the
                              ``entry_protocol`` to ``udp``"" , the ``target_protocol`` must be set to
                              ``udp``.  When using UDP, the load balancer requires that you set up a
                              health  check with a port that uses TCP, HTTP, or HTTPS to work properly.
                              Required. Known values are: "http", "https", "http2", "http3", "tcp", and
                              "udp".
                            "target_port": 0,  # An integer representing the port on the
                              backend Droplets to which the load balancer will send traffic. Required.
                            "target_protocol": "str",  # The protocol used for traffic
                              from the load balancer to the backend Droplets. The possible values are:
                              ``http``"" , ``https``"" , ``http2``"" , ``tcp``"" , or ``udp``. If you
                              set the ``target_protocol`` to ``udp``"" , the ``entry_protocol`` must be
                              set to  ``udp``. When using UDP, the load balancer requires that you set
                              up a health  check with a port that uses TCP, HTTP, or HTTPS to work
                              properly. Required. Known values are: "http", "https", "http2", "tcp",
                              and "udp".
                            "certificate_id": "str",  # Optional. The ID of the TLS
                              certificate used for SSL termination if enabled.
                            "tls_passthrough": bool  # Optional. A boolean value
                              indicating whether SSL encrypted traffic will be passed through to the
                              backend Droplets.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_load_balancers_remove_forwarding_rules_request(
            lb_id=lb_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class MonitoringOperations:  # pylint: disable=too-many-public-methods
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`monitoring` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_alert_policy(
        self, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Alert Policies.

        Returns all alert policies that are configured for the given account. To List all alert
        policies, send a GET request to ``/v2/monitoring/alerts``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "policies": [
                        {
                            "alerts": {
                                "email": [
                                    "str"  # An email to notify on an alert
                                      trigger. Required.
                                ],
                                "slack": [
                                    {
                                        "channel": "str",  # Slack channel to
                                          notify of an alert trigger. Required.
                                        "url": "str"  # Slack Webhook URL.
                                          Required.
                                    }
                                ]
                            },
                            "compare": "str",  # Required. Known values are:
                              "GreaterThan" and "LessThan".
                            "description": "str",  # Required.
                            "enabled": bool,  # Required.
                            "entities": [
                                "str"  # Required.
                            ],
                            "tags": [
                                "str"  # Required.
                            ],
                            "type": "str",  # Required. Known values are:
                              "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                              "v1/insights/droplet/load_15",
                              "v1/insights/droplet/memory_utilization_percent",
                              "v1/insights/droplet/disk_utilization_percent",
                              "v1/insights/droplet/cpu", "v1/insights/droplet/disk_read",
                              "v1/insights/droplet/disk_write",
                              "v1/insights/droplet/public_outbound_bandwidth",
                              "v1/insights/droplet/public_inbound_bandwidth",
                              "v1/insights/droplet/private_outbound_bandwidth",
                              "v1/insights/droplet/private_inbound_bandwidth",
                              "v1/insights/lbaas/avg_cpu_utilization_percent",
                              "v1/insights/lbaas/connection_utilization_percent",
                              "v1/insights/lbaas/droplet_health",
                              "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                              "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                              "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                              "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                              "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                              "v1/insights/lbaas/high_http_request_response_time",
                              "v1/insights/lbaas/high_http_request_response_time_50p",
                              "v1/insights/lbaas/high_http_request_response_time_95p",
                              "v1/insights/lbaas/high_http_request_response_time_99p",
                              "v1/dbaas/alerts/load_15_alerts",
                              "v1/dbaas/alerts/memory_utilization_alerts",
                              "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                              "v1/droplet/autoscale_alerts/current_instances",
                              "v1/droplet/autoscale_alerts/target_instances",
                              "v1/droplet/autoscale_alerts/current_cpu_utilization",
                              "v1/droplet/autoscale_alerts/target_cpu_utilization",
                              "v1/droplet/autoscale_alerts/current_memory_utilization",
                              "v1/droplet/autoscale_alerts/target_memory_utilization",
                              "v1/droplet/autoscale_alerts/scale_up", and
                              "v1/droplet/autoscale_alerts/scale_down".
                            "uuid": "str",  # Required.
                            "value": 0.0,  # Required.
                            "window": "str"  # Required. Known values are: "5m", "10m",
                              "30m", and "1h".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_list_alert_policy_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_alert_policy(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Alert Policy.

        To create a new alert, send a POST request to ``/v2/monitoring/alerts``.

        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "alerts": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "compare": "str",  # Required. Known values are: "GreaterThan" and
                      "LessThan".
                    "description": "str",  # Required.
                    "enabled": bool,  # Required.
                    "entities": [
                        "str"  # Required.
                    ],
                    "tags": [
                        "str"  # Required.
                    ],
                    "type": "str",  # Required. Known values are: "v1/insights/droplet/load_1",
                      "v1/insights/droplet/load_5", "v1/insights/droplet/load_15",
                      "v1/insights/droplet/memory_utilization_percent",
                      "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                      "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                      "v1/insights/droplet/public_outbound_bandwidth",
                      "v1/insights/droplet/public_inbound_bandwidth",
                      "v1/insights/droplet/private_outbound_bandwidth",
                      "v1/insights/droplet/private_inbound_bandwidth",
                      "v1/insights/lbaas/avg_cpu_utilization_percent",
                      "v1/insights/lbaas/connection_utilization_percent",
                      "v1/insights/lbaas/droplet_health",
                      "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                      "v1/insights/lbaas/high_http_request_response_time",
                      "v1/insights/lbaas/high_http_request_response_time_50p",
                      "v1/insights/lbaas/high_http_request_response_time_95p",
                      "v1/insights/lbaas/high_http_request_response_time_99p",
                      "v1/dbaas/alerts/load_15_alerts", "v1/dbaas/alerts/memory_utilization_alerts",
                      "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                      "v1/droplet/autoscale_alerts/current_instances",
                      "v1/droplet/autoscale_alerts/target_instances",
                      "v1/droplet/autoscale_alerts/current_cpu_utilization",
                      "v1/droplet/autoscale_alerts/target_cpu_utilization",
                      "v1/droplet/autoscale_alerts/current_memory_utilization",
                      "v1/droplet/autoscale_alerts/target_memory_utilization",
                      "v1/droplet/autoscale_alerts/scale_up", and
                      "v1/droplet/autoscale_alerts/scale_down".
                    "value": 0.0,  # Required.
                    "window": "str"  # Required. Known values are: "5m", "10m", "30m", and "1h".
                }

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
        """

    @overload
    def create_alert_policy(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Alert Policy.

        To create a new alert, send a POST request to ``/v2/monitoring/alerts``.

        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
        """

    @distributed_trace
    def create_alert_policy(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create Alert Policy.

        To create a new alert, send a POST request to ``/v2/monitoring/alerts``.

        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "alerts": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "compare": "str",  # Required. Known values are: "GreaterThan" and
                      "LessThan".
                    "description": "str",  # Required.
                    "enabled": bool,  # Required.
                    "entities": [
                        "str"  # Required.
                    ],
                    "tags": [
                        "str"  # Required.
                    ],
                    "type": "str",  # Required. Known values are: "v1/insights/droplet/load_1",
                      "v1/insights/droplet/load_5", "v1/insights/droplet/load_15",
                      "v1/insights/droplet/memory_utilization_percent",
                      "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                      "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                      "v1/insights/droplet/public_outbound_bandwidth",
                      "v1/insights/droplet/public_inbound_bandwidth",
                      "v1/insights/droplet/private_outbound_bandwidth",
                      "v1/insights/droplet/private_inbound_bandwidth",
                      "v1/insights/lbaas/avg_cpu_utilization_percent",
                      "v1/insights/lbaas/connection_utilization_percent",
                      "v1/insights/lbaas/droplet_health",
                      "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                      "v1/insights/lbaas/high_http_request_response_time",
                      "v1/insights/lbaas/high_http_request_response_time_50p",
                      "v1/insights/lbaas/high_http_request_response_time_95p",
                      "v1/insights/lbaas/high_http_request_response_time_99p",
                      "v1/dbaas/alerts/load_15_alerts", "v1/dbaas/alerts/memory_utilization_alerts",
                      "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                      "v1/droplet/autoscale_alerts/current_instances",
                      "v1/droplet/autoscale_alerts/target_instances",
                      "v1/droplet/autoscale_alerts/current_cpu_utilization",
                      "v1/droplet/autoscale_alerts/target_cpu_utilization",
                      "v1/droplet/autoscale_alerts/current_memory_utilization",
                      "v1/droplet/autoscale_alerts/target_memory_utilization",
                      "v1/droplet/autoscale_alerts/scale_up", and
                      "v1/droplet/autoscale_alerts/scale_down".
                    "value": 0.0,  # Required.
                    "window": "str"  # Required. Known values are: "5m", "10m", "30m", and "1h".
                }

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_monitoring_create_alert_policy_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_alert_policy(self, alert_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Alert Policy.

        To retrieve a given alert policy, send a GET request to ``/v2/monitoring/alerts/{alert_uuid}``.

        :param alert_uuid: A unique identifier for an alert policy. Required.
        :type alert_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_alert_policy_request(
            alert_uuid=alert_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_alert_policy(
        self,
        alert_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert Policy.

        To update en existing policy, send a PUT request to ``v2/monitoring/alerts/{alert_uuid}``.

        :param alert_uuid: A unique identifier for an alert policy. Required.
        :type alert_uuid: str
        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "alerts": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "compare": "str",  # Required. Known values are: "GreaterThan" and
                      "LessThan".
                    "description": "str",  # Required.
                    "enabled": bool,  # Required.
                    "entities": [
                        "str"  # Required.
                    ],
                    "tags": [
                        "str"  # Required.
                    ],
                    "type": "str",  # Required. Known values are: "v1/insights/droplet/load_1",
                      "v1/insights/droplet/load_5", "v1/insights/droplet/load_15",
                      "v1/insights/droplet/memory_utilization_percent",
                      "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                      "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                      "v1/insights/droplet/public_outbound_bandwidth",
                      "v1/insights/droplet/public_inbound_bandwidth",
                      "v1/insights/droplet/private_outbound_bandwidth",
                      "v1/insights/droplet/private_inbound_bandwidth",
                      "v1/insights/lbaas/avg_cpu_utilization_percent",
                      "v1/insights/lbaas/connection_utilization_percent",
                      "v1/insights/lbaas/droplet_health",
                      "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                      "v1/insights/lbaas/high_http_request_response_time",
                      "v1/insights/lbaas/high_http_request_response_time_50p",
                      "v1/insights/lbaas/high_http_request_response_time_95p",
                      "v1/insights/lbaas/high_http_request_response_time_99p",
                      "v1/dbaas/alerts/load_15_alerts", "v1/dbaas/alerts/memory_utilization_alerts",
                      "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                      "v1/droplet/autoscale_alerts/current_instances",
                      "v1/droplet/autoscale_alerts/target_instances",
                      "v1/droplet/autoscale_alerts/current_cpu_utilization",
                      "v1/droplet/autoscale_alerts/target_cpu_utilization",
                      "v1/droplet/autoscale_alerts/current_memory_utilization",
                      "v1/droplet/autoscale_alerts/target_memory_utilization",
                      "v1/droplet/autoscale_alerts/scale_up", and
                      "v1/droplet/autoscale_alerts/scale_down".
                    "value": 0.0,  # Required.
                    "window": "str"  # Required. Known values are: "5m", "10m", "30m", and "1h".
                }

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_alert_policy(
        self,
        alert_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert Policy.

        To update en existing policy, send a PUT request to ``v2/monitoring/alerts/{alert_uuid}``.

        :param alert_uuid: A unique identifier for an alert policy. Required.
        :type alert_uuid: str
        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_alert_policy(
        self, alert_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert Policy.

        To update en existing policy, send a PUT request to ``v2/monitoring/alerts/{alert_uuid}``.

        :param alert_uuid: A unique identifier for an alert policy. Required.
        :type alert_uuid: str
        :param body: The ``type`` field dictates what type of entity that the alert policy applies to
         and hence what type of entity is passed in the ``entities`` array. If both the ``tags`` array
         and ``entities`` array are empty the alert policy applies to all entities of the relevant type
         that are owned by the user account. Otherwise the following table shows the valid entity types
         for each type of alert policy:

         .. list-table::
            :header-rows: 1

            * - Type
              - Description
              - Valid Entity Type
            * - ``v1/insights/droplet/memory_utilization_percent``
              - alert on the percent of memory utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_read``
              - alert on the rate of disk read I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/load_5``
              - alert on the 5 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/load_15``
              - alert on the 15 minute load average
              - Droplet ID
            * - ``v1/insights/droplet/disk_utilization_percent``
              - alert on the percent of disk utilization
              - Droplet ID
            * - ``v1/insights/droplet/cpu``
              - alert on the percent of CPU utilization
              - Droplet ID
            * - ``v1/insights/droplet/disk_write``
              - alert on the rate of disk write I/O in MBps
              - Droplet ID
            * - ``v1/insights/droplet/public_outbound_bandwidth``
              - alert on the rate of public outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/public_inbound_bandwidth``
              - alert on the rate of public inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_outbound_bandwidth``
              - alert on the rate of private outbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/private_inbound_bandwidth``
              - alert on the rate of private inbound bandwidth in Mbps
              - Droplet ID
            * - ``v1/insights/droplet/load_1``
              - alert on the 1 minute load average
              - Droplet ID
            * - ``v1/insights/lbaas/avg_cpu_utilization_percent``
              - alert on the percent of CPU utilization
              - load balancer ID
            * - ``v1/insights/lbaas/connection_utilization_percent``
              - alert on the percent of connection utilization
              - load balancer ID
            * - ``v1/insights/lbaas/droplet_health``
              - alert on Droplet health status changes
              - load balancer ID
            * - ``v1/insights/lbaas/tls_connections_per_second_utilization_percent``
              - alert on the percent of TLS connections per second utilization (requires at least one
         HTTPS forwarding rule)
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx``
              - alert on the percent increase of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx``
              - alert on the percent increase of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_5xx``
              - alert on the count of 5xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/increase_in_http_error_rate_count_4xx``
              - alert on the count of 4xx level http errors over 5m
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time``
              - alert on high average http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_50p``
              - alert on high 50th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_95p``
              - alert on high 95th percentile http response time
              - load balancer ID
            * - ``v1/insights/lbaas/high_http_request_response_time_99p``
              - alert on high 99th percentile http response time
              - load balancer ID
            * - ``v1/dbaas/alerts/load_15_alerts``
              - alert on 15 minute load average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/memory_utilization_alerts``
              - alert on the percent memory utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/disk_utilization_alerts``
              - alert on the percent disk utilization average across the database cluster
              - database cluster UUID
            * - ``v1/dbaas/alerts/cpu_alerts``
              - alert on the percent CPU usage average across the database cluster
              - database cluster UUID
            * - ``v1/droplet/autoscale_alerts/current_instances``
              - alert on current pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_instances``
              - alert on target pool size
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_cpu_utilization``
              - alert on current average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_cpu_utilization``
              - alert on target average CPU utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/current_memory_utilization``
              - alert on current average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/target_memory_utilization``
              - alert on target average memory utilization
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_up``
              - alert on scale up event
              - autoscale pool ID
            * - ``v1/droplet/autoscale_alerts/scale_down``
              - alert on scale down event
              - autoscale pool ID. Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "alerts": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "compare": "str",  # Required. Known values are: "GreaterThan" and
                      "LessThan".
                    "description": "str",  # Required.
                    "enabled": bool,  # Required.
                    "entities": [
                        "str"  # Required.
                    ],
                    "tags": [
                        "str"  # Required.
                    ],
                    "type": "str",  # Required. Known values are: "v1/insights/droplet/load_1",
                      "v1/insights/droplet/load_5", "v1/insights/droplet/load_15",
                      "v1/insights/droplet/memory_utilization_percent",
                      "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                      "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                      "v1/insights/droplet/public_outbound_bandwidth",
                      "v1/insights/droplet/public_inbound_bandwidth",
                      "v1/insights/droplet/private_outbound_bandwidth",
                      "v1/insights/droplet/private_inbound_bandwidth",
                      "v1/insights/lbaas/avg_cpu_utilization_percent",
                      "v1/insights/lbaas/connection_utilization_percent",
                      "v1/insights/lbaas/droplet_health",
                      "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                      "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                      "v1/insights/lbaas/high_http_request_response_time",
                      "v1/insights/lbaas/high_http_request_response_time_50p",
                      "v1/insights/lbaas/high_http_request_response_time_95p",
                      "v1/insights/lbaas/high_http_request_response_time_99p",
                      "v1/dbaas/alerts/load_15_alerts", "v1/dbaas/alerts/memory_utilization_alerts",
                      "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                      "v1/droplet/autoscale_alerts/current_instances",
                      "v1/droplet/autoscale_alerts/target_instances",
                      "v1/droplet/autoscale_alerts/current_cpu_utilization",
                      "v1/droplet/autoscale_alerts/target_cpu_utilization",
                      "v1/droplet/autoscale_alerts/current_memory_utilization",
                      "v1/droplet/autoscale_alerts/target_memory_utilization",
                      "v1/droplet/autoscale_alerts/scale_up", and
                      "v1/droplet/autoscale_alerts/scale_down".
                    "value": 0.0,  # Required.
                    "window": "str"  # Required. Known values are: "5m", "10m", "30m", and "1h".
                }

                # response body for status code(s): 200
                response == {
                    "policy": {
                        "alerts": {
                            "email": [
                                "str"  # An email to notify on an alert trigger.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "compare": "str",  # Required. Known values are: "GreaterThan" and
                          "LessThan".
                        "description": "str",  # Required.
                        "enabled": bool,  # Required.
                        "entities": [
                            "str"  # Required.
                        ],
                        "tags": [
                            "str"  # Required.
                        ],
                        "type": "str",  # Required. Known values are:
                          "v1/insights/droplet/load_1", "v1/insights/droplet/load_5",
                          "v1/insights/droplet/load_15",
                          "v1/insights/droplet/memory_utilization_percent",
                          "v1/insights/droplet/disk_utilization_percent", "v1/insights/droplet/cpu",
                          "v1/insights/droplet/disk_read", "v1/insights/droplet/disk_write",
                          "v1/insights/droplet/public_outbound_bandwidth",
                          "v1/insights/droplet/public_inbound_bandwidth",
                          "v1/insights/droplet/private_outbound_bandwidth",
                          "v1/insights/droplet/private_inbound_bandwidth",
                          "v1/insights/lbaas/avg_cpu_utilization_percent",
                          "v1/insights/lbaas/connection_utilization_percent",
                          "v1/insights/lbaas/droplet_health",
                          "v1/insights/lbaas/tls_connections_per_second_utilization_percent",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_percentage_4xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_5xx",
                          "v1/insights/lbaas/increase_in_http_error_rate_count_4xx",
                          "v1/insights/lbaas/high_http_request_response_time",
                          "v1/insights/lbaas/high_http_request_response_time_50p",
                          "v1/insights/lbaas/high_http_request_response_time_95p",
                          "v1/insights/lbaas/high_http_request_response_time_99p",
                          "v1/dbaas/alerts/load_15_alerts",
                          "v1/dbaas/alerts/memory_utilization_alerts",
                          "v1/dbaas/alerts/disk_utilization_alerts", "v1/dbaas/alerts/cpu_alerts",
                          "v1/droplet/autoscale_alerts/current_instances",
                          "v1/droplet/autoscale_alerts/target_instances",
                          "v1/droplet/autoscale_alerts/current_cpu_utilization",
                          "v1/droplet/autoscale_alerts/target_cpu_utilization",
                          "v1/droplet/autoscale_alerts/current_memory_utilization",
                          "v1/droplet/autoscale_alerts/target_memory_utilization",
                          "v1/droplet/autoscale_alerts/scale_up", and
                          "v1/droplet/autoscale_alerts/scale_down".
                        "uuid": "str",  # Required.
                        "value": 0.0,  # Required.
                        "window": "str"  # Required. Known values are: "5m", "10m", "30m",
                          and "1h".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_monitoring_update_alert_policy_request(
            alert_uuid=alert_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_alert_policy(self, alert_uuid: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an Alert Policy.

        To delete an alert policy, send a DELETE request to ``/v2/monitoring/alerts/{alert_uuid}``.

        :param alert_uuid: A unique identifier for an alert policy. Required.
        :type alert_uuid: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_monitoring_delete_alert_policy_request(
            alert_uuid=alert_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_droplet_bandwidth_metrics(
        self,
        *,
        host_id: str,
        interface: str,
        direction: str,
        start: str,
        end: str,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Bandwidth Metrics.

        To retrieve bandwidth metrics for a given Droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/bandwidth``. Use the ``interface`` query parameter to specify
        if the results should be for the ``private`` or ``public`` interface. Use the ``direction``
        query parameter to specify if the results should be for ``inbound`` or ``outbound`` traffic.
        The metrics in the response body are in megabits per second (Mbps).

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword interface: The network interface. Known values are: "private" and "public". Required.
        :paramtype interface: str
        :keyword direction: The traffic direction. Known values are: "inbound" and "outbound".
         Required.
        :paramtype direction: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_bandwidth_metrics_request(
            host_id=host_id,
            interface=interface,
            direction=direction,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_cpu_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet CPU Metrics.

        To retrieve CPU metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/cpu``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_cpu_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_filesystem_free_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Filesystem Free Metrics.

        To retrieve filesystem free metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/filesystem_free``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_filesystem_free_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_filesystem_size_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Filesystem Size Metrics.

        To retrieve filesystem size metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/filesystem_size``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_filesystem_size_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_load1_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Load1 Metrics.

        To retrieve 1 minute load average metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/load_1``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_load1_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_load5_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Load5 Metrics.

        To retrieve 5 minute load average metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/load_5``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_load5_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_load15_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Load15 Metrics.

        To retrieve 15 minute load average metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/load_15``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_load15_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_memory_cached_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Cached Memory Metrics.

        To retrieve cached memory metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/memory_cached``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_memory_cached_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_memory_free_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Free Memory Metrics.

        To retrieve free memory metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/memory_free``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_memory_free_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_memory_total_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Total Memory Metrics.

        To retrieve total memory metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/memory_total``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_memory_total_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_memory_available_metrics(
        self, *, host_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Available Memory Metrics.

        To retrieve available memory metrics for a given droplet, send a GET request to
        ``/v2/monitoring/metrics/droplet/memory_available``.

        :keyword host_id: The droplet ID. Required.
        :paramtype host_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_memory_available_metrics_request(
            host_id=host_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_app_memory_percentage_metrics(
        self,
        *,
        app_id: str,
        start: str,
        end: str,
        app_component: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get App Memory Percentage Metrics.

        To retrieve memory percentage metrics for a given app, send a GET request to
        ``/v2/monitoring/metrics/apps/memory_percentage``.

        :keyword app_id: The app UUID. Required.
        :paramtype app_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :keyword app_component: The app component name. Default value is None.
        :paramtype app_component: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_app_memory_percentage_metrics_request(
            app_id=app_id,
            start=start,
            end=end,
            app_component=app_component,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_app_cpu_percentage_metrics(
        self,
        *,
        app_id: str,
        start: str,
        end: str,
        app_component: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get App CPU Percentage Metrics.

        To retrieve cpu percentage metrics for a given app, send a GET request to
        ``/v2/monitoring/metrics/apps/cpu_percentage``.

        :keyword app_id: The app UUID. Required.
        :paramtype app_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :keyword app_component: The app component name. Default value is None.
        :paramtype app_component: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_app_cpu_percentage_metrics_request(
            app_id=app_id,
            start=start,
            end=end,
            app_component=app_component,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_app_restart_count_metrics_yml(
        self,
        *,
        app_id: str,
        start: str,
        end: str,
        app_component: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get App Restart Count Metrics.

        To retrieve restart count metrics for a given app, send a GET request to
        ``/v2/monitoring/metrics/apps/restart_count``.

        :keyword app_id: The app UUID. Required.
        :paramtype app_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :keyword app_component: The app component name. Default value is None.
        :paramtype app_component: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_app_restart_count_metrics_yml_request(
            app_id=app_id,
            start=start,
            end=end,
            app_component=app_component,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_connections_current(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Total Current Active Connections Metrics.

        To retrieve frontend total current active connections for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_connections_current``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_connections_current_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_connections_limit(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Max Connections Limit Metrics.

        To retrieve frontend max connections limit for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/frontend_connections_limit``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_connections_limit_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_cpu_utilization(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Average Percentage CPU Utilization Metrics.

        To retrieve frontend average percentage CPU utilization for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_cpu_utilization``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_cpu_utilization_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_firewall_dropped_bytes(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Firewall Dropped Bytes Metrics.

        To retrieve firewall dropped bytes for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/frontend_firewall_dropped_bytes``. This is currently
        only supported for network load balancers.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_firewall_dropped_bytes_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_firewall_dropped_packets(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Firewall Dropped Packets Metrics.

        To retrieve firewall dropped packets per second for a given load balancer, send a GET request
        to ``/v2/monitoring/metrics/load_balancer/frontend_firewall_dropped_packets``. This is
        currently only supported for network load balancers.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_firewall_dropped_packets_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_http_responses(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend HTTP Rate Of Response Code Metrics.

        To retrieve frontend HTTP rate of response code for a given load balancer, send a GET request
        to ``/v2/monitoring/metrics/load_balancer/frontend_http_responses``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_http_responses_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_http_requests_per_second(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend HTTP Requests Metrics.

        To retrieve frontend HTTP requests per second for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/frontend_http_requests_per_second``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_http_requests_per_second_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_network_throughput_http(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend HTTP Throughput Metrics.

        To retrieve frontend HTTP throughput in bytes per second for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_network_throughput_http``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_network_throughput_http_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_network_throughput_udp(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend UDP Throughput Metrics.

        To retrieve frontend UDP throughput in bytes per second for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_network_throughput_udp``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_network_throughput_udp_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_network_throughput_tcp(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend TCP Throughput Metrics.

        To retrieve frontend TCP throughput in bytes per second for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_network_throughput_tcp``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_network_throughput_tcp_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_nlb_tcp_network_throughput(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Network Load Balancer Frontend TCP Throughput Metrics.

        To retrieve frontend TCP throughput in bytes per second for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_nlb_tcp_network_throughput``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_nlb_tcp_network_throughput_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_nlb_udp_network_throughput(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Network Load Balancer Frontend UDP Throughput Metrics.

        To retrieve frontend UDP throughput in bytes per second for a given load balancer, send a GET
        request to ``/v2/monitoring/metrics/load_balancer/frontend_nlb_udp_network_throughput``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_nlb_udp_network_throughput_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_tls_connections_current(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Current TLS Connections Rate Metrics.

        To retrieve frontend current TLS connections rate for a given load balancer, send a GET request
        to ``/v2/monitoring/metrics/load_balancer/frontend_tls_connections_current``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_tls_connections_current_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_tls_connections_limit(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Max TLS Connections Limit Metrics.

        To retrieve frontend max TLS connections limit for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/frontend_tls_connections_limit``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_tls_connections_limit_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_frontend_tls_connections_exceeding_rate_limit(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Frontend Closed TLS Connections For Exceeded Rate Limit Metrics.

        To retrieve frontend closed TLS connections for exceeded rate limit for a given load balancer,
        send a GET request to
        ``/v2/monitoring/metrics/load_balancer/frontend_tls_connections_exceeding_rate_limit``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_frontend_tls_connections_exceeding_rate_limit_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_session_duration_avg(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Average HTTP Session Duration Metrics.

        To retrieve Droplets average HTTP session duration in seconds for a given load balancer, send a
        GET request to ``/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_avg``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_session_duration_avg_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_session_duration50_p(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets 50th Percentile HTTP Session Duration Metrics.

        To retrieve Droplets 50th percentile HTTP session duration in seconds for a given load
        balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_50p``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_session_duration50_p_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_session_duration95_p(  # pylint: disable=name-too-long
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets 95th Percentile HTTP Session Duration Metrics.

        To retrieve Droplets 95th percentile HTTP session duration in seconds for a given load
        balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_http_session_duration_95p``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_session_duration95_p_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_response_time_avg(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Average HTTP Response Time Metrics.

        To retrieve Droplets average HTTP response time in seconds for a given load balancer, send a
        GET request to ``/v2/monitoring/metrics/load_balancer/droplets_http_response_time_avg``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_response_time_avg_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_response_time50_p(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets 50th Percentile HTTP Response Time Metrics.

        To retrieve Droplets 50th percentile HTTP response time in seconds for a given load balancer,
        send a GET request to ``/v2/monitoring/metrics/load_balancer/droplets_http_response_time_50p``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_response_time50_p_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_response_time95_p(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets 95th Percentile HTTP Response Time Metrics.

        To retrieve Droplets 95th percentile HTTP response time in seconds for a given load balancer,
        send a GET request to ``/v2/monitoring/metrics/load_balancer/droplets_http_response_time_95p``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_response_time95_p_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_response_time99_p(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets 99th Percentile HTTP Response Time Metrics.

        To retrieve Droplets 99th percentile HTTP response time in seconds for a given load balancer,
        send a GET request to ``/v2/monitoring/metrics/load_balancer/droplets_http_response_time_99p``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_response_time99_p_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_queue_size(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Queue Size Metrics.

        To retrieve Droplets queue size for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_queue_size``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_queue_size_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_http_responses(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets HTTP Rate Of Response Code Metrics.

        To retrieve Droplets HTTP rate of response code for a given load balancer, send a GET request
        to ``/v2/monitoring/metrics/load_balancer/droplets_http_responses``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_http_responses_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_connections(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Active Connections Metrics.

        To retrieve Droplets active connections for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_connections``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_connections_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_health_checks(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Health Check Status Metrics.

        To retrieve Droplets health check status for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_health_checks``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_health_checks_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_lb_droplets_downtime(
        self, *, lb_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Load Balancer Droplets Downtime Status Metrics.

        To retrieve Droplets downtime status for a given load balancer, send a GET request to
        ``/v2/monitoring/metrics/load_balancer/droplets_downtime``.

        :keyword lb_id: A unique identifier for a load balancer. Required.
        :paramtype lb_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_lb_droplets_downtime_request(
            lb_id=lb_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_current_instances(
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Current Size.

        To retrieve the current size for a given Droplet Autoscale Pool, send a GET request to
        ``/v2/monitoring/metrics/droplet_autoscale/current_instances``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_autoscale_current_instances_request(
            autoscale_pool_id=autoscale_pool_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_target_instances(
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Target Size.

        To retrieve the target size for a given Droplet Autoscale Pool, send a GET request to
        ``/v2/monitoring/metrics/droplet_autoscale/target_instances``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_droplet_autoscale_target_instances_request(
            autoscale_pool_id=autoscale_pool_id,
            start=start,
            end=end,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_current_cpu_utilization_yml(  # pylint: disable=name-too-long
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Current Average CPU utilization.

        To retrieve the current average CPU utilization for a given Droplet Autoscale Pool, send a GET
        request to ``/v2/monitoring/metrics/droplet_autoscale/current_cpu_utilization``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = (
            build_monitoring_get_droplet_autoscale_current_cpu_utilization_yml_request(
                autoscale_pool_id=autoscale_pool_id,
                start=start,
                end=end,
                headers=_headers,
                params=_params,
            )
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_target_cpu_utilization(  # pylint: disable=name-too-long
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Target Average CPU utilization.

        To retrieve the target average CPU utilization for a given Droplet Autoscale Pool, send a GET
        request to ``/v2/monitoring/metrics/droplet_autoscale/target_cpu_utilization``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = (
            build_monitoring_get_droplet_autoscale_target_cpu_utilization_request(
                autoscale_pool_id=autoscale_pool_id,
                start=start,
                end=end,
                headers=_headers,
                params=_params,
            )
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_current_memory_utilization(  # pylint: disable=name-too-long
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Current Average Memory utilization.

        To retrieve the current average memory utilization for a given Droplet Autoscale Pool, send a
        GET request to ``/v2/monitoring/metrics/droplet_autoscale/current_memory_utilization``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = (
            build_monitoring_get_droplet_autoscale_current_memory_utilization_request(
                autoscale_pool_id=autoscale_pool_id,
                start=start,
                end=end,
                headers=_headers,
                params=_params,
            )
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_droplet_autoscale_target_memory_utilization(  # pylint: disable=name-too-long
        self, *, autoscale_pool_id: str, start: str, end: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Get Droplet Autoscale Pool Target Average Memory utilization.

        To retrieve the target average memory utilization for a given Droplet Autoscale Pool, send a
        GET request to ``/v2/monitoring/metrics/droplet_autoscale/target_memory_utilization``.

        :keyword autoscale_pool_id: A unique identifier for an autoscale pool. Required.
        :paramtype autoscale_pool_id: str
        :keyword start: UNIX timestamp to start metric window. Required.
        :paramtype start: str
        :keyword end: UNIX timestamp to end metric window. Required.
        :paramtype end: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data": {
                        "result": [
                            {
                                "metric": {
                                    "str": "str"  # An object containing the
                                      metric's labels. These labels are key/value pairs that vary
                                      depending on the metric being queried. For example, load balancer
                                      metrics contain a ``lb_id`` label, while Droplet metrics contain
                                      a ``host_id`` label, and App Platform metrics contain a
                                      ``app_component`` label. Required.
                                },
                                "values": [
                                    [
                                        {}
                                    ]
                                ]
                            }
                        ],
                        "resultType": "str"  # Required. "matrix"
                    },
                    "status": "str"  # Required. Known values are: "success" and "error".
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = (
            build_monitoring_get_droplet_autoscale_target_memory_utilization_request(
                autoscale_pool_id=autoscale_pool_id,
                start=start,
                end=end,
                headers=_headers,
                params=_params,
            )
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_destination(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Logging Destination.

        To create a new destination, send a POST request to ``/v2/monitoring/sinks/destinations``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "endpoint": "str",  # host of the OpenSearch cluster. Required.
                        "cluster_name": "str",  # Optional. Name of a managed OpenSearch
                          cluster.
                        "cluster_uuid": "str",  # Optional. A unique identifier for a managed
                          OpenSearch cluster.
                        "credentials": {
                            "password": "str",  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                            "username": "str"  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                        },
                        "index_name": "str",  # Optional. OpenSearch index to send logs to.
                        "retention_days": 14  # Optional. Default value is 14. Number of days
                          to retain logs in an OpenSearch cluster.
                    },
                    "type": "str",  # The destination type. ``opensearch_dbaas`` for a
                      DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an externally
                      managed one. Required. Known values are: "opensearch_dbaas" and "opensearch_ext".
                    "name": "str"  # Optional. destination name.
                }

                # response body for status code(s): 200
                response == {
                    "destination": {
                        "config": {
                            "cluster_name": "str",  # Optional. Name of a managed
                              OpenSearch cluster.
                            "cluster_uuid": "str",  # Optional. A unique identifier for a
                              managed OpenSearch cluster.
                            "endpoint": "str",  # Optional. host of the OpenSearch
                              cluster.
                            "id": "str",  # Optional. A unique identifier for a
                              configuration.
                            "index_name": "str",  # Optional. OpenSearch index to send
                              logs to.
                            "retention_days": 14  # Optional. Default value is 14. Number
                              of days to retain logs in OpenSearch.
                        },
                        "id": "str",  # Optional. A unique identifier for a destination.
                        "name": "str",  # Optional. destination name.
                        "type": "str"  # Optional. The destination type. ``opensearch_dbaas``
                          for a DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an
                          externally managed one. Known values are: "opensearch_dbaas" and
                          "opensearch_ext".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_destination(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Logging Destination.

        To create a new destination, send a POST request to ``/v2/monitoring/sinks/destinations``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "destination": {
                        "config": {
                            "cluster_name": "str",  # Optional. Name of a managed
                              OpenSearch cluster.
                            "cluster_uuid": "str",  # Optional. A unique identifier for a
                              managed OpenSearch cluster.
                            "endpoint": "str",  # Optional. host of the OpenSearch
                              cluster.
                            "id": "str",  # Optional. A unique identifier for a
                              configuration.
                            "index_name": "str",  # Optional. OpenSearch index to send
                              logs to.
                            "retention_days": 14  # Optional. Default value is 14. Number
                              of days to retain logs in OpenSearch.
                        },
                        "id": "str",  # Optional. A unique identifier for a destination.
                        "name": "str",  # Optional. destination name.
                        "type": "str"  # Optional. The destination type. ``opensearch_dbaas``
                          for a DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an
                          externally managed one. Known values are: "opensearch_dbaas" and
                          "opensearch_ext".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_destination(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create Logging Destination.

        To create a new destination, send a POST request to ``/v2/monitoring/sinks/destinations``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "endpoint": "str",  # host of the OpenSearch cluster. Required.
                        "cluster_name": "str",  # Optional. Name of a managed OpenSearch
                          cluster.
                        "cluster_uuid": "str",  # Optional. A unique identifier for a managed
                          OpenSearch cluster.
                        "credentials": {
                            "password": "str",  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                            "username": "str"  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                        },
                        "index_name": "str",  # Optional. OpenSearch index to send logs to.
                        "retention_days": 14  # Optional. Default value is 14. Number of days
                          to retain logs in an OpenSearch cluster.
                    },
                    "type": "str",  # The destination type. ``opensearch_dbaas`` for a
                      DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an externally
                      managed one. Required. Known values are: "opensearch_dbaas" and "opensearch_ext".
                    "name": "str"  # Optional. destination name.
                }

                # response body for status code(s): 200
                response == {
                    "destination": {
                        "config": {
                            "cluster_name": "str",  # Optional. Name of a managed
                              OpenSearch cluster.
                            "cluster_uuid": "str",  # Optional. A unique identifier for a
                              managed OpenSearch cluster.
                            "endpoint": "str",  # Optional. host of the OpenSearch
                              cluster.
                            "id": "str",  # Optional. A unique identifier for a
                              configuration.
                            "index_name": "str",  # Optional. OpenSearch index to send
                              logs to.
                            "retention_days": 14  # Optional. Default value is 14. Number
                              of days to retain logs in OpenSearch.
                        },
                        "id": "str",  # Optional. A unique identifier for a destination.
                        "name": "str",  # Optional. destination name.
                        "type": "str"  # Optional. The destination type. ``opensearch_dbaas``
                          for a DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an
                          externally managed one. Known values are: "opensearch_dbaas" and
                          "opensearch_ext".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_monitoring_create_destination_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_destinations(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Logging Destinations.

        To list all logging destinations, send a GET request to ``/v2/monitoring/sinks/destinations``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "destinations": [
                        {
                            "config": {
                                "cluster_name": "str",  # Optional. Name of a managed
                                  OpenSearch cluster.
                                "cluster_uuid": "str",  # Optional. A unique
                                  identifier for a managed OpenSearch cluster.
                                "endpoint": "str",  # Optional. host of the
                                  OpenSearch cluster.
                                "id": "str",  # Optional. A unique identifier for a
                                  configuration.
                                "index_name": "str",  # Optional. OpenSearch index to
                                  send logs to.
                                "retention_days": 14  # Optional. Default value is
                                  14. Number of days to retain logs in OpenSearch.
                            },
                            "id": "str",  # Optional. A unique identifier for a
                              destination.
                            "name": "str",  # Optional. destination name.
                            "type": "str"  # Optional. The destination type.
                              ``opensearch_dbaas`` for a DigitalOcean managed OpenSearch cluster or
                              ``opensearch_ext`` for an externally managed one. Known values are:
                              "opensearch_dbaas" and "opensearch_ext".
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_list_destinations_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_destination(self, destination_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Logging Destination.

        To get the details of a destination, send a GET request to
        ``/v2/monitoring/sinks/destinations/${destination_uuid}``.

        :param destination_uuid: A unique identifier for a destination. Required.
        :type destination_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "destination": {
                        "config": {
                            "cluster_name": "str",  # Optional. Name of a managed
                              OpenSearch cluster.
                            "cluster_uuid": "str",  # Optional. A unique identifier for a
                              managed OpenSearch cluster.
                            "endpoint": "str",  # Optional. host of the OpenSearch
                              cluster.
                            "id": "str",  # Optional. A unique identifier for a
                              configuration.
                            "index_name": "str",  # Optional. OpenSearch index to send
                              logs to.
                            "retention_days": 14  # Optional. Default value is 14. Number
                              of days to retain logs in OpenSearch.
                        },
                        "id": "str",  # Optional. A unique identifier for a destination.
                        "name": "str",  # Optional. destination name.
                        "type": "str"  # Optional. The destination type. ``opensearch_dbaas``
                          for a DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an
                          externally managed one. Known values are: "opensearch_dbaas" and
                          "opensearch_ext".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_destination_request(
            destination_uuid=destination_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_destination(
        self,
        destination_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logging Destination.

        To update the details of a destination, send a PATCH request to
        ``/v2/monitoring/sinks/destinations/${destination_uuid}``.

        :param destination_uuid: A unique identifier for a destination. Required.
        :type destination_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "endpoint": "str",  # host of the OpenSearch cluster. Required.
                        "cluster_name": "str",  # Optional. Name of a managed OpenSearch
                          cluster.
                        "cluster_uuid": "str",  # Optional. A unique identifier for a managed
                          OpenSearch cluster.
                        "credentials": {
                            "password": "str",  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                            "username": "str"  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                        },
                        "index_name": "str",  # Optional. OpenSearch index to send logs to.
                        "retention_days": 14  # Optional. Default value is 14. Number of days
                          to retain logs in an OpenSearch cluster.
                    },
                    "type": "str",  # The destination type. ``opensearch_dbaas`` for a
                      DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an externally
                      managed one. Required. Known values are: "opensearch_dbaas" and "opensearch_ext".
                    "name": "str"  # Optional. destination name.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_destination(
        self,
        destination_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logging Destination.

        To update the details of a destination, send a PATCH request to
        ``/v2/monitoring/sinks/destinations/${destination_uuid}``.

        :param destination_uuid: A unique identifier for a destination. Required.
        :type destination_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_destination(
        self, destination_uuid: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Update Logging Destination.

        To update the details of a destination, send a PATCH request to
        ``/v2/monitoring/sinks/destinations/${destination_uuid}``.

        :param destination_uuid: A unique identifier for a destination. Required.
        :type destination_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "config": {
                        "endpoint": "str",  # host of the OpenSearch cluster. Required.
                        "cluster_name": "str",  # Optional. Name of a managed OpenSearch
                          cluster.
                        "cluster_uuid": "str",  # Optional. A unique identifier for a managed
                          OpenSearch cluster.
                        "credentials": {
                            "password": "str",  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                            "username": "str"  # Optional. Credentials for an OpenSearch
                              cluster user. Optional if ``cluster_uuid`` is passed.
                        },
                        "index_name": "str",  # Optional. OpenSearch index to send logs to.
                        "retention_days": 14  # Optional. Default value is 14. Number of days
                          to retain logs in an OpenSearch cluster.
                    },
                    "type": "str",  # The destination type. ``opensearch_dbaas`` for a
                      DigitalOcean managed OpenSearch cluster or ``opensearch_ext`` for an externally
                      managed one. Required. Known values are: "opensearch_dbaas" and "opensearch_ext".
                    "name": "str"  # Optional. destination name.
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_monitoring_update_destination_request(
            destination_uuid=destination_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def delete_destination(
        self, destination_uuid: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Logging Destination.

        To delete a destination and all associated sinks, send a DELETE request to
        ``/v2/monitoring/sinks/destinations/${destination_uuid}``.

        :param destination_uuid: A unique identifier for a destination. Required.
        :type destination_uuid: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_monitoring_delete_destination_request(
            destination_uuid=destination_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def create_sink(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Create Sink.

        To create a new sink, send a POST request to ``/v2/monitoring/sinks``. Forwards logs from the
        resources identified in ``resources`` to the specified pre-existing destination.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "destination_uuid": "str",  # Optional. A unique identifier for an
                      already-existing destination.
                    "resources": [
                        {
                            "urn": "str",  # The uniform resource name (URN) for the
                              resource in the format do:resource_type:resource_id. Required.
                            "name": "str"  # Optional. resource name.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_sink(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Create Sink.

        To create a new sink, send a POST request to ``/v2/monitoring/sinks``. Forwards logs from the
        resources identified in ``resources`` to the specified pre-existing destination.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_sink(
        self, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Create Sink.

        To create a new sink, send a POST request to ``/v2/monitoring/sinks``. Forwards logs from the
        resources identified in ``resources`` to the specified pre-existing destination.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "destination_uuid": "str",  # Optional. A unique identifier for an
                      already-existing destination.
                    "resources": [
                        {
                            "urn": "str",  # The uniform resource name (URN) for the
                              resource in the format do:resource_type:resource_id. Required.
                            "name": "str"  # Optional. resource name.
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_monitoring_create_sink_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_sinks(self, *, resource_id: Optional[str] = None, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Lists all sinks.

        To list all sinks, send a GET request to ``/v2/monitoring/sinks``.

        :keyword resource_id: A unique URN for a resource. Default value is None.
        :paramtype resource_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "sinks": [
                        {
                            "destination": {
                                "config": {
                                    "endpoint": "str",  # host of the OpenSearch
                                      cluster. Required.
                                    "cluster_name": "str",  # Optional. Name of a
                                      managed OpenSearch cluster.
                                    "cluster_uuid": "str",  # Optional. A unique
                                      identifier for a managed OpenSearch cluster.
                                    "credentials": {
                                        "password": "str",  # Optional.
                                          Credentials for an OpenSearch cluster user. Optional if
                                          ``cluster_uuid`` is passed.
                                        "username": "str"  # Optional.
                                          Credentials for an OpenSearch cluster user. Optional if
                                          ``cluster_uuid`` is passed.
                                    },
                                    "id": "str",  # Optional. A unique identifier
                                      for a configuration.
                                    "index_name": "str",  # Optional. OpenSearch
                                      index to send logs to.
                                    "retention_days": 0  # Optional. Number of
                                      days to retain logs in OpenSearch (default: 14).
                                },
                                "id": "str",  # Optional. A unique identifier for a
                                  destination.
                                "name": "str",  # Optional. destination name.
                                "type": "str"  # Optional. The destination type.
                                  ``opensearch_dbaas`` for a DigitalOcean managed OpenSearch cluster or
                                  ``opensearch_ext`` for an externally managed one. Known values are:
                                  "opensearch_dbaas" and "opensearch_ext".
                            },
                            "resources": [
                                {
                                    "urn": "str",  # The uniform resource name
                                      (URN) for the resource in the format
                                      do:resource_type:resource_id. Required.
                                    "name": "str"  # Optional. resource name.
                                }
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_list_sinks_request(
            resource_id=resource_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_sink(self, sink_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Sink.

        To get the details of a sink (resources and destination), send a GET request to
        ``/v2/monitoring/sinks/${sink_uuid}``.

        :param sink_uuid: A unique identifier for a sink. Required.
        :type sink_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "sink": {
                        "destination": {
                            "config": {
                                "endpoint": "str",  # host of the OpenSearch cluster.
                                  Required.
                                "cluster_name": "str",  # Optional. Name of a managed
                                  OpenSearch cluster.
                                "cluster_uuid": "str",  # Optional. A unique
                                  identifier for a managed OpenSearch cluster.
                                "credentials": {
                                    "password": "str",  # Optional. Credentials
                                      for an OpenSearch cluster user. Optional if ``cluster_uuid`` is
                                      passed.
                                    "username": "str"  # Optional. Credentials
                                      for an OpenSearch cluster user. Optional if ``cluster_uuid`` is
                                      passed.
                                },
                                "id": "str",  # Optional. A unique identifier for a
                                  configuration.
                                "index_name": "str",  # Optional. OpenSearch index to
                                  send logs to.
                                "retention_days": 0  # Optional. Number of days to
                                  retain logs in OpenSearch (default: 14).
                            },
                            "id": "str",  # Optional. A unique identifier for a
                              destination.
                            "name": "str",  # Optional. destination name.
                            "type": "str"  # Optional. The destination type.
                              ``opensearch_dbaas`` for a DigitalOcean managed OpenSearch cluster or
                              ``opensearch_ext`` for an externally managed one. Known values are:
                              "opensearch_dbaas" and "opensearch_ext".
                        },
                        "resources": [
                            {
                                "urn": "str",  # The uniform resource name (URN) for
                                  the resource in the format do:resource_type:resource_id. Required.
                                "name": "str"  # Optional. resource name.
                            }
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_monitoring_get_sink_request(
            sink_uuid=sink_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_sink(self, sink_uuid: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Sink.

        To delete a sink, send a DELETE request to ``/v2/monitoring/sinks/${sink_uuid}``.

        :param sink_uuid: A unique identifier for a sink. Required.
        :type sink_uuid: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_monitoring_delete_sink_request(
            sink_uuid=sink_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class PartnerAttachmentsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`partner_attachments` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List all partner attachments.

        To list all of the Partner Attachments on your account, send a ``GET`` request to
        ``/v2/partner_network_connect/attachments``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "partner_attachments": [
                        {
                            "bgp": {
                                "local_asn": 0,  # Optional. ASN of the local router.
                                "local_router_ip": "str",  # Optional. IP of the
                                  DigitalOcean router.
                                "peer_asn": 0,  # Optional. ASN of the peer router.
                                "peer_router_ip": "str"  # Optional. IP of the peer
                                  router.
                            },
                            "children": [
                                "str"  # Optional. An array of associated partner
                                  attachment UUIDs.
                            ],
                            "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth
                              (in Mbps) of the connection.
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the partner attachment.
                            "naas_provider": "str",  # Optional. The Network as a Service
                              (NaaS) provider for the partner attachment.
                            "name": "str",  # Optional. The name of the partner
                              attachment. Must be unique and may only contain alphanumeric characters,
                              dashes, and periods.
                            "parent_uuid": "str",  # Optional. Associated partner
                              attachment UUID.
                            "region": "str",  # Optional. The region where the partner
                              attachment is located.
                            "state": "str",  # Optional. The current operational state of
                              the attachment.
                            "vpc_ids": [
                                "str"  # Optional. An array of VPC network IDs.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a new partner attachment.

        To create a new partner attachment, send a ``POST`` request to
        ``/v2/partner_network_connect/attachments`` with a JSON object containing the
        required configuration details.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "connection_bandwidth_in_mbps": 0,  # Bandwidth (in Mbps) of the connection.
                      Required. Known values are: 1000, 2000, 5000, and 10000.
                    "naas_provider": "str",  # Required.
                    "name": "str",  # The name of the partner attachment. Must be unique and may
                      only contain alphanumeric characters, dashes, and periods. Required.
                    "region": "str",  # Required.
                    "vpc_ids": [
                        "str"  # An array of VPCs IDs. Required.
                    ],
                    "bgp": {
                        "auth_key": "str",  # BGP Auth Key. Required.
                        "local_router_ip": "str",  # IP of the DO router. Required.
                        "peer_router_asn": 0,  # ASN of the peer router. Required.
                        "peer_router_ip": "str"  # IP of the Naas Provider router. Required.
                    },
                    "parent_uuid": "str"  # Optional. Optional associated partner attachment
                      UUID.
                }

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a new partner attachment.

        To create a new partner attachment, send a ``POST`` request to
        ``/v2/partner_network_connect/attachments`` with a JSON object containing the
        required configuration details.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a new partner attachment.

        To create a new partner attachment, send a ``POST`` request to
        ``/v2/partner_network_connect/attachments`` with a JSON object containing the
        required configuration details.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "connection_bandwidth_in_mbps": 0,  # Bandwidth (in Mbps) of the connection.
                      Required. Known values are: 1000, 2000, 5000, and 10000.
                    "naas_provider": "str",  # Required.
                    "name": "str",  # The name of the partner attachment. Must be unique and may
                      only contain alphanumeric characters, dashes, and periods. Required.
                    "region": "str",  # Required.
                    "vpc_ids": [
                        "str"  # An array of VPCs IDs. Required.
                    ],
                    "bgp": {
                        "auth_key": "str",  # BGP Auth Key. Required.
                        "local_router_ip": "str",  # IP of the DO router. Required.
                        "peer_router_asn": 0,  # ASN of the peer router. Required.
                        "peer_router_ip": "str"  # IP of the Naas Provider router. Required.
                    },
                    "parent_uuid": "str"  # Optional. Optional associated partner attachment
                      UUID.
                }

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_partner_attachments_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404, 422]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 422:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, pa_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an existing partner attachment.

        To get the details of a partner attachment, send a ``GET`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}``.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_get_request(
            pa_id=pa_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch(
        self,
        pa_id: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an existing partner attachment.

        To update an existing partner attachment, send a ``PATCH`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}`` with a JSON object containing the
        fields to be updated.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch(
        self,
        pa_id: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an existing partner attachment.

        To update an existing partner attachment, send a ``PATCH`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}`` with a JSON object containing the
        fields to be updated.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch(
        self, pa_id: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an existing partner attachment.

        To update an existing partner attachment, send a ``PATCH`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}`` with a JSON object containing the
        fields to be updated.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_partner_attachments_patch_request(
            pa_id=pa_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, pa_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete an existing partner attachment.

        To delete an existing partner attachment, send a ``DELETE`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}``.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "partner_attachment": {
                        "bgp": {
                            "local_asn": 0,  # Optional. ASN of the local router.
                            "local_router_ip": "str",  # Optional. IP of the DigitalOcean
                              router.
                            "peer_asn": 0,  # Optional. ASN of the peer router.
                            "peer_router_ip": "str"  # Optional. IP of the peer router.
                        },
                        "children": [
                            "str"  # Optional. An array of associated partner attachment
                              UUIDs.
                        ],
                        "connection_bandwidth_in_mbps": 0,  # Optional. The bandwidth (in
                          Mbps) of the connection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the partner attachment.
                        "naas_provider": "str",  # Optional. The Network as a Service (NaaS)
                          provider for the partner attachment.
                        "name": "str",  # Optional. The name of the partner attachment. Must
                          be unique and may only contain alphanumeric characters, dashes, and periods.
                        "parent_uuid": "str",  # Optional. Associated partner attachment
                          UUID.
                        "region": "str",  # Optional. The region where the partner attachment
                          is located.
                        "state": "str",  # Optional. The current operational state of the
                          attachment.
                        "vpc_ids": [
                            "str"  # Optional. An array of VPC network IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_delete_request(
            pa_id=pa_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_bgp_auth_key(self, pa_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get current BGP auth key for the partner attachment.

        To get the current BGP auth key for a partner attachment, send a ``GET`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/bgp_auth_key``.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "bgp_auth_key": {}  # Optional. Any object.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_get_bgp_auth_key_request(
            pa_id=pa_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_remote_routes(
        self, pa_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List remote routes for a partner attachment.

        To list all remote routes associated with a partner attachment, send a ``GET`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/remote_routes``.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_list_remote_routes_request(
            pa_id=pa_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_remote_routes(
        self,
        pa_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Set remote routes for a partner attachment.

        To set remote routes for a partner attachment, send a ``PUT`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/remote_routes`` with a JSON object
        containing the remote routes to be set.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_remote_routes(
        self,
        pa_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Set remote routes for a partner attachment.

        To set remote routes for a partner attachment, send a ``PUT`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/remote_routes`` with a JSON object
        containing the remote routes to be set.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_remote_routes(
        self, pa_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Set remote routes for a partner attachment.

        To set remote routes for a partner attachment, send a ``PUT`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/remote_routes`` with a JSON object
        containing the remote routes to be set.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "remote_routes": [
                        {
                            "cidr": "str"  # Optional. A CIDR block representing a remote
                              route.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_partner_attachments_update_remote_routes_request(
            pa_id=pa_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_service_key(self, pa_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get the current service key for the partner attachment.

        To get the current service key for a partner attachment, send a ``GET`` request to
        ``/v2/partner_network_connect/attachments/{pa_id}/service_key``.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "service_key": {}  # Optional. Any object.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_get_service_key_request(
            pa_id=pa_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def create_service_key(self, pa_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Regenerate the service key for the partner attachment.

        This operation generates a new service key for the specified partner attachment.

        :param pa_id: A unique identifier for a partner attachment. Required.
        :type pa_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "service_key": {}  # Optional. Any object.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_partner_attachments_create_service_key_request(
            pa_id=pa_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class ProjectsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`projects` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Projects.

        To list all your projects, send a GET request to ``/v2/projects``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "projects": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "description": "str",  # Optional. The description of the
                              project. The maximum length is 255 characters.
                            "environment": "str",  # Optional. The environment of the
                              project's resources. Known values are: "Development", "Staging", and
                              "Production".
                            "id": "str",  # Optional. The unique universal identifier of
                              this project.
                            "is_default": bool,  # Optional. If true, all resources will
                              be added to this project if no project is specified.
                            "name": "str",  # Optional. The human-readable name for the
                              project. The maximum length is 175 characters and the name must be
                              unique.
                            "owner_id": 0,  # Optional. The integer id of the project
                              owner.
                            "owner_uuid": "str",  # Optional. The unique universal
                              identifier of the project owner.
                            "purpose": "str",  # Optional. The purpose of the project.
                              The maximum length is 255 characters. It can have one of the following
                              values:   * Just trying out DigitalOcean * Class project / Educational
                              purposes * Website or blog * Web Application * Service or API * Mobile
                              Application * Machine learning / AI / Data processing * IoT * Operational
                              / Developer tooling  If another value for purpose is specified, for
                              example, "your custom purpose", your purpose will be stored as ``Other:
                              your custom purpose``.
                            "updated_at": "2020-02-20 00:00:00"  # Optional. A time value
                              given in ISO8601 combined date and time format that represents when the
                              project was updated.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_projects_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Project.

        To create a project, send a POST request to ``/v2/projects``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 201
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Project.

        To create a project, send a POST request to ``/v2/projects``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a Project.

        To create a project, send a POST request to ``/v2/projects``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 201
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_default(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve the Default Project.

        To get your default project, send a GET request to ``/v2/projects/default``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_projects_get_default_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_default(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update the Default Project.

        To update you default project, send a PUT request to ``/v2/projects/default``. All of the
        following attributes must be sent.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_default(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update the Default Project.

        To update you default project, send a PUT request to ``/v2/projects/default``. All of the
        following attributes must be sent.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_default(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Update the Default Project.

        To update you default project, send a PUT request to ``/v2/projects/default``. All of the
        following attributes must be sent.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_update_default_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch_default(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Patch the Default Project.

        To update only specific attributes of your default project, send a PATCH request to
        ``/v2/projects/default``. At least one of the following attributes needs to be sent.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch_default(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Patch the Default Project.

        To update only specific attributes of your default project, send a PATCH request to
        ``/v2/projects/default``. At least one of the following attributes needs to be sent.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch_default(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Patch the Default Project.

        To update only specific attributes of your default project, send a PATCH request to
        ``/v2/projects/default``. At least one of the following attributes needs to be sent.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_patch_default_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, project_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Project.

        To get a project, send a GET request to ``/v2/projects/$PROJECT_ID``.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_projects_get_request(
            project_id=project_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        project_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Project.

        To update a project, send a PUT request to ``/v2/projects/$PROJECT_ID``. All of the following
        attributes must be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        project_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Project.

        To update a project, send a PUT request to ``/v2/projects/$PROJECT_ID``. All of the following
        attributes must be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self, project_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Project.

        To update a project, send a PUT request to ``/v2/projects/$PROJECT_ID``. All of the following
        attributes must be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_update_request(
            project_id=project_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch(
        self,
        project_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Patch a Project.

        To update only specific attributes of a project, send a PATCH request to
        ``/v2/projects/$PROJECT_ID``. At least one of the following attributes needs to be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch(
        self,
        project_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Patch a Project.

        To update only specific attributes of a project, send a PATCH request to
        ``/v2/projects/$PROJECT_ID``. At least one of the following attributes needs to be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch(
        self, project_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Patch a Project.

        To update only specific attributes of a project, send a PATCH request to
        ``/v2/projects/$PROJECT_ID``. At least one of the following attributes needs to be sent.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "created_at": "2020-02-20 00:00:00",  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      created.
                    "description": "str",  # Optional. The description of the project. The
                      maximum length is 255 characters.
                    "environment": "str",  # Optional. The environment of the project's
                      resources. Known values are: "Development", "Staging", and "Production".
                    "id": "str",  # Optional. The unique universal identifier of this project.
                    "is_default": bool,  # Optional. If true, all resources will be added to this
                      project if no project is specified.
                    "name": "str",  # Optional. The human-readable name for the project. The
                      maximum length is 175 characters and the name must be unique.
                    "owner_id": 0,  # Optional. The integer id of the project owner.
                    "owner_uuid": "str",  # Optional. The unique universal identifier of the
                      project owner.
                    "purpose": "str",  # Optional. The purpose of the project. The maximum length
                      is 255 characters. It can have one of the following values:   * Just trying out
                      DigitalOcean * Class project / Educational purposes * Website or blog * Web
                      Application * Service or API * Mobile Application * Machine learning / AI / Data
                      processing * IoT * Operational / Developer tooling  If another value for purpose
                      is specified, for example, "your custom purpose", your purpose will be stored as
                      ``Other: your custom purpose``.
                    "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given in
                      ISO8601 combined date and time format that represents when the project was
                      updated.
                }

                # response body for status code(s): 200
                response == {
                    "project": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          created.
                        "description": "str",  # Optional. The description of the project.
                          The maximum length is 255 characters.
                        "environment": "str",  # Optional. The environment of the project's
                          resources. Known values are: "Development", "Staging", and "Production".
                        "id": "str",  # Optional. The unique universal identifier of this
                          project.
                        "is_default": bool,  # Optional. If true, all resources will be added
                          to this project if no project is specified.
                        "name": "str",  # Optional. The human-readable name for the project.
                          The maximum length is 175 characters and the name must be unique.
                        "owner_id": 0,  # Optional. The integer id of the project owner.
                        "owner_uuid": "str",  # Optional. The unique universal identifier of
                          the project owner.
                        "purpose": "str",  # Optional. The purpose of the project. The
                          maximum length is 255 characters. It can have one of the following values:
                          * Just trying out DigitalOcean * Class project / Educational purposes *
                          Website or blog * Web Application * Service or API * Mobile Application *
                          Machine learning / AI / Data processing * IoT * Operational / Developer
                          tooling  If another value for purpose is specified, for example, "your custom
                          purpose", your purpose will be stored as ``Other: your custom purpose``.
                        "updated_at": "2020-02-20 00:00:00"  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the project was
                          updated.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_patch_request(
            project_id=project_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, project_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an Existing Project.

        To delete a project, send a DELETE request to ``/v2/projects/$PROJECT_ID``. To
        be deleted, a project must not have any resources assigned to it. Any existing
        resources must first be reassigned or destroyed, or you will receive a 412 error.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404, 412
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_projects_delete_request(
            project_id=project_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404, 412]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 412:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_resources(
        self, project_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Project Resources.

        To list all your resources in a project, send a GET request to
        ``/v2/projects/$PROJECT_ID/resources``.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_projects_list_resources_request(
            project_id=project_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def assign_resources(
        self,
        project_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to a Project.

        To assign resources to a project, send a POST request to
        ``/v2/projects/$PROJECT_ID/resources``.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        "str"  # Optional. A list of uniform resource names (URNs) to be
                          added to a project.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def assign_resources(
        self,
        project_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to a Project.

        To assign resources to a project, send a POST request to
        ``/v2/projects/$PROJECT_ID/resources``.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def assign_resources(
        self, project_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to a Project.

        To assign resources to a project, send a POST request to
        ``/v2/projects/$PROJECT_ID/resources``.

        :param project_id: A unique identifier for a project. Required.
        :type project_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        "str"  # Optional. A list of uniform resource names (URNs) to be
                          added to a project.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_assign_resources_request(
            project_id=project_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_resources_default(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Default Project Resources.

        To list all your resources in your default project, send a GET request to
        ``/v2/projects/default/resources``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_projects_list_resources_default_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def assign_resources_default(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to Default Project.

        To assign resources to your default project, send a POST request to
        ``/v2/projects/default/resources``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        "str"  # Optional. A list of uniform resource names (URNs) to be
                          added to a project.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def assign_resources_default(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to Default Project.

        To assign resources to your default project, send a POST request to
        ``/v2/projects/default/resources``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def assign_resources_default(
        self, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Assign Resources to Default Project.

        To assign resources to your default project, send a POST request to
        ``/v2/projects/default/resources``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        "str"  # Optional. A list of uniform resource names (URNs) to be
                          added to a project.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "resources": [
                        {
                            "assigned_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the project was created.
                            "links": {
                                "self": "str"  # Optional. A URI that can be used to
                                  retrieve the resource.
                            },
                            "status": "str",  # Optional. The status of assigning and
                              fetching the resources. Known values are: "ok", "not_found", "assigned",
                              "already_assigned", and "service_down".
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_projects_assign_resources_default_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class RegionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`regions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Data Center Regions.

        To list all of the regions that are available, send a GET request to ``/v2/regions``.
        The response will be a JSON object with a key called ``regions``. The value of this will be an
        array of ``region`` objects, each of which will contain the standard region attributes.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "regions": [
                        {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_regions_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class RegistryOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`registry` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def get(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Container Registry Information.

        To get information about your container registry, send a GET request to ``/v2/registry``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "registry": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the registry
                          was created.
                        "name": "str",  # Optional. A globally unique name for the container
                          registry. Must be lowercase and be composed only of numbers, letters and
                          ``-``"" , up to a limit of 63 characters.
                        "region": "str",  # Optional. Slug of the region where registry data
                          is stored.
                        "storage_usage_bytes": 0,  # Optional. The amount of storage used in
                          the registry in bytes.
                        "storage_usage_bytes_updated_at": "2020-02-20 00:00:00",  # Optional.
                          The time at which the storage usage was updated. Storage usage is calculated
                          asynchronously, and may not immediately reflect pushes to the registry.
                        "subscription": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The time at
                              which the subscription was created.
                            "tier": {
                                "allow_storage_overage": bool,  # Optional. A boolean
                                  indicating whether the subscription tier supports additional storage
                                  above what is included in the base plan at an additional cost per GiB
                                  used.
                                "included_bandwidth_bytes": 0,  # Optional. The
                                  amount of outbound data transfer included in the subscription tier in
                                  bytes.
                                "included_repositories": 0,  # Optional. The number
                                  of repositories included in the subscription tier. ``0`` indicates
                                  that the subscription tier includes unlimited repositories.
                                "included_storage_bytes": 0,  # Optional. The amount
                                  of storage included in the subscription tier in bytes.
                                "monthly_price_in_cents": 0,  # Optional. The monthly
                                  cost of the subscription tier in cents.
                                "name": "str",  # Optional. The name of the
                                  subscription tier.
                                "slug": "str",  # Optional. The slug identifier of
                                  the subscription tier.
                                "storage_overage_price_in_cents": 0  # Optional. The
                                  price paid in cents per GiB for additional storage beyond what is
                                  included in the subscription plan.
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time at
                              which the subscription was last updated.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_get_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Container Registry.

        To create your container registry, send a POST request to ``/v2/registry``.

        The ``name`` becomes part of the URL for images stored in the registry. For
        example, if your registry is called ``example``\\ , an image in it will have the
        URL ``registry.digitalocean.com/example/image:tag``.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A globally unique name for the container registry. Must be
                      lowercase and be composed only of numbers, letters and ``-``"" , up to a limit of
                      63 characters. Required.
                    "subscription_tier_slug": "str",  # The slug of the subscription tier to sign
                      up for. Valid values can be retrieved using the options endpoint. Required. Known
                      values are: "starter", "basic", and "professional".
                    "region": "str"  # Optional. Slug of the region where registry data is
                      stored. When not provided, a region will be selected. Known values are: "nyc3",
                      "sfo3", "ams3", "sgp1", and "fra1".
                }

                # response body for status code(s): 201
                response == {
                    "registry": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the registry
                          was created.
                        "name": "str",  # Optional. A globally unique name for the container
                          registry. Must be lowercase and be composed only of numbers, letters and
                          ``-``"" , up to a limit of 63 characters.
                        "region": "str",  # Optional. Slug of the region where registry data
                          is stored.
                        "storage_usage_bytes": 0,  # Optional. The amount of storage used in
                          the registry in bytes.
                        "storage_usage_bytes_updated_at": "2020-02-20 00:00:00",  # Optional.
                          The time at which the storage usage was updated. Storage usage is calculated
                          asynchronously, and may not immediately reflect pushes to the registry.
                        "subscription": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The time at
                              which the subscription was created.
                            "tier": {
                                "allow_storage_overage": bool,  # Optional. A boolean
                                  indicating whether the subscription tier supports additional storage
                                  above what is included in the base plan at an additional cost per GiB
                                  used.
                                "included_bandwidth_bytes": 0,  # Optional. The
                                  amount of outbound data transfer included in the subscription tier in
                                  bytes.
                                "included_repositories": 0,  # Optional. The number
                                  of repositories included in the subscription tier. ``0`` indicates
                                  that the subscription tier includes unlimited repositories.
                                "included_storage_bytes": 0,  # Optional. The amount
                                  of storage included in the subscription tier in bytes.
                                "monthly_price_in_cents": 0,  # Optional. The monthly
                                  cost of the subscription tier in cents.
                                "name": "str",  # Optional. The name of the
                                  subscription tier.
                                "slug": "str",  # Optional. The slug identifier of
                                  the subscription tier.
                                "storage_overage_price_in_cents": 0  # Optional. The
                                  price paid in cents per GiB for additional storage beyond what is
                                  included in the subscription plan.
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time at
                              which the subscription was last updated.
                        }
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Container Registry.

        To create your container registry, send a POST request to ``/v2/registry``.

        The ``name`` becomes part of the URL for images stored in the registry. For
        example, if your registry is called ``example``\\ , an image in it will have the
        URL ``registry.digitalocean.com/example/image:tag``.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "registry": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the registry
                          was created.
                        "name": "str",  # Optional. A globally unique name for the container
                          registry. Must be lowercase and be composed only of numbers, letters and
                          ``-``"" , up to a limit of 63 characters.
                        "region": "str",  # Optional. Slug of the region where registry data
                          is stored.
                        "storage_usage_bytes": 0,  # Optional. The amount of storage used in
                          the registry in bytes.
                        "storage_usage_bytes_updated_at": "2020-02-20 00:00:00",  # Optional.
                          The time at which the storage usage was updated. Storage usage is calculated
                          asynchronously, and may not immediately reflect pushes to the registry.
                        "subscription": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The time at
                              which the subscription was created.
                            "tier": {
                                "allow_storage_overage": bool,  # Optional. A boolean
                                  indicating whether the subscription tier supports additional storage
                                  above what is included in the base plan at an additional cost per GiB
                                  used.
                                "included_bandwidth_bytes": 0,  # Optional. The
                                  amount of outbound data transfer included in the subscription tier in
                                  bytes.
                                "included_repositories": 0,  # Optional. The number
                                  of repositories included in the subscription tier. ``0`` indicates
                                  that the subscription tier includes unlimited repositories.
                                "included_storage_bytes": 0,  # Optional. The amount
                                  of storage included in the subscription tier in bytes.
                                "monthly_price_in_cents": 0,  # Optional. The monthly
                                  cost of the subscription tier in cents.
                                "name": "str",  # Optional. The name of the
                                  subscription tier.
                                "slug": "str",  # Optional. The slug identifier of
                                  the subscription tier.
                                "storage_overage_price_in_cents": 0  # Optional. The
                                  price paid in cents per GiB for additional storage beyond what is
                                  included in the subscription plan.
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time at
                              which the subscription was last updated.
                        }
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create Container Registry.

        To create your container registry, send a POST request to ``/v2/registry``.

        The ``name`` becomes part of the URL for images stored in the registry. For
        example, if your registry is called ``example``\\ , an image in it will have the
        URL ``registry.digitalocean.com/example/image:tag``.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A globally unique name for the container registry. Must be
                      lowercase and be composed only of numbers, letters and ``-``"" , up to a limit of
                      63 characters. Required.
                    "subscription_tier_slug": "str",  # The slug of the subscription tier to sign
                      up for. Valid values can be retrieved using the options endpoint. Required. Known
                      values are: "starter", "basic", and "professional".
                    "region": "str"  # Optional. Slug of the region where registry data is
                      stored. When not provided, a region will be selected. Known values are: "nyc3",
                      "sfo3", "ams3", "sgp1", and "fra1".
                }

                # response body for status code(s): 201
                response == {
                    "registry": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the registry
                          was created.
                        "name": "str",  # Optional. A globally unique name for the container
                          registry. Must be lowercase and be composed only of numbers, letters and
                          ``-``"" , up to a limit of 63 characters.
                        "region": "str",  # Optional. Slug of the region where registry data
                          is stored.
                        "storage_usage_bytes": 0,  # Optional. The amount of storage used in
                          the registry in bytes.
                        "storage_usage_bytes_updated_at": "2020-02-20 00:00:00",  # Optional.
                          The time at which the storage usage was updated. Storage usage is calculated
                          asynchronously, and may not immediately reflect pushes to the registry.
                        "subscription": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The time at
                              which the subscription was created.
                            "tier": {
                                "allow_storage_overage": bool,  # Optional. A boolean
                                  indicating whether the subscription tier supports additional storage
                                  above what is included in the base plan at an additional cost per GiB
                                  used.
                                "included_bandwidth_bytes": 0,  # Optional. The
                                  amount of outbound data transfer included in the subscription tier in
                                  bytes.
                                "included_repositories": 0,  # Optional. The number
                                  of repositories included in the subscription tier. ``0`` indicates
                                  that the subscription tier includes unlimited repositories.
                                "included_storage_bytes": 0,  # Optional. The amount
                                  of storage included in the subscription tier in bytes.
                                "monthly_price_in_cents": 0,  # Optional. The monthly
                                  cost of the subscription tier in cents.
                                "name": "str",  # Optional. The name of the
                                  subscription tier.
                                "slug": "str",  # Optional. The slug identifier of
                                  the subscription tier.
                                "storage_overage_price_in_cents": 0  # Optional. The
                                  price paid in cents per GiB for additional storage beyond what is
                                  included in the subscription plan.
                            },
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time at
                              which the subscription was last updated.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_registry_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Container Registry.

        To delete your container registry, destroying all container image data stored in it, send a
        DELETE request to ``/v2/registry``.

        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_registry_delete_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_subscription(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Subscription Information.

        A subscription is automatically created when you configure your container registry. To get
        information about your subscription, send a GET request to ``/v2/registry/subscription``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "subscription": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time at which
                          the subscription was created.
                        "tier": {
                            "allow_storage_overage": bool,  # Optional. A boolean
                              indicating whether the subscription tier supports additional storage
                              above what is included in the base plan at an additional cost per GiB
                              used.
                            "included_bandwidth_bytes": 0,  # Optional. The amount of
                              outbound data transfer included in the subscription tier in bytes.
                            "included_repositories": 0,  # Optional. The number of
                              repositories included in the subscription tier. ``0`` indicates that the
                              subscription tier includes unlimited repositories.
                            "included_storage_bytes": 0,  # Optional. The amount of
                              storage included in the subscription tier in bytes.
                            "monthly_price_in_cents": 0,  # Optional. The monthly cost of
                              the subscription tier in cents.
                            "name": "str",  # Optional. The name of the subscription
                              tier.
                            "slug": "str",  # Optional. The slug identifier of the
                              subscription tier.
                            "storage_overage_price_in_cents": 0  # Optional. The price
                              paid in cents per GiB for additional storage beyond what is included in
                              the subscription plan.
                        },
                        "updated_at": "2020-02-20 00:00:00"  # Optional. The time at which
                          the subscription was last updated.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_get_subscription_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_subscription(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Subscription Tier.

        After creating your registry, you can switch to a different subscription tier to better suit
        your needs. To do this, send a POST request to ``/v2/registry/subscription``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tier_slug": "str"  # Optional. The slug of the subscription tier to sign up
                      for. Known values are: "starter", "basic", and "professional".
                }

                # response body for status code(s): 200
                response == {
                    "subscription": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time at which
                          the subscription was created.
                        "tier": {
                            "allow_storage_overage": bool,  # Optional. A boolean
                              indicating whether the subscription tier supports additional storage
                              above what is included in the base plan at an additional cost per GiB
                              used.
                            "included_bandwidth_bytes": 0,  # Optional. The amount of
                              outbound data transfer included in the subscription tier in bytes.
                            "included_repositories": 0,  # Optional. The number of
                              repositories included in the subscription tier. ``0`` indicates that the
                              subscription tier includes unlimited repositories.
                            "included_storage_bytes": 0,  # Optional. The amount of
                              storage included in the subscription tier in bytes.
                            "monthly_price_in_cents": 0,  # Optional. The monthly cost of
                              the subscription tier in cents.
                            "name": "str",  # Optional. The name of the subscription
                              tier.
                            "slug": "str",  # Optional. The slug identifier of the
                              subscription tier.
                            "storage_overage_price_in_cents": 0  # Optional. The price
                              paid in cents per GiB for additional storage beyond what is included in
                              the subscription plan.
                        },
                        "updated_at": "2020-02-20 00:00:00"  # Optional. The time at which
                          the subscription was last updated.
                    }
                }
        """

    @overload
    def update_subscription(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Subscription Tier.

        After creating your registry, you can switch to a different subscription tier to better suit
        your needs. To do this, send a POST request to ``/v2/registry/subscription``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "subscription": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time at which
                          the subscription was created.
                        "tier": {
                            "allow_storage_overage": bool,  # Optional. A boolean
                              indicating whether the subscription tier supports additional storage
                              above what is included in the base plan at an additional cost per GiB
                              used.
                            "included_bandwidth_bytes": 0,  # Optional. The amount of
                              outbound data transfer included in the subscription tier in bytes.
                            "included_repositories": 0,  # Optional. The number of
                              repositories included in the subscription tier. ``0`` indicates that the
                              subscription tier includes unlimited repositories.
                            "included_storage_bytes": 0,  # Optional. The amount of
                              storage included in the subscription tier in bytes.
                            "monthly_price_in_cents": 0,  # Optional. The monthly cost of
                              the subscription tier in cents.
                            "name": "str",  # Optional. The name of the subscription
                              tier.
                            "slug": "str",  # Optional. The slug identifier of the
                              subscription tier.
                            "storage_overage_price_in_cents": 0  # Optional. The price
                              paid in cents per GiB for additional storage beyond what is included in
                              the subscription plan.
                        },
                        "updated_at": "2020-02-20 00:00:00"  # Optional. The time at which
                          the subscription was last updated.
                    }
                }
        """

    @distributed_trace
    def update_subscription(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Subscription Tier.

        After creating your registry, you can switch to a different subscription tier to better suit
        your needs. To do this, send a POST request to ``/v2/registry/subscription``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "tier_slug": "str"  # Optional. The slug of the subscription tier to sign up
                      for. Known values are: "starter", "basic", and "professional".
                }

                # response body for status code(s): 200
                response == {
                    "subscription": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time at which
                          the subscription was created.
                        "tier": {
                            "allow_storage_overage": bool,  # Optional. A boolean
                              indicating whether the subscription tier supports additional storage
                              above what is included in the base plan at an additional cost per GiB
                              used.
                            "included_bandwidth_bytes": 0,  # Optional. The amount of
                              outbound data transfer included in the subscription tier in bytes.
                            "included_repositories": 0,  # Optional. The number of
                              repositories included in the subscription tier. ``0`` indicates that the
                              subscription tier includes unlimited repositories.
                            "included_storage_bytes": 0,  # Optional. The amount of
                              storage included in the subscription tier in bytes.
                            "monthly_price_in_cents": 0,  # Optional. The monthly cost of
                              the subscription tier in cents.
                            "name": "str",  # Optional. The name of the subscription
                              tier.
                            "slug": "str",  # Optional. The slug identifier of the
                              subscription tier.
                            "storage_overage_price_in_cents": 0  # Optional. The price
                              paid in cents per GiB for additional storage beyond what is included in
                              the subscription plan.
                        },
                        "updated_at": "2020-02-20 00:00:00"  # Optional. The time at which
                          the subscription was last updated.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_registry_update_subscription_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_docker_credentials(
        self, *, expiry_seconds: int = 0, read_write: bool = False, **kwargs: Any
    ) -> JSON:
        """Get Docker Credentials for Container Registry.

        In order to access your container registry with the Docker client or from a
        Kubernetes cluster, you will need to configure authentication. The necessary
        JSON configuration can be retrieved by sending a GET request to
        ``/v2/registry/docker-credentials``.

        The response will be in the format of a Docker ``config.json`` file. To use the
        config in your Kubernetes cluster, create a Secret with:

        .. code-block::

           kubectl create secret generic docr \\
             --from-file=.dockerconfigjson=config.json \\
             --type=kubernetes.io/dockerconfigjson


        By default, the returned credentials have read-only access to your registry
        and cannot be used to push images. This is appropriate for most Kubernetes
        clusters. To retrieve read/write credentials, suitable for use with the Docker
        client or in a CI system, read_write may be provided as query parameter. For
        example: ``/v2/registry/docker-credentials?read_write=true``

        By default, the returned credentials will not expire. To retrieve credentials
        with an expiry set, expiry_seconds may be provided as a query parameter. For
        example: ``/v2/registry/docker-credentials?expiry_seconds=3600`` will return
        credentials that expire after one hour.

        :keyword expiry_seconds: The duration in seconds that the returned registry credentials will be
         valid. If not set or 0, the credentials will not expire. Default value is 0.
        :paramtype expiry_seconds: int
        :keyword read_write: By default, the registry credentials allow for read-only access. Set this
         query parameter to ``true`` to obtain read-write credentials. Default value is False.
        :paramtype read_write: bool
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "auths": {
                        "registry.digitalocean.com": {
                            "auth": "str"  # Optional. A base64 encoded string containing
                              credentials for the container registry.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_get_docker_credentials_request(
            expiry_seconds=expiry_seconds,
            read_write=read_write,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def validate_name(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Validate a Container Registry Name.

        To validate that a container registry name is available for use, send a POST
        request to ``/v2/registry/validate-name``.

        If the name is both formatted correctly and available, the response code will
        be 204 and contain no body. If the name is already in use, the response will
        be a 409 Conflict.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # A globally unique name for the container registry. Must be
                      lowercase and be composed only of numbers, letters and ``-``"" , up to a limit of
                      63 characters. Required.
                }

                # response body for status code(s): 409
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def validate_name(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Validate a Container Registry Name.

        To validate that a container registry name is available for use, send a POST
        request to ``/v2/registry/validate-name``.

        If the name is both formatted correctly and available, the response code will
        be 204 and contain no body. If the name is already in use, the response will
        be a 409 Conflict.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 409
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def validate_name(
        self, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Validate a Container Registry Name.

        To validate that a container registry name is available for use, send a POST
        request to ``/v2/registry/validate-name``.

        If the name is both formatted correctly and available, the response code will
        be 204 and contain no body. If the name is already in use, the response will
        be a 409 Conflict.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # A globally unique name for the container registry. Must be
                      lowercase and be composed only of numbers, letters and ``-``"" , up to a limit of
                      63 characters. Required.
                }

                # response body for status code(s): 409
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_registry_validate_name_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 409]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 409:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_repositories(
        self, registry_name: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Container Registry Repositories.

        This endpoint has been deprecated in favor of the *List All Container Registry Repositories
        [V2]* endpoint.

        To list all repositories in your container registry, send a GET
        request to ``/v2/registry/$REGISTRY_NAME/repositories``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "repositories": [
                        {
                            "latest_tag": {
                                "compressed_size_bytes": 0,  # Optional. The
                                  compressed size of the tag in bytes.
                                "manifest_digest": "str",  # Optional. The digest of
                                  the manifest associated with the tag.
                                "registry_name": "str",  # Optional. The name of the
                                  container registry.
                                "repository": "str",  # Optional. The name of the
                                  repository.
                                "size_bytes": 0,  # Optional. The uncompressed size
                                  of the tag in bytes (this size is calculated asynchronously so it may
                                  not be immediately available).
                                "tag": "str",  # Optional. The name of the tag.
                                "updated_at": "2020-02-20 00:00:00"  # Optional. The
                                  time the tag was last updated.
                            },
                            "name": "str",  # Optional. The name of the repository.
                            "registry_name": "str",  # Optional. The name of the
                              container registry.
                            "tag_count": 0  # Optional. The number of tags in the
                              repository.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_list_repositories_request(
            registry_name=registry_name,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_repositories_v2(
        self,
        registry_name: str,
        *,
        per_page: int = 20,
        page: int = 1,
        page_token: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Container Registry Repositories (V2).

        To list all repositories in your container registry, send a GET request to
        ``/v2/registry/$REGISTRY_NAME/repositoriesV2``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Ignored when 'page_token' is
         provided. Default value is 1.
        :paramtype page: int
        :keyword page_token: Token to retrieve of the next or previous set of results more quickly than
         using 'page'. Default value is None.
        :paramtype page_token: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "repositories": [
                        {
                            "latest_manifest": {
                                "blobs": [
                                    {
                                        "compressed_size_bytes": 0,  #
                                          Optional. The compressed size of the blob in bytes.
                                        "digest": "str"  # Optional. The
                                          digest of the blob.
                                    }
                                ],
                                "compressed_size_bytes": 0,  # Optional. The
                                  compressed size of the manifest in bytes.
                                "digest": "str",  # Optional. The manifest digest.
                                "registry_name": "str",  # Optional. The name of the
                                  container registry.
                                "repository": "str",  # Optional. The name of the
                                  repository.
                                "size_bytes": 0,  # Optional. The uncompressed size
                                  of the manifest in bytes (this size is calculated asynchronously so
                                  it may not be immediately available).
                                "tags": [
                                    "str"  # Optional. All tags associated with
                                      this manifest.
                                ],
                                "updated_at": "2020-02-20 00:00:00"  # Optional. The
                                  time the manifest was last updated.
                            },
                            "manifest_count": 0,  # Optional. The number of manifests in
                              the repository.
                            "name": "str",  # Optional. The name of the repository.
                            "registry_name": "str",  # Optional. The name of the
                              container registry.
                            "tag_count": 0  # Optional. The number of tags in the
                              repository.
                        }
                    ]
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_list_repositories_v2_request(
            registry_name=registry_name,
            per_page=per_page,
            page=page,
            page_token=page_token,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_repository_tags(
        self,
        registry_name: str,
        repository_name: str,
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Container Registry Repository Tags.

        To list all tags in your container registry repository, send a GET
        request to ``/v2/registry/$REGISTRY_NAME/repositories/$REPOSITORY_NAME/tags``.

        Note that if your repository name contains ``/`` characters, it must be
        URL-encoded in the request URL. For example, to list tags for
        ``registry.digitalocean.com/example/my/repo``\\ , the path would be
        ``/v2/registry/example/repositories/my%2Frepo/tags``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param repository_name: The name of a container registry repository. If the name contains ``/``
         characters, they must be URL-encoded, e.g. ``%2F``. Required.
        :type repository_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "tags": [
                        {
                            "compressed_size_bytes": 0,  # Optional. The compressed size
                              of the tag in bytes.
                            "manifest_digest": "str",  # Optional. The digest of the
                              manifest associated with the tag.
                            "registry_name": "str",  # Optional. The name of the
                              container registry.
                            "repository": "str",  # Optional. The name of the repository.
                            "size_bytes": 0,  # Optional. The uncompressed size of the
                              tag in bytes (this size is calculated asynchronously so it may not be
                              immediately available).
                            "tag": "str",  # Optional. The name of the tag.
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time the
                              tag was last updated.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_list_repository_tags_request(
            registry_name=registry_name,
            repository_name=repository_name,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_repository_tag(
        self,
        registry_name: str,
        repository_name: str,
        repository_tag: str,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Container Registry Repository Tag.

        To delete a container repository tag, send a DELETE request to
        ``/v2/registry/$REGISTRY_NAME/repositories/$REPOSITORY_NAME/tags/$TAG``.

        Note that if your repository name contains ``/`` characters, it must be
        URL-encoded in the request URL. For example, to delete
        ``registry.digitalocean.com/example/my/repo:mytag``\\ , the path would be
        ``/v2/registry/example/repositories/my%2Frepo/tags/mytag``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param repository_name: The name of a container registry repository. If the name contains ``/``
         characters, they must be URL-encoded, e.g. ``%2F``. Required.
        :type repository_name: str
        :param repository_tag: The name of a container registry repository tag. Required.
        :type repository_tag: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_registry_delete_repository_tag_request(
            registry_name=registry_name,
            repository_name=repository_name,
            repository_tag=repository_tag,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_repository_manifests(
        self,
        registry_name: str,
        repository_name: str,
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Container Registry Repository Manifests.

        To list all manifests in your container registry repository, send a GET
        request to ``/v2/registry/$REGISTRY_NAME/repositories/$REPOSITORY_NAME/digests``.

        Note that if your repository name contains ``/`` characters, it must be
        URL-encoded in the request URL. For example, to list manifests for
        ``registry.digitalocean.com/example/my/repo``\\ , the path would be
        ``/v2/registry/example/repositories/my%2Frepo/digests``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param repository_name: The name of a container registry repository. If the name contains ``/``
         characters, they must be URL-encoded, e.g. ``%2F``. Required.
        :type repository_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "manifests": [
                        {
                            "blobs": [
                                {
                                    "compressed_size_bytes": 0,  # Optional. The
                                      compressed size of the blob in bytes.
                                    "digest": "str"  # Optional. The digest of
                                      the blob.
                                }
                            ],
                            "compressed_size_bytes": 0,  # Optional. The compressed size
                              of the manifest in bytes.
                            "digest": "str",  # Optional. The manifest digest.
                            "registry_name": "str",  # Optional. The name of the
                              container registry.
                            "repository": "str",  # Optional. The name of the repository.
                            "size_bytes": 0,  # Optional. The uncompressed size of the
                              manifest in bytes (this size is calculated asynchronously so it may not
                              be immediately available).
                            "tags": [
                                "str"  # Optional. All tags associated with this
                                  manifest.
                            ],
                            "updated_at": "2020-02-20 00:00:00"  # Optional. The time the
                              manifest was last updated.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_list_repository_manifests_request(
            registry_name=registry_name,
            repository_name=repository_name,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_repository_manifest(
        self,
        registry_name: str,
        repository_name: str,
        manifest_digest: str,
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete Container Registry Repository Manifest.

        To delete a container repository manifest by digest, send a DELETE request to
        ``/v2/registry/$REGISTRY_NAME/repositories/$REPOSITORY_NAME/digests/$MANIFEST_DIGEST``.

        Note that if your repository name contains ``/`` characters, it must be
        URL-encoded in the request URL. For example, to delete
        ``registry.digitalocean.com/example/my/repo@sha256:abcd``\\ , the path would be
        ``/v2/registry/example/repositories/my%2Frepo/digests/sha256:abcd``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param repository_name: The name of a container registry repository. If the name contains ``/``
         characters, they must be URL-encoded, e.g. ``%2F``. Required.
        :type repository_name: str
        :param manifest_digest: The manifest digest of a container registry repository tag. Required.
        :type manifest_digest: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_registry_delete_repository_manifest_request(
            registry_name=registry_name,
            repository_name=repository_name,
            manifest_digest=manifest_digest,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def run_garbage_collection(self, registry_name: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Start Garbage Collection.

        Garbage collection enables users to clear out unreferenced blobs (layer &
        manifest data) after deleting one or more manifests from a repository. If
        there are no unreferenced blobs resulting from the deletion of one or more
        manifests, garbage collection is effectively a noop.
        `See here for more information
        <https://docs.digitalocean.com/products/container-registry/how-to/clean-up-container-registry/>`_
        about how and why you should clean up your container registry periodically.

        To request a garbage collection run on your registry, send a POST request to
        ``/v2/registry/$REGISTRY_NAME/garbage-collection``. This will initiate the
        following sequence of events on your registry.


        * Set the registry to read-only mode, meaning no further write-scoped
          JWTs will be issued to registry clients. Existing write-scoped JWTs will
          continue to work until they expire which can take up to 15 minutes.
        * Wait until all existing write-scoped JWTs have expired.
        * Scan all registry manifests to determine which blobs are unreferenced.
        * Delete all unreferenced blobs from the registry.
        * Record the number of blobs deleted and bytes freed, mark the garbage
          collection status as ``success``.
        * Remove the read-only mode restriction from the registry, meaning write-scoped
          JWTs will once again be issued to registry clients.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "garbage_collection": {
                        "blobs_deleted": 0,  # Optional. The number of blobs deleted as a
                          result of this garbage collection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was created.
                        "freed_bytes": 0,  # Optional. The number of bytes freed as a result
                          of this garbage collection.
                        "registry_name": "str",  # Optional. The name of the container
                          registry.
                        "status": "str",  # Optional. The current status of this garbage
                          collection. Known values are: "requested", "waiting for write JWTs to
                          expire", "scanning manifests", "deleting unreferenced blobs", "cancelling",
                          "failed", "succeeded", and "cancelled".
                        "updated_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was last updated.
                        "uuid": "str"  # Optional. A string specifying the UUID of the
                          garbage collection.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_run_garbage_collection_request(
            registry_name=registry_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_garbage_collection(self, registry_name: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Active Garbage Collection.

        To get information about the currently-active garbage collection for a registry, send a GET
        request to ``/v2/registry/$REGISTRY_NAME/garbage-collection``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "garbage_collection": {
                        "blobs_deleted": 0,  # Optional. The number of blobs deleted as a
                          result of this garbage collection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was created.
                        "freed_bytes": 0,  # Optional. The number of bytes freed as a result
                          of this garbage collection.
                        "registry_name": "str",  # Optional. The name of the container
                          registry.
                        "status": "str",  # Optional. The current status of this garbage
                          collection. Known values are: "requested", "waiting for write JWTs to
                          expire", "scanning manifests", "deleting unreferenced blobs", "cancelling",
                          "failed", "succeeded", and "cancelled".
                        "updated_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was last updated.
                        "uuid": "str"  # Optional. A string specifying the UUID of the
                          garbage collection.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_get_garbage_collection_request(
            registry_name=registry_name,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_garbage_collections(
        self, registry_name: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Garbage Collections.

        To get information about past garbage collections for a registry, send a GET request to
        ``/v2/registry/$REGISTRY_NAME/garbage-collections``.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "garbage_collections": [
                        {
                            "blobs_deleted": 0,  # Optional. The number of blobs deleted
                              as a result of this garbage collection.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The time
                              the garbage collection was created.
                            "freed_bytes": 0,  # Optional. The number of bytes freed as a
                              result of this garbage collection.
                            "registry_name": "str",  # Optional. The name of the
                              container registry.
                            "status": "str",  # Optional. The current status of this
                              garbage collection. Known values are: "requested", "waiting for write
                              JWTs to expire", "scanning manifests", "deleting unreferenced blobs",
                              "cancelling", "failed", "succeeded", and "cancelled".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The time
                              the garbage collection was last updated.
                            "uuid": "str"  # Optional. A string specifying the UUID of
                              the garbage collection.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_list_garbage_collections_request(
            registry_name=registry_name,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_garbage_collection(
        self,
        registry_name: str,
        garbage_collection_uuid: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Garbage Collection.

        To cancel the currently-active garbage collection for a registry, send a PUT request to
        ``/v2/registry/$REGISTRY_NAME/garbage-collection/$GC_UUID`` and specify one or more of the
        attributes below.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param garbage_collection_uuid: The UUID of a garbage collection run. Required.
        :type garbage_collection_uuid: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cancel": bool  # Optional. A boolean value indicating that the garbage
                      collection should be cancelled.
                }

                # response body for status code(s): 200
                response == {
                    "garbage_collection": {
                        "blobs_deleted": 0,  # Optional. The number of blobs deleted as a
                          result of this garbage collection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was created.
                        "freed_bytes": 0,  # Optional. The number of bytes freed as a result
                          of this garbage collection.
                        "registry_name": "str",  # Optional. The name of the container
                          registry.
                        "status": "str",  # Optional. The current status of this garbage
                          collection. Known values are: "requested", "waiting for write JWTs to
                          expire", "scanning manifests", "deleting unreferenced blobs", "cancelling",
                          "failed", "succeeded", and "cancelled".
                        "updated_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was last updated.
                        "uuid": "str"  # Optional. A string specifying the UUID of the
                          garbage collection.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_garbage_collection(
        self,
        registry_name: str,
        garbage_collection_uuid: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Garbage Collection.

        To cancel the currently-active garbage collection for a registry, send a PUT request to
        ``/v2/registry/$REGISTRY_NAME/garbage-collection/$GC_UUID`` and specify one or more of the
        attributes below.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param garbage_collection_uuid: The UUID of a garbage collection run. Required.
        :type garbage_collection_uuid: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "garbage_collection": {
                        "blobs_deleted": 0,  # Optional. The number of blobs deleted as a
                          result of this garbage collection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was created.
                        "freed_bytes": 0,  # Optional. The number of bytes freed as a result
                          of this garbage collection.
                        "registry_name": "str",  # Optional. The name of the container
                          registry.
                        "status": "str",  # Optional. The current status of this garbage
                          collection. Known values are: "requested", "waiting for write JWTs to
                          expire", "scanning manifests", "deleting unreferenced blobs", "cancelling",
                          "failed", "succeeded", and "cancelled".
                        "updated_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was last updated.
                        "uuid": "str"  # Optional. A string specifying the UUID of the
                          garbage collection.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_garbage_collection(
        self,
        registry_name: str,
        garbage_collection_uuid: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Garbage Collection.

        To cancel the currently-active garbage collection for a registry, send a PUT request to
        ``/v2/registry/$REGISTRY_NAME/garbage-collection/$GC_UUID`` and specify one or more of the
        attributes below.

        :param registry_name: The name of a container registry. Required.
        :type registry_name: str
        :param garbage_collection_uuid: The UUID of a garbage collection run. Required.
        :type garbage_collection_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "cancel": bool  # Optional. A boolean value indicating that the garbage
                      collection should be cancelled.
                }

                # response body for status code(s): 200
                response == {
                    "garbage_collection": {
                        "blobs_deleted": 0,  # Optional. The number of blobs deleted as a
                          result of this garbage collection.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was created.
                        "freed_bytes": 0,  # Optional. The number of bytes freed as a result
                          of this garbage collection.
                        "registry_name": "str",  # Optional. The name of the container
                          registry.
                        "status": "str",  # Optional. The current status of this garbage
                          collection. Known values are: "requested", "waiting for write JWTs to
                          expire", "scanning manifests", "deleting unreferenced blobs", "cancelling",
                          "failed", "succeeded", and "cancelled".
                        "updated_at": "2020-02-20 00:00:00",  # Optional. The time the
                          garbage collection was last updated.
                        "uuid": "str"  # Optional. A string specifying the UUID of the
                          garbage collection.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_registry_update_garbage_collection_request(
            registry_name=registry_name,
            garbage_collection_uuid=garbage_collection_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_options(self, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List Registry Options (Subscription Tiers and Available Regions).

        This endpoint serves to provide additional information as to which option values are available
        when creating a container registry.
        There are multiple subscription tiers available for container registry. Each tier allows a
        different number of image repositories to be created in your registry, and has a different
        amount of storage and transfer included.
        There are multiple regions available for container registry and controls where your data is
        stored.
        To list the available options, send a GET request to ``/v2/registry/options``.

        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "options": {
                        "available_regions": [
                            "str"  # Optional.
                        ],
                        "subscription_tiers": [
                            {
                                "allow_storage_overage": bool,  # Optional. A boolean
                                  indicating whether the subscription tier supports additional storage
                                  above what is included in the base plan at an additional cost per GiB
                                  used.
                                "eligibility_reasons": [
                                    "str"  # Optional. If your account is not
                                      eligible to use a certain subscription tier, this will include a
                                      list of reasons that prevent you from using the tier.
                                ],
                                "eligible": bool,  # Optional. A boolean indicating
                                  whether your account it eligible to use a certain subscription tier.
                                "included_bandwidth_bytes": 0,  # Optional. The
                                  amount of outbound data transfer included in the subscription tier in
                                  bytes.
                                "included_repositories": 0,  # Optional. The number
                                  of repositories included in the subscription tier. ``0`` indicates
                                  that the subscription tier includes unlimited repositories.
                                "included_storage_bytes": 0,  # Optional. The amount
                                  of storage included in the subscription tier in bytes.
                                "monthly_price_in_cents": 0,  # Optional. The monthly
                                  cost of the subscription tier in cents.
                                "name": "str",  # Optional. The name of the
                                  subscription tier.
                                "slug": "str",  # Optional. The slug identifier of
                                  the subscription tier.
                                "storage_overage_price_in_cents": 0  # Optional. The
                                  price paid in cents per GiB for additional storage beyond what is
                                  included in the subscription plan.
                            }
                        ]
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_registry_get_options_request(
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class ReservedIPsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`reserved_ips` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Reserved IPs.

        To list all of the reserved IPs available on your account, send a GET request to
        ``/v2/reserved_ips``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "reserved_ips": [
                        {
                            "droplet": {},
                            "ip": "str",  # Optional. The public IP address of the
                              reserved IP. It also serves as its identifier.
                            "locked": bool,  # Optional. A boolean value indicating
                              whether or not the reserved IP has pending actions preventing new ones
                              from being submitted.
                            "project_id": "str",  # Optional. The UUID of the project to
                              which the reserved IP currently belongs.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            }
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ips_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Reserved IP.

        On creation, a reserved IP must be either assigned to a Droplet or reserved to a region.


        *
          To create a new reserved IP assigned to a Droplet, send a POST
          request to ``/v2/reserved_ips`` with the ``droplet_id`` attribute.

        *
          To create a new reserved IP reserved to a region, send a POST request to
          ``/v2/reserved_ips`` with the ``region`` attribute.

        **Note**\\ :  In addition to the standard rate limiting, only 12 reserved IPs may be created
        per 60 seconds.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "links": {
                        "actions": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ],
                        "droplets": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ]
                    },
                    "reserved_ip": {
                        "droplet": {},
                        "ip": "str",  # Optional. The public IP address of the reserved IP.
                          It also serves as its identifier.
                        "locked": bool,  # Optional. A boolean value indicating whether or
                          not the reserved IP has pending actions preventing new ones from being
                          submitted.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        }
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Reserved IP.

        On creation, a reserved IP must be either assigned to a Droplet or reserved to a region.


        *
          To create a new reserved IP assigned to a Droplet, send a POST
          request to ``/v2/reserved_ips`` with the ``droplet_id`` attribute.

        *
          To create a new reserved IP reserved to a region, send a POST request to
          ``/v2/reserved_ips`` with the ``region`` attribute.

        **Note**\\ :  In addition to the standard rate limiting, only 12 reserved IPs may be created
        per 60 seconds.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "links": {
                        "actions": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ],
                        "droplets": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ]
                    },
                    "reserved_ip": {
                        "droplet": {},
                        "ip": "str",  # Optional. The public IP address of the reserved IP.
                          It also serves as its identifier.
                        "locked": bool,  # Optional. A boolean value indicating whether or
                          not the reserved IP has pending actions preventing new ones from being
                          submitted.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        }
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Reserved IP.

        On creation, a reserved IP must be either assigned to a Droplet or reserved to a region.


        *
          To create a new reserved IP assigned to a Droplet, send a POST
          request to ``/v2/reserved_ips`` with the ``droplet_id`` attribute.

        *
          To create a new reserved IP reserved to a region, send a POST request to
          ``/v2/reserved_ips`` with the ``region`` attribute.

        **Note**\\ :  In addition to the standard rate limiting, only 12 reserved IPs may be created
        per 60 seconds.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "links": {
                        "actions": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ],
                        "droplets": [
                            {
                                "href": "str",  # Optional. A URL that can be used to
                                  access the action.
                                "id": 0,  # Optional. A unique numeric ID that can be
                                  used to identify and reference an action.
                                "rel": "str"  # Optional. A string specifying the
                                  type of the related action.
                            }
                        ]
                    },
                    "reserved_ip": {
                        "droplet": {},
                        "ip": "str",  # Optional. The public IP address of the reserved IP.
                          It also serves as its identifier.
                        "locked": bool,  # Optional. A boolean value indicating whether or
                          not the reserved IP has pending actions preventing new ones from being
                          submitted.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        }
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_reserved_ips_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, reserved_ip: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Reserved IP.

        To show information about a reserved IP, send a GET request to
        ``/v2/reserved_ips/$RESERVED_IP_ADDR``.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "reserved_ip": {
                        "droplet": {},
                        "ip": "str",  # Optional. The public IP address of the reserved IP.
                          It also serves as its identifier.
                        "locked": bool,  # Optional. A boolean value indicating whether or
                          not the reserved IP has pending actions preventing new ones from being
                          submitted.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ips_get_request(
            reserved_ip=reserved_ip,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, reserved_ip: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Reserved IP.

        To delete a reserved IP and remove it from your account, send a DELETE request
        to ``/v2/reserved_ips/$RESERVED_IP_ADDR``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_reserved_ips_delete_request(
            reserved_ip=reserved_ip,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class ReservedIPsActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`reserved_ips_actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, reserved_ip: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Actions for a Reserved IP.

        To retrieve all actions that have been executed on a reserved IP, send a GET request to
        ``/v2/reserved_ips/$RESERVED_IP/actions``.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional. A unique identifier for the
                              resource that the action is associated with.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "transfer" to represent
                              the state of an image transfer action.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ips_actions_list_request(
            reserved_ip=reserved_ip,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def post(
        self,
        reserved_ip: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Reserved IP Action.

        To initiate an action on a reserved IP send a POST request to
        ``/v2/reserved_ips/$RESERVED_IP/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IP to a Droplet
           * - ``unassign``
             - Unassign a reserved IP from a Droplet.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IP. Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post(
        self,
        reserved_ip: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Reserved IP Action.

        To initiate an action on a reserved IP send a POST request to
        ``/v2/reserved_ips/$RESERVED_IP/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IP to a Droplet
           * - ``unassign``
             - Unassign a reserved IP from a Droplet.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IP. Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post(
        self,
        reserved_ip: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate a Reserved IP Action.

        To initiate an action on a reserved IP send a POST request to
        ``/v2/reserved_ips/$RESERVED_IP/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IP to a Droplet
           * - ``unassign``
             - Unassign a reserved IP from a Droplet.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IP. Is either a JSON type or a IO[bytes] type. Default value is
         None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_reserved_ips_actions_post_request(
            reserved_ip=reserved_ip,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, reserved_ip: str, action_id: int, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Reserved IP Action.

        To retrieve the status of a reserved IP action, send a GET request to
        ``/v2/reserved_ips/$RESERVED_IP/actions/$ACTION_ID``.

        :param reserved_ip: A reserved IP address. Required.
        :type reserved_ip: str
        :param action_id: A unique numeric ID that can be used to identify and reference an action.
         Required.
        :type action_id: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "project_id": "str",  # Optional. The UUID of the project to which
                          the reserved IP currently belongs.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ips_actions_get_request(
            reserved_ip=reserved_ip,
            action_id=action_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class ReservedIPv6Operations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`reserved_ipv6` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] List All Reserved IPv6s.

        To list all of the reserved IPv6s available on your account, send a GET request to
        ``/v2/reserved_ipv6``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "reserved_ipv6s": [
                        {
                            "droplet": {},
                            "ip": "str",  # Optional. The public IP address of the
                              reserved IPv6. It also serves as its identifier.
                            "region_slug": "str",  # Optional. The region that the
                              reserved IPv6 is reserved to. When you query a reserved IPv6,the
                              region_slug will be returned.
                            "reserved_at": "2020-02-20 00:00:00"  # Optional.
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ipv6_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Create a New Reserved IPv6.

        On creation, a reserved IPv6 must be reserved to a region.


        * To create a new reserved IPv6 reserved to a region, send a POST request to
          ``/v2/reserved_ipv6`` with the ``region_slug`` attribute.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region_slug": "str"  # The slug identifier for the region the reserved IPv6
                      will be reserved to. Required.
                }

                # response body for status code(s): 201
                response == {
                    "reserved_ipv6": {
                        "ip": "str",  # Optional. The public IP address of the reserved IPv6.
                          It also serves as its identifier.
                        "region_slug": "str",  # Optional. The region that the reserved IPv6
                          is reserved to. When you query a reserved IPv6,the region_slug will be
                          returned.
                        "reserved_at": "2020-02-20 00:00:00"  # Optional.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Create a New Reserved IPv6.

        On creation, a reserved IPv6 must be reserved to a region.


        * To create a new reserved IPv6 reserved to a region, send a POST request to
          ``/v2/reserved_ipv6`` with the ``region_slug`` attribute.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "reserved_ipv6": {
                        "ip": "str",  # Optional. The public IP address of the reserved IPv6.
                          It also serves as its identifier.
                        "region_slug": "str",  # Optional. The region that the reserved IPv6
                          is reserved to. When you query a reserved IPv6,the region_slug will be
                          returned.
                        "reserved_at": "2020-02-20 00:00:00"  # Optional.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Create a New Reserved IPv6.

        On creation, a reserved IPv6 must be reserved to a region.


        * To create a new reserved IPv6 reserved to a region, send a POST request to
          ``/v2/reserved_ipv6`` with the ``region_slug`` attribute.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "region_slug": "str"  # The slug identifier for the region the reserved IPv6
                      will be reserved to. Required.
                }

                # response body for status code(s): 201
                response == {
                    "reserved_ipv6": {
                        "ip": "str",  # Optional. The public IP address of the reserved IPv6.
                          It also serves as its identifier.
                        "region_slug": "str",  # Optional. The region that the reserved IPv6
                          is reserved to. When you query a reserved IPv6,the region_slug will be
                          returned.
                        "reserved_at": "2020-02-20 00:00:00"  # Optional.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_reserved_ipv6_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, reserved_ipv6: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Retrieve an Existing Reserved IPv6.

        To show information about a reserved IPv6, send a GET request to
        ``/v2/reserved_ipv6/$RESERVED_IPV6``.

        :param reserved_ipv6: A reserved IPv6 address. Required.
        :type reserved_ipv6: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "reserved_ipv6": {
                        "droplet": {},
                        "ip": "str",  # Optional. The public IP address of the reserved IPv6.
                          It also serves as its identifier.
                        "region_slug": "str",  # Optional. The region that the reserved IPv6
                          is reserved to. When you query a reserved IPv6,the region_slug will be
                          returned.
                        "reserved_at": "2020-02-20 00:00:00"  # Optional. The date and time
                          when the reserved IPv6 was reserved.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_reserved_ipv6_get_request(
            reserved_ipv6=reserved_ipv6,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, reserved_ipv6: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """[Public Preview] Delete a Reserved IPv6.

        To delete a reserved IP and remove it from your account, send a DELETE request
        to ``/v2/reserved_ipv6/$RESERVED_IPV6``.

        A successful request will receive a 204 status code with no body in response.
        This indicates that the request was processed successfully.

        :param reserved_ipv6: A reserved IPv6 address. Required.
        :type reserved_ipv6: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404, 422
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_reserved_ipv6_delete_request(
            reserved_ipv6=reserved_ipv6,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404, 422]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 422:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class ReservedIPv6ActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`reserved_ipv6_actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @overload
    def post(
        self,
        reserved_ipv6: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Initiate a Reserved IPv6 Action.

        To initiate an action on a reserved IPv6 send a POST request to
        ``/v2/reserved_ipv6/$RESERVED_IPV6/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IPv6 to a Droplet
           * - ``unassign``
             - Unassign a reserved IPv6 from a Droplet.

        :param reserved_ipv6: A reserved IPv6 address. Required.
        :type reserved_ipv6: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IPv6. Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post(
        self,
        reserved_ipv6: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Initiate a Reserved IPv6 Action.

        To initiate an action on a reserved IPv6 send a POST request to
        ``/v2/reserved_ipv6/$RESERVED_IPV6/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IPv6 to a Droplet
           * - ``unassign``
             - Unassign a reserved IPv6 from a Droplet.

        :param reserved_ipv6: A reserved IPv6 address. Required.
        :type reserved_ipv6: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IPv6. Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post(
        self,
        reserved_ipv6: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """[Public Preview] Initiate a Reserved IPv6 Action.

        To initiate an action on a reserved IPv6 send a POST request to
        ``/v2/reserved_ipv6/$RESERVED_IPV6/actions``. In the JSON body to the request,
        set the ``type`` attribute to on of the supported action types:

        .. list-table::
           :header-rows: 1

           * - Action
             - Details
           * - ``assign``
             - Assigns a reserved IPv6 to a Droplet
           * - ``unassign``
             - Unassign a reserved IPv6 from a Droplet.

        :param reserved_ipv6: A reserved IPv6 address. Required.
        :type reserved_ipv6: str
        :param body: The ``type`` attribute set in the request body will specify the action that
         will be taken on the reserved IPv6. Is either a JSON type or a IO[bytes] type. Default value
         is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional. A unique identifier for the resource
                          that the action is associated with.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "transfer" to represent the state of
                          an image transfer action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_reserved_ipv6_actions_post_request(
            reserved_ipv6=reserved_ipv6,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class SizesOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`sizes` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Droplet Sizes.

        To list all of available Droplet sizes, send a GET request to ``/v2/sizes``.
        The response will be a JSON object with a key called ``sizes``. The value of this will be an
        array of ``size`` objects each of which contain the standard size attributes.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "sizes": [
                        {
                            "available": True,  # Default value is True. This is a
                              boolean value that represents whether new Droplets can be created with
                              this size.
                            "description": "str",  # A string describing the class of
                              Droplets created from this size. For example: Basic, General Purpose,
                              CPU-Optimized, Memory-Optimized, or Storage-Optimized. Required.
                            "disk": 0,  # The amount of disk space set aside for Droplets
                              of this size. The value is represented in gigabytes. Required.
                            "memory": 0,  # The amount of RAM allocated to Droplets
                              created of this size. The value is represented in megabytes. Required.
                            "price_hourly": 0.0,  # This describes the price of the
                              Droplet size as measured hourly. The value is measured in US dollars.
                              Required.
                            "price_monthly": 0.0,  # This attribute describes the monthly
                              cost of this Droplet size if the Droplet is kept for an entire month. The
                              value is measured in US dollars. Required.
                            "regions": [
                                "str"  # An array containing the region slugs where
                                  this size is available for Droplet creates. Required.
                            ],
                            "slug": "str",  # A human-readable string that is used to
                              uniquely identify each size. Required.
                            "transfer": 0.0,  # The amount of transfer bandwidth that is
                              available for Droplets created in this size. This only counts traffic on
                              the public interface. The value is given in terabytes. Required.
                            "vcpus": 0,  # The number of CPUs allocated to Droplets of
                              this size. Required.
                            "disk_info": [
                                {
                                    "size": {
                                        "amount": 0,  # Optional. The amount
                                          of space allocated to the disk.
                                        "unit": "str"  # Optional. The unit
                                          of measure for the disk size.
                                    },
                                    "type": "str"  # Optional. The type of disk.
                                      All Droplets contain a ``local`` disk. Additionally, GPU Droplets
                                      can also have a ``scratch`` disk for non-persistent data. Known
                                      values are: "local" and "scratch".
                                }
                            ],
                            "gpu_info": {
                                "count": 0,  # Optional. The number of GPUs allocated
                                  to the Droplet.
                                "model": "str",  # Optional. The model of the GPU.
                                "vram": {
                                    "amount": 0,  # Optional. The amount of VRAM
                                      allocated to the GPU.
                                    "unit": "str"  # Optional. The unit of
                                      measure for the VRAM.
                                }
                            }
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_sizes_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class SnapshotsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`snapshots` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        per_page: int = 20,
        page: int = 1,
        resource_type: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Snapshots.

        To list all of the snapshots available on your account, send a GET request to
        ``/v2/snapshots``.

        The response will be a JSON object with a key called ``snapshots``. This will be
        set to an array of ``snapshot`` objects, each of which will contain the standard
        snapshot attributes.

        Filtering Results by Resource Type
        ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^

        It's possible to request filtered results by including certain query parameters.

        List Droplet Snapshots
        ~~~~~~~~~~~~~~~~~~~~~~

        To retrieve only snapshots based on Droplets, include the ``resource_type``
        query parameter set to ``droplet``. For example, ``/v2/snapshots?resource_type=droplet``.

        List Volume Snapshots
        ~~~~~~~~~~~~~~~~~~~~~

        To retrieve only snapshots based on volumes, include the ``resource_type``
        query parameter set to ``volume``. For example, ``/v2/snapshots?resource_type=volume``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword resource_type: Used to filter snapshots by a resource type. Known values are:
         "droplet" and "volume". Default value is None.
        :paramtype resource_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "snapshots": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the snapshot
                              was created. Required.
                            "min_disk_size": 0,  # The minimum size in GB required for a
                              volume or Droplet to use this snapshot. Required.
                            "name": "str",  # A human-readable name for the snapshot.
                              Required.
                            "regions": [
                                "str"  # An array of the regions that the snapshot is
                                  available in. The regions are represented by their identifying slug
                                  values. Required.
                            ],
                            "resource_id": "str",  # The unique identifier for the
                              resource that the snapshot originated from. Required.
                            "resource_type": "str",  # The type of resource that the
                              snapshot originated from. Required. Known values are: "droplet" and
                              "volume".
                            "size_gigabytes": 0.0,  # The billable size of the snapshot
                              in gigabytes. Required.
                            "tags": [
                                "str"  # An array of Tags the snapshot has been
                                  tagged with. Required.
                            ]
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_snapshots_list_request(
            per_page=per_page,
            page=page,
            resource_type=resource_type,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, snapshot_id: JSON, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Snapshot.

        To retrieve information about a snapshot, send a GET request to
        ``/v2/snapshots/$SNAPSHOT_ID``.

        The response will be a JSON object with a key called ``snapshot``. The value of
        this will be an snapshot object containing the standard snapshot attributes.

        :param snapshot_id: Either the ID of an existing snapshot. This will be an integer for a
         Droplet snapshot or a string for a volume snapshot. Required.
        :type snapshot_id: JSON
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "snapshot": {
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the snapshot was created.
                          Required.
                        "min_disk_size": 0,  # The minimum size in GB required for a volume
                          or Droplet to use this snapshot. Required.
                        "name": "str",  # A human-readable name for the snapshot. Required.
                        "regions": [
                            "str"  # An array of the regions that the snapshot is
                              available in. The regions are represented by their identifying slug
                              values. Required.
                        ],
                        "resource_id": "str",  # The unique identifier for the resource that
                          the snapshot originated from. Required.
                        "resource_type": "str",  # The type of resource that the snapshot
                          originated from. Required. Known values are: "droplet" and "volume".
                        "size_gigabytes": 0.0,  # The billable size of the snapshot in
                          gigabytes. Required.
                        "tags": [
                            "str"  # An array of Tags the snapshot has been tagged with.
                              Required.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_snapshots_get_request(
            snapshot_id=snapshot_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, snapshot_id: JSON, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Snapshot.

        Both Droplet and volume snapshots are managed through the ``/v2/snapshots/``
        endpoint. To delete a snapshot, send a DELETE request to
        ``/v2/snapshots/$SNAPSHOT_ID``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        :param snapshot_id: Either the ID of an existing snapshot. This will be an integer for a
         Droplet snapshot or a string for a volume snapshot. Required.
        :type snapshot_id: JSON
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_snapshots_delete_request(
            snapshot_id=snapshot_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class SpacesKeyOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`spaces_key` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        per_page: int = 20,
        page: int = 1,
        sort: str = "created_at",
        sort_direction: str = "desc",
        name: Optional[str] = None,
        bucket: Optional[str] = None,
        permission: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Spaces Access Keys.

        To list Spaces Access Key, send a GET request to ``/v2/spaces/keys``. Sort parameter must be
        used with Sort Direction.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword sort: The field to sort by. Default value is "created_at".
        :paramtype sort: str
        :keyword sort_direction: The direction to sort by. Possible values are ``asc`` or ``desc``.
         Default value is "desc".
        :paramtype sort_direction: str
        :keyword name: The access key's name. Default value is None.
        :paramtype name: str
        :keyword bucket: The bucket's name. Default value is None.
        :paramtype bucket: str
        :keyword permission: The permission of the access key. Possible values are ``read``\\ ,
         ``readwrite``\\ , ``fullaccess``\\ , or an empty string. Default value is None.
        :paramtype permission: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "keys": [
                        {
                            "access_key": "str",  # Optional. The Access Key ID used to
                              access a bucket.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The date
                              and time the key was created.
                            "grants": [
                                {
                                    "bucket": "str",  # The name of the bucket.
                                      Required.
                                    "permission": "str"  # The permission to
                                      grant to the user. Possible values are ``read``"" ,
                                      ``readwrite``"" , ``fullaccess``"" , or an empty string.
                                      Required.
                                }
                            ],
                            "name": "str"  # Optional. The access key's name.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_spaces_key_list_request(
            per_page=per_page,
            page=page,
            sort=sort,
            sort_direction=sort_direction,
            name=name,
            bucket=bucket,
            permission=permission,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Spaces Access Key.

        To create a new Spaces Access Key, send a POST request to ``/v2/spaces/keys``.
        At the moment, you cannot mix a fullaccess permission with scoped permissions.
        A fullaccess permission will be prioritized if fullaccess and scoped permissions are both
        added.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 201
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str",  # Optional. The access key's name.
                        "secret_key": "str"  # Optional. The secret key used to access the
                          bucket. We return secret keys only once upon creation. Make sure to copy the
                          key and securely store it.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Spaces Access Key.

        To create a new Spaces Access Key, send a POST request to ``/v2/spaces/keys``.
        At the moment, you cannot mix a fullaccess permission with scoped permissions.
        A fullaccess permission will be prioritized if fullaccess and scoped permissions are both
        added.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str",  # Optional. The access key's name.
                        "secret_key": "str"  # Optional. The secret key used to access the
                          bucket. We return secret keys only once upon creation. Make sure to copy the
                          key and securely store it.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Spaces Access Key.

        To create a new Spaces Access Key, send a POST request to ``/v2/spaces/keys``.
        At the moment, you cannot mix a fullaccess permission with scoped permissions.
        A fullaccess permission will be prioritized if fullaccess and scoped permissions are both
        added.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 201
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str",  # Optional. The access key's name.
                        "secret_key": "str"  # Optional. The secret key used to access the
                          bucket. We return secret keys only once upon creation. Make sure to copy the
                          key and securely store it.
                    }
                }
                # response body for status code(s): 400
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_spaces_key_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 400]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, access_key: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get a Spaces Access Key.

        To get a Spaces Access Key, send a GET request to ``/v2/spaces/keys/$ACCESS_KEY``.

        A successful request will return the Access Key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "keys": [
                        {
                            "access_key": "str",  # Optional. The Access Key ID used to
                              access a bucket.
                            "created_at": "2020-02-20 00:00:00",  # Optional. The date
                              and time the key was created.
                            "grants": [
                                {
                                    "bucket": "str",  # The name of the bucket.
                                      Required.
                                    "permission": "str"  # The permission to
                                      grant to the user. Possible values are ``read``"" ,
                                      ``readwrite``"" , ``fullaccess``"" , or an empty string.
                                      Required.
                                }
                            ],
                            "name": "str"  # Optional. The access key's name.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_spaces_key_get_request(
            access_key=access_key,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, access_key: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Spaces Access Key.

        To delete a Spaces Access Key, send a DELETE request to ``/v2/spaces/keys/$ACCESS_KEY``.

        A successful request will return a ``204 No Content`` status code.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_spaces_key_delete_request(
            access_key=access_key,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def update(
        self,
        access_key: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        access_key: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(
        self, access_key: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_spaces_key_update_request(
            access_key=access_key,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch(
        self,
        access_key: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch(
        self,
        access_key: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch(
        self, access_key: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Spaces Access Keys.

        To update Spaces Access Key, send a PUT or PATCH request to ``/v2/spaces/keys/$ACCESS_KEY``. At
        the moment, you cannot convert a
        fullaccess key to a scoped key or vice versa. You can only update the name of the key.

        :param access_key: The access key's ID. Required.
        :type access_key: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "access_key": "str",  # Optional. The Access Key ID used to access a bucket.
                    "created_at": "2020-02-20 00:00:00",  # Optional. The date and time the key
                      was created.
                    "grants": [
                        {
                            "bucket": "str",  # The name of the bucket. Required.
                            "permission": "str"  # The permission to grant to the user.
                              Possible values are ``read``"" , ``readwrite``"" , ``fullaccess``"" , or
                              an empty string. Required.
                        }
                    ],
                    "name": "str"  # Optional. The access key's name.
                }

                # response body for status code(s): 200
                response == {
                    "key": {
                        "access_key": "str",  # Optional. The Access Key ID used to access a
                          bucket.
                        "created_at": "2020-02-20 00:00:00",  # Optional. The date and time
                          the key was created.
                        "grants": [
                            {
                                "bucket": "str",  # The name of the bucket. Required.
                                "permission": "str"  # The permission to grant to the
                                  user. Possible values are ``read``"" , ``readwrite``"" ,
                                  ``fullaccess``"" , or an empty string. Required.
                            }
                        ],
                        "name": "str"  # Optional. The access key's name.
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_spaces_key_patch_request(
            access_key=access_key,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class TagsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`tags` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Tags.

        To list all of your tags, you can send a GET request to ``/v2/tags``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "tags": [
                        {
                            "name": "str",  # Optional. The name of the tag. Tags may
                              contain letters, numbers, colons, dashes, and underscores. There is a
                              limit of 255 characters per tag.  **Note:** Tag names are case stable,
                              which means the capitalization you use when you first create a tag is
                              canonical.  When working with tags in the API, you must use the tag's
                              canonical capitalization. For example, if you create a tag named "PROD",
                              the URL to add that tag to a resource would be
                              ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                              ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel
                              will always display the canonical capitalization. For example, if you
                              create a tag named "PROD", you can tag resources in the control panel by
                              entering "prod". The tag will still display with its canonical
                              capitalization, "PROD".
                            "resources": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "databases": {
                                    "count": 0,  # Optional. The number of tagged
                                      objects for this type of resource.
                                    "last_tagged_uri": "str"  # Optional. The URI
                                      for the last tagged object for this type of resource.
                                },
                                "droplets": {
                                    "count": 0,  # Optional. The number of tagged
                                      objects for this type of resource.
                                    "last_tagged_uri": "str"  # Optional. The URI
                                      for the last tagged object for this type of resource.
                                },
                                "imgages": {
                                    "count": 0,  # Optional. The number of tagged
                                      objects for this type of resource.
                                    "last_tagged_uri": "str"  # Optional. The URI
                                      for the last tagged object for this type of resource.
                                },
                                "last_tagged_uri": "str",  # Optional. The URI for
                                  the last tagged object for this type of resource.
                                "volume_snapshots": {
                                    "count": 0,  # Optional. The number of tagged
                                      objects for this type of resource.
                                    "last_tagged_uri": "str"  # Optional. The URI
                                      for the last tagged object for this type of resource.
                                },
                                "volumes": {
                                    "count": 0,  # Optional. The number of tagged
                                      objects for this type of resource.
                                    "last_tagged_uri": "str"  # Optional. The URI
                                      for the last tagged object for this type of resource.
                                }
                            }
                        }
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_tags_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Tag.

        To create a tag you can send a POST request to ``/v2/tags`` with a ``name`` attribute.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # Optional. The name of the tag. Tags may contain letters,
                      numbers, colons, dashes, and underscores. There is a limit of 255 characters per
                      tag.  **Note:** Tag names are case stable, which means the capitalization you use
                      when you first create a tag is canonical.  When working with tags in the API, you
                      must use the tag's canonical capitalization. For example, if you create a tag
                      named "PROD", the URL to add that tag to a resource would be
                      ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                      ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                      always display the canonical capitalization. For example, if you create a tag
                      named "PROD", you can tag resources in the control panel by entering "prod". The
                      tag will still display with its canonical capitalization, "PROD".
                    "resources": {
                        "count": 0,  # Optional. The number of tagged objects for this type
                          of resource.
                        "databases": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "droplets": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "imgages": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "last_tagged_uri": "str",  # Optional. The URI for the last tagged
                          object for this type of resource.
                        "volume_snapshots": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "volumes": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        }
                    }
                }

                # response body for status code(s): 201
                response == {
                    "tag": {
                        "name": "str",  # Optional. The name of the tag. Tags may contain
                          letters, numbers, colons, dashes, and underscores. There is a limit of 255
                          characters per tag.  **Note:** Tag names are case stable, which means the
                          capitalization you use when you first create a tag is canonical.  When
                          working with tags in the API, you must use the tag's canonical
                          capitalization. For example, if you create a tag named "PROD", the URL to add
                          that tag to a resource would be
                          ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                          ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                          always display the canonical capitalization. For example, if you create a tag
                          named "PROD", you can tag resources in the control panel by entering "prod".
                          The tag will still display with its canonical capitalization, "PROD".
                        "resources": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "databases": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "droplets": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "imgages": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "last_tagged_uri": "str",  # Optional. The URI for the last
                              tagged object for this type of resource.
                            "volume_snapshots": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "volumes": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            }
                        }
                    }
                }
                # response body for status code(s): 400
                response == {
                    "error": "str",  # A message providing information about the error. Required.
                    "root_causes": [
                        "str"  # A list of underlying causes for the error, including details
                          to help  resolve it when possible. Required.
                    ],
                    "messages": [
                        "str"  # Optional. A list of error messages.
                    ]
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Tag.

        To create a tag you can send a POST request to ``/v2/tags`` with a ``name`` attribute.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "tag": {
                        "name": "str",  # Optional. The name of the tag. Tags may contain
                          letters, numbers, colons, dashes, and underscores. There is a limit of 255
                          characters per tag.  **Note:** Tag names are case stable, which means the
                          capitalization you use when you first create a tag is canonical.  When
                          working with tags in the API, you must use the tag's canonical
                          capitalization. For example, if you create a tag named "PROD", the URL to add
                          that tag to a resource would be
                          ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                          ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                          always display the canonical capitalization. For example, if you create a tag
                          named "PROD", you can tag resources in the control panel by entering "prod".
                          The tag will still display with its canonical capitalization, "PROD".
                        "resources": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "databases": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "droplets": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "imgages": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "last_tagged_uri": "str",  # Optional. The URI for the last
                              tagged object for this type of resource.
                            "volume_snapshots": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "volumes": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            }
                        }
                    }
                }
                # response body for status code(s): 400
                response == {
                    "error": "str",  # A message providing information about the error. Required.
                    "root_causes": [
                        "str"  # A list of underlying causes for the error, including details
                          to help  resolve it when possible. Required.
                    ],
                    "messages": [
                        "str"  # Optional. A list of error messages.
                    ]
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Tag.

        To create a tag you can send a POST request to ``/v2/tags`` with a ``name`` attribute.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # Optional. The name of the tag. Tags may contain letters,
                      numbers, colons, dashes, and underscores. There is a limit of 255 characters per
                      tag.  **Note:** Tag names are case stable, which means the capitalization you use
                      when you first create a tag is canonical.  When working with tags in the API, you
                      must use the tag's canonical capitalization. For example, if you create a tag
                      named "PROD", the URL to add that tag to a resource would be
                      ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                      ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                      always display the canonical capitalization. For example, if you create a tag
                      named "PROD", you can tag resources in the control panel by entering "prod". The
                      tag will still display with its canonical capitalization, "PROD".
                    "resources": {
                        "count": 0,  # Optional. The number of tagged objects for this type
                          of resource.
                        "databases": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "droplets": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "imgages": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "last_tagged_uri": "str",  # Optional. The URI for the last tagged
                          object for this type of resource.
                        "volume_snapshots": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        },
                        "volumes": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "last_tagged_uri": "str"  # Optional. The URI for the last
                              tagged object for this type of resource.
                        }
                    }
                }

                # response body for status code(s): 201
                response == {
                    "tag": {
                        "name": "str",  # Optional. The name of the tag. Tags may contain
                          letters, numbers, colons, dashes, and underscores. There is a limit of 255
                          characters per tag.  **Note:** Tag names are case stable, which means the
                          capitalization you use when you first create a tag is canonical.  When
                          working with tags in the API, you must use the tag's canonical
                          capitalization. For example, if you create a tag named "PROD", the URL to add
                          that tag to a resource would be
                          ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                          ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                          always display the canonical capitalization. For example, if you create a tag
                          named "PROD", you can tag resources in the control panel by entering "prod".
                          The tag will still display with its canonical capitalization, "PROD".
                        "resources": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "databases": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "droplets": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "imgages": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "last_tagged_uri": "str",  # Optional. The URI for the last
                              tagged object for this type of resource.
                            "volume_snapshots": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "volumes": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            }
                        }
                    }
                }
                # response body for status code(s): 400
                response == {
                    "error": "str",  # A message providing information about the error. Required.
                    "root_causes": [
                        "str"  # A list of underlying causes for the error, including details
                          to help  resolve it when possible. Required.
                    ],
                    "messages": [
                        "str"  # Optional. A list of error messages.
                    ]
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_tags_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 400]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )
            response_headers["x-request-id"] = self._deserialize(
                "str", response.headers.get("x-request-id")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, tag_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve a Tag.

        To retrieve an individual tag, you can send a ``GET`` request to ``/v2/tags/$TAG_NAME``.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "tag": {
                        "name": "str",  # Optional. The name of the tag. Tags may contain
                          letters, numbers, colons, dashes, and underscores. There is a limit of 255
                          characters per tag.  **Note:** Tag names are case stable, which means the
                          capitalization you use when you first create a tag is canonical.  When
                          working with tags in the API, you must use the tag's canonical
                          capitalization. For example, if you create a tag named "PROD", the URL to add
                          that tag to a resource would be
                          ``https://api.digitalocean.com/v2/tags/PROD/resources`` (not
                          ``/v2/tags/prod/resources``"" ).  Tagged resources in the control panel will
                          always display the canonical capitalization. For example, if you create a tag
                          named "PROD", you can tag resources in the control panel by entering "prod".
                          The tag will still display with its canonical capitalization, "PROD".
                        "resources": {
                            "count": 0,  # Optional. The number of tagged objects for
                              this type of resource.
                            "databases": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "droplets": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "imgages": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "last_tagged_uri": "str",  # Optional. The URI for the last
                              tagged object for this type of resource.
                            "volume_snapshots": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            },
                            "volumes": {
                                "count": 0,  # Optional. The number of tagged objects
                                  for this type of resource.
                                "last_tagged_uri": "str"  # Optional. The URI for the
                                  last tagged object for this type of resource.
                            }
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_tags_get_request(
            tag_id=tag_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, tag_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Tag.

        A tag can be deleted by sending a ``DELETE`` request to ``/v2/tags/$TAG_NAME``. Deleting a tag
        also untags all the resources that have previously been tagged by the Tag.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_tags_delete_request(
            tag_id=tag_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def assign_resources(
        self,
        tag_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Tag a Resource.

        Resources can be tagged by sending a POST request to ``/v2/tags/$TAG_NAME/resources`` with an
        array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only tagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        {
                            "resource_id": "str",  # Optional. The identifier of a
                              resource.
                            "resource_type": "str"  # Optional. The type of the resource.
                              Known values are: "droplet", "image", "volume", and "volume_snapshot".
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def assign_resources(
        self,
        tag_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Tag a Resource.

        Resources can be tagged by sending a POST request to ``/v2/tags/$TAG_NAME/resources`` with an
        array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only tagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def assign_resources(
        self, tag_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Tag a Resource.

        Resources can be tagged by sending a POST request to ``/v2/tags/$TAG_NAME/resources`` with an
        array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only tagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        {
                            "resource_id": "str",  # Optional. The identifier of a
                              resource.
                            "resource_type": "str"  # Optional. The type of the resource.
                              Known values are: "droplet", "image", "volume", and "volume_snapshot".
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_tags_assign_resources_request(
            tag_id=tag_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @overload
    def unassign_resources(
        self,
        tag_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Untag a Resource.

        Resources can be untagged by sending a DELETE request to ``/v2/tags/$TAG_NAME/resources`` with
        an array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only untagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        {
                            "resource_id": "str",  # Optional. The identifier of a
                              resource.
                            "resource_type": "str"  # Optional. The type of the resource.
                              Known values are: "droplet", "image", "volume", and "volume_snapshot".
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def unassign_resources(
        self,
        tag_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Untag a Resource.

        Resources can be untagged by sending a DELETE request to ``/v2/tags/$TAG_NAME/resources`` with
        an array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only untagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def unassign_resources(
        self, tag_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Untag a Resource.

        Resources can be untagged by sending a DELETE request to ``/v2/tags/$TAG_NAME/resources`` with
        an array of json objects containing ``resource_id`` and ``resource_type`` attributes.
        Currently only untagging of Droplets, Databases, Images, Volumes, and Volume Snapshots is
        supported. ``resource_type`` is expected to be the string ``droplet``\\ , ``database``\\ ,
        ``image``\\ , ``volume`` or ``volume_snapshot``. ``resource_id`` is expected to be the ID of
        the resource as a string.

        :param tag_id: The name of the tag. Tags may contain letters, numbers, colons, dashes, and
         underscores. There is a limit of 255 characters per tag. Required.
        :type tag_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "resources": [
                        {
                            "resource_id": "str",  # Optional. The identifier of a
                              resource.
                            "resource_type": "str"  # Optional. The type of the resource.
                              Known values are: "droplet", "image", "volume", and "volume_snapshot".
                        }
                    ]
                }

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_tags_unassign_resources_request(
            tag_id=tag_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class VolumesOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`volumes` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        name: Optional[str] = None,
        region: Optional[str] = None,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Block Storage Volumes.

        To list all of the block storage volumes available on your account, send a GET request to
        ``/v2/volumes``.

        Filtering Results
        -----------------

        By Region
        ^^^^^^^^^

        The ``region`` may be provided as query parameter in order to restrict results to volumes
        available in a specific region. For example: ``/v2/volumes?region=nyc1``

        By Name
        ^^^^^^^

        It is also possible to list volumes on your account that match a specified name. To do so, send
        a GET request with the volume's name as a query parameter to ``/v2/volumes?name=$VOLUME_NAME``.
        **Note:** You can only create one volume per region with the same name.

        By Name and Region
        ^^^^^^^^^^^^^^^^^^

        It is also possible to retrieve information about a block storage volume by name. To do so,
        send a GET request with the volume's name and the region slug for the region it is located in
        as query parameters to ``/v2/volumes?name=$VOLUME_NAME&region=nyc1``.

        :keyword name: The block storage volume's name. Default value is None.
        :paramtype name: str
        :keyword region: The slug identifier for the region where the resource is available. Known
         values are: "ams1", "ams2", "ams3", "blr1", "fra1", "lon1", "nyc1", "nyc2", "nyc3", "sfo1",
         "sfo2", "sfo3", "sgp1", "tor1", and "syd1". Default value is None.
        :paramtype region: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "volumes": [
                        {
                            "created_at": "str",  # Optional. A time value given in
                              ISO8601 combined date and time format that represents when the block
                              storage volume was created.
                            "description": "str",  # Optional. An optional free-form text
                              field to describe a block storage volume.
                            "droplet_ids": [
                                0  # Optional. An array containing the IDs of the
                                  Droplets the volume is attached to. Note that at this time, a volume
                                  can only be attached to a single Droplet.
                            ],
                            "filesystem_label": "str",  # Optional. The label currently
                              applied to the filesystem.
                            "filesystem_type": "str",  # Optional. The type of filesystem
                              currently in-use on the volume.
                            "id": "str",  # Optional. The unique identifier for the block
                              storage volume.
                            "name": "str",  # Optional. A human-readable name for the
                              block storage volume. Must be lowercase and be composed only of numbers,
                              letters and "-", up to a limit of 64 characters. The name must begin with
                              a letter.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "size_gigabytes": 0,  # Optional. The size of the block
                              storage volume in GiB (1024^3). This field does not apply  when creating
                              a volume from a snapshot.
                            "tags": [
                                "str"  # Optional. A flat array of tag names as
                                  strings to be applied to the resource. Tag names may be for either
                                  existing or new tags.
                            ]
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volumes_list_request(
            name=name,
            region=region,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Block Storage Volume.

        To create a new volume, send a POST request to ``/v2/volumes``. Optionally, a
        ``filesystem_type`` attribute may be provided in order to automatically format the volume's
        filesystem. Pre-formatted volumes are automatically mounted when attached to Ubuntu, Debian,
        Fedora, Fedora Atomic, and CentOS Droplets created on or after April 26, 2018. Attaching
        pre-formatted volumes to Droplets without support for auto-mounting is not recommended.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "volume": {
                        "created_at": "str",  # Optional. A time value given in ISO8601
                          combined date and time format that represents when the block storage volume
                          was created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe a block storage volume.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              the volume is attached to. Note that at this time, a volume can only be
                              attached to a single Droplet.
                        ],
                        "filesystem_label": "str",  # Optional. The label currently applied
                          to the filesystem.
                        "filesystem_type": "str",  # Optional. The type of filesystem
                          currently in-use on the volume.
                        "id": "str",  # Optional. The unique identifier for the block storage
                          volume.
                        "name": "str",  # Optional. A human-readable name for the block
                          storage volume. Must be lowercase and be composed only of numbers, letters
                          and "-", up to a limit of 64 characters. The name must begin with a letter.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "size_gigabytes": 0,  # Optional. The size of the block storage
                          volume in GiB (1024^3). This field does not apply  when creating a volume
                          from a snapshot.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Block Storage Volume.

        To create a new volume, send a POST request to ``/v2/volumes``. Optionally, a
        ``filesystem_type`` attribute may be provided in order to automatically format the volume's
        filesystem. Pre-formatted volumes are automatically mounted when attached to Ubuntu, Debian,
        Fedora, Fedora Atomic, and CentOS Droplets created on or after April 26, 2018. Attaching
        pre-formatted volumes to Droplets without support for auto-mounting is not recommended.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "volume": {
                        "created_at": "str",  # Optional. A time value given in ISO8601
                          combined date and time format that represents when the block storage volume
                          was created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe a block storage volume.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              the volume is attached to. Note that at this time, a volume can only be
                              attached to a single Droplet.
                        ],
                        "filesystem_label": "str",  # Optional. The label currently applied
                          to the filesystem.
                        "filesystem_type": "str",  # Optional. The type of filesystem
                          currently in-use on the volume.
                        "id": "str",  # Optional. The unique identifier for the block storage
                          volume.
                        "name": "str",  # Optional. A human-readable name for the block
                          storage volume. Must be lowercase and be composed only of numbers, letters
                          and "-", up to a limit of 64 characters. The name must begin with a letter.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "size_gigabytes": 0,  # Optional. The size of the block storage
                          volume in GiB (1024^3). This field does not apply  when creating a volume
                          from a snapshot.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Block Storage Volume.

        To create a new volume, send a POST request to ``/v2/volumes``. Optionally, a
        ``filesystem_type`` attribute may be provided in order to automatically format the volume's
        filesystem. Pre-formatted volumes are automatically mounted when attached to Ubuntu, Debian,
        Fedora, Fedora Atomic, and CentOS Droplets created on or after April 26, 2018. Attaching
        pre-formatted volumes to Droplets without support for auto-mounting is not recommended.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 201
                response == {
                    "volume": {
                        "created_at": "str",  # Optional. A time value given in ISO8601
                          combined date and time format that represents when the block storage volume
                          was created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe a block storage volume.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              the volume is attached to. Note that at this time, a volume can only be
                              attached to a single Droplet.
                        ],
                        "filesystem_label": "str",  # Optional. The label currently applied
                          to the filesystem.
                        "filesystem_type": "str",  # Optional. The type of filesystem
                          currently in-use on the volume.
                        "id": "str",  # Optional. The unique identifier for the block storage
                          volume.
                        "name": "str",  # Optional. A human-readable name for the block
                          storage volume. Must be lowercase and be composed only of numbers, letters
                          and "-", up to a limit of 64 characters. The name must begin with a letter.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "size_gigabytes": 0,  # Optional. The size of the block storage
                          volume in GiB (1024^3). This field does not apply  when creating a volume
                          from a snapshot.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_volumes_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_by_name(
        self, *, name: Optional[str] = None, region: Optional[str] = None, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Block Storage Volume by Name.

        Block storage volumes may also be deleted by name by sending a DELETE request with the volume's
        **name** and the **region slug** for the region it is located in as query parameters to
        ``/v2/volumes?name=$VOLUME_NAME&region=nyc1``.
        No response body will be sent back, but the response code will indicate success. Specifically,
        the response code will be a 204, which means that the action was successful with no returned
        body data.

        :keyword name: The block storage volume's name. Default value is None.
        :paramtype name: str
        :keyword region: The slug identifier for the region where the resource is available. Known
         values are: "ams1", "ams2", "ams3", "blr1", "fra1", "lon1", "nyc1", "nyc2", "nyc3", "sfo1",
         "sfo2", "sfo3", "sgp1", "tor1", and "syd1". Default value is None.
        :paramtype region: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_volumes_delete_by_name_request(
            name=name,
            region=region,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get(self, volume_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Block Storage Volume.

        To show information about a block storage volume, send a GET request to
        ``/v2/volumes/$VOLUME_ID``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "volume": {
                        "created_at": "str",  # Optional. A time value given in ISO8601
                          combined date and time format that represents when the block storage volume
                          was created.
                        "description": "str",  # Optional. An optional free-form text field
                          to describe a block storage volume.
                        "droplet_ids": [
                            0  # Optional. An array containing the IDs of the Droplets
                              the volume is attached to. Note that at this time, a volume can only be
                              attached to a single Droplet.
                        ],
                        "filesystem_label": "str",  # Optional. The label currently applied
                          to the filesystem.
                        "filesystem_type": "str",  # Optional. The type of filesystem
                          currently in-use on the volume.
                        "id": "str",  # Optional. The unique identifier for the block storage
                          volume.
                        "name": "str",  # Optional. A human-readable name for the block
                          storage volume. Must be lowercase and be composed only of numbers, letters
                          and "-", up to a limit of 64 characters. The name must begin with a letter.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "size_gigabytes": 0,  # Optional. The size of the block storage
                          volume in GiB (1024^3). This field does not apply  when creating a volume
                          from a snapshot.
                        "tags": [
                            "str"  # Optional. A flat array of tag names as strings to be
                              applied to the resource. Tag names may be for either existing or new
                              tags.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volumes_get_request(
            volume_id=volume_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, volume_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Block Storage Volume.

        To delete a block storage volume, destroying all data and removing it from your account, send a
        DELETE request to ``/v2/volumes/$VOLUME_ID``.
        No response body will be sent back, but the response code will indicate success. Specifically,
        the response code will be a 204, which means that the action was successful with no returned
        body data.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_volumes_delete_request(
            volume_id=volume_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class VolumeActionsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`volume_actions` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @overload
    def post(
        self,
        body: JSON,
        *,
        per_page: int = 20,
        page: int = 1,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Name.

        To initiate an action on a block storage volume by Name, send a POST request to
        ``~/v2/volumes/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located.

        :param body: Required.
        :type body: JSON
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post(
        self,
        body: IO[bytes],
        *,
        per_page: int = 20,
        page: int = 1,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Name.

        To initiate an action on a block storage volume by Name, send a POST request to
        ``~/v2/volumes/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located.

        :param body: Required.
        :type body: IO[bytes]
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post(
        self,
        body: Union[JSON, IO[bytes]],
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Name.

        To initiate an action on a block storage volume by Name, send a POST request to
        ``~/v2/volumes/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - volume_name
             - The name of the block storage volume
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_volume_actions_post_request(
            per_page=per_page,
            page=page,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list(
        self, volume_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Actions for a Volume.

        To retrieve all actions that have been executed on a volume, send a GET request to
        ``/v2/volumes/$VOLUME_ID/actions``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "actions": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was completed.
                            "id": 0,  # Optional. A unique numeric ID that can be used to
                              identify and reference an action.
                            "region": {
                                "available": bool,  # This is a boolean value that
                                  represents whether new Droplets can be created in this region.
                                  Required.
                                "features": {},  # This attribute is set to an array
                                  which contains features available in this region. Required.
                                "name": "str",  # The display name of the region.
                                  This will be a full name that is used in the control panel and other
                                  interfaces. Required.
                                "sizes": {},  # This attribute is set to an array
                                  which contains the identifying slugs for the sizes available in this
                                  region. Required.
                                "slug": "str"  # A human-readable string that is used
                                  as a unique identifier for each region. Required.
                            },
                            "region_slug": "str",  # Optional. A human-readable string
                              that is used as a unique identifier for each region.
                            "resource_id": 0,  # Optional.
                            "resource_type": "str",  # Optional. The type of resource
                              that the action is associated with.
                            "started_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format that represents when
                              the action was initiated.
                            "status": "in-progress",  # Optional. Default value is
                              "in-progress". The current status of the action. This can be
                              "in-progress", "completed", or "errored". Known values are:
                              "in-progress", "completed", and "errored".
                            "type": "str"  # Optional. This is the type of action that
                              the object represents. For example, this could be "attach_volume" to
                              represent the state of a volume attach action.
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volume_actions_list_request(
            volume_id=volume_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def post_by_id(
        self,
        volume_id: str,
        body: JSON,
        *,
        per_page: int = 20,
        page: int = 1,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Id.

        To initiate an action on a block storage volume by Id, send a POST request to
        ``~/v2/volumes/$VOLUME_ID/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Resize a Volume
        ---------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``resize``
           * - size_gigabytes
             - The new size of the block storage volume in GiB (1024^3)
           * - region
             - Set to the slug representing the region where the volume is located


        Volumes may only be resized upwards. The maximum size for a volume is 16TiB.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Required.
        :type body: JSON
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def post_by_id(
        self,
        volume_id: str,
        body: IO[bytes],
        *,
        per_page: int = 20,
        page: int = 1,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Id.

        To initiate an action on a block storage volume by Id, send a POST request to
        ``~/v2/volumes/$VOLUME_ID/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Resize a Volume
        ---------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``resize``
           * - size_gigabytes
             - The new size of the block storage volume in GiB (1024^3)
           * - region
             - Set to the slug representing the region where the volume is located


        Volumes may only be resized upwards. The maximum size for a volume is 16TiB.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def post_by_id(
        self,
        volume_id: str,
        body: Union[JSON, IO[bytes]],
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Initiate A Block Storage Action By Volume Id.

        To initiate an action on a block storage volume by Id, send a POST request to
        ``~/v2/volumes/$VOLUME_ID/actions``. The body should contain the appropriate
        attributes for the respective action.

        Attach a Block Storage Volume to a Droplet
        ------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``attach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Each volume may only be attached to a single Droplet. However, up to fifteen
        volumes may be attached to a Droplet at a time. Pre-formatted volumes will be
        automatically mounted to Ubuntu, Debian, Fedora, Fedora Atomic, and CentOS
        Droplets created on or after April 26, 2018 when attached. On older Droplets,
        `additional configuration <https://docs.digitalocean.com/products/volumes/how-to/mount/>`_
        is required.

        Remove a Block Storage Volume from a Droplet
        --------------------------------------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``detach``
           * - droplet_id
             - Set to the Droplet's ID
           * - region
             - Set to the slug representing the region where the volume is located


        Resize a Volume
        ---------------

        .. list-table::
           :header-rows: 1

           * - Attribute
             - Details
           * - type
             - This must be ``resize``
           * - size_gigabytes
             - The new size of the block storage volume in GiB (1024^3)
           * - region
             - Set to the slug representing the region where the volume is located


        Volumes may only be resized upwards. The maximum size for a volume is 16TiB.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {}

                # response body for status code(s): 202
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_volume_actions_post_by_id_request(
            volume_id=volume_id,
            per_page=per_page,
            page=page,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(
        self,
        volume_id: str,
        action_id: int,
        *,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Volume Action.

        To retrieve the status of a volume action, send a GET request to
        ``/v2/volumes/$VOLUME_ID/actions/$ACTION_ID``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param action_id: A unique numeric ID that can be used to identify and reference an action.
         Required.
        :type action_id: int
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "action": {
                        "completed_at": "2020-02-20 00:00:00",  # Optional. A time value
                          given in ISO8601 combined date and time format that represents when the
                          action was completed.
                        "id": 0,  # Optional. A unique numeric ID that can be used to
                          identify and reference an action.
                        "region": {
                            "available": bool,  # This is a boolean value that represents
                              whether new Droplets can be created in this region. Required.
                            "features": {},  # This attribute is set to an array which
                              contains features available in this region. Required.
                            "name": "str",  # The display name of the region.  This will
                              be a full name that is used in the control panel and other interfaces.
                              Required.
                            "sizes": {},  # This attribute is set to an array which
                              contains the identifying slugs for the sizes available in this region.
                              Required.
                            "slug": "str"  # A human-readable string that is used as a
                              unique identifier for each region. Required.
                        },
                        "region_slug": "str",  # Optional. A human-readable string that is
                          used as a unique identifier for each region.
                        "resource_id": 0,  # Optional.
                        "resource_type": "str",  # Optional. The type of resource that the
                          action is associated with.
                        "started_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format that represents when the action was
                          initiated.
                        "status": "in-progress",  # Optional. Default value is "in-progress".
                          The current status of the action. This can be "in-progress", "completed", or
                          "errored". Known values are: "in-progress", "completed", and "errored".
                        "type": "str"  # Optional. This is the type of action that the object
                          represents. For example, this could be "attach_volume" to represent the state
                          of a volume attach action.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volume_actions_get_request(
            volume_id=volume_id,
            action_id=action_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class VolumeSnapshotsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`volume_snapshots` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def get_by_id(self, snapshot_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Volume Snapshot.

        To retrieve the details of a snapshot that has been created from a volume, send a GET request
        to ``/v2/volumes/snapshots/$VOLUME_SNAPSHOT_ID``.

        :param snapshot_id: The unique identifier for the snapshot. Required.
        :type snapshot_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "snapshot": {
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the snapshot was created.
                          Required.
                        "min_disk_size": 0,  # The minimum size in GB required for a volume
                          or Droplet to use this snapshot. Required.
                        "name": "str",  # A human-readable name for the snapshot. Required.
                        "regions": [
                            "str"  # An array of the regions that the snapshot is
                              available in. The regions are represented by their identifying slug
                              values. Required.
                        ],
                        "resource_id": "str",  # The unique identifier for the resource that
                          the snapshot originated from. Required.
                        "resource_type": "str",  # The type of resource that the snapshot
                          originated from. Required. Known values are: "droplet" and "volume".
                        "size_gigabytes": 0.0,  # The billable size of the snapshot in
                          gigabytes. Required.
                        "tags": [
                            "str"  # An array of Tags the snapshot has been tagged with.
                              Required.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volume_snapshots_get_by_id_request(
            snapshot_id=snapshot_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_by_id(self, snapshot_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Volume Snapshot.

        To delete a volume snapshot, send a DELETE request to
        ``/v2/volumes/snapshots/$VOLUME_SNAPSHOT_ID``.

        A status of 204 will be given. This indicates that the request was processed
        successfully, but that no response body is needed.

        :param snapshot_id: The unique identifier for the snapshot. Required.
        :type snapshot_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_volume_snapshots_delete_by_id_request(
            snapshot_id=snapshot_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list(
        self, volume_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Snapshots for a Volume.

        To retrieve the snapshots that have been created from a volume, send a GET request to
        ``/v2/volumes/$VOLUME_ID/snapshots``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "snapshots": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # A time value given in
                              ISO8601 combined date and time format that represents when the snapshot
                              was created. Required.
                            "min_disk_size": 0,  # The minimum size in GB required for a
                              volume or Droplet to use this snapshot. Required.
                            "name": "str",  # A human-readable name for the snapshot.
                              Required.
                            "regions": [
                                "str"  # An array of the regions that the snapshot is
                                  available in. The regions are represented by their identifying slug
                                  values. Required.
                            ],
                            "resource_id": "str",  # The unique identifier for the
                              resource that the snapshot originated from. Required.
                            "resource_type": "str",  # The type of resource that the
                              snapshot originated from. Required. Known values are: "droplet" and
                              "volume".
                            "size_gigabytes": 0.0,  # The billable size of the snapshot
                              in gigabytes. Required.
                            "tags": [
                                "str"  # An array of Tags the snapshot has been
                                  tagged with. Required.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_volume_snapshots_list_request(
            volume_id=volume_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self,
        volume_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Snapshot from a Volume.

        To create a snapshot from a volume, sent a POST request to
        ``/v2/volumes/$VOLUME_ID/snapshots``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for the volume snapshot. Required.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to be applied
                          to the resource. Tag names may be for either existing or new tags.
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "snapshot": {
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the snapshot was created.
                          Required.
                        "min_disk_size": 0,  # The minimum size in GB required for a volume
                          or Droplet to use this snapshot. Required.
                        "name": "str",  # A human-readable name for the snapshot. Required.
                        "regions": [
                            "str"  # An array of the regions that the snapshot is
                              available in. The regions are represented by their identifying slug
                              values. Required.
                        ],
                        "resource_id": "str",  # The unique identifier for the resource that
                          the snapshot originated from. Required.
                        "resource_type": "str",  # The type of resource that the snapshot
                          originated from. Required. Known values are: "droplet" and "volume".
                        "size_gigabytes": 0.0,  # The billable size of the snapshot in
                          gigabytes. Required.
                        "tags": [
                            "str"  # An array of Tags the snapshot has been tagged with.
                              Required.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create(
        self,
        volume_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Snapshot from a Volume.

        To create a snapshot from a volume, sent a POST request to
        ``/v2/volumes/$VOLUME_ID/snapshots``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "snapshot": {
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the snapshot was created.
                          Required.
                        "min_disk_size": 0,  # The minimum size in GB required for a volume
                          or Droplet to use this snapshot. Required.
                        "name": "str",  # A human-readable name for the snapshot. Required.
                        "regions": [
                            "str"  # An array of the regions that the snapshot is
                              available in. The regions are represented by their identifying slug
                              values. Required.
                        ],
                        "resource_id": "str",  # The unique identifier for the resource that
                          the snapshot originated from. Required.
                        "resource_type": "str",  # The type of resource that the snapshot
                          originated from. Required. Known values are: "droplet" and "volume".
                        "size_gigabytes": 0.0,  # The billable size of the snapshot in
                          gigabytes. Required.
                        "tags": [
                            "str"  # An array of Tags the snapshot has been tagged with.
                              Required.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create(
        self, volume_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Snapshot from a Volume.

        To create a snapshot from a volume, sent a POST request to
        ``/v2/volumes/$VOLUME_ID/snapshots``.

        :param volume_id: The ID of the block storage volume. Required.
        :type volume_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # A human-readable name for the volume snapshot. Required.
                    "tags": [
                        "str"  # Optional. A flat array of tag names as strings to be applied
                          to the resource. Tag names may be for either existing or new tags.
                    ]
                }

                # response body for status code(s): 201
                response == {
                    "snapshot": {
                        "created_at": "2020-02-20 00:00:00",  # A time value given in ISO8601
                          combined date and time format that represents when the snapshot was created.
                          Required.
                        "min_disk_size": 0,  # The minimum size in GB required for a volume
                          or Droplet to use this snapshot. Required.
                        "name": "str",  # A human-readable name for the snapshot. Required.
                        "regions": [
                            "str"  # An array of the regions that the snapshot is
                              available in. The regions are represented by their identifying slug
                              values. Required.
                        ],
                        "resource_id": "str",  # The unique identifier for the resource that
                          the snapshot originated from. Required.
                        "resource_type": "str",  # The type of resource that the snapshot
                          originated from. Required. Known values are: "droplet" and "volume".
                        "size_gigabytes": 0.0,  # The billable size of the snapshot in
                          gigabytes. Required.
                        "tags": [
                            "str"  # An array of Tags the snapshot has been tagged with.
                              Required.
                        ]
                    }
                }
                # response body for status code(s): 400, 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_volume_snapshots_create_request(
            volume_id=volume_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 400, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 400:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class VpcsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`vpcs` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All VPCs.

        To list all of the VPCs on your account, send a GET request to ``/v2/vpcs``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "vpcs": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format.
                            "default": bool,  # Optional. A boolean value indicating
                              whether or not the VPC is the default network for the region. All
                              applicable resources are placed into the default VPC network unless
                              otherwise specified during their creation. The ``default`` field cannot
                              be unset from ``true``. If you want to set a new default VPC network,
                              update the ``default`` field of another VPC network in the same region.
                              The previous network's ``default`` field will be set to ``false`` when a
                              new default VPC has been defined.
                            "description": "str",  # Optional. A free-form text field for
                              describing the VPC's purpose. It may be a maximum of 255 characters.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the VPC.
                            "ip_range": "str",  # Optional. The range of IP addresses in
                              the VPC in CIDR notation. Network ranges cannot overlap with other
                              networks in the same account and must be in range of private addresses as
                              defined in RFC1918. It may not be smaller than ``/28`` nor larger than
                              ``/16``. If no IP range is specified, a ``/20`` network range is
                              generated that won't conflict with other VPC networks in your account.
                            "name": "str",  # Optional. The name of the VPC. Must be
                              unique and may only contain alphanumeric characters, dashes, and periods.
                            "region": "str",  # Optional. The slug identifier for the
                              region where the VPC will be created.
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpcs_list_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC.

        To create a VPC, send a POST request to ``/v2/vpcs`` specifying the attributes
        in the table below in the JSON body.

        **Note:** If you do not currently have a VPC network in a specific datacenter
        region, the first one that you create will be set as the default for that
        region. The default VPC for a region cannot be changed or deleted.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "ip_range": "str",  # Optional. The range of IP addresses in the VPC in CIDR
                      notation. Network ranges cannot overlap with other networks in the same account
                      and must be in range of private addresses as defined in RFC1918. It may not be
                      smaller than ``/28`` nor larger than ``/16``. If no IP range is specified, a
                      ``/20`` network range is generated that won't conflict with other VPC networks in
                      your account.
                    "name": "str",  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                    "region": "str"  # Optional. The slug identifier for the region where the VPC
                      will be created.
                }

                # response body for status code(s): 201
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC.

        To create a VPC, send a POST request to ``/v2/vpcs`` specifying the attributes
        in the table below in the JSON body.

        **Note:** If you do not currently have a VPC network in a specific datacenter
        region, the first one that you create will be set as the default for that
        region. The default VPC for a region cannot be changed or deleted.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC.

        To create a VPC, send a POST request to ``/v2/vpcs`` specifying the attributes
        in the table below in the JSON body.

        **Note:** If you do not currently have a VPC network in a specific datacenter
        region, the first one that you create will be set as the default for that
        region. The default VPC for a region cannot be changed or deleted.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "ip_range": "str",  # Optional. The range of IP addresses in the VPC in CIDR
                      notation. Network ranges cannot overlap with other networks in the same account
                      and must be in range of private addresses as defined in RFC1918. It may not be
                      smaller than ``/28`` nor larger than ``/16``. If no IP range is specified, a
                      ``/20`` network range is generated that won't conflict with other VPC networks in
                      your account.
                    "name": "str",  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                    "region": "str"  # Optional. The slug identifier for the region where the VPC
                      will be created.
                }

                # response body for status code(s): 201
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpcs_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, vpc_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing VPC.

        To show information about an existing VPC, send a GET request to ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpcs_get_request(
            vpc_id=vpc_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update(
        self,
        vpc_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC.

        To update information about a VPC, send a PUT request to ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "default": bool,  # Optional. A boolean value indicating whether or not the
                      VPC is the default network for the region. All applicable resources are placed
                      into the default VPC network unless otherwise specified during their creation.
                      The ``default`` field cannot be unset from ``true``. If you want to set a new
                      default VPC network, update the ``default`` field of another VPC network in the
                      same region. The previous network's ``default`` field will be set to ``false``
                      when a new default VPC has been defined.
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "name": "str"  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                }

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update(
        self,
        vpc_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC.

        To update information about a VPC, send a PUT request to ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update(self, vpc_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC.

        To update information about a VPC, send a PUT request to ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "default": bool,  # Optional. A boolean value indicating whether or not the
                      VPC is the default network for the region. All applicable resources are placed
                      into the default VPC network unless otherwise specified during their creation.
                      The ``default`` field cannot be unset from ``true``. If you want to set a new
                      default VPC network, update the ``default`` field of another VPC network in the
                      same region. The previous network's ``default`` field will be set to ``false``
                      when a new default VPC has been defined.
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "name": "str"  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                }

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpcs_update_request(
            vpc_id=vpc_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch(
        self,
        vpc_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Partially Update a VPC.

        To update a subset of information about a VPC, send a PATCH request to
        ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "default": bool,  # Optional. A boolean value indicating whether or not the
                      VPC is the default network for the region. All applicable resources are placed
                      into the default VPC network unless otherwise specified during their creation.
                      The ``default`` field cannot be unset from ``true``. If you want to set a new
                      default VPC network, update the ``default`` field of another VPC network in the
                      same region. The previous network's ``default`` field will be set to ``false``
                      when a new default VPC has been defined.
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "name": "str"  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                }

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch(
        self,
        vpc_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Partially Update a VPC.

        To update a subset of information about a VPC, send a PATCH request to
        ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch(self, vpc_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Partially Update a VPC.

        To update a subset of information about a VPC, send a PATCH request to
        ``/v2/vpcs/$VPC_ID``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "default": bool,  # Optional. A boolean value indicating whether or not the
                      VPC is the default network for the region. All applicable resources are placed
                      into the default VPC network unless otherwise specified during their creation.
                      The ``default`` field cannot be unset from ``true``. If you want to set a new
                      default VPC network, update the ``default`` field of another VPC network in the
                      same region. The previous network's ``default`` field will be set to ``false``
                      when a new default VPC has been defined.
                    "description": "str",  # Optional. A free-form text field for describing the
                      VPC's purpose. It may be a maximum of 255 characters.
                    "name": "str"  # Optional. The name of the VPC. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods.
                }

                # response body for status code(s): 200
                response == {
                    "vpc": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "default": bool,  # Optional. A boolean value indicating whether or
                          not the VPC is the default network for the region. All applicable resources
                          are placed into the default VPC network unless otherwise specified during
                          their creation. The ``default`` field cannot be unset from ``true``. If you
                          want to set a new default VPC network, update the ``default`` field of
                          another VPC network in the same region. The previous network's ``default``
                          field will be set to ``false`` when a new default VPC has been defined.
                        "description": "str",  # Optional. A free-form text field for
                          describing the VPC's purpose. It may be a maximum of 255 characters.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC.
                        "ip_range": "str",  # Optional. The range of IP addresses in the VPC
                          in CIDR notation. Network ranges cannot overlap with other networks in the
                          same account and must be in range of private addresses as defined in RFC1918.
                          It may not be smaller than ``/28`` nor larger than ``/16``. If no IP range is
                          specified, a ``/20`` network range is generated that won't conflict with
                          other VPC networks in your account.
                        "name": "str",  # Optional. The name of the VPC. Must be unique and
                          may only contain alphanumeric characters, dashes, and periods.
                        "region": "str",  # Optional. The slug identifier for the region
                          where the VPC will be created.
                        "urn": "str"  # Optional. The uniform resource name (URN) for the
                          resource in the format do:resource_type:resource_id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpcs_patch_request(
            vpc_id=vpc_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, vpc_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a VPC.

        To delete a VPC, send a DELETE request to ``/v2/vpcs/$VPC_ID``. A 204 status
        code with no body will be returned in response to a successful request.

        The default VPC for a region can not be deleted. Additionally, a VPC can only
        be deleted if it does not contain any member resources. Attempting to delete
        a region's default VPC or a VPC that still has members will result in a
        403 Forbidden error response.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_vpcs_delete_request(
            vpc_id=vpc_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def list_members(
        self,
        vpc_id: str,
        *,
        resource_type: Optional[str] = None,
        per_page: int = 20,
        page: int = 1,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List the Member Resources of a VPC.

        To list all of the resources that are members of a VPC, send a GET request to
        ``/v2/vpcs/$VPC_ID/members``.

        To only list resources of a specific type that are members of the VPC,
        included a ``resource_type`` query parameter. For example, to only list Droplets
        in the VPC, send a GET request to ``/v2/vpcs/$VPC_ID/members?resource_type=droplet``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :keyword resource_type: Used to filter VPC members by a resource type. Default value is None.
        :paramtype resource_type: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "members": [
                        {
                            "created_at": "str",  # Optional. A time value given in
                              ISO8601 combined date and time format that represents when the resource
                              was created.
                            "name": "str",  # Optional. The name of the resource.
                            "urn": "str"  # Optional. The uniform resource name (URN) for
                              the resource in the format do:resource_type:resource_id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpcs_list_members_request(
            vpc_id=vpc_id,
            resource_type=resource_type,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_peerings(
        self, vpc_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List the Peerings of a VPC.

        To list all of a VPC's peerings, send a GET request to
        ``/v2/vpcs/$VPC_ID/peerings``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "peerings": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the VPC peering.
                            "name": "str",  # Optional. The name of the VPC peering. Must
                              be unique within the team and may only contain alphanumeric characters
                              and dashes.
                            "status": "str",  # Optional. The current status of the VPC
                              peering. Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                            "vpc_ids": [
                                "str"  # Optional. An array of the two peered VPCs
                                  IDs.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpcs_list_peerings_request(
            vpc_id=vpc_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_peerings(
        self,
        vpc_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Peering with a VPC.

        To create a new VPC peering for a given VPC, send a POST request to
        ``/v2/vpcs/$VPC_ID/peerings``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name of the VPC peering. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods. Required.
                    "vpc_id": "str"  # The ID of the VPC to peer with. Required.
                }

                # response body for status code(s): 202
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_peerings(
        self,
        vpc_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Peering with a VPC.

        To create a new VPC peering for a given VPC, send a POST request to
        ``/v2/vpcs/$VPC_ID/peerings``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_peerings(
        self, vpc_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Peering with a VPC.

        To create a new VPC peering for a given VPC, send a POST request to
        ``/v2/vpcs/$VPC_ID/peerings``.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # The name of the VPC peering. Must be unique and may only
                      contain alphanumeric characters, dashes, and periods. Required.
                    "vpc_id": "str"  # The ID of the VPC to peer with. Required.
                }

                # response body for status code(s): 202
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpcs_create_peerings_request(
            vpc_id=vpc_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch_peerings(
        self,
        vpc_id: str,
        vpc_peering_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC Peering.

        To update the name of a VPC peering in a particular VPC, send a PATCH request
        to ``/v2/vpcs/$VPC_ID/peerings/$VPC_PEERING_ID`` with the new ``name`` in the
        request body.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. The name of the VPC peering. Must be unique within
                      the team and may only contain alphanumeric characters and dashes.
                }

                # response body for status code(s): 200
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch_peerings(
        self,
        vpc_id: str,
        vpc_peering_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC Peering.

        To update the name of a VPC peering in a particular VPC, send a PATCH request
        to ``/v2/vpcs/$VPC_ID/peerings/$VPC_PEERING_ID`` with the new ``name`` in the
        request body.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch_peerings(
        self,
        vpc_id: str,
        vpc_peering_id: str,
        body: Union[JSON, IO[bytes]],
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC Peering.

        To update the name of a VPC peering in a particular VPC, send a PATCH request
        to ``/v2/vpcs/$VPC_ID/peerings/$VPC_PEERING_ID`` with the new ``name`` in the
        request body.

        :param vpc_id: A unique identifier for a VPC. Required.
        :type vpc_id: str
        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. The name of the VPC peering. Must be unique within
                      the team and may only contain alphanumeric characters and dashes.
                }

                # response body for status code(s): 200
                response == {
                    "peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpcs_patch_peerings_request(
            vpc_id=vpc_id,
            vpc_peering_id=vpc_peering_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class VpcPeeringsOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`vpc_peerings` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list(
        self,
        *,
        per_page: int = 20,
        page: int = 1,
        region: Optional[str] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All VPC Peerings.

        To list all of the VPC peerings on your account, send a GET request to ``/v2/vpc_peerings``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :keyword region: The slug identifier for the region where the resource is available. Known
         values are: "ams1", "ams2", "ams3", "blr1", "fra1", "lon1", "nyc1", "nyc2", "nyc3", "sfo1",
         "sfo2", "sfo3", "sgp1", "tor1", and "syd1". Default value is None.
        :paramtype region: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "links": {
                        "pages": {}
                    },
                    "vpc_peerings": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. A time
                              value given in ISO8601 combined date and time format.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the VPC peering.
                            "name": "str",  # Optional. The name of the VPC peering. Must
                              be unique within the team and may only contain alphanumeric characters
                              and dashes.
                            "status": "str",  # Optional. The current status of the VPC
                              peering. Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                            "vpc_ids": [
                                "str"  # Optional. An array of the two peered VPCs
                                  IDs.
                            ]
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpc_peerings_list_request(
            per_page=per_page,
            page=page,
            region=region,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC Peering.

        To create a new VPC Peering, send a POST request to ``/v2/vpc_peerings``
        specifying a name and a list of two VPC IDs to peer. The response code, 202
        Accepted, does not indicate the success or failure of the operation, just
        that the request has been accepted for processing.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # Optional. The name of the VPC peering. Must be unique
                      within the team and may only contain alphanumeric characters and dashes.
                    "vpc_ids": [
                        "str"  # Optional. An array of the two peered VPCs IDs.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
        """

    @overload
    def create(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC Peering.

        To create a new VPC Peering, send a POST request to ``/v2/vpc_peerings``
        specifying a name and a list of two VPC IDs to peer. The response code, 202
        Accepted, does not indicate the success or failure of the operation, just
        that the request has been accepted for processing.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
        """

    @distributed_trace
    def create(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New VPC Peering.

        To create a new VPC Peering, send a POST request to ``/v2/vpc_peerings``
        specifying a name and a list of two VPC IDs to peer. The response code, 202
        Accepted, does not indicate the success or failure of the operation, just
        that the request has been accepted for processing.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str",  # Optional. The name of the VPC peering. Must be unique
                      within the team and may only contain alphanumeric characters and dashes.
                    "vpc_ids": [
                        "str"  # Optional. An array of the two peered VPCs IDs.
                    ]
                }

                # response body for status code(s): 202
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpc_peerings_create_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get(self, vpc_peering_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing VPC Peering.

        To show information about an existing VPC Peering, send a GET request to
        ``/v2/vpc_peerings/$VPC_PEERING_ID``.

        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpc_peerings_get_request(
            vpc_peering_id=vpc_peering_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def patch(
        self,
        vpc_peering_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC peering.

        To update the name of a VPC peering, send a PATCH request to
        ``/v2/vpc_peerings/$VPC_PEERING_ID`` with the new ``name`` in the request body.

        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. The name of the VPC peering. Must be unique within
                      the team and may only contain alphanumeric characters and dashes.
                }

                # response body for status code(s): 200
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def patch(
        self,
        vpc_peering_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC peering.

        To update the name of a VPC peering, send a PATCH request to
        ``/v2/vpc_peerings/$VPC_PEERING_ID`` with the new ``name`` in the request body.

        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def patch(
        self, vpc_peering_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a VPC peering.

        To update the name of a VPC peering, send a PATCH request to
        ``/v2/vpc_peerings/$VPC_PEERING_ID`` with the new ``name`` in the request body.

        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "name": "str"  # Optional. The name of the VPC peering. Must be unique within
                      the team and may only contain alphanumeric characters and dashes.
                }

                # response body for status code(s): 200
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_vpc_peerings_patch_request(
            vpc_peering_id=vpc_peering_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete(self, vpc_peering_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete a VPC peering.

        To delete a VPC peering, send a DELETE request to ``/v2/vpc_peerings/$VPC_PEERING_ID``.

        :param vpc_peering_id: A unique identifier for a VPC peering. Required.
        :type vpc_peering_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 202
                response == {
                    "vpc_peering": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. A time value given
                          in ISO8601 combined date and time format.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the VPC peering.
                        "name": "str",  # Optional. The name of the VPC peering. Must be
                          unique within the team and may only contain alphanumeric characters and
                          dashes.
                        "status": "str",  # Optional. The current status of the VPC peering.
                          Known values are: "PROVISIONING", "ACTIVE", and "DELETING".
                        "vpc_ids": [
                            "str"  # Optional. An array of the two peered VPCs IDs.
                        ]
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_vpc_peerings_delete_request(
            vpc_peering_id=vpc_peering_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [202, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 202:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore


class UptimeOperations:
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`uptime` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_checks(self, *, per_page: int = 20, page: int = 1, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """List All Checks.

        To list all of the Uptime checks on your account, send a GET request to ``/v2/uptime/checks``.

        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "checks": [
                        {
                            "enabled": True,  # Optional. Default value is True. A
                              boolean value indicating whether the check is enabled/disabled.
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the check.
                            "name": "str",  # Optional. A human-friendly display name.
                            "regions": [
                                "str"  # Optional. An array containing the selected
                                  regions to perform healthchecks from.
                            ],
                            "target": "str",  # Optional. The endpoint to perform
                              healthchecks on.
                            "type": "str"  # Optional. The type of health check to
                              perform. Known values are: "ping", "http", and "https".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_uptime_list_checks_request(
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_check(
        self, body: JSON, *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Check.

        To create an Uptime check, send a POST request to ``/v2/uptime/checks`` specifying the
        attributes
        in the table below in the JSON body.

        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "enabled": True,  # Optional. Default value is True. A boolean value
                      indicating whether the check is enabled/disabled.
                    "name": "str",  # Optional. A human-friendly display name.
                    "regions": [
                        "str"  # Optional. An array containing the selected regions to
                          perform healthchecks from.
                    ],
                    "target": "str",  # Optional. The endpoint to perform healthchecks on.
                    "type": "str"  # Optional. The type of health check to perform. Known values
                      are: "ping", "http", and "https".
                }

                # response body for status code(s): 201
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
        """

    @overload
    def create_check(
        self, body: IO[bytes], *, content_type: str = "application/json", **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Check.

        To create an Uptime check, send a POST request to ``/v2/uptime/checks`` specifying the
        attributes
        in the table below in the JSON body.

        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
        """

    @distributed_trace
    def create_check(self, body: Union[JSON, IO[bytes]], **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Check.

        To create an Uptime check, send a POST request to ``/v2/uptime/checks`` specifying the
        attributes
        in the table below in the JSON body.

        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "enabled": True,  # Optional. Default value is True. A boolean value
                      indicating whether the check is enabled/disabled.
                    "name": "str",  # Optional. A human-friendly display name.
                    "regions": [
                        "str"  # Optional. An array containing the selected regions to
                          perform healthchecks from.
                    ],
                    "target": "str",  # Optional. The endpoint to perform healthchecks on.
                    "type": "str"  # Optional. The type of health check to perform. Known values
                      are: "ping", "http", and "https".
                }

                # response body for status code(s): 201
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_uptime_create_check_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        response_headers["ratelimit-limit"] = self._deserialize(
            "int", response.headers.get("ratelimit-limit")
        )
        response_headers["ratelimit-remaining"] = self._deserialize(
            "int", response.headers.get("ratelimit-remaining")
        )
        response_headers["ratelimit-reset"] = self._deserialize(
            "int", response.headers.get("ratelimit-reset")
        )

        if response.content:
            deserialized = response.json()
        else:
            deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_check(self, check_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Check.

        To show information about an existing check, send a GET request to
        ``/v2/uptime/checks/$CHECK_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_uptime_get_check_request(
            check_id=check_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_check(
        self,
        check_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Check.

        To update the settings of an Uptime check, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "enabled": True,  # Optional. Default value is True. A boolean value
                      indicating whether the check is enabled/disabled.
                    "name": "str",  # Optional. A human-friendly display name.
                    "regions": [
                        "str"  # Optional. An array containing the selected regions to
                          perform healthchecks from.
                    ],
                    "target": "str",  # Optional. The endpoint to perform healthchecks on.
                    "type": "str"  # Optional. The type of health check to perform. Known values
                      are: "ping", "http", and "https".
                }

                # response body for status code(s): 200
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_check(
        self,
        check_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Check.

        To update the settings of an Uptime check, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_check(
        self, check_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Check.

        To update the settings of an Uptime check, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "enabled": True,  # Optional. Default value is True. A boolean value
                      indicating whether the check is enabled/disabled.
                    "name": "str",  # Optional. A human-friendly display name.
                    "regions": [
                        "str"  # Optional. An array containing the selected regions to
                          perform healthchecks from.
                    ],
                    "target": "str",  # Optional. The endpoint to perform healthchecks on.
                    "type": "str"  # Optional. The type of health check to perform. Known values
                      are: "ping", "http", and "https".
                }

                # response body for status code(s): 200
                response == {
                    "check": {
                        "enabled": True,  # Optional. Default value is True. A boolean value
                          indicating whether the check is enabled/disabled.
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the check.
                        "name": "str",  # Optional. A human-friendly display name.
                        "regions": [
                            "str"  # Optional. An array containing the selected regions
                              to perform healthchecks from.
                        ],
                        "target": "str",  # Optional. The endpoint to perform healthchecks
                          on.
                        "type": "str"  # Optional. The type of health check to perform. Known
                          values are: "ping", "http", and "https".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_uptime_update_check_request(
            check_id=check_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_check(self, check_id: str, **kwargs: Any) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete a Check.

        To delete an Uptime check, send a DELETE request to ``/v2/uptime/checks/$CHECK_ID``. A 204
        status
        code with no body will be returned in response to a successful request.

        Deleting a check will also delete alerts associated with the check.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_uptime_delete_check_request(
            check_id=check_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore

    @distributed_trace
    def get_check_state(self, check_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Check State.

        To show information about an existing check's state, send a GET request to
        ``/v2/uptime/checks/$CHECK_ID/state``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "state": {
                        "previous_outage": {
                            "duration_seconds": 0,  # Optional.
                            "ended_at": "str",  # Optional.
                            "region": "str",  # Optional.
                            "started_at": "str"  # Optional.
                        },
                        "regions": {
                            "eu_west": {
                                "status": "str",  # Optional. Known values are:
                                  "DOWN", "UP", and "CHECKING".
                                "status_changed_at": "str",  # Optional. A map of
                                  region to regional state.
                                "thirty_day_uptime_percentage": 0.0  # Optional. A
                                  map of region to regional state.
                            },
                            "us_east": {
                                "status": "str",  # Optional. Known values are:
                                  "DOWN", "UP", and "CHECKING".
                                "status_changed_at": "str",  # Optional. A map of
                                  region to regional state.
                                "thirty_day_uptime_percentage": 0.0  # Optional. A
                                  map of region to regional state.
                            }
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_uptime_get_check_state_request(
            check_id=check_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_alerts(
        self, check_id: str, *, per_page: int = 20, page: int = 1, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List All Alerts.

        To list all of the alerts for an Uptime check, send a GET request to
        ``/v2/uptime/checks/$CHECK_ID/alerts``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :keyword per_page: Number of items returned per page. Default value is 20.
        :paramtype per_page: int
        :keyword page: Which 'page' of paginated results to return. Default value is 1.
        :paramtype page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "meta": {
                        "total": 0  # Optional. Number of objects returned by the request.
                    },
                    "alerts": [
                        {
                            "comparison": "str",  # Optional. The comparison operator
                              used against the alert's threshold. Known values are: "greater_than" and
                              "less_than".
                            "id": "str",  # Optional. A unique ID that can be used to
                              identify and reference the alert.
                            "name": "str",  # Optional. A human-friendly display name.
                            "notifications": {
                                "email": [
                                    "str"  # An email to notify on an alert
                                      trigger. The Email has to be one that is verified on that
                                      DigitalOcean account. Required.
                                ],
                                "slack": [
                                    {
                                        "channel": "str",  # Slack channel to
                                          notify of an alert trigger. Required.
                                        "url": "str"  # Slack Webhook URL.
                                          Required.
                                    }
                                ]
                            },
                            "period": "str",  # Optional. Period of time the threshold
                              must be exceeded to trigger the alert. Known values are: "2m", "3m",
                              "5m", "10m", "15m", "30m", and "1h".
                            "threshold": 0,  # Optional. The threshold at which the alert
                              will enter a trigger state. The specific threshold is dependent on the
                              alert type.
                            "type": "str"  # Optional. The type of alert. Known values
                              are: "latency", "down", "down_global", and "ssl_expiry".
                        }
                    ],
                    "links": {
                        "pages": {}
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_uptime_list_alerts_request(
            check_id=check_id,
            per_page=per_page,
            page=page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_alert(
        self,
        check_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Alert.

        To create an Uptime alert, send a POST request to ``/v2/uptime/checks/$CHECK_ID/alerts``
        specifying the attributes
        in the table below in the JSON body.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: The ''type'' field dictates the type of alert, and hence what type of value to
         pass into the threshold property.
         Type | Description | Threshold Value
         -----|-------------|--------------------
         ``latency`` | alerts on the response latency | milliseconds
         ``down`` | alerts on a target registering as down in any region | N/A (Not required)
         ``down_global`` | alerts on a target registering as down globally | N/A (Not required)
         ``ssl_expiry`` | alerts on a SSL certificate expiring within $threshold days | days. Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "comparison": "str",  # Optional. The comparison operator used against the
                      alert's threshold. Known values are: "greater_than" and "less_than".
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference the alert.
                    "name": "str",  # Optional. A human-friendly display name.
                    "notifications": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. The Email
                              has to be one that is verified on that DigitalOcean account. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "period": "str",  # Optional. Period of time the threshold must be exceeded
                      to trigger the alert. Known values are: "2m", "3m", "5m", "10m", "15m", "30m",
                      and "1h".
                    "threshold": 0,  # Optional. The threshold at which the alert will enter a
                      trigger state. The specific threshold is dependent on the alert type.
                    "type": "str"  # Optional. The type of alert. Known values are: "latency",
                      "down", "down_global", and "ssl_expiry".
                }

                # response body for status code(s): 201
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_alert(
        self,
        check_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Alert.

        To create an Uptime alert, send a POST request to ``/v2/uptime/checks/$CHECK_ID/alerts``
        specifying the attributes
        in the table below in the JSON body.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: The ''type'' field dictates the type of alert, and hence what type of value to
         pass into the threshold property.
         Type | Description | Threshold Value
         -----|-------------|--------------------
         ``latency`` | alerts on the response latency | milliseconds
         ``down`` | alerts on a target registering as down in any region | N/A (Not required)
         ``down_global`` | alerts on a target registering as down globally | N/A (Not required)
         ``ssl_expiry`` | alerts on a SSL certificate expiring within $threshold days | days. Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 201
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_alert(
        self, check_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a New Alert.

        To create an Uptime alert, send a POST request to ``/v2/uptime/checks/$CHECK_ID/alerts``
        specifying the attributes
        in the table below in the JSON body.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param body: The ''type'' field dictates the type of alert, and hence what type of value to
         pass into the threshold property.
         Type | Description | Threshold Value
         -----|-------------|--------------------
         ``latency`` | alerts on the response latency | milliseconds
         ``down`` | alerts on a target registering as down in any region | N/A (Not required)
         ``down_global`` | alerts on a target registering as down globally | N/A (Not required)
         ``ssl_expiry`` | alerts on a SSL certificate expiring within $threshold days | days. Is either
         a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "comparison": "str",  # Optional. The comparison operator used against the
                      alert's threshold. Known values are: "greater_than" and "less_than".
                    "id": "str",  # Optional. A unique ID that can be used to identify and
                      reference the alert.
                    "name": "str",  # Optional. A human-friendly display name.
                    "notifications": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. The Email
                              has to be one that is verified on that DigitalOcean account. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "period": "str",  # Optional. Period of time the threshold must be exceeded
                      to trigger the alert. Known values are: "2m", "3m", "5m", "10m", "15m", "30m",
                      and "1h".
                    "threshold": 0,  # Optional. The threshold at which the alert will enter a
                      trigger state. The specific threshold is dependent on the alert type.
                    "type": "str"  # Optional. The type of alert. Known values are: "latency",
                      "down", "down_global", and "ssl_expiry".
                }

                # response body for status code(s): 201
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_uptime_create_alert_request(
            check_id=check_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [201, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 201:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_alert(self, check_id: str, alert_id: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Alert.

        To show information about an existing alert, send a GET request to
        ``/v2/uptime/checks/$CHECK_ID/alerts/$ALERT_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param alert_id: A unique identifier for an alert. Required.
        :type alert_id: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_uptime_get_alert_request(
            check_id=check_id,
            alert_id=alert_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_alert(
        self,
        check_id: str,
        alert_id: str,
        body: JSON,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert.

        To update the settings of an Uptime alert, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID/alerts/$ALERT_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param alert_id: A unique identifier for an alert. Required.
        :type alert_id: str
        :param body: Required.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "comparison": "str",  # Optional. The comparison operator used against the
                      alert's threshold. Known values are: "greater_than" and "less_than".
                    "name": "str",  # Optional. A human-friendly display name.
                    "notifications": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. The Email
                              has to be one that is verified on that DigitalOcean account. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "period": "str",  # Optional. Period of time the threshold must be exceeded
                      to trigger the alert. Known values are: "2m", "3m", "5m", "10m", "15m", "30m",
                      and "1h".
                    "threshold": 0,  # Optional. The threshold at which the alert will enter a
                      trigger state. The specific threshold is dependent on the alert type.
                    "type": "str"  # Optional. The type of alert. Known values are: "latency",
                      "down", "down_global", and "ssl_expiry".
                }

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_alert(
        self,
        check_id: str,
        alert_id: str,
        body: IO[bytes],
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert.

        To update the settings of an Uptime alert, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID/alerts/$ALERT_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param alert_id: A unique identifier for an alert. Required.
        :type alert_id: str
        :param body: Required.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_alert(
        self, check_id: str, alert_id: str, body: Union[JSON, IO[bytes]], **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Alert.

        To update the settings of an Uptime alert, send a PUT request to
        ``/v2/uptime/checks/$CHECK_ID/alerts/$ALERT_ID``.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param alert_id: A unique identifier for an alert. Required.
        :type alert_id: str
        :param body: Is either a JSON type or a IO[bytes] type. Required.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "comparison": "str",  # Optional. The comparison operator used against the
                      alert's threshold. Known values are: "greater_than" and "less_than".
                    "name": "str",  # Optional. A human-friendly display name.
                    "notifications": {
                        "email": [
                            "str"  # An email to notify on an alert trigger. The Email
                              has to be one that is verified on that DigitalOcean account. Required.
                        ],
                        "slack": [
                            {
                                "channel": "str",  # Slack channel to notify of an
                                  alert trigger. Required.
                                "url": "str"  # Slack Webhook URL. Required.
                            }
                        ]
                    },
                    "period": "str",  # Optional. Period of time the threshold must be exceeded
                      to trigger the alert. Known values are: "2m", "3m", "5m", "10m", "15m", "30m",
                      and "1h".
                    "threshold": 0,  # Optional. The threshold at which the alert will enter a
                      trigger state. The specific threshold is dependent on the alert type.
                    "type": "str"  # Optional. The type of alert. Known values are: "latency",
                      "down", "down_global", and "ssl_expiry".
                }

                # response body for status code(s): 200
                response == {
                    "alert": {
                        "comparison": "str",  # Optional. The comparison operator used
                          against the alert's threshold. Known values are: "greater_than" and
                          "less_than".
                        "id": "str",  # Optional. A unique ID that can be used to identify
                          and reference the alert.
                        "name": "str",  # Optional. A human-friendly display name.
                        "notifications": {
                            "email": [
                                "str"  # An email to notify on an alert trigger. The
                                  Email has to be one that is verified on that DigitalOcean account.
                                  Required.
                            ],
                            "slack": [
                                {
                                    "channel": "str",  # Slack channel to notify
                                      of an alert trigger. Required.
                                    "url": "str"  # Slack Webhook URL. Required.
                                }
                            ]
                        },
                        "period": "str",  # Optional. Period of time the threshold must be
                          exceeded to trigger the alert. Known values are: "2m", "3m", "5m", "10m",
                          "15m", "30m", and "1h".
                        "threshold": 0,  # Optional. The threshold at which the alert will
                          enter a trigger state. The specific threshold is dependent on the alert type.
                        "type": "str"  # Optional. The type of alert. Known values are:
                          "latency", "down", "down_global", and "ssl_expiry".
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            _json = body

        _request = build_uptime_update_alert_request(
            check_id=check_id,
            alert_id=alert_id,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_alert(
        self, check_id: str, alert_id: str, **kwargs: Any
    ) -> Optional[JSON]:
        # pylint: disable=line-too-long
        """Delete an Alert.

        To delete an Uptime alert, send a DELETE request to
        ``/v2/uptime/checks/$CHECK_ID/alerts/$ALERT_ID``. A 204 status
        code with no body will be returned in response to a successful request.

        :param check_id: A unique identifier for a check. Required.
        :type check_id: str
        :param alert_id: A unique identifier for an alert. Required.
        :type alert_id: str
        :return: JSON object or None
        :rtype: JSON or None
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[Optional[JSON]] = kwargs.pop("cls", None)

        _request = build_uptime_delete_alert_request(
            check_id=check_id,
            alert_id=alert_id,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [204, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        deserialized = None
        response_headers = {}
        if response.status_code == 204:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, deserialized, response_headers)  # type: ignore

        return deserialized  # type: ignore


class GenaiOperations:  # pylint: disable=too-many-public-methods
    """
    .. warning::
        **DO NOT** instantiate this class directly.

        Instead, you should access the following operations through
        :class:`~pydo.GeneratedClient`'s
        :attr:`genai` attribute.
    """

    def __init__(self, *args, **kwargs):
        input_args = list(args)
        self._client = input_args.pop(0) if input_args else kwargs.pop("client")
        self._config = input_args.pop(0) if input_args else kwargs.pop("config")
        self._serialize = input_args.pop(0) if input_args else kwargs.pop("serializer")
        self._deserialize = (
            input_args.pop(0) if input_args else kwargs.pop("deserializer")
        )

    @distributed_trace
    def list_agents(
        self,
        *,
        only_deployed: Optional[bool] = None,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Agents.

        To list all agents, send a GET request to ``/v2/gen-ai/agents``.

        :keyword only_deployed: Only list agents that are deployed. Default value is None.
        :paramtype only_deployed: bool
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agents": [
                        {
                            "chatbot": {
                                "button_background_color": "str",  # Optional. A
                                  Chatbot.
                                "logo": "str",  # Optional. A Chatbot.
                                "name": "str",  # Optional. Name of chatbot.
                                "primary_color": "str",  # Optional. A Chatbot.
                                "secondary_color": "str",  # Optional. A Chatbot.
                                "starting_message": "str"  # Optional. A Chatbot.
                            },
                            "chatbot_identifiers": [
                                {
                                    "agent_chatbot_identifier": "str"  #
                                      Optional. Agent chatbot identifier.
                                }
                            ],
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "deployment": {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "name": "str",  # Optional. Name.
                                "status": "STATUS_UNKNOWN",  # Optional. Default
                                  value is "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                                  "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING",
                                  "STATUS_RUNNING", "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT",
                                  "STATUS_UNDEPLOYING", "STATUS_UNDEPLOYMENT_FAILED", and
                                  "STATUS_DELETED".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Access your deployed agent
                                  here.
                                "uuid": "str",  # Optional. Unique id.
                                "visibility": "VISIBILITY_UNKNOWN"  # Optional.
                                  Default value is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The
                                  status of the deployment is unknown    * VISIBILITY_DISABLED: The
                                  deployment is disabled and will no longer service requests   *
                                  VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state   *
                                  VISIBILITY_PUBLIC: The deployment is public and will service requests
                                  from the public internet   * VISIBILITY_PRIVATE: The deployment is
                                  private and will only service requests from other agents, or through
                                  API keys. Known values are: "VISIBILITY_UNKNOWN",
                                  "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND", "VISIBILITY_PUBLIC",
                                  and "VISIBILITY_PRIVATE".
                            },
                            "description": "str",  # Optional. Description of agent.
                            "if_case": "str",  # Optional. Instructions to the agent on
                              how to use the route.
                            "instruction": "str",  # Optional. Agent instruction.
                              Instructions help your agent to perform its job effectively. See `Write
                              Effective Agent Instructions
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                              for best practices.
                            "k": 0,  # Optional. How many results should be considered
                              from an attached knowledge base.
                            "max_tokens": 0,  # Optional. Specifies the maximum number of
                              tokens the model can process in a single input or output, set as a number
                              between 1 and 512. This determines the length of each response.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Agent name.
                            "project_id": "str",  # Optional. The DigitalOcean project ID
                              associated with the agent.
                            "region": "str",  # Optional. Region code.
                            "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional.
                              Default value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN:
                              The retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The
                              retrieval method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval
                              method is step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval
                              method is sub queries   * RETRIEVAL_METHOD_NONE: The retrieval method is
                              none. Known values are: "RETRIEVAL_METHOD_UNKNOWN",
                              "RETRIEVAL_METHOD_REWRITE", "RETRIEVAL_METHOD_STEP_BACK",
                              "RETRIEVAL_METHOD_SUB_QUERIES", and "RETRIEVAL_METHOD_NONE".
                            "route_created_at": "2020-02-20 00:00:00",  # Optional.
                              Creation of route date / time.
                            "route_created_by": "str",  # Optional. Id of user that
                              created the route.
                            "route_name": "str",  # Optional. Route name.
                            "route_uuid": "str",  # Optional. Route uuid.
                            "tags": [
                                "str"  # Optional. A set of abitrary tags to organize
                                  your agent.
                            ],
                            "temperature": 0.0,  # Optional. Controls the model"u2019s
                              creativity, specified as a number between 0 and 1. Lower values produce
                              more predictable and conservative responses, while higher values
                              encourage creativity and variation.
                            "template": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's creation date.
                                "description": "str",  # Optional. Description of the
                                  agent template.
                                "instruction": "str",  # Optional. Instructions for
                                  the agent template.
                                "k": 0,  # Optional. The 'k' value for the agent
                                  template.
                                "knowledge_bases": [
                                    {
                                        "added_to_agent_at": "2020-02-20
                                          00:00:00",  # Optional. Time when the knowledge base was
                                          added to the agent.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "database_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "embedding_model_uuid": "str",  #
                                          Optional. List of knowledge bases associated with the agent
                                          template.
                                        "is_public": bool,  # Optional.
                                          Whether the knowledge base is public or not.
                                        "last_indexing_job": {
                                            "completed_datasources": 0,
                                              # Optional. Number of datasources indexed completed.
                                            "created_at": "2020-02-20
                                              00:00:00",  # Optional. Creation date / time.
                                            "data_source_uuids": [
                                                "str"  # Optional.
                                                  IndexingJob description.
                                            ],
                                            "finished_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "knowledge_base_uuid": "str",
                                              # Optional. Knowledge base id.
                                            "phase":
                                              "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                                              "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                              "BATCH_JOB_PHASE_CANCELLED".
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "tokens": 0,  # Optional.
                                              Number of tokens.
                                            "total_datasources": 0,  #
                                              Optional. Number of datasources being indexed.
                                            "updated_at": "2020-02-20
                                              00:00:00",  # Optional. Last modified.
                                            "uuid": "str"  # Optional.
                                              Unique id.
                                        },
                                        "name": "str",  # Optional. Name of
                                          knowledge base.
                                        "project_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "region": "str",  # Optional. Region
                                          code.
                                        "tags": [
                                            "str"  # Optional. Tags to
                                              organize related resources.
                                        ],
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "user_id": "str",  # Optional. Id of
                                          user that created the knowledge base.
                                        "uuid": "str"  # Optional. Unique id
                                          for knowledge base.
                                    }
                                ],
                                "max_tokens": 0,  # Optional. The max_tokens setting
                                  for the agent template.
                                "model": {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                },
                                "name": "str",  # Optional. Name of the agent
                                  template.
                                "temperature": 0.0,  # Optional. The temperature
                                  setting for the agent template.
                                "top_p": 0.0,  # Optional. The top_p setting for the
                                  agent template.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's last updated date.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "top_p": 0.0,  # Optional. Defines the cumulative probability
                              threshold for word selection, specified as a number between 0 and 1.
                              Higher values allow for more diverse outputs, while lower values ensure
                              focused and coherent responses.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your agent under this url.
                            "user_id": "str",  # Optional. Id of user that created the
                              agent.
                            "uuid": "str"  # Optional. Unique agent id.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_agents_request(
            only_deployed=only_deployed,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_agent(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent.

        To create a new agent, send a POST request to ``/v2/gen-ai/agents``. The response body contains
        a JSON object with the newly created agent object.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "anthropic_key_uuid": "str",  # Optional. Optional Anthropic API key ID to
                      use with Anthropic models.
                    "description": "str",  # Optional. A text description of the agent, not used
                      in inference.
                    "instruction": "str",  # Optional. Agent instruction. Instructions help your
                      agent to perform its job effectively. See `Write Effective Agent Instructions
                      <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                      for best practices.
                    "knowledge_base_uuid": [
                        "str"  # Optional. Ids of the knowledge base(s) to attach to the
                          agent.
                    ],
                    "model_uuid": "str",  # Optional. Identifier for the foundation model.
                    "name": "str",  # Optional. Agent name.
                    "open_ai_key_uuid": "str",  # Optional. Optional OpenAI API key ID to use
                      with OpenAI models.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      agent will belong to.
                    "region": "str",  # Optional. The DigitalOcean region to deploy your agent
                      in.
                    "tags": [
                        "str"  # Optional. Agent tag to organize related resources.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_agent(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent.

        To create a new agent, send a POST request to ``/v2/gen-ai/agents``. The response body contains
        a JSON object with the newly created agent object.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_agent(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent.

        To create a new agent, send a POST request to ``/v2/gen-ai/agents``. The response body contains
        a JSON object with the newly created agent object.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "anthropic_key_uuid": "str",  # Optional. Optional Anthropic API key ID to
                      use with Anthropic models.
                    "description": "str",  # Optional. A text description of the agent, not used
                      in inference.
                    "instruction": "str",  # Optional. Agent instruction. Instructions help your
                      agent to perform its job effectively. See `Write Effective Agent Instructions
                      <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                      for best practices.
                    "knowledge_base_uuid": [
                        "str"  # Optional. Ids of the knowledge base(s) to attach to the
                          agent.
                    ],
                    "model_uuid": "str",  # Optional. Identifier for the foundation model.
                    "name": "str",  # Optional. Agent name.
                    "open_ai_key_uuid": "str",  # Optional. Optional OpenAI API key ID to use
                      with OpenAI models.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      agent will belong to.
                    "region": "str",  # Optional. The DigitalOcean region to deploy your agent
                      in.
                    "tags": [
                        "str"  # Optional. Agent tag to organize related resources.
                    ]
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_agent_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_agent_api_keys(
        self,
        agent_uuid: str,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Agent API Keys.

        To list all agent API keys, send a GET request to ``/v2/gen-ai/agents/{agent_uuid}/api_keys``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_infos": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date.
                            "created_by": "str",  # Optional. Created by.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "secret_key": "str",  # Optional. Api key infos.
                            "uuid": "str"  # Optional. Uuid.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_agent_api_keys_request(
            agent_uuid=agent_uuid,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_agent_api_key(
        self,
        agent_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent API Key.

        To create an agent API key, send a POST request to ``/v2/gen-ai/agents/{agent_uuid}/api_keys``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "name": "str"  # Optional. A human friendly name to identify the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_agent_api_key(
        self,
        agent_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent API Key.

        To create an agent API key, send a POST request to ``/v2/gen-ai/agents/{agent_uuid}/api_keys``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_agent_api_key(
        self,
        agent_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create an Agent API Key.

        To create an agent API key, send a POST request to ``/v2/gen-ai/agents/{agent_uuid}/api_keys``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "name": "str"  # Optional. A human friendly name to identify the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_agent_api_key_request(
            agent_uuid=agent_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_agent_api_key(
        self,
        agent_uuid: str,
        api_key_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update API Key for an Agent.

        To update an agent API key, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param api_key_uuid: Api key id. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "api_key_uuid": "str",  # Optional. Api key id.
                    "name": "str"  # Optional. Name.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_agent_api_key(
        self,
        agent_uuid: str,
        api_key_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update API Key for an Agent.

        To update an agent API key, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param api_key_uuid: Api key id. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_agent_api_key(
        self,
        agent_uuid: str,
        api_key_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update API Key for an Agent.

        To update an agent API key, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param api_key_uuid: Api key id. Required.
        :type api_key_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "api_key_uuid": "str",  # Optional. Api key id.
                    "name": "str"  # Optional. Name.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_agent_api_key_request(
            agent_uuid=agent_uuid,
            api_key_uuid=api_key_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_agent_api_key(
        self, agent_uuid: str, api_key_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Delete API Key for an Agent.

        To delete an API key for an agent, send a DELETE request to
        ``/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}``.

        :param agent_uuid: A unique identifier for your agent. Required.
        :type agent_uuid: str
        :param api_key_uuid: API key for an agent. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_agent_api_key_request(
            agent_uuid=agent_uuid,
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def regenerate_agent_api_key(
        self, agent_uuid: str, api_key_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Regenerate API Key for an Agent.

        To regenerate an agent API key, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/api_keys/{api_key_uuid}/regenerate``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param api_key_uuid: Api key id. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date.
                        "created_by": "str",  # Optional. Created by.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Deleted date.
                        "name": "str",  # Optional. Name.
                        "secret_key": "str",  # Optional. Agent API Key Info.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_regenerate_agent_api_key_request(
            agent_uuid=agent_uuid,
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def attach_agent_function(
        self,
        agent_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Function Route to an Agent.

        To create a function route for an agent, send a POST request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "description": "str",  # Optional. Function description.
                    "faas_name": "str",  # Optional. The name of the function in the DigitalOcean
                      functions platform.
                    "faas_namespace": "str",  # Optional. The namespace of the function in the
                      DigitalOcean functions platform.
                    "function_name": "str",  # Optional. Function name.
                    "input_schema": {},  # Optional. Describe the input schema for the function
                      so the agent may call it.
                    "output_schema": {}  # Optional. Describe the output schema for the function
                      so the agent handle its response.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def attach_agent_function(
        self,
        agent_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Function Route to an Agent.

        To create a function route for an agent, send a POST request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def attach_agent_function(
        self,
        agent_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Function Route to an Agent.

        To create a function route for an agent, send a POST request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "description": "str",  # Optional. Function description.
                    "faas_name": "str",  # Optional. The name of the function in the DigitalOcean
                      functions platform.
                    "faas_namespace": "str",  # Optional. The namespace of the function in the
                      DigitalOcean functions platform.
                    "function_name": "str",  # Optional. Function name.
                    "input_schema": {},  # Optional. Describe the input schema for the function
                      so the agent may call it.
                    "output_schema": {}  # Optional. Describe the output schema for the function
                      so the agent handle its response.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_attach_agent_function_request(
            agent_uuid=agent_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_agent_function(
        self,
        agent_uuid: str,
        function_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Function Route for an Agent.

        To update the function route, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param function_uuid: Function id. Required.
        :type function_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "description": "str",  # Optional. Funciton description.
                    "faas_name": "str",  # Optional. The name of the function in the DigitalOcean
                      functions platform.
                    "faas_namespace": "str",  # Optional. The namespace of the function in the
                      DigitalOcean functions platform.
                    "function_name": "str",  # Optional. Function name.
                    "function_uuid": "str",  # Optional. Function id.
                    "input_schema": {},  # Optional. Describe the input schema for the function
                      so the agent may call it.
                    "output_schema": {}  # Optional. Describe the output schema for the function
                      so the agent handle its response.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_agent_function(
        self,
        agent_uuid: str,
        function_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Function Route for an Agent.

        To update the function route, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param function_uuid: Function id. Required.
        :type function_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_agent_function(
        self,
        agent_uuid: str,
        function_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Function Route for an Agent.

        To update the function route, send a PUT request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param function_uuid: Function id. Required.
        :type function_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "agent_uuid": "str",  # Optional. Agent id.
                    "description": "str",  # Optional. Funciton description.
                    "faas_name": "str",  # Optional. The name of the function in the DigitalOcean
                      functions platform.
                    "faas_namespace": "str",  # Optional. The namespace of the function in the
                      DigitalOcean functions platform.
                    "function_name": "str",  # Optional. Function name.
                    "function_uuid": "str",  # Optional. Function id.
                    "input_schema": {},  # Optional. Describe the input schema for the function
                      so the agent may call it.
                    "output_schema": {}  # Optional. Describe the output schema for the function
                      so the agent handle its response.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_agent_function_request(
            agent_uuid=agent_uuid,
            function_uuid=function_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def detach_agent_function(
        self, agent_uuid: str, function_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Delete Function Route for an Agent.

        To delete a function route from an agent, send a DELETE request to
        ``/v2/gen-ai/agents/{agent_uuid}/functions/{function_uuid}``.

        :param agent_uuid: The id of the agent the function route belongs to. Required.
        :type agent_uuid: str
        :param function_uuid: The function route to be destroyed. This does not destroy the function
         itself. Required.
        :type function_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_detach_agent_function_request(
            agent_uuid=agent_uuid,
            function_uuid=function_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def attach_knowledge_base(
        self, agent_uuid: str, knowledge_base_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Attach Knowledge Base to an Agent.

        To attach a knowledge base to an agent, send a POST request to
        ``/v2/gen-ai/agents/{agent_uuid}/knowledge_bases/{knowledge_base_uuid}``.

        :param agent_uuid: A unique identifier for an agent. Required.
        :type agent_uuid: str
        :param knowledge_base_uuid: A unique identifier for a knowledge base. Required.
        :type knowledge_base_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_attach_knowledge_base_request(
            agent_uuid=agent_uuid,
            knowledge_base_uuid=knowledge_base_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def detach_knowledge_base(
        self, agent_uuid: str, knowledge_base_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Detach Knowledge Base from an Agent.

        To detach a knowledge base from an agent, send a DELETE request to
        ``/v2/gen-ai/agents/{agent_uuid}/knowledge_bases/{knowledge_base_uuid}``.

        :param agent_uuid: Agent id. Required.
        :type agent_uuid: str
        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_detach_knowledge_base_request(
            agent_uuid=agent_uuid,
            knowledge_base_uuid=knowledge_base_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def attach_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Agent Route to an Agent.

        To add an agent route to an agent, send a POST request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "if_case": "str",  # Optional.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "route_name": "str"  # Optional. Name of route.
                }

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str"  # Optional. A unique identifier for the parent
                      agent.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def attach_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Agent Route to an Agent.

        To add an agent route to an agent, send a POST request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str"  # Optional. A unique identifier for the parent
                      agent.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def attach_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Agent Route to an Agent.

        To add an agent route to an agent, send a POST request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "if_case": "str",  # Optional.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "route_name": "str"  # Optional. Name of route.
                }

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str"  # Optional. A unique identifier for the parent
                      agent.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_attach_agent_request(
            parent_agent_uuid=parent_agent_uuid,
            child_agent_uuid=child_agent_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_attached_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Route for an Agent.

        To update an agent route for an agent, send a PUT request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "if_case": "str",  # Optional. Describes the case in which the child agent
                      should be used.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "route_name": "str",  # Optional. Route name.
                    "uuid": "str"  # Optional. Unique id of linkage.
                }

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "rollback": bool,  # Optional.
                    "uuid": "str"  # Optional. Unique id of linkage.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_attached_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Route for an Agent.

        To update an agent route for an agent, send a PUT request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "rollback": bool,  # Optional.
                    "uuid": "str"  # Optional. Unique id of linkage.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_attached_agent(
        self,
        parent_agent_uuid: str,
        child_agent_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Route for an Agent.

        To update an agent route for an agent, send a PUT request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: A unique identifier for the parent agent. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "if_case": "str",  # Optional. Describes the case in which the child agent
                      should be used.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "route_name": "str",  # Optional. Route name.
                    "uuid": "str"  # Optional. Unique id of linkage.
                }

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str",  # Optional. A unique identifier for the parent
                      agent.
                    "rollback": bool,  # Optional.
                    "uuid": "str"  # Optional. Unique id of linkage.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_attached_agent_request(
            parent_agent_uuid=parent_agent_uuid,
            child_agent_uuid=child_agent_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def detach_agent(
        self, parent_agent_uuid: str, child_agent_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Delete Agent Route for an Agent.

        To delete an agent route from a parent agent, send a DELETE request to
        ``/v2/gen-ai/agents/{parent_agent_uuid}/child_agents/{child_agent_uuid}``.

        :param parent_agent_uuid: Pagent agent id. Required.
        :type parent_agent_uuid: str
        :param child_agent_uuid: Routed agent id. Required.
        :type child_agent_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "child_agent_uuid": "str",  # Optional. Routed agent id.
                    "parent_agent_uuid": "str"  # Optional. Pagent agent id.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_detach_agent_request(
            parent_agent_uuid=parent_agent_uuid,
            child_agent_uuid=child_agent_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_agent(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve an Existing Agent.

        To retrieve details of an agent, GET request to ``/v2/gen-ai/agents/{uuid}``. The response body
        is a JSON object containing the agent.

        :param uuid: Unique agent id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_agent_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_agent(
        self,
        uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Agent.

        To update an agent, send a PUT request to ``/v2/gen-ai/agents/{uuid}``. The response body is a
        JSON object containing the agent.

        :param uuid: Unique agent id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "anthropic_key_uuid": "str",  # Optional. Optional anthropic key uuid for use
                      with anthropic models.
                    "description": "str",  # Optional. Agent description.
                    "instruction": "str",  # Optional. Agent instruction. Instructions help your
                      agent to perform its job effectively. See `Write Effective Agent Instructions
                      <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                      for best practices.
                    "k": 0,  # Optional. How many results should be considered from an attached
                      knowledge base.
                    "max_tokens": 0,  # Optional. Specifies the maximum number of tokens the
                      model can process in a single input or output, set as a number between 1 and 512.
                      This determines the length of each response.
                    "model_uuid": "str",  # Optional. Identifier for the foundation model.
                    "name": "str",  # Optional. Agent name.
                    "open_ai_key_uuid": "str",  # Optional. Optional OpenAI key uuid for use with
                      OpenAI models.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      agent will belong to.
                    "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default value is
                      "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The retrieval method is
                      unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval method is rewrite   *
                      RETRIEVAL_METHOD_STEP_BACK: The retrieval method is step back   *
                      RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub queries   *
                      RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values are:
                      "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                      "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                      "RETRIEVAL_METHOD_NONE".
                    "tags": [
                        "str"  # Optional. A set of abitrary tags to organize your agent.
                    ],
                    "temperature": 0.0,  # Optional. Controls the model"u2019s creativity,
                      specified as a number between 0 and 1. Lower values produce more predictable and
                      conservative responses, while higher values encourage creativity and variation.
                    "top_p": 0.0,  # Optional. Defines the cumulative probability threshold for
                      word selection, specified as a number between 0 and 1. Higher values allow for
                      more diverse outputs, while lower values ensure focused and coherent responses.
                    "uuid": "str"  # Optional. Unique agent id.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_agent(
        self,
        uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Agent.

        To update an agent, send a PUT request to ``/v2/gen-ai/agents/{uuid}``. The response body is a
        JSON object containing the agent.

        :param uuid: Unique agent id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_agent(
        self, uuid: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update an Agent.

        To update an agent, send a PUT request to ``/v2/gen-ai/agents/{uuid}``. The response body is a
        JSON object containing the agent.

        :param uuid: Unique agent id. Required.
        :type uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "anthropic_key_uuid": "str",  # Optional. Optional anthropic key uuid for use
                      with anthropic models.
                    "description": "str",  # Optional. Agent description.
                    "instruction": "str",  # Optional. Agent instruction. Instructions help your
                      agent to perform its job effectively. See `Write Effective Agent Instructions
                      <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                      for best practices.
                    "k": 0,  # Optional. How many results should be considered from an attached
                      knowledge base.
                    "max_tokens": 0,  # Optional. Specifies the maximum number of tokens the
                      model can process in a single input or output, set as a number between 1 and 512.
                      This determines the length of each response.
                    "model_uuid": "str",  # Optional. Identifier for the foundation model.
                    "name": "str",  # Optional. Agent name.
                    "open_ai_key_uuid": "str",  # Optional. Optional OpenAI key uuid for use with
                      OpenAI models.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      agent will belong to.
                    "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default value is
                      "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The retrieval method is
                      unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval method is rewrite   *
                      RETRIEVAL_METHOD_STEP_BACK: The retrieval method is step back   *
                      RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub queries   *
                      RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values are:
                      "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                      "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                      "RETRIEVAL_METHOD_NONE".
                    "tags": [
                        "str"  # Optional. A set of abitrary tags to organize your agent.
                    ],
                    "temperature": 0.0,  # Optional. Controls the model"u2019s creativity,
                      specified as a number between 0 and 1. Lower values produce more predictable and
                      conservative responses, while higher values encourage creativity and variation.
                    "top_p": 0.0,  # Optional. Defines the cumulative probability threshold for
                      word selection, specified as a number between 0 and 1. Higher values allow for
                      more diverse outputs, while lower values ensure focused and coherent responses.
                    "uuid": "str"  # Optional. Unique agent id.
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_agent_request(
            uuid=uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_agent(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete an Agent.

        To delete an agent, send a DELETE request to ``/v2/gen-ai/agents/{uuid}``.

        :param uuid: Unique agent id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_agent_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_agent_children(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """View Agent Routes.

        To view agent routes for an agent, send a GET requtest to
        ``/v2/gen-ai/agents/{uuid}/child_agents``.

        :param uuid: Agent id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "children": [
                        {
                            "anthropic_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "api_key_infos": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date.
                                    "created_by": "str",  # Optional. Created by.
                                    "deleted_at": "2020-02-20 00:00:00",  #
                                      Optional. Deleted date.
                                    "name": "str",  # Optional. Name.
                                    "secret_key": "str",  # Optional. Api key
                                      infos.
                                    "uuid": "str"  # Optional. Uuid.
                                }
                            ],
                            "api_keys": [
                                {
                                    "api_key": "str"  # Optional. Api key.
                                }
                            ],
                            "chatbot": {
                                "button_background_color": "str",  # Optional. A
                                  Chatbot.
                                "logo": "str",  # Optional. A Chatbot.
                                "name": "str",  # Optional. Name of chatbot.
                                "primary_color": "str",  # Optional. A Chatbot.
                                "secondary_color": "str",  # Optional. A Chatbot.
                                "starting_message": "str"  # Optional. A Chatbot.
                            },
                            "chatbot_identifiers": [
                                {
                                    "agent_chatbot_identifier": "str"  #
                                      Optional. Agent chatbot identifier.
                                }
                            ],
                            "child_agents": [
                                ...
                            ],
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "deployment": {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "name": "str",  # Optional. Name.
                                "status": "STATUS_UNKNOWN",  # Optional. Default
                                  value is "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                                  "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING",
                                  "STATUS_RUNNING", "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT",
                                  "STATUS_UNDEPLOYING", "STATUS_UNDEPLOYMENT_FAILED", and
                                  "STATUS_DELETED".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Access your deployed agent
                                  here.
                                "uuid": "str",  # Optional. Unique id.
                                "visibility": "VISIBILITY_UNKNOWN"  # Optional.
                                  Default value is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The
                                  status of the deployment is unknown    * VISIBILITY_DISABLED: The
                                  deployment is disabled and will no longer service requests   *
                                  VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state   *
                                  VISIBILITY_PUBLIC: The deployment is public and will service requests
                                  from the public internet   * VISIBILITY_PRIVATE: The deployment is
                                  private and will only service requests from other agents, or through
                                  API keys. Known values are: "VISIBILITY_UNKNOWN",
                                  "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND", "VISIBILITY_PUBLIC",
                                  and "VISIBILITY_PRIVATE".
                            },
                            "description": "str",  # Optional. Description of agent.
                            "functions": [
                                {
                                    "api_key": "str",  # Optional. Api key.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "description": "str",  # Optional. Agent
                                      description.
                                    "faas_name": "str",  # Optional. Child
                                      agents.
                                    "faas_namespace": "str",  # Optional. Child
                                      agents.
                                    "input_schema": {},  # Optional. Any object.
                                    "name": "str",  # Optional. Name.
                                    "output_schema": {},  # Optional. Any object.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "url": "str",  # Optional. Download your
                                      agent here.
                                    "uuid": "str"  # Optional. Unique id.
                                }
                            ],
                            "guardrails": [
                                {
                                    "agent_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "default_response": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "description": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "guardrail_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_attached": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_default": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "metadata": {},  # Optional. Any object.
                                    "name": "str",  # Optional. The guardrails
                                      the agent is attached to.
                                    "priority": 0,  # Optional. The guardrails
                                      the agent is attached to.
                                    "type": "GUARDRAIL_TYPE_UNKNOWN",  #
                                      Optional. Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values
                                      are: "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                      "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                      "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "uuid": "str"  # Optional. The guardrails the
                                      agent is attached to.
                                }
                            ],
                            "if_case": "str",  # Optional. Child agents.
                            "instruction": "str",  # Optional. Agent instruction.
                              Instructions help your agent to perform its job effectively. See `Write
                              Effective Agent Instructions
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                              for best practices.
                            "k": 0,  # Optional. Child agents.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. Knowledge
                                      bases.
                                    "embedding_model_uuid": "str",  # Optional.
                                      Knowledge bases.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. Knowledge
                                      bases.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. Child agents.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Agent name.
                            "openai_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "models": [
                                    {
                                        "agreement": {
                                            "description": "str",  #
                                              Optional. Agreement Description.
                                            "name": "str",  # Optional.
                                              Agreement Description.
                                            "url": "str",  # Optional.
                                              Agreement Description.
                                            "uuid": "str"  # Optional.
                                              Agreement Description.
                                        },
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "inference_name": "str",  # Optional.
                                          Internally used name.
                                        "inference_version": "str",  #
                                          Optional. Internally used version.
                                        "is_foundational": bool,  # Optional.
                                          True if it is a foundational model provided by do.
                                        "metadata": {},  # Optional.
                                          Additional meta data.
                                        "name": "str",  # Optional. Name of
                                          the model.
                                        "parent_uuid": "str",  # Optional.
                                          Unique id of the model, this model is based on.
                                        "provider":
                                          "MODEL_PROVIDER_DIGITALOCEAN",  # Optional. Default value is
                                          "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                                          "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC",
                                          and "MODEL_PROVIDER_OPENAI".
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "upload_complete": bool,  # Optional.
                                          Model has been fully uploaded.
                                        "url": "str",  # Optional. Download
                                          url.
                                        "usecases": [
                                            "str"  # Optional. Usecases
                                              of the model.
                                        ],
                                        "uuid": "str",  # Optional. Unique
                                          id.
                                        "version": {
                                            "major": 0,  # Optional.
                                              Major version number.
                                            "minor": 0,  # Optional.
                                              Minor version number.
                                            "patch": 0  # Optional. Patch
                                              version number.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "parent_agents": [
                                ...
                            ],
                            "project_id": "str",  # Optional. Child agents.
                            "region": "str",  # Optional. Region code.
                            "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional.
                              Default value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN:
                              The retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The
                              retrieval method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval
                              method is step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval
                              method is sub queries   * RETRIEVAL_METHOD_NONE: The retrieval method is
                              none. Known values are: "RETRIEVAL_METHOD_UNKNOWN",
                              "RETRIEVAL_METHOD_REWRITE", "RETRIEVAL_METHOD_STEP_BACK",
                              "RETRIEVAL_METHOD_SUB_QUERIES", and "RETRIEVAL_METHOD_NONE".
                            "route_created_at": "2020-02-20 00:00:00",  # Optional.
                              Creation of route date / time.
                            "route_created_by": "str",  # Optional. Child agents.
                            "route_name": "str",  # Optional. Route name.
                            "route_uuid": "str",  # Optional. Child agents.
                            "tags": [
                                "str"  # Optional. Agent tag to organize related
                                  resources.
                            ],
                            "temperature": 0.0,  # Optional. Child agents.
                            "template": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's creation date.
                                "description": "str",  # Optional. Description of the
                                  agent template.
                                "instruction": "str",  # Optional. Instructions for
                                  the agent template.
                                "k": 0,  # Optional. The 'k' value for the agent
                                  template.
                                "knowledge_bases": [
                                    {
                                        "added_to_agent_at": "2020-02-20
                                          00:00:00",  # Optional. Time when the knowledge base was
                                          added to the agent.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "database_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "embedding_model_uuid": "str",  #
                                          Optional. List of knowledge bases associated with the agent
                                          template.
                                        "is_public": bool,  # Optional.
                                          Whether the knowledge base is public or not.
                                        "last_indexing_job": {
                                            "completed_datasources": 0,
                                              # Optional. Number of datasources indexed completed.
                                            "created_at": "2020-02-20
                                              00:00:00",  # Optional. Creation date / time.
                                            "data_source_uuids": [
                                                "str"  # Optional.
                                                  IndexingJob description.
                                            ],
                                            "finished_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "knowledge_base_uuid": "str",
                                              # Optional. Knowledge base id.
                                            "phase":
                                              "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                                              "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                              "BATCH_JOB_PHASE_CANCELLED".
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "tokens": 0,  # Optional.
                                              Number of tokens.
                                            "total_datasources": 0,  #
                                              Optional. Number of datasources being indexed.
                                            "updated_at": "2020-02-20
                                              00:00:00",  # Optional. Last modified.
                                            "uuid": "str"  # Optional.
                                              Unique id.
                                        },
                                        "name": "str",  # Optional. Name of
                                          knowledge base.
                                        "project_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "region": "str",  # Optional. Region
                                          code.
                                        "tags": [
                                            "str"  # Optional. Tags to
                                              organize related resources.
                                        ],
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "user_id": "str",  # Optional. Id of
                                          user that created the knowledge base.
                                        "uuid": "str"  # Optional. Unique id
                                          for knowledge base.
                                    }
                                ],
                                "max_tokens": 0,  # Optional. The max_tokens setting
                                  for the agent template.
                                "model": {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                },
                                "name": "str",  # Optional. Name of the agent
                                  template.
                                "temperature": 0.0,  # Optional. The temperature
                                  setting for the agent template.
                                "top_p": 0.0,  # Optional. The top_p setting for the
                                  agent template.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's last updated date.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "top_p": 0.0,  # Optional. Child agents.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your agent under this url.
                            "user_id": "str",  # Optional. Id of user that created the
                              agent.
                            "uuid": "str"  # Optional. Unique agent id.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_agent_children_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_agent_deployment_visibility(
        self,
        uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Status.

        Check whether an agent is public or private. To update the agent status, send a PUT request to
        ``/v2/gen-ai/agents/{uuid}/deployment_visibility``.

        :param uuid: Unique id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "uuid": "str",  # Optional. Unique id.
                    "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value is
                      "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the deployment is
                      unknown    * VISIBILITY_DISABLED: The deployment is disabled and will no longer
                      service requests   * VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state
                      * VISIBILITY_PUBLIC: The deployment is public and will service requests from the
                      public internet   * VISIBILITY_PRIVATE: The deployment is private and will only
                      service requests from other agents, or through API keys. Known values are:
                      "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                      "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_agent_deployment_visibility(
        self,
        uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Status.

        Check whether an agent is public or private. To update the agent status, send a PUT request to
        ``/v2/gen-ai/agents/{uuid}/deployment_visibility``.

        :param uuid: Unique id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_agent_deployment_visibility(
        self, uuid: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Agent Status.

        Check whether an agent is public or private. To update the agent status, send a PUT request to
        ``/v2/gen-ai/agents/{uuid}/deployment_visibility``.

        :param uuid: Unique id. Required.
        :type uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "uuid": "str",  # Optional. Unique id.
                    "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value is
                      "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the deployment is
                      unknown    * VISIBILITY_DISABLED: The deployment is disabled and will no longer
                      service requests   * VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state
                      * VISIBILITY_PUBLIC: The deployment is public and will service requests from the
                      public internet   * VISIBILITY_PRIVATE: The deployment is private and will only
                      service requests from other agents, or through API keys. Known values are:
                      "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                      "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                }

                # response body for status code(s): 200
                response == {
                    "agent": {
                        "anthropic_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "api_key_infos": [
                            {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date.
                                "created_by": "str",  # Optional. Created by.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional.
                                  Deleted date.
                                "name": "str",  # Optional. Name.
                                "secret_key": "str",  # Optional. Api key infos.
                                "uuid": "str"  # Optional. Uuid.
                            }
                        ],
                        "api_keys": [
                            {
                                "api_key": "str"  # Optional. Api key.
                            }
                        ],
                        "chatbot": {
                            "button_background_color": "str",  # Optional. A Chatbot.
                            "logo": "str",  # Optional. A Chatbot.
                            "name": "str",  # Optional. Name of chatbot.
                            "primary_color": "str",  # Optional. A Chatbot.
                            "secondary_color": "str",  # Optional. A Chatbot.
                            "starting_message": "str"  # Optional. A Chatbot.
                        },
                        "chatbot_identifiers": [
                            {
                                "agent_chatbot_identifier": "str"  # Optional. Agent
                                  chatbot identifier.
                            }
                        ],
                        "child_agents": [
                            ...
                        ],
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "deployment": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "name": "str",  # Optional. Name.
                            "status": "STATUS_UNKNOWN",  # Optional. Default value is
                              "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                              "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING", "STATUS_RUNNING",
                              "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT", "STATUS_UNDEPLOYING",
                              "STATUS_UNDEPLOYMENT_FAILED", and "STATUS_DELETED".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your deployed agent here.
                            "uuid": "str",  # Optional. Unique id.
                            "visibility": "VISIBILITY_UNKNOWN"  # Optional. Default value
                              is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The status of the
                              deployment is unknown    * VISIBILITY_DISABLED: The deployment is
                              disabled and will no longer service requests   * VISIBILITY_PLAYGROUND:
                              Deprecated: No longer a valid state   * VISIBILITY_PUBLIC: The deployment
                              is public and will service requests from the public internet   *
                              VISIBILITY_PRIVATE: The deployment is private and will only service
                              requests from other agents, or through API keys. Known values are:
                              "VISIBILITY_UNKNOWN", "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND",
                              "VISIBILITY_PUBLIC", and "VISIBILITY_PRIVATE".
                        },
                        "description": "str",  # Optional. Description of agent.
                        "functions": [
                            {
                                "api_key": "str",  # Optional. Api key.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "description": "str",  # Optional. Agent description.
                                "faas_name": "str",  # Optional. An Agent.
                                "faas_namespace": "str",  # Optional. An Agent.
                                "input_schema": {},  # Optional. Any object.
                                "name": "str",  # Optional. Name.
                                "output_schema": {},  # Optional. Any object.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Download your agent here.
                                "uuid": "str"  # Optional. Unique id.
                            }
                        ],
                        "guardrails": [
                            {
                                "agent_uuid": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "default_response": "str",  # Optional. The
                                  guardrails the agent is attached to.
                                "description": "str",  # Optional. The guardrails the
                                  agent is attached to.
                                "guardrail_uuid": "str",  # Optional. The guardrails
                                  the agent is attached to.
                                "is_attached": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "is_default": bool,  # Optional. The guardrails the
                                  agent is attached to.
                                "metadata": {},  # Optional. Any object.
                                "name": "str",  # Optional. The guardrails the agent
                                  is attached to.
                                "priority": 0,  # Optional. The guardrails the agent
                                  is attached to.
                                "type": "GUARDRAIL_TYPE_UNKNOWN",  # Optional.
                                  Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values are:
                                  "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                  "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                  "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  guardrails the agent is attached to.
                                "uuid": "str"  # Optional. The guardrails the agent
                                  is attached to.
                            }
                        ],
                        "if_case": "str",  # Optional. An Agent.
                        "instruction": "str",  # Optional. Agent instruction. Instructions
                          help your agent to perform its job effectively. See `Write Effective Agent
                          Instructions
                          <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                          for best practices.
                        "k": 0,  # Optional. An Agent.
                        "knowledge_bases": [
                            {
                                "added_to_agent_at": "2020-02-20 00:00:00",  #
                                  Optional. Time when the knowledge base was added to the agent.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "database_id": "str",  # Optional. Knowledge bases.
                                "embedding_model_uuid": "str",  # Optional. Knowledge
                                  bases.
                                "is_public": bool,  # Optional. Whether the knowledge
                                  base is public or not.
                                "last_indexing_job": {
                                    "completed_datasources": 0,  # Optional.
                                      Number of datasources indexed completed.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "data_source_uuids": [
                                        "str"  # Optional. IndexingJob
                                          description.
                                    ],
                                    "finished_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "knowledge_base_uuid": "str",  # Optional.
                                      Knowledge base id.
                                    "phase": "BATCH_JOB_PHASE_UNKNOWN",  #
                                      Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                      values are: "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                      "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                      "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                      "BATCH_JOB_PHASE_CANCELLED".
                                    "started_at": "2020-02-20 00:00:00",  #
                                      Optional. IndexingJob description.
                                    "tokens": 0,  # Optional. Number of tokens.
                                    "total_datasources": 0,  # Optional. Number
                                      of datasources being indexed.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "uuid": "str"  # Optional. Unique id.
                                },
                                "name": "str",  # Optional. Name of knowledge base.
                                "project_id": "str",  # Optional. Knowledge bases.
                                "region": "str",  # Optional. Region code.
                                "tags": [
                                    "str"  # Optional. Tags to organize related
                                      resources.
                                ],
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "user_id": "str",  # Optional. Id of user that
                                  created the knowledge base.
                                "uuid": "str"  # Optional. Unique id for knowledge
                                  base.
                            }
                        ],
                        "max_tokens": 0,  # Optional. An Agent.
                        "model": {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "inference_name": "str",  # Optional. Internally used name.
                            "inference_version": "str",  # Optional. Internally used
                              version.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "metadata": {},  # Optional. Additional meta data.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "provider": "MODEL_PROVIDER_DIGITALOCEAN",  # Optional.
                              Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                              "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC", and
                              "MODEL_PROVIDER_OPENAI".
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "usecases": [
                                "str"  # Optional. Usecases of the model.
                            ],
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        },
                        "name": "str",  # Optional. Agent name.
                        "openai_api_key": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        },
                        "parent_agents": [
                            ...
                        ],
                        "project_id": "str",  # Optional. An Agent.
                        "region": "str",  # Optional. Region code.
                        "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional. Default
                          value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN: The
                          retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The retrieval
                          method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval method is
                          step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval method is sub
                          queries   * RETRIEVAL_METHOD_NONE: The retrieval method is none. Known values
                          are: "RETRIEVAL_METHOD_UNKNOWN", "RETRIEVAL_METHOD_REWRITE",
                          "RETRIEVAL_METHOD_STEP_BACK", "RETRIEVAL_METHOD_SUB_QUERIES", and
                          "RETRIEVAL_METHOD_NONE".
                        "route_created_at": "2020-02-20 00:00:00",  # Optional. Creation of
                          route date / time.
                        "route_created_by": "str",  # Optional. An Agent.
                        "route_name": "str",  # Optional. Route name.
                        "route_uuid": "str",  # Optional. An Agent.
                        "tags": [
                            "str"  # Optional. Agent tag to organize related resources.
                        ],
                        "temperature": 0.0,  # Optional. An Agent.
                        "template": {
                            "created_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's creation date.
                            "description": "str",  # Optional. Description of the agent
                              template.
                            "instruction": "str",  # Optional. Instructions for the agent
                              template.
                            "k": 0,  # Optional. The 'k' value for the agent template.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "embedding_model_uuid": "str",  # Optional.
                                      List of knowledge bases associated with the agent template.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. List of
                                      knowledge bases associated with the agent template.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional. The max_tokens setting for the
                              agent template.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Name of the agent template.
                            "temperature": 0.0,  # Optional. The temperature setting for
                              the agent template.
                            "top_p": 0.0,  # Optional. The top_p setting for the agent
                              template.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. The agent
                              template's last updated date.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "top_p": 0.0,  # Optional. An Agent.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "url": "str",  # Optional. Access your agent under this url.
                        "user_id": "str",  # Optional. Id of user that created the agent.
                        "uuid": "str"  # Optional. Unique agent id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_agent_deployment_visibility_request(
            uuid=uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_anthropic_api_keys(
        self,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Anthropic API Keys.

        To list all Anthropic API keys, send a GET request to ``/v2/gen-ai/anthropic/keys``.

        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_infos": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_anthropic_api_keys_request(
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_anthropic_api_key(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Anthropic API Key.

        To create an Anthropic API key, send a POST request to ``/v2/gen-ai/anthropic/keys``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. Anthropic API key.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_anthropic_api_key(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Anthropic API Key.

        To create an Anthropic API key, send a POST request to ``/v2/gen-ai/anthropic/keys``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_anthropic_api_key(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create Anthropic API Key.

        To create an Anthropic API key, send a POST request to ``/v2/gen-ai/anthropic/keys``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. Anthropic API key.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_anthropic_api_key_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_anthropic_api_key(self, api_key_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get Anthropic API Key.

        To retrieve details of an Anthropic API key, send a GET request to
        ``/v2/gen-ai/anthropic/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_anthropic_api_key_request(
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_anthropic_api_key(
        self,
        api_key_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Anthropic API Key.

        To update an Anthropic API key, send a PUT request to
        ``/v2/gen-ai/anthropic/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. Anthropic API key.
                    "api_key_uuid": "str",  # Optional. API key ID.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_anthropic_api_key(
        self,
        api_key_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Anthropic API Key.

        To update an Anthropic API key, send a PUT request to
        ``/v2/gen-ai/anthropic/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_anthropic_api_key(
        self,
        api_key_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update Anthropic API Key.

        To update an Anthropic API key, send a PUT request to
        ``/v2/gen-ai/anthropic/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. Anthropic API key.
                    "api_key_uuid": "str",  # Optional. API key ID.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_anthropic_api_key_request(
            api_key_uuid=api_key_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_anthropic_api_key(self, api_key_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete Anthropic API Key.

        To delete an Anthropic API key, send a DELETE request to
        ``/v2/gen-ai/anthropic/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_anthropic_api_key_request(
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_agents_by_anthropic_key(
        self,
        uuid: str,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List agents by Anthropic key.

        List Agents by Anthropic Key.

        :param uuid: Unique ID of Anthropic key. Required.
        :type uuid: str
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agents": [
                        {
                            "anthropic_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "api_key_infos": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date.
                                    "created_by": "str",  # Optional. Created by.
                                    "deleted_at": "2020-02-20 00:00:00",  #
                                      Optional. Deleted date.
                                    "name": "str",  # Optional. Name.
                                    "secret_key": "str",  # Optional. Api key
                                      infos.
                                    "uuid": "str"  # Optional. Uuid.
                                }
                            ],
                            "api_keys": [
                                {
                                    "api_key": "str"  # Optional. Api key.
                                }
                            ],
                            "chatbot": {
                                "button_background_color": "str",  # Optional. A
                                  Chatbot.
                                "logo": "str",  # Optional. A Chatbot.
                                "name": "str",  # Optional. Name of chatbot.
                                "primary_color": "str",  # Optional. A Chatbot.
                                "secondary_color": "str",  # Optional. A Chatbot.
                                "starting_message": "str"  # Optional. A Chatbot.
                            },
                            "chatbot_identifiers": [
                                {
                                    "agent_chatbot_identifier": "str"  #
                                      Optional. Agent chatbot identifier.
                                }
                            ],
                            "child_agents": [
                                ...
                            ],
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "deployment": {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "name": "str",  # Optional. Name.
                                "status": "STATUS_UNKNOWN",  # Optional. Default
                                  value is "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                                  "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING",
                                  "STATUS_RUNNING", "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT",
                                  "STATUS_UNDEPLOYING", "STATUS_UNDEPLOYMENT_FAILED", and
                                  "STATUS_DELETED".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Access your deployed agent
                                  here.
                                "uuid": "str",  # Optional. Unique id.
                                "visibility": "VISIBILITY_UNKNOWN"  # Optional.
                                  Default value is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The
                                  status of the deployment is unknown    * VISIBILITY_DISABLED: The
                                  deployment is disabled and will no longer service requests   *
                                  VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state   *
                                  VISIBILITY_PUBLIC: The deployment is public and will service requests
                                  from the public internet   * VISIBILITY_PRIVATE: The deployment is
                                  private and will only service requests from other agents, or through
                                  API keys. Known values are: "VISIBILITY_UNKNOWN",
                                  "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND", "VISIBILITY_PUBLIC",
                                  and "VISIBILITY_PRIVATE".
                            },
                            "description": "str",  # Optional. Description of agent.
                            "functions": [
                                {
                                    "api_key": "str",  # Optional. Api key.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "description": "str",  # Optional. Agent
                                      description.
                                    "faas_name": "str",  # Optional.
                                    "faas_namespace": "str",  # Optional.
                                    "input_schema": {},  # Optional. Any object.
                                    "name": "str",  # Optional. Name.
                                    "output_schema": {},  # Optional. Any object.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "url": "str",  # Optional. Download your
                                      agent here.
                                    "uuid": "str"  # Optional. Unique id.
                                }
                            ],
                            "guardrails": [
                                {
                                    "agent_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "default_response": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "description": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "guardrail_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_attached": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_default": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "metadata": {},  # Optional. Any object.
                                    "name": "str",  # Optional. The guardrails
                                      the agent is attached to.
                                    "priority": 0,  # Optional. The guardrails
                                      the agent is attached to.
                                    "type": "GUARDRAIL_TYPE_UNKNOWN",  #
                                      Optional. Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values
                                      are: "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                      "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                      "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "uuid": "str"  # Optional. The guardrails the
                                      agent is attached to.
                                }
                            ],
                            "if_case": "str",  # Optional.
                            "instruction": "str",  # Optional. Agent instruction.
                              Instructions help your agent to perform its job effectively. See `Write
                              Effective Agent Instructions
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                              for best practices.
                            "k": 0,  # Optional.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. Knowledge
                                      bases.
                                    "embedding_model_uuid": "str",  # Optional.
                                      Knowledge bases.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. Knowledge
                                      bases.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Agent name.
                            "openai_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "models": [
                                    {
                                        "agreement": {
                                            "description": "str",  #
                                              Optional. Agreement Description.
                                            "name": "str",  # Optional.
                                              Agreement Description.
                                            "url": "str",  # Optional.
                                              Agreement Description.
                                            "uuid": "str"  # Optional.
                                              Agreement Description.
                                        },
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "inference_name": "str",  # Optional.
                                          Internally used name.
                                        "inference_version": "str",  #
                                          Optional. Internally used version.
                                        "is_foundational": bool,  # Optional.
                                          True if it is a foundational model provided by do.
                                        "metadata": {},  # Optional.
                                          Additional meta data.
                                        "name": "str",  # Optional. Name of
                                          the model.
                                        "parent_uuid": "str",  # Optional.
                                          Unique id of the model, this model is based on.
                                        "provider":
                                          "MODEL_PROVIDER_DIGITALOCEAN",  # Optional. Default value is
                                          "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                                          "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC",
                                          and "MODEL_PROVIDER_OPENAI".
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "upload_complete": bool,  # Optional.
                                          Model has been fully uploaded.
                                        "url": "str",  # Optional. Download
                                          url.
                                        "usecases": [
                                            "str"  # Optional. Usecases
                                              of the model.
                                        ],
                                        "uuid": "str",  # Optional. Unique
                                          id.
                                        "version": {
                                            "major": 0,  # Optional.
                                              Major version number.
                                            "minor": 0,  # Optional.
                                              Minor version number.
                                            "patch": 0  # Optional. Patch
                                              version number.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "parent_agents": [
                                ...
                            ],
                            "project_id": "str",  # Optional.
                            "region": "str",  # Optional. Region code.
                            "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional.
                              Default value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN:
                              The retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The
                              retrieval method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval
                              method is step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval
                              method is sub queries   * RETRIEVAL_METHOD_NONE: The retrieval method is
                              none. Known values are: "RETRIEVAL_METHOD_UNKNOWN",
                              "RETRIEVAL_METHOD_REWRITE", "RETRIEVAL_METHOD_STEP_BACK",
                              "RETRIEVAL_METHOD_SUB_QUERIES", and "RETRIEVAL_METHOD_NONE".
                            "route_created_at": "2020-02-20 00:00:00",  # Optional.
                              Creation of route date / time.
                            "route_created_by": "str",  # Optional.
                            "route_name": "str",  # Optional. Route name.
                            "route_uuid": "str",  # Optional.
                            "tags": [
                                "str"  # Optional. Agent tag to organize related
                                  resources.
                            ],
                            "temperature": 0.0,  # Optional.
                            "template": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's creation date.
                                "description": "str",  # Optional. Description of the
                                  agent template.
                                "instruction": "str",  # Optional. Instructions for
                                  the agent template.
                                "k": 0,  # Optional. The 'k' value for the agent
                                  template.
                                "knowledge_bases": [
                                    {
                                        "added_to_agent_at": "2020-02-20
                                          00:00:00",  # Optional. Time when the knowledge base was
                                          added to the agent.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "database_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "embedding_model_uuid": "str",  #
                                          Optional. List of knowledge bases associated with the agent
                                          template.
                                        "is_public": bool,  # Optional.
                                          Whether the knowledge base is public or not.
                                        "last_indexing_job": {
                                            "completed_datasources": 0,
                                              # Optional. Number of datasources indexed completed.
                                            "created_at": "2020-02-20
                                              00:00:00",  # Optional. Creation date / time.
                                            "data_source_uuids": [
                                                "str"  # Optional.
                                                  IndexingJob description.
                                            ],
                                            "finished_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "knowledge_base_uuid": "str",
                                              # Optional. Knowledge base id.
                                            "phase":
                                              "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                                              "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                              "BATCH_JOB_PHASE_CANCELLED".
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "tokens": 0,  # Optional.
                                              Number of tokens.
                                            "total_datasources": 0,  #
                                              Optional. Number of datasources being indexed.
                                            "updated_at": "2020-02-20
                                              00:00:00",  # Optional. Last modified.
                                            "uuid": "str"  # Optional.
                                              Unique id.
                                        },
                                        "name": "str",  # Optional. Name of
                                          knowledge base.
                                        "project_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "region": "str",  # Optional. Region
                                          code.
                                        "tags": [
                                            "str"  # Optional. Tags to
                                              organize related resources.
                                        ],
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "user_id": "str",  # Optional. Id of
                                          user that created the knowledge base.
                                        "uuid": "str"  # Optional. Unique id
                                          for knowledge base.
                                    }
                                ],
                                "max_tokens": 0,  # Optional. The max_tokens setting
                                  for the agent template.
                                "model": {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                },
                                "name": "str",  # Optional. Name of the agent
                                  template.
                                "temperature": 0.0,  # Optional. The temperature
                                  setting for the agent template.
                                "top_p": 0.0,  # Optional. The top_p setting for the
                                  agent template.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's last updated date.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "top_p": 0.0,  # Optional.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your agent under this url.
                            "user_id": "str",  # Optional. Id of user that created the
                              agent.
                            "uuid": "str"  # Optional. Unique agent id.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_agents_by_anthropic_key_request(
            uuid=uuid,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_indexing_jobs(
        self,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Indexing Jobs for a Knowledge Base.

        To list all indexing jobs for a knowledge base, send a GET request to
        ``/v2/gen-ai/indexing_jobs``.

        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "jobs": [
                        {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. The indexing jobs.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional. The
                              indexing jobs.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. The
                              indexing jobs.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_indexing_jobs_request(
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_indexing_job(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start Indexing Job for a Knowledge Base.

        To start an indexing job for a knowledge base, send a POST request to
        ``/v2/gen-ai/indexing_jobs``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "data_source_uuids": [
                        "str"  # Optional. List of data source ids to index, if none are
                          provided, all data sources will be indexed.
                    ],
                    "knowledge_base_uuid": "str"  # Optional. Knowledge base id.
                }

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_indexing_job(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start Indexing Job for a Knowledge Base.

        To start an indexing job for a knowledge base, send a POST request to
        ``/v2/gen-ai/indexing_jobs``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_indexing_job(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Start Indexing Job for a Knowledge Base.

        To start an indexing job for a knowledge base, send a POST request to
        ``/v2/gen-ai/indexing_jobs``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "data_source_uuids": [
                        "str"  # Optional. List of data source ids to index, if none are
                          provided, all data sources will be indexed.
                    ],
                    "knowledge_base_uuid": "str"  # Optional. Knowledge base id.
                }

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_indexing_job_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_indexing_job_data_sources(
        self, indexing_job_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Data Sources for Indexing Job for a Knowledge Base.

        To list all datasources for an indexing job, send a GET request to
        ``/v2/gen-ai/indexing_jobs/{indexing_job_uuid}/data_sources``.

        :param indexing_job_uuid: Uuid of the indexing job. Required.
        :type indexing_job_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "indexed_data_sources": [
                        {
                            "completed_at": "2020-02-20 00:00:00",  # Optional. Timestamp
                              when data source completed indexing.
                            "data_source_uuid": "str",  # Optional. Uuid of the indexed
                              data source.
                            "failed_item_count": "str",  # Optional. Total count of files
                              that have failed.
                            "indexed_file_count": "str",  # Optional. Total count of
                              files that have been indexed.
                            "indexed_item_count": "str",  # Optional. Total count of
                              files that have been indexed.
                            "removed_item_count": "str",  # Optional. Total count of
                              files that have been removed.
                            "skipped_item_count": "str",  # Optional. Total count of
                              files that have been skipped.
                            "started_at": "2020-02-20 00:00:00",  # Optional. Timestamp
                              when data source started indexing.
                            "status": "DATA_SOURCE_STATUS_UNKNOWN",  # Optional. Default
                              value is "DATA_SOURCE_STATUS_UNKNOWN". Known values are:
                              "DATA_SOURCE_STATUS_UNKNOWN", "DATA_SOURCE_STATUS_IN_PROGRESS",
                              "DATA_SOURCE_STATUS_UPDATED", "DATA_SOURCE_STATUS_PARTIALLY_UPDATED",
                              "DATA_SOURCE_STATUS_NOT_UPDATED", and "DATA_SOURCE_STATUS_FAILED".
                            "total_bytes": "str",  # Optional. Total size of files in
                              data source in bytes.
                            "total_bytes_indexed": "str",  # Optional. Total size of
                              files in data source in bytes that have been indexed.
                            "total_file_count": "str"  # Optional. Total file count in
                              the data source.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_indexing_job_data_sources_request(
            indexing_job_uuid=indexing_job_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_indexing_job(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Status of Indexing Job for a Knowledge Base.

        To get status of an indexing Job for a knowledge base, send a GET request to
        ``/v2/gen-ai/indexing_jobs/{uuid}``.

        :param uuid: Indexing job id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_indexing_job_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def cancel_indexing_job(
        self,
        uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Cancel Indexing Job for a Knowledge Base.

        To cancel an indexing job for a knowledge base, send a PUT request to
        ``/v2/gen-ai/indexing_jobs/{uuid}/cancel``.

        :param uuid: A unique identifier for an indexing job. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "uuid": "str"  # Optional. A unique identifier for an indexing job.
                }

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def cancel_indexing_job(
        self,
        uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Cancel Indexing Job for a Knowledge Base.

        To cancel an indexing job for a knowledge base, send a PUT request to
        ``/v2/gen-ai/indexing_jobs/{uuid}/cancel``.

        :param uuid: A unique identifier for an indexing job. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def cancel_indexing_job(
        self, uuid: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Cancel Indexing Job for a Knowledge Base.

        To cancel an indexing job for a knowledge base, send a PUT request to
        ``/v2/gen-ai/indexing_jobs/{uuid}/cancel``.

        :param uuid: A unique identifier for an indexing job. Required.
        :type uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "uuid": "str"  # Optional. A unique identifier for an indexing job.
                }

                # response body for status code(s): 200
                response == {
                    "job": {
                        "completed_datasources": 0,  # Optional. Number of datasources
                          indexed completed.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "data_source_uuids": [
                            "str"  # Optional. IndexingJob description.
                        ],
                        "finished_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                        "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                          "BATCH_JOB_PHASE_UNKNOWN". Known values are: "BATCH_JOB_PHASE_UNKNOWN",
                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                        "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                          description.
                        "tokens": 0,  # Optional. Number of tokens.
                        "total_datasources": 0,  # Optional. Number of datasources being
                          indexed.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str"  # Optional. Unique id.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_cancel_indexing_job_request(
            uuid=uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_knowledge_bases(
        self,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Knowledge Bases.

        To attach a knowledge base to an agent, send a POST request to
        ``/v2/gen-ai/agents/{agent_uuid}/knowledge_bases/{knowledge_base_uuid}``.

        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "knowledge_bases": [
                        {
                            "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time
                              when the knowledge base was added to the agent.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "database_id": "str",  # Optional. The knowledge bases.
                            "embedding_model_uuid": "str",  # Optional. The knowledge
                              bases.
                            "is_public": bool,  # Optional. Whether the knowledge base is
                              public or not.
                            "last_indexing_job": {
                                "completed_datasources": 0,  # Optional. Number of
                                  datasources indexed completed.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "data_source_uuids": [
                                    "str"  # Optional. IndexingJob description.
                                ],
                                "finished_at": "2020-02-20 00:00:00",  # Optional.
                                  IndexingJob description.
                                "knowledge_base_uuid": "str",  # Optional. Knowledge
                                  base id.
                                "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional.
                                  Default value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                  "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                  "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                  "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                  "BATCH_JOB_PHASE_CANCELLED".
                                "started_at": "2020-02-20 00:00:00",  # Optional.
                                  IndexingJob description.
                                "tokens": 0,  # Optional. Number of tokens.
                                "total_datasources": 0,  # Optional. Number of
                                  datasources being indexed.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "name": "str",  # Optional. Name of knowledge base.
                            "project_id": "str",  # Optional. The knowledge bases.
                            "region": "str",  # Optional. Region code.
                            "tags": [
                                "str"  # Optional. Tags to organize related
                                  resources.
                            ],
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "user_id": "str",  # Optional. Id of user that created the
                              knowledge base.
                            "uuid": "str"  # Optional. Unique id for knowledge base.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_knowledge_bases_request(
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_knowledge_base(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Knowledge Base.

        To create a knowledge base, send a POST request to ``/v2/gen-ai/knowledge_bases``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "database_id": "str",  # Optional. Identifier of the DigitalOcean OpenSearch
                      database this knowledge base will use, optional. If not provided, we create a new
                      database for the knowledge base in the same region as the knowledge base.
                    "datasources": [
                        {
                            "bucket_name": "str",  # Optional. Deprecated, moved to
                              data_source_details.
                            "bucket_region": "str",  # Optional. Deprecated, moved to
                              data_source_details.
                            "file_upload_data_source": {
                                "original_file_name": "str",  # Optional. The
                                  original file name.
                                "size_in_bytes": "str",  # Optional. The size of the
                                  file in bytes.
                                "stored_object_key": "str"  # Optional. The object
                                  key the file was stored as.
                            },
                            "item_path": "str",  # Optional. The data sources to use for
                              this knowledge base. See `Organize Data Sources
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#spaces-buckets>`_
                              for more information on data sources best practices.
                            "spaces_data_source": {
                                "bucket_name": "str",  # Optional. Spaces bucket
                                  name.
                                "item_path": "str",  # Optional. Spaces Bucket Data
                                  Source.
                                "region": "str"  # Optional. Region of bucket.
                            },
                            "web_crawler_data_source": {
                                "base_url": "str",  # Optional. The base url to
                                  crawl.
                                "crawling_option": "UNKNOWN",  # Optional. Default
                                  value is "UNKNOWN". Options for specifying how URLs found on pages
                                  should be handled.   * UNKNOWN: Default unknown value * SCOPED: Only
                                  include the base URL. * PATH: Crawl the base URL and linked pages
                                  within the URL path. * DOMAIN: Crawl the base URL and linked pages
                                  within the same domain. * SUBDOMAINS: Crawl the base URL and linked
                                  pages for any subdomain. Known values are: "UNKNOWN", "SCOPED",
                                  "PATH", "DOMAIN", and "SUBDOMAINS".
                                "embed_media": bool  # Optional. Whether to ingest
                                  and index media (images, etc.) on web pages.
                            }
                        }
                    ],
                    "embedding_model_uuid": "str",  # Optional. Identifier for the `embedding
                      model
                      <https://docs.digitalocean.com/products/genai-platform/details/models/#embedding-models>`_.
                    "name": "str",  # Optional. Name of the knowledge base.
                    "project_id": "str",  # Optional. Identifier of the DigitalOcean project this
                      knowledge base will belong to.
                    "region": "str",  # Optional. The datacenter region to deploy the knowledge
                      base in.
                    "tags": [
                        "str"  # Optional. Tags to organize your knowledge base.
                    ],
                    "vpc_uuid": "str"  # Optional. The VPC to deploy the knowledge base database
                      in.
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_knowledge_base(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Knowledge Base.

        To create a knowledge base, send a POST request to ``/v2/gen-ai/knowledge_bases``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_knowledge_base(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create a Knowledge Base.

        To create a knowledge base, send a POST request to ``/v2/gen-ai/knowledge_bases``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "database_id": "str",  # Optional. Identifier of the DigitalOcean OpenSearch
                      database this knowledge base will use, optional. If not provided, we create a new
                      database for the knowledge base in the same region as the knowledge base.
                    "datasources": [
                        {
                            "bucket_name": "str",  # Optional. Deprecated, moved to
                              data_source_details.
                            "bucket_region": "str",  # Optional. Deprecated, moved to
                              data_source_details.
                            "file_upload_data_source": {
                                "original_file_name": "str",  # Optional. The
                                  original file name.
                                "size_in_bytes": "str",  # Optional. The size of the
                                  file in bytes.
                                "stored_object_key": "str"  # Optional. The object
                                  key the file was stored as.
                            },
                            "item_path": "str",  # Optional. The data sources to use for
                              this knowledge base. See `Organize Data Sources
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#spaces-buckets>`_
                              for more information on data sources best practices.
                            "spaces_data_source": {
                                "bucket_name": "str",  # Optional. Spaces bucket
                                  name.
                                "item_path": "str",  # Optional. Spaces Bucket Data
                                  Source.
                                "region": "str"  # Optional. Region of bucket.
                            },
                            "web_crawler_data_source": {
                                "base_url": "str",  # Optional. The base url to
                                  crawl.
                                "crawling_option": "UNKNOWN",  # Optional. Default
                                  value is "UNKNOWN". Options for specifying how URLs found on pages
                                  should be handled.   * UNKNOWN: Default unknown value * SCOPED: Only
                                  include the base URL. * PATH: Crawl the base URL and linked pages
                                  within the URL path. * DOMAIN: Crawl the base URL and linked pages
                                  within the same domain. * SUBDOMAINS: Crawl the base URL and linked
                                  pages for any subdomain. Known values are: "UNKNOWN", "SCOPED",
                                  "PATH", "DOMAIN", and "SUBDOMAINS".
                                "embed_media": bool  # Optional. Whether to ingest
                                  and index media (images, etc.) on web pages.
                            }
                        }
                    ],
                    "embedding_model_uuid": "str",  # Optional. Identifier for the `embedding
                      model
                      <https://docs.digitalocean.com/products/genai-platform/details/models/#embedding-models>`_.
                    "name": "str",  # Optional. Name of the knowledge base.
                    "project_id": "str",  # Optional. Identifier of the DigitalOcean project this
                      knowledge base will belong to.
                    "region": "str",  # Optional. The datacenter region to deploy the knowledge
                      base in.
                    "tags": [
                        "str"  # Optional. Tags to organize your knowledge base.
                    ],
                    "vpc_uuid": "str"  # Optional. The VPC to deploy the knowledge base database
                      in.
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_knowledge_base_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_knowledge_base_data_sources(
        self,
        knowledge_base_uuid: str,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Data Sources for a Knowledge Base.

        To list all data sources for a knowledge base, send a GET request to
        ``/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources``.

        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "knowledge_base_data_sources": [
                        {
                            "bucket_name": "str",  # Optional. Name of storage bucket -
                              Deprecated, moved to data_source_details.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "file_upload_data_source": {
                                "original_file_name": "str",  # Optional. The
                                  original file name.
                                "size_in_bytes": "str",  # Optional. The size of the
                                  file in bytes.
                                "stored_object_key": "str"  # Optional. The object
                                  key the file was stored as.
                            },
                            "item_path": "str",  # Optional. Path of folder or object in
                              bucket - Deprecated, moved to data_source_details.
                            "last_indexing_job": {
                                "completed_datasources": 0,  # Optional. Number of
                                  datasources indexed completed.
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "data_source_uuids": [
                                    "str"  # Optional. IndexingJob description.
                                ],
                                "finished_at": "2020-02-20 00:00:00",  # Optional.
                                  IndexingJob description.
                                "knowledge_base_uuid": "str",  # Optional. Knowledge
                                  base id.
                                "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional.
                                  Default value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                  "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                  "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                  "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                  "BATCH_JOB_PHASE_CANCELLED".
                                "started_at": "2020-02-20 00:00:00",  # Optional.
                                  IndexingJob description.
                                "tokens": 0,  # Optional. Number of tokens.
                                "total_datasources": 0,  # Optional. Number of
                                  datasources being indexed.
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "region": "str",  # Optional. Region code - Deprecated, moved
                              to data_source_details.
                            "spaces_data_source": {
                                "bucket_name": "str",  # Optional. Spaces bucket
                                  name.
                                "item_path": "str",  # Optional. Spaces Bucket Data
                                  Source.
                                "region": "str"  # Optional. Region of bucket.
                            },
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str",  # Optional. Unique id of knowledge base.
                            "web_crawler_data_source": {
                                "base_url": "str",  # Optional. The base url to
                                  crawl.
                                "crawling_option": "UNKNOWN",  # Optional. Default
                                  value is "UNKNOWN". Options for specifying how URLs found on pages
                                  should be handled.   * UNKNOWN: Default unknown value * SCOPED: Only
                                  include the base URL. * PATH: Crawl the base URL and linked pages
                                  within the URL path. * DOMAIN: Crawl the base URL and linked pages
                                  within the same domain. * SUBDOMAINS: Crawl the base URL and linked
                                  pages for any subdomain. Known values are: "UNKNOWN", "SCOPED",
                                  "PATH", "DOMAIN", and "SUBDOMAINS".
                                "embed_media": bool  # Optional. Whether to ingest
                                  and index media (images, etc.) on web pages.
                            }
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_knowledge_base_data_sources_request(
            knowledge_base_uuid=knowledge_base_uuid,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_knowledge_base_data_source(
        self,
        knowledge_base_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Data Source to a Knowledge Base.

        To add a data source to a knowledge base, send a POST request to
        ``/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources``.

        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                    "spaces_data_source": {
                        "bucket_name": "str",  # Optional. Spaces bucket name.
                        "item_path": "str",  # Optional. Spaces Bucket Data Source.
                        "region": "str"  # Optional. Region of bucket.
                    },
                    "web_crawler_data_source": {
                        "base_url": "str",  # Optional. The base url to crawl.
                        "crawling_option": "UNKNOWN",  # Optional. Default value is
                          "UNKNOWN". Options for specifying how URLs found on pages should be handled.
                          * UNKNOWN: Default unknown value * SCOPED: Only include the base URL. * PATH:
                          Crawl the base URL and linked pages within the URL path. * DOMAIN: Crawl the
                          base URL and linked pages within the same domain. * SUBDOMAINS: Crawl the
                          base URL and linked pages for any subdomain. Known values are: "UNKNOWN",
                          "SCOPED", "PATH", "DOMAIN", and "SUBDOMAINS".
                        "embed_media": bool  # Optional. Whether to ingest and index media
                          (images, etc.) on web pages.
                    }
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base_data_source": {
                        "bucket_name": "str",  # Optional. Name of storage bucket -
                          Deprecated, moved to data_source_details.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "file_upload_data_source": {
                            "original_file_name": "str",  # Optional. The original file
                              name.
                            "size_in_bytes": "str",  # Optional. The size of the file in
                              bytes.
                            "stored_object_key": "str"  # Optional. The object key the
                              file was stored as.
                        },
                        "item_path": "str",  # Optional. Path of folder or object in bucket -
                          Deprecated, moved to data_source_details.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "region": "str",  # Optional. Region code - Deprecated, moved to
                          data_source_details.
                        "spaces_data_source": {
                            "bucket_name": "str",  # Optional. Spaces bucket name.
                            "item_path": "str",  # Optional. Spaces Bucket Data Source.
                            "region": "str"  # Optional. Region of bucket.
                        },
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str",  # Optional. Unique id of knowledge base.
                        "web_crawler_data_source": {
                            "base_url": "str",  # Optional. The base url to crawl.
                            "crawling_option": "UNKNOWN",  # Optional. Default value is
                              "UNKNOWN". Options for specifying how URLs found on pages should be
                              handled.   * UNKNOWN: Default unknown value * SCOPED: Only include the
                              base URL. * PATH: Crawl the base URL and linked pages within the URL
                              path. * DOMAIN: Crawl the base URL and linked pages within the same
                              domain. * SUBDOMAINS: Crawl the base URL and linked pages for any
                              subdomain. Known values are: "UNKNOWN", "SCOPED", "PATH", "DOMAIN", and
                              "SUBDOMAINS".
                            "embed_media": bool  # Optional. Whether to ingest and index
                              media (images, etc.) on web pages.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_knowledge_base_data_source(
        self,
        knowledge_base_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Data Source to a Knowledge Base.

        To add a data source to a knowledge base, send a POST request to
        ``/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources``.

        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "knowledge_base_data_source": {
                        "bucket_name": "str",  # Optional. Name of storage bucket -
                          Deprecated, moved to data_source_details.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "file_upload_data_source": {
                            "original_file_name": "str",  # Optional. The original file
                              name.
                            "size_in_bytes": "str",  # Optional. The size of the file in
                              bytes.
                            "stored_object_key": "str"  # Optional. The object key the
                              file was stored as.
                        },
                        "item_path": "str",  # Optional. Path of folder or object in bucket -
                          Deprecated, moved to data_source_details.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "region": "str",  # Optional. Region code - Deprecated, moved to
                          data_source_details.
                        "spaces_data_source": {
                            "bucket_name": "str",  # Optional. Spaces bucket name.
                            "item_path": "str",  # Optional. Spaces Bucket Data Source.
                            "region": "str"  # Optional. Region of bucket.
                        },
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str",  # Optional. Unique id of knowledge base.
                        "web_crawler_data_source": {
                            "base_url": "str",  # Optional. The base url to crawl.
                            "crawling_option": "UNKNOWN",  # Optional. Default value is
                              "UNKNOWN". Options for specifying how URLs found on pages should be
                              handled.   * UNKNOWN: Default unknown value * SCOPED: Only include the
                              base URL. * PATH: Crawl the base URL and linked pages within the URL
                              path. * DOMAIN: Crawl the base URL and linked pages within the same
                              domain. * SUBDOMAINS: Crawl the base URL and linked pages for any
                              subdomain. Known values are: "UNKNOWN", "SCOPED", "PATH", "DOMAIN", and
                              "SUBDOMAINS".
                            "embed_media": bool  # Optional. Whether to ingest and index
                              media (images, etc.) on web pages.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_knowledge_base_data_source(
        self,
        knowledge_base_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Add Data Source to a Knowledge Base.

        To add a data source to a knowledge base, send a POST request to
        ``/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources``.

        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                    "spaces_data_source": {
                        "bucket_name": "str",  # Optional. Spaces bucket name.
                        "item_path": "str",  # Optional. Spaces Bucket Data Source.
                        "region": "str"  # Optional. Region of bucket.
                    },
                    "web_crawler_data_source": {
                        "base_url": "str",  # Optional. The base url to crawl.
                        "crawling_option": "UNKNOWN",  # Optional. Default value is
                          "UNKNOWN". Options for specifying how URLs found on pages should be handled.
                          * UNKNOWN: Default unknown value * SCOPED: Only include the base URL. * PATH:
                          Crawl the base URL and linked pages within the URL path. * DOMAIN: Crawl the
                          base URL and linked pages within the same domain. * SUBDOMAINS: Crawl the
                          base URL and linked pages for any subdomain. Known values are: "UNKNOWN",
                          "SCOPED", "PATH", "DOMAIN", and "SUBDOMAINS".
                        "embed_media": bool  # Optional. Whether to ingest and index media
                          (images, etc.) on web pages.
                    }
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base_data_source": {
                        "bucket_name": "str",  # Optional. Name of storage bucket -
                          Deprecated, moved to data_source_details.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "file_upload_data_source": {
                            "original_file_name": "str",  # Optional. The original file
                              name.
                            "size_in_bytes": "str",  # Optional. The size of the file in
                              bytes.
                            "stored_object_key": "str"  # Optional. The object key the
                              file was stored as.
                        },
                        "item_path": "str",  # Optional. Path of folder or object in bucket -
                          Deprecated, moved to data_source_details.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "region": "str",  # Optional. Region code - Deprecated, moved to
                          data_source_details.
                        "spaces_data_source": {
                            "bucket_name": "str",  # Optional. Spaces bucket name.
                            "item_path": "str",  # Optional. Spaces Bucket Data Source.
                            "region": "str"  # Optional. Region of bucket.
                        },
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "uuid": "str",  # Optional. Unique id of knowledge base.
                        "web_crawler_data_source": {
                            "base_url": "str",  # Optional. The base url to crawl.
                            "crawling_option": "UNKNOWN",  # Optional. Default value is
                              "UNKNOWN". Options for specifying how URLs found on pages should be
                              handled.   * UNKNOWN: Default unknown value * SCOPED: Only include the
                              base URL. * PATH: Crawl the base URL and linked pages within the URL
                              path. * DOMAIN: Crawl the base URL and linked pages within the same
                              domain. * SUBDOMAINS: Crawl the base URL and linked pages for any
                              subdomain. Known values are: "UNKNOWN", "SCOPED", "PATH", "DOMAIN", and
                              "SUBDOMAINS".
                            "embed_media": bool  # Optional. Whether to ingest and index
                              media (images, etc.) on web pages.
                        }
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_knowledge_base_data_source_request(
            knowledge_base_uuid=knowledge_base_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_knowledge_base_data_source(
        self, knowledge_base_uuid: str, data_source_uuid: str, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Delete a Data Source from a Knowledge Base.

        To delete a data source from a knowledge base, send a DELETE request to
        ``/v2/gen-ai/knowledge_bases/{knowledge_base_uuid}/data_sources/{data_source_uuid}``.

        :param knowledge_base_uuid: Knowledge base id. Required.
        :type knowledge_base_uuid: str
        :param data_source_uuid: Data source id. Required.
        :type data_source_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "data_source_uuid": "str",  # Optional. Data source id.
                    "knowledge_base_uuid": "str"  # Optional. Knowledge base id.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_knowledge_base_data_source_request(
            knowledge_base_uuid=knowledge_base_uuid,
            data_source_uuid=data_source_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_knowledge_base(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Retrieve Information About an Existing Knowledge Base.

        To retrive information about an existing knowledge base, send a GET request to
        ``/v2/gen-ai/knowledge_bases/{uuid}``.

        :param uuid: Knowledge base id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "database_status": "CREATING",  # Optional. Default value is "CREATING".
                      Known values are: "CREATING", "ONLINE", "POWEROFF", "REBUILDING", "REBALANCING",
                      "DECOMMISSIONED", "FORKING", "MIGRATING", "RESIZING", "RESTORING", "POWERING_ON",
                      and "UNHEALTHY".
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_knowledge_base_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_knowledge_base(
        self,
        uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Knowledge Base.

        To update a knowledge base, send a PUT request to ``/v2/gen-ai/knowledge_bases/{uuid}``.

        :param uuid: Knowledge base id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "database_id": "str",  # Optional. The id of the DigitalOcean database this
                      knowledge base will use, optiona.
                    "embedding_model_uuid": "str",  # Optional. Identifier for the foundation
                      model.
                    "name": "str",  # Optional. Knowledge base name.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      knowledge base will belong to.
                    "tags": [
                        "str"  # Optional. Tags to organize your knowledge base.
                    ],
                    "uuid": "str"  # Optional. Knowledge base id.
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_knowledge_base(
        self,
        uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Knowledge Base.

        To update a knowledge base, send a PUT request to ``/v2/gen-ai/knowledge_bases/{uuid}``.

        :param uuid: Knowledge base id. Required.
        :type uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_knowledge_base(
        self, uuid: str, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update a Knowledge Base.

        To update a knowledge base, send a PUT request to ``/v2/gen-ai/knowledge_bases/{uuid}``.

        :param uuid: Knowledge base id. Required.
        :type uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "database_id": "str",  # Optional. The id of the DigitalOcean database this
                      knowledge base will use, optiona.
                    "embedding_model_uuid": "str",  # Optional. Identifier for the foundation
                      model.
                    "name": "str",  # Optional. Knowledge base name.
                    "project_id": "str",  # Optional. The id of the DigitalOcean project this
                      knowledge base will belong to.
                    "tags": [
                        "str"  # Optional. Tags to organize your knowledge base.
                    ],
                    "uuid": "str"  # Optional. Knowledge base id.
                }

                # response body for status code(s): 200
                response == {
                    "knowledge_base": {
                        "added_to_agent_at": "2020-02-20 00:00:00",  # Optional. Time when
                          the knowledge base was added to the agent.
                        "created_at": "2020-02-20 00:00:00",  # Optional. Creation date /
                          time.
                        "database_id": "str",  # Optional. Knowledgebase Description.
                        "embedding_model_uuid": "str",  # Optional. Knowledgebase
                          Description.
                        "is_public": bool,  # Optional. Whether the knowledge base is public
                          or not.
                        "last_indexing_job": {
                            "completed_datasources": 0,  # Optional. Number of
                              datasources indexed completed.
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "data_source_uuids": [
                                "str"  # Optional. IndexingJob description.
                            ],
                            "finished_at": "2020-02-20 00:00:00",  # Optional.
                              IndexingJob description.
                            "knowledge_base_uuid": "str",  # Optional. Knowledge base id.
                            "phase": "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default
                              value is "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                              "BATCH_JOB_PHASE_CANCELLED".
                            "started_at": "2020-02-20 00:00:00",  # Optional. IndexingJob
                              description.
                            "tokens": 0,  # Optional. Number of tokens.
                            "total_datasources": 0,  # Optional. Number of datasources
                              being indexed.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "uuid": "str"  # Optional. Unique id.
                        },
                        "name": "str",  # Optional. Name of knowledge base.
                        "project_id": "str",  # Optional. Knowledgebase Description.
                        "region": "str",  # Optional. Region code.
                        "tags": [
                            "str"  # Optional. Tags to organize related resources.
                        ],
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Last modified.
                        "user_id": "str",  # Optional. Id of user that created the knowledge
                          base.
                        "uuid": "str"  # Optional. Unique id for knowledge base.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_knowledge_base_request(
            uuid=uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_knowledge_base(self, uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete a Knowledge Base.

        To delete a knowledge base, send a DELETE request to ``/v2/gen-ai/knowledge_bases/{uuid}``.

        :param uuid: Knowledge base id. Required.
        :type uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "uuid": "str"  # Optional. The id of the deleted knowledge base.
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_knowledge_base_request(
            uuid=uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_models(
        self,
        *,
        usecases: Optional[List[str]] = None,
        public_only: Optional[bool] = None,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Available Models.

        To list all models, send a GET request to ``/v2/gen-ai/models``.

        :keyword usecases: Include only models defined for the listed usecases.


         * MODEL_USECASE_UNKNOWN: The use case of the model is unknown
         * MODEL_USECASE_AGENT: The model maybe used in an agent
         * MODEL_USECASE_FINETUNED: The model maybe used for fine tuning
         * MODEL_USECASE_KNOWLEDGEBASE: The model maybe used for knowledge bases (embedding models)
         * MODEL_USECASE_GUARDRAIL: The model maybe used for guardrails
         * MODEL_USECASE_REASONING: The model usecase for reasoning. Default value is None.
        :paramtype usecases: list[str]
        :keyword public_only: Only include models that are publicly available. Default value is None.
        :paramtype public_only: bool
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    },
                    "models": [
                        {
                            "agreement": {
                                "description": "str",  # Optional. Agreement
                                  Description.
                                "name": "str",  # Optional. Agreement Description.
                                "url": "str",  # Optional. Agreement Description.
                                "uuid": "str"  # Optional. Agreement Description.
                            },
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "is_foundational": bool,  # Optional. True if it is a
                              foundational model provided by do.
                            "name": "str",  # Optional. Name of the model.
                            "parent_uuid": "str",  # Optional. Unique id of the model,
                              this model is based on.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "upload_complete": bool,  # Optional. Model has been fully
                              uploaded.
                            "url": "str",  # Optional. Download url.
                            "uuid": "str",  # Optional. Unique id.
                            "version": {
                                "major": 0,  # Optional. Major version number.
                                "minor": 0,  # Optional. Minor version number.
                                "patch": 0  # Optional. Patch version number.
                            }
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_models_request(
            usecases=usecases,
            public_only=public_only,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_openai_api_keys(
        self,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List OpenAI API Keys.

        To list all OpenAI API keys, send a GET request to ``/v2/gen-ai/openai/keys``.

        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_infos": [
                        {
                            "created_at": "2020-02-20 00:00:00",  # Optional. Key
                              creation date.
                            "created_by": "str",  # Optional. Created by user id from DO.
                            "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted
                              date.
                            "models": [
                                {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                }
                            ],
                            "name": "str",  # Optional. Name.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Key last
                              updated date.
                            "uuid": "str"  # Optional. Uuid.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_openai_api_keys_request(
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def create_openai_api_key(
        self,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create OpenAI API Key.

        To create an OpenAI API key, send a POST request to ``/v2/gen-ai/openai/keys``.

        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. OpenAI API key.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def create_openai_api_key(
        self,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create OpenAI API Key.

        To create an OpenAI API key, send a POST request to ``/v2/gen-ai/openai/keys``.

        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def create_openai_api_key(
        self, body: Optional[Union[JSON, IO[bytes]]] = None, **kwargs: Any
    ) -> JSON:
        # pylint: disable=line-too-long
        """Create OpenAI API Key.

        To create an OpenAI API key, send a POST request to ``/v2/gen-ai/openai/keys``.

        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. OpenAI API key.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_create_openai_api_key_request(
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def get_openai_api_key(self, api_key_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Get OpenAI API Key.

        To retrieve details of an OpenAI API key, send a GET request to
        ``/v2/gen-ai/openai/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_get_openai_api_key_request(
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @overload
    def update_openai_api_key(
        self,
        api_key_uuid: str,
        body: Optional[JSON] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update OpenAI API Key.

        To update an OpenAI API key, send a PUT request to ``/v2/gen-ai/openai/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: JSON
        :keyword content_type: Body Parameter content-type. Content type parameter for JSON body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. OpenAI API key.
                    "api_key_uuid": "str",  # Optional. API key ID.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @overload
    def update_openai_api_key(
        self,
        api_key_uuid: str,
        body: Optional[IO[bytes]] = None,
        *,
        content_type: str = "application/json",
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update OpenAI API Key.

        To update an OpenAI API key, send a PUT request to ``/v2/gen-ai/openai/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Default value is None.
        :type body: IO[bytes]
        :keyword content_type: Body Parameter content-type. Content type parameter for binary body.
         Default value is "application/json".
        :paramtype content_type: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """

    @distributed_trace
    def update_openai_api_key(
        self,
        api_key_uuid: str,
        body: Optional[Union[JSON, IO[bytes]]] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """Update OpenAI API Key.

        To update an OpenAI API key, send a PUT request to ``/v2/gen-ai/openai/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :param body: Is either a JSON type or a IO[bytes] type. Default value is None.
        :type body: JSON or IO[bytes]
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # JSON input template you can fill out and use as your body input.
                body = {
                    "api_key": "str",  # Optional. OpenAI API key.
                    "api_key_uuid": "str",  # Optional. API key ID.
                    "name": "str"  # Optional. Name of the key.
                }

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = case_insensitive_dict(kwargs.pop("headers", {}) or {})
        _params = kwargs.pop("params", {}) or {}

        content_type: Optional[str] = kwargs.pop(
            "content_type", _headers.pop("Content-Type", None)
        )
        cls: ClsType[JSON] = kwargs.pop("cls", None)

        content_type = content_type or "application/json"
        _json = None
        _content = None
        if isinstance(body, (IOBase, bytes)):
            _content = body
        else:
            if body is not None:
                _json = body
            else:
                _json = None

        _request = build_genai_update_openai_api_key_request(
            api_key_uuid=api_key_uuid,
            content_type=content_type,
            json=_json,
            content=_content,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def delete_openai_api_key(self, api_key_uuid: str, **kwargs: Any) -> JSON:
        # pylint: disable=line-too-long
        """Delete OpenAI API Key.

        To delete an OpenAI API key, send a DELETE request to
        ``/v2/gen-ai/openai/keys/{api_key_uuid}``.

        :param api_key_uuid: API key ID. Required.
        :type api_key_uuid: str
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "api_key_info": {
                        "created_at": "2020-02-20 00:00:00",  # Optional. Key creation date.
                        "created_by": "str",  # Optional. Created by user id from DO.
                        "deleted_at": "2020-02-20 00:00:00",  # Optional. Key deleted date.
                        "models": [
                            {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            }
                        ],
                        "name": "str",  # Optional. Name.
                        "updated_at": "2020-02-20 00:00:00",  # Optional. Key last updated
                          date.
                        "uuid": "str"  # Optional. Uuid.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_delete_openai_api_key_request(
            api_key_uuid=api_key_uuid,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_agents_by_openai_key(
        self,
        uuid: str,
        *,
        page: Optional[int] = None,
        per_page: Optional[int] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List agents by OpenAI key.

        List Agents by OpenAI Key.

        :param uuid: Unique ID of OpenAI key. Required.
        :type uuid: str
        :keyword page: Page number. Default value is None.
        :paramtype page: int
        :keyword per_page: Items per page. Default value is None.
        :paramtype per_page: int
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "agents": [
                        {
                            "anthropic_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "api_key_infos": [
                                {
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date.
                                    "created_by": "str",  # Optional. Created by.
                                    "deleted_at": "2020-02-20 00:00:00",  #
                                      Optional. Deleted date.
                                    "name": "str",  # Optional. Name.
                                    "secret_key": "str",  # Optional. Api key
                                      infos.
                                    "uuid": "str"  # Optional. Uuid.
                                }
                            ],
                            "api_keys": [
                                {
                                    "api_key": "str"  # Optional. Api key.
                                }
                            ],
                            "chatbot": {
                                "button_background_color": "str",  # Optional. A
                                  Chatbot.
                                "logo": "str",  # Optional. A Chatbot.
                                "name": "str",  # Optional. Name of chatbot.
                                "primary_color": "str",  # Optional. A Chatbot.
                                "secondary_color": "str",  # Optional. A Chatbot.
                                "starting_message": "str"  # Optional. A Chatbot.
                            },
                            "chatbot_identifiers": [
                                {
                                    "agent_chatbot_identifier": "str"  #
                                      Optional. Agent chatbot identifier.
                                }
                            ],
                            "child_agents": [
                                ...
                            ],
                            "created_at": "2020-02-20 00:00:00",  # Optional. Creation
                              date / time.
                            "deployment": {
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "name": "str",  # Optional. Name.
                                "status": "STATUS_UNKNOWN",  # Optional. Default
                                  value is "STATUS_UNKNOWN". Known values are: "STATUS_UNKNOWN",
                                  "STATUS_WAITING_FOR_DEPLOYMENT", "STATUS_DEPLOYING",
                                  "STATUS_RUNNING", "STATUS_FAILED", "STATUS_WAITING_FOR_UNDEPLOYMENT",
                                  "STATUS_UNDEPLOYING", "STATUS_UNDEPLOYMENT_FAILED", and
                                  "STATUS_DELETED".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "url": "str",  # Optional. Access your deployed agent
                                  here.
                                "uuid": "str",  # Optional. Unique id.
                                "visibility": "VISIBILITY_UNKNOWN"  # Optional.
                                  Default value is "VISIBILITY_UNKNOWN". * VISIBILITY_UNKNOWN: The
                                  status of the deployment is unknown    * VISIBILITY_DISABLED: The
                                  deployment is disabled and will no longer service requests   *
                                  VISIBILITY_PLAYGROUND: Deprecated: No longer a valid state   *
                                  VISIBILITY_PUBLIC: The deployment is public and will service requests
                                  from the public internet   * VISIBILITY_PRIVATE: The deployment is
                                  private and will only service requests from other agents, or through
                                  API keys. Known values are: "VISIBILITY_UNKNOWN",
                                  "VISIBILITY_DISABLED", "VISIBILITY_PLAYGROUND", "VISIBILITY_PUBLIC",
                                  and "VISIBILITY_PRIVATE".
                            },
                            "description": "str",  # Optional. Description of agent.
                            "functions": [
                                {
                                    "api_key": "str",  # Optional. Api key.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "description": "str",  # Optional. Agent
                                      description.
                                    "faas_name": "str",  # Optional.
                                    "faas_namespace": "str",  # Optional.
                                    "input_schema": {},  # Optional. Any object.
                                    "name": "str",  # Optional. Name.
                                    "output_schema": {},  # Optional. Any object.
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "url": "str",  # Optional. Download your
                                      agent here.
                                    "uuid": "str"  # Optional. Unique id.
                                }
                            ],
                            "guardrails": [
                                {
                                    "agent_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "default_response": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "description": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "guardrail_uuid": "str",  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_attached": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "is_default": bool,  # Optional. The
                                      guardrails the agent is attached to.
                                    "metadata": {},  # Optional. Any object.
                                    "name": "str",  # Optional. The guardrails
                                      the agent is attached to.
                                    "priority": 0,  # Optional. The guardrails
                                      the agent is attached to.
                                    "type": "GUARDRAIL_TYPE_UNKNOWN",  #
                                      Optional. Default value is "GUARDRAIL_TYPE_UNKNOWN". Known values
                                      are: "GUARDRAIL_TYPE_UNKNOWN", "GUARDRAIL_TYPE_JAILBREAK",
                                      "GUARDRAIL_TYPE_SENSITIVE_DATA", and
                                      "GUARDRAIL_TYPE_CONTENT_MODERATION".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. The guardrails the agent is attached to.
                                    "uuid": "str"  # Optional. The guardrails the
                                      agent is attached to.
                                }
                            ],
                            "if_case": "str",  # Optional.
                            "instruction": "str",  # Optional. Agent instruction.
                              Instructions help your agent to perform its job effectively. See `Write
                              Effective Agent Instructions
                              <https://docs.digitalocean.com/products/genai-platform/concepts/best-practices/#agent-instructions>`_
                              for best practices.
                            "k": 0,  # Optional.
                            "knowledge_bases": [
                                {
                                    "added_to_agent_at": "2020-02-20 00:00:00",
                                      # Optional. Time when the knowledge base was added to the agent.
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "database_id": "str",  # Optional. Knowledge
                                      bases.
                                    "embedding_model_uuid": "str",  # Optional.
                                      Knowledge bases.
                                    "is_public": bool,  # Optional. Whether the
                                      knowledge base is public or not.
                                    "last_indexing_job": {
                                        "completed_datasources": 0,  #
                                          Optional. Number of datasources indexed completed.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "data_source_uuids": [
                                            "str"  # Optional.
                                              IndexingJob description.
                                        ],
                                        "finished_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "knowledge_base_uuid": "str",  #
                                          Optional. Knowledge base id.
                                        "phase": "BATCH_JOB_PHASE_UNKNOWN",
                                          # Optional. Default value is "BATCH_JOB_PHASE_UNKNOWN". Known
                                          values are: "BATCH_JOB_PHASE_UNKNOWN",
                                          "BATCH_JOB_PHASE_PENDING", "BATCH_JOB_PHASE_RUNNING",
                                          "BATCH_JOB_PHASE_SUCCEEDED", "BATCH_JOB_PHASE_FAILED",
                                          "BATCH_JOB_PHASE_ERROR", and "BATCH_JOB_PHASE_CANCELLED".
                                        "started_at": "2020-02-20 00:00:00",
                                          # Optional. IndexingJob description.
                                        "tokens": 0,  # Optional. Number of
                                          tokens.
                                        "total_datasources": 0,  # Optional.
                                          Number of datasources being indexed.
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "uuid": "str"  # Optional. Unique id.
                                    },
                                    "name": "str",  # Optional. Name of knowledge
                                      base.
                                    "project_id": "str",  # Optional. Knowledge
                                      bases.
                                    "region": "str",  # Optional. Region code.
                                    "tags": [
                                        "str"  # Optional. Tags to organize
                                          related resources.
                                    ],
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "user_id": "str",  # Optional. Id of user
                                      that created the knowledge base.
                                    "uuid": "str"  # Optional. Unique id for
                                      knowledge base.
                                }
                            ],
                            "max_tokens": 0,  # Optional.
                            "model": {
                                "agreement": {
                                    "description": "str",  # Optional. Agreement
                                      Description.
                                    "name": "str",  # Optional. Agreement
                                      Description.
                                    "url": "str",  # Optional. Agreement
                                      Description.
                                    "uuid": "str"  # Optional. Agreement
                                      Description.
                                },
                                "created_at": "2020-02-20 00:00:00",  # Optional.
                                  Creation date / time.
                                "inference_name": "str",  # Optional. Internally used
                                  name.
                                "inference_version": "str",  # Optional. Internally
                                  used version.
                                "is_foundational": bool,  # Optional. True if it is a
                                  foundational model provided by do.
                                "metadata": {},  # Optional. Additional meta data.
                                "name": "str",  # Optional. Name of the model.
                                "parent_uuid": "str",  # Optional. Unique id of the
                                  model, this model is based on.
                                "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                  Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                  values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                  "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                "updated_at": "2020-02-20 00:00:00",  # Optional.
                                  Last modified.
                                "upload_complete": bool,  # Optional. Model has been
                                  fully uploaded.
                                "url": "str",  # Optional. Download url.
                                "usecases": [
                                    "str"  # Optional. Usecases of the model.
                                ],
                                "uuid": "str",  # Optional. Unique id.
                                "version": {
                                    "major": 0,  # Optional. Major version
                                      number.
                                    "minor": 0,  # Optional. Minor version
                                      number.
                                    "patch": 0  # Optional. Patch version number.
                                }
                            },
                            "name": "str",  # Optional. Agent name.
                            "openai_api_key": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. Key
                                  creation date.
                                "created_by": "str",  # Optional. Created by user id
                                  from DO.
                                "deleted_at": "2020-02-20 00:00:00",  # Optional. Key
                                  deleted date.
                                "models": [
                                    {
                                        "agreement": {
                                            "description": "str",  #
                                              Optional. Agreement Description.
                                            "name": "str",  # Optional.
                                              Agreement Description.
                                            "url": "str",  # Optional.
                                              Agreement Description.
                                            "uuid": "str"  # Optional.
                                              Agreement Description.
                                        },
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "inference_name": "str",  # Optional.
                                          Internally used name.
                                        "inference_version": "str",  #
                                          Optional. Internally used version.
                                        "is_foundational": bool,  # Optional.
                                          True if it is a foundational model provided by do.
                                        "metadata": {},  # Optional.
                                          Additional meta data.
                                        "name": "str",  # Optional. Name of
                                          the model.
                                        "parent_uuid": "str",  # Optional.
                                          Unique id of the model, this model is based on.
                                        "provider":
                                          "MODEL_PROVIDER_DIGITALOCEAN",  # Optional. Default value is
                                          "MODEL_PROVIDER_DIGITALOCEAN". Known values are:
                                          "MODEL_PROVIDER_DIGITALOCEAN", "MODEL_PROVIDER_ANTHROPIC",
                                          and "MODEL_PROVIDER_OPENAI".
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "upload_complete": bool,  # Optional.
                                          Model has been fully uploaded.
                                        "url": "str",  # Optional. Download
                                          url.
                                        "usecases": [
                                            "str"  # Optional. Usecases
                                              of the model.
                                        ],
                                        "uuid": "str",  # Optional. Unique
                                          id.
                                        "version": {
                                            "major": 0,  # Optional.
                                              Major version number.
                                            "minor": 0,  # Optional.
                                              Minor version number.
                                            "patch": 0  # Optional. Patch
                                              version number.
                                        }
                                    }
                                ],
                                "name": "str",  # Optional. Name.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. Key
                                  last updated date.
                                "uuid": "str"  # Optional. Uuid.
                            },
                            "parent_agents": [
                                ...
                            ],
                            "project_id": "str",  # Optional.
                            "region": "str",  # Optional. Region code.
                            "retrieval_method": "RETRIEVAL_METHOD_UNKNOWN",  # Optional.
                              Default value is "RETRIEVAL_METHOD_UNKNOWN". * RETRIEVAL_METHOD_UNKNOWN:
                              The retrieval method is unknown    * RETRIEVAL_METHOD_REWRITE: The
                              retrieval method is rewrite   * RETRIEVAL_METHOD_STEP_BACK: The retrieval
                              method is step back   * RETRIEVAL_METHOD_SUB_QUERIES: The retrieval
                              method is sub queries   * RETRIEVAL_METHOD_NONE: The retrieval method is
                              none. Known values are: "RETRIEVAL_METHOD_UNKNOWN",
                              "RETRIEVAL_METHOD_REWRITE", "RETRIEVAL_METHOD_STEP_BACK",
                              "RETRIEVAL_METHOD_SUB_QUERIES", and "RETRIEVAL_METHOD_NONE".
                            "route_created_at": "2020-02-20 00:00:00",  # Optional.
                              Creation of route date / time.
                            "route_created_by": "str",  # Optional.
                            "route_name": "str",  # Optional. Route name.
                            "route_uuid": "str",  # Optional.
                            "tags": [
                                "str"  # Optional. Agent tag to organize related
                                  resources.
                            ],
                            "temperature": 0.0,  # Optional.
                            "template": {
                                "created_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's creation date.
                                "description": "str",  # Optional. Description of the
                                  agent template.
                                "instruction": "str",  # Optional. Instructions for
                                  the agent template.
                                "k": 0,  # Optional. The 'k' value for the agent
                                  template.
                                "knowledge_bases": [
                                    {
                                        "added_to_agent_at": "2020-02-20
                                          00:00:00",  # Optional. Time when the knowledge base was
                                          added to the agent.
                                        "created_at": "2020-02-20 00:00:00",
                                          # Optional. Creation date / time.
                                        "database_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "embedding_model_uuid": "str",  #
                                          Optional. List of knowledge bases associated with the agent
                                          template.
                                        "is_public": bool,  # Optional.
                                          Whether the knowledge base is public or not.
                                        "last_indexing_job": {
                                            "completed_datasources": 0,
                                              # Optional. Number of datasources indexed completed.
                                            "created_at": "2020-02-20
                                              00:00:00",  # Optional. Creation date / time.
                                            "data_source_uuids": [
                                                "str"  # Optional.
                                                  IndexingJob description.
                                            ],
                                            "finished_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "knowledge_base_uuid": "str",
                                              # Optional. Knowledge base id.
                                            "phase":
                                              "BATCH_JOB_PHASE_UNKNOWN",  # Optional. Default value is
                                              "BATCH_JOB_PHASE_UNKNOWN". Known values are:
                                              "BATCH_JOB_PHASE_UNKNOWN", "BATCH_JOB_PHASE_PENDING",
                                              "BATCH_JOB_PHASE_RUNNING", "BATCH_JOB_PHASE_SUCCEEDED",
                                              "BATCH_JOB_PHASE_FAILED", "BATCH_JOB_PHASE_ERROR", and
                                              "BATCH_JOB_PHASE_CANCELLED".
                                            "started_at": "2020-02-20
                                              00:00:00",  # Optional. IndexingJob description.
                                            "tokens": 0,  # Optional.
                                              Number of tokens.
                                            "total_datasources": 0,  #
                                              Optional. Number of datasources being indexed.
                                            "updated_at": "2020-02-20
                                              00:00:00",  # Optional. Last modified.
                                            "uuid": "str"  # Optional.
                                              Unique id.
                                        },
                                        "name": "str",  # Optional. Name of
                                          knowledge base.
                                        "project_id": "str",  # Optional.
                                          List of knowledge bases associated with the agent template.
                                        "region": "str",  # Optional. Region
                                          code.
                                        "tags": [
                                            "str"  # Optional. Tags to
                                              organize related resources.
                                        ],
                                        "updated_at": "2020-02-20 00:00:00",
                                          # Optional. Last modified.
                                        "user_id": "str",  # Optional. Id of
                                          user that created the knowledge base.
                                        "uuid": "str"  # Optional. Unique id
                                          for knowledge base.
                                    }
                                ],
                                "max_tokens": 0,  # Optional. The max_tokens setting
                                  for the agent template.
                                "model": {
                                    "agreement": {
                                        "description": "str",  # Optional.
                                          Agreement Description.
                                        "name": "str",  # Optional. Agreement
                                          Description.
                                        "url": "str",  # Optional. Agreement
                                          Description.
                                        "uuid": "str"  # Optional. Agreement
                                          Description.
                                    },
                                    "created_at": "2020-02-20 00:00:00",  #
                                      Optional. Creation date / time.
                                    "inference_name": "str",  # Optional.
                                      Internally used name.
                                    "inference_version": "str",  # Optional.
                                      Internally used version.
                                    "is_foundational": bool,  # Optional. True if
                                      it is a foundational model provided by do.
                                    "metadata": {},  # Optional. Additional meta
                                      data.
                                    "name": "str",  # Optional. Name of the
                                      model.
                                    "parent_uuid": "str",  # Optional. Unique id
                                      of the model, this model is based on.
                                    "provider": "MODEL_PROVIDER_DIGITALOCEAN",  #
                                      Optional. Default value is "MODEL_PROVIDER_DIGITALOCEAN". Known
                                      values are: "MODEL_PROVIDER_DIGITALOCEAN",
                                      "MODEL_PROVIDER_ANTHROPIC", and "MODEL_PROVIDER_OPENAI".
                                    "updated_at": "2020-02-20 00:00:00",  #
                                      Optional. Last modified.
                                    "upload_complete": bool,  # Optional. Model
                                      has been fully uploaded.
                                    "url": "str",  # Optional. Download url.
                                    "usecases": [
                                        "str"  # Optional. Usecases of the
                                          model.
                                    ],
                                    "uuid": "str",  # Optional. Unique id.
                                    "version": {
                                        "major": 0,  # Optional. Major
                                          version number.
                                        "minor": 0,  # Optional. Minor
                                          version number.
                                        "patch": 0  # Optional. Patch version
                                          number.
                                    }
                                },
                                "name": "str",  # Optional. Name of the agent
                                  template.
                                "temperature": 0.0,  # Optional. The temperature
                                  setting for the agent template.
                                "top_p": 0.0,  # Optional. The top_p setting for the
                                  agent template.
                                "updated_at": "2020-02-20 00:00:00",  # Optional. The
                                  agent template's last updated date.
                                "uuid": "str"  # Optional. Unique id.
                            },
                            "top_p": 0.0,  # Optional.
                            "updated_at": "2020-02-20 00:00:00",  # Optional. Last
                              modified.
                            "url": "str",  # Optional. Access your agent under this url.
                            "user_id": "str",  # Optional. Id of user that created the
                              agent.
                            "uuid": "str"  # Optional. Unique agent id.
                        }
                    ],
                    "links": {
                        "pages": {
                            "first": "str",  # Optional. First page.
                            "last": "str",  # Optional. Last page.
                            "next": "str",  # Optional. Next page.
                            "previous": "str"  # Optional. Previous page.
                        }
                    },
                    "meta": {
                        "page": 0,  # Optional. The current page.
                        "pages": 0,  # Optional. Total number of pages.
                        "total": 0  # Optional. Total amount of items over all pages.
                    }
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_agents_by_openai_key_request(
            uuid=uuid,
            page=page,
            per_page=per_page,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore

    @distributed_trace
    def list_datacenter_regions(
        self,
        *,
        serves_inference: Optional[bool] = None,
        serves_batch: Optional[bool] = None,
        **kwargs: Any,
    ) -> JSON:
        # pylint: disable=line-too-long
        """List Datacenter Regions.

        To list all datacenter regions, send a GET request to ``/v2/gen-ai/regions``.

        :keyword serves_inference: Include datacenters that serve inference. Default value is None.
        :paramtype serves_inference: bool
        :keyword serves_batch: Include datacenters that are capable of running batch jobs. Default
         value is None.
        :paramtype serves_batch: bool
        :return: JSON object
        :rtype: JSON
        :raises ~azure.core.exceptions.HttpResponseError:

        Example:
            .. code-block:: python

                # response body for status code(s): 200
                response == {
                    "regions": [
                        {
                            "inference_url": "str",  # Optional. Url for inference
                              server.
                            "region": "str",  # Optional. Region code.
                            "serves_batch": bool,  # Optional. This datacenter is capable
                              of running batch jobs.
                            "serves_inference": bool,  # Optional. This datacenter is
                              capable of serving inference.
                            "stream_inference_url": "str"  # Optional. The url for the
                              inference streaming server.
                        }
                    ]
                }
                # response body for status code(s): 404
                response == {
                    "id": "str",  # A short identifier corresponding to the HTTP status code
                      returned. For  example, the ID for a response returning a 404 status code would
                      be "not_found.". Required.
                    "message": "str",  # A message providing additional information about the
                      error, including  details to help resolve it when possible. Required.
                    "request_id": "str"  # Optional. Optionally, some endpoints may include a
                      request ID that should be  provided when reporting bugs or opening support
                      tickets to help  identify the issue.
                }
        """
        error_map: MutableMapping[int, Type[HttpResponseError]] = {
            404: ResourceNotFoundError,
            409: ResourceExistsError,
            304: ResourceNotModifiedError,
            401: cast(
                Type[HttpResponseError],
                lambda response: ClientAuthenticationError(response=response),
            ),
            429: HttpResponseError,
            500: HttpResponseError,
        }
        error_map.update(kwargs.pop("error_map", {}) or {})

        _headers = kwargs.pop("headers", {}) or {}
        _params = kwargs.pop("params", {}) or {}

        cls: ClsType[JSON] = kwargs.pop("cls", None)

        _request = build_genai_list_datacenter_regions_request(
            serves_inference=serves_inference,
            serves_batch=serves_batch,
            headers=_headers,
            params=_params,
        )
        _request.url = self._client.format_url(_request.url)

        _stream = False
        pipeline_response: PipelineResponse = (
            self._client._pipeline.run(  # pylint: disable=protected-access
                _request, stream=_stream, **kwargs
            )
        )

        response = pipeline_response.http_response

        if response.status_code not in [200, 404]:
            if _stream:
                response.read()  # Load the body in memory and close the socket
            map_error(status_code=response.status_code, response=response, error_map=error_map)  # type: ignore
            raise HttpResponseError(response=response)

        response_headers = {}
        if response.status_code == 200:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if response.status_code == 404:
            response_headers["ratelimit-limit"] = self._deserialize(
                "int", response.headers.get("ratelimit-limit")
            )
            response_headers["ratelimit-remaining"] = self._deserialize(
                "int", response.headers.get("ratelimit-remaining")
            )
            response_headers["ratelimit-reset"] = self._deserialize(
                "int", response.headers.get("ratelimit-reset")
            )

            if response.content:
                deserialized = response.json()
            else:
                deserialized = None

        if cls:
            return cls(pipeline_response, cast(JSON, deserialized), response_headers)  # type: ignore

        return cast(JSON, deserialized)  # type: ignore
